
;;;*********************************************************************
;;;
;;;                 LEMMAS.LISP    In KCL
;;;                            
;;;               W. W. Bledsoe            25 JULY 1988
;;;                              
;;;
;;;                 For use by  IMPLY.LISP
;;;
;;;
;;;***********************************************************************
;;;
;;;     This is the list of Lemmas and theorems used by the analogy
;;;      prover.  Also included here is the DESCRIPTIONs for names
;;;      of theorems and lemmas, etc.  See below.
;;;
;;;*********************************************************************** 

(defvar ex70 'resolution-is-complete-for-FOL)

(setq L1 
  '(-> (& (Clauses S) (ground S) (element C S) (element L C) 
          (= C1  (set-diff C (sng L)))
	  (= S% (union (set-diff S (sng C)) (sng C1)))
          (element [] (res S% k))
	  (p-integer k))
       (or (element [] (res S k)) (element (sng L) (res S k)))))

(setq L2 '(-> (& (clauses S17) (clauses S27) (subset S17 S27)(p-integer k))
	      (subset (res S17 k) (res S27 k))))

(setq L2c '(clauses (res s n)))

(setq L3 '(-> (& (clauses S) (p-integer n) (p-integer m))
                    (= (res (res S n) m) (res S (+ n m)))))

(setq L4 '(-> (& (clauses S) (= (excess-Literal S) 0) (not (element [] S)))
	      (& (all C (-> (element C S) (unit-clause C)))
                 (-> (unsatisfiable S) (element [] (res S 1))))))
#|
(setq L5 '(-> (& (Clauses S) (element C S) (= C1 (set-diff C (sng LL)))
		 (= S* (union (set-diff S (sng C)) (sng C1))))
	      (& (Clauses S*)
                 (-> (ground S) (ground S*))
                 (-> (Unsatisfiable S) (Unsatisfiable S*))
                 (-> (& (not (element [] S)) (non-unit C))
                     (not (element [] S*)))
                 (-> (< (length C1) (length C))
		     (< (excess-literal S*) (excess-literal S))))))
|#
(setq L5 '(-> (& (Clauses S) (element C S) (subset C1 C) 
		 (= S* (union (set-diff S (sng C)) (sng C1))))
	      (& (Clauses S*)
                 (-> (ground S) (ground S*))
                 (-> (finite S) (finite S*))
                 (-> (Unsatisfiable S) (Unsatisfiable S*))
                 (-> (& (not (element [] S) (non-unit C))
                     (not (element [] S*)))
                 (-> (< (length C1) (length C))
		     (< (excess-literal S*) (excess-literal S)))))))

(setq L6 '(-> (& (clauses S) (p-integer k)) 
	      (& (clauses (res S k)) (subset S (res S k)))))

(setq L7 '(-> (& (clauses S) (not (element [] S)))
              (<= (- (excess-literal S)))))

(setq L8 '(-> (& (clauses S)  (not (element [] S))
		 (< (- (excess-literal S))))
          (some C (& (element C S) (non-unit C)))))

(setq L8* '(-> (& (clauses S)  
                  (all C (-> (element C S) (non-unit C))))
               (= (excess-literal S) 0)))

(setq L9  '(-> (& (Clauses S) (element C S)) (clause C)))

(setq L10  '(-> (& (Clause C) (element L C)) (Literal L)))

(setq L11 '(-> (& (clause C) (non-unit C)) (non-empty C)))

(setq L12 '(-> (non-unit A) (some x (element x A))))   
  ;;see lower versions of this

(setq L13 '(-> (& (element L C) (= C1 (set-diff C (sng L))))
               (& (subset C1 C) (< (length C1) (length C)))))

(setq L14 '(-> (& (element L C) (= C2 (sng L)))
               (& (subset C2 C) (< (length C2) (length C)))))

(setq L15 '(-> (non-unit C) (< (+ 1 (- (length C))))))

(setq L16 '(= (length (sng L)) 1))

(setq L17 '(p-integer 1))

(setq L18 '(-> (& (p-integer n91) (p-integer n92)) (p-integer (+ n91 n92))))

;;;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

(defvar ex70-Lock 'Lock-resolution-is-complete-for-FOL)

(setq L1-L                   ;L1-L stands for L1-Lock (for Lock Resolution).
  '(-> (& (Locked-Clauses S) (ground S) (element C S) (element L C) 
          (all C* (-> (& (element C* S) (non-unit C*))
                      (all L* (-> (element L* C*)
                                  (<= (+ (index L*) (- (index L))))))))
          (= C1  (set-diff C (sng L)))
	  (= S% (union (set-diff S (sng C)) (sng C1)))
          (element [] (res-L S% k))
	  (p-integer k))
       (or (element [] (res-L S k)) (element (sng L) (res-L S k)))))

(setq L2-L '(-> (& (Locked-clauses S17) (Locked-clauses S27) 
		 (subset S17 S27) (p-integer k))
	      (subset (res-L S17 k) (res-L S27 k))))

(setq L3-L '(-> (& (Locked-clauses S) (p-integer n) (p-integer m))
                    (= (res-L (res-L S n) m) (res-L S (+ n m)))))

(setq L4-L '(-> (& (Locked-clauses S) (= (excess-Literal S) 0) 
		 (not (element [] S)))
	      (& (all C (-> (element C S) (unit-clause C)))
                 (-> (unsatisfiable S) (element [] (res-L S 1))))))

(setq L5-L '(-> (& (Locked-Clauses S) (element C S) (subset C1 C) 
		 (= S* (union (set-diff S (sng C)) (sng C1))))
	      (& (Locked-Clauses S*)
                 (-> (ground S) (ground S*))
                 (-> (finite S) (finite S*))
                 (-> (Unsatisfiable S) (Unsatisfiable S*))
                 (-> (& (not (element [] S) (< (length C1) (length C))))
                     (not (element [] S*)))
                 (-> (< (length C1) (length C))
		     (< (excess-literal S*) (excess-literal S))))))

(setq L6-L '(-> (& (Locked-clauses S) (p-integer k)) 
	      (& (Locked-clauses (res-L S k)) (subset S (res-L S k)))))

(setq L7-L '(-> (& (Locked-clauses S)  (not (element [] S)))
              (<= (- (excess-literal S)))))

(setq L8-L 
     '(-> (& (Locked-clauses S)  (not (element [] S))
	     (< (- (excess-literal S))))
	  (some C (& (element C S) (non-unit C)
		     (some L (& (element L C)
				(ALL C*
				     (-> (& (ELEMENT C* S) (NON-UNIT C*))
					 (ALL L*
					      (-> (ELEMENT L* C*)
						  (<= (+ (INDEX L*) 
                                                         (- (INDEX L))))))))
				))))))

(setq L8*-L '(-> (& (Locked-clauses S)  
                  (all C (-> (element C S) (non-unit C))))
               (= (excess-literal S) 0)))

(setq L9-L  '(-> (& (Locked-Clauses S) (element C S)) (Locked-clause C)))

(setq L10-L  '(-> (& (Locked-Clause C) (element L C)) (Locked-Literal L)))

(setq L11-L '(-> (& (Locked-clause C) (non-unit C)) (non-empty C)))

(setq L12 '(-> (non-empty A) (some x (element x A))))

(setq L13 '(-> (& (element L C) (= C1 (set-diff C (sng L))))
               (& (subset C1 C) (< (length C1) (length C)))))

(setq L14 '(-> (& (element L C) (= C2 (sng L)))
               (& (subset C2 C) (< (length C2) (length C)))))

(setq L15 '(-> (non-unit C) (< (+ 1 (- (length C))))))

(setq L16 '(= (length (sng L)) 1))

(setq L17 '(p-integer 1))

(setq L18 '(-> (& (p-integer n91) (p-integer n92)) (p-integer (+ n91 n92))))

(setq L19 '(-> (& (element L C) (= C1 (set-diff C (sng L))))
               (= C (union C1 (sng L)))))


;;; DESCRIPTIONS is a list in which a term like RESOLUTION-IS-COMPLETE-FOR-FOL
;;;  are associated with a list describing this atom.  Such a description
;;;  includes: verbs, nouns, adjectives, etc.  
;;; These descriptions are used to help with the FETCHING problems associated
;;;  proofs by ANALOGY.  

(defvar descriptions '(

 (Ex70
  (verb complete) (noun resolution) (adjective ordinary) (adjective ground)
  (for First-order-logic))

 (Ex70-Lock
  (verb complete) (noun resolution) (adjective Lock) (adjective ground)
  (for First-order-logic))

 (resolution-is-complete-for-FOL 
  (verb complete) (noun resolution) (adjective ordinary) (adjective ground)
  (for First-order-logic))

 (Lock-resolution-is-complete-for-FOL 
  (verb complete) (noun resolution) (adjective Lock) (adjective ground)
  (for First-order-logic))

 (L1      (noun Lemma) (associated-with ex70))

 (L1-Lock (noun Lemma) (associated-with ex70-Lock)) 

))


(setq Defn-list '(
  ((RESOLUTION-IS-COMPLETE-FOR-FOL) 
   (all S (-> (& (Clauses S) (ground S)  (Unsatisfiable S))
	      (some nn (& (element [] (res S nn)) (p-integer nn))))))

   ((LOCK-RESOLUTION-IS-COMPLETE-FOR-FOL) 
    (all S (-> (& (Clauses S) (ground S)  (Unsatisfiable S)
		  (Locked-clauses S))
	       (some nn (& (element [] (res-L S nn)) (p-integer nn))))))
))


(setq L12 '(-> (non-unit A) (some x (element x A))))

;;%% Lemmas for Bertrand's Conjecture

(setq L8-d '(all n (= (bi-coef (* 2 n) n)                
		      (product p (prime p) (exp p (mu p))))))

;;In the following, and elsewhere, we need mu an v to be functions of n

(setq L8-1 '(= (mu p) (sum j (<= 1 j)(+ (ceiling (/ (* 2 n) (exp p j)))
					(* -2 (ceiling (/ n (exp p j))))))))

(setq L8-1- '(& (<= (exp p (v p)) (* 2 n)) 
		(< (* 2 n) (exp p (+ (v p) 1)))))

(setq L8-2 '(<= (mu p) (v p)))

(setq L8-3 '(= (bi-coef (* 2 n) n)                           
	       (product p (& (prime p) (<= p (* 2 n))) (exp p (mu p)))))

(setq Lp3 '(-> (<= 16 y) 
	       (<=    (num-of p (& (prime p) (<= p y))) 
		   (+ (num-of x (& (odd x) (<= 1 x) (<= x y))) -2))))

(setq Lp4 '(-> (<= 1 y) (= (num-of p (& (odd p) (<= 1 p) (<= p y)))
			   (/ (+ y 1) 2))))

(setq Lp5 '(-> (<= 1 y) (< (* (exp (* 2 n) -1) (exp 2 (* 2 n)))
			   (bi-coef (* 2 n) n))))

(setq Lp6 '(-> (& (< 0 x) (< x y)) (< (log x) (log y))))

(setq Lp7 '(-> (& (differtiable f) (<= 0 (apply f a))
		  (all x (-> (<= 0 x) (<= 0 (apply (derivative f) x)))))
	       (all x (-> (<= 0 x) (<= 0 (apply f x))))))
