
;;;**********************************************************************
;;;
;;;                     OPTIONS.LISP    In AKCL      9Jan92
;;;
;;;               W. W. Bledsoe      12 Feb 1987    29 June 1988
;;;                                                 25 Feb  1989
;;;                 Called by  IMPLY.LISP            2 Mar  1990
;;;
;;;       Was divided into 4 parts for ease of Compiling
;;;                 9Jan92 Now recombined
;;;
;;;***********************************************************************

(DEFUN OPTIONS (&optional signal)
              ;Used-in (IMPLY IMPLY-RULES CLAIM INDUCTION ETC)
  ;;At the **-IMPLY-STOP-**, the user can choose a number of different 
  ;;Options, by typing any one of the letters (or charcters) shown below.
  ;;See Bledsoe & Bruell, AI Jour 5 (1974) 51-71, for the general idea.
  ;;Type a CR (Carriage Return) to proceed with the proof in the ordinary way.

 (declare (special bigx reported))   
 (declare  (special h c tl anc lt yet))
 (let (read read* pl use h-gu H= Hv)
  (setq use (car H))(setq h-gu (cadr H))(setq H= (caddr H))(setq Hv (cadddr H))
  
  (COND (REPORTED NIL) 
	((not *jr-light*) (format t "~%") (princ TL) (format t "~%~s" C)))
  (cond (%Non-stop-light% (return-from options (cond (bigx) (t t)))))
  ;;If the non-stop-light is on, then return with Bigx (the current computed 
   ;; value of THETA) if non-NIL, else with T.

  (and (not *jr-light*) (format t "~%______________~%  **-IMPLY-STOP-** ~% "))
  (setq pl %plan%) (clear-in)
  (and %plan% (cond (*jr-light* (setq read (car %plan%))
				(setq %plan% (cdr %plan%)))
		    (t (setq read (read-h)))))

;;%% Print C (or not)
  (cond ((and *jr-light* *-*)
	 (cond (*suppress-printing-c* (setq *suppress-printing-c* nil))
	       (t (-%) (ind2) (format t "- ~s" C)))))

;;%% Print READ (The inputted command)  
;;   2Jan90: This section need to be standardized
  (cond ((not *jr-light*) nil)
        (*-* (cond ((eq '* read) (-.) (setq read 'qed))   ;print . at the right
                   ((eq 'a read) (format t "  a"))        ;print A at the right
		   ((eq 'aa read)(-.))   ;used only for infix-printing. Like a.
		   ((eq 'proof-by-contradiction read) (format t "~%~%~s" read))
		   ((use-formula read) (format t "  ~s " read)) ; at the right
		   ((Reference read) (format t " ~s" read))    ; at the right

		   ((Label read) (format t "~%~%~s" read))  ;print label at rt

		   ((and (not (atom read)) (eq 'assume-that (car read)))
		    (-%)(-%)(format t "Assume That")
		    (cond ((cddr read) (format t " ~s:" (cadr read))
			               (format t " ~s"  (caddr read)))
			  (t           (format t ": ~s" (cadr read)))))

		   (*after-Label*                         ;print after a Label
		    (cond (*iprn*                         ;Infix Printing
			   (print-infix (list 'claim2 read) 5))
			  (t (format t " ~s " read))))    ;Regular Printing

		   (*iprn* (-%)(-%)                       ;Infix Printing
			    (print-infix (list 'claim2 read) 0))
		    
		   (t (-%)(-%) (format t "~s " read))))   ;Regular Printing
        ((eq '* read) (format t "~%")(ind)(format t "|: *~%")(setq read 'qed))
	((eq '** read) (setq read 'cr))
	((eq 'a read) (format t "~%")(ind)(format t "|: a%"))
	(t (format t "~%")(ind)(format t "|: ~s~%" read)))
;;%% Process the Options
  (COND ((or (member read '(cr carriage-return))
             (and (not read) (setq read (testr))))
	 (COND ((member read '(cr carriage-return)) ;From (TESTR), 
					; CR means "Proceed"
                (and (not pl) (not *jr-light*)(format t "Proceed-ed ~%"))
                (COND ((MEMBER SIGNAL '(MATCH)) T) 
		      ;;Called from REPORT&OPTIONS, so return there.

		      ((NUMBERP BIGX)	;used only in backing up (B or BACK)
		       (IMPLY H C TL ANC 'PROCEED YET))
                                                  
		      ((MEMBER LT *report-lights*)  BIGX)
				;(qed-1 detail-1 detail-3 1 2 proceed prove)
					;Return the value Bigx
		      (T (IMPLY H C TL ANC LT YET))))))
        (SIGNAL T)   
           ;;If (OPTIONS signal) is called where signal is non-NIL, then no 
           ;; option is possible (used only to notify the user)
        ((and (not read) (setq read (read-h)) nil)) ;Just setq Read

	((and *-* (Label read)) (setq *suppress-printing-c* t)
	 (setq *after-label* read) (options)) ;3Jan90 Used by next CLAIM

	((and *-* (Reference read)) (setq *suppress-printing-c* t) (options))
       
;;        ((and *jr-light* *-* (setq read* (use-formula read)))
;;	   (use-jr read*) (options))

	((EQ READ 'QED)          	
	 ;;finish the proof of this subgoal without stopping.
         (cond ((not *jr-light*) (PRINT '(QED BEING TRIED))))
	 (ANS* '(QED BEING TRIED))
	 (IMPLY H C (APPEND TL '(QED)) ANC 'QED-1 YET))

	((EQ READ 'QEDN)		;Non-stop version of QED.
	 (setq %Non-stop-light% t)	;It is the same as QED,
	 (PRINT '(QEDN BEING TRIED))	;except that it is non-stop to
	 (ANS* '(QEDN BEING TRIED))	;the end of the whole proof
	 (IMPLY H C (APPEND TL '(QED)) ANC 'QED-1 YET))
 
	((EQ READ 'N)			;Same as QEDN
	 (setq %Non-stop-light% t)       
	 (PRINT '(QEDN BEING TRIED))	
	 (ANS* '(QEDN BEING TRIED))	
	 (IMPLY H C (APPEND TL '(QED)) ANC 'QED-1 YET))
    
	((EQ READ 'GO)			;Essentially the same as CR
	 (COND (BIGX) (T (IMPLY H C TL ANC 'PROCEED YET))))

	((EQ READ 'DETAIL)		;DETAIL is not working in this version
	 (IMPLY H C TL ANC 'DETAIL-1 yet))

	((EQ READ 'A)			;This returns TRUE for the current subgoal.
	 (AND *PL* (FORMAT T "~%The subgoal is ASSUMED by the User~%"))
	 (PROVE-YET T)			;we may need to put this back  15Aug89
	 )
	((eq read 'aa)			;Like a (ASSUMMED) for infix-printing
	 t)

	((EQ READ 'F)			;This returns NIL (failure) for current subgoal.
	 (AND *PL* (FORMAT T "~%The subgoal is FAILED by the User~%"))
	 (ANS* '(The subgoal is FAILED by the User)) 'Failed-goal)

	((EQ READ 'REJECT)		;Same as F
	 (AND *PL* (FORMAT T "~%REJECTED by User~%"))
	 (ANS* 'REJECTED-by-User) 'Failed-goal) 
	;;this rejects the answer being proposed
    
	((EQ READ 'B)			;this causes the program to back up
					;to the last backup point
	 (COND ((EQ '\. (CAR (REVERSE TL))) 
		(THROW '*catch-atom* 1)) ;here is where BIGX can become 
	       (T (THROW '*catch-atom* 0)))) ;a number
    
	((EQ READ 'BACK) (BACKUP))	;this causes the program to back up
					;to the last back-up point, or to back-up n levels
					;as commanded by (prompted) user input
    
	((EQ READ 'B-POINT) (IMPLY H C TL ANC 'B YET))
					;this inserts a back-up point (.) in TL (theorem-lable)
					;and enables a CATCH to accept a THROW
	((EQ READ 'E)			;Break to the LISP level, (type  :R  to proceed)
	 (PRINC 'EVAL\:) (break) (OPTIONS))
	((and (not (atom Read)) (member (car read) '(eval-it E)))
         ;;This just evaluates an instruction
	 (print read) (eval (cadr read)) (options) (options))
	((EQ READ 'PUT) (put))
	((eq-car READ 'put-theta) (put-theta (cadr READ)))
	((EQ READ 'USE) (USE))
	((and *jr-light* (not (atom read)) (eq (car read) 'use)) 
	 (cond ((cddr read) (use-jr (cadr read) (caddr read)))
	       (t (use-jr (cadr read)))) (options))
	((and (not (atom read)) (eq (car read) 'use)) (use (cadr read)))
	((eq read 'useq) (use nil 'qed)) ;Use a lemma and try QED
	((and (not (atom read)) (eq (car read) 'useq)) 
	 (use (cadr read) nil 'qed))
	((and (not (atom read)) (eq (car read) 'use-h)) 
	 (use (cadr read) nil nil 'H-lt)) ;Lemma will be placed in Hv.
	((EQ READ 'CLAIM) (CLAIM))
	((and *jr-light* (not (atom read)) (eq 'claim (car read)))
	 (claim-jr (cadr read)) (options))
	((and (not (atom read)) (eq 'claim (car read))) (claim (cadr read)))
	((EQ READ 'LEMMA) 
	 (FORMAT T "~%       ++++++LEMMA++++++~%Same as CLAIM~%")
	 (CLAIM))
	((EQ READ 'LET) (LETT))
	((and (not (atom read)) (eq 'let (car read))) (Lett (cdr read)))
	((EQ READ 'INDUCTION) (INDUCTION))
	((EQ READ 'I) (INDUCTION))
	((and *jr-light* (not (atom read)) (member (car read) '(I induction)))
	 (induction-jr (cadr read)))
	((and (not (atom read)) (member (car read) '(I induction)))
	 (induction (cadr read)))
	((eq read 'ineq) (inequality-prove h c tl anc lt yet))
	((eq read 'ineq-c) (inequality-prove-c h c tl anc lt yet))
	((eq read 'ineq-u) (inequality-prove-c h c tl anc lt yet t))
	((eq read 'no-op) (no-op))	;No operation, Type noc to continue.
	((eq read 'noc)   (noc))
	((eq read 'cases) (cases2))
	((and *jr-light* (not (atom read)) (eq 'cases (car read))) 
	 (cases-jr (cadr read)))
	((and (not (atom read)) (eq 'cases (car read))) (cases2 (cadr read)))
	((and *jr-light* (eq read 'cases-h)) (cases-h-jr))
	((eq read 'promote) (promote) (options))
	((eq read 'assume-the-hypotheses) (promote) (options)) ;note the e
	((eq read 'assume-the-hypothesis) (promote) (options)) ;note the i
	((and (not (atom read)) (eq 'apply (car read)))	;Apply a Plan
	 (setq %plan% (append (eval (cadr read)) %plan%)) (options))
	((and (not (atom read)) (eq 'a      (car read))) ;Apply a Plan
	 (setq %plan% (append (eval (cadr read)) %plan%)) (options))
	((and (not (atom read)) (eq 'sub= (car read))) ;sub=
	 (sub== (cadr read) (cond ((cddr read) (caddr read)))))
        ;;eg, (sub= (x)) to replace (x) in C, if (= (x) tr) is in H
        ;;    (sub= (x) t)     "     "    h-gu  etc
	((eq-car read 'split-h) (split-h (cdr read)))
	((eq-car read 'split-c) (split-c (cdr read)))
	((eq read 'split) (split-jr))
	((eq read 'VE-light)		;This enables inequality-prove
	 (setq *VE-light* t) (options)) 
	((eq read 'No-VE-light)	;This disables inequality-prove
	 (setq *VE-light* nil) (options))
	((eq read '=) (prove= C))	;This tries to prove C by 
					;strong algebraic reductions
	((EQ READ 'TIME) (PRINT (+ (get-internal-run-time) (- %TIME%))) 
	 (OPTIONS))
	((EQ READ 'H) (NUMBER&PRINT H) (OPTIONS))
	((eq read 'HH) (NUMBER&PRINT-List use h-gu H= Hv) (OPTIONS))
	((EQ READ 'C) (NUMBER&PRINT C) (OPTIONS))
	((EQ READ 'Hi) (NUMBER&PRINT-infix Hv) (format t "~%")(OPTIONS))
	((EQ READ 'Ci) (NUMBER&PRINT-infix C) (format t "~%")(OPTIONS))
	((EQ READ 'THM) (NUMBER&PRINT-list use h-gu H= Hv)
	 (PRINT '------->)
	 (NUMBER&PRINT C) (OPTIONS))
	((EQ READ 'TL) (PRINc TL) (OPTIONS))
	((EQ READ 'LT) (PRINT LT) (OPTIONS))
	((EQ READ 'YET) (format-s YET) (OPTIONS))
	((EQ READ 'USEE) (FORMAT-S use) (OPTIONS))
	((EQ READ 'GU) (number&PRINT h-gu) (OPTIONS))
	((eq read 'plan) (print %plan%) (options))
	((EQ READ 'X)  (PPRINT BIGX) (OPTIONS))
	((EQ READ '^^) (THROW '*catch-atom* -1))
	((EQ READ 'R)  (TRYREDUCE 'C)(OPTIONS))
	((EQ READ 'R*)  (TRYREDUCE 'C t))
	((eq read 'rh) (TRYREDUCE 'Hv)(TRYREDUCE 'h-gu)(TRYREDUCE 'H=)
	 (OPTIONS))
	((eq read 'rh*) (TRYREDUCE 'Hv t)(TRYREDUCE 'h-gu t)(OPTIONS))
	((eq read 'rh-gu) (TRYREDUCE 'H-Gu)(OPTIONS))
	((eq read 'rh-gu*) (TRYREDUCE 'H-Gu t)(OPTIONS))

	((eq read 'r-alg) (setq C (reduce-algebraically C)) (options))
        ;;Algebraically Reduce C.
        ;;A stronger version of Reduce for algebraic expressions
	((eq read 'ra) (setq C (reduce-algebraically C)) (options))
	((eq read 'rah) (setq H (reduce-algebraically H)) (options))
        ;;Algebraically Reduce H.
	((eq read 'reduce-lt) (setq *reduce-light* t) (options))
        ((eq read 'no-reduce-lt)(setq *reduce-light* nil) (options))
;	((EQ READ 'NO-R) (SETQ *GLOBAL-NO-REDUCE-LIGHT* T)(OPTIONS))
;	((EQ READ 'OFF-NO-R) (SETQ *GLOBAL-NO-REDUCE-LIGHT* NIL)(OPTIONS))
	((eq read 'rlt) (print *REDUCE-LIGHT*)(OPTIONS))
	((eq read 'anc) (setq *ancestry-light* t) (options))
	((eq read 'no-anc) (setq *ancestry-light* nil) (options))
	((eq read 'flip) (setq *flip* t) (options))
	((eq read 'no-flip) (setq *flip* nil) (options))
	((and (not (atom read)) (eq 'trace (car read)))
	 (eval (list 'trace (cadr read))) (options)(options))
	((eq READ 'untrace) (eval '(untrace)) (options))
	((EQ READ 'ADD-REDUCE) (ADD-REDUCE) (OPTIONS))
	((EQ READ 'DEL-REDUCE) (DEL-REDUCE) (OPTIONS))
	((EQ READ 'DC) (setq C (DEFINE C t)) (options))
	((EQ READ 'D) (DEFINITION) (options) (options))
	((EQ READ 'SHOW-DEF)		;Show the definition of (prompted) term
	 (SHOW-DEF)   (OPTIONS))
	((EQ READ 'ADD-DEF) (ADD-DEF) (OPTIONS))
	((EQ READ 'DEL-DEF) (DEL-DEF) (OPTIONS))
	((EQ READ 'MOVE->)		;PROMOTE
	 (SETQ H (AND-ON-H H (CADR C))) (SETQ C (CADDR C))
	 (OPTIONS))

	((EQ READ 'PRT) (FORMAT T "~%   *** REDUCE - TABLE *** ~%~%")
	 (PPRINT *REDUCE-TABLE*) (OPTIONS))

	((EQ READ 'PDT) (FORMAT T "~%   *** DEFINITION - TABLE *** ~%~%")
	 (PPRINT *DEFINITION-TABLE*) (OPTIONS))
 
	;;The next 8 options are under development, and may or may not work.
	((eq read 'rcp) (list 'c-pack t c))
	;;return a c-package of the substitution t and the current c
	((eq read 'scp) (c-package) (options)) ;send for a c-package
	;;As of 12/4/87, I am not sure how (or if) this is used

	((eq read 'replace) (examine (replace-term (&H h) c) 'Rep)) 
	;;see replace.lisp
	((eq read 'rep    ) (examine (replace-term (&H h) c) 'Rep))
	;;3/27/89  the (&H h) andify's the units of H
	((eq read 'remove-shields) (examine (remove-shields h c) 'RS)) 
	((eq read 'rs) (examine (remove-shields h c) 'RS))  
	((eq read 'remove-variable) (examine (remove-variable h c) 'RV))
	((eq read 'rv) (examine (remove-variable h c) 'RV)) 

	((eq read 'apply-reduce) (apply-reduce))
	((eq read 'apply-r)      (apply-reduce))
	((eq read 'a-r)          (apply-reduce))

	((eq read 'apply-Lemma) (apply-Lemma))
	((eq read 'apply-L)     (apply-Lemma))
	((eq read 'a-L)         (apply-Lemma))

	((eq read 'apply-Hypothesis) (apply-Hypothesis))
	((eq read 'a-H)              (apply-Hypothesis))

	((eq read 'Eligibles) (print (Eligibles C)) (options))
	((eq read 'Elig)      (print (Eligibles C)) (options))
	((eq read 'El)        (print (Eligibles C)) (options))

	((eq read 'Eligibles-all) (Eligibles-all H C YET) (options))
	((eq read 'Elig-a)        (Eligibles-all H C YET) (options))
	((eq read 'El-a)          (Eligibles-all H C YET) (options))

	((eq read 'E-Eligible)    (E-Eligible H C Yet) (options))
	((eq read 'E-E)           (E-Eligible H C Yet) (options))

	((eq read 'Eliminate-variable) (eliminate-variable)(options))
	((eq read 'Elim              ) (eliminate-variable)(options))

	((and (not (atom read)) (eq 'shields (car read))) ;Shields
	 (shielding-terms (cadr read) C) (options))
	((and (not (atom read)) (eq 'shs     (car read)))
	 (shielding-terms (cadr read) C) (options))       

	((eq read 'Action) (Action) (options))
	((eq read 'Ac    ) (Action) (options))

	((eq read 'save-args) (save-args) (options))

	((and (atom read) *jr-light* *-* (setq read* (use-formula read)))
	 (use-jr read*) (options))
       
	((eq 'proof-by-contradiction read) ;print it and do nothing else.
	 (setq *suppress-printing-c* t) (options))  

	((and *jr-light* *-* (eq 'check-cases read))
	 (verify C) (setq *suppress-printing-c* nil) (options))  

	((ATOM READ) 	
	 (PRINT '(UNRECOGNIZED OPTION)) 
	 (OPTIONS))

	((or (NUMBERP (CAR READ)) (member (car read) '(H Hd Hv)))
	 (REORDER-H READ 'H) (OPTIONS))
	;;eg, (H 3 2) or ( 3 2) causes hypotheses 3 and 2 to be first in H
	;;and (HD 3 2) deletes the other hypotheses of H
	((OR (EQ (CAR READ) 'H-gu) (eq (car read) 'h-gud))
	 (REORDER-H READ 'h-gu) (OPTIONS))
	((EQ (CAR READ) 'C) 
	 (REORDER-C READ) (OPTIONS))	;similarly for (C 3 2)
	((eq 'trace (car read)) (trace (cadr read)) (options))

	((and *jr-light* *-* (eq 'assume-that (car read)))
	 (setq read (reverse (cdr read))) ;put the label last, if there is one
	 (assume-that (car read)(cadr read)) (options))

	((and *jr-light* *-* (eq 'contradicts (car read)))
	 (contradicts (cdr read)) (setq *suppress-printing-c* t) (options))

	((and *jr-light* *-* (claim-formula read))
	 (claim-jr read) (options))

	((and *jr-light* *-* (setq read* (use-formula read)))
	 (use-jr read*) (options))

	(T 
	(PRINT '(UNRECOGNIZED OPTION))  
	(OPTIONS)))))

(defun Label (read)  ;called by Options.  Is Read a Label?  Eg, (2).
  (and *-* (not (atom read)) (every #'(lambda (u) (numberp u)) read)))

(defun Reference (read) ;called by Options.  Is Read a Reference? 
  ;;Eg, 2  or  3  or [2  or  3], or R5 or R13
  (let (L)
    (cond ((numberp read) t)
	  ((and (atom read) (setq L (explode read))
		(eq 'R (car L)) (numberp (cadr L))))

;;	  ((atom read) 
;;	   (cond ((eq '#\R (char (setq L (format nil "~s" read)) 0)) 
		  ;;eg, R5 or R13
;;		  read)))

	  ((or (eq '#\[ (char (setq L (format nil "~s" read)) 0)) 
	       (eq '#\] (char (setq L (format nil "~s" read)) 1))) t)
;;	  ((eq '& (car read)) (reference (cdr read)))    ;disabled 12Jan90
;;	  ((every #' (lambda (u) (Reference u)) read)
           ;;(R2 R5) -> (& R2 R5)
;;         (cons '& read))
 )))

(defun claim-formula (read)  ;called by OPTIONS.  
  ;;Is READ a claim-formula?  Like  (element (L) (S)).
  (not (atom read))

)         ;more later  7Nov89

(defun use-formula (read)    ;called by OPTIONS.  
  ;;Is READ a use-formula?  Like L5 or (L13 L7) 
 (let (L)
   (cond ((and (atom read) (setq L (explode read))
	       (eq 'L (car L)) (numberp (cadr L))))

;;         ((atom read)
;;	  (cond ((eq '#\L (char (setq L (format nil "~s" read)) 0)) 
		 ;;eg, L5 or L13 
;;		 read)))
	 ((atom read) nil)
	 ((eq '& (car read)) (use-formula (cdr read)))

	 ((every #' (lambda (u) (use-formula u)) read)
	  ;;(L1 L5) -> (& L1 L5)
	  (cons '& read)) )))

(DEFUN ABS-TERM (lf)			;finds an absolute-value member (|| x)
					;or (- (|| x)) of lf
  (some #'(lambda (u) 
	    (cond ((and (not (atom u)) (eq '|| (car u))) u)
		  ((and (not (atom u)) (eq '- (car u)) 
                        (not (atom (cadr u))) (eq '|| (caadr u))) u)))
        lf))

(defun action(&optional input)       ;Print out on the screen the user input
  (let (user-input)
       (format t "~%Action: ~%~%")
       (cond (input (testr) (format t "~a ~%" input))
             (t (setq user-input (read-line)) ))
       t))

(DEFUN ADD-DEF NIL                    ;USED-IN  OPTIONS
  ;;This lets the user add a definition to the *DEFINITION-TABLE*
  (PROG (R S)
        (FORMAT T "~%      ++++++ ADD - DEFINITION ++++++~%Type in the two parts of the definition rule.  

First the PATTERN to be defined, and then what it is to be defined as.  
~%PATTERN:  ")

	(SETQ R (READ-H))
        (FORMAT T "~%~%Define as:  ")

	(SETQ S (READ-H))
        (IF (Y-OR-N-PW "Is This OK?   Type:  ") T (RETURN T))

	(SETQ *DEFINITION-TABLE* (CONS (LIST R S) *DEFINITION-TABLE*))
	(SETQ %reduce-light% T)
        (FORMAT T "~%DEFINITION-TABLE entry Added~%")
        (ANS* 'DEFINITION-TABLE-entry-Added)
))

(DEFUN ADD-REDUCE NIL                    ;USED-IN  OPTIONS
  (PROG (R S)
        (FORMAT T "~%      ++++++ ADD - REDUCE ++++++~%Type in the two parts of the reduce rule.  

First the PATTERN to be reduced, and then what it is to be rewritten as.  ~%PATTERN:  ")

	(SETQ R (READ-H))
        (FORMAT T "~%~%Rewrite as:  ")

	(SETQ S (READ-H))
        (IF (Y-OR-N-PW "Is This OK?   Type:  ") T (RETURN T))

	(SETQ *REDUCE-TABLE* (CONS (LIST R S) *REDUCE-TABLE*))
	(SETQ %reduce-light% T)
        (FORMAT T "~%REDUCE-RULE Added~%")
        (ANS* 'REDUCE-RULE-Added)
))

(defun anc (&optional (n t)) ;to set or turn-off the ancestry light
  (setq *ancestry-light* (cond (n t) (t nil))))
  
(defun no-anc () (anc nil)) ;to turn-off the ancestry light

(DEFUN AND-ON-LIST (L)             ;USED-IN ( AND-OR-OUT)
  (COND ((NULL L) NIL)
	((NULL (CDR L)) (CAR L))
	(T (AND-ON (CAR L) (AND-ON-LIST (CDR L))))))
     
(DEFUN ANS* (MESSAGE)   ;USED-IN (OPTIONS REPORT)
  (setq message message)  ;2Mar90  Only to remove clutter during compiling.
#| (SETQ %PROOF-LIST%
	(CONS 
            (list 'format 't "~s ~%" (list 'quote message))
    
;;          (LIST 'MSG (LIST 'QUOTE MESSAGE) 'T) 
    
            %PROOF-LIST%))  |#
  t)
    
(DEFUN BACKUP NIL                   ;USED-IN (OPTIONS)
  (PRINT '(HOW MANY LEVELS))
  (let ((n (read-h)))
       (THROW '*catch-atom* n)))    ;where BIGX can become a number

(defun bound-variables-induction (F)   ;Called by INDUCTION
  ;;(b-v (excess-literal (S)) ) is ( (S) ).
  (cond ((atom F) nil)
        ((and (null (cdr F)) (atom (car F))) (list F))
        (t (union-w (bound-variables-induction (car F))
                    (bound-variables-induction (cdr F)) ))))
     
(defun cases2 (&optional args)                     ;called by options  
 (declare  (special h c tl anc lt yet))
 (let (P Q Plan-1 Plan-2 h1 h2 tl1 tl2 th1 th2 pl plan-save PP lt* 
       Proof-1 Proof-2)
   (setq pl %plan%) (setq PP (cond (%al% 'Proof) (t 'Plan)))
   (format t "~% ************* CASES ******************")

;;%% Read the Cases Predicate and Plans for Case-1 and Case-2 if any.
   (cond 
    (args (setq P (car args))      ;Case where the args for P, etc, are given.
          (setq Plan-1 (cadr args))    
          (setq Plan-2 (caddr args))
          (cond (%al% (setq Proof-1 (eval Plan-1))  
                      (setq Proof-2 (eval Plan-2))  )))

    (t                             ;Case where the args must be given by user
       (format t "~%Type Cases Predicate and Plans for Cases-1 and 2 if any:~%")
       (format t "~% There are 2 parts to a CASES Predicate, P and (not P).
    (NOTE: One can get additional cases by repeating CASES at **-IMPLY-STOP-**)
    (ALSO: Type NIL if you wish to return to OPTIONS with no action.)
     ~% Please type P:  ") 

       (setq P (read-h))
       (cond ((not P) (return-from cases2 (options))))
       (cond ((y-or-n-p "Do you wish to give Plans for Cases-1 and 2?  
  Type y or N: ")
              (format t "Type Plan-1 for Case-1: ") (setq Plan-1 (read-h)) 
              (format t "Type Plan-2 for Case-2: ") (setq Plan-2 (read-h)) ))))

             
   (setq Q (list 'not P))

   (format t "~%~%You have chosen the Cases Predicate: ~s~%" P)
   (cond (args (format t "~%And ~s-1: ~s for Case-1.
And ~s-2: ~s for Case-2." PP (cond (%al% Proof-1) (t Plan-1)) 
                          PP (cond (%al% Proof-2) (t Plan-2)) )))

   (if (or pl args) nil
     (format t "~%The prover will attempt to complete the proof in two steps:
    (1) The first  with  ~s  added to H, then 
    (2) The second with  ~s  added to H. ~%" P Q) )

   (write-goal-message)
   (setq %goal-message% 'Cases)
   (ans* (list 'CASES-being-used 'with-cases-Predicate P))

;;%%Put P and Q into h-gu, H= and Hv positions of H.
    (setq h1 (and-on-h H P))
    (setq h2 (and-on-h H Q))

;;%%Prove the current Goal for the two cases.
    (setq tl1 (append tl '(case-1)))
    (setq tl2 (append tl '(case-2)))
    (setq plan-save %plan%)        ;save the general plan, for continuation 
    (setq %plan% Plan-1)
    (setq lt* (cond (%al% 'ao) (t 'prove)))
    (cond ((setq th1 (imply h1 c tl1 anc lt* yet Proof-1))
           (format t "~% >>>>>>>>>>>>>>>>CASE-1 Proved with MGU: ")
           (cond ((< (symbol-length th1) 12) (format t "~s~%" th1))
                 (t                          (format t "~%  ~s~%" th1)))
           (setq %plan% Plan-2)
           (cond ((setq th2 (imply h2 c tl2 anc lt* yet Proof-2))
                  (format t "~% >>>>>>>>>>>>>>>>CASE-2 Proved with MGU: ")
                  (cond ((< (symbol-length th2) 12) (format t "~s~%" th2))
			(t                          (format t "~%  ~s~%" th2)))
                  (setq %plan% plan-save)
                  (compose th1 th2))
                  
		 (t (format t "~% >>>>>>>>>>>>>>>> ~%  CASE-2 Failed~%")
                    (cond ((not %al%) (setq %plan% plan-save)(no-op))
                          (%al% nil)))))
             
          (t (format t "~% >>>>>>>>>>>>>>>> ~%  CASE-1 Failed~%")
             (cond ((not %al%) (setq %plan% plan-save)(no-op))
                   (%al% nil))) )))


(DEFVAR CE-U ;USED-IN (COUNTEREXAMPLE OPTIONS)
  '((((P) FALSE) (A (LAMBDA (X) 0)) (B (LAMBDA (X) 1)) (LS0107 
	    (LAMBDA (X) 0.50000000)) (F (LAMBDA (X) (+ (* 2 X) -1))) 
	    (TS0123 (LAMBDA (X) (+ 0.25000000 (* 0.50000000 X)))) (TS0120 
	    (LAMBDA (X) (+ 0.25000000 (* 0.50000000 X)))) (ZS0108 (LAMBDA 
	    (X) (+ 0.25000000 (* 0.50000000 X)))))))
   

;;;**********************************************************************
;;;
;;;                     OPTIONS.LISP    (cont)
;;;
;;;               W. W. Bledsoe      12 Feb 1987    29 June 1988
;;;                                                 25 Feb  1989
;;;                 Called by  IMPLY.LISP            2 Mar  1990
;;;
;;;        Was divided into 4 parts for ease of Compiling
;;;                 9Jan92: now recombined
;;;
;;;***********************************************************************
     
(DEFUN CLAIM (&optional lemma claim-proof)   ;Called by OPTIONS and A-OPTIONS.
 (declare  (special h c tl anc lt yet))
 (let (LEMMA* lemma-q V X pl claim-plan theta plan* lt*)
  ;; this is called from options 
  ;; the new goal - which is typed in here by the user, or given in the 
  ;;  claim statement - is proved and used to help prove the current goal
  ;;  being addressed by IMPLY 

  (setq pl %plan%)
  (FORMAT T "       ======CLAIM======~%")

;;%% Read in the Claim Lemma (and Claim Plan if any).
  (cond ((and claim-proof (atom claim-proof)) 
         (setq claim-proof (eval claim-proof))))
  (cond (lemma (cond ((not %al%) (setq Claim-Plan (cadr lemma))
		      (setq lemma (eval (car lemma)))
		      (format t "~%The Claim Lemma is:~% ~s~%With Claim-Plan:~%  ~s~%"		      lemma Claim-Plan))
                     (%al% (setq lemma (eval lemma)) 
                           (setq claim-plan claim-proof))))
        (t 
	 (FORMAT T "~%Type in the Claim-Lemma you wish prove and to use: ~%")
	 
  	 (SETQ LEMMA (eval (READ-H)))
	 
	 (SETQ LEMMA (SUBST= C '&C LEMMA))  
	 (SETQ LEMMA (SUBST= H '&H LEMMA)) 
	   ;;These lets the user use the symbols &C and &H to represent ALL of
           ;;  the current C and H.  Thus avoiding a lot of typing
	 (format t "~%The Claim Lemma is:~%  ~s ~%" lemma)
	 (if (not pl)
	     (if (y-or-n-pw "IS THIS OK?   Type:  ") T 
	       (progn 
		 (format t "~%Claim-Lemma Rejected - Do you want to try Another Claim-Lemma? 
                      (Type  Y  or  N):  ")
		 (if (y-or-n-pw) (return-from CLAIM (CLAIM))
		   (progn (format t"~%Exit CLAIM & Go Back to OPTIONS~%") 
			  (return-from CLAIM (OPTIONS)))))) nil)  ))

;;%% Prove the Claim-Lemma

  (FORMAT T "~%     +++++Trying to prove the Claim-Lemma+++++~%")
  (setq lemma-q (cond ((setq V (free-variables-in Lemma))
                       (unique-bound-variables (universally-quantify lemma 
								     V)))
                      (t lemma)))
  (SETQ LEMMA* (SKOLEMIZE LEMMA-Q nil T))
  (cond ((eq-car Lemma* '&) (setq Lemma* (and-c-reorder-c Lemma*))))
  (SETQ %REDUCE-LIGHT% T)  
  (ANS T H C TL %GOAL-MESSAGE%)
  (ANS* 'Trying-to-Prove-a-CLAIM-LEMMA)
  (setq plan* %plan%)   ;Save the general plan for continuation.
  (setq %plan% CLAIM-PLAN)       ;This is Claim-proof if %al% is not nil.
    ;;CLAIM-PLAN provides help in proving the claim-lemma.
  (SETQ %GOAL-MESSAGE% 'CLAIM)
  (setq lt* (cond (%al% 'ao) (t 'Prove)))
  (COND ((SETQ X (IMPLY H LEMMA* (APPEND TL '(CLAIM)) ANC lt* nil claim-proof))
         (format t "~% &&&&&&&&&&-ESTABLISHED THE CLAIM-&&&&&: ")
         (cond ((< (symbol-length Lemma) 12) (format t "~s~%" Lemma))
               (t                            (format t "~%  ~s~%" Lemma)))
         (format t "~% &&&&&&&&&&&&&&&-WITH MGU-&&&&&&: ~s~%" X)
         (or %al% (format t "~%  Now the prover will continue the proof using the Claim-Lemma~%"))

;;%% Now continue the proof using the Claim-Lemma.(If %al% is nil).
         (ANS* 'CLAIM-ESTABLISHED)
         (SETQ LEMMA* (SKOLEMIZE LEMMA-Q nil NIL))
         (cond (%al% (setq tl (append tl '(CLAIM)))
                     (setq H (and-on-h H Lemma*)) X)
               (t (SETQ %GOAL-MESSAGE% 'CONTINUE-USING-THE-CLAIM-LEMMA)
		  (setq %plan% (cons 'promote plan*))
		  (setq theta (IMPLY H (LIST '-> LEMMA* C) 
                                     (APPEND TL '(CLAIM-2)) ANC 'PROVE YET))
		  (cr-plan) theta)))
	(T 
         (format t "~% &&&-COULD-NOT-ESTABLISH-THE CLAIM-&&&&&: ")
         (cond ((< (symbol-length Lemma) 12) (format t "~s~%" Lemma))
               (t                            (format t "~%  ~s~%" Lemma)))
	 (cond (%al% nil)
	       (%plan% (cr-plan 0 'no-op) (options))
	       (t (OPTIONS)) )))))
     
(DEFUN COUNTEREXAMPLE (FLAG CE-U DB C)             ;USED-IN (OPTIONS)
 (declare  (special h c tl anc lt yet))
 (PROG (subst ce-time qed-lt SUBSTLIST THEOREM CS FLAG1)
	(PRINL '(LOOKING FOR A COUNTEREXAMPLE))
	(TERPRI)
	(SETQ SUBST CE-U)
	(SETQ CE-TIME (GET-INTERNAL-RUN-TIME))
	(SETQ QED-LT T)
	(TERPRI)
	(PRINT 'IMPLIES)
	(TERPRI)
	(GRINDEF C)
	(AND *NO-INTERRUPT* (SETQ SUBSTLIST CE-U) (GO LP))
	(COND (CE-U (PRINL '(DO YOU WANT TO CHANGE OR ADD ANYTHING?))
		    (TERPRI)
		    (SETQ *TEMP* (READ-H))
		    (COND (*TEMP* (SETQ SUBSTLIST (SETQ CE-U (CHANGE_CE CE-U))))
			  (T (SETQ SUBSTLIST CE-U)))
		    (GO LP)))
	(PRINL '(TYPE IN 
		      LIST 
		      OF 
		      FUNCTION 
		      AND 
		      CONSTANTS 
		      AND 
		      REPLACEMENTS 
		      EG= 
		      ((AS1 2) (BS34 1) (F (LAMBDA (X) (+ (* 2 X) 1))))))
	(TERPRI)
	(SETQ SUBSTLIST (READ-H))
	(SETQ SUBSTLIST
	      (MAPCAR #'(lambda(X)
			(COND ((NUMBERP (CADR X))
			       (LIST (CAR X) (LIST 'LAMBDA NIL (CADR X))))
			      (T X)))
		      SUBSTLIST))
	(TERPRI)
	(TERPRI)
	(TERPRI)
     LP (COND ((NULL SUBST)
	       (PRINL '(**** COUNTEREXAMPLE NOT FOUND ***))
	       (PRINT (+ (GET-INTERNAL-RUN-TIME) (- CE-TIME)))
	       (RETURN NIL)))
 	(SETQ SUBSTLIST (CAR SUBST))
	(SETQ FLAG1 (CAR FLAG))
	(SETQ FLAG (CDR FLAG))
	(SETQ SUBST (CDR SUBST))
	(COND ((NULL FLAG1) (GO LP)))
	(SETQ CS (SUBLIS** SUBSTLIST (AND-ON (RESTORE-TYPELIST DB) C)))
	(SETQ THEOREM (REDUC CS t))
	(COND ((EQ THEOREM 'true) (GO LP))
	      ((EQ THEOREM 'false)
	       (PRINL '(******* COUNTEREXAMPLE SUCCESS *******))
 	       (RETURN T)))
	(SETQ THEOREM (NOTQL (RECONSTRUCT-QUANTIFIERS THEOREM)))
	(TERPRI)
	(TERPRI)
	(PRINL '(NEGATED REQUANTIFIED THEOREM))
	(TERPRI)
	(PRINT THEOREM)
	(COND ((VARIABLES-IN THEOREM) (RETURN NIL)))
	(SETQ THEOREM (REMQ THEOREM T NIL NIL))
	(SETQ *CE-THEOREMS* (UNION-W (LIST THEOREM) *CE-THEOREMS*))
	(SETQ THEOREM (CE-PROVE (NOTL THEOREM) NIL))
	(COND (THEOREM (TERPRI)
		       (TERPRI)
		       (TERPRI)
		       (PRINL '(***** COUNTEREXAMPLE FOUND ****))
		       (TERPRI)
		       (TERPRI)
		       (PRINL '(***** TIME SPENT IN COUNTEREXAMPLE ***))
		       (PRINT (+ (GET-INTERNAL-RUN-TIME) (- CE-TIME)))
		       (RETURN T)))
	(GO LP)))
    
(defun c-package ()    ;called by options
  ;;this lets the user send for a c-package, ie, a list (c-pack THETA C*)
  ;;where C* is a partially proved conclusion and THETA is a substitution
  ;;which will be returned if the used invokes the command rcp later, or (?)
 (declare  (special h c tl anc lt yet))
 (let (cp)
      (cond ((setq cp (options))
             (setq c (cond ((eq t cp) c) 
                           ((eq 'c-pack (car cp)) (caddr cp))
                           (t c)))))))

(defun cr-plan (&optional (n 1) sym)  ;used by DEFINE, etc
  ;;Add n cr's (carriage-returns) and the symbol "sym" to %plan%.
  (cond ((< n 1) (cond (sym (setq %plan% (cons sym %plan%)) %plan%)
                       (t %plan%)))
        (t (setq %plan% (cons 'cr %plan%)) (cr-plan (1- n) sym)) ))

(DEFUN DEFINEC NIL     ;USED-IN (OPTIONS) (ie, DC)  %%Not now used (?)
 (declare  (special h c tl anc lt yet))
 (FORMAT T "~%     ****** DEFINEC ******~%")
 (let (c* h* V RULE-ENTRY)
   (SETQ C* (REDUC (DEFN C) T))
   (PPRINT C*) (TERPRI) (TERPRI)
   (if (y-or-n-pw "IS THIS OK?   Type:  ") T 
     (progn 
       (format t "~%DEFINITION of C Rejected - Do you want to try Again? 
                      (Type  Y  or  N):  ")
       (if (y-or-n-pw) (return-from definec (DEFINEC))
	 (progn (format t"~%Exit DEFINEC & Go Back to OPTIONS~%") 
		(return-from definec (OPTIONS))))))      
   (COND ((EQUAL C* C) (OPTIONS))
	 (T (ANS T H C TL %GOAL-MESSAGE%)
	    (FORMAT T "~%    %%%% C HAS BEEN DEFINED %%%%~%")
	    (ANS* '(%%%% C HAS BEEN DEFINED %%%%))
	    (SETQ RULE-ENTRY (RULE-USED C *DEFINITION-TABLE*))
	    (SETQ H* (REDUC (SUBST-INSTANCE ;if C is Reduced, apply the 
			    (CAR RULE-ENTRY) ;same reduction to H
			    (CADR RULE-ENTRY) H) NIL))
            (setq h* (unique-bound-variables h*))
            (setq c* (unique-bound-variables c*))
            (setq V (free-variables-in h*))
	    (setq h (SKOLEM h* nil NIL))
            (setq V (free-variables-in c*))
	    (SETQ C (SKOLEM C* nil t))
	    (SETQ TL (APPEND TL '(DC))) 
	    (SETQ %REDUCE-LIGHT% T) (OPTIONS)))))
       
(DEFUN DEFN (A)          ;used by SHOW-DEF, DEFINEC
  ;;This is better than DEFINE for SHOW-DEF and DEFINEC, because we want
  ;;to see the pre-skolemized form of the result.
  (PROG (THETA A*)
    (COND ((SETQ A* (SOME #'(LAMBDA (Q) 
                                (AND (SETQ THETA (INSTANCE A (CAR Q)))
				       (APPLY-SUBSTITUTION THETA (CADR Q))))
                           *DEFINITION-TABLE*))
           (RETURN A*))
          (T (FORMAT T "~%DEFINITION NOT FOUND~%") ))))
    
(DEFUN DEFINE (A PARITY &optional V) ;used-by IMPLY-RULES REDUC define-in 
  (LET (THETA A* A2 SIGMA)

       (SETQ SIGMA (NEW-BINDINGS A))	;give new bindings to avoid conflicts
       (SETQ A2 (SUBLIS SIGMA (copy-tree A)))
;      (cr-plan)
       (COND ((SETQ A* (SOME #'(lambda(Q)
				 (AND (SETQ THETA (INSTANCE A2 (CAR Q)))
				      (APPLY-SUBSTITUTION THETA (CADR Q))))
			     *DEFINITION-TABLE*))
	      (SETQ SIGMA
		    (MAPCAR #'(lambda(Q)(CONS (CDR Q)(CAR Q))) SIGMA))

	      (SETQ A* (SUBLIS SIGMA (copy-tree A*))) ;Replace the old bindings
              (SETQ A* (BINARY-TO-UNARY< A*))
	      (setq A* (reduc A* parity))
	      (setq V (union-w V (free-variables-in A)))
              (setq V (mapcan #'(lambda (x) 
				  (cond ((member x *function-type-list*) nil) 
                                        (t (list x)))) V))
              (setq A* (unique-bound-variables A*))
	      (SKOLEM A* V PARITY))
	     (T A))))


(DEFUN DEFINITION NIL			;USED-IN (OPTIONS) (ie, D)
       (declare  (special h c tl anc lt yet))
       (let (p c* h* cc hc)

	 (format t "~%    ====== OPEN THE DEFINITION OF A PREDICATE OR FUNCTION SYMBOL  =====~%
~%Please type the name of the Predicate or Function symbol P  being defined : 
 ~%(You may just type P if you want P defined in both C and H,
   or you can type (P C) if you want P defined in C only;  similarly for H)
   ~%Type P:   ")

	 (setq p (read-h))
	 (cond ((atom p)                     
		(setq c* (define-in p c t nil))
 		(setq h* (define-in p h nil nil)))
               ((eq 'c (cadr p))
		(setq c* (define-in (car p) c t nil)))
	       ((eq 'h (cadr p)) (unread-char (read-char))
		(setq h* (define-in (car p) h nil nil))) )
	 (cond ((and (or (null c*)(equal c c*))
                     (or (null h*)(equal h h*))) nil) ;return, unchanged
	       (t (setq cc (cond ((and c* (not (equal c c*))) t)(t nil)))
                  (setq hc (cond ((and h* (not (equal h h*))) t)(t nil)))
                  (format 't "~% THE SYMBOL ~5T ~s ~5t HAS BEEN DEFINED ~3t in  ~s ~% ~s  to obtain   ~s ~2% ~s ~2%"
			  p
			  (cond ((and hc cc) 'both-H-and-C) (hc 'h) (cc 'c))
			  (cond ((and hc cc) (list h '& c)) (hc h)  (cc c))
			  (cond ((and hc cc) 'H*-and-C*)    (hc 'H*)(cc 'C*))
			  (cond ((and hc cc) (list h* '& c*)) (hc h*) (cc c*)) )

		  (and cc (setq c (reduc c* t)))
		  (and hc (setq h (reduc h* nil))) )) ))
 
(defun define-in (p A parity &optional (exclude-list nil))
					;used in definition
  ;;This opens the definition of p in the formula A 
  ;;(if p is not in exclude-list)                     
  (let (p* p** par A* IA IA* sign W)
    (cond ((eq '|| p)			;handle separately the case of abs val.
	   (cond ((setq IA (ineq-abs A))
		  ;;eg, IA = ( (< (+(-(|| x))a) b)  (|| x)  -)
		  (setq p* (cadr IA))         ;eg,  (|| x) 
		  (setq sign (caddr IA))      ;eg,  -
		  (setq IA (car IA))          ;eg,  (< (+(-(|| x))a) b)
		  (cond ((eq '+ sign)
			 (setq IA* (and-on (subst= (cadr p*) p* IA 
                                                 )
					   (subst= (list '- (cadr p*)) p* Ia 
                                                 )))
			 (setq A* (subst= IA* IA A))
                         (define-in p A* parity exclude-list))

			((eq '- sign)
 			 (setq IA* (or-on (subst= (cadr p*) (list '- p*) Ia 
                                                )
					  (subst= (cadr p*) p* Ia 
                                                )))
			 (setq A* (subst= IA* IA A))
                         (define-in p A* parity exclude-list)) ))
                   (t A) ))
	
	  ((setq p* (assoc p *definition-table* :test 'equal))
	   (setq p* (skolemize (cadr p*) nil parity))
	   (subst= p* p A))  
	  ((setq w (headed-by p A parity exclude-list))  
	    ;;returns a subformula of A which has as it's head (and its parity)
           (setq par (cadr w))
	   (setq p* (car w))
	   (setq p** (define (reduc p*) par))
	   (setq A* (subst= p** p* A))
	   (define-in p A* parity (cons p* exclude-list)))
                                      ;;Look for other instances in A
	  (t A) )))

  (SETQ *DEFINITION-TABLE*		;USED-IN (ADD-DEF DEFINE)
	'(((is-int-sqrt x y) (& (not (< y (* x x))) (< y (* (+ x 1)(+ x 1)))))
          ((UNION-OF G8) 
	   (SET-OF TG (SOME XG (& (ELEMENT XG G8) (ELEMENT TG XG))))) 

	  ((SET-= A8 B8) (& (SUBSET A8 B8) (SUBSET B8 A8))) 

	  ((SUBSET A8 B8) (ALL TS (-> (ELEMENT TS A8) (ELEMENT TS B8)))) 

	  ((UNION A8 B8) (SET-OF TU (OR (ELEMENT TU A8) (ELEMENT TU B8))))
   
	  ((INTERSECTION A8 B8) (SET-OF TI (AND (ELEMENT TI A8) 
						(ELEMENT TI B8)))) 

	  ((UNION-OF-SETS S8)
	   (SET-OF TO (SOME T8 (& (ELEMENT T8 S8) (ELEMENT TO T8))) ))

	  ((INTERSECTION-OF-SETS S8)
	   (SET-OF X6 (ALL T8 (-> (ELEMENT T8 S8) (ELEMENT X6 T8))))) 

	  ((SUBSETS A8) (SET-OF XS (SUBSET XS A8))) 

	  ((SB A8) (SUBSETS A8)) 

	  ((RANGE F8) (SET-OF Y8 (SOME X8 (= Y8 (F8 X8))))) 

	  ((OC F8) (& (OPEN F8) (COVER F8)))
    
	  ((LIM F A L) 
	   (ALL E (-> (< 0 E) (SOME D (& (< 0 D) 
					 (ALL X (-> (< (|| (+ X (- A))) D) 
						    (< (|| (+ (F X) 
							      (- L))) E))))))))
 
	  ((cont f a) (continuous f a))

	  ((continuous f c) (lim f a (f a)))
 
	  ((diff f a) (differentiable f a))

	  ((cont-de f a) (continuous-de f a))  
     
	  ((continuous-de f c)		;ordinary "delta-eplison" continuity
	   (ALL E (-> (< 0 E) 
               (SOME D (& (< 0 D) 
			  (ALL X (-> (< (|| (+ X (- C))) D) 
				     (< (|| (+ (F X) (- (f C))))
					E))))))))

	  ((cont-N f a) (continuous-n f a))   

	  ((continuous-N f c)		;"neighborhood" (topology) continuity
	   (all d 
		(all e 
		     (-> (& (< d (f c)) (< (f c) e))
			 (some a2 (some b2 (& (< a2 c) (< c b2) 
					      (all x (-> (& (< a2 x) (< x b2))
							 (& (< d (f x)) 
							    (< (f x) e)))))))))))

	  ((DIFFERENTIABLE F C)		;differentiability in terms of limits
	   (SOME DE 
		 (LIM (LAMBDA X-Lambda 
			      (QUOTIENT (+ (F X-Lambda) (- (F C))) 
					(+ X-Lambda (- C)))) 
		      C DE)))

	  ((diff-de f a) (differentiable-de f a))

	  ((DIFFERENTIABLE-DE F C)	;differentiability in "delta-eplison" 
	                                ; terms
	   (ALL E (-> (< 0 E) (SOME D (& (< 0 D) 
					 (ALL X (-> (< (|| (+ X (- A))) D) 
						    (< (|| (+ (F X) (- L))) 
						       (* E (|| (+ X (-A)))) ))))))))

	  ((diff-L f a) (differentiable-L f a))

	  ((differentiable-L f a)	;differentiability in terms of "Linear
					;functions" (for n-dimensional space)
	   (some k (all E (some D (all x (-> (< (|| (+ x (- c))) D)
					     (< (|| (+ (f x) (- (f c)) 
						       (- (* k x))))
						(* E (|| (+ x (- c))))) ))))))
	  ((<= (|| x) y) (& (<= x y) (<= (- y) x)))  

	  ((< (|| x) y) (& (< x y) (< (- y) x)))

	  ((<= x (|| y)) (or (<= x y) (<= x (- y))))  

	  ((< x (|| y)) (or (< x y) (< x (- y))))

          ((Completeness-of-Ground-Resolution) 
           (all S (-> (& (Clauses S) (ground S) (finite S) (Unsatisfiable S))
		      (some nn (& (element [] (res S nn)) (p-integer nn))))))

          ((LOCK-Completeness-of-Ground-Resolution) 
           (all S (-> (& (Locked-Clauses S) (ground S) (finite S) 
			 (Unsatisfiable S))
		      (some nn (& (element [] (res-L S nn))(p-integer nn))))))

          ((res S k)
           (set-of R (some C1 (some C2 
             (some L (& 
		      (element C1 S)
		      (element C2 S)
		      (element L C1)
		      (element (list 'not L) C2)
		      (= R (union (set-diff C1 (sng L))
				  (set-diff C2 (sng (list 'not L)))))))))))
	  ))
 
(DEFUN DEL-DEF NIL                    ;USED-IN  OPTIONS
  ;;This lets the user delete a definition from the *DEFINITION-TABLE*
  (PROG (R S)
        (FORMAT T "~%      ++++++ DELETE - DEFINITION ++++++

Type in the PATTERN part of the definition rule, that you want to delete.
(If you wish to delete the last rule that was entered, just type the letter L.)
~%PATTERN:  ")

	(SETQ R (READ-H))
        (SETQ S (cond ((eq R 'L) (car *definition-table*))
                      ((SOME #'(lambda(Q) (AND(INSTANCE R (CAR Q)) Q))
                             *DEFINITION-TABLE*))
                      (T NIL)))
        (PPRINT S)
        (IF (Y-OR-N-PW "Is This the rule you want deleted?  Type:  ") 
                      T (RETURN T))                ;if not return to options

	(SETQ *DEFINITION-TABLE* (REMOVE S  *DEFINITION-TABLE* :TEST 'EQUAL))

        (FORMAT T "~%DEFINITION-TABLE entry Deleted~%")
        (ANS* 'DEFINITION-TABLE-entry-Deleted)
	))

(DEFUN DEL-REDUCE NIL                    ;USED-IN  OPTIONS
  ;;This lets the user delete a REDUCE-rule from the *REDUCE-TABLE*
  (PROG (R S)
        (FORMAT T "~%      ++++++ DELETE - REDUCE Rule ++++++

Type in the PATTERN part of the REDUCE rule, that you want to delete.
(If you wish to delete the last rule that was entered, just type the letter L.)
~%PATTERN:  ")

	(SETQ R (READ-H))
        (SETQ S (cond ((eq R 'L) (car *reduce-table*))
                      ((SOME #'(lambda(Q) (AND(INSTANCE R (CAR Q)) Q))
                             *REDUCE-TABLE*))
                      (T NIL)))
        (PPRINT S)
        (IF (Y-OR-N-PW "Is This the rule you want deleted?  Type:  ") 
                      T (RETURN T))                ;if not return to options

	(SETQ *REDUCE-TABLE* (REMOVE S  *REDUCE-TABLE* :TEST 'EQUAL))

        (FORMAT T "~%REDUCE-TABLE entry Deleted~%")
        (ANS* 'REDUCE-TABLE-entry-Deleted)
	))

(DEFUN DETERMINE-INDUCTION-VARIABLE (IH) ;used by INDUCTION
  ;; CALLED BY INDUCTION -- TO SELECT AND RETURN A VARIABLE N TO INDUCT UPON 
  ;; THIS IS A FIRST VERSION -- IT SHOULD BE MORE SOPHISTICATED 
  ;; FOR THE EXAMPLE == ((QUOTE ->) (ELEMENT X (OMEGA)) (P X)) == IT RETURNS X 
  ;; AND FOR THE EXAMPLE == ((QUOTE ->) (& (ELEMENT (X) (OMEGA)) (ELEMENT (T)
  ;;  (X))) (ELEMENT (T) (OMEGA))) == IT RETURNS (X) 
  (declare  (special h c tl anc lt yet))
    (let (H* DD)
	 (COND
	  ((EQ '-> (CAR IH))
	   (COND
	    ((AND (EQ 'ELEMENT (CAR (SETQ H* (CADR IH))))
		  (EQUAL '(OMEGA) (CADDR H*)))
	     (CADR H*))
	    ((AND (EQ '& (CAR H*))
		  (SETQ DD
			(SOME #'(lambda(D)
				  (AND (EQ 'ELEMENT (CAR D))
				       (EQUAL '(OMEGA) (CADDR D)))
				  D)
			      (CDR H*))))
	     (CADR DD))))
	  ((AND (EQ 'ELEMENT (CAR H)) (EQUAL '(OMEGA) (CADDR H)))
	   (CADR H))
	  ((AND (EQ '& (CAR H))
		(SETQ DD
		      (SOME #'(lambda(D)
				(AND (EQ 'ELEMENT (CAR D))
				     (EQUAL '(OMEGA) (CADDR D)))
				D)
			    (CDR H))))
	   (CADR DD)))))

(defun eq-car (A B)   ;is A non-nil and (Car A) is B.
  (and (not (atom A)) (eq (car A) B)))

(defun Existentially-quantify (A L) ;used in INDUCTION
     (mapc #'(lambda (x) (setq A (list 'some x A))) L) A)

(defun Existentially-quantify-free-variables (A) ;used in INDUCTION
   (Existentially-quantify A (free-variables-in A)))

(defun find-theta (LM)   ;used by USE to find a substitution for LM
  (declare (special h c tl anc lt yet))
  (declare (special %pairs-light%))
  (prog (LM* H* H** theta theta* CL tl* n)
    (cond ((setq theta (find-unique-unifier H LM)) (return theta)))
    ;;If there is a premise of LM which unifies with exactly one of the
    ;; hypotheses in h-gu or H=, then apply that unifier to LM, and
    ;; try for another such, etc.  
    ;; Return the composition of all such unifiers, if there are any

    (setq LM* LM)
    (setq H** (copy-tree H))               ;save H 8Sept89
    (setq H* (and-on-H (cons nil (cdr H)) LM* nil 'U))
     ;;place ground part of LM* in h-gu and rest in USE args of H
    (setq CL (cond ((atom C) (list C)) ((eq '& (car C)) (cdr C)) (t (list C))))
                                             ;CL is the C list.
    (setq CL (And-C-Reorder-c CL))
    (setq tl* (append tl (list 'find-theta)))
    (setq theta* t)
    (setq n 1)
    top
    (cond ((null CL) (cond ((> n 1) (setq H H**) (return theta*))
                           (t (setq H H**) (return t))))  
            ;;if no more than conjucnt is proved, then return theta=t, 
            ;; so that the lemma is placed in the USE position of H.
	  
          ((and (in* 20 t) (setq theta (imply H* (car CL) tl* nil 'qed nil)))
	   (in* *in-limit**)
           (setq theta* (compose theta* theta))
           (setq LM* (apply-substitution theta* LM*))
           (setq n (+ n 1))
           (cond ((and (ground LM*) (> n 1)) (setq H H**) (return theta*))
                 (t (setq H* (subst LM* (car H*) H* :test 'equal))
                    (setq CL (cdr CL)) (go top))))
          (t (setq CL (cdr CL)) (go top)) )))

(defun find-unique-unifier (H LM)  ;called by FIND-THETA
  (let (H* HLM)
    (setq H* (and-on(cadr H) (caddr H))) ;h-gu U H=
    (setq H* (cond ((atom H*) (list H*))
		   ((eq '& (car H*)) (cdr H*))
		   (t (list H*))))
    (setq HLM (cond ((and (not (atom LM)) (eq '-> (car LM)))
		     (cond ((atom (cadr LM)) (list (cadr LM)))
			   ((eq '& (caadr LM)) (cdadr LM))
			   (t (list (cadr LM)))))
		    (t (list LM))))       ;the set of premises of LM

    (find-unique-unifier2 H* HLM)))

(defun find-unique-unifier2 (H* HLM &optional theta*)
  (let (theta HLM*)
    (cond ((null HLM) theta*)
	  ((some #'(lambda (u) (setq theta (find-unique-unifier3 H* u))) HLM)
	   (setq HLM (apply-substitution theta HLM))
	   (setq theta* (cond (theta* (compose theta theta*)) (t theta)))
	   (setq HLM* (mapcan #'(lambda (u) (cond((ground u) nil)(t (list u))))
			      HLM))
	   (find-unique-unifier2 H* HLM* theta*))
          (t theta*))))

(defun find-unique-unifier3 (H* h-l &optional theta) 
					;called by FIND-UNIQUE-UNIFIER2
  (let (theta2)
    (cond ((null H*) theta)  ;If theta has already been computed, return it
                             ; Else nil
          ((setq theta2 (unify (car H*) h-l))
           (cond (theta nil) ;theta is not unique, so return nil
                 (t (find-unique-unifier3 (cdr H*) h-l theta2))))
	  (t (find-unique-unifier3 (cdr H*) h-l theta)))))


;;;**********************************************************************
;;;
;;;                     OPTIONS.LISP    (cont)
;;;
;;;               W. W. Bledsoe      12 Feb 1987    29 June 1988
;;;                                                 25 Feb  1989
;;;                 Called by  IMPLY.LISP            2 Mar  1990
;;;
;;;        Was divided into 4 parts for ease of Compiling
;;;                 9Jan92: now recombined
;;;
;;;***********************************************************************

(defun find->Caddrs (U)     ;used by find-theta
  ;;replace each instance of (-> A B) in U by U
  (cond ((atom U) U)
        ((eq '-> (car U)) (find->Caddrs (caddr U)))
        (t (cons (find->Caddrs (car U))
                 (find->Caddrs (cdr U)) )) ))

(defun flip (&optional (n t)) 
  (setq *flip* (cond (n t) (t nil))))
(defun no-flip () (flip nil))

(DEFVAR %GOAL-MESSAGE% NIL)
 
(defun headed-by (p A parity exclude-list) ;used in define-in (p is an atom)
  ;;returns one subformula of A which has p as it's head (and it's parity),
  ;; which is not already in EXCLUDE-LIST.
  (cond ((atom A) nil)
	((eq p (car A)) (cond ((member A exclude-list :test 'equal) nil)
			      (t (list A parity))))
	((eq '-> (car A)) (or (headed-by p (cadr A) (not parity) exclude-list)
			      (headed-by p (caddr A) parity exclude-list)))
	((eq 'not (car A)) (headed-by p (cadr A) (not parity) exclude-list))
	(t (or (headed-by p (car A) parity exclude-list) 
	       (headed-by p (cdr A) parity exclude-list))) ))
 
(defun ineq-abs (A)			
  ;;finds an inequality subformula A* of A containing an absolute-value term 
  ;;AB with sign S and return (A* AB S)
  (let (lf AB S)
    (cond ((atom A) nil)
           ((member (car A) '(< <=))
           (setq lf (minus-on-reduce (cadr A) (caddr A)))
           (setq lf (cond ((eq '+ (car lf)) (cdr lf)) (t (list lf))))
           (cond ((setq AB (abs-term lf))
                  (cond ((eq '- (car AB)) (setq S '-) (setq AB (cadr AB)))
                        (t (setq S '+)))
                  (list A AB S))))
	  ((ineq-abs (car A)))          
	  ((ineq-abs (cdr A))) )))


 

 
(DEFUN INDUCTION (&optional args)			;USED-IN OPTIONS
       ;; It tries to prove C by INDUCTION on N using induction hypothesis IH.
       ;; N and IH are given here by the user -- the user can leave either NIL.
       ;; If IH is NIL -- then C is used as the INDUCTION HYPOTHESIS 
       ;; And if N is NIL it uses DETERMINE-INDUCTION-VARIABLE to select the
       ;;  induction variable N 
       ;; One might try using induction (from OPTIONS) on EX33 EX30 orEX31 
       ;;
       ;; Another option off of this if COMPLETE induction, whereby we use
       ;;  the induction "Axiom":
       ;;   0\< x  &  (x=0 --> P)  &  ([x \< k -> P] &  k<x --> P)  --->  P .
       ;;  This option is signaled by the user typing  (Complete x), when asked
       ;;   for the induction variable.  (Actually, the process is more 
       ;;   complicated, one must take into account the present state of H
       ;;   and C, properly reskolemize parts, etc (see 5/19/88 notes)).
       ;;  For example, he might type (Complete (excess-literal S))
       ;; Another options in OPTIONS is (Induction (I Plan-0 Plan-1 Plan-2))
       ;;  so that the induction variable (predicate) I, and Plans are given
       ;;  args.

   (declare  (special h c tl anc lt yet))
   (let (N CI N* F FY W C* X Y pr TX TQ TY IH IH* C0 C1 C2 THETA0 THETA LAMBDA 
	  SIGMA TAU V pl Plan-0 Plan-1 Plan-2 plan* H* lt* Proof-0 Proof-1 
          Proof-2)
    (setq pl %plan%)
    (FORMAT T "~%     ====== INDUCTION BEING TRIED ======~%")

;;%% Read in the Induction Variable (or Predicate) and Plans, if any, 
;;   for proving Induction-0, Induction-1, and Induction-2.
    (cond (args (setq N (car args))      ;case where args for N, etc are given.
                (cond ((and (not (atom N)) (eq 'complete (car N)))
                       (setq F (cadr N)) (setq CI t) 
                       (setq Plan-0 (cadr args)))
                      (t (setq args (cons nil args)) (setq Plan-0 nil)))
                (setq Plan-1 (caddr args))
                (setq Plan-2 (cadddr args))
                (cond (%al% (setq Proof-0 (eval Plan-0))
			    (setq Proof-1 (eval Plan-1))
			    (setq Proof-2 (eval Plan-2)))))
          (t                       ;Case where the args must be given by user
             (format t "~%Please Type the INDUCTION VARIABLE, N: ")
             (format t "(You may Type NIL or CR -- if you wish to let it find the induction variable)  ~%Type N:  ")
             (SETQ N (TESTR))
             (COND ((EQ N 'carriage-return) (SETQ N NIL)) 
		   (t (SETQ N (READ-H)) (testr) )) 
             (cond ((and (not (atom N)) (eq 'complete (car N)))  ;Complete Ind.
		    (setq F (cadr N)) (setq CI t) )) ))          ; case

;;%% Prepare for Induction, Regular Induction Case
    (cond 
     ((not CI)		;The regular induction case (not complete-induction)
      (cond ((or 
              (and (setq W (prepare-for-induction (cadr H) C N))
		;;(H -> C) is rewritten as ((element N (omega)) -> C*),W=(N C*)
		   (setq N* (car W)) (setq C* (cadr W)) 
                   (setq H (subst nil (cadr H) H :test 'equal)))
              (and (setq W (prepare-for-induction (cadddr H) C N))
		;;(H -> C) is rewritten as ((element N (omega)) -> C*),W=(N C*)
		   (setq N* (car W)) (setq C* (cadr W))
                   (setq H (subst nil (cadddr H) H :test 'equal)))))
	    (t (progn 
	        (cond (N (format t  "~%For your N, ie, ~s , the Hypothesis: (element N (omega)) is not in H ~%" N))       
		      (t (format t  "~%There is no Hyp of the form (element N (omega)) in H ~%")))
               
	       (format t "~%Do you want to try Again?
                      (Type  Y  or  N):  ")
	       (if (y-or-n-pw) (return-from induction (INDUCTION))
		 (progn (format t"~%Exit INDUCTION & Go Back to OPTIONS~%") 
			(return-from induction (OPTIONS)))))))

      (setq N N*)
      (FORMAT T "~%Please Type the INDUCTION HYPOTHESIS, IH:
       ~%(You may Type NIL or CR -- if you wish to use  C  for the Ind. Hyp.)
       ~%Type IH:  ")

      (SETQ IH (cond (pl (read-h)) (t (TESTR))))
      (COND ((EQ IH 'carriage-return) (SETQ IH NIL)) 
	    (IH)
	    (t (SETQ IH (READ-H)) (testr) ))

      (cond (ih (SETQ IH (SUBST= C '&C IH))  
		(SETQ IH (SUBST= H '&H IH))  ))
      ;;These lets the user use the symbols &C and &H to represent ALL 
      ;; of the current C and H. Thus avoiding a lot of typing.

      (setq ih* (cond (ih ih) (t C*)))

      (setq IH* (cond ((setq V (free-variables-in ih*))
		       (existentially-quantify IH* V))
                      (t IH*)))
;;;     What we need here, instead of the above command, is an UN-SKOLEMIZING
;;;    function, that recovers the fully quantified form of ih*.  Then the
;;;    skolem calls below will result in the correct formulas.  In the meantime
;;;    this will usually give the correct answer, and the user can correct it
;;;    otherwise.

      (setq C0 nil)
      (SETQ C1 (SUBST= 0 N IH*))
      (SETQ C2 (LIST '-> (List '& (List 'element N '(omega)) IH*)
		     (SUBST= (LIST 'SCSR N) N IH*)))

      (setq W (list '& C0 C1 C2))
      (SETQ W (UNIQUE-BOUND-VARIABLES W))
      (setq C0 (cadr W)) (setq C1 (caddr W)) (setq C2 (cadddr W))

      (cond (V (setq C0 (skolem C0 Nil t))
	       (setq C1 (skolem C1 Nil t))
	       (setq C2 (skolem C2 Nil t)) )))

;;%% Prepare for Complete Induction Case.
     (CI		
      (cond ((not (or pl args))
	     (format t "~%Please type the list X of bound-variables in F")
	     (format t "~%You may type CR or NIL- to let it find these.  Type X: ")
	     (SETQ X (TESTR))
	     (COND ((member X '(cr carriage-return))
		    (SETQ X NIL) )
		   (t (SETQ X (READ-H)) ))

	     (cond ((not X) (setq X (bound-variables-induction F))))
	     (format t "~%The Bound-variables of F are: ~s ~%" X)
	     (if (y-or-n-pw "IS THIS OK?   Type:  ") T 
	       (progn 
		 (format t "~%Rejected - Do you want to try Again?
                      (Type  Y  or  N):  ")
		 (if (y-or-n-pw) (return-from induction (INDUCTION))
		   (progn (format t"~%Exit INDUCTION & Go Back to OPTIONS~%") 
			  (return-from induction (OPTIONS)))))))
	    (t (setq X (bound-variables-induction F)) ))

      (setq pr (mapcar #'(lambda (z) (cons z (new-symbol (car z)))) X))
      (setq FY (sublis= pr F))
      (setq TX (list '-> (and-on (cadr H) (cadddr H)) C)) ;(h-gu & Hv -> C)
      (setq TQ (cond ((setq V (free-variables-in TX))
		      (existentially-quantify TX V))
		     (t TX)))
      (setq TY (sublis= pr TQ))
      (setq IH* (list '-> (list '< (list '+ FY (list '- F))) TY))
      (setq Y (mapcar #'cdr pr))
      (setq IH* (universally-quantify IH* Y))

      (setq C0 (list '<= (list '- F)))	;(element of (omega)) later?
      (setq C1 (list '-> (list '= F 0) C))
      (setq C2 (list '-> (list '& IH* (list '< (list '- F))) C))

      (setq W (list '& C0 C1 C2))
      (SETQ W (UNIQUE-BOUND-VARIABLES W))
      (setq C0 (cadr W)) (setq C1 (caddr W)) (setq C2 (cadddr W))

      (setq C2 (skolem C2 Nil t)) ))
                           
    (cond ((occur-in '(< > + *) C)		;arithemetic case
           (setq c2 (repl-scsr c2))
           (setq h  (repl-scsr h))))

;;%% Print Message and Accept or Reject
    (FORMAT T "~[Ordinary~;Complete~] INDUCTION ON: ~% ~S~%USING INDUCTION HYPOTHESIS:~%  ~S~%" 
       (cond (CI 1) (t 0)) (cond (CI F) (t N)) IH*)
    (cond (CI (FORMAT T "~%~%C0:~%~S~%~%" C0)))

    (FORMAT T "~%~%C1:  ~S~%" C1) (FORMAT T "~%~%C2:~%~S~%~%" C2)
    (cond (%al% (format t "~%With ~% Proof-0:  ~s~% Proof-1:  ~s~% Proof-2:  ~s
 Given for Proving Induction-0, Induction-1, and Induction2.~%" 
      Proof-0 Proof-1 (cond ((< (symbol-length Proof-2) 12) Proof-2)
                            (t Plan-2))))

          (args (format t "~%With ~% Plan-0:   ~s~% Plan-1:   ~s~% Plan-2:   ~s
 Given for Proving Induction-0, Induction-1, and Induction2.~%" 
      Plan-0 Plan-1 Plan-2)))
      
    (if (not (or pl args))
     (if (y-or-n-pw "IS THIS OK?   Type:  ") T 
      (progn 
	(format t "~%Rejected - Do you want to try Again?
                      (Type  Y  or  N):  ")
	(if (y-or-n-pw) (return-from induction (INDUCTION))
	  (progn (format t"~%Exit INDUCTION & Go Back to OPTIONS~%") 
		 (return-from induction (OPTIONS))))))nil)

   (ANS T H C TL %GOAL-MESSAGE%)
   (ANS* 'TRY-INDUCTION)

;;%% Prove the Cases: Induction-0, Induction-1, and Induction-2.
    (setq lt* (cond (%al% 'ao) (t 'prove)))
    (COND 
     ((AND (SETQ %reduce-light% T)
	   (cond (CI (format t "~%Complete Induction 0th Case:~%")
		     (ans* 'Complete-Induction-0th-Case\:)
                     (setq plan* %plan%)  ;Save the main plan for continuation
                     (setq %plan%  Plan-0)
                     (cond ((SETQ THETA0 (IMPLY H C0 (APPEND TL 
                                    '(INDUCTION-0)) NIL LT* nil Proof-0))
                            (format t "~% $$$$$-Induction-0 Proved with MGU-&&&: ~s~%"                               theta0) t) 
                           (t (format t "~% $$$$$$$$$$-Induction-0 Failed-&&&~%") 
			      nil)))
		 (T (SETQ THETA0 T)))
	   (FORMAT NIL "~%Base Case:~%")
	   (ANS* 'Base-case\:)
           (or (setq %plan% Plan-1) t)
           (cond ((SETQ THETA (IMPLY H C1 (APPEND TL '(INDUCTION-1)) 
                                     NIL LT* nil Proof-1))
                  (format t "~% $$$$$-Induction-1 Proved with MGU-&&&: ~s~%"  
                             theta) t) 
                 (t (format t "~% $$$$$$$$$$-Induction-1 Failed-&&&~%") nil))

	   (SETQ %reduce-light% T)
	   (FORMAT NIL "~%Induction Step:~%")
	   (ANS* 'Induction-step\:)
           (or (setq %plan% Plan-2) t)
          (cond ((SETQ LAMBDA (IMPLY H C2 (APPEND TL '(INDUCTION-2)) 
                                      NIL LT* nil Proof-2))
                  (format t "~% $$$$$-Induction-2 Proved with MGU-&&&: ~s~%"  
                             lambda) t)
                 (t (format t "~% $$$$$$$$$$-Induction-2 Failed-&&&~%") nil))

      (COND ((not IH)			;regular case, when IH* is C*
	     (ANS (setq tau (COMPOSE THETA0 (COMPOSE THETA LAMBDA))))
             (setq %plan% plan*) 
	     (PROVE-YET tau) )
	    (T (SETQ %reduce-light% T)    ;Generalized Ind Case disabled 7/5/88
	       (FORMAT T "~%Generalized Hypothesis Case~%")
	       (ANS* '(Generalized Hypothesis Case))
               (setq H* (and-on-h '(nil nil nil nil)
                                   (List '& (List 'element N '(omega)) IH)))
	       (COND			;case where a generalized ind hyp is used
		((SETQ SIGMA 
		       (IMPLY H* C* (APPEND TL '(I-IH)) NIL LT* YET))
		 (format t "~% $$$$$$$$$$$$$$$$$$$$$$")
		 (format t "~% Induction-Gen Hyp Case  Proved with MGU ~s~%" 
                         sigma)
		 (setq tau (COMPOSE (COMPOSE THETA0 
					     (COMPOSE THETA LAMBDA)) SIGMA))
		 (ans tau)
                 (setq %plan% plan*)    ;restore the main plan for continuation
		 (prove-yet tau))
		(T (format t "~% $$$$$$$$$$$$$$$$$$$$$$")
                   (format t "~% Induction-Gen Hyp Case Failed~%")
                   (setq %plan% (cons 'no-op plan*))
                    ;;restore the main plan for continuation
		   (OPTIONS)) )) )) )) ))

(DEFUN induction-jr (args)     ;USED-IN OPTIONS for Journal Ready Proofs

  ;;See INDUCTION for a general description of how Induction works.  This 
  ;; version of induction is called only when the *jr-light* is on.
  ;;There are two cases: 
  ;;  Ordinary Induction, where args = N  or  ('Ordinary N IH).
  ;;   If args = ('Ordinary N IH)it inducts on N using induction hypothesis IH.
  ;;   If args = N, it automatically finds the ind hyp, IH.
  ;;   If args = nil, it automatically finds both I and IH>
  ;;  Complete Induction, where args = ('Complete F).
  ;;   Then it does complete induction on the parameter F.
  ;;   (Eg, (Complete (Excess-Literal (S)))).

   (declare  (special h c tl anc lt yet))
   (let (N F CI W N* C* H* X Pr FY TX TQ TY IH* C0 C1 C2 Theta Theta Lambda)

     (cond ((not args) (setq N nil) (setq IH nil))           ;Ordinary Ind case
	   ((and (not (atom args)) (eq 'Ordinary (car args)));Ordinary Ind case
	    (setq N (cadr args)) (setq IH (caddr args)))
	   ((and (not (atom args)) (eq 'complete (car args)));Complete Ind case
	    (setq F (cadr args)) (setq CI t))
	   (t (setq N args) (setq IH nil)))                  ;Ordinary Ind case
	   

;;%% Prepare for Induction, Ordinary Induction Case
    (cond 
     ((not CI)		;The Ordinary induction case (not complete-induction)
      (cond (IH (setq N* N) (setq H* H))
            ((or 
              (and (setq W (prepare-for-induction (cadr H) C N))
		   ;;First try h-gu = (cadr H)
		   ;;(H -> C) is rewritten as ((element N (omega)) -> C*),
		   ;;                         W=(N C*)
		   (setq N* (car W)) (setq C* (cadr W)) 
                   (setq H* (subst nil (cadr H) H :test 'equal)))
              (and (setq W (prepare-for-induction (cadddr H) C N))
		   ;;and then try hv = (cadddr H)
		   ;;(H -> C) is rewritten as ((element N (omega)) -> C*),
		   ;;                         W=(N C*)
		   (setq N* (car W)) (setq C* (cadr W))
                   (setq H* (subst nil (cadddr H) H :test 'equal)))))
	    (t (format t  "~%For your N, ie, ~s , the Hypothesis: (element N (omega)) is not in H ~%" N)               
	       (format t "~%Do you want to try Again?
                      (Type  Y  or  N):  ")
	       (if (y-or-n-pw) (return-from induction (INDUCTION))
		 (progn (format t"~%Exit INDUCTION & Go Back to OPTIONS~%") 
			(return-from induction (OPTIONS))))))

      (setq N N*)

      (setq IH* (cond (IH IH) (t C*)))

      (setq IH* (cond ((setq V (free-variables-in ih*))
		       (existentially-quantify IH* V))
                      (t IH*)))

      (setq C0 nil)
      (SETQ C1 (SUBST= 0 N IH*))
      (SETQ C2 (LIST '-> (List '& (List 'element N '(omega)) IH*)
		     (SUBST= (LIST 'SCSR N) N IH*)))

      (setq W (list '& C0 C1 C2))
      (SETQ W (UNIQUE-BOUND-VARIABLES W))
      (setq C0 (cadr W)) (setq C1 (caddr W)) (setq C2 (cadddr W))

      (cond (V (setq C0 (skolem C0 Nil t))
	       (setq C1 (skolem C1 Nil t))
	       (setq C2 (skolem C2 Nil t)) )))

;;%% Prepare for Complete Induction Case.
     (CI		
      (setq H* H)
      (setq X (bound-variables-induction F))

      (setq pr (mapcar #'(lambda (z) (cons z (new-symbol (car z)))) X))
      (setq FY (sublis= pr F))
      (setq TX (list '-> (and-on (cadr H) (cadddr H)) C)) ;(h-gu & Hv -> C)
      (setq TQ (cond ((setq V (free-variables-in TX))
		      (existentially-quantify TX V))
		     (t TX)))
      (setq TY (sublis= pr TQ))
      (setq IH* (list '-> (list '< (list '+ FY (list '- F))) TY))
      (setq Y (mapcar #'cdr pr))
      (setq IH* (universally-quantify IH* Y))

      (setq C0 (list '<= (list '- F)))	;(element of (omega)) later?
      (setq C1 (list '-> (list '= F 0) C))
      (setq C2 (list '-> (list '& IH* (list '< (list '- F))) C))

      (setq W (list '& C0 C1 C2))
      (SETQ W (UNIQUE-BOUND-VARIABLES W))
      (setq C0 (cadr W)) (setq C1 (caddr W)) (setq C2 (cadddr W))

      (setq C2 (skolem C2 Nil t))))
                           
    (cond ((occur-in '(< > + *) C)		;arithemetic case
           (setq c2 (repl-scsr c2))
           (setq h  (repl-scsr h))))

;;Most of the Printing is suppressed in this version (see INDUCTION).

    (ind2)(format t "Induction Hypothesis-~%")
    (ind2)(format t "~s~%~%" IH*) 

;;%% Prove the Cases: Induction-0, Induction-1, and Induction-2.

;   (SETQ %reduce-light% T)
    (COND 
     ((AND 
       (cond (CI (ind2)(format t "Induction-0 Being Proved~%")
		 (ind2)(format t "  ~s" C0)
		 (setq *indent* (+ *indent* 2))
		 (setq *suppress-printing-c* t)
		 (cond ((SETQ THETA0 (IMPLY H* C0 (APPEND TL '(INDUCTION-0)) 
					    NIL LT* nil))
			(setq *indent* (- *indent* 2))
			(ind2)(format t "Induction-0 Has Been Proved~%")
			(ind2)(format t "   ~s~%~%" C0)
			t)
		       (t (format t "~% $$$$$$$$$$-Induction-0 Failed-&&&~%") 
			  nil)))
	     (T (SETQ THETA0 T)))

       (ind2)(or (format t "Induction-1 Being Proved~%")t)
       (ind2)(or (format t "   ~s" C1)t)
       (setq *indent* (+ *indent* 2))
       (setq *suppress-printing-c* t)
       (cond ((SETQ THETA (IMPLY H* C1 (APPEND TL '(INDUCTION-1)) 
				 NIL LT* nil))
	      (setq *indent* (- *indent* 2)) 
	      (ind2)(format t "Induction-1 Has Been Proved~%")
	      (ind2)(format t "   ~s~%~%" C1)
	      t)
	     (t (format t "~% $$$$$$$$$$-Induction-1 Failed-&&&~%") nil))

       (ind2)(or (format t "Induction-2 Being Proved~%")t)
       (ind2)(or (format t "   ~s" C2)t)
       (setq *indent* (+ *indent* 2))
       (setq *suppress-printing-c* t)
       (cond ((SETQ LAMBDA (IMPLY H* C2 (APPEND TL '(INDUCTION-2)) 
				  NIL LT* nil))
	      (setq *indent* (- *indent* 2))
	      (ind2)(format t "Induction-2 Has Been Proved~%")
	      (ind2)(format t "   ~s~%~%" C2)
	      t)

	     (t (format t "~% $$$$$$$$$$-Induction-2 Failed-&&&~%") nil)) )

 ;;Generalized Induction Case not in operation 7Aug89
      (COMPOSE THETA0 (COMPOSE THETA LAMBDA)))

     (t (format t "~% $$$$$$$$$$-Induction Failed-&&&~%") nil)) ))

(defun Lett (&optional x&F)                           ;Called by OPTIONS
   ;;This permits the user to assign a constant symbol x to
   ;; a formula F for convenience in referring to F.
   ;;The only result is that (= (x) F) is placed in the Hyp H
  (declare  (special h c tl anc lt yet))
  (let (x F u)
    (cond (x&F (setq x (car x&F)) (setq F (cadr x&F))
	       (setq u (list '= (list x) F))
	       (setq H (and-on-h H u))
	       (setq tl (append tl (list 'Let)))
	       (cond (*jr-light* (setq *suppress-printing-c* t)))

               ;;Note that this is the only use of Lett from JOURNAL-READY
	       (cond (%al% t) (t (options))))
          (t (format t "~%          LET ~%")
	     (format t "~% This permits the user to assign a constant
Symbol x to a formula F.  Then (= (x) F) is placed in H.~%")
	     (format t "~%Please type x:  ")
	     (setq x (read-h))

	     (if (atom x) nil 
	       (progn (format t "~%Your x is an atom.  Rejected.
            Do you wish to try again?  (Type: Y or N):   ")
		      (if (y-or-n-pw) (return-from Lett (Lett))
			(return-from Lett (options)))))
	     (format t "~%Please type F:  ")
	     (setq F (read-h))

	     (setq u (list '= (list x) F))
	     (format t "(~% The hypothesis   ~s   is to be placed in H.  
    ~%Is that OK?  (Type Y or N):  " u)
	     (if (y-or-n-pw) 
		 (progn (setq H (and-on-h H u)) 
			(setq tl (append tl (list 'Let)))(options))
	       (progn 
		 (format t "~%Rejected - Do you want to try Again?
                      (Type  Y  or  N):  ")
		 (if (y-or-n-pw) (return-from Lett (LETT))
		   (progn (format t"~%Exit LETT & Go Back to OPTIONS~%") 
			  (return-from Lett (OPTIONS)))))) ))))

(DEFUN MAN-SUBST NIL                    ;USED-IN (OPTIONS)
 (declare  (special h c tl anc lt yet))
 (let (X THETA VALUEE TH1 y tl* yet*)

  (format t "~%Substitute for what Variable?:  ")
  (SETQ X (READ-H))

  (If (occur x (LIST '-> H C)) T  (progn
    (format t "~% ~s does not occur in the theorem.~%
      Do you want to try again?  (Type  Y  or  N):  " x)
    (if (y-or-n-pw) (Return-From Man-Subst (man-subst)) 
                   (Return-From Man-Subst (OPTIONS)))))

  (format t "~%PUT What, for that Variable:  ")  
  (SETQ VALUEE (READ-H))
  (SETQ THETA (LIST (CONS X VALUEE )))
  (SETQ *PUTLIST* (APPEND THETA *PUTLIST*))

  (SETQ TH1 (SUBLIS= THETA (LIST '-> H C)))
  (format t "~%====MANUAL SUBSTITUTION====")
  (format t "~%The result of PUT is:~%")
  (Format-S (cadr th1)) (format t "~% ------>") (Format-S (caddr th1))
  (TERPRI) (TERPRI)
  (if (y-or-n-pw "IS THIS OK?   Type:  ") T 
    (progn 
      (format t "~%PUT Rejected - Do you want to try PUT again? 
                      (Type  Y  or  N):  ")
      (if (y-or-n-pw) (return-from man-subst (man-subst))
       (progn (format t"~%EXIT PUT & Go Back to OPTIONS") 
              (return-from man-subst (OPTIONS))))))

  (SETQ %reduce-light% T)
  
  (setq tl* (append tl '(PUT)))
  (setq yet* (mapcar #'(lambda (u) (cons (compose (car u) theta) (cdr u)))
		     yet))	;compose THETA with existing subs of yet.

  (COND ((SETQ Y (IMPLY (CADR TH1) (CADDR TH1) TL* NIL 'PROVE YET*))
	 (COMPOSE theta Y))
	(T NIL))))

(DEFUN NEW-BINDINGS (A)   ;used by apply-lemma,apply-reduce
  (MAPCAR #'(lambda (X) (CONS X (GENSYM))) 
          (ALL-VARIABLES-IN A)))

(defun no-op ()     ;Called by OPTIONS
  ;;This halts the procedure of a Plan, saves %Plan% in %Plan%%, and 
  ;; waits at **-IMPLY-STOP-** for user input.  The user 
  ;; can continue with %Plan% by typing (apply %Plan%%) or (a %Plan%%).

  (format t "~%Your NO-OP command has Interrupted the processing of %plan%. 
   To continue with %Plan%, type: noc ~%")
  
  (setq %plan%% %plan%)   (setq %plan% nil) (options))

(defun noc ()    ;Called by OPTIONS,  see no-op
  (format t ": Continue %Plan% after no-op command~%")
  (setq %plan% %plan%%) (options))

;(defun no-r () (setq *global-no-reduce-light* t))
;(defun off-no-r () (setq *global-no-reduce-light* nil))

(DEFUN NUMBER&PRINT (HC &OPTIONAL (N 1))   ;Called by OPTIONS
 ;;Number and print the conjuncts of HC
 (COND ((OR (ATOM HC) (NOT (EQ '& (CAR HC)))) 
        (format-s HC) (TERPRI))
       ((NULL (CDR HC)) NIL)
       (T (FORMAT T "~%~S :  ~S~%" N (CADR HC))
          (SETQ N (1+ N)) 
          (NUMBER&PRINT (CONS '& (CDDR HC)) N))))

(DEFUN NUMBER&PRINT-H  (H)                 ;Called from Analogy.lisp
  (NUMBER&PRINT-List (car H) (cadr H) (caddr H) (cadddr H)))

(DEFUN NUMBER&PRINT-List  (U GU H= Hv &OPTIONAL (N 1))   ;Called by OPTIONS
  (and U (or (format t "~%USE Argument:~%")t) (number&print U N))
  (and GU (or (format t "~%H-Ground-units:~%")t) (number&print GU N))
  (and H= (or (format t "~%H=:~%") t) (number&print H= N))
  (and Hv (or (format t "~%Hv:~%") t) (number&print Hv N)))

(DEFUN NUMBER&PRINT-infix (HC &OPTIONAL (N 1) (width 0))  ;Called by OPTIONS
  ;;Number and print, in INFIX mode, the conjuncts of HC
 (COND ((OR (ATOM HC) (NOT (EQ '& (CAR HC)))) 
        (infix HC 1) (TERPRI))
       ((NULL (CDR HC)) NIL)
        ;;Print if you can, but fix for the next printing

       (t (cond ((zerop width) (format t "~%~%") (infix (cadr HC) N) 
		 (cond ((< 12 (symbol-length (cadr HC))) (setq width 0))
		       (t (setq width 40)) ))
		((< 12 (symbol-length (cadr HC))) 
                 (format t "~%~%") (infix (cadr HC) N) 
                 (cond ((< 12 (symbol-length (cadr HC))) (setq width 0))
		       (t (setq width 40)) ))

		(t (format t "~40t") (infix (cadr HC) N) (setq width 0)))

          (SETQ N (1+ N)) 
	  (NUMBER&PRINT-infix (CONS '& (CDDR HC)) N width))))


;;;**********************************************************************
;;;
;;;                     OPTIONS.LISP   (cont)
;;;
;;;               W. W. Bledsoe      12 Feb 1987    29 June 1988
;;;                                                 25 Feb  1989
;;;                 Called by  IMPLY.LISP            1 Mar  1990
;;;
;;;        Was divided into 4 parts for ease of Compiling
;;;                 9Jan92: now recombined.
;;;
;;;***********************************************************************

(defun occur (a b)   ;does x occur in A?
    (cond ((equal a b) t)
          ((atom b) nil)
          (t (some #'(lambda (x) (occur a x)) b))))
 
(DEFUN OCCUR-INSTANCE (A C)   ;used by SUBST-INSTANCE
  ;;This returns the pair (A* THETA) where A* is the first subform of C
  ;;for which  A* is a  THETA-instance of A
  (LET (THETA)
       (COND ((SETQ THETA (INSTANCE C A)) (LIST C THETA))
             ((ATOM C) NIL)
             (T (SOME #'(LAMBDA (C*) (OCCUR-INSTANCE A C*)) (CDR C))) )))

(defun occur-in (L C)           ;used by INDUCTION, 
                                ;does a member of the list L occur in C
  (some #'(lambda (s) (occur s C)) L))

(defun occur-list (A L)  ;called by Reorder-c (from And-C)
  ;;Returns the list of elements of L which occur in A.
  (remove-if-not #'(lambda (x) (occur x A)) L))

(defun occur-predicate (a b)  
  ;;like OCCUR, except that a must be one of the logical symbols,
  ;;  & or -> not all some, or be a top level pred. symbol within one of these.
  (cond ((atom b) nil)
        ((eq a (car b)) t)
        ((member (car b) '(& or -> not all some))
         (some #'(lambda (x) (occur-predicate a x)) (cdr b)))))

        

(defun pair (L L2) (cond 
    ((null L) nil)
    ((null L2) nil)
    (t (cons (cons (car L) (car L2)) (pair (cdr L) (cdr L2))))))

(DEFUN PICK (L HH)    ;Choose from HH the members corresponding to the 
                      ;numbers in L
  (PROG (X LL)
        (SETQ LL(MAPCAR #'(LAMBDA (N) (COND ((SETQ X (NTH N HH)) X)
                                    (T (RETURN NIL)))) L))
        (RETURN LL)))

(defun prepare-for-induction (H C N)  ;Called by Induction
  ;;This attemps to express (H -> C) in the form ( (ele N omeg) -> C* ),
  ;; and return  W = (N C*).  If N is nil it attempts to find such a N.

  (let (W C*)
    (cond 
     (h 
      (cond 
       ((atom H)
	(cond ((setq W (prepare-for-induction nil C N))
	       (list (car W) (imp-on H (cadr W))))
	      ;;Treat ( H -> ( (ele N omeg) -> C)) like
	      ;;      ( (ele N omeg) -> (H -> C) )
	      (t nil )))
       ((and (eq 'element (car H)) 
	     (or (null N) (equal N (cadr H))) 
	     (equal '(omega) (caddr H)))
	(list (cadr H) C))

       ((and (eq '& (car H))
	     (some #'(lambda (H*) 
		       (and (not (atom H*)) (eq 'element (car h*))
			    (or (null N) (equal N (cadr H*)))
                            (equal '(omega) (caddr H*))
                            (setq N (cadr H*))
                            (setq H* (remove H* H :test 'equal))
                            (setq C* (imp-on H* C))
			    (setq W (list N C*)))) (cdr H)))
	W)
      ((setq W (prepare-for-induction nil C N))
       (list (car W) (imp-on H (cadr W))))
      ;;Treat ( H -> ( (ele N omeg) -> C)) like
      ;;      ( (ele N omeg) -> (H -> C) )
      (t nil )))

     ((atom C) nil)
     ((eq '-> (car C)) (prepare-for-induction (cadr C) (caddr C) N))
     ;;Treat  (nil -> (H2 -> C2)) as (H2 -> C2), ie, Promote
     (t nil ))))

(defun promote () 
 (declare  (special h c tl anc lt yet))
 (cond (*jr-light* (ind2) (--) (format t "Current Goal:")
		   (-%)(ind2)(--)
		   (cond (*iprn* (print-infix (caddr C) 0))
			 (t (format t " ~s" (caddr C))))
		   (setq *suppress-printing-c* t)))
       
 (setq tl (append tl '(P->)))
 (setq H (and-on-h H (cadr C))) (setq C (caddr C)) )

(DEFUN PUT NIL                    ;USED-IN (OPTIONS)
 ;;Manual sutstitution. Allows the user to instantiate a variable with a term.
 (declare  (special h c tl anc lt yet))
 (let (X THETA VALUEE TH1 y tl* yet* H* Hv H=)

  (format t "~%Substitute for what Variable?:  ")
  (SETQ X (READ-H))

  (If (occur x (LIST '-> H C)) T  (progn
    (format t "~% ~s does not occur in the theorem.~%
      Do you want to try again?  (Type  Y  or  N):  " x)
    (if (y-or-n-pw) (Return-From Put (Put)) 
                   (Return-From Put (OPTIONS)))))

  (format t "~%PUT What Term, for that Variable:  ")  
  (SETQ VALUEE (READ-H))
  (SETQ THETA (LIST (CONS X VALUEE )))
  (SETQ *PUTLIST* (APPEND THETA *PUTLIST*))

  (SETQ TH1 (SUBLIS= THETA (LIST '-> H C)))
  (format t "~%====MANUAL SUBSTITUTION====")
  (format t "~%The result of PUT is:~%")
  (Format-S (cadr th1)) (format t "~% ------>") (Format-S (caddr th1))
   ;;Format-S prints a shortened version of its argument.
    (TERPRI) (TERPRI)
  (if (y-or-n-pw "IS THIS OK?   Type:  ") T 
    (progn 
      (format t "~%PUT Rejected - Do you want to try PUT again? 
                      (Type  Y  or  N):  ")
      (if (y-or-n-pw) (return-from Put (Put))
       (progn (format t"~%EXIT PUT & Go Back to OPTIONS") 
              (return-from Put (OPTIONS))))))

  (SETQ %reduce-light% T)
  
  (setq tl* (append tl '(PUT)))
  (setq yet* (mapcar #'(lambda (u) (cons (compose (car u) theta) (cdr u)))
		     yet))	;compose THETA with existing subs of yet.

  (setq H* (cadr th1)) (setq H= (caddr H*)) (setq Hv (cadddr H*))
  (setq H* (list (car H*) (cadr H*) nil nil))
  (setq H* (and-on-h (and-on-h H* Hv) H=))      ;put ground parts into h-gu

  (COND ((SETQ Y (IMPLY H* (CADDR TH1) TL* NIL 'PROVE YET*))
	 (COMPOSE theta Y))
	(T NIL))))

(defun put-theta (theta)         ;28Jan92  Called by OPTIONS
  ;;replace H and C by (H theta) and (C theta)
   (declare  (special h c tl anc lt yet))
   (setq H (sublis theta H :test 'equal))
   (setq C (sublis theta C :test 'equal))
   (options))

(DEFVAR PUTLIST NIL)   ;USED-IN (PUT SET-VALUES)

#|(DEFUN QED NIL   ;USED-IN (AND-C IMPLY OPTIONS OR-H PROVE-THE-PREMISE 
                 ;         REPORT)
 (declare  (special h c tl anc lt yet))
 (AND (SETQ QED-LT T)
       (NOT (UPDATE-HISTORY))
       (IMPLY DB H C (PRINT (APPEND TL '(QED))) 3 PV CE-YET)))
|#

(defun reduce-lt (&optional (n t))
   (setq *reduce-light* (cond (n t) (t nil))))
(defun no-reduce-lt () (reduce-lt nil))

(defun remove& (A)  ;eg, (& A B C) goes to (A B C), and A to (A).
   (cond ((atom A) (list A))
         ((eq '& (car A)) (cdr A))
         (t (list A))))
 
(defun remove-superfluous-quantifiers (A)  ;Called by USE-A
  (cond ((atom A) A)
        ((member (car A) '(all some))
         (cond ((atom (cadr A)) 
                (list (car A) (cadr A) 
                      (remove-superfluous-quantifiers (caddr A))))
               (t     (remove-superfluous-quantifiers (caddr A)))))
        (t (cons (remove-superfluous-quantifiers (car A))
                 (remove-superfluous-quantifiers (cdr A))))))

(DEFUN REORDER-H (L &optional (H-which 'H)) ;this reorders the hypotheses of H
  (declare (special H))
  (format t "~%~%****-REORDER THE HYPOTHESES OF ~s-****~%~%" h-which)
  (LET (H* H2 l1 L2)
       (setq H* (cond ((member H-which '(H Hv)) (cadddr H)) (t (cadr H))))
       (SETQ L1 (REMOVE 'H L))  
       (SETQ L1 (REMOVE 'H-gu L1))
       (SETQ L1 (REMOVE 'HD L1))  
       (SETQ L1 (REMOVE 'H-guD L1))  
       (SETQ L1 (REMOVE 'Hv L1))  
       (COND ((NOT (EQ '& (CAR H*))) 
	      (FORMAT T "~%Hypothesis not a conjunct~%
                           So we cannot reorder it.~%")
               )
             ((NOT (SETQ L2 (PICK L1 H*)))
	      (FORMAT T "~%The listed numbers do not represent 
                  Hypotheses of H~%")
               )   ;clear the read-char buffer
	     (T (SETQ %GOAL-MESSAGE% 'Reorder-Hypotheses-of-H)
		(SETQ H2 (cond ((member (car L) '(hd h-gud)) (CONS '& L2))
                               (t (CONS '& (APPEND L2 
		 		   (SET-DIFFERENCE-W (CDR H*) L2))))))
		(NUMBER&PRINT H2)
                (cond ((not %plan%)
                  (IF (Y-OR-N-PW "Is that correct?") 
		      (cond ((eq H-which 'H) 
                             (SETQ H (subst H2 (cadddr H) H :test 'equal)))
                            (t (setq H (subst H2 (cadr H) H :test 'equal))))
		      (IF (y-or-n-pw "Do you want to answer again?") 
			  (REORDER-H L H-which)
			  T)))))
		)))
 
(DEFUN REORDER-C (L) ;this reorders the hypotheses of C
  (declare (special C))
  (format t "~%~%Reorder the Conclusions of C~%~%")
  (LET (C2 L2)
       (SETQ L (REMOVE 'C L))  
       (COND ((NOT (EQ '& (CAR C))) 
	      (FORMAT T "~%Conclusion is not a conjunct~%
                           So we cannot reorder it.~%") 
               )
              
             ((NOT (SETQ L2 (PICK L C)))
	      (FORMAT T "~%The listed numbers do not represent 
                  Conclusions of C~%")
               )   ;clear the read-char buffer
	     (T (SETQ %GOAL-MESSAGE% 'Reorder-Conclusions-of-H)
		(SETQ C2 (CONS '& (APPEND L2 (SET-DIFFERENCE-W (CDR C) L2))))
		(NUMBER&PRINT C2)
                (IF (Y-OR-N-PW "Is that correct?") (SETQ C C2)
                    (IF (y-or-n-pw "Do you want to answer again?") 
                        (REORDER-C L)
                        T)))
		)))

(defun repl-scsr (A)
   (cond ((atom A) A)
         ((eq 'scsr (car A)) (list '+ (cadr A) 1))
         (t (cons (repl-scsr (car A)) (repl-scsr (cdr A))))))

(DEFUN RULE-USED (C DT)  ;Return the rule for which C is an instance of its LS
  (SOME #'(LAMBDA (R) (AND (INSTANCE C (CAR R)) R)) DT))

(DEFUN SHOW-DEF NIL                 ;Used by  OPTIONS
  (PROG (R)
        (FORMAT T "~%      +++++ SHOW-DEF ++++~%~%What Term do you wish to see the definition of?  ")
        (SETQ R (READ-H))
        (PPRINT (DEFN R))))
 

(DEFUN SKO-IN (S)                      ;USED-IN (PUT) Not any more.
  (COND ((NULL S) NIL)
	((ATOM S) S)
	((NULL (CDR S))
	 (COND ((AND (ATOM (CAR S)) (GET (CAR S) 'REPRESENTS))
		(GET (CAR S) 'REPRESENTS))  ;not used now.  It lets us replace 
                                            ;S by something that represents it
	       ((ATOM (CAR S)) S)
	       (T (CONS (SKO-IN (CAR S)) NIL))))
	(T (CONS (SKO-IN (CAR S)) (SKO-IN (CDR S))))))


(defun split-c (Two-Plans)     ;Called by options
  (declare  (special h c tl anc lt yet))
  (let (plan1 plan2 plan* c* c1 c2 tl1 tl2 theta lambda lt* yet* H2)
       (setq plan* %plan%)   ;Save the main plan for continuation
       (setq plan1 (car  Two-Plans))
       (setq plan2 (cadr Two-Plans))
       (setq c* c)
       (cond ((or (eq-car c* '&) (eq-car (setq c* (and-out c*)) '&))
              (setq c1 (cadr c))
              (setq c2 (last-part c)))
             (t (format t "~%C cannot be Split~%")
                (cond ((not %al%) (setq %plan% (cons 'no-op plan*))
		                  (return-from split-c (options)))
                      (%al% (return-from split-c nil)))))

       (setq tl1 (append tl '(C1))) (setq tl2 (append tl '(C2)))
       (setq %plan% plan1)
       ;;Since we usually emply this when C is ground, there is no need for 
       ;; putting c2 into YET.
       (setq lt* (cond (%al% 'ao) (t 'prove)))
       (setq yet* (cond (%al% nil) (t yet)))
       (cond ((setq theta (imply H c1 tl1 NIL lt* YET* Plan1))
              (format t "~%First Part of Split-c Proved with MGU: ~s~%" theta)
              (setq %plan% plan2)
              (setq C2 (apply-substitution theta C2))
              (cond ((setq lambda (imply H c2 tl2 NIL lt* YET* Plan2))
                     (format t "~%Second Part of Split-c Proved with MGU: ~s~%"
                             lambda)
                     (setq %plan% plan*) ;Restore the main plan for contin.
                     (compose theta lambda))
                    (t (format t "~%Second Part of Split-c Failed~%")
                       (cond ((not %al%) (setq %plan% (cons 'no-op plan*)) 
                                        (options))
                             (%al% nil)))))
             (t (format t "~%First Part of Split-c Failed~%")
		(cond ((not %al%) (setq %plan% (cons 'no-op plan*)) 
                                  (options))
                      (%al% nil))))))

(defun split-h (Two-Plans)     ;Called by options
  (declare  (special h c tl anc lt yet))
  (let (plan1 plan2 plan* h-gu Hv H1 H2 tl1 tl2 theta lambda 
        lt* yet* Proof-1 Proof-2)
       (cond (two-plans nil) (t (setq two-plans '(nil nil))))
       (setq h-gu (cadr H)) (setq Hv (cadddr H))
       (setq plan* %plan%)   ;Save the main plan for continuation
       (setq plan1 (car  Two-Plans))
       (setq plan2 (cadr Two-Plans))
       (cond (%al% (setq Proof-1 (eval Plan1))
		   (setq Proof-2 (eval Plan2))))

       (cond ((or (eq-car h-gu 'or) (eq-car (setq h-gu (or-out h-gu)) 'or))
              (setq H1 (and-on-h H (cadr h-gu) (cadr H))) 
              (setq H2 (and-on-h H (last-part h-gu) (cadr H))))
             ((eq-car Hv 'or)
              (setq H1 (and-on-h H (cadr Hv) (cadddr H)))
              (setq H2 (and-on-h H (last-part Hv) (cadddr H))))
             (t (format t "~%h-gu cannot be Split~%")
                (cond ((not %al%) (setq %plan% (cons 'no-op plan*))
		                  (return-from split-h (options)))
                      (%al% nil))))

       (setq tl1 (append tl '(H1))) (setq tl2 (append tl '(H2)))
       (setq %plan% plan1)
       (setq lt* (cond (%al% 'ao) (t 'prove)))
       (setq yet* (cond (%al% nil) (t yet)))
       (cond ((setq theta (imply H1 C tl1 NIL lt* YET* proof-1))
              (format t "~%First Part of Split-h Proved with MGU: ~s~%" theta)
              (setq %plan% plan2)
              (setq H2 (apply-substitution theta H2))
              (cond ((setq lambda (imply H2 C tl2 NIL lt* YET* proof-2))
                     (format t "~%Second Part of Split-h Proved with MGU: ~s~%"
                             lambda)
                     (setq %plan% plan*) ;Restore the main plan for contin.
                     (compose theta lambda))
                    (t (format t "~%Second Part of Split-h Failed~%")
                       (cond ((not %al%) (setq %plan% (cons 'no-op plan*)) 
                                         (options))
                             (%al% nil)))))
             (t (format t "~%First Part of Split-h Failed~%")
		(cond ((not %al%) (setq %plan% (cons 'no-op plan*)) 
                                  (options))
                      (%al% nil))))))

(defun sub==-in (x)    ;called by A-options
  ;;Apply SUB==-IN (below) to H and then prove the current goal C,
  ;; with the altered hypothesis in USE.
  (declare  (special h c tl anc lt yet))
  (let (H% H$ H* use h-gu H= Hv)
    (setq use (car H)) (setq h-gu (cadr H)) (setq H= (caddr H)) 
                       (setq Hv (cadddr H))
    (cond ((not (equal H= (setq H$ (sub=-in x H=))))
           (setq H% H=))
	  ((not (equal Hv (setq H$ (sub=-in x Hv))))
           (setq H% Hv))
	  ((not (equal use (setq H$ (sub=-in x use))))
           (setq H% use))
	  ((not (equal h-gu (setq H$ (sub=-in x h-gu))))
           (setq H% h-gu))
          (t (format t "~%Failed to find x in H~%") 
             (return-from sub==-in nil)))
    (setq H* (subst H$ H% (copy-tree H) :test 'equal))
    (imply H* C tl anc 'prove nil) ))

(defun sub=-in (x A)   ;called by sub==-in
  ;;If A contains a subformula of the form (= x t) then replace x by t
  ;; in all other subformulas of A which are "conjunctive" with (= x t),
  ;; and discard (= x t).
  ;;For example, if A is  (Q -> P(x) & [(= x t1) or (= x t2)]), then
  ;; replace it by        (Q -> P(t1) or P(t2)).
  (let (uu A*)
    (cond ((atom A) A)
          ((eq '-> (car A)) 
           (list '-> (sub=-in x (cadr A)) (sub=-in x (caddr A))))
          ((eq 'or (car A))
           (cons 'or (mapcar #'(lambda (u) (sub=-in x u)) (cdr A))))
          ((eq 'not (car A)) (list 'not (sub=-in x (cadr A))))
          ((equal '& (car A))
           (cond ((not (equal A (setq A (or-out A 'imp)))) (sub=-in x A))
		 ((not (some #'(lambda (u) (and (eq-car u '=) 
                                                (equal x (cadr u))
                                                (setq uu u))) 
                             (cdr A)))
                  A)
                 ((and (setq A* (remove-one uu A))
                       (setq A* (cond ((null (cdr A*)) nil)
                                      ((null (cddr A*)) (cadr A*))
                                      (t A*)))
                       (not (equal A* (setq A* (subst (caddr uu) x 
                                        (copy-tree A*) :test 'equal)))))
                  A*)
                 (t A)))
          (t A))))


(defun sub== (A &optional Hgu)    ;called by OPTIONS
  ;;Replace A by B in C if  (= A B) is in H and A occurs in C, 
  ;; else replace B by A if (= A B) is in H and B occurs in C.
  ;;Similarly replace in h-GU instead of C, if Hgu is not nil.
  (declare  (special h c tl anc lt yet))
  (let (B u CH h-gu CH*)
    (setq h-gu (cadr H))
    (setq CH (cond (Hgu h-gu) (t C)))
    (format t "~%        USER SUB==  ~%")
    (cond ((setq u (some #'(lambda (uu) (and (not (atom uu)) (eq '= (car uu))
                                             (equal A (cadr uu)) uu) )
                         (remove& (and-on (caddr H) (cadddr H))) ))
           (setq B (caddr u))
           (cond ((occur A CH) (setq CH* (subst= B A CH))
                  (format t "~% ~s is replaced by ~s in ~s ~%" 
                          A B (cond (Hgu 'h-gu)(t 'C))))
                 ((occur B CH) (setq CH* (subst= A B CH))
                  (format t "~% ~s is replaced by ~s in ~s ~%" 
                          B A (cond (Hgu 'h-gu)(t 'C))))
                 (t (format t "~%A or its equal does not occur in ~s ~%"
                            (cond (Hgu 'h-gu)(t 'C)))) ))
           (t (format t "~%A not found in ~s ~%" (cond (Hgu 'h-gu)(t 'C)))))
    (cond ((equal CH* CH) (cr-plan 0 'no-op))
          (hgu (setq H (and-on-h H CH* CH)))
          (t   (setq C CH*)))
    (cond ((not %al%) (options))
          ((equal CH* CH) nil)
          (t t)) ))

(defun subst= (a b c)  ;replace a by b in c
   ;;So that (subst= '(y) '(x) '(P x))                correctly gives   (P x).
   ;;Whereas (subst  '(y) '(x) '(P x) :test 'equal) incorrectly gives   (P y).
   (cond ((equal b c) a)
         ((atom c) c)
         (t (mapcar #'(lambda (x) (subst= a b x)) c))))

(defun sublis= (theta A)  ;apply the substitution theta to A
   ;;So that (sublis= '( ((x) y)) '(P x))     correctly gives   (P x).
   ;;Whereas (subst   '( ((x) y)) '(P x) :test 'equal) incorrectly gives (P y).
     (mapc #'(lambda (u) (setq A (subst= (cdr u) (car u) A))) theta)
     A)

(DEFUN SUBST-INSTANCE (A B C)     ;used by DEFINEC
  ;;This replaces each subform A* of C, for which mgu(A,A*) = THETA,
  ;;by  B THETA
  (LET (W A* B* THETA)
       (COND ((SETQ W (OCCUR-INSTANCE A C))
	      (SETQ A* (CAR W))
	      (SETQ THETA (CADR W))
	      (SETQ B* (SUBLIS= THETA B))
	      (RETURN-FROM SUBST-INSTANCE 
			   (SUBST-INSTANCE A B (SUBST= B* A* C))))
             (T C))))
 


(defun symbol-length (A)   ;called by NUMBER&PRINT-INFIX
  (cond ((null A) 0)
        ((atom A) 1)        (t (+ (symbol-length (car A)) (symbol-length (cdr A)))) ))

(defun TESTR NIL                      ;USED-IN (EVLOOP INDUCTION OPTIONS)
  (prog (READ)
    (setq read (read-char))
    (return (COND ((char= READ #\linefeed) 'CARRIAGE-RETURN)
	  ;;this lets the user type a carriage-return in OPTIONS to Proceed
	          (T (unread-char READ) NIL)))))

(DEFUN TRYREDUCE (CorH &optional *flag)			;used by  OPTIONS
  (declare  (special h c tl anc lt yet))
  (let (c* h* rl tl* Hv h-gu)

    (format t "~% ************* ~s is being REDUCED ************~%" CorH)
 
    (setq rl *reduce-light*)	;Save the value of RL
    (setq *reduce-light* t)	;Turn it on
    (setq tl* (cond ((equal '(\.) (last tl)) (append tl '(R)))
                     (t (append tl '(\. R)))))
    (COND ((EQ CorH 'C)
	   (setq C* (binary-to-unary< C))
           (cond ((Equal C (setq C* (cond (*flag (reduc** C* t))
                                          (t     (reduc   C* t)))))
                  (print '(No Change in C))
                  t)
                 (t (format t "~%C has been REDUCED from ~%")
                    (format-s C) (format t "~% to ~%")
                    (format-s C*)
                    (write-goal-message)
                    (ans* (list C 'has-been-been-REDUCED-to C*))
	            (SETQ C C*) (setq tl tl*)
;                   (cond (%plan% (cr-plan)))
		    t) ))

           ((EQ CorH 'Hv)
	    (setq H* (binary-to-unary< (setq Hv (cadddr H))))
	    (cond ((Equal Hv (setq H* (cond (*flag (reduc** H* nil))
					   (t     (reduc   H* nil)))))
		   (print '(No Change in Hv))
		   t)
                  (t (format t "~%Hv has been REDUCED from ~%")
		     (format-s Hv) (format t "~% to ~%")
		     (format-s H*)
		     (write-goal-message)
                     (ans* (list Hv 'has-been-been-REDUCED-to H*))
		     (SETQ H (and-on-h H H* Hv))
                     (setq tl tl*)
		     t) ))

           ((EQ CorH 'H-Gu)
	    (setq H* (binary-to-unary< (setq h-gu (cadr H))))
	    (cond ((Equal H-Gu (setq H* (cond (*flag (reduc** H* nil))
					      (t     (reduc   H* nil)))))
		   (print '(No Change in H-Gu))
		   t)

                  (t (format t "~%H-gu has been REDUCED from ~%")
		     (format-s H-gu) (format t "~% to ~%")
		     (format-s H*)
		     (write-goal-message)
                     (ans* (list H-Gu 'has-been-been-REDUCED-to H*))
		     (SETQ H (and-on-h H H* h-gu))
		     (setq tl tl*)
		     t) ))

           ((EQ CorH 'H=)
	    (setq H* (binary-to-unary< (setq H= (caddr H))))
	    (cond ((Equal H= (setq H* (cond (*flag (reduc** H* nil))
					    (t     (reduc   H* nil)))))
		   (print '(No Change in H=))
		   t)

                  (t (format t "~%H= has been REDUCED from ~%")
		     (format-s H=) (format t "~% to ~%")
		     (format-s H*)
		     (write-goal-message)
                     (ans* (list H= 'has-been-been-REDUCED-to H*))
		     (SETQ H (and-on-h H H* H=))
		     (setq tl tl*)
		     t) )) )

    (setq *reduce-light* rl)	;Restore value of RL
    nil))

(DEFUN UNIVERSALIZE-FREE-VARIABLES-IN (A) ;Called by USE
  (let (V)
    (setq V (Free-variables-in A))
    (mapc #'(lambda (x) (setq A (list 'all x A))) (reverse V))
    A))

(defun universally-quantify (A L)
  (mapc #'(lambda (x) (setq A (list 'all x A))) L) A)

(DEFUN USE (&optional lemma theta Q H-Lt)	;used in  OPTIONS
  (declare  (special h c tl anc lt yet))
  (let (Lemma* GU c* c** h-gu USE H= Hv)
    (FORMAT T "       ======USE=====~%")

;;%% Read in the Lemma and print it.
    (cond (lemma (setq lemma (eval lemma)) 
		 (format t "~%The Lemma you have selected is:~%"))        
	  (t (FORMAT T "~%Type the Lemma you wish to use:  ")
	     (SETQ LEMMA (eval (READ-H))) (testr) ))
    (PPRINT LEMMA)(TERPRI)(TERPRI)
    
    (setq tl (append tl '(U)))
    (ANS T H C TL %GOAL-MESSAGE%)
    (SETQ %GOAL-MESSAGE% 'USE-LEMMA)
    (SETQ LEMMA (BINARY-TO-UNARY< LEMMA))

;;%% Store it in h-gu if it is ground and return to OPTIONS, else Slolemize it.
    (cond ((ground Lemma) 
           (setq H (and-on-h H lemma))
           (cond (Q (setq lt 'qed) (cr-plan))) ;because we go back to OPTIONS
                                               ; we need 'cr in Plan to proceed
           (return-from USE (options))))
    (SETQ LEMMA (UNIVERSALIZE-FREE-VARIABLES-IN LEMMA))
    (SETQ *LEMMA-LIST* (CONS LEMMA *LEMMA-LIST*))
    (SETQ %reduce-light% T)
    (SETQ LEMMA (SKOLEMIZE LEMMA nil NIL))

;;%% Store it in H (not USE) if H-lt is on and return to OPTIONS,
;;    else find the needed THETA, and apply it.

    (cond (H-Lt (format t "~%The Lemma is being placed in H~%")
                (setq H (and-on-h H Lemma)) 
                (cond (Q (setq lt 'qed) (cr-plan)))
                (return-from USE (options)))
          (theta (format t "~%The Theta you have selected is: ~s~%" theta))
          ((not (occur '& C))
           (format t "~%Since C contains no conjunctive subgoals, we put the 
             USE Lemma directly into the USE argument.~%")
           (setq theta t))
          (q (format t "~%Since you have used QED mode it will automatically
             find the substitution THETA for the Lemma.~%")
             (setq theta (find-theta Lemma))
	     (format t "~%It has found THETA = ~s ~%" theta))
	  (t (FORMAT T "~%Type the Theta you wish to use:  ")
	     (format t "~%Type T for NO SUBSTITUTION.
Type F if the computer is to FIND the substitution THETA for the Lemma.
   Type theta:  ")
	     (setq theta (read-h))
	     (cond ((eq 'F theta)
		    (setq theta (find-theta Lemma))
		    (format t "~%It has found THETA = ~s ~%" theta)) )))
    (setq Lemma* (apply-substitution theta Lemma))

;(format t "~%Middle H ~s~%" H)

;;%% Propositionally FC into the lemma, and store the results in h-gu, Hv,etc,
;;    and return to OPTIONS.

    (and (not (eq t theta)) 
         (setq h-gu (and-on (cadr H) (caddr H)))  ;(h-gu U H=)
         (setq GU (cond ((atom h-gu) nil)
                        ((eq '& (car h-gu)) (cdr h-gu))
                        (t (list h-gu))))
         (setq Lemma* (propositionally-forward-chain GU Lemma*)))
    (setq H (and-on-h H lemma* nil 'USE))
    (setq USE (car H)) (setq h-gu (cadr H)) (setq H= (caddr H))

;(format t "~%Low H ~s~%" H)
                                            (setq Hv (cadddr H))
    (cond ((setq GU (ground-units Lemma*))
	   (format t "~%The following units have been added to H:~%")      
	   (number&print GU)
	   (format t "~% (As a result of Forward-Chaining on the USE Lemma)~%")

           (and *pl* (format t "~%The Hypotheses now contain:~%")
		(number&print-list USE h-gu H= Hv))
           (cond ((null (setq c* (and-off c h-gu))) (setq c '(true)) 
                  (format t "~%C is a subset of h-gu~%"))
                 ((null (setq c** (and-off c* Hv))) (setq c '(true))
                  (format t "~%C is a subset of ~s~%" 
                          (cond ((equal c* c) 'Hv) (t '(h-gu & Hv))) ))
                 ((equal c** c) nil)
                 ((equal c* c) (setq c c**) 
                  (format t "~% Part of C is a subset of Hv~%"))
                 ((equal c** c*) (setq c c**)
                  (format t "~% Part of C is a subset of h-gu~%"))
                 (t (format t "~% Part of C is a subset of (h-gu & Hv)~%"))))
	  (t (format t "~%The USE Lemma has been put in the USE arg of IMPLY.~%")))
;(format t "~%Lowest H ~s~%" H)

    (cond (Q (setq lt 'qed) (cr-plan)))        ;because we go back to OPTIONS
                                               ; we need 'cr in Plan to proceed
    (options) ))

(defun USE-A (LEMMA &optional theta0)          ;Called by A-options.
  ;;This is the "Analogy" Version of the function USE.
  ;;It uses the Lemma LEMMA to prove C with substitution theta.
  ;;   If theta0 is given use it first, then derive theta.
  ;;   In either case theta is retuned.  Else nil is returned. 
  (declare  (special h c tl anc lt yet))
  (let (theta-f Lemma* GU USE h-gu H= Hv c* c**)

    (setq lemma (cond ((eq-car lemma '&)
                       (cons '& (mapcar #'eval (cdr lemma))))
                      (t (eval lemma))))
    (format t "~%The Action  USE-A  is being employed with 
    USE LEMMA: ~s ~%" lemma)
    (setq tl (append tl '(U)))
    (SETQ LEMMA* (BINARY-TO-UNARY< LEMMA))
    (cond (theta0 (setq Lemma* (apply-substitution theta0 Lemma*))
                  (setq Lemma* (remove-superfluous-quantifiers lemma*))))
    (cond ((setq GU (ground-units Lemma* nil T))
           (setq H (and-on-h H GU)) (setq Lemma* (and-off Lemma* GU))
           (cond ((null Lemma*) 
                  (return-from Use-A (imply H C TL nil 'prove nil))))))
			       
;;%%If Lemma* is not ground, Slolemize it, and derive and apply theta if
;;  Theta0 is nil.
    (cond  ((not (ground Lemma*))
	    (SETQ LEMMA* (UNIVERSALIZE-FREE-VARIABLES-IN LEMMA*))
	    (SETQ LEMMA* (SKOLEMIZE LEMMA* nil NIL)) 
            (cond ((not theta0)
		   (setq theta-f (find-theta Lemma*))
		   (format t "~%It has found THETA-f = ~s ~%" theta-f)
		   (setq Lemma* (apply-substitution theta-f Lemma*))
		   (setq GU (ground-units Lemma* nil T))
		   (setq H (and-on-h H GU)) (setq Lemma* (and-off Lemma* GU))
		   (cond ((null Lemma*) (return-from Use-A 
                                  (imply H C TL nil 'prove nil))))))))

;;%%Propositionally FC into the lemma*, and store the results in H.
    (setq GU (and-on (cadr H) (caddr H)))	;(h-gu and H=)
    (setq GU (cond ((atom GU) nil) ((eq '& (car GU)) (cdr GU))
		   (t (list GU))))
    (setq Lemma* (propositionally-forward-chain GU Lemma*))
    (setq H (and-on-h H lemma* nil 'USE))
    (setq USE (car H)) (setq h-gu (cadr H)) (setq H= (caddr H))
    (setq Hv (cadddr H))

;;%% Now Prove C.    
    (cond ((null (setq c* (and-off c h-gu))) (setq c '(true)) 
	   (format t "~%C is a subset of h-gu~%"))
	  ((null (setq c** (and-off c* Hv))) (setq c '(true))
	   (format t "~%C is a subset of ~s~%" 
		   (cond ((equal c* c) 'Hv) (t '(h-gu & Hv))) ))
	  ((equal c** c) nil)
	  ((equal c* c) (setq c c**) 
	   (format t "~% Part of C is a subset of Hv~%"))
	  ((equal c** c*) (setq c c**)
	   (format t "~% Part of C is a subset of h-gu~%"))
	  (t (format t "~% Part of C is a subset of (h-gu & Hv)~%")))
     
    (imply H C TL nil 'prove nil)))


(DEFUN USE-jr (Lemma)    ;used in OPTIONS, for Journal Ready proofs.
  ;;3Aug89 This is supposed to finish the proof of the current goal without
  ;; further user input.  Later we may need to arrange for further user input
  (declare  (special h c tl anc lt yet))
  (let (Lemma*)

    (cond ((atom Lemma) (setq Lemma (eval Lemma)))
	  ((eq '& (car Lemma))
	   (setq lemma* (eval (cadr Lemma)))
	   (mapc #'(lambda (u) (setq lemma* (and-on lemma* (eval u))))
		 (cddr Lemma))
	   (setq Lemma Lemma*))
	  (t (setq Lemma (eval Lemma))))

    (setq tl (append tl '(U)))
    (setq lemma (binary-to-unary< lemma))

;;%% Store it in h-gu if it is ground, else Slolemize it in H.
    (cond ((ground Lemma) (setq H (and-on-h H lemma)))
	  (t (setq lemma (universalize-free-variables-in lemma))
	     (setq %reduce-light% t)
	     (setq lemma (skolemize lemma nil nil))
	     (setq H (and-on-h H lemma))))

    (imply h c (append tl '(u)) anc 'qed yet) ))

(defun USE-BC (LEMMA &optional theta0)          ;Called by A-options.
  ;;This is like USE-A, except that it backchains on LEMMA to 
  ;;   to derive a new subgoal C* by back-chaining on it with 
  ;;   substitution theta. If theta0 is given use it first, then derive theta.
  ;;   In either case theta is retuned.  Else nil is returned. 
  (declare  (special h c tl anc lt yet))
  (let (theta Lemma* c*)

    (setq lemma (eval lemma)) 
    (format t "~%The Action  USE-BC  is being employed with 
    USE LEMMA: ~s ~%" lemma)
    (setq tl (append tl '(U)))
    (SETQ LEMMA* (BINARY-TO-UNARY< LEMMA))
    (cond (theta0 (setq Lemma* (apply-substitution theta0 Lemma*))
                  (setq Lemma* (remove-superfluous-quantifiers lemma*))))

;;%%If Lemma* is not ground, Slolemize it.
    (cond ((not (ground Lemma*))
           (SETQ LEMMA* (UNIVERSALIZE-FREE-VARIABLES-IN LEMMA*))
	   (SETQ LEMMA* (SKOLEMIZE LEMMA* nil NIL))))

    (cond ((setq theta (back-chain Lemma* 1 nil 'use-bc))
           (setq c* (car theta))
           (setq theta (cadr theta))
           (setq theta (compose theta theta0))
           (setq c* (apply-substitution theta c*))
           (list c* theta))) ))

(defun ve-lt (&optional (n t)) (setq *ve-light* (cond (n t) (t nil))))

