
;;;*********************************************************************
;;;
;;;               EXAMPLE-THEOREMS.LISP    In KCL
;;;                            
;;;               W. W. Bledsoe      21 Feb 1987   3 Mar 87  27 Aug 87
;;;                                                21 Jan 88
;;;
;;;                 For use by  IMPLY.LISP
;;;
;;;
;;;***********************************************************************


(defvar ex0 '(all x (-> (P x) (q x))))                  ;Not a theorem

(defvar ex0a '(-> (& (SOME X (P X)) (SOME X (Q X))) (SOME Y (& (P Y) (Q Y)))))
                                                        ;Not a theorem
(defvar ex0b '(-> (some x (P x)) (all x (P x))))        ;Not a theorem

(DEFVAR EX1 '(-> A A))
(SETQ EX1 '(-> A A))

(DEFVAR EX2 '(ALL A (-> (ALL X (P X)) (P A))))

(DEFVAR EX3  '(-> (& (P A) (ALL X (-> (P X) (Q X)))) (Q A)))
(SETQ EX3  '(-> (& (P A) (ALL X (-> (P X) (Q X)))) (Q A)))
(DEFVAR EX3< '(-> (& (ALL x (-> (P x) (< (f x) a))) (P c) (-> (p c) (<= a b)))
		  (< (f c) b)))

(defvar ex3* '(-> (-> TRUE C) C))
(defvar ex3** '(-> (-> a (or b c)) c)) ;not a theorem
(defvar ex3*** '(->  (&  (not a)  (not b)  (-> true (or a b c)) )   c) )

(DEFVAR EX4 '(-> (OR B A) (OR A B)))

(DEFVAR EX5 '(-> A (OR B C)))             ;not a theorem

(DEFVAR EX6 '(-> (& A (OR (NOT A) B)) B))     ;REDUCER needed

(DEFVAR EX7 '(-> (& (NOT A) B) (NOT A)))

(DEFVAR EX7* '(-> (& (-> B A) (-> C B) (-> (NOT A) C)) A))

(DEFVAR EX8 '(-> (& (= A B) (P A)) (P B)))

(DEFVAR EX9 '(-> (ALL X (P X)) (& (P A) (P B))))

(DEFVAR EX9* '(-> (OR (P A) (P B)) (SOME X (P X))))

(DEFVAR EX9** '(-> (& (Q A) (Q B)) (SOME X (& (-> (P X) (& (P A) (P B))) 
	    (Q X)))))

(DEFVAR EX9*** '(-> (ALL X (P X)) (& (P A) (P B) (P C))))

(DEFVAR EX10 '(-> (& A B (-> A (-> B C))) C))

(defvar ex10f '(-> (& (OR A B) (-> B A) (-> A B)) (& A B))) ;Full Set on 2 syms

(DEFVAR EX11 '(-> (& (P A) (P B) (Q B)) (SOME X (& (P X) (Q X)))))
 
(DEFVAR EX12 '(-> (& (P (A) (C)) (P (B) (D)) (P (A) (E)) (Q (F) (C)) (Q 
	    (A) (E))) (SOME X (SOME Y (& (P X Y) (Q X Y))))))

(defvar ex12 '(-> (& (P A C) (P B D) (P A E) (Q F C) (Q A E))
		  (SOME X (SOME Y (& (P X Y) (Q X Y))))))  ;24Aug94

(DEFVAR EX12* '(-> (& (P A) (P B) (Q C) (Q D) (R A E) (R B D)) (SOME X 
	     (SOME Y (& (-> E* (& (P X) (Q Y))) (R X Y))))))
 
(DEFVAR EX13 '(-> (& (P A) (P B) (P C) (R C) (R D) (R E) (Q F C) (Q B E)) 
	    (SOME X (SOME Y (& (P X) (R Y) (Q X Y))))))

(DEFVAR EX14 '(-> (& (P A) (P B) (P C) (R C) (R D) (R E) (Q F C) (Q B E)) 
	    (SOME X (SOME Y (& (Q X Y) (P X) (R Y))))))

(DEFVAR EX15 '(-> (& (P A) (P B) (P C) (R C) (R D) (R E) (Q F C) (Q B E)) 
	    (SOME X (SOME Y (& (P X) (Q X Y) (R Y))))))

(DEFVAR EX16 '(SOME X (-> (& (P X) (Q A) (Q B)) (& (P A) (P B) (Q X)))))

(defvar HWE16-clauses            ;CS385F Homework Problem E16 in clausal form
  '(((<= (+ (C) (- (F X)))) (<= (+ (D) (- (F X)))) (<= (+ (E) (- (F X)))))
    ((< (+ (F X) (- (C)))) (< (+ (F X) (- (D)))) (< (+ (F X) (- (E)))))
    ((<= (+ (D) (- (C))))) ((<= (+ (C) (- (D))))) ((<= (+ (E) (- (C)))))
    ((<= (+ (C) (- (E)))))))
  ;; Note that in this example a deduction of [] is not possible without
  ;;  retaining tautologies, unless we try GROUND-INEQUALITY-PROVER first,
  ;;  obtain equality units (c=d and c=e) and sub=.

(DEFVAR EX17 '(SOME X (-> (& (-> (& (Q (A)) (R (B))) (P X)) (-> (& (Q* 
	    (C)) (R* (D))) (P X)) (Q X) (R X) (Q* X) (R* X) (S (A)) 
	    (S (C)) (S (D))) (& (P X) (S X)))))

(defvar ex17 '(SOME X
		(-> (& (-> (& (Q A) (R B)) (P X)) (-> (& (Q* C) (R* D)) (P X))
			  (Q X) (R X) (Q* X) (R* X) (S A) (S C) (S D))
		       (& (P X) (S X)))))  ;24Aug94

(DEFVAR EX17* '(SOME X (-> (& (-> (& (Q (A)) (R (B))) (P X)) (-> (& (Q* 
	     (C)) (R* (D))) (P X)) (Q X) (R (E)) (Q* X) (R* X) (S (A)) 
	     (S (C)) (S (D))) (& (P X) (S X)))))

(defvar ex17* '(SOME X (-> (& (-> (& (Q A) (R B)) (P X)) 
			      (-> (& (Q* C) (R* D)) (P X))
			      (Q X) (R E) (Q* X) (R* X) (S A) (S C) (S D))
			   (& (P X) (S X)))))   ;24Aug94

(DEFVAR EX17** '(SOME X (-> (& (-> (& (Q (A)) (R (B))) (P X)) (-> (& (Q* 
	      (C)) (R* (D))) (P X)) (Q X) (R (E)) (Q* X) (R* (E)) (S 
	      (A)) (S (C)) (S (D))) (& (P X) (S X)))))  ;not a theorem

(defvar ex17** '(SOME X  (-> (& (-> (& (Q A) (R B)) (P X)) 
				(-> (& (Q* C) (R* D)) (P X))
				(Q X) (R B) (Q* X) (R* D) (S A) (S C) (S D))
			     (& (P X) (S X)))))         ;now it is a theorem

(DEFVAR EX18 '(SOME X (SOME X2 (SOME X3 (SOME X4 (SOME Y (-> (& (P A) 
	    (E A) (-> (E X) (OR (G X) (S X (F X)))) (-> (E X2) (OR 
	    (G X2) (C (F X2)))) (-> (S A Y) (P Y))) (OR (& (P X3) (G X3)) 
	    (& (P X4) (C X4))))))))));This is a theorem, 
                                  ; but can IMPLY prove it without human help?

(setq ex19- '(some x (& (-> (P x) (P a)) (-> (P x) (P b)))))

(DEFVAR EX19 '(-> (ALL Z (-> (Q Z) (P Z)))
		  (SOME X (& (-> (P X) (P A)) 
			     (-> (Q X) (P B)))))) 
   ;;EX19,19- are theorems, but IMPLY cannot prove them, without human help.

(DEFVAR EX19* '(-> (ALL Z (ALL X (& (-> (Q Z) (P Z)) (OR (P X) (Q X)) 
	     (-> (P A) (Q X)) (-> (P B) (P X))))) (& (P A) (P B))))



(DEFVAR EX20                   ;for checking DETAIL.  Not a Theorem.
#|     '(->
       (& (-> (& a b) c)
          (-> (& a1 a2) a)
          (-> (& a11 a12) a1)
          (-> true a11)
          (-> true a12)
          (-> true a2)
          (-> (& b1 b2) b)
          (-> true b1)
          (-> (& e f) c))
        c)
|#
       nil)
 
(DEFVAR EX20BC '(->            ;for testing BACK-CHAIN and PROVE-THE-PREMISE 
                 (& (-> h1 c1) (-> h2 c2) (-> h3 (& c1 c2 c3))
                    (-> h4 (or c4 c5 c6)) (-> h5 (-> h6 c7))
                    h1 h2 h3 h4 h5 h6 
                    (not c4) (not c5) (not c6) )
                 (& c1 c2 c3 c4 c5 c6 c7)))
 

(DEFVAR EX20* '(-> (& (-> (& A B) C) (-> TRUE A)) C))    ;not a theorem

(DEFVAR EX20** '(-> (& (S A) (S B) (R B C)
                       (ALL X (-> (S X) (P X)))
                       (ALL X (ALL Y (-> (R X Y) (Q X Y)))))
                    (SOME X (SOME Y (& (P X) (Q X Y))))))
(DEFVAR ex20*** '(-> (& (S A) (S B) (R B C) (ALL X (-> (S X) (P X)))
			(ALL X (ALL Y (-> (R X Y) (Q X Y)))))
		     (SOME X (SOME Y (& (P X) (Q X Y))))))

(DEFVAR EX20A '(->  (ALL Y (-> (-> (R B) (R Y)) (P (F Y) Y)))
                    (SOME X (SOME Y (& (P X Y) (-> (Q (F B) B) (Q X Y))))) ))
(DEFVAR EX20B '(->  (ALL Y (-> (-> (R B) (R Y)) (P (F Y) Y)))
                    (SOME X (SOME Y (& (P X Y) (-> (Q A B) (Q X Y))))) ))
                                              ;Not a theorem

(DEFVAR EX20C '(->  (ALL Y (-> (-> (R B) (R Y)) (OR (P (F Y) Y)
                                                     (& (P A) (NOT (P A))))))
                    (SOME X (SOME Y (& (P X Y) (-> (Q (F B) B) (Q X Y))))) ))

(defvar ex20c '(-> (ALL Y (-> (-> (R B) (R Y)) (OR (P (F Y) Y) ;24Aug94
						   (& (P A) (NOT (P A))))))
		   (SOME X (SOME Y2 (& (P X Y2) (-> (Q (F B) B) (Q X Y2)))))))

(DEFVAR EX20C* '(-> (& (R B) (Q (F B) B) (P B)
                       (ALL Y (-> (R Y) (OR (P (F Y) Y) (NOT (P Y))))))
                    (SOME X (SOME Y (& (P X Y) (Q X Y)))) ))

(defvar ex20c* '(-> (& (R B) (Q (F B) B) (P B)                  ;24Aug94
		       (ALL Y3 (-> (R Y3) (OR (P (F Y3) Y3) (NOT (P Y3))))))
		    (SOME X (SOME Y (& (P X Y) (Q X Y))))))
                                                      
(DEFVAR EX20D '(-> (& (Q A B) (R B) (ALL Y (-> (R Y) (P (f Y) Y))))
                     (SOME X (SOME Y (& (P X Y) (Q X Y)))) )) ;Not a theorem

(DEFVAR EX21 '(ALL A (ALL B (SUBSET A (UNION A B)))))         ;needs REDUCE

(DEFVAR EX22 '(ALL A (ALL B (SET-= (SUBSETS (INTERSECTION A B)) (INTERSECTION 
	    (SUBSETS A) (SUBSETS B))))))                      ;needs REDUCE

(DEFVAR EX23 '(-> (element A G) (SUBSET A (UNION-OF-SETS G)))) ;needs REDUCE

(DEFVAR EX24 '(-> 
     (& (ALL X (-> (FOOD X) (LIKES JOHN X))) 
        (FOOD APPLES) 
	(FOOD CHICKEN) 
        (ALL X (-> (SOME Y (& (EATS Y X) (NOT-KILLED-BY Y X) ))
		   (FOOD X))) 
        (EATS BILL PEANUTS) 
        (ALIVE BILL) 
        (ALL X (-> (EATS BILL X) (EATS SUE X))) 
        (ALL Y (-> (ALIVE Y) (ALL X (NOT-KILLED-BY Y X)))))
      (LIKES JOHN PEANUTS)))
  
(DEFVAR  EX24* '(->                    ;for checking out DETAIL
     (& 
        (all x (all y (-> (& (alive y) (eats y chicken)) (likes y x))))
        (ALL X (-> (FOOD X) (LIKES JOHN X))) 
        (FOOD APPLES) 
	(FOOD CHICKEN) 
        (ALL X (-> (SOME Y (& (EATS Y X) (NOT-KILLED-BY Y X) ))
		   (FOOD X))) 
        (EATS BILL PEANUTS) 
        (ALIVE BILL) 
        (ALL X (-> (EATS BILL X) (EATS SUE X))) 
        (ALL Y (-> (ALIVE Y) (ALL X (NOT-KILLED-BY Y X)))))
      (LIKES JOHN PEANUTS)))

(DEFVAR EX25 '(ALL X (SOME Y (& (-> (P Y X) (SOME W (P W Y))) (-> (& (P Z Y) 
	    (P Y Z)) (P Y X))))))

(DEFVAR EX26 '(-> (& (ALL X (-> (P X) (Q X))) (SOME Y (-> (Q Y) (R Y)))) 
	    (SOME Z (-> (P Z) (R Z)))))

(DEFVAR EX27 '(-> (ALL Y (-> (Q Y) (P Y))) (SOME X (& (-> (P X) (P A)) 
	    (-> (Q X) (P B))))))

(DEFVAR EX28 '(-> (& (ALL X (-> (P X) (Q X))) (R B)) (-> (ALL Y (-> (R Y) 
	    (P Y))) (Q B))))

(DEFVAR EX29 nil)

(DEFVAR EX30 '(ALL X (ALL T (-> (& (ELEMENT X (OMEGA)) (ELEMENT T X)) 
	    (ELEMENT T (OMEGA))))))       ;needs REDUCE.  Use induction

(DEFVAR EX30* '(ALL X (ALL T (-> H (-> (& (ELEMENT X (OMEGA)) (ELEMENT T X)) 
				       (ELEMENT T (OMEGA)))))))

(DEFVAR EX31 '(-> (& (ELEMENT (X) (OMEGA)) (ELEMENT (T) (X))) (ELEMENT 
	    (T) (OMEGA))))

(DEFVAR EX31* '(-> (& (ELEMENT (SCSR X) (OMEGA)) (ELEMENT (T) (SCSR X))) 
                   (ELEMENT (T) (OMEGA))))

(DEFVAR EX31** '(-> (& (ELEMENT (F X) (OMEGA)) (ELEMENT (T) (F X))) (ELEMENT 
	    (T) (OMEGA))))

(DEFVAR EX32 '(-> (& (ALL J (CLOSED (CLSR J))) 
                       (ALL K (-> (LF K) (LF (CLSR K)))) 
	    (ALL M (-> (COVER M) (COVER (CLSR M)))) (ALL P (ALL Q (ALL R 
	    (-> (& (REF P Q) (REF Q R)) (REF P R))))) (ALL U (ALL V 
	    (-> (REF U V) (REF (CLSR U) (CLSR V))))) (ALL F (-> (& 
	    (OPEN F) (COVER F)) (SOME G (& (OPEN G) (COVER G) (REF 
	    (CLSR G) F))))) (ALL F* (-> (& (OPEN F*) (COVER F*)) (SOME G* 
	    (& (OPEN G*) (COVER G*) (REF G* F*) (LF G*)))))) (ALL FF 
	    (-> (& (OPEN FF) (COVER FF)) (SOME H (& (CLOSED H) (COVER H) 
	    (REF H FF) (LF H)))))))  ;needs REDUCE, PUT, reorder, induction

(DEFVAR EX33 '(-> (ALL T (ALL X (-> (& (ELEMENT X (OMEGA)) (< T X)) 
				    (< T (SCSR X)))))
		  (ALL Y (-> (ELEMENT Y (OMEGA)) 
			     (< -1 Y))))) ;needs REDUCE.  Use induction
  
(DEFVAR EX33* '(-> (ALL T (ALL X (-> (& (ELEMENT X (OMEGA)) (<= T X)) 
				    (< T (SCSR X)))))
		  (ALL Y (-> (ELEMENT Y (OMEGA)) 
			     (<= 0 Y)))))

(DEFVAR EX34 NIL)

(DEFVAR EX35 '(-> (& (PARENT M V) (PARENT V P) (PARENT P H) (ALL X (ALL Y 
	    (-> (PARENT X Y) (ANCESTER X Y)))) (ALL X (ALL Y (ALL Z 
	    (-> (& (ANCESTER X Y) (ANCESTER Y Z)) (ANCESTER X Z)))))) 
	    (ANCESTER M H)))

(DEFVAR EX35* '(-> (& (PARENT M V) (PARENT V P) (PARENT P H) (ALL X (ALL Y 
	     (-> (PARENT X Y) (ANCESTER X Y)))) (ALL X (ALL Y (ALL Z 
	     (-> (& (ANCESTER X Y) (PARENT Y Z)) (ANCESTER X Z)))))) 
	     (ANCESTER M H)))

(DEFVAR EX36 '(-> (ELEMENT N OMEGA) (= (* 2 (SUM I 1 N I)) (* N (+ N 1)))))
                                                ;needs REDUCE.  Use induction
(defvar ex36* '(-> (ELEMENT N OMEGA) (= (+ (+ (* N N) N) (* 2 N) 2) 
					(+ (* N N) N N N 1 1))))

(DEFVAR EX37 '(-> (ELEMENT N OMEGA) (= (* 6 (SUM I A N (* I I))) (* N 
	    (+ N 1) (+ (* 2 N) 1)))))

(defvar ex37* 
   '(= (+ (* (N) (N) (* 2 (N))) (* (N) (N)) (* (N) (* 2 (N))) (N)
	  (* 6 (* (N) (N))) (* 6 (N)) (* 6 (N)) 6)
       (+ (* (N) (N) (* 2 (N))) (* (N) (N) 2) (* (N) (N)) (* (N) (* 2 (N)))
	  (* (N) 2) (N) (* (N) (* 2 (N))) (* (N) 2) (N) (* (N) (* 2 (N)))
	  (* (N) 2) (N) (* 2 (N)) 2 1 (* 2 (N)) 2 1)))

(DEFVAR EX38 '(-> (ALL Z (Q (F Z))) (SOME X (SOME Y (& (-> (P (F Y)) (P X)) 
	    (-> (R Y) (& (R B) (R C))) (Q X))))))

(DEFVAR EX38* '(-> (ALL Z (Q (F Z))) (SOME X (SOME Y (& (-> (P (F Y)) 
	     (& (P X) (-> (R Y) (& (R B) (R C))))) (Q X))))))

(DEFVAR EX38** '(-> (Q (F B)) (SOME X (SOME Y (& (-> (P (F Y)) (& (P X) 
	      (-> (R Y) (& (R B) (R C))))) (Q X))))))

(DEFVAR EX39 NIL)

(DEFVAR EX40 nil)

(DEFVAR EX41 '(SET-= (INTERSECTION (SUBSETS A) (SUBSETS B)) 
                    (SUBSETS (INTERSECTION A B))))

(defvar ex42 '(-> (ALL X42 (-> (ELEMENT X42 (OMEGA)) 
			       (ELEMENT (SCSR X42) (OMEGA))))
		  (SET-= (UNION-OF (OMEGA)) (OMEGA)))) ;needs REDUCE, induction

(DEFVAR EX42L '(& (ELEMENT 0 1) (ELEMENT 1 (OMEGA))))
(DEFVAR EX42-Lemma1 '(ALL X (-> (ELEMENT X (OMEGA))(ELEMENT (SCSR X)(OMEGA)))))
(DEFVAR EX42-Lemma2 '(ALL X (-> (ELEMENT X (OMEGA))(ELEMENT X (SCSR X)))))

  
(DEFVAR EX43 '(-> (ALL E                         ;Trivial
		       (SOME D
			     (ALL X
				  (-> (< (|| (+ X (- A))) D)
				      (< (|| (+ (- (L)) (F X))) E)))))
		  (ALL E
		       (SOME D
			     (ALL X
				  (-> (< (|| (+ X (- A))) D)
				      (< (|| (+ (F X) (- (L)))) E)))))))

(DEFVAR EX44 '(-> (& (R (A)) (NOT (P (A))) (Q (B)))
                  (SOME X (& (-> (P X) (Q X)) (R X)))))

(DEFVAR EX45 '(-> (& (R (A)) (NOT (Q (B))))            ;Not a theorem
                  (SOME X (& (-> (P X) (Q X)) (R X)))))

(DEFVAR EX46 '(-> (& (some x (A x)) (some x (B x))     ;Not a theorem
                     (-> R (some x (& (A x) (B x))))
                     (-> (& P Q) R) )
                  (some x (& (-> P (A x)) (-> Q (B x))))))
(DEFVAR EX46* '(SOME X (& (-> (<= A C) (<= A X)) (-> (<= C B) (<= X B)))))

(DEFVAR EX47 '(-> (< a b) (some x (& (< a x) (< x b)))))

(DEFVAR EX47P '(-> (& (P a) (< a b)) (some x (& (< a x) (P a) (< x b)))))

(DEFVAR EX47<= '(-> (<= a b) (some x (& (<= a x) (<= x b)))))

(DEFVAR EX48 '(-> (& (< c b) (< a c)) (some x (& (< a x) (< x b)))))

(DEFVAR EX48G '(-> (& (< a c) (< c b)) (< a b)))

(DEFVAR EX49 '(SOME X (& (-> (& (< A B) (< A D)) (& (< A X) (< X B)))
			 (-> (& (< C B) (< C D)) (& (< C X) (< X D))) )))

(DEFVAR EX49* '(-> (& (< A B) (< A D) (< C B) (< C D))
                  (SOME X (& (< A X) (< X B) (< C X) (< X D))) ))

(DEFVAR EX50 NIL)

(defvar ex51 '(-> (cont-de f a) (cont-N f a)))

(defvar ex51L1 '(all x (all y (all d  (-> (& (< y (+ x d)) (< x (+ y d)))
					  (< (|| (+ x (-y))) d))))))
(defvar ex51L2 '(all x (all y (all d  (-> (< (|| (+ x (-y))) d)
					  (& (< y (+ x d)) (< x (+ y d))))))))

(defvar ex52 '(-> (diff-de f a) (cont-de f a)))

(defvar ex53 '(<-> (diff-L f a) (diff-de f a)))

(defvar ex54 '(-> (diff-L f a) (cont-de f a)))

(defvar ex55 '(-> (diff-L f a) (cont-N f a)))

(defvar ex56 '(some x (& (< a x) (< x b))))    ;not a theorem

(defvar ex56* '(-> (< a b) (some x (& (< a x) (< x b)))))

(defvar ex57 '(-> (& (all y (< (f y) y)) (< a b))
                  (some x (& (< a x) (< (f x) b))) ))

(defvar ex58 '(-> (& (lim f a l) (lim g a k)) (lim (+ f g) a (+ l k)))) ;Lim+
(defvar Lim+ ex58)
(defvar Lim+                                   ;2April90  for STR+VE
'(ALL A
      (-> (& (ALL E
		  (-> (< 0 E)
		      (SOME D
			    (& (< 0 D)
			       (ALL X
				    (-> (< (|| (+ X (- A))) D)
					(< (|| (+ (F X) (- (F A)))) E)))))))
	     (ALL E
		  (-> (< 0 E)
		      (SOME D
			    (& (< 0 D)
			       (ALL X
				    (-> (< (|| (+ X (- A))) D)
					(< (|| (+ (G X) (- (G A)))) E))))))))
	  (ALL EE
	       (-> (< 0 EE)
		   (SOME D
			 (& (< 0 D)
			    (ALL X
				 (-> (< (|| (+ X (- A))) D)
				     (<
				      (||
				       (+ (F X) (G X) (- (F A))
					  (- (G A))))
				      EE))))))))))
(defvar lim+-clauses 
'(((<= E1) (< (- (D1S E1))))
 ((<= E2) (<= (+ (- (A)) X2 (D1S E2))) (<= (+ (- X2) (D1S E2) (A)))
  (< (+ (- E2) (- (F X2)) (F (A)))))
 ((<= E3) (<= (+ (- (A)) X3 (D1S E3))) (<= (+ (- X3) (D1S E3) (A)))
  (< (+ (- E3) (- (F (A))) (F X3))))

 ((<= E4) (< (- (D2S E4))))
 ((<= E5) (<= (+ (- (A)) X5 (D2S E5))) (<= (+ (- X5) (D2S E5) (A)))
  (< (+ (- E5) (- (G X5)) (G (A)))))
 ((<= E6) (<= (+ (- (A)) X6 (D2S E6))) (<= (+ (- X6) (D2S E6) (A)))
  (< (+ (- E6) (- (G (A))) (G X6))))

 ((< (- (EE))))
 ((<= D7) (< (+ (- D7) (- (XS D7)) (A))))
 ((<= D8) (< (+ (- D8) (- (A)) (XS D8))))
 ((<= D9) (<= (+ (- (F (A))) (- (G (A))) (F (XS D9)) (G (XS D9)) (EE)))
  (<= (+ (- (F (XS D9))) (- (G (XS D9))) (EE) (F (A)) (G (A))))))
)

(defvar LIM+                            ;from Larry Hines
  '(((<= E1 0) (< 0 (D1 E1)))
    ((<= E1 0) (< (+ (D1 E1) Y) (X0)) (< (+ (D1 E1) (X0)) Y)
     (<= (L) (+ (F Y) E1)))
    ((<= E1 0) (< (+ (D1 E1) Y) (X0)) (< (+ (D1 E1) (X0)) Y)
     (<= (F Y) (+ (L) E1)))
    ((<= E2 0) (< 0 (D2 E2)))
    ((<= E2 0) (< (+ (D2 E2) Z) (X0)) (< (+ (D2 E2) (X0)) Z)
     (<= (K) (+ (G Z) E2)))
    ((<= E2 0) (< (+ (D2 E2) Z) (X0)) (< (+ (D2 E2) (X0)) Z)
     (<= (G Z) (+ (K) E2)))
    ((< 0 (E0)))
    ((<= D 0)  (<= (X0) (+ (X D) D)))
    ((<= D 0)  (<= (X D) (+ (X0) D)))
    ((<= D 0)  (< (+ (L) (+ (K) (E0))) (+ (F (X D)) (G (X D)))) 
     (< (+ (F (X D)) (+ (G (X D)) (E0))) (+ (L) (K))))))

(defvar LIM+THM                         ;from Larry Hines
  '(-> (& (ALL E1 (-> (< 0 E1) 
		      (SOME D1 (& (< 0 D1) 
				  (ALL X1 (-> (and (< (- X1 A) D1) 
						   (< (- A X1) D1))
					      (and (< (- (F X1) L) E1)
						   (< (- L (F X1)) E1))))))))
	  (ALL E2 (-> (< 0 E2) 
		      (SOME D2 (& (< 0 D2) 
				  (ALL X2 (-> (and (< (- X2 A) D2)
						   (< (- A X2) D2))
					      (and (< (- (G X2) K) E2)
						   (< (- K (G X2)) E2)))))))))
       (ALL E (-> (< 0 E) 
		  (SOME D 
			(& (< 0 D) 
			   (ALL X 
				(-> (and (< (- X A) D) (< (- A X) D))
				    (and (< (- (+ (F X) (G X)) (+ L K)) E)
					 (< (- (+ L K) (+ (F X) (G X))) E))))))
		  ))))


(defvar ex58* '(-> (& (ALL E                                        ;Lim++
             (ALL X
                   (-> (< 0 E)
                       (& (< 0 (DS E))
                          (-> (& (< (|| X) (/ (DS E) 2))
                                 (< (|| (- (A))) (/ (DS E) 2)))
                              (< (|| (+ (F X) (- (L)))) E))))))
       (ALL E1
             (ALL X1
                   (-> (< 0 E1)
                       (& (< 0 (DS1 E1))
                          (-> (& (< (|| X1) (/ (DS1 E1) 2))
                                 (< (|| (- (A))) (/ (DS1 E1) 2)))
                              (< (|| (+ (G X1) (- (K)))) E1)))))))
    (SOME D
          (-> (< 0 (E))
              (& (< 0 D)
                 (-> (< (|| (+ (XS D) (- (A)))) D)
                     (& (< (|| (+ (F (XS (K))) (- (L)))) (/ (E) 2))
                        (< (|| (+ (G (XS (K))) (- (K)))) (/ (E) 2)))))))))

(defvar ex58L1 '(=--> ((+ f g) x)  (+ (f x) (g x)) ))         ;rewrite rule
(defvar ex58L2 '(=--> (+ (+ a b) (- (+ c d)))                 ;rewrite rule
                      (+ (+ a (- c)) (+ b (- d))) )) 
                      
(defvar ex58L3 '(-->  (< (+ (|| a) (|| b)) E)  (< (|| (+ a b)) E) )) 
                                                         ;forward Lemma
(defvar ex58L4 '(-->  (& (< a (/ E 2)) (< b (/ E 2)))  (< (+ a b) E) ))
                                                         ;forward Lemma
(defvar ex58L5 '(<= (||(+ A B)) (+ (|| A) (|| B))))
(defvar ex58L6 '(-->  (< 0 x) (< 0 (/ x 2))))            ;forward Lemma
(defvar L1+ ex58L1) (defvar L2+ ex58L2) (defvar L3 ex58L3)
(defvar L4  ex58L4) (defvar L5  ex58L5) (defvar L6 ex58L6)
(defvar ex59 '(-> (& (lim f a l) (lim g a k)) (lim (* f g) a (* l k)))) ;Lim*
(defvar Lim* ex59)
(defvar ex59* 
 '(-> (SOME E1
          (SOME E2
                (SOME X
                      (SOME X1
                            (& (-> (< 0 E1)
                                   (& (< 0 (D1S E1))
                                    (-> (< (|| (+ X (- (A)))) (D1S E1))
                                     (< (|| (+ (F X) (- (L)))) E1))))
                               (-> (< 0 E2)
                                   (& (< 0 (D1S1 E2))
                                    (->
                                     (< (|| (+ X1 (- (A)))) (D1S1 E2))
                                     (< (|| (+ (G X1) (- (K)))) E2)))))))))
    (SOME D
          (-> (< 0 (E))
              (& (< 0 D)
                 (-> (< (|| (+ (XS D) (- (A)))) D)
                     (& (< (|| (* (G (XS D)) (+ (F (XS D)) (- (L)))))
                           (/ (E) 2))
                        (< (|| (* (L) (+ (G (XS D)) (- (K)))))
                           (/ (E) 2)))))))))

(defvar ex59L1 '(=--> ((* f g) x)  (* (f x) (g x)) ))         ;rewrite rule
(defvar ex59L2 '(=--> (+ (* a b) (- (* c d)))                 ;rewrite rule
                      (+ (* b (+ a (- c))) (* c (+ b (- d))) ) ))
(defvar L1* ex59L1) (defvar L2* ex59L2)
(defvar ex59L3 '(-->  (< (+ (|| a) (|| b)) E)  (< (|| (+ a b)) E) )) 
                                                         ;forward Lemma
(defvar ex59L4 '(-->  (& (< a (/ E 2)) (< b (/ E 2)))  (< (+ a b) E) ))
                                                         ;forward Lemma
(defvar ex59L7 '(all z (all E (all E2 (all t 
                 (-> (& (<= (* (|| z) E) E2) (not (= z 0)) (< (|| t) E))
		     (< (|| (* z t)) E2)) )))) )
               ; |Z|.E \< E'  &  (Z' /= 0)  &  |t| < E  -->  |Z.t| < E'
(defvar ex59L71 '(= (|| (* x y)) (* (|| x) (|| y))))  ;|x.y| = |x|.|y|
(defvar ex59L72 '(all z (all a (all b (-> (& (not (= z 0)) (< a b)) 
					  (< (* z a) (* z b)))))))
                      ;z/=0 & a<b --> z.a<z.b
(defvar ex59L73 '(all z (-> (not (= z 0)) (not (= (|| z) 0)))))
    ;;z/=0 -> |z| /= 0
(defvar ex59L8 '(all a (all m (all e (all e4 
   (-> (& (<= a m) (<= (* m e) e4)) (<= (* a e) e4)))))))
(defvar ex59L9 '(all a (all b (<= (|| a) (+ (|| (+ a (- b))) (|| b))))))
(defvar ex59L10 '(all x (-> (< 0 (|| x)) (not (= x 0)))))
(defvar ex59L11 '(=--> (|| (+ x (- y))) (|| (+ y (- x)))))

(defvar ex60 '(all y (-> (element y (omega))            ;Matt Kaufmann's
                         (some x (& (is-int-sqrt x y) (element x (omega)))))))
                                                     
(defvar ex60A '(some x (& (NOT (< 0 (* X X))) (< 0 (* (+ X 1) (+ X 1))))))

(defvar ex60B '
   (-> (& (<= (+ (- (Y)) (* (X2) (X2))))
	  (< (+ (Y) (- (* (X2) (X2))) (- (X2)) (- (X2)) -1)))
       
       (SOME X (& (<= (+ (- (Y)) -1 (* X X)))
		   (< (+ (Y) 1 (- (* X X)) (- X) (- X) -1))))))
(defvar ex61 '(all x (some y (& (< x y) (prime y)))))   ;Matt Kaufmann's

(defvar ex62 '(-> (& (< c d) (<= (+ (f a) (- c))));for use with rep, e = (f x)
                  (some x (<  (+ (f  x ) (- d))))))

(defvar ex63 nil)
(defvar ex64 nil)
(defvar ex65 nil)
(defvar ex66 nil)
(defvar ex67 nil)

(defvar ex68 '(-> (& (-> (& (not A) B) C) B (-> A C)) C)) ;ex for CASES, (A)

(defvar ex69 '(or (null L) (= L (cons (car L) (cdr L))))) ;An ex for Complete 
                                                          ; induction
(defvar ex70 'Completeness-of-Ground-Resolution)
(defvar Completeness-of-Ground-Resolution
             '(all S (-> (& (Clauses S) (ground S) (Unsatisfiable S))
			  (some n (& (element [] (res S n)) (p-integer n))))))
(defvar ex70A '(all S (-> (& (Clauses S) (ground S) (Unsatisfiable S))
			  (some n (& (element [] (res S n)) (p-integer n))))))
(defvar ex70L1
  '(-> (& (Clauses S) (ground S) (element C S) (= C  (union C1 (sng L)))
	  (= S1 (union (set-diff S (sng C)) (sng C1))) 
	  (element [] (res S1 n)))
       (& (integer n)
	  (or (element [] (res S n)) (element (sng L) (res S n))))))

(defvar ex70L2 '(-> (& (clauses S1) (clauses S2) (subset S1 S2)(integer n))
                    (subset (res S1 n) (res S2 n))))

(defvar ex70L3 '(-> (& (clauses S) (integer n) (integer m))
                    (= (res (res S n) m) (res S (+ n m)))))

(defvar ex70L4 '(-> (& (clauses S) (ground S) (not (element [] S)) 
                       (= (excess-l S) 0))
                    (all C (-> (element C S) (unit-clause C)))))

(defvar ex70L41 '(-> (& (clauses S) (unsatisfiable S) 
                       (all C (-> (element C S) (unit-clause C))))
                    (element [] (res S 1))))

(defvar ex70L5 '(-> (& (Clauses S) (ground S) (Unsatisfiable S)
                       (subset C1 C) (element C S)
                       (= S1 (union (set-diff S (sng C)) (sng C1))))
		    (& (Clauses S1)(ground S1) (Unsatisfiable S1))))

(defvar ex70L51 '(-> (element L C) (subset (sng L) C)))                   

(defvar ex70L6 '(-> (clauses S) (subset S (res S 1))))

(defvar ex70L7 '(all A (all B (all x 
   (-> (& (subset A B) (element x A)) (element x B))))))

(defvar ex70L8 '(-> (& (clauses S) (element C S) (subset C1 C) (not (= C1 C))
		       (= S1 (union (set-diff S (sng C)) (sng C1))))
		    (< (excess-literal S1) (excess-literal S))))

(defvar ex70L9 '(-> (clauses S) (element (excess-literal S) (omega))))

(defvar ex70L10 '(-> (not (element [] S)) (<= (- (excess-literal S)))))

(defvar ex70L11 '(-> (& (clauses S) (= (excess-literal S) 0))
		     (all C (-> (element C S) (unit-clause C)))))

(defvar ex70L12 '(-> (& (clauses S) (not (element [] S)) 

			(< (- (excess-literal S))))
		     (some C (& (element C S) (non-unit C))) ))

(defvar ex70L13 '(-> (& (clauses S) (element C S) (non-unit C) (element L C)
			(= C1  (set-diff C (sng L)))
			(= S1 (union (set-diff S (sng C)) (sng C1))) 
			(= S2 (union (set-diff S (sng C)) (sng (sng L)))) )
		     (& (< (+ (excess-literal S1) (- (excess-literal S))))
			(< (+ (excess-literal S2) (- (excess-literal S))))
			(-> (unsatisfiable S) (& (unsatisfiable S1) 
						 (unsatisfiable S2) ))) ))

(defvar ex70L14 '(-> (& (clause C) (non-unit C)) (some L (element L C))))

(defvar ex70L19 '(-> (element C S) (element C (res S n))))

(defvar ex71 '(-> (all E (-> (< 0 E) (<= a (+ b E)))) (<= a b)))  ;ex9,CADE 80

(defvar ex72 '(-> (all E (& (-> (< 0 E) (<= (f L) (+ (f (z E)) E))) 
			    (<= (f (z E)) (f t))))                ;ex12,CADE 80
		  (<= (f L) (f t))))

(defvar ex73 '(-> (& (<= a L) (<= L b) (<= a t0) (< t0 L)         ;ex13,CADE 80
		     (all E (all s (all y (all t
                            (& (-> (< 0 E) (< (r E) L))
			       (-> (& (< 0 E) (<= (r E) s) (<= s L))
				   (<= (f L) (+ (f s) E)))
			       (-> (& (<= a y) (< y L)) 
				   (& (< y (z y)) (<= (z y) L)))
			       (-> (& (<= a y) (< y L) (<= a t) (< t (z y)))
				   (<= (f (z y)) (f t)))))))))
		  (<= (f L) (f t0))))
		     
(defvar ex74 '(-> (all x (-> (< x a) (& (<= x b) (<= x c))))
		  (& (<= a b) (<= a c))))
(defvar ex74p '(-> (or (< b a) (< c a))
		   (some x (& (< x a) (or (< b x) (< c x))))))
(defvar ex74pp '(-> (or (< b a) (< c a))
		    (some x (& (< x a) (-> (<= x b) (< c x))))))

(defvar IMV1-THM              ;from Larry Hines April 1990
  '(-> (& (ALL X1 (-> (& (<= (A) X1) (<= X1 (B)) (< 0 (F X1)))
			(SOME T1 (& (< T1 X1)
				      (ALL S1 (-> (& (< T1 S1) (<= S1 X1))
						  (< 0 (F S1))))))))
	    (ALL X2 (-> (& (<= (A) X2) (<= X2 (B)) (< (F X2) 0))
			(SOME T2 (& (< X2 T2)
				      (ALL S2 (-> (& (< S2 T2) (<= X2 S2))
						  (< (F S2) 0)))))))
	    (ALL Y (-> (< Y (L)) 
		       (SOME Z (& (< Y Z) (<= Z (L))
				    (<= (F Z) 0)))))
	    (ALL XL (-> (& (< (L) XL)	;derived l.u.b. axiom
			     (<= XL (B)))
			(< 0 (F XL))))
	    (< (A) (B))
	    (< (L) (B))
	    (< (A) (L))
	    (< (F (A)) 0)
	    (< 0 (F (B))))
       (SOME X (& (<= (F X) 0) (<= 0 (F X))))))

(defvar imv-clauses
  '(((< (+ (- (A)) X11)) (< (+ (- X11) (B))) (<= (F X11))         ;continuity 1
   (< (+ (T11S X11) (- X11))))
  ((< (+ (- (A)) X11)) (< (+ (- X11) (B))) (<= (F X11))         ;continuity 1
   (<= (+ (- (T11S X11)) S11)) (< (+ (- S11) X11)) (< (- (F S11)))) 
  ((< (+ (- (A)) X21)) (< (+ (- X21) (B))) (<= (- (F X21)))     ;continuity 2
   (< (+ X21 (- (T21S X21)))))
  ((< (+ (- (A)) X21)) (< (+ (- X21) (B))) (<= (- (F X21)))     ;continuity 2
   (<= (+ (- S21) (T21S X21))) (< (+ (- X21) S21)) (< (F S21)))
  ((<= (+ (- (L)) XL1)) (< (+ (- XL1) (B))) (< (- (F XL1))))    ;LUB1
  ((<= (+ (- Y1) (L))) (< (+ Y1 (- (Z1S Y1)))))                 ;LUB2
  ((<= (+ (- Y1) (L))) (<= (+ (Z1S Y1) (- (L)))))               ;LUB2
  ((<= (+ (- Y1) (L))) (<= (F (Z1S Y1))))                       ;LUB2
  ((< (+ (A) (- (B)))))
  ((< (+ (L) (- (B)))))                                      ;a < L < b
  ((< (+ (A) (- (L)))))
  ((< (F (A))))                                              ;f(a) < 0
  ((< (- (F (B)))))                                          ;f(b) > 0
  ((< (- (F X3))) (< (F X3)))                                ;f(x)=0 for some x
;;((< (- (F (L)))) (< (F (L)))) 
;;Replace X by (L) in Clause 14 for IMV-L-clauses
;;Omit the second literal of Clause 14, and omit Clauses 3,4 for IMV-L1
))

(defvar imv-clauses-A
'(((<= (+ (- (T1S X1)) S1)) (< (+ (- S1) X1)) (< (- (F S1))) (<= (F X1)))
  ((< (+ (T1S X1) (- X1))) (<= (F X1)))                         ;continuity 1

  ((<= (+ (- S2) (T2S X2))) (< (+ (- X2) S2)) (< (F S2)) (<= (- (F X2))))
  ((< (+ X2 (- (T2S X2)))) (<= (- (F X2))))                     ;continuity 2

  ((not (subset A (set-of z% (<= (+ z% (- u)))))) (not (element r A))
   (not (element x3 A)) (<= (+ x3 (L A))))                      ;LUB1

  ((not (subset A (set-of z% (<= (+ z% (- u)))))) (not (element r A))
   (element (ZS A y) A)            (<= (+ (L A) (- y))))         ;LUB2-1
  ((not (subset A (set-of z% (<= (+ z% (- u)))))) (not (element r A))
   (< (+ y (- (ZS A y))))   (<= (+ (L A) (- y))))                ;LUB2-2

  ((< (+ (A) (- (B)))))                                         ;a <= b
  ((< (F (A))))                                                 ;f(a) < 0
  ((< (- (F (B)))))                                             ;f(b) > 0
  ((< (- (F X3))) (< (F X3)) (< (+ x (- (A)))) (< (+ (B) (- x))))
                                                        ;f(x)=0 for some x
))

(defvar IMV1                  ;from Larry Hines April 1990
  '(((< X2 (a)) (< (b) X2) (<= 0 (f X2)) (< X2 (t1 X2)))
    ((< X2 (a)) (< (b) X2) (<= 0 (f X2)) (< S2 X2) (<= (t1 X2) S2)
     (< (f S2) 0))
    ;;one continuity condition missing?
    ((< (b) XL) (< 0 (f XL)) (<= XL (L)))
    ((<= (L) y) (<= (z y) (L)))		;derived l.u.b. axiom
    ((<= (L) y) (<= (f (z y)) 0))
    ((<= (L) y) (< y (z y)))
    ((<= (a) (b)))
    ((<= (L) (b)))
    ((<= (a) (L)))
    ((<= (f (a)) 0)) 
    ((<= 0 (f (b))))
    ((< 0 (f X)) (< (f X) 0))))

(defvar AM5                     ;from Larry Hines April 1990
  '(((<= (A) (B)))
    ((< (R X E) X)		(<= E 0) (< X (A)) (< (B) X))
    ((<= S (R X E))		(<= E 0) (< X (A)) (< (B) X) (< X S)
     (<= (F X) (+ (F S) E)))
    ((< X1 (R1 X1 E1))		(<= E1 0) (< X1 (A)) (< (B) X1))
    ((<= (R1 X1 E1) S1)		(<= E1 0) (< X1 (A)) (< (B) X1) (< S1 X1)
     (<= (F X1) (+ (F S1) E1)))
    ((<= (A) (T X2))		(<= X2 (L)) (< X2 (A)) (< (B) X2))
    ((<= (T X2) X2)		(<= X2 (L)) (< X2 (A)) (< (B) X2))
    ((< (F (T X2)) (F X2))	(<= X2 (L)) (< X2 (A)) (< (B) X2))
    ((<= (A) (Z Y))		(<= (L) Y))
    ((<= (Z Y) (B))		(<= (L) Y))
    ((<= (Z Y) (L))		(<= (L) Y))
    ((< T (A))			(<= (L) Y) (< (Z Y) T) (<= (F (Z Y)) (F T)))
    ((< Y (Z Y))		(<= (L) Y))
    ((<= (A) (Z1 Y1))		(<= Y1 (G W)) (< W (A)) (< (B) W))
    ((<= (Z1 Y1) (B))		(<= Y1 (G W)) (< W (A)) (< (B) W))
    ((<= (F (Z1 Y1)) (F W))	(<= Y1 (G W)) (< W (A)) (< (B) W))
    ((<= (G W) (Z1 Y1))		(<= Y1 (G W)) (< W (A)) (< (B) W))
    ((< (Z1 Y1) Y1)		(<= Y1 (G W)) (< W (A)) (< (B) W))
    ((< (F W) (F X3))		(<= (G W) X3) (< W (A)) (< (B) W)
     (< X3 (A))			(< (B) X3))
    ((<= (A) (T1 U))		(< U (A)) (< (B) U)) 
    ((<= (T1 U) (B))		(< U (A)) (< (B) U))
    ((< (F (T1 U)) (F U))	(< U (A)) (< (B) U))))

(defvar AM5-THM                  ;from Larry Hines April 1990
  '(-> (& (<= (A) (B))
	    (SOME L (& (ALL X1 (-> (& (<= (A) X1) (<= X1 (B))
					  (ALL T1 (-> (& (<= (A) T1)
							   (<= T1 X1))
						      (<= (F X1) (F T1)))))
				     (<= X1 L)))
			 (ALL Y1
			      (-> (ALL Z1
				       (-> (& (<= (A) Z1) (<= Z1 (B))
						(ALL T2 (-> (& (<= (A) T2)
								 (<= T2 Z1))
							    (<= (F Z1)
								(F T2)))))
					   (<= Z1 Y1)))
				  (<= L Y1)))))
	    (ALL W (-> (& (<= (A) W) (<= W (B)))
		       (SOME G (& (ALL X2 (-> (& (<= (A) X2) (<= X2 (B))
						     (<= (F X2) (F W)))
						(<= G X2)))
				    (ALL Y2 (-> (ALL Z2 (-> (& (<= (A) Z2)
								 (<= Z2 (B))
								 (<= (F Z2) 
								     (F W)))
							    (<= Z2 Y2)))
						(<= Y2 G)))))))
	    (ALL C1 (-> (& (<= (A) C1) (<= C1 (B)))
			(ALL E1 (-> (< 0 E1)
				    (SOME R1 (& (< C1 R1)
						  (ALL S1 (-> (& (< S1 R1)
								   (<= C1 S1))
							      (<= (F C1)
								  (+ (F S1) E1)
								  )))))))))
	    (ALL C2 (-> (& (<= (A) C2) (<= C2 (B)))
			(ALL E2 (-> (< 0 E2)
				    (SOME R2 (& (< R2 C2)
						  (ALL S2 (-> (& (< R2 S2)
								   (<= S2 C2))
							      (<= (F C2)
								  (+ (F S2) E2)
								  ))))))))))
       (SOME U (& (<= (A) U) (<= U (B))
		    (ALL T (-> (& (<= (A) T) (<= T (B))) 
			       (<= (F U) (F T))))))))

(defvar AM8                      ;from Larry Hines April 1990
  '(((<= (A) (B)))
    ((<= (A) (L))) 
    ((<= (L) (B)))
    ((< w (A)) (< (B) w) (<= (A) (G w)))
    ((< w (A)) (< (B) w) (<= (G w) (B)))
    ((<= (F (L)) (F t2)) (<= (L) t2) (< t2 (A)))
    ((<= (F (G w)) (F w)) (< (G w) (A)) (< (B) (G w)) (< w (A)) (< (B) w))
    ((<= (A) (T x2)) (<= x2 (L)) (< x2 (A)) (< (B) x2))
    ((<= (T x2) x2) (<= x2 (L)) (< x2 (A)) (< (B) x2))
    ((< (F (T x2)) (F x2)) (<= x2 (L)) (< x2 (A)) (< (B) x2))
    ((< (F w) (F x3)) (<= (G w) x3) (< w (A)) (< (B) w) (< x3 (A)) (< (B) x3))
    ((< U (A)) (< (B) U) (<= (A) (T1 U)))
    ((< U (A)) (< (B) U) (<= (T1 U) (B)))
    ((< U (A)) (< (B) U) (< (F (T1 U)) (F U)))))

(defvar AM8-THM                   ;from Larry Hines April 1990
  '(-> (& (SOME L (& (<= (A) L) (<= L (B))
			 (ALL X1 (-> (& (<= (A) X1) (<= X1 (B))
					  (ALL T1 (-> (& (<= (A) T1) 
							   (<= T1 X1))
						      (<= (F X1) (F T1)))))
				     (<= X1 L)))
			 (ALL T2 (-> (& (<= (A) T2) (<= T2 L))
				     (<= (F L) (F T2))))))
	    (ALL W (-> (& (<= (A) W) (<= W (B)))
		       (SOME G (& (<= (A) G) (<= G (B))
				    (ALL X2 (-> (& (<= (A) X2) (<= X2 (B))
						     (<= (F X2) (F W)))
						(<= G X2)))
				    (-> (& (<= (A) G) (<= G (B)))
					(<= (F G) (F W))))))))
       (SOME U (& (<= (A) U) (<= U (B))
		    (ALL T (-> (& (<= (A) T) (<= T (B)))
			       (<= (F U) (F T))))))))

(defvar AM8-PRIME             ;from Larry Hines April 1990
  '(((<= (F (L)) (F T2))    (<= (L) T2))
    ((<= (F (G W)) (F W)))
    ((<= (T1 X) X)          (<= X (L)))
    ((< (F (T1 X1)) (F X1)) (<= X1 (L)))
    ((< (F W) (F X2))       (<= (G W) X2))
    ((< (F (T U)) (F U)))))

(defvar AM8P-THM              ;from Larry Hines April 1990
  '(-> (& (SOME L (& (ALL X1 (-> (ALL T1 (-> (<= T1 X1)
						 (<= (F X1) (F T1))))
				     (<= X1 L)))
			 (ALL T2 (-> (<= T2 L) (<= (F L) (F T2))))))
	    (ALL W (SOME G (& (ALL X2 (-> (<= (F X2) (F W)) (<= G X2)))
				(<= (F G) (F W))))))
       (SOME U (ALL T (<= (F U) (F T))))))

(DEFVAR THEOREM-LIST '(ex0 ex0a ex0b EX1 EX2 EX3 EX3* EX3** EX3*** EX4 EX5 EX6
   EX7 EX7* EX8 EX9 EX9* EX9** EX9***
   EX10 EX11 EX12 EX12* EX13 EX14 EX15 EX16 EX17 EX17* EX17** EX18 EX19 EX19*
   EX20 EX20* EX20** EX20*** EX20BC EX20A EX20B EX20C EX20C* EX20D
   EX21 EX22 EX23 EX24 EX24* HTH EX25 EX26 EX27 EX28 EX29 EX30 ex30* EX31
   EX32 EX33 EX34 EX35 EX35* EX36 ex36* EX37 ex37* EX38 EX38* EX38**
   EX39 EX40 EX41 EX42 EX43 EX44 EX45 EX46 ex46* EX47 EX48 EX49 ex49* EX50 EX51
   EX52 EX53 EX54 EX55 EX56 EX57 TH1 TH2))
;;Try (prove-n theorem-list) to prove all of these in sequence. (But fail on 
;; some)

(setq L1 
  '(-> (& (Clauses S) (ground S) (element C S) (element L C) 
          (= C1  (set-diff C (sng L)))
	  (= S% (union (set-diff S (sng C)) (sng C1)))(element [] (res S% n))
	  (p-integer n))
       (or (element [] (res S n)) (element (sng L) (res S n)))))

(setq L2 '(-> (& (clauses S17) (clauses S27) (subset S17 S27)(p-integer n))
                    (subset (res S17 n) (res S27 n))))

(setq L3 '(-> (& (clauses S) (p-integer n) (p-integer m))
                    (= (res (res S n) m) (res S (+ n m)))))

(setq L4 '(-> (& (clauses S) (= (excess-Literal S) 0) (not (element [] S)))
	      (& (all C (-> (element C S) (unit-clause C)))
                 (-> (unsatisfiable S) (element [] (res S 1))))))

(setq L5 '(-> (& (Clauses S) (element C S) 
		 (or (= C1 (set-diff C (sng LL))) (= C1 (sng LL)))
		 (= S* (union (set-diff S (sng C)) (sng C1))))
	      (& (Clauses S*)
                 (-> (ground S) (ground S*))
                 (-> (Unsatisfiable S) (Unsatisfiable S*))
                 (-> (& (not (element [] S)) (non-unit C))
                     (not (element [] S*)))
                 (-> (< (length C1) (length C))
		     (< (excess-literal S*) (excess-literal S))))))

(setq L6 '(-> (& (clauses S) (p-integer k)) 
	      (& (clauses (res S k)) (subset S (res S k)))))

(setq L7 '(-> (& (clauses S) (finite S) (not (element [] S)))
              (<= (- (excess-literal S)))))

(setq L8 '(-> (& (clauses S) (finite S) (not (element [] S))
		 (< (- (excess-literal S))))
          (some C (& (element C S) (non-unit C)))))

(setq L8* '(-> (& (clauses S) (finite S) 
                  (all C (-> (element C S) (non-unit C))))
               (= (excess-literal S) 0)))

(setq L9  '(-> (& (Clauses S) (element C S)) (clause C)))

(setq L10  '(-> (& (Clause C) (element L C)) (Literal L)))

(setq L11 '(-> (& (clause C) (non-unit C)) (non-empty C)))

(setq L12 '(-> (non-empty A) (some x (element x A))))

(setq L13 '(-> (& (element L C) (= C1 (set-diff C (sng L))))
               (& (subset C1 C) (< (length C1) (length C)))))

(setq L14 '(-> (& (element L C) (= C2 (sng L)))
               (& (subset C2 C) (< (length C2) (length C)))))

(setq L14* '(-> (proper-subset A B) (< (length A) (length B))))

(setq L15 '(-> (non-unit C) (< (+ 1 (- (length C))))))

(setq L16 '(= (length (sng L)) 1))

(setq L17 '(p-integer 1))

(setq L18 '(-> (& (p-integer n91) (p-integer n92)) (p-integer (+ n91 n92))))

(setq L19 '(-> (element C S) (element C (res S n))))

;;For temporary runs

(setq th '(-> (& (clauses (S)) (element (CC) (S)) (subset (C1) (CC))
                 (= (S1) (union (set-diff (S) (sng (CC))) (sng (C1))))
                 (ground (S)) (unsatisfiable (S)))
              (& (clauses (S1)) (ground (S1)) (unsatisfiable (S1)) )))


(setq thh '(-> (P (a)) (Q (a))))

(setq LL '(-> (P x) (Q x)))

(setq LL-70 '(& (P-INTEGER (N113)) (P-INTEGER (N22))
   (SUBSET (S2) (RES (S) (N113))) (ELEMENT [] (RES (S2) (N22)))))

;;-------------------------------------------- 1Sept94

(setq ex75 '(-> (-> (ALL x (& (P x) (Q x) (R x))) 
		   (ALL y (& (P y) (Q y) (R y))))
	       (-> (ALL x (& (P x) (Q x) (R x))) 
		   (ALL y (& (P y) (Q y) (R y))))))

(setq ex76 '(-> (-> (-> (ALL x (& (P x) (Q x) (R x))) 
		       (ALL y (& (P y) (Q y) (R y))))
		   (-> (ALL x (& (P x) (Q x) (R x))) 
		       (ALL y (& (P y) (Q y) (R y)))))
	       (-> (-> (ALL x (& (P x) (Q x) (R x))) 
		       (ALL y (& (P y) (Q y) (R y))))
		   (-> (ALL x (& (P x) (Q x) (R x))) 
		       (ALL y (& (P y) (Q y) (R y)))))))

(setq ex77 '(-> (-> (-> (-> (ALL x (& (P x) (Q x) (R x))) 
			   (ALL y (& (P y) (Q y) (R y))))
		       (-> (ALL x (& (P x) (Q x) (R x))) 
			   (ALL y (& (P y) (Q y) (R y)))))
		   (-> (-> (ALL x (& (P x) (Q x) (R x))) 
			   (ALL y (& (P y) (Q y) (R y))))
		       (-> (ALL x (& (P x) (Q x) (R x))) 
			   (ALL y (& (P y) (Q y) (R y))))))
	       (-> (-> (-> (ALL x (& (P x) (Q x) (R x))) 
			   (ALL y (& (P y) (Q y) (R y))))
		       (-> (ALL x (& (P x) (Q x) (R x))) 
			   (ALL y (& (P y) (Q y) (R y)))))
		   (-> (-> (ALL x (& (P x) (Q x) (R x))) 
			   (ALL y (& (P y) (Q y) (R y))))
		       (-> (ALL x (& (P x) (Q x) (R x))) 
			   (ALL y (& (P y) (Q y) (R y))))))))

(setq ex78 '(-> (-> (-> (-> (-> (ALL x (& (P x) (Q x) (R x))) ;OTTER 3.6,11 Sec
			       (ALL y (& (P y) (Q y) (R y))));PR    2.0,2.4
			   (-> (ALL x (& (P x) (Q x) (R x))) 
			       (ALL y (& (P y) (Q y) (R y)))))
		       (-> (-> (ALL x (& (P x) (Q x) (R x))) 
			       (ALL y (& (P y) (Q y) (R y))))
			   (-> (ALL x (& (P x) (Q x) (R x))) 
			       (ALL y (& (P y) (Q y) (R y))))))
		   (-> (-> (-> (ALL x (& (P x) (Q x) (R x))) 
			       (ALL y (& (P y) (Q y) (R y))))
			   (-> (ALL x (& (P x) (Q x) (R x))) 
			       (ALL y (& (P y) (Q y) (R y)))))
		       (-> (-> (ALL x (& (P x) (Q x) (R x))) 
			       (ALL y (& (P y) (Q y) (R y))))
			   (-> (ALL x (& (P x) (Q x) (R x))) 
			       (ALL y (& (P y) (Q y) (R y)))))))
	       (-> (-> (-> (-> (ALL x (& (P x) (Q x) (R x))) 
			       (ALL y (& (P y) (Q y) (R y))))
			   (-> (ALL x (& (P x) (Q x) (R x))) 
			       (ALL y (& (P y) (Q y) (R y)))))
		       (-> (-> (ALL x (& (P x) (Q x) (R x))) 
			       (ALL y (& (P y) (Q y) (R y))))
			   (-> (ALL x (& (P x) (Q x) (R x))) 
			       (ALL y (& (P y) (Q y) (R y))))))
		   (-> (-> (-> (ALL x (& (P x) (Q x) (R x))) 
			       (ALL y (& (P y) (Q y) (R y))))
			   (-> (ALL x (& (P x) (Q x) (R x))) 
			       (ALL y (& (P y) (Q y) (R y)))))
		       (-> (-> (ALL x (& (P x) (Q x) (R x))) 
			       (ALL y (& (P y) (Q y) (R y))))
			   (-> (ALL x (& (P x) (Q x) (R x))) 
			       (ALL y (& (P y) (Q y) (R y)))))))))

(setq ex79 '(-> (& (-> (-> (-> (-> (-> (ALL x (& (P x) (Q x) (R x))) 
                                  ;OTTER failed "out of memory", PR 4 sec
				      (ALL y (& (P y) (Q y) (R y))))
				  (-> (ALL x (& (P x) (Q x) (R x))) 
				      (ALL y (& (P y) (Q y) (R y)))))
			      (-> (-> (ALL x (& (P x) (Q x) (R x))) 
				      (ALL y (& (P y) (Q y) (R y))))
				  (-> (ALL x (& (P x) (Q x) (R x))) 
				      (ALL y (& (P y) (Q y) (R y))))))
			  (-> (-> (-> (ALL x (& (P x) (Q x) (R x))) 
				      (ALL y (& (P y) (Q y) (R y))))
				  (-> (ALL x (& (P x) (Q x) (R x))) 
				      (ALL y (& (P y) (Q y) (R y)))))
			      (-> (-> (ALL x (& (P x) (Q x) (R x))) 
				      (ALL y (& (P y) (Q y) (R y))))
				  (-> (ALL x (& (P x) (Q x) (R x))) 
				      (ALL y (& (P y) (Q y) (R y)))))))
		      (-> (-> (-> (-> (ALL x (& (P x) (Q x) (R x))) 
				      (ALL y (& (P y) (Q y) (R y))))
				  (-> (ALL x (& (P x) (Q x) (R x))) 
				      (ALL y (& (P y) (Q y) (R y)))))
			      (-> (-> (ALL x (& (P x) (Q x) (R x))) 
				      (ALL y (& (P y) (Q y) (R y))))
				  (-> (ALL x (& (P x) (Q x) (R x))) 
				      (ALL y (& (P y) (Q y) (R y))))))
			  (-> (-> (-> (ALL x (& (P x) (Q x) (R x))) 
				      (ALL y (& (P y) (Q y) (R y))))
				  (-> (ALL x (& (P x) (Q x) (R x))) 
				      (ALL y (& (P y) (Q y) (R y)))))
			      (-> (-> (ALL x (& (P x) (Q x) (R x))) 
				      (ALL y (& (P y) (Q y) (R y))))
				  (-> (ALL x (& (P x) (Q x) (R x))) 
				      (ALL y (& (P y) (Q y) (R y))))))))

		  (-> (-> (-> (-> (-> (-> (ALL x (& (P x) (Q x) (R x))) 
				      (ALL y (& (P y) (Q y) (R y))))
				  (-> (ALL x (& (P x) (Q x) (R x))) 
				      (ALL y (& (P y) (Q y) (R y)))))
			      (-> (-> (ALL x (& (P x) (Q x) (R x))) 
				      (ALL y (& (P y) (Q y) (R y))))
				  (-> (ALL x (& (P x) (Q x) (R x))) 
				      (ALL y (& (P y) (Q y) (R y))))))
			  (-> (-> (-> (ALL x (& (P x) (Q x) (R x))) 
				      (ALL y (& (P y) (Q y) (R y))))
				  (-> (ALL x (& (P x) (Q x) (R x))) 
				      (ALL y (& (P y) (Q y) (R y)))))
			      (-> (-> (ALL x (& (P x) (Q x) (R x))) 
				      (ALL y (& (P y) (Q y) (R y))))
				  (-> (ALL x (& (P x) (Q x) (R x))) 
				      (ALL y (& (P y) (Q y) (R y)))))))
		      (-> (-> (-> (-> (ALL x (& (P x) (Q x) (R x))) 
				      (ALL y (& (P y) (Q y) (R y))))
				  (-> (ALL x (& (P x) (Q x) (R x))) 
				      (ALL y (& (P y) (Q y) (R y)))))
			      (-> (-> (ALL x (& (P x) (Q x) (R x))) 
				      (ALL y (& (P y) (Q y) (R y))))
				  (-> (ALL x (& (P x) (Q x) (R x))) 
				      (ALL y (& (P y) (Q y) (R y))))))
			  (-> (-> (-> (ALL x (& (P x) (Q x) (R x))) 
				      (ALL y (& (P y) (Q y) (R y))))
				  (-> (ALL x (& (P x) (Q x) (R x))) 
				      (ALL y (& (P y) (Q y) (R y)))))
			      (-> (-> (ALL x (& (P x) (Q x) (R x))) 
				      (ALL y (& (P y) (Q y) (R y))))
				  (-> (ALL x (& (P x) (Q x) (R x))) 
				      (ALL y (& (P y) (Q y) (R y))))))))
		      (-> (-> (-> (-> (-> (ALL x (& (P x) (Q x) (R x))) 
				      (ALL y (& (P y) (Q y) (R y))))
				  (-> (ALL x (& (P x) (Q x) (R x))) 
				      (ALL y (& (P y) (Q y) (R y)))))
			      (-> (-> (ALL x (& (P x) (Q x) (R x))) 
				      (ALL y (& (P y) (Q y) (R y))))
				  (-> (ALL x (& (P x) (Q x) (R x))) 
				      (ALL y (& (P y) (Q y) (R y))))))
			  (-> (-> (-> (ALL x (& (P x) (Q x) (R x))) 
				      (ALL y (& (P y) (Q y) (R y))))
				  (-> (ALL x (& (P x) (Q x) (R x))) 
				      (ALL y (& (P y) (Q y) (R y)))))
			      (-> (-> (ALL x (& (P x) (Q x) (R x))) 
				      (ALL y (& (P y) (Q y) (R y))))
				  (-> (ALL x (& (P x) (Q x) (R x))) 
				      (ALL y (& (P y) (Q y) (R y)))))))
		      (-> (-> (-> (-> (ALL x (& (P x) (Q x) (R x))) 
				      (ALL y (& (P y) (Q y) (R y))))
				  (-> (ALL x (& (P x) (Q x) (R x))) 
				      (ALL y (& (P y) (Q y) (R y)))))
			      (-> (-> (ALL x (& (P x) (Q x) (R x))) 
				      (ALL y (& (P y) (Q y) (R y))))
				  (-> (ALL x (& (P x) (Q x) (R x))) 
				      (ALL y (& (P y) (Q y) (R y))))))
			  (-> (-> (-> (ALL x (& (P x) (Q x) (R x))) 
				      (ALL y (& (P y) (Q y) (R y))))
				  (-> (ALL x (& (P x) (Q x) (R x))) 
				      (ALL y (& (P y) (Q y) (R y)))))
			      (-> (-> (ALL x (& (P x) (Q x) (R x))) 
				      (ALL y (& (P y) (Q y) (R y))))
				  (-> (ALL x (& (P x) (Q x) (R x))) 
				      (ALL y (& (P y) (Q y) (R y))))))))))
	       (-> (-> (-> (-> (-> (ALL x (& (P x) (Q x) (R x))) 
				      (ALL y (& (P y) (Q y) (R y))))
				  (-> (ALL x (& (P x) (Q x) (R x))) 
				      (ALL y (& (P y) (Q y) (R y)))))
			      (-> (-> (ALL x (& (P x) (Q x) (R x))) 
				      (ALL y (& (P y) (Q y) (R y))))
				  (-> (ALL x (& (P x) (Q x) (R x))) 
				      (ALL y (& (P y) (Q y) (R y))))))
			  (-> (-> (-> (ALL x (& (P x) (Q x) (R x))) 
				      (ALL y (& (P y) (Q y) (R y))))
				  (-> (ALL x (& (P x) (Q x) (R x))) 
				      (ALL y (& (P y) (Q y) (R y)))))
			      (-> (-> (ALL x (& (P x) (Q x) (R x))) 
				      (ALL y (& (P y) (Q y) (R y))))
				  (-> (ALL x (& (P x) (Q x) (R x))) 
				      (ALL y (& (P y) (Q y) (R y)))))))
		      (-> (-> (-> (-> (ALL x (& (P x) (Q x) (R x))) 
				      (ALL y (& (P y) (Q y) (R y))))
				  (-> (ALL x (& (P x) (Q x) (R x))) 
				      (ALL y (& (P y) (Q y) (R y)))))
			      (-> (-> (ALL x (& (P x) (Q x) (R x))) 
				      (ALL y (& (P y) (Q y) (R y))))
				  (-> (ALL x (& (P x) (Q x) (R x))) 
				      (ALL y (& (P y) (Q y) (R y))))))
			  (-> (-> (-> (ALL x (& (P x) (Q x) (R x))) 
				      (ALL y (& (P y) (Q y) (R y))))
				  (-> (ALL x (& (P x) (Q x) (R x))) 
				      (ALL y (& (P y) (Q y) (R y)))))
			      (-> (-> (ALL x (& (P x) (Q x) (R x))) 
				      (ALL y (& (P y) (Q y) (R y))))
				  (-> (ALL x (& (P x) (Q x) (R x))) 
				      (ALL y (& (P y) (Q y) (R y))))))))))

(setq ex80          ;see atp.124  OTTER, no proof in 1 hour, PR .8sec
 '(-> (& (CLSD-REC D)
	 (NOT (SOME H7 (& (SUBSET H7 G0) (FINITE H7) (SUBSET D (@ H7)))))
	 (<<= (LF D) (RT D))
	 (<<= (BOT D) (TOP D))
	 (CLSD-REC (RECT A B C D))
	 (NOT (SOME H8 (& (SUBSET H8 G0) (FINITE H8)
			  (SUBSET (RECT A B C D) (@ H8)))))
	 (<<= (LF (RECT A B C D)) (RT (RECT A B C D)))
	 (<<= (BOT (RECT A B C D)) (TOP (RECT A B C D)))
	 (E A R1) (E B R1) (E C R1) (E D R1)
	 (<<= A B) (<<= C D)
	 (ALL B9 (-> (E B9 G0) (OPEN B9)))
	 (SUBSET (RECT A B C D) (@ G0))
      
	 (ALL D2 (ALL G3
		      (-> (& (CLSD-REC D2)
			     (NOT (SOME H4 (& (SUBSET H4 G3) (FINITE H4)
					      (SUBSET D2 (@ H4)))))
			     (<<= (LF D2) (RT D2))
			     (<<= (BOT D2) (TOP D2)))
			  (SOME D5 (& (& (CLSD-REC D5)
					 (NOT (SOME H6 (& (SUBSET H6 G3) (FINITE H6)
							  (SUBSET D5 (@ H6)))))
					 (<<= (LF D5) (RT D5))
					 (<<= (BOT D5) (TOP D5)))
				      (& (SUBSET D5 D2) (= (DIAM D5) (/ (DIAM D2) 2)))))))))
(SOME D10 (& (& (CLSD-REC D10)
			 (NOT (SOME H11 (& (SUBSET H11 G0) (FINITE H11)
					   (SUBSET D10 (@ H11)))))
			 (<<= (LF D10) (RT D10))
			 (<<= (BOT D10) (TOP D10)))
		      (& (SUBSET D10 D) (= (DIAM D10) (/ (DIAM D) 2)))))))

(setq ex81
 '(-> (& (CLSD-REC D)
	 (NOT (SOME H7 (& (SUBSET H7 G0) (FINITE H7) (SUBSET D (@ H7)))))
	 (<<= (LF D) (RT D))
	 (<<= (BOT D) (TOP D))
	 (CLSD-REC (RECT A B C D))
	 (NOT (SOME H8 (& (SUBSET H8 G0) (FINITE H8)
			  (SUBSET (RECT A B C D) (@ H8)))))
	 (<<= (LF (RECT A B C D)) (RT (RECT A B C D)))
	 (<<= (BOT (RECT A B C D)) (TOP (RECT A B C D)))
	 (E A R1) (E B R1) (E C R1) (E D R1)
	 (<<= A B) (<<= C D)
	 (ALL B9 (-> (E B9 G0) (OPEN B9)))
	 (SUBSET (RECT A B C D) (@ G0))
	 )
(SOME D10 (& (& (CLSD-REC D10)
		(NOT (SOME H11 (& (SUBSET H11 G0) (FINITE H11)
				  (SUBSET D10 (@ H11)))))
		(<<= (LF D10) (RT D10))
		(<<= (BOT D10) (TOP D10)))
	     (& (SUBSET D10 D) (= (DIAM D10) (/ (DIAM D) 2)))))))

(defvar ex82 nil)
(defvar ex83 nil)
(defvar ex84 nil)
(defvar ex85 nil)
(defvar ex86 nil)
(defvar ex87 nil)
(defvar ex88 nil)
(defvar ex89 nil)
(defvar ex90 nil)
(defvar ex91 nil)
(defvar ex92 nil)
(defvar ex93 nil)
(defvar ex94 nil)
(defvar ex95 nil)
(defvar ex96 nil)
(defvar ex97 nil)
(defvar ex98 nil)
(defvar ex99 nil)
(defvar ex100 nil)


;;13Sept94 The following examples are from examples-hb2-nil1.lisp

(setq Ex101 '(all x (= x (/ x (exp 2 0)))))
(setq Ex102 '(all x (all y (all d (all n 
                             (-> (& (= x (/ d (exp 2 n))) (= y (/ x 2)))
				 (= y (/ d (exp 2 (+ n 1))))))))))
				        
(setq Ex103 '(all x (all y (clsd-int (nt x y)))))

(setq Ex104 '(all x (all  y (& (= (lf (nt x y)) x) (= (rt (nt x y)) y)))))

(setq Ex105 '(all D (all G33 
               (-> (& (clsd-int D) 	         
		      (not (some H (& (subset H G33) (finite H) 
				      (subset D (@ H)))))
		      (<= (lf D) (rt D))
		      )
		   (some D* (& (& (clsd-int D*) 	 
				  (not (some H (& (subset H G33) (finite H) 
						  (subset D* (@ H)))))
				  (<= (lf D*) (rt D*))
				  )
			       (& (subset D* D) 
				  (= (length D*) (/ (length D) 2)))))))))

(setq Ex106 '(all A (all H (all x 
            (-> (& (subset A (@ H)) (e x A)) 
		(some B (& (e B H) (e x B)))) ))) )

(setq Ex107 '(all x (all B 
            (-> (& (e x B) (open B))
		(some u (some v (& (< u v) (subset (nt u v) B) 
				   (center x (nt u v)))))) )) )

(setq Ex108 '(all d (all b (-> (& (< 0 d) (<= 0 b))
			        (some i (& (e i omega) 
					   (<= (/ b (exp 2 i)) (/ d 2))))))))

(setq Ex109 '(all x (all u (all v (all c (all d 
                   (-> (& (center x (nt u v)) (e x (nt c d)) 
			  (<= (length (nt c d)) (/ (length (nt u v)) 2)))
		       (subset (nt c d) (nt u v))) ))))) )

(setq Ex110 '(all B (finite (sng B))))

(setq Ex111 '(all D2  (-> (clsd-int D2)  (= D2 (nt (lf D2) (rt D2))))))

(setq Ex112 '(all B (= B (@ (sng B)))))

(setq Ex113 '(all A (all B (all C (-> (& (subset A B) (subset B C)) 
				     (subset A C))))))


(setq Ex114 '(all B (all G (-> (e B G) (subset (sng B) G)))))

(setq Ex115 '(all u (all v (-> (< u v) (< 0 (length (nt u v)))))))

(setq Ex116 '(all u (all v (-> (<= u v) (& (<= 0 (length (nt u v)))
					  (<= 0 (/ (length (nt u v)) 2)))))))
(defvar ex117 nil)
(defvar ex118 nil)
(defvar ex119 nil)
(defvar ex120 nil)


;;13Sept94 The following examples are from examples-hb2-nil2.lisp

(setq Ex121 '(all x (= x (/ x (exp 2 0)))))
(setq Ex122 '(all x (all y (all d (all n 
                             (-> (& (= x (/ d (exp 2 n))) (= y (/ x 2)))
				 (= y (/ d (exp 2 (+ n 1))))))))))
				        
(setq Ex123 '(all x (all y (all z (all w (clsd-rec (rect x y z w)))))))

(setq Ex124 '(all x (all  y (all z (all w 
       (& (= (lf  (rect x y z w)) x) (= (rt  (rect x y z w)) y)
	  (= (bot (rect x y z w)) z) (= (top (rect x y z w)) w)))))))

(setq Ex125 '(all D (all G33 
               (-> (& (clsd-rec D) 	         
		      (not (some H (& (subset H G33) (finite H) 
				      (subset D (@ H)))))
		      (<= (lf D) (rt D)) (<= (bot D) (top D)))
		   (some D* (& (& (clsd-rec D*) 	 
				  (not (some H (& (subset H G33) (finite H) 
						  (subset D* (@ H)))))
				  (<= (lf D*) (rt D*)) (<= (bot D*) (top D*)))
			       (& (subset D* D) 
				  (= (diam D*) (/ (diam D) 2)))))))))

(setq Ex126 '(all A (all H (all x 
            (-> (& (subset A (@ H)) (e x A)) 
		(some B (& (e B H) (e x B)))) ))) )

(setq Ex127 '(all x (all B 
   (-> (& (e x B) (open B))
       (some u (some v (some r (some s (& (< u v) (< r s) 
					  (subset (rect u v r s) B) 
					  (center x (rect u v r s)))))) )) )))
(setq Ex128 '(all d (all b (-> (& (< 0 d) (<= 0 b))
			        (some i (& (e i omega) 
					   (<= (/ b (exp 2 i)) (/ d 2))))))))

(setq Ex129 '(all x (all u (all v (all r (all s (all a (all b (all c (all d 
                (-> (& (center x (rect u v r s)) (e x (rect a b c d))
		       (<= (diam (rect a b c d)) (/ (diam (rect u v r s)) 2)))
		    (subset (rect a b c d) (rect u v r s))) ))))))))) )

(setq Ex130 '(all B (finite (sng B))))

(setq Ex131 '(all D2  (-> (clsd-rec D2)  
			  (= D2 (rect (lf D2) (rt D2) (bot D2) (top D2))))))

(setq Ex132 '(all B (= B (@ (sng B)))))

(setq Ex133 '(all A (all B (all C (-> (& (subset A B) (subset B C)) 
				      (subset A C))))))

(setq Ex134 '(all B (all G (-> (e B G) (subset (sng B) G)))))

(setq Ex135 '(all u (all v (all r (all s (-> (& (< u v) (< r s))
					     (< 0 (diam (rect u v r s)))))))))
(setq Ex136 '(all u (all v (all r (all s (-> (& (<= u v) (<= r s))
					     (<= 0 (diam (rect u v r s)))))))))


