

;;;                examples-pbrL.lisp                           13Mar92
;;;
;;; To be used with pbr.lisp   (for GCLR proofs)
;;;
;;; See also  examples-pbr.lisp
;;;
;;; Also for examples in the Hans B. Paper  31July93


;;--------&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&--------------------------------
;;Example GCLR  Ground Completeness of Lock Resolution           29May92
;;--------&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&--------------------------------

;;NOTE NOTE 7Aug93.  To run GCR and GCRL now, we must 
;;  1. Put all lemmas in the common list (the step lemmas will not be used)
;;  2. Put 'st (for struve) in steps where STRUVE is to be used (else OTTER)

(defun pL () (pc-start h-gclr thm-gclr plan-gclr 'pbr-mode nil nil gclr-theta
		       '(plan-gclr - 0)))

(defun ppL () (lpc) (lpLe) (untrace)
     (trace (pc :entry `(pc ,(cadr  si::arglist)))  ;prints only theorem
	    (pcn     :entry `(pcn ,(cadr si::arglist))) ;prints only F
	    (otter-prove  :entry `(otter-prove ,(car si::arglist)))
		)
     (time (pL)) )

(setq H-GCLR '(& (all x (<= x x))  (all y (= y y))
		(all S11 (-> (& (clauses-L S11) (finite S11)) 
			     (e (exl S11) w)))))
(setq Lemma-names-GCLR '(induction-axiom-gcL induction-axiom-lm1 L=
  r0 r1 r2 r3 r4 r5 r6 r7 r8 r9 r10 r11 r12                          ;3Aug92
  d1 d2 d21 d3 d31 d4 d5 d41 d6 d61
  s1 s2 s3 s4 s5 s6 s7 s8 s9 s91 s10 s11 s13 s14 s17 s21))

(setq Lemma-names-GCLR-used '())                                     ;3Aug92

(setq thm-GCLR '(-> (& (clauses-L S) (ground S) (finite S) (unsat-L S))
		    (SOME n (& (e n w) (e [] (res-L S n))))))

;;**************** Proof Plans for GCLR ************************** 5Mar92
;;Units of a PLAN have the form    [Fi flagi plani lemmasi]
;;If flagi is tt, then assume Fi without proof. (Only used for doing the proof)
;;If flagi is ttt and *tt* is non-nil, then assume Fi without proof.

;;3Aug92 We are moving all of the LEMMA-NAMES from the steps of the plan
;; and putting them into H (actually leave them in the plan but change
;; pc program so that it does not bring them back in the back-tracking)
;; (Later leave them out of Plan altogether (and put them in H)).

(setq PLAN-GCLR 
'( ( (ALL S0 (ALL n0 (-> (& (e n0 w) (e [] S0))                           
			 (e [] (res-L S0 n0))))) ttt nil (r0 r11 s4))     ;1
   ( (ALL S* (ALL k* (gc S* k*))) ttt Plan2 (induction-axiom-gcL))        ;2

   ))                                                                   

(setq PLAN2 
'( ( (all S21 (gc S21 0)) ttt nil (s10 s11 s13 r1 r2))                    ;2-1
   ( (all k (all S (-> (& (e k w) (all S* (gc S* k)))                     ;2-2
		       (gc S (+ k 1))))) ttt Plan22 (s10 s13 r1 r2))
   ))                                 

(setq plan22
'( ( (-> (& (< 0 (exl S)) (not (e [] S)))                                ;22-1
	 (some C (& (e C S) (clause-L C) (nu C)))) ttt nil (r3))
   ( (-> (& (clause-L C) (nu C)) (some L (e L C))) ttt nil (r4))         ;22-2

   ( (-> (& (not (e [] S)) (< 0 (exl S)))                               
	 (some C1 (some C2 (some S1 (some S2 (H2 S C L C1 C2 S1 S2)))))) ;22-3
     (some-def ttt) nil (r9 r10 L=))

   ( (-> (& (< 0 (exl S)) (not (e [] S))) (gc S (+ k 1)))                 ;22-4
     ttt plan224 (s14))     
   ))

(setq plan224 
'( 
   ( (& (clauses-L S1) (ground S1) (finite S1) (unsat-L S1) (<= (exl S1) k)) 
     tt nil (r6))                 ;treated as an input lemma             ;224-1
   ( (some n1 (& (e n1 w) (e [] (res-L S1 n1)))) (some-def ttt) nil nil) ;224-2
					
   ( (& (clauses-L S2) (ground S2) (finite S2) (unsat-L S2) (<= (exl S2) k)) 
     tt nil (r6))                 ;treated as an input lemma             ;224-3
   ( (some n2 (& (e n2 w) (e [] (res-L S2 n2)))) (some-def ttt) nil nil) ;224-4
					
   ( (or (e [] (res-L S n1)) (e (sng L) (res-L S n1))) ttt Plan1 (s1))   ;224-5
   ( (-> (e (sng L) (res-L S n1)) (e [] (res-L S (+ n1 n2)))) ttt Plan2246  
     (r7 s2 s4))  ))                                                     ;224-6

(setq plan2246
'( ( (subset S  (res-L S n1)) ttt nil (d1))                            ;2246-1
   ( (subset S2 (res-L S n1)) ttt nil (s3))                            ;    -2 

   ( (subset (res-L S2 n2) (res-L (res-L S n1) n2)) ttt nil (r8)) ))   ;    -3

(setq plan1
'( ( (all R*1 (ALL k* (lm1 R*1 k*))) ttt plan12 (induction-axiom-lm1 s10)) ;1-1
   ))

(setq plan12
'( ( (= C (U C1 (sng L))) ttt nil (s5))                                   ;12-1

   ( (all R_ (lm1 R_ 0)) ttt plan122 (r0 s17))                            ;12-2
   ( (all R (ALL k (-> (& (e k w) (all R*2 (lm1 R*2 k))) 
		       (lm1 R (+ k 1)))))
	  ttt plan123 nil) ))                                             ;12-3

(setq plan122
'( ( (-> (e R_ S1) (or (e R_ S) (e (U R_ (sng L)) S))) ttt plan1221 nil) ;122-1
   ))

(setq plan1221
'( ( (-> (= R_ C1)       (or (e R_ S) (e (U R_ (sng L)) S))) ttt nil nil) 
                                                                    ;1221-1
   ( (-> (not (= R_ C1)) (or (e R_ S) (e (U R_ (sng L)) S))) ttt nil (s6)) 
   ))                                                                   ;1221-2

(setq plan123
'( ( (or (e R (res-L S1 k)) (e R (resolvents-L (res-L S1 k)))) ttt nil (d2));-1
   ( (-> (e R (res-L S1 k)) (or (e    R          (res-L S (+ k 1)))      ;123-2
			      (e (U R (sng L)) (res-L S (+ k 1)))))
     ttt nil (d21))
   ( (-> (e R (resolvents-L (res-L S1 k)))                               ;123-3
	 (or (e    R          (res-L S (+ k 1)))
	     (e (U R (sng L)) (res-L S (+ k 1)))))
     ttt plan1233 nil) ))     ; (d2)        12Mar92


(setq plan1233
'( ( (some C11 (some C21 (some L1 (some L2                              ;1233-1
      (& (e C11 (res-L S1 k)) (e C21 (res-L S1 k)) 
	 (resolvent-L C11 C21 L1 L2 R))))))
     (some-def ttt) nil (d3 d4))    
   ( (or (e C11 (res-L S k)) (e (U C11 (sng L)) (res-L S k))) ttt nil nil)  ;-2
   ( (or (e C21 (res-L S k)) (e (U C21 (sng L)) (res-L S k))) ttt nil nil)  ;-3
   ( (-> (& (e C11 (res-L S k)) (e C21 (res-L S k))) (cck R S k L))     ;1233-4
     ttt nil (d21 d31))                                                 
   ( (-> (& (e C11 (res-L S k)) (e (U C21 (sng L)) (res-L S k)))        ;1233-5
	 (cck R S k L)) ttt plan12335 (d31 d21))
   ( (-> (& (e (U C11 (sng L)) (res-L S k)) (e C21 (res-L S k)))        ;1233-6
	 (cck R S k L)) tt plan12336 (d31))
         ;;like 1233-5, assumed without proof.
   ( (-> (& (e (U C11 (sng L)) (res-L S k)) (e (U C21 (sng L)) (res-L S k)))
	 (cck R S k L)) tt plan12337 (d31))                             ;1233-7
         ;;like 1233-5, assumed without proof.

   ( (cck R S k L) ttt nil nil)                                         ;1233-8
   ))

(setq plan12335
'( ( (& (e L1 C11) (e L2 C21) (negatives-L L1 L2)                      ;12335-1
	(all L_ (-> (e L_ C11) (<= (i L1) (i L_))))
	(all L_ (-> (e L_ C21) (<= (i L2) (i L_))))
        (= R (merge-low (U (~ C11 (sng L1)) (~ C21 (sng L2)))))) ttt nil (d4))

   ( (-> (= L2 L) (cck R S k L)) ttt plan123352 nil)                   ;12335-2
   ( (e L2 (U C21 (sng L))) ttt nil (s8))                              ;12335-3


   ( (-> (& (not (= L2 L)) (= k 0)) (some C& (& (e C& S) (nu C&) (e L C&))))
	 (some-def ttt) plan123354 (s22))                              ;12335-4
   ( (-> (not (= L2 L)) 
	 (all R* (-> (= R* (merge-low (U (~ C11 (sng L1))             ;12335-5
					 (~ (U C21 (sng L)) (sng L2)))))
		 (or (= R* R) (= R* (U R (sng L))))))) ttt plan123355 (s7 s10))

   ( (-> (not (= L2 L))
	 (or (resolvent-L C11 (U C21 (sng L)) L1 L2 R) ;a PB goal     ;12335-6
	     (resolvent-L C11 (U C21 (sng L)) L1 L2 (U R (sng L))))) 
	 ttt plan3 (d4 d41 L=)) 
                 ;;7Aug92 OTTER proved this (from Plan3 result) in 300 Seconds.

   ( (-> (not (= L2 L)) (cck R S k L)) ttt nil (d31 d21))             ;12335-7
   ))

(setq plan123352    
'( 
   ( (= C21 (U C21 (sng L))) ttt nil (s24))                           ;123352-1
   ( (e C21 (res-L S k)) ttt nil nil) ))                              ;123352-2

(setq plan123354    
'( 
   ( (e (U C21 (sng L)) S) tt nil (r0 s24))                           ;123354-1
   ;;7June93  We put tt for ttt, because Otter could not prove this obvious thm

   ( (e L (U C21 (sng L))) ttt nil (s23)) ))                          ;123354-2

(setq plan123355
'( 
   ( (all t (-> (e t R) (e t R*))) fail nil (s8 s9 s91 s17 s21 d6 d61 r5 r12))
                                                                      ;123355-1
                            ;d6,d61,s91,r5,s17,s8,s21 added. This is a PB goal
   ( (subset R R*) ttt nil (d5))                                      ;123355-2
   ))

(setq plan3 
'( ( (ALL L_ (-> (e L_ (U C21 (sng L))) (<= (i L2) (i L_)))) fail nil  ;3-1
     (s8 s9 s91 s17 s21 d6 d61 r5 r12))
   ))

;;----------------------------------------------------------------------------
;;HANS B PAPER: 31July93  Plans, etc for the examples in the Hans B. Paper

;;---111111111111l1111111111111111111111111111111111
(defun p1 () (time (pc-start H-Ex1 Thm-Ex1 Plan-ex1 'pbr-mode 
                        nil nil gclr-theta '(plan-ex1 - 0))))
(defun pp1 () (lpc) (lpLe) (untrace)
     (trace (pc :entry `(pc ,(cadr  si::arglist)))  ;prints only theorem
	    (pcn     :entry `(pcn ,(cadr si::arglist))) ;prints only F
	    (otter-prove  :entry `(otter-prove ,(car si::arglist)))
		)
     (time (p1)) )

(setq H-Ex1 nil)

(setq thm-Ex1 '(-> (P a) (all x (& (P a) (Q x)))))                   ;31July93
(setq plan-ex1 nil)

;;--- 222222222222222222222222222222222222222
(defun p2 () (time (pc-start H-Ex2 Thm-Ex2 Plan-ex2 'pbr-mode 
                        nil nil gclr-theta '(plan-ex2 - 0))))
(defun pp2 () (lpc) (lpLe) (untrace)
     (trace (pc :entry `(pc ,(cadr  si::arglist)))  ;prints only theorem
	    (pcn     :entry `(pcn ,(cadr si::arglist))) ;prints only F
	    (otter-prove  :entry `(otter-prove ,(car si::arglist)))
		)
     (time (p2)) )

(setq H-Ex2 nil)
(setq thm-Ex2 '(-> (& (P a) (Q a)) (some x (& (P x) (Q x)))))
(setq plan-Ex2 nil)
(setq plan-Ex2 '(((some x (P x)) nil) ((Q x) nil)))

;;--- 333333333333333333333333333333333333333333
(defun p3 () (setq *struve* nil) (time (pc-start H-Ex3 Thm-Ex3 Plan-ex3 
                        'pbr-mode nil nil gclr-theta '(plan-ex3 - 0))))
(defun pp3 () (lpc) (lpLe) (untrace)
     (trace (pc :entry `(pc ,(cadr  si::arglist)))  ;prints only theorem
	    (pcn     :entry `(pcn ,(cadr si::arglist))) ;prints only F
	    (otter-prove  :entry `(otter-prove ,(car si::arglist)))
		)
     (time (p3)) )

(setq H-Ex3 '(& (all x (<= x x))  (all y (= y y))
		(all S11 (-> (& (clauses-L S11) (finite S11)) 
			     (e (exl S11) w)))
		(all C* (-> (nu C*) (some L* (e L* C*))))))
(setq thm-Ex3 '(-> (& (e C1 S) (e C2 S) (NU C1) (e L1 C1) (Q S L1))
		   (some C (some L (& (e C S) (NU C) (e L C) (Q S L))))))

(setq plan-Ex3 '( ((some C (& (e C S) (NU C))) nil) 
                  ((some L (e L C)) nil) 
		  ((Q S L) nil) ))
;;--------------
(setq d10 '(<-> (subsumes S* S)
		(all C* (-> (e C* S*) (some C (& (e C S) (subset C* C)))))))
(setq d10* '(all S10 (all S10* (-> (all C10* (-> (e C10* S10*)
					  (some C10 (& (e C10 S10) 
						     (subset C10* C10)))))
			      (subsumes S10* S10)))))	;3Aug93  
(setq d11 '(<-> (NU C11) 
		(some x (some y (& (e x C11) (e y C11) (not (= x y)))))))
(setq d12 '(<-> (subset* C4 C5)
		(& (subset C4 C5) (not (subset C5 C4)))))
(setq d12* '(all C4 (all C5 (-> (& (subset C4 C5) (not (subset C5 C4)))
				(subset* C4 C5)))))

(setq lemma0 '(all S0 (all S0* (-> (& (clauses S0) (fnt S0) (unsat S0) 
				    (subsumes S0* S0))
				 (& (clauses S0*) (fnt S0*) (unsat S0*))))))
(setq lemma0-L '(all S0 (all S0* (-> (& (clauses-L S0) (fnt S0) (unsat-L S0) 
				      (subsumes S0* S0))
				   (& (clauses-L S0*) (fnt S0*) (unsat-L S0*))))))

(setq lemma1 '(all S11 (all C11 (all L11 (all n11 
         	 (-> (e [] (res (U S11 (sng C11)) n11)) 
		     (or (e   []     (res (U S11 (sng (U C11 (sng L11)))) n11))
			 (e (sng L11)  (res (U S11 (sng (U C11 (sng L11)))) n11)) )))))))

(setq lemma1-L '(all S11 (all C11 (all L11 (all n11 
         	 (-> (& (e [] (res-L (U S11 (sng C11)) n11)) 
			(Q (U S11 (sng (U C11 (sng L11)))) L11)) 
		     (or (e   []    (res-L (U S11 (sng (U C11 (sng L11)))) n11))
			 (e (sng L11) (res-L (U S11 (sng (U C11 (sng L11)))) n11)))))))))

(setq lemma2   '(all S20 (-> (& (not (e [] S20)) (< 0 (Exl S20))) 
			   (some C20 (some L (& (e C20 S20) (nu C20) (e L C20)))))))
(setq lemma2-L '(all S20 (-> (& (not (e [] S20)) (< 0 (Exl S20)))
			   (some C20 (some L (& (e C20 S20) (nu C20) (e L C20) 
					      (Q S20 L)))))))
(setq lemma3 '(all S3 (all C3 (all C3* (-> (& (e C3 S3) (subset* C3* C3))
					(< (Exl (U (~ S3 (sng C3)) (sng C3*)))
					   (Exl S3)))))))  

(setq lemma4   '(all S4 (all n4 (subset S4 (res S4 n4)))))
(setq lemma4-L '(all S4 (all n4 (subset S4 (res-L S4 n4)))))

(setq lemma5  '(all S5 (all S5* (all n5 (-> (subset S5 S5*)
				   (subset (res S5 n5) (res S5* n5)))))))
(setq lemma5-L'(all S5 (all S5* (all n5 (-> (subset S5 S5*)
				   (subset (res-L S5 n5)(res-L S5* n5))))
			    )))
(setq lemma6   '(all S6 (all n11 (all n21 
			    (= (res (res S6 n11) n21) (res S6 (+ n11 n21)))))))
(setq lemma6-L '(all S6 (all n11 (all n21 
			    (= (res-L (res-L S6 n11) n21) (res-L S6 (+ n11 n21)))))))

;;--- 4444444444444444444444444444444444444444444
(defun p4 () (time (pc-start H-Ex4 Thm-Ex4 Plan-ex4 
                        'pbr-mode nil lemmas-ex4* gclr-theta '(plan-ex4 - 0))))
                                     ;11Aug93  Lemmas-ex4* put as an argument
(defun pp4 () (lpc) (lpLe) (untrace)
     (trace (pc :entry `(pc ,(cadr  si::arglist)))  ;prints only theorem
	    (pcn     :entry `(pcn ,(cadr si::arglist))) ;prints only F
	    (otter-prove  :entry `(otter-prove ,(car si::arglist)))
		)
     (time (p4)) )

(setq lemmas-ex4 '(lemma0 lemma1 lemma2 Lemma3 lemma4 lemma5 lemma6 d10* d12*))
(setq lemmas-ex4* 
 (append '((all x (<= x x))  (all y (= y y))
	   (all S11 (-> (& (clauses S11) (finite S11)) (e (exl S11) w)))
	   (all C* (-> (nu C*) (some L* (e L* C*)))))
	 (mapcar #'eval lemmas-ex4)))
(setq H-Ex4 nil)

(setq thm-Ex4 '(-> (& (clauses S) (fnt S) (unsat S) (< 0 (Exl S))
		      (not (e [] S))                             
		      (all S* (-> (& (clauses S*) (fnt S*) (unsat S*)
				     (< (Exl S*) (Exl S)))
				  (some n* (e [] (res S* n*))))))
		   (some n (e [] (res S n)))))

;;4Aug93  The lemmas shown in each step are not needed there, they are
;;        all included in H-ex4.  (But we can see where they are needed.)
;;7Aug93  When the lemmas-slot shows 'st, it means use STRUVE, else OTTER

(setq PLAN-ex4 '(                                                  ;43.8 secs
 ((some C (& (e C S) (nu C)))                          ttt nil (lemma2))
 ((some L (e L C))                                     ttt nil (lemma2))
 ((& (= C1 (~ C (sng L))) (= C2 (sng L)) (= S1 (U (~ S (sng C)) (sng C1)))
      (= S2 (U (~ S (sng C)) (sng C2))))               nil Let    nil)
 ((some n1 (e [] (res S1 n1)))                         ttt PLAN-44 nil)
 ((some n2 (e [] (res S2 n2)))                         ttt PLAN-45 nil)
 ((or (e [] (res S n1)) (e (sng L) (res S n1)))        ttt PLAN-46 (Lemma1))
 ((-> (e (sng L) (res S n1)) (e [] (res S (+ n1 n2)))) ttt PLAN-47 (lemma6))
 ((some n (e [] (res S n)))                            ttt nil nil) ))

(setq PLAN-44 '(                                            ;19Aug93
 ((subsumes S1 S)                      ttt nil st)          ;(d10)
 ((& (clauses S1) (fnt S1) (unsat S1)) ttt nil nil)         ;(lemma0)
 ((subset* C1 C)                       ttt nil st)
 ((< (Exl S1) (Exl S))                 ttt nil nil)         ;(lemma3) 
 ((some n1 (e [] (res S1 n1)))         ttt nil nil) ))

(setq PLAN-45 '(
 ((subsumes S2 S)                      ttt nil st)          ;(d10)
 ((& (clauses S2) (fnt S2) (unsat S2)) ttt nil nil)         ;(lemma0)
 ((subset* C2 C)                       ttt nil st)
 ((< (Exl S2) (Exl S))                 ttt nil nil)         ;(lemma3)
 ((some n2 (e [] (res S2 n2)))         ttt nil nil) ))


(setq PLAN-46 '(
 ((= S (U (~ S (sng C)) (sng (U C1 (sng L)))))  ttt nil st)
 ((or (e [] (res S n1)) (e (sng L) (res S n1))) ttt nil nil)      ;Lemma1
  ))

(setq PLAN-47 '(
 ((-> (e (sng L) (res S n1)) (subset S2 (res S n1)))   ttt nil st) ;lemma4
 ((-> (e (sng L) (res S n1)) (subset (res S2 n2) (res (res S n1) n2))) 
                                                       ttt nil st) ;lemma5
 ((-> (e (sng L) (res S n1)) (e [] (res S (+ n1 n2)))) ttt nil st) ;lemma6
 ))
 
;;4L4L4L4L4L4L4L4L4L4L4L4L4L4L4L4L4L4L4L4L4L4L4L4L4L
;;44444444444444444444LLLLLLLLLLLLLLLLLLLLLLLLLLLLL
(defun p4L () (time (pc-start H-Ex4L Thm-Ex4L Plan-ex4L 
                     'pbr-mode nil Lemmas-ex4L* gclr-theta '(plan-ex4L - 0))))
                             ;11Aug93  Lemmas-ex4L* put in as an argument
(defun pp4L () (lpc) (lpLe) (untrace)
     (trace (pc :entry `(pc ,(cadr  si::arglist)))  ;prints only theorem
	    (pcn     :entry `(pcn ,(cadr si::arglist))) ;prints only F
	    (otter-prove-start   :entry `(otter-prove-start  ,(car si::arglist)
							     ))
	    (struve-prove-start  :entry `(struve-prove-start ,(cadr si::arglist
								    )))
	    (pci-start  :entry `(struve-prove-start ,(cadr si::arglist )))
		)
     (time (p4L)) )
(defun tr () (trace pcn struve-prove-start struve-prove otter-prove-start
		    otter-prove))

(setq lemmas-ex4L '(lemma0-L lemma1-L lemma2-L Lemma3 lemma4-L lemma5-L
			     lemma6-L d10* d12*))
(setq lemmas-ex4L* 
 (append (mapcar #'eval lemmas-ex4L)
	 '((all x (<= x x))  (all y (= y y))
	   (all S11 (-> (& (clauses-L S11) (finite S11)) (e (exl S11) w)))
	   (all C* (-> (nu C*) (some L* (e L* C*)))))))
(setq H-Ex4L nil)

(setq thm-Ex4L '(-> (& (clauses-L S) (fnt S) (unsat-L S) (< 0 (Exl S))
		      (not (e [] S))
		      (all S* (-> (& (clauses-L S*) (fnt S*) (unsat-L S*)
				     (< (Exl S*) (Exl S)))
				  (some n* (e [] (res-L S* n*))))))
		   (some n (e [] (res-L S n)))))

(setq PLAN-ex4L '(                                                  
 ((some C (& (e C S) (nu C)))                              ttt nil (3 300))
 ((some L (e L C))                                         ttt nil (3 3))
 ((& (= C1 (~ C (sng L))) (= C2 (sng L)) (= S1 (U (~ S (sng C)) (sng C1)))
      (= S2 (U (~ S (sng C)) (sng C2))))                   ttt Let    nil)
 ((some n1 (e [] (res-L S1 n1)))                           ttt PLAN-44L nil)
 ((some n2 (e [] (res-L S2 n2)))                           ttt PLAN-45L nil)

 ((or (e [] (res-L S n1)) (e (sng L) (res-L S n1)))        ttt PLAN-46L nil)
                                                                 ;(Lemma1-L)
 ((-> (e (sng L) (res-L S n1)) (e [] (res-L S (+ n1 n2)))) ttt PLAN-47L 
                                                                    (lemma6-L))
 ((some n (e [] (res-L S n)))                              ttt nil nil) ))

(setq PLAN-44L '(                                           ;20Aug93
 ((subsumes S1 S)                          ttt nil st)      ;(d10)
 ((& (clauses-L S1) (fnt S1) (unsat-L S1)) ttt nil nil)     ;(lemma0-L)
 ((subset* C1 C)                           ttt nil st)      
 ((< (Exl S1) (Exl S))                     ttt nil nil)     ;(lemma3) 
 ((some n1 (e [] (res-L S1 n1)))           ttt nil nil) ))

(setq PLAN-45L '(
 ((subsumes S2 S)                          ttt nil st)      ;(d10)
 ((& (clauses-L S2) (fnt S2) (unsat-L S2)) ttt nil nil)     ;(lemma0-L)
 ((subset* C2 C)                           ttt nil st)
 ((< (Exl S2) (Exl S))                     ttt nil nil)     ;(lemma3)
 ((some n2 (e [] (res-L S2 n2)))           ttt nil nil) ))


(setq PLAN-46L '(
;; ((all x (-> (= x C) (e x S)))                      nil nil st) ;1Sep93 readded
;; ((all x (& (-> (e x (U (~ S (sng C)) (sng (U C1 (sng L))))) (e x S))
;;	    (-> (e x S) (e x (U (~ S (sng C)) (sng (U C1 (sng L)))))) ))
;;                                                    nil nil st) ;1Sep93 readded
 ((= S (U (~ S (sng C)) (sng (U C1 (sng L)))))      ttt nil st)
 ((or (e [] (res-L S n1)) (e (sng L) (res-L S n1))) ttt nil 3 )  ;Lemma1-L
))                                                            

(setq PLAN-47L '(
 ((-> (e (sng L) (res-L S n1)) (subset S2 (res-L S n1)))   ttt nil st);lemma4-L
 ((-> (e (sng L) (res-L S n1)) (subset (res-L S2 n2) (res-L (res-L S n1) n2))) 
                                                           nil nil st);lemma5-L
 ((-> (e (sng L) (res-L S n1)) (e [] (res-L S (+ n1 n2)))) ttt nil st);lemma6-L
 ))

;;(setq Ex4-theta '((res . res-L) (clauses . clauses-L ) (unsat . unsat-L)))

;;-----------------------------------------------------------------------------


(setq GCLR-theta 
'((gc . (lambda (S k)
	         (-> (& (e k w) (clauses-L S) (ground S) 
			(finite S) (unsat-L S) (<= (exl S) k))
		     (SOME n (& (e n w) (e [] (res-L S n))))))) 20

  (H  . (lambda S (& (clauses-L S) (ground S) (finite S) (unsat-L S)))) 22
  (H2 . (lambda (S C L C1- C2- S1- S2-) 
    (& (clauses-L S) (ground S) (unsat-L S) (finite S) (not (e [] S))
       (clause-L C) (literal-L L) (e C S) (nu C) (e L C) 
       (= C1- (~ C (sng L))) (= C2- (sng L)) 
       (= S1- (U (~ S (sng C)) (sng C1-)))
       (= S2- (U (~ S (sng C)) (sng C2-)))))) 23
   (lm1 . (lambda (R k) (-> (& (e k w) (e R (res-L S1 k)))
	    (or (e R (res-L S k)) (e (U R (sng L)) (res-L S k)))))) 24
	      (cck . (lambda (R S k L) 
	  (or (e R (res-L S (+ k 1))) (e (U R (sng L)) (res-L S (+ k 1)))))) 25
	  ))
;;The integers above are for uniquely indexing the variables.


;;                 RESOLUTION LEMMAS AND AXIOMS                  
(setq induction-axiom-gcL
      '(all S-i (-> (& (gc S-i 0) 
		       (all k-i* (-> (& (e k-i* w) (all S-i* (gc S-i* k-i*)))
				     (gc S-i (+ k-i* 1)))))
		    (all k-i (gc S-i k-i)))))
(setq induction-axiom-lm1
      '(all R-i (-> (& (lm1 R-i 0) 
		       (all k-i* (-> (& (e k-i* w) (all R-i* (lm1 R-i* k-i*)))
				     (lm1 R-i (+ k-i* 1))))) 
		    (all k-i (lm1 R-i k-i)))))

(setq L<= '(all x (-> (& (e x w) (<= x 0)) (= x 0))))
(setq L=  '(all y (= y y)))

(setq R0 '(all S (= (res-L S 0) S)))

(setq R1 '(all S (-> (& (clauses-L S) (unsat-L S) (= (exl S) 0))
		     (e [] (res-L S 1)))))
(setq R2 '(all S (-> (& (clauses-L S)(finite S)) (e (exl S) w))))

(setq R3 '(all S (-> (& (clauses-L S) (finite S) (not (e [] S)) 
			(< 0 (exl S)))
		     (some C (& (e C S) (clause-L C) (nu C))))))
(setq R4 '(all C (-> (& (clause-L C) (nu C)) 
		     (some L (some L1 (& (e L C) (literal-L L) (e L1 C) (literal-L L1) 
					 (not (= L L1))))))))

(setq R5
      '(all S (-> (& (clauses-L S) (finite S) (not (e [] S)) (< 0 (exl S)))
		  (some C (& (e C S) (clause-L C) (nu C)
    (some L (some L1 (& (e L  C) (literal-L L) 
			(e L1 C) (literal-L L1) (not (= L L1))
			(all C* (all L* (-> (& (e C* S) (nu C*) (e L* C*))
					    (<= (i L*) (i L)))))))))))))

(setq R6 '(all (S C L C1 C2 S1 S2)
	       (-> (H2 S C L C1 C2 S1 S2) 
		   (& (& (H S1) (< (exl S1) (exl S)))
		      (& (H S2) (< (exl S2) (exl S))))) ))
(setq R7 '(All (S1 i j) (= (res-L (res-L S1 i) j) (res-L S1 (+ i j)))))
(setq R8 '(all (S1 S2 i)
	       (-> (subset S1 S2) (subset (res-L S1 i) (res-L S2 i)))))
(setq R9  '(all S (all C (-> (& (clauses-L S) (e C S)) (clause-L  C)))))
(setq R10 '(all C (all L (-> (& (clause-L  C) (e L C)) (literal-L L)))))
(setq R11 '(all S (all k (-> (e k w) (subset S (res-L S k))))))
(setq R12 '(all (S k C L) (-> (& (e C (res-L S k)) (e k w) (< 0 k) (e L C))
			      (some C* (& (e C* S) (nu C*) (e L C*))))))

;;              Definitional Lemmas For Resolution
(setq d1 '(all S (all n (subset S (res-L S n)))))
(setq d2 '(all (S k R) (-> (e R (res-L S (+ k 1)))
			   (or (e R (res-L S k))
			       (e R (resolvents-L (res-L S k)))))))
(setq d21 '(all (S k R) (-> (or (e R (res-L S k))
				(e R (resolvents-L (res-L S k))))
			    (e R (res-L S (+ k 1))))))
(setq d3 '(all S (all R (-> (e R (resolvents-L S))
			    (some (c1 c2 L1 L2) 
				  (& (e c1 S) (e c2 S) (resolvent-L c1 c2 L1 L2 R)))))))
(setq d31 '(all S (all R (-> (some (c1 c2 L1 L2) 
				   (& (e c1 S) (e c2 S) (resolvent-L c1 c2 L1 L2 R)))
			     (e R (resolvents-L S))))))
(setq d4 '(all (C1 C2 L1 L2 R) (-> (resolvent-L C1 C2 L1 L2 R)
				   (& (e L1 C1) (e L2 C2) (negatives-L L1 L2) 
				      (= R (merge-low (U (~ C1 (sng L1)) (~ C2 (sng L2)))))
				      (all L_ (-> (e L_ C1) (<= (i L1) (i L_)))) ;P(C1,L1), P(C2,L2)
				      (all L_ (-> (e L_ C2) (<= (i L2) (i L_)))) ))))

;;Resolvent-L(C1 C2 L1 L2 R) 
;; = (L1 e C1 & L2 e C2 & negatives-L(L1,L2) & R = merge-low(C1~{L1} U C2~{L2})
;;                      & P(C1,L1) & P(C2,L2)),
;;    where  P(C,L) = ALL L'(L' e C -> i(L) <= i(L')).

(setq d41 '(all (C1 C2 L1 L2 R) 
		(-> (& (e L1 C1) (e L2 C2) (negatives-L L1 L2) 
		       (= R (merge-low (U (~ C1 (sng L1)) (~ C2 (sng L2)))))
	  (all L1_ (-> (e L1_ C1) (<= (i L1) (i L1_))))            
	  (all L2_ (-> (e L2_ C2) (<= (i L2) (i L2_)))) 
	  ) 
       (resolvent-L C1 C2 L1 L2 R))))

(setq d5 '(ALL A (ALL B (-> (all x (-> (e x A) (e x B))) (subset A B)))))

(setq d6 '(ALL L (ALL C (-> (e L (merge-low C))
    (& (e L C) (ALL L_ (-> (& (e L_ C) (= (lit L_) (lit L)))
			   (<= (i L) (i L_)))))))))

;; L e merge-low(C)         L e C  &  ALL L'(L'e C & lit(L') = lit(L)
;;                                             --> i(L) <= i(L'))

(setq d61 '(ALL L (ALL C 
    (-> (& (e L C) (ALL L_ (-> (& (e L_ C) (= (lit L_) (lit L)))
			   (<= (i L) (i L_)))))
	(e L (merge-low C)) ))))


;;                 Set-theory Lemmas
(setq s1 '(all A (= (U [] A) A)))
(setq s2 '(all x (all A (all B (-> (& (e x A) (= A B)) (e x B))))))
(setq s3 '(all (S S2 C C2 A) 
    (-> (& (= S2 (U (~ S (sng C)) (sng C2))) (e C2 A) (subset S A))
	(subset S2 A))))
(setq s4 '(all x (all A (all B (-> (& (e x A) (subset A B)) (e x B))))))
(setq s5 '(all L (all C (all C1 (-> (& (e L C) (= C1 (~ C (sng L))))
				    (= C (U C1 (sng L))))))))
(setq s6 '(all (S C C1 R) (-> (& (e R (U (~ S (sng C)) (sng C1)))
				 (not (= R C1)))
			      (e R S))))
(setq s7 '(all (R R* L C1 C2 L1 L2) 
    (-> (& (= R  (merge-low (U (~ C1 (sng L1)) (~ C2 (sng L2)))))
	   (= R* (merge-low (U (~ C1 (sng L1)) (~ (U C2 (sng L)) (sng L2)))))
	   (subset R R*))              ;How can we justify adding this lemma?
	(or (= R* R) (= R* (U R (sng L)))))))
(setq s8 '(all x (all A (all B (-> (e x A) (e x (U A B)))))))
(setq s9 '(all (x L C1 C2 L1 L2) 
               (-> (e x (U (~ C1 (sng L1)) (~ C2 (sng L2))))
		   (e x (U (~ C1 (sng L1)) (~ (U C2 (sng L)) (sng L2)))))))
(setq s91 '(all (x L C1 C2 L1 L2) 
               (-> (e x (U (~ C1 (sng L1)) (~ (U C2 (sng L)) (sng L2))))
		   (or (e x (U (~ C1 (sng L1)) (~ C2 (sng L2)))) (= x L)))))
(setq s10 '(all z (-> (e z w) (or (= z 0) (< 0 z)))))
(setq s11 '(all a (all b (or (not (< b a)) (not (<= a b))))))
(setq s12 '(all a (all b (or (< b a) (<= a b)))))
(setq s13 '(& (e 0 w) (e 1 w)))
(setq s14 '(all x (all y (-> (& (e x w) (e y w)) (e (+ x y) w)))))
(setq s15 '(all A (all B (all C (-> (& (subset A B) (subset B C)) 
				    (subset A C))))))
(setq s16 '(ALL (S S1 C C1) (-> (& (= S1 (U (~ S (sng C)) (sng C1))) (e C1 S))
				(subset S1 S))))
(setq s17 '(ALL (S S1 C C1 R) (-> (& (= S1 (U (~ S (sng C)) (sng C1))) 
				     (e R S1))
				  (or (e R S) (= R C)))))
(setq s18 '(all (C1 C2 L1 L2 x) 
           (-> (e x (U (~ C1 (sng L1)) (~ C2 (sng L2))))
	       (or (& (e x C1) (not (= x L1))) (& (e x C2) (not (= x L2)))))))

(setq s19 '(all C (all D (all y (-> (e y C) (e y (U C D)))))))
(setq s20 '(all C (all D        (-> (nu C) (nu (U C D))))))
(setq s21 '(all (C L x) (-> (e x (U C (sng L))) (or (e x C) (= x L)))))
(setq s22 '(all (C L1 L2) (-> (& (e L1 C) (e L2 C) (not (= L1 L2))) (nu C))))
(setq s23 '(all (C L) (e L (U C (sng L)))))
(setq s24 '(all (C L) (-> (e L C) (= C (U C (sng L))))))
(setq s25 '(all (x A B) (-> (e x (U A B)) (or (e x A) (e x B)))))
(setq s26 '(all (x A B) (-> (or (e x A) (e x B)) (e x (U A B)))))
(setq s27 '(all (x y A) (-> (& (e x A) (y e A) (not (nu A))) (= x y))))
;; See examples-pbrL.lisp for PLANs, etc for GCLR

;;1Sep93 Set-theory-axioms
(setq Lsn1 '(all x (all y (-> (e x (sng y)) (= x y)))))
(setq Lsn2 '(all x (all y (-> (= x y) (e x (sng y))))))
(setq L^1  '(all A (all B (all x (-> (e x (intersection A B)) 
				     (& (e x A) (e x B)))))))
(setq L^2  '(all A (all B (all x (-> (& (e x A) (e x B)) 
				     (e x (intersection A B)))))))
(setq LU1  '(all A (all B (all x (-> (e x (U A B)) 
				     (or (e x A) (e x B)))))))
(setq LU2  '(all A (all B (all x (-> (or (e x A) (e x B)) 
				     (e x (U A B)))))))
(setq L~1  '(all A (all B (all x (-> (e x (~ A B)) 
				     (& (e x A) (not (e x B))))))))
(setq L~2  '(all A (all B (all x (-> (& (e x A) (not (e x B))) 
				     (e x (~ A B)))))))
(setq Lsu1  '(all A (all B (-> (subset A B) (all x (-> (e x A) (e x B)))))))
(setq Lsu2  '(all A (all B (-> (all x (-> (e x A) (e x B))) (subset A B)))))
(setq Lsb   '(all A (all B (-> (& (subset A B) (subset B A)) (= A B)))))
(setq L==   '(all A (all B (-> (= A B) (= B A)))))
(setq L=    '(all y (= y y)))
(setq set-theory-lemmas (list '& Lsn1 Lsn2 L^1 L^2 LU1 LU2 L~1 L~2 Lsu1 Lsu2
			         Lsb L= L==))
;;-------------------------------------------------------------------------
(defun ret () (untrace)                   ;retrace
     (trace (pc :entry `(pc ,(cadr  si::arglist)))  ;prints only theorem
	    (pcn     :entry `(pcn ,(cadr si::arglist))) ;prints only F
	    (otter-prove  :entry `(otter-prove ,(car si::arglist)))
		))



