
;;           experiments-hl.lisp                       13Sept94

;; See  high-low.lisp                           

;;This file is only in support of high-low.lisp, 
;; to carry out experiments using large example FOL theorems,
;; using lemmas from example-theorems.lisp  

(defun lehl () (load "experiments-hl.lisp"))

(defun tre () (untrace) (trace prove-hl hl bcc-hl bch-hl bch bcl))
(defun trg () (untrace) (trace prove-hl hlg hlgl bcc-hl))

(defun trer () (untrace) 
               (trace (hl  :entry `(hl ,(cadr  si::arglist)))  ;prints C only
		      (bcc-hl :entry `(bcc-hl ,(cadr si::arglist))) 
		      (bch-hl :entry `(bch-hl ,(cadr  si::arglist)))  
		      (bch :entry `(bch ,(cadr  si::arglist)))  ;prints C only
		      (bcl :entry `(bcl ,(cadr  si::arglist)))  ;prints C only
		      ))

;;1
(and (setq thm1 '(Q b))
     (setq H1 '(P b))
     (setq lammas1 '((all x (-> (P x) (Q x)))))
     (defun p1 () (time (prove-HL thm1 H1 lammas1))))

;;1*
(and (setq thm1* '(R b))
     (setq H1* '(P b))
     (setq lammas1* '((all x (-> (P x) (Q x))) (all x (-> (Q x) (R x)))))
     (defun p1* () (time (prove-HL thm1* H1* lammas1*))))

;;2
(and (setq thm2 (caddr ex81))
     (setq lemmas2 (list ex125))
     (setq H2 (cadr ex81))
     (defun p2 () (time (prove-HL thm2 H2 lemmas2))))

;;2* 
(and (setq thm2* (caddr ex81))
     (setq lemmas2* (list ex125))
     (setq H2* '(& (CLSD-REC D)
		  (NOT (SOME H7 (& (SUBSET H7 G0) (FINITE H7) 
				   (SUBSET D (@ H7)))))
		  (<<= (LF D) (RT D)) (<<= (BOT D) (TOP D))))
     (defun p2* () (time (prove-HL thm2* H2* lemmas2*))))

;;3
(and (setq thm3 (caddr ex81))
     (setq lemmas3 '(exs-from-to 111 126))
     (setq H3 (cadr ex81))
     (defun p3 () (time (prove-HL thm3 H3 lemmas3))))

;;3* 
(and (setq thm3* (caddr ex81))
     (setq lemmas3* '(exs-from-to 111 126))
     (setq H3* '(& (CLSD-REC D)
		  (NOT (SOME H7 (& (SUBSET H7 G0) (FINITE H7) 
				   (SUBSET D (@ H7)))))
		  (<<= (LF D) (RT D)) (<<= (BOT D) (TOP D))))
     (defun p3* () (time (prove-HL thm3* H3* lemmas3*))))

;;4
(and (setq thm4 (caddr ex81))
       (setq lemmas4 '(exs-from-to 1 10 101 126))
       (setq H4 (cadr ex81))
       (defun p4 () (time (prove-HL thm4 H4 lemmas4))))

;;4* 
(and (setq thm4* (caddr ex81))
     (setq lemmas4* '(exs-from-to 1 10 101 126))
     (setq H4* '(& (CLSD-REC D)
		  (NOT (SOME H7 (& (SUBSET H7 G0) (FINITE H7) 
				   (SUBSET D (@ H7)))))
		  (<<= (LF D) (RT D)) (<<= (BOT D) (TOP D))))
     (defun p4* () (time (prove-HL thm4* H4* lemmas4*))))

;;5
(and (setq thm5 (caddr ex81))
       (setq lemmas5 '(exs-from-to 82 136))
       (setq H5 (cadr ex81))
       (defun p5 () (time (prove-HL thm5 H5 lemmas5))))

;;5* 
(and (setq thm5* (caddr ex81))
     (setq lemmas5* '(exs-from-to 82 136))
     (setq H5* '(& (CLSD-REC D)
		  (NOT (SOME H7 (& (SUBSET H7 G0) (FINITE H7) 
				   (SUBSET D (@ H7)))))
		  (<<= (LF D) (RT D)) (<<= (BOT D) (TOP D))))
     (defun p5* () (time (prove-HL thm5* H5* lemmas5*))))

;;6
(and (setq thm6 (caddr ex81))  ;< 2min via grind-version of High-low
       (setq lemmas6 '(exs-from-to 1 30 82 136))
       (setq H6 (cadr ex81))
       (defun p6 () (time (prove-HL thm6 H6 lemmas6))))

;;6* 
(and (setq thm6* (caddr ex81))
     (setq lemmas6* '(exs-from-to 1 30 82 136))
     (setq H6* '(& (CLSD-REC D)
		  (NOT (SOME H7 (& (SUBSET H7 G0) (FINITE H7) 
				   (SUBSET D (@ H7)))))
		  (<<= (LF D) (RT D)) (<<= (BOT D) (TOP D))))
     (defun p6* () (time (prove-HL thm6* H6* lemmas6*))))

;;7
(and (setq thm7 (caddr ex81))  ;< 6min via grind-version of High-low
       (setq lemmas7 '(exs-from-to 1 30 82 136))  ;592 Lemmas
       (setq H7 (cadr ex81))
       (defun p7 () (time (prove-HL thm7 H7 lemmas7 10 ex125))))
        ;;The 10 here means duplicate the lemmas 10 times                    
        ;;There are 591 lemmas here, the used one is last. 

;;7* 
(and (setq thm7* (caddr ex81))
     (setq lemmas7* '(exs-from-to 1 30 82 136))  ;592 Lemmas
     (setq H7* '(& (CLSD-REC D)
		  (NOT (SOME H7 (& (SUBSET H7 G0) (FINITE H7) 
				   (SUBSET D (@ H7)))))
		  (<<= (LF D) (RT D)) (<<= (BOT D) (TOP D))))
     (defun p7* () (time (prove-HL thm7* H7* lemmas7* 10 ex125))))

;;8 
(and (setq thm8 '(some x (& (P x) (Q x))))
     (setq lemmas8 '((all x (-> (P x) (Q x)))))
     (setq H8 '(& (P a) (Q b)))
     (defun p8 () (time (prove-HL thm8 H8 lemmas8))))

;;8* 
(and (setq thm8* '(some x (& (P x) (Q x))))
     (setq lemmas8* '((all x (-> (& (P x) (Q x) (R1 x)) (Q1 x)))
		      (all x (-> (& (P x) (Q x) (R2 x)) (Q2 x)))
		      (all x (-> (& (P x) (Q x) (R3 x)) (Q3 x)))
		      (all x (-> (& (P x) (Q x) (R4 x)) (Q4 x)))
		      (all x (-> (& (P x) (Q x) (R5 x)) (Q5 x)))
		      (all x (-> (P x) (& (Q x) (R6 x) (R7 x))))))
     (setq H8* '(& (P a) (Q b)))
     (defun p8* () (time (prove-HL thm8* H8* lemmas8*))))


;;8* 
(and (setq thm8* '(some x (& (P x) (Q x))))
     (setq lemmas8* '((all x (-> (& (P x) (R1 x)) (Q x)))
		      (all x (-> (& (P x) (R2 x)) (Q x)))
		      (all x (-> (& (P x) (R3 x)) (Q x)))
		      (all x (-> (& (P x) (R4 x)) (Q x)))
		      (all x (-> (& (P x) (R5 x)) (Q x)))
		      (all x (-> (P x) (& (Q x) (R6 x) (R7 x))))))
     (setq H8* '(& (P a) (Q b)))
     (defun p8* () (time (prove-HL thm8* H8* lemmas8*))))

