
;;                ground-resolution.lisp                 21Sept94


(defvar *nm* nil)
(defvar *theta* nil)

(defun lgr () (load "ground-resolution.lisp"))


(defun ground-resolution (thm)  ;21Sept94
  (let (S)
    (setq S (clausify-gr thm))
    (gr S)))

(defun gr (S &optional (S* S))
  (let (RR S2)
    (cond ((eq '[] (setq RR (cond (*grind*-version* (gr2* S S*))
				  (t                (gr2  S S*))))) '[])
	  ((null RR) S)
	  ((and (setq S2 (crunch-hl (subsume-gr RR S))) nil))
	  (t (gr (union-w S2 RR) RR)) )))

(defun gr2 (S S*)
  (let (y C2 C2* RR)
    (setq RR (mapcan #'(lambda (C*) (mapcan #'(lambda (x*) 
	(setq y (not-fcn x*))
	(setq C2* (remove x* C* :test 'equal))
	(mapcan #'(lambda (C) 
	    (cond ((equal C (setq C2 (remove y C :test 'equal))) nil)
		  ((null (setq R (union-w C2 C2*))) (return-from gr2 '[]))
		  ((gtaut R) nil)
		  (t (list R))))
		S))
					    C*))
		     S*))
    (crunch-hl RR)))

(defun gr2* (S S*)
  (let (y C2 C2* RR)
    (setq RR (mapcan #'(lambda (C*) (mapcan #'(lambda (x*) 
	(setq y (not-fcn x*))
	(setq C2* (remove x* C* :test 'equal))
	(mapcan #'(lambda (C) 
	    (cond ((equal C (setq C2 (remove y C :test 'equal*))) nil)
		  ((null (setq R (union-w C2 C2*))) (return-from gr2* '[]))
		  ((gtaut R) nil)
		  (t (list R))))
		S))
					    C*))
		     S*))
    (crunch-hl RR)))



(defun clausify-gr (thm &optional par)
  (let (A)
    (cond ((null thm) (return-from clausify-gr (cond (par t) (t nil)))))
    (cond ((not *grind*-version*) (setq A (fol->ground A))))
    (setq A (convert-implication-signs (cond (par thm) (t (list 'not thm)))))
    (setq A (push-nots-in A))
    (cond (*grind*-version* (setq A (remove-somes-alls A))))
    (setq A (cnf A))  
    (setq A (remove-&&-or-signs A))))

(defun clausify-matrix (thm &optional par) ;26Sept94
  (setq thm (cond (par thm) (t (not-fcn2 thm))))
  (setq thm (convert->2 thm))
  (setq thm (push-nots-in thm))
  (setq thm (remove-somes-alls thm))
  (setq thm (reduce&or thm)))

(defun cdr2 (S) (cons (car S) (cddr S)))  ;26Sept94

(defun cons2 (x L) (cons (car L) (cons x (cddr L))))  ;26Sept94

(defun convert->2 (A) ;26Sept94
  (cond ((atom A) A)
	((eq-car A '->) 
	 (list 'or (list 'not (convert->2 (cadr A))) 
	           (convert->2 (caddr A))))
	((member (car A) '(& or not some all))
	 (cons (car A) (mapcar #'convert->2 (cdr A))))
	(t A)))

(defun fol->ground (A)
  (cond ((atom A) A)
	((member (car A) '(all some))
	 (fol->ground (caddr A)))
	((member (car A) '(-> & or not))
	 (cons (car A) (crunch-hl (mapcar #'fol->ground (cdr A)))))
	(t (car A)) ))
  
(defun gtaut (R) 
  (cond ((null (cdr R)) nil)
	((member (not-fcn (car R)) (cdr R) :test 'equal) t)
	(t (gtaut (cdr R))) ))

(defun grind (HS CS) 
  (let (ans)
    (cond ((or (eq '[] HS) (eq '[] CS)) '[])
	  ((eq '[] (setq ans (gr (union-w HS CS) CS))) '[])
	  (t (subsume-gr ans CS)))))

(defun grind-matrix (HS CS &optional par)   ;26Sept94
  (let (ans)
    (cond ((or (eq '[] HS) (eq '[] CS)) '[])
	  ((eq-car (setq ans (matrix (and-on CS HS) par)) '[]) '[])
	  (t (cadr ans)) )))

(defun Lxs (lem)
  (let (LS atoms y C2 CC)
    (setq LS (clausify-gr lem t))
    (setq atoms (atoms-in LS))
    (mapcan #'(lambda (x) (setq y (not-fcn x))
        (setq CC (mapcan #'(lambda (C) 
            (cond ((equal C (setq C2 (remove y C :test 'equal))) nil)
		  (t (list C2))))
			 LS))
	(cond (CC (list (list x CC)))))
	    atoms) ))

(defun literal (A) 
   (cond ((atom A) t)
	 ((eq-car A 'not) (literal (cadr A)))
	 ((member (car A) '(& or -> some all)) nil)
	 (t t)))

(defun literals-in (S)  ;28Sept94  S is a set of clauses
  ;;for maxtrix-type clause-sets
  (cond ((null S) nil)
	((literal S) (list S))
	((member (car S) '(& or))
	 (mapcan #'literals-in (cdr S)))
	(t S)))

(defun matrix (S par)                ;26Sept94
  (let (ans)
    (setq *nm* 0)
    (setq *theta* nil)
    (setq ans (mtx S nil par))
    (list ans *nm*)))

(defun mtx (S &optional LL par)      ;26Sept94
  (let (L1 C1 C1* S* S2)
    (cond ((null S) nil) 
	  ((eq-car S '&)
	   (cond ((null (cdr S)) nil)
		 ((literal (setq L1 (cadr S)))
		  (cond ((member L1 LL :test (cond (par 'equal) (t 'equal*)))
			 '[])
			((eq '[] (mtx (cdr2 S) (cons (not-fcn L1) LL) par))
			 '[])
			(t S)))
		 ((eq-car (setq C1 (cadr S)) '&) 
		  (setq S2 (cons '& (append (cdr C1) (cddr S))))
		  (mtx S2 LL par))
  		 ((eq-car (setq C1 (cadr S)) 'or)
		  (setq C1* (mapcan #'(lambda (x) 
                                  (cond ((eq '[] (mtx (cons2 x S) LL par)) nil)
					(t (list x))))
				    (cdr C1)))
                  (cond ((null C1*) '[])
			(t (setq C1* (orify C1*))
			   (subst C1* C1 S))))
		 (t '[])))
	  ((eq-car S 'or)
	   (cond ((null (setq S* (mapcan #'(lambda (C)
                                       (cond ((eq '[] (mtx C LL par)) nil)
					     (t (list C))))
					 (cdr S))))
		  '[])
		 (t (orify S*))))
	  (t (format t "~%Problem~%") (break)) )))

(defun not-fcn2 (A) ;26Sept94
  (cond ((eq-car A '->) (list '& (cadr A) (list 'not (caddr A))))
	(t (list 'not A))))

(defun push-some-alls-in (A)    ;not used 24Sept94
  ;;Not legal fol change, but used by SKOLEMIZE-HL
  ;;Assume that A has no -> signs, and that all NOT's have been pushed in
  ;;Ie, (push-some-alls-in '(some x (& (P x y) (not (Q x)) (R z))))
  ;;  =    (& (some x (P x y)) (some x (not (Q x))) (some x (R z)))
  (let (A*)
    (cond ((atom A) A)
	  ((eq 'not (car A)) A)
	  ((and (member (car A) '(some all)) (member (cadr A) *V*))
	   (push-some-alls-in (caddr A)))
	  ((member (car A) '(some all))
	   (setq A* (push-some-alls-in (caddr A)))
	   (setq A (list (car A) (cadr A) A*))
	   (cond ((atom A*) A)
		 ((member (car A*) '(some all)) A)
		 ((eq-car A* 'not) A)
		 ((member (car A*) '(& or))
		  (cons (car A*) (mapcar #'(lambda (u) 
                            (push-some-alls-in (list (car A) (cadr A) u)))
					 (cdr A*))))
		 (t A)))
	  ((member (car A) '(& or)) 
	   (cons (car A) (mapcar #'push-some-alls-in (cdr A))))
	  (t A) )))

(defun remove-somes-alls (A)    ;24Sept94
  ;;Assume that A has no -> signs, and that all NOT's have been pushed in
  ;;Ie, (remove-somes-alls '(some x (& (P x y) (not (Q x)) (R z))))
  ;;                    =          (& (P x y) (not (Q x)) (R z))
  (let (A*)
    (cond ((atom A) A)
	  ((eq 'not (car A)) A)
	  ((member (car A) '(some all)) (remove-somes-alls (caddr A)))
	  ((member (car A) '(& or)) 
	   (cons (car A) (mapcar #'remove-somes-alls (cdr A))))
	  (t A) )))
    
(defun subsume-gr (RR S)
  (mapcar #'(lambda (C) 
               (cond ((some #'(lambda (R) (and (subset R C) (setq R2 R)))
			    RR)
		      R2)
		     (t C)))
	  S))
