
;;                    hb-data.lisp                                5Dec94
;;
;; Used by reformulate.lisp to apply the add-argument rules

(defun lhd () (load "hb-data.lisp"))

(setq hb1 
'(-> (& (e a R) (e b R) (<= a b) (all O (-> (e O G) (open O)))
	(subset (nt a b) (u G)))
     (some H (& (subset H G) (finite H) (subset (nt a b) (u H))))))

;;-------------------------------------------------------------
(setq Definitions '(DEL TH not-TH P Q F1 F2 F3 F4 indhyp)) ;abbreviations

(setq DEL 
'(& (e a R) (e b R) (<= a b) (all O (-> (e O G0) (open O)))
    (subset (nt a b) (@ G0))))

(setq TH
'(SOME H (& (subset H G0) (finite H) (subset (nt a b) (@ H)))))

(setq not-TH 
'(not (SOME H (& (subset H G0) (finite H) (subset (nt a b) (@ H))))))

(setq P 
'(lambda (D) (& (clsd-int D)	
		(not (some H (& (subset H G0) (finite H) (subset D (@ H)))))
		(<= (lf D) (rt D)) )))
(setq Q
'(lambda (D D*) (& (subset D* D) (= (length D*) (/ (length D) 2)))))

(setq F1 
'(& (= (g 0) (nt a b))
    (all i (-> (e i omega)            
	       (& (clsd-int (g i)) (subset (g (+ i 1)) (g i)) 
		  (= (length (g i)) (/ (length (nt a b)) (exp 2 i)))
		  (not (some H (& (subset H G0) (finite H)       
				  (subset (g i)(@ H)))))
		  (<= (lf (g i)) (rt (g i))) )))))
(setq F2 
'(SOME i (SOME H (& (e i omega) (subset H G0) (finite H)                
		    (subset (g i) (@ H))))))

(setq F3 '(& (= (g 0) (nt a b))
	     (all i (& (P (g i)) (Q (g i) (g (+ i 1)))))))

(setq F4 '(P (nt a b)))

(setq indhyp '(-> (e k omega) 
		  (= (length (g k)) (/ (length (nt a b)) (exp 2 k)))))

;;-------------------------------------------------------------------
(setq lemmas '(L1 L2 L3 L4 L5 L6 L7 L8 L9 L10 L11 L12 L13 L14 L15 L16))

(setq L1 '(all x (-> (e x R) (= x (/ x (exp 2 0))))))
(setq L2 '(all x (all y (all d (all n 
                             (-> (& (= x (/ d (exp 2 n))) (= y (/ x 2)))
				 (= y (/ d (exp 2 (+ n 1))))))))))
				        
(setq L3 '(all x (all y (-> (<= x y) (clsd-int (nt x y))))))

(setq L4 '(all x (all  y (-> (<= x y) 
			     (& (= (lf (nt x y)) x) (= (rt (nt x y)) y))))))

(setq L5 '(all D (all G33 
               (-> (& (clsd-int D) 	         
		      (not (some H (& (subset H G33) (finite H) 
				      (subset D (@ H)))))
		      (<= (lf D) (rt D)))
		   (some D* (& (clsd-int D*) 	 
			       (not (some H (& (subset H G33) (finite H) 
						  (subset D* (@ H)))))
			       (<= (lf D*) (rt D*))
			       (subset D* D) 
			       (= (length D*) (/ (length D) 2))))))))

(setq L6 '(all A (all H (all x 
            (-> (& (subset A (@ H)) (e x A)) 
		(some O (& (e O H) (e x O)))) ))) )

(setq L7 '(all x (all O 
            (-> (& (e x O) (open O))
		(some u (some v (& (< u v) (subset (nt u v) O) 
				   (center x (nt u v)))))) )) )

(setq L8 '(all d (all o (-> (& (< 0 d) (<= 0 o))
			        (some i (& (e i omega) 
					   (<= (/ o (exp 2 i)) (/ d 2))))))))

(setq L9 '(all x (all u (all v (all c (all d   ;Erica's version
     (-> (& (e u R) (e v R) (e c R) (e d R) (center x (nt u v)) (e x (nt c d))
	    (<= (length (nt c d)) (/ (length (nt u v)) 2)))
	 (subset (nt c d) (nt u v))) ))))))
(setq L9 '(all x (all u (all v (all c (all d 
                   (-> (& (center x (nt u v)) (e x (nt c d)) 
			  (<= (length (nt c d)) (/ (length (nt u v)) 2)))
		       (subset (nt c d) (nt u v))) ))))) )

(setq L10 '(all O (finite (sng O))))

(setq L11 '(all D2  (-> (clsd-int D2)  (= D2 (nt (lf D2) (rt D2))))))

(setq L12 '(all O (= O (@ (sng O)))))

(setq L13 '(all A (all B (all C (-> (& (subset A B) (subset B C)) 
				     (subset A C))))))

(setq L14 '(all O (all G (-> (e O G) (subset (sng O) G)))))

(setq L15 '(all u (all v (-> (< u v) (< 0 (length (nt u v)))))))

(setq L16 '(all u (all v (-> (<= u v) (& (<= 0 (length (nt u v)))
					 (<= 0 (/ (length (nt u v)) 2)))))))

(setq CIA 
'(-> (& (P (nt a b)) (all D (-> (P D) (some D* (& (P D*) (Q D D*))))))
     (some g (& (= (g 0) (nt a b)) 
		(all i (-> (e i omega) 
			   (& (P (g I)) (Q (g i) (g (+ i 1))))))))))
(setq indax 
'(-> (& (= (length (gi 0)) (/ (length (nt a b)) (exp 2 0)))
	(all k (-> (& (e k omega) 
		      (= (length (g k)) (/ (length (nt a b)) (exp 2 k))))
		   (= (length (g (+ k 1))) 
		      (/ (length (nt a b)) (exp 2 (+ k 1)))))))
     (all i (-> (e i omega)
		(= (length (gi i)) (/ (length (nt a b)) (exp 2 i)))))))

(setq nit1 
'(all n (->  (-> (e n omega) 
		 (& (clsd-int (g n)) (clsd-int (g (+ n 1))) 
		    (subset (g (+ n 1)) (g n))))
	     (some z (all i (-> (e i omega) (e z (g i))))))))


;;-------------------------------------------------------------------------
(setq plans '(plan-indirect-proof plan-0 plan-1 plan-11 plan-111 plan-2))

(setq plan-indirect-proof '(
  (1 (not-TH) not-TH hyp)
  (2 (DEL not-Th) [] plan-o)
  (3 (DEL not-Th) TH ((IP) nil (2))) ))

(setq plan-0 '(
  (1 (DEL not-Th) F1 plan-1)
  (2 (DEL not-Th) (not F2) ((otter) nil (1)))
  (3 (DEL not-Th) F2 plan-2)
  (4 (DEL not-Th) [] (([]I) nil (2 3))) ))

(setq plan-1 '(
  (1 (DEL not-Th) (& (= (g 0) (nt a b))
		     (all i (-> (e i omega) 
				(& (P (g i)) (Q (g i) (g (+ i 1)))))))
     plan-11)
  (2 (DEL not-Th) (= (length (g 0)) (/ (length (nt a b)) (exp 2 0)))
     ((otter) (L17) (1)))
  (3 (DEL not-Th) (all i (-> (& (e i omega) 
				(= (length (g i)) 
				   (/ (length (nt a b)) (exp 2 i))))
			     (= (length (g (+ i 1))) 
				(/ (length (nt a b)) (exp 2 (+ i 1))))))
     ((otter) (L2 L17) (1)))

  (4 (DEL not-Th) (all i (-> (e i omega)
			     (= (length (g i))
				(/ (length (nt a b)) (exp 2 i)))))
     ((otter IA) nil (2 3)))

  (5 (DEL not-Th) F1   ((otter) nil (1 4)))  ))

(setq plan-11 '(
  (1 (DEL not-Th) (P (nt a b))  plan-111)
  (2 (DEL not-Th) (some g (& (= (g 0) (nt a b))
			     (all i (-> (e i omega)                            
					(& (P (g i)) (Q (g i) (g (= i 1))))))))
     ((otter) (CIA) (1)))

  (3 (DEL not-Th) (& (= (g 0) (nt a b))
		     (all i (-> (e i omega)                            
				(& (P (g i)) (Q (g i) (g (= i 1)))))))
     ((SOME-D) nil (2))) ))

(setq plan-111 '(

  (3 (DEL) (clsd-int (nt a b)) (ALL-D) (L3) nil)
  (4 (not-TH) (not (some H (& (subset H G0) (finite H) 
			      (subset (nt a b) (@ H)))))
     hyp)
  (5 (DEL) (<= (lf (nt a b)) (rt (nt a b))) ((otter) (L4) nil))
  (6 (DEL not-TH) (P (nt a b)) ((^I) nil (3 4 5))) ))


(setq plan-2 '(
  (0-1 (DEL) (& (e a R) (e b R) (<= a b))  hyp)
  (0-2 (DEL) (ALL O (-> (e O G) (open O))) hyp)

  (1  (DEL not-Th) F1 plan-1)  
  (2  (DEL not-Th) (SOME z (ALL i (e z (g i)))) ((otter) (nit1) (1)))
  (2a (DEL not-Th) (ALL i (e z (g i)))          ((Some-E) nil (2)))

  (4  (DEL not-Th) (SOME O (& (e O G) (e z O))) ((otter) (L6) ((1 2a 3))))
  (4a (DEL not-Th) (& (e O G) (e z O))          ((some-E) nil (4)))

  (5  (DEL not-Th) (SOME u (SOME v (& (< u v) (subset (nt u v) O)
				      (center z (nt u v)))))
      ((otter) (L7) (4a 0-2)))
  (5a (DEL not-Th)  (& (< u v) (subset (nt u v) O)
		       (center z (nt u v)))     ((some-E) nil (5)))

  (6  (DEL not-Th) (SOME i (& (e i omega) (<= (/ (length (nt a b)) (exp 2 i))  
					      (/ (length (nt u v)) 2))))
      ((otter) (L8 L15 L16) (5a 0-1)))
  (6  (DEL not-Th) (& (e i omega) (<= (/ (length (nt a b)) (exp 2 i))  
				      (/ (length (nt u v)) 2)))
                                                ((some-E) nil (6)))

  (7  (DEL not-Th) (some c1 (some d1 (& (<= c1 d1) (= (g i) (nt c1 d1)))))
      ((otter) (L11) (1 61)))
  (7a (DEL not-Th) (& (<= c1 d1) (= (g i) (nt c1 d1)))
                                                ((some-E) nil (7)))
  (8  (DEL not-Th) (subset (g i) (nt u v)) ((otter) (L9) (1 2a 5a 6a 7a)))
  (9  (DEL not-Th) (subset (g i) (@ (sng O))) ((otter) (L12 L13) (5a 8)))
  (10 (DEL not-Th) F2 ((otter) (L10 L14) (4a 6a 9))) ))

;;---------------------------------------------------------------------
(setq  KB 
'( (definitions 
    ( ((clsd-int A) (some a (some b (& (e a R) (e b R) (= A (nt a b))))))
      ((clsd-rect A) (some a (some b (some c (some d
		       (& (e a R) (e b R) (e c R) (e d R) 
			  (= A (rect a b c d))))))))
      ( etc etc )))

   (types ( ((+ x y) ((e x R) (e y R)))
	    ((- x y) ((e x R) (e y R)))
	    ((* x y) ((e x R) (e y R)))
	    ((/ x y) ((e x R) (e y R)))
	    ((<= x y) ((e x R) (e y R)))
	    ((<  x y) ((e x R) (e y R)))
	    ((exp x n)((e x R) (e n R)))
	    ((nt x y) ((e x R) (e y R)))
	    ((rect x y z w) ((e x R) (e y R) (e z R) (e w R)))
	    ))

   (connections ( (r r2)
		  ((nt x y) (rect x y r s)) 
		  ((clsd-int a) (clsd-rect a))
		  ((open-int a) (open-rect a))
		  ((length a) (diam a))
		  ((center x a) (center x a))
		  ((lf a) (lf a))
		  ((rt a) (rt a))
		  ;; bot top
		  (etc etc)
		  )) ))

;;-----------------------------------------------------------------------
 
(setq s  (cadr (assoc 'connections kb)))

(setq s2 (mapcan #'(lambda (pr)  ;S2= ( ((nt x y) (rect x y r s)) ...)
    (cond ((and (not (atom pr)) (not (atom (car pr)))
		(not (equal (length (cdar pr)) (length (cdadr pr)))))
	   (list pr))))
		 S))


(setq udlm (union definitions lemmas :test 'equal))
(setq udlm (union udlm plans :test 'equal))
(setq S3 (mapcan #'(lambda (pr)  ;S3=( (((nt x y) (rect x y r s)) (lf rt)) ...)
           (mapcan #'(lambda (x) (find-sub-constants-in pr (caar pr) (eval x)))
		   udlm))
		 S2))

(setq S4 '((R R2)))

(defun rt () (add-arg hb1 s s3 s4))

(defun rd () 
  (let (d*)
  (mapc #'(lambda (d) (prnt d) (setq d (eval d)) 
                      (format t "~%~s~%" d)
	              (setq d* (add-arg d s s3 s4))
		      (format t "~%~s~%~%" d*))
	definitions)))

(defun rl () 
  (let (l*)
  (mapc #'(lambda (l) (prnt l) (setq l (eval l)) 
                      (format t "~%~s~%" l)
	              (setq l* (add-arg l s s3 s4))
		      (format t "~%~s~%~%" l*))
	lemmas)))

(defun rp () 
  (let (p* Ln*)
  (mapc #'(lambda (p)                  ;p is a sub-plan, ln is a line.
    (format t "~% ~%") (prnt p) (setq p (eval p)) 
    (setq p* (mapcar #'(lambda (ln) 
           (format t "~%~s ~%" ln)
           (setq Ln* (list (car ln) (cadr ln) (add-arg (caddr ln) s s3 s4) 
			   (cadddr ln)))
	              (format t "~s ~%" ln*))
		     p)))
	plans)))

(defun rpn (n)
  (let (p* plans*)
    (setq plans* (nth (1- n) plans))  
    (mapc #'(lambda (p)                  ;p is a sub-plan, ln is a line.
      (prnt p) (setq p (eval p)) (prnt p)
      (setq p* (mapcar #'(lambda (ln) 
           (list (car ln) (cadr ln) (add-arg (caddr ln) s s3 s4) (cadddr ln)))
		     p))
    (prnt p*))
	plans*)))

;;---------------------------------------------------------------
(defun rl7 () 
  (let (l*)
  (mapc #'(lambda (l) (prnt l) (setq l (eval l)) (prnt l)
	              (setq l* (add-arg l s s3 s4))
		      (prnt l*))
	(list 'l7))))

(defun rL11 () 
  (let (L*)
  (mapc #'(lambda (L) (prnt L) (setq L (eval L)) (prnt L)
	              (setq L* (add-arg L S S3 S4))
		      (prnt L*))
	(list 'L11))))

(defun rDEL () 
  (let (L*)
  (mapc #'(lambda (L) (prnt L) (setq L (eval L)) (prnt L)
	              (setq L* (add-arg L S S3 S4))
		      (prnt L*))
	(list 'DEL))))

(defun rDP () 
  (let (L*)
  (mapc #'(lambda (L) (prnt L) (setq L (eval L)) (prnt L)
	              (setq L* (add-arg L S S3 S4))
		      (prnt L*))
	(list 'P))))

(defun rf1 () 
  (let (L*)
  (mapc #'(lambda (L) (prnt L) (setq L (eval L)) (prnt L)
	              (setq L* (add-arg L S S3 S4))
		      (prnt L*))
	(list 'f1))))

(defun rPP () 
  (let (L*)
  (mapc #'(lambda (L) (prnt L) (setq L (eval L)) (prnt L)
	              (setq L* (add-arg L S S3 S4))
		      (prnt L*))
	(list 'P))))

(defun rL1 () 
  (let (L*)
  (mapc #'(lambda (L) (prnt L) (setq L (eval L)) (prnt L)
	              (setq L* (add-arg L S S3 S4))
		      (prnt L*))
	(list 'L1))))

(defun rL4 () 
  (let (L*)
  (mapc #'(lambda (L) (prnt L) (setq L (eval L)) (prnt L)
	              (setq L* (add-arg L S S3 S4))
		      (prnt L*))
	(list 'L4))))

(defun rL9 () 
  (let (L*)
  (mapc #'(lambda (L) (prnt L) (setq L (eval L)) (prnt L)
	              (setq L* (add-arg L S S3 S4))
		      (prnt L*))
	(list 'L9))))

(defun rL11 () 
  (let (L*)
  (mapc #'(lambda (L) (prnt L) (setq L (eval L)) (prnt L)
	              (setq L* (add-arg L S S3 S4))
		      (prnt L*))
	(list 'L11))))

(defun rp2 () 
  (let (L*)
  (mapc #'(lambda (L) (prnt L) (setq L (eval L)) (prnt L)
	              (setq L* (add-arg L S S3 S4))
		      (prnt L*))
	(list 'plan-2))))

(setq plan-24  '((SOME U (SOME V (& (< U V) (SUBSET (NT U V) B) 
			     (CENTER Z (NT U V)))))))
(defun rp24 ()
  (let (L*)
  (mapc #'(lambda (L) (prnt L) (setq L (eval L)) (prnt L)
	              (setq L* (add-arg L S S3 S4))
		      (prnt L*))
	(list 'plan-24))))

(setq plan-244 '(16 (DEL not-Th)(SOME u(SOME v (& (< u v) (subset (nt u v) B)
				      (center z (nt u v)))))
      ((otter) (L7) (15))))


(defun rp244 ()
  (let (L*)
  (mapc #'(lambda (L) (prnt L) (setq L (eval L)) (prnt L)
	              (setq L* (add-arg L S S3 S4))
		      (prnt L*))
	(list 'plan-244))))

(defun rp11 () 
  (let (L*)
  (mapc #'(lambda (L) (prnt L) (setq L (eval L)) (prnt L)
	              (setq L* (add-arg L S S3 S4))
		      (prnt L*))
	(list 'plan-11))))

(defun rp111 () 
  (let (L*)
  (mapc #'(lambda (L) (prnt L) (setq L (eval L)) (prnt L)
	              (setq L* (add-arg L S S3 S4))
		      (prnt L*))
	(list 'plan-111))))

(defun rp111 () 
  (let (L*)
  (mapc #'(lambda (L) (prnt L)
	              (setq L* (add-arg L S S3 S4))
		      (prnt L*))
	plan-111)))

(setq plan-1115 '((5 (DEL) (<= (LF (NT A B)) (RT (NT A B))) ((OTTER) (L4) NIL))))
(defun rp1115 () 
  (let (L*)
  (mapc #'(lambda (L) (prnt L)
	              (setq L* (add-arg L S S3 S4))
		      (prnt L*))
	plan-1115)))



