
;                       high-low-tree.lisp                  8Mar95

;;This the OPTIONS version of high-low-tree5.lisp, where we
;; combine, under options, member&, BCH-ors, and Lemmas.  
;;Also here we revamp the rankings of *tree* when results change.  

#|
 This is new version of the prover in high-low.lisp, high-low-tree2.lisp, 3,4.
 Many (most) of the concepts found there are used here.
 See that file and files high-low6.lisp, 5, etc for excplanations.
 Also, see DOCUMENDATION and PROCEDURE (in ile high-low-tree-PROCEDURE),
 for a brief explanation of how this version uses a PROOF-TREE, with 
 regular nodes and DECISION nodes -- with RATINGS which help determine
 how to proceed with the proof.  

LOADING:  

(load "imply.lisp")(ls)(lu)(lp)(le)                               ;(lplns)
(lres)(lpi)(lpci)(lop)(lsg)(lpbr)(lppc)(lpc)(lpbe)(lpLe)
;(load "print-float.lsp")
(lf)(lfo)(lgr)(lm2)(lehl)(lp)(leq)(lhl2)(lhl)(lhlt)

|#
;;(defun p () (lhlt) (lpLe) (time (pr8)))

(defun lhlt () (load "high-low-tree.lisp"))
(defvar *FOL-version* t)
(defvar *strange-list* 
 '(nu not== unsat-L resolvent-L  negatives-L clause-L clauses-L
   literal-L exp finite ground subset == << <<= < <= e))   
                                    ;This list needs to be lengthened  26Dec94
(setq *repeats-limit* 40)
(setq *gv* *grind*-version*)
(defvar *types* nil)
(defvar *lemmas* nil)
(defvar *lemmas** nil)
(defvar *lems* nil)
(defvar *lemma-names* nil)
(defvar *save-lemmas* nil)
(defvar *lemmas-used* nil)
(defvar *lemma-list* nil)
(defvar *reject*  nil)
(defvar *predicate-list* nil)
(defvar *reject** nil)
(defvar *n* 20)
(defvar *lemn* 0)                                   ;20Jan95
(defvar *nn* 0)                                     ;23Jan95 node number
(defvar *nodes* nil)
(defvar *sn* 0)                                     ;23Jan95 step number
(defvar *steps* nil)
(defvar *storage* nil)
(defvar *thetas* nil)
(defvar *tree* nil)
(defvar *H** nil)
(defvar *thetasxy* nil)

(defun prove-HL (Thm &optional H Lemmas copies Lm) ;Main Call  2Sept94
  ;;Lemmas are listed here as a set of atoms (mames of the lemmas)
  (let (Thm* thm** thm*** H* W lemmas* number-of-lemmas pv nl W k Hi= Hi> 
	     H1 H2 H12 lemmas2 lemmas3 lemmas4)
    (setq *ns* nil)
    (setq *nn* 0)
    (setq *reject* nil)
    (setq *storage* nil)
    (setq *thetas* nil)
    (setq *save-lemmas* nil)
    (setq *lemmas-used* nil)
    (setq *H** (list nil nil))
    (setq *lemma-names* nil)
    (setq *thetasxy* nil)
    (setq %theorem-variables% nil)
    (setq *n* 20)
    (setq *lemn* 0)
    (setq *repeats* 0)
    (setq *MINIMAL-IMAGE-MATCH* 1)
    (cond ((eq t Lemmas) (setq Lemmas nil)))   ;4 Oct 94
    (setq thm* (imp-on H thm))
    (cond ((and lemmas (eq-car lemmas 'exs-from-to)) 
	   (setq lemmas (exs-from-to (cadr lemmas) (caddr lemmas)
				     (cadddr lemmas) (fifth lemmas)))))
    (and copies (setq lemmas (union-n lemmas copies)))
    (and lm (setq lemmas (append (remove lm lemmas :test 'equal) (list lm))))
    (setq number-of-lemmas (length lemmas)) (prnt number-of-lemmas)

    (setq lemmas2 (mapcar #'(lambda (u) (cond ((atom u) (eval u)) (t u)))
			  lemmas))
    (setq lemmas* (mapcar #'replace-multiple-quantifiers lemmas2))
    (setq thm** (imp-on (andify lemmas*) thm*))
    (setq thm** (sublis '((< . <<) (<= . <<=) (= . ==)) thm**))
    (setq thm** (unique-ize-quan-vars thm**))               ;8 Oct 94
    (setq thm-temp thm**)   ;just for editing  13Mar95
    (setq *V* (unifiable-variables Thm**))
    (setq *types* (types Thm**))                            ;7Nov94
    (prnt *types*)
;;  (setq pv (predicate-symbols thm**))    ;15Sept94
;;  (setq pv (set-difference pv *predicate-list*))
;;  (setq *predicate-list* (append pv *predicate-list*))    ;not uese?
    (cond (lemmas (setq thm* (caddr thm**))
		  (setq *lemmas* (un-andify (cadr thm**))))
	  (t (setq thm* thm**) (setq *lemmas* nil)))
 
   (setq *lemmas* (sublis '((< . <) (<= . <<=) (= . ==)) *lemmas*))   ;7Mar95 
   (setq *lemma-list* (mapcar #'(lambda (a lm) (list a lm)) lemmas *lemmas*)) 
   (setq *lemmas* (mapcar #'(lambda (Lm Lem) (list Lm (image Lem)))
			  lemmas *lemmas*))
   (setq *lems* lemmas)                       ;14Mar95
   (prnt *lems*) 

   (cond ((eq-car Thm* '->) 
	  (setq H* (cadr Thm*)) (setq Thm* (caddr Thm*))))
   (cond ((eq-car Thm* '->) 
	  (setq H* (and-on (cadr Thm*) H*)) (setq Thm* (caddr Thm*))))
   (setq H* (forward-chain-on H*))                        ;8 Oct 94
   (setq H12 (atomics-pair H*))
   (setq H1 (car H12)) (setq H2 (cadr H12))
   (cond ((null (setq W (HL-tree H1 H2 thm* 'first))) nil)
	 (t '[])) ))

(defun HL-tree (H1 H2 C &optional flag)  ;2Feb95  Called by PROVE-HL	
  (let (new-limb gui-limb L ans ns ns*)
    (cond ((eq flag 'first) (setq *tree* '(root))))
    (format t "~%HL-tree~%")
    (cond ((cdr *tree*) (setq new-limb '(root))
	                (setq gui-limb (cdr *tree*)))
	  (t (setq new-limb '(root)) (setq gui-limb nil)))
    (setq L (list H1 H2 C nil nil new-limb gui-limb flag))   ;23Nar85 PH= nil
    (cond ((eq 'back (setq ans (HHL L))) 
	   (setq *tree* (re-rank *tree*))
	   (format t "~%*tree*= ~s~%~%" *tree*)
#|
	   (setq ns (crunch (atoms-in *tree*)))
	   (setq ns* (set-difference ns *ns*))
	   (print-ns ns*)
|#
	   (setq *ns* (append ns* *ns*))
	   (HL-tree H1 H2 C))
	  (t (prnt *tree*) ans) )))

(defun HHL (L)    ;23Jan95 9Feb95  Called by, and calls, HL
  (apply 'HL L))

;;HL HL HL HL HL HL HL HL HL HL HL HL HL HL HL HL HL HL HL HL HL HL HL HL 

(defun HL (H1 H2 C VC PH new-limb gui-limb &optional flag)    ;23Mar95
  ;;tree is built as the proof proceeds, gui-limb is guiding the proof.
  ;;HL returns THETA (or nil or 'back)
  (let (step L L* n# n#i n#1 n#2 tup tup1 tup2 rank-list Pj namei
	     valuesi values1 values2 values1* values2* VC*
	     args* argsi args1 args2 args1* args2* 
	     P1 csi ranki theta thetai theta1 theta2 sigma  
	     new-limb*1 new-limb*2 new-limb21 new-limb22 lemma-name lm
	     lemma-namei new-limb* new-limb** new-limb2 subtree dec-step &-step
	     path option-list k m CL* Cs-in-H W ans C1 C* C** hi* image 
	     LH1* LH2* H1* H2* H1*2 H2*2 H1** H2** H1&2 HC1 HC2 H12 H21 H22 
	     x xs path-mem path-member& path-BCH-ors path-lemmas xxx PH*)

(format t "~%HL") 
;;(cond (gui-limb nil) (t (setq H1 (and-on (car  *H**) H1))
;;                        (setq H2 (and-on (cadr *H**) H2))))
(setq H1 (and-on (car  *H**) H1))
(setq H2 (and-on (cadr *H**) H2))

(cond ((equal C '(& (E L2 C11) (E L192 C11)))
       (prnt '22>) (prnt C) (prnt PH) (break)))
(cond 
  ((and (eq C t) (null PH)) (return-from HL t))
  (gui-limb      ;HL is now following the guide-limb
   (cond ((atom (setq step (car gui-limb)))                     ;REGULAR step
	  (format t " ~s" step)
	  (setq n# step) (setq new-limb2 (append new-limb (list n#)))
;;(cond ((eq 'n13 n#) (prnt step n# 'atom 1) (break)))
	  (setq L (cadr (assoc n# *storage*)))
	  ;;L=(H1 H2 C VC PH)  or L= (n# 'not-done '& argsi)   ;PH
	  (setq L (cond ((eq '& (caddr L)) (cadddr L)) (t L)))
	  (setq L* (append (first-n 5 L) (list new-limb2 (cdr gui-limb))))
	  (setq theta (HHL L*))
	  (return-from HL (cond ((null theta) nil)
				((eq 'back theta) 'back)
				((setq theta1 (cadr (assoc n# *thetas*)))
				 (compose theta1 theta)) ;For the k=1 case
				(t theta))))

	 ((eq-car step 'dec)                                     ;DECISION step
	  ;;step= ('dec n# k [(n#1 Rank1) ... (n#k Rankk)])
	  (setq n# (cadr step)) (setq rank-list (cadddr step))
	  (setq n#i (best-option rank-list)) 
                                    ;rank-list= [(n#1 Rank1) ... (n#k Rankk)]
	  (format t " ~s  Choose: ~s ~%~s" n# n#i step)
	  (setq valuesi (cadr (assoc n#i *storage*)))
	  ;;valuesi= (n#i thetai Ranki Resultsi argsi)
	  (setq argsi (fifth valuesi))
	  ;;argsi= (H1 H2 C VC PH)                             ;23Mar95  PH
	  (setq gui-limb* (limb-after n#i))  ;limb starting after n#i in *tree*
          (setq args* (append argsi (list (list n#i) gui-limb*)))
	  (setq theta (HHL args*))
          (cond ((eq 'back theta) (return-from HL 'back))
		((null theta) 
		 (replace-resultsi nil n#i step valuesi) 
		 (cond ((every #'(lambda (u)
                                    (or (eq-car u n#i) (zerop (cadr u))))
			       rank-list)
			(return-from HL nil))
		       (t (rerank-tree n#i)
                          (return-from HL 'back))))
		(t (setq thetai (cadr valuesi))
		   (setq sigma (compose theta thetai))
		   (replace-resultsi sigma n#i step valuesi)
                                          ;replace resulti by sigma in *tree*
		   (return-from HL sigma))))

	 ((eq-car step '&)		;&-STEP   step= (& N2 2 (N3 N4)) 
	  (setq n# (cadr step)) ;N2
	  (setq n#1 (car(cadddr step))) :N3 
	  (setq n#2 (cadr (cadddr step))) :N4 	
	  (format t " ~s ~s" n# step)

	  (setq tup1 (cadr (assoc n#1 *storage*)))
					;tup1= (n#1 Rusults1 '& args1)
					;tup1= (N3 NOT-DONE '& args1) 
	  (setq tup2 (cadr (assoc n#2 *storage*)))
	  (setq args1 (cadddr tup1)) ;args1= (H1 H2 C1 VC PH)   23Mar95 PH
	  (setq args2 (cadddr tup2)) ;args2= (H1 H2 C* VC pH)    
	  (setq new-limb21 (append new-limb (list step n#1)))
	  (setq new-limb22 (append new-limb (list step n#2))) 	 
	  (setq args1* (append args1 (list new-limb21 (cddr gui-limb))))       

	  (cond ((eq 'not-done (cadr tup1))  
 		 (setq theta1 (HHL args1*))
		 (cond ((null theta1) (return-from HL nil))
		       ((eq 'back theta1) (return-from HL 'back))
		       (t (setq tup1* (list n#1 theta1 args1)) 		  
			  (setq *tree* (subst tup1* tup1 *tree* :test 'equal))
			  (setq *storage* (subst tup1* tup1 *storage*
						 :test 'equal)) 
			  (setq C** (apply-subs-q theta1 (caddr  args2) t))
			  (setq VC* (apply-subs-q theta1 (cadddr args2) t))
			  
			  (setq args2* (list (car args2) (cadr args2) C** VC*
					     (fifth args2) new-limb22 nil))
			  (setq theta2 (HHL args2*))
			  (return-from HL 
				       (cond ((null theta2) nil)
					     ((eq 'back theta2) 'back)
					     (t (compose theta1 theta2)))))))
	                  
		(t (setq theta1 (cadr tup1))     ;tup1= (n#1 Rusults1 args1)
		   (setq C** (apply-subs-q theta1 (caddr  args2) t))
		   (setq VC* (apply-subs-q theta1 (cadddr args2) t))
		   (setq args2* (list (car args2) (cadr args2) C** VC*
				      (fifth args2)new-limb22 (cddr gui-limb)))
		   (setq theta2 (HHL args2*))
		   (return-from HL (cond ((null theta2) nil)
					 ((eq 'back theta2) 'back)
					 (t (compose theta1 theta2)))))))

	 (t (format t "~%A Problem in HL When gui-limb is not NIL~%")
	    (break)))))

(cond ((and (eq-car C '->) (not PH))
       (setq H12 (atomics-pair (cadr C)))
       (or (setq HC1 (and-on (car H12)  H1)) t)
       (or (setq HC2 (and-on (cadr H12) H2)) t)
       (setq n# (n-name)) (setq new-limb2 (append new-limb (list n#)))
       (setq L (list HC1 HC2 (caddr C) VC PH))
       (store L n#)			;Store (n# L) in *storage*
       (setq L* (append L (list new-limb2 nil)))
       (HHL L*))		     ;HHL calls HL with arguments listed in L*
     
      ((and (eq-car C 'or) (not PH))
       (setq H12 (atomics-pair (not-fcnf (cadr C))))
       (setq H21 (atomics-pair (not-fcnf (rest-&or C))))
       (or (and (setq n# (n-name)) (setq new-limb2 (append new-limb (list n#)))
		(setq L (list (and-on (car H21) H1) (and-on (cadr H21) H2)
			      (cadr C) VC PH))
		(store L n#)
		(setq L* (append L (list new-limb2 nil))) (HHL L*))
	   (and (setq n# (n-name)) (setq new-limb2 (append new-limb (list n#)))
		(setq L (list (and-on (car H12) H1) (and-on (cadr H12) H2) 
			      (rest-&or C) VC PH))
		(store L n#)
		(setq L* (append L (list new-limb2 nil))) (HHL L*))))
     
      ((eq-car C 'not) nil)		;later
     
      ((and (eq-car C 'some) (not PH))
       (setq n# (n-name)) (setq new-limb2 (append new-limb (list n#)))
       (setq L (list  H1 H2 (caddr C) (cons (cadr C) VC) PH))
       (store L n#)
       (setq L* (append L (list new-limb2 nil))) (HHL L*))
     
      ((and (eq-car C 'all) (not PH))
       (setq xs (make-skolem-expresn (setq x (cadr C)) VC)) ;(xs ...)
       (setq C* (subst xs x (caddr C) :test 'equal))
       (setq n# (n-name)) (setq new-limb2 (append new-limb (list n#)))
       (setq L (list H1 H2 C* VC PH))
       (store L n#)
       (setq L* (append L (list new-limb2 nil))) (HHL L*))

      ((and (some #'(lambda (hi) (and (setq hi* hi) (member hi *lems*)))
		 H2)
	    (or (format t "~%LEMMA-NAME= ~s~%" hi*) t)
	    (setq *lemmas-used* (cons hi* *lemmas-used*))
	    (setq H2 (remove hi* H2)) nil))
      ((and (some #'(lambda (hi) (and (setq hi* hi) (member hi *lems*)))
		  H1)
	    (or (format t "~%LEMMA-NAME= ~s~%" hi*) t)
	    (setq *lemmas-used* (cons hi* *lemmas-used*))
	    (setq H1 (remove hi* H1)) nil))

      ((and (or (setq LH1* (predicate-choose C H1)) t)
	    (or (setq LH2* (predicate-choose C H2)) t)
	    (or (setq H1* (cond (LH1* (andify LH1*)))) t)
	    (or (setq H2* (cond (LH2* (andify LH2*)))) t)
	    (or (setq H1&2 (append LH1* LH2*)) t)
	    nil))

      ((and (member C H1&2 :test 'equal) (or (prnt 'C-in-H) t) (setq C t) 
	    (not PH)) t)
      ((and (eq-car C '&) 
	    (null (setq CL* (set-difference (cdr C) H1&2 :test 'equal)))
	    (or (format t "~%All Ci's in H~%~%") t) 
            (setq C t) (or (format t "~%C-Now= ~s~%" C) t) (not PH) ) t)
      ((and (eq-car C '&) (not (equal CL* (cdr C)))
	    (setq Cs-in-H (set-difference (cdr C) CL* :test 'equal))
	    (or (prnt Cs-in-H) (format t "~%") t) (setq C (andify CL*)) nil))

      ((and (eq-car C '&)                    ;27Mar95  fis this like last one?
	    (not (equal C (setq C* (andify (crunch (cdr C)))))))
       (prnt '&crunch)          
       (setq n# (n-name)) (setq new-limb2 (append new-limb (list n#)))
       (setq L (list H1 H2 C* VC PH))
       (store L n#) 
       (setq L* (append L (list new-limb2 nil))) 
       (HHL L*))

  ;;------------------ try Atomic MEMBER*2 -------------------------??----
      ((and nil (atomic C) (setq path-mem (cons 'mem path)) ;skip for now
	    (setq W (member*2 C H1&2 *V* *V* path)))        ;13Mar95
       (return-from HL (car W)))                  ;23Mar95 watch re PH

  ;;------------------ try OTTER -------------------------------------
      ((and nil (or (eq flag 'first)	;nil now, handle this later
		    (and (not (eq flag 'rj)) (ground-v C *V*)))
	    (setq ans (time (otter-prove C   
			 :inference-rules '(binary_res)
			 :time 10 :factor t :base-axioms (and-on H1 H2))))
	    (eq-car ans t))		;Proved by otter
       t)

      ((and C (atom C) (not (eq t C)) (not PH)) nil)

      ;;-------------------- Now try OPTIONS------------- new-limb is nil.  
      ((and (not PH) (or (eq-car C '&) (and (atomic C) (setq C (list '& C))))
	    (setq L* (options H1* H2* H1 H2 C (image C) VC)))      ;8Mar95

       ;;L*= ([($1 P1 Cs1 name1 H*1) rank1] ... [($k pk Csk namek H*) rankk]) 
       ;; where: $i means THETA -- a substitution
       ;;        Pi is a precondition from BCH which must be proved first
       ;;        CSi is a set of conclusions to be proved
       ;;        namei is either 'MEM, 'BCH, or lm (lemma name)
       ;;        H*i is an add'nl hypotheses that can be used if Pi is proved

       (cond ((and (equal 1 (setq k (length L*))) (eq t (cadaar L*))
		   (null (caddr (caar L*))))
	      (return-from HL (caaar L*))))

       (setq n# (n-name))                          
       (setq option-list nil)                
       (mapc #'(lambda (u)       	;u= [(thetai Pi Csi namei H*i) ranki]
                  (setq tup (car u))
		  (setq thetai (car tup))
		  (setq Pj (cadr tup)) 
		  (setq Ci (andify (caddr tup)))
		  (setq namei (cadddr tup)) (setq H*i (fifth tup))
		  (setq ranki (cadr u))
		  (setq n#i (n-name))
		  (setq option-list (cons (list n#i ranki) option-list))
		  (setq C*  (apply-subs-q thetai Ci t))
		  (setq VC* (apply-subs-q thetai VC t))
		  (cond ((not (member namei '(mem BCH)))
			 (setq lemma-name namei)
			 (setq H22 (apply-subs-q thetai (evalr lemma-name)nil))
			 (setq H22 (and-on namei H22)) ;add lemma to end of H2
			 (setq H2 (and-on H2 H22))))
		  (setq PH* (list Pj H*i))                         ;29Mar95
		  (setq argsi (list H1 H2 Ci VC* PH*))
		  (setq valuesi (list n#i thetai ranki 'not-done argsi))
		  (store valuesi n#i))	;store in *storage*
	     L*)

       ;;option-list= [(n2 1/4) (n1 3/4)]
       (setq dec-step (list 'dec n# k (reverse option-list)))
       (store dec-step n#) 
       (setq subtree (reverse (mapcar #'(lambda (u) (list (car u))) 
				      option-list)))           
       ;;subtree= [(n#1)(n#2)...(n#k)]   [(n1) (n2)]
       (setq new-limb* (append new-limb (list dec-step subtree)))
       ;;new-limb*= (root n-> ns ('dec n0 2 [(n1 3/4) (n2 1/4)]) [(n1) (n2)])
       (graft new-limb*)   
       'back)

  ;;------------------- now try whos-first  ------------------------
      ((or (and (eq-car c '&) (cddr c)) PH)                        ;not (& c1)
       (setq n#  (maknam (list 'n (setq *nn* (1+ *nn*))))) ;step name   
       (setq n#1 (maknam (list 'n (setq *nn* (1+ *nn*))))) ;c1 step name   
       (setq n#2 (maknam (list 'n (setq *nn* (1+ *nn*))))) ;c* step name   
       (setq m (cond ((atom c) 1) (t (length (cdr c)))))

       (cond (PH (setq C1 (car PH)) (setq H* (cadr PH)))
	     ((null (setq w (whos-first (cdr c) h1&2 *v* path)))
	      (format t "~%problem with whos-first~%") (break))
	     (t (setq C1 (car W))))                   ;w= (c1 --)

       (cond (PH (setq C* C))
	     ((equal C (andify (cons C1 (remove C1 (cdr C) :test 'equal))))
	      (setq C* (andify (cddr C))))
	     (t (format t "~%moved to front of c~%~s~%~%" C1)
		(setq C* (andify (remove C1 (cdr C) :test 'equal)))))
   
       (setq args1 (list h1 h2 c1 vc nil))        ;PH= nil for next call to HL
       (setq args2 (list h1 h2 c* vc nil))     
       (setq values1 (list n#1 'not-done '& args1))
       (setq values2 (list n#2 'not-done '& args2))
       (store values1 n#1) (store values2 n#2) 
       (setq &-step (list '& n# m (list n#1 n#2)))
       (store &-step n#)
       (setq new-limb*1 (append new-limb (list &-step n#1)))  
       (setq new-limb*2 (append new-limb (list &-step n#1 n#2)))  
       (setq args1* (append args1 (list new-limb*1 nil)))
       (setq args2* (append args2 (list new-limb*2 nil)))
       (setq theta1 (hhl args1*))
       (cond ((not theta1) nil)
	     ((eq 'back theta1) 'back)
             ((null C*) theta1)                                
	     (t (setq values1* (list n#1 theta1 '& args1))
		(setq *storage*(subst values1* values1 *storage* :test 'equal))
		(setq c** (apply-subs-q theta1 (caddr args2*) t))
		(cond ((null C**) (return-from HL theta1)))
		(setq args2* (subst c** (caddr args2*) args2* :test 'equal))
		(setq vc* (apply-subs-q theta1 (cadddr args2*) t))
		(setq args2* (subst vc* (cadddr args2*) args2* :test 'equal))
		(cond (PH (setq H* (apply-subs-q theta1 H* nil))
			  (setq H12 (atomics-pair H*))
			  (setq H5 (and-on (car  H12) (car  *H**)))
			  (setq H6 (and-on (cadr H12) (cadr *H**)))
			  (setq *H** (list H5 H6))
			  (setq H1*2 (and-on (car  H12) (car  args2*)))
			  (setq H2*2 (and-on (cadr H12) (cadr args2*)))
			  (setq args2* (subst H1*2 (car  args2*) args2*
					      :test 'equal))
			  (setq args2* (subst H2*2 (cadr args2*) args2*
					      :test 'equal)) ))     ;4Apr95
		(setq values2* (list n#2 'not-done '& args2*))
		(setq *storage*(subst values2* values2 *storage* :test 'equal))
		(setq theta2 (HHL args2*))
		(cond ((not theta2) nil)
		      ((eq 'back theta2) 'back)
		      (t (compose theta1 theta2))))))

      ((and (eq 'first flag) 
	    (setq ans (time (otter-prove c
					 :inference-rules '(binary_res)
					 :time 1000 :factor t 
					 :base-axioms (and-on h1 h2))))
	    (eq-car ans t)) t) ) ))

#|Skip this for now.  See next.
(defun options (H1* H2* h1 h2 C image VC)     ;8mar95  called by HL
  ;;H1* and H2* hold only the pertinent members of H1 abd H2
  (let (L*1 L*2 L*3 L* l2 l3 tot k rank0 Ltop Ltop* L*12 lm)
    (format t "~%options~%")    

    ;;MEMBER&      
    (cond ((and H1* (some #'atomic (cdr C)))
	   (setq L*1 (crunch (member& H1* C (list 'member&) *v*)))
	   (setq L*1 (total-ranks=1 L*1))))

    ;;BCH-ors    6Apr95  only
    (and (< (length L*1) 2)
    (setq L*2 (crunch (bch-ors H1* H2* H1 H2 C VC (list 'bch-ors) image)))
    (setq L*2 (total-ranks=1 L*2)))

    ;;LEMMAS      6Apr95  only
    (and (< (length (append L*1 L*2)) 2)
    (cond (*lemmas*                                       
	   (setq L*3 (crunch (lemmas H1* H2* H1 H2 C VC (list 'lemmas) image)))
	   (setq L*3 (total-ranks=1 L*3)))))

    ;;4Apr95 If a lemmas has already been used, rank it behind MEM and BCH 
    (cond ((null L*3) nil)
	  ((null (setq L*12 (append L*1 L*2))) nil)
	  (t (setq rank0 0)          
	     (mapc #'(lambda (u) (setq rank0 (min rank0 (cadr u)))) L*12)
	     (setq L*3 (mapcar #'(lambda (u)  ;u= [($i Pi Csi namei H*i) ranki]
			(setq lm (cadddr (car u)))
		      (cond ((and (< rank0 (cadr u)) (member lm *lemmas-used*))
			     (list (car u) rank0)) (t u)))
			       L*3))))

    (setq L* (crunch (append L*1 L*2 L*3)))
    ;;L*= ([($1 P1 Cs1 name1 H*1) rank1]  ... [($k Pk Csk namek H*k) rankk])
    (setq L* (rank-thetas L*))                        ;30Mar95

    (cond ((setq L2 (mapcan #'(lambda (u)   ;u= [($i Pi Csi namei H*i) ranki]
                                   (cond ((eq t (caar u)) (list u))))
			    L*))
	   (setq L3 (set-difference L* L2))
	   (setq L* (append L2 L3))))
    (setq L* (sort L* '(lambda (x y) (> (cadr x) (cadr y)))))

    (setq L* (crunch-options L*))

    ;;NOTE %$%$%$ 5Apr95  For now, we will shorten L* to length < 4
    (setq L* (first-n 3 L*))

    (setq k (length L*))
    (setq tot 0) (mapc #'(lambda (u) (setq tot (+ tot (cadr u)))) L*)
    (setq L* (mapcar #'(lambda (u) (list (car u) (/ (cadr u) tot))) L*))
    (prnt L*) ; (break)
    L*))
|#      

(defun options (H1* H2* h1 h2 C image VC)     ;8mar95  called by HL
  ;;H1* and H2* hold only the pertinent members of H1 abd H2
  (let (L*1 L*2 L*3 L* l2 l3 tot k rank0 Ltop Ltop* L*12 lm)
    (format t "~%options~%")    

    ;;MEMBER&      
    (cond ((and H1* (some #'atomic (cdr C)))
	   (setq L*1 (crunch (member& H1* C (list 'member&) *v*)))
	   (setq L*1 (total-ranks=1 L*1))))
;;(prnt 'mem L*1 'mem) (break)

    ;;BCH-ors                 
    (setq L*2 (crunch (bch-ors H1* H2* H1 H2 C VC (list 'bch-ors) image)))
    (setq L*2 (total-ranks=1 L*2))
;;(prnt 'bch L*2 'bck) (break)

    ;;LEMMAS
    (cond (*lemmas*                                       
	   (setq L*3 (crunch (lemmas H1* H2* H1 H2 C VC (list 'lemmas) image)))
	   (setq L*3 (total-ranks=1 L*3))))
;;(prnt 'lem L*3 'lem) (break)

    ;;4Apr95 If a lemmas has already been used, rank it behind MEM and BCH 
    (cond ((null L*3) nil)
	  ((null (setq L*12 (append L*1 L*2))) nil)
	  (t (setq rank0 0)          
	     (mapc #'(lambda (u) (setq rank0 (min rank0 (cadr u)))) L*12)
	     (setq L*3 (mapcar #'(lambda (u)  ;u= [($i Pi Csi namei H*i) ranki]
			(setq lm (cadddr (car u)))
		      (cond ((and (< rank0 (cadr u)) (member lm *lemmas-used*))
			     (list (car u) rank0)) (t u)))
			       L*3))))

    (setq L* (crunch (append-L L*1 L*2 L*3)))     ;NOTE append-L 10Apr95

    ;;NOTE %$%$%$ 7Apr95  For now, we will shorten L* to length < 5
    (setq L* (first-n 4 L*))

    ;;L*= ([($1 P1 Cs1 name1 H*1) rank1]  ... [($k Pk Csk namek H*k) rankk])
    (setq L* (rank-thetas L*))                        ;30Mar95

    (cond ((setq L2 (mapcan #'(lambda (u)   ;u= [($i Pi Csi namei H*i) ranki]
                                   (cond ((eq t (caar u)) (list u))))
			    L*))
	   (setq L3 (set-difference L* L2))
	   (setq L* (append L2 L3))))
    (setq L* (sort L* '(lambda (x y) (> (cadr x) (cadr y)))))

    (setq L* (crunch-options L*))

    ;;NOTE %$%$%$ 5Apr95  For now, we will shorten L* to length < 4
;;    (setq L* (first-n 3 L*))

    (setq k (length L*))
    (setq tot 0) (mapc #'(lambda (u) (setq tot (+ tot (cadr u)))) L*)
    (setq L* (mapcar #'(lambda (u) (list (car u) (/ (cadr u) tot))) L*))
    (prnt L*) ; (break)
    L*))
             
(defun member& (H1* C path V)  ;12jan95  called by OPTIONS
  (let (h-list L* (P t) (H* nil) tup tup*)
    (format t "~%member&~%")
    (setq h-list '(number-cs-with-same$ number-c$s-proved-new@ size-theta))
    (setq L* (rank nil h-list H1* nil nil nil c nil path nil))
    ;;L*= ([($ Cs) rank] ... [($ Cs) rank])
    (setq L* (mapcar #'(lambda (u) 
               (setq tup (car u))                             ;tup= ($ Cs)
	       (setq tup* (list (car tup) P (cadr tup) 'mem H*))
                                                        ;tup*=($ P Cs .mem H*)
	       (list tup* (cadr u)))                    ; [($ P Cs .mem H*) #]
		     L*))
    ;;We put nil in for P and H* here.
    ;;L*= ([($ t Cs 'mem nil) #] [($ t Cs 'mem nil) #]...[($ t Cs 'mem nil) #])
    L*))

(defun bch-ors (H1* H2* H1 H2 C VC path image)     ;5Apr95 Called by OPTIONS
  (let (h-list L*)
    (format t "~%bch-ors&~%")
    (setq h-list '(bch-$p fcn-repeats-bc prove-ps-by-member))
    (setq L* (rank nil h-list H1* H2* h1 h2 c vc path image))
    ;;L*= ([($ P Cs'bch H*) #] [($ P Cs 'bch H*) #] ... [($ P Cs 'bch H*) #]) 
    L*))
                               
(defun lemmas (H1* H2$ H1 H2 C VC path image)    ;5Apr95 Called by OPTIONS
  ;;not called if *lemmas* is nil (or if a test run is ??)
  ;;14Mar95: *lemmas* have the form ([Lm image] ... [Lm image])
  ;; where, Lm is the atom-name of the lemma.
  ;; We first select (and store in *Lemmas**, a global variable) 
  ;;  a subset of the Lm's whose images macch image of C. 
  ;;  And use *lemmas**, instead of *lemmas*, in the RANK functions.

  (let (h-list L* h1&2 lemmas2 lemmas3 lemmas4 lemmas5 lemmas6)
    (format t "~%lemmas~%")    
    (cond ((< (length *lemmas*) 6)
	   (setq *lemmas** (mapcar #'car *lemmas*)))
	  (t (setq lemmas2 (mapcar #'(lambda (pr)      ;pr= [Lmi imagei]
		         (list (car pr) (match-images image (cadr pr))))
				   *lemmas*))
;;	     (setq lemmas3 (mapcan #'(lambda (pr)   ;prune the poor ones
;                    (cond ((< *minimal-image-match* (cadr pr)) (list pr))))
;;				   lemmas2))
	     (setq lemmas3 (mapcan #'(lambda (pr)   ;only ones with val~= 0
                       (cond ((zerop (cadr pr)) nil) (t (list pr)))) ;14Mar95
				   lemmas2))
	     (cond ((< (length lemmas3) 5)
		    (setq lemmas4 
			  (sort lemmas2 #'(lambda (x y)(> (cadr x) (cadr y)))))
		    (setq lemmas6 (first-n= 5 lemmas4))
		    (prnt lemmas6)
		    (setq *lemmas** (mapcar #'car lemmas6)))
		   (t (setq lemmas4        ;same as above  Why?  Change later?
			  (sort lemmas3 #'(lambda (x y)(> (cadr x) (cadr y)))))
		      (setq lemmas6 (first-n= 5 lemmas4))
		      (prnt lemmas6)
		      (setq *lemmas** (mapcar #'car lemmas6)) ))))

    (cond ((null *lemmas**) (return-from lemmas nil)))
    (prnt *lemmas**) ; (break) 
    (cond ((not (eq-car C '&)) (setq C (list '& C))))
    (setq h-list '(bch-lem-$p fcn-repeats-bc prove-ps-by-member)) 
    (setq h1&2 (and-on h1 h2))                                 ;not used       
    (setq L* (rank nil h-list H1* H2* H1 H2 C VC path image))
    ;;L*= ([($ P Cs lem H*) #] [($ P Cs lem H*) #] ... [($ P Cs lem H*) #]) 
    L*))

(defun add-limb (limb new-limb)     ;24jan95
 ;;eg, (setq new-limb '(root ((n1 (n11 n12 n13)) (n2 (n21 n22)))))
 ;;    (setq limb '(n12 (n121 n122)))
 ;;    (add-limb limb new-limb) = 
 ;;        (root ((n1 (n11 (n12 (n121 n122)) n13)) (n2 (n21 n22))))
  (let (node1 options tre*)
    (cond ((null new-limb) nil)
	  ((atom new-limb) (cond ((eq new-limb (car limb)) limb) (t new-limb)))
	  (t (list (car new-limb) (mapcar #'(lambda (tre) (add-limb limb tre))
				      (cadr new-limb)))))))

(defun append-L (L*1 L*2 L*3)   ;10Apr95    Called by OPTIONS
  ;;Like append, but longer L*i's are given higher ranks
  (let ((ln1 (length-L L*1)) (ln2 (length-L L*2)) (ln3 (length-L L*3)))
    (setq L*1 (mapcar #'(lambda (u) (list (car u) (* ln1 (cadr u)))) L*1))
    (setq L*2 (mapcar #'(lambda (u) (list (car u) (* ln2 (cadr u)))) L*2))
    (setq L*3 (mapcar #'(lambda (u) (list (car u) (* ln3 (cadr u)))) L*3))
    (append L*1 L*2 L*3)))

(defun atoms-in (tree) ;3Mar95   For debugging
  (let (step dec-list nis atoms-in* atoms-in** sub-tree)
    (cond ((null tree) nil)
	  ((atom tree) nil)
	  ((atom (setq step (car tree))) 
	   (cons (car tree) (atoms-in (cdr tree))))
	  ((eq-car step 'dec)  ;step= ('dec n# j ((n#1 r1) ... (n#k rk)))
	   (setq dec-list (cadddr step))
	   (setq nis (mapcar #'car dec-list))
	   (setq atoms-in* (append (cons (cadr step) nis)))
	   (setq sub-tree (cadr tree))
	   (setq atoms-in** (mapcan #'(lambda (u) (atoms-in u)) sub-tree))
	   (append atoms-in* atoms-in** (atoms-in (cddr tree))))
	  ((eq-car step '&)    ;step= (& N158 2 (N159 N160))
	   (append (cons (cadr step) (cadddr step))
		   (atoms-in (cdr tree))))
	  (t nil))))
#|
  eg, (crunch (atoms-in '(ROOT N1 (& N158 2 (N159 N160)) N159 N161
                      (DEC N162 2 ((N163 0) (N164 1/4)))
                      ((N163 NIL) (N164 (DEC N165 1 ((N166 1))) ((N166)))))))
  =   (ROOT N1 N158 N160 N159 N161 N162 N163 NIL N164 N165 N166)
|#

(defun apply-subs-q (theta h* &optional (par t))  ;28jan95  for a shorter name
      (apply-substitution-q theta h* par))

(defun apply-substitution-q (theta h* &optional (par t)) ;26dec94  called by hl
  ;;some members of h* might have a quantifier
  ;;eg, (apply-substitution-q '((x . a) (y . b)) '(& (p x) (all y (q y))))
  ;;            =                                 (& (p a) (q b))
  (cond ((atom h*) (app-subq theta h* par))
	((atom (car h*)) (app-subq theta h* par))
	(t (mapcar #'(lambda (u) (app-subq theta u par)) h*))))

(defun app-subq (theta A &optional par) ;3Apr95 Called by APPLY-SUBSTITUTION-Q
  (let (A*)
    (setq A* (sko-part A par))
    (app-subq2 theta A*)))

(defun app-subq2 (theta A)             ;3Apr95  Called by APP-SUBQ
  (let () 
    (cond ((atom A) (apply-substitution theta A))
	  ((member (car A) '(all some))
	   (cond ((equal (cadr A) (apply-substitution theta (cadr A)))
		  ;;If it does not affect the quantified variable
		  (list (car A) (cadr A) (app-subq theta (caddr A))))
		 (t (app-subq theta (caddr A)))))
	  ((and (not (occur 'all A)) (not (occur 'some A)))
	   (apply-substitution theta A))
	  ((member (car A) '(-> & or not))
	   (cons (car A) (mapcar #'(lambda (u) (app-subq theta u))
				 (cdr A))))
	  (t (apply-substitution theta A)))))

(defun assoc-t (n# &optional (tree *tree*))    ;8Mar95   Called by RERANK-TREE
  ;;Return the smallest dec-node in *tree* which contains n#
  (let (dec-node dec-node* subtree)
    (cond ((null tree) nil)
	  ((eq-car (setq dec-node (car tree)) 'dec)  ;(dec n1 2 [(n2 #)(n3 $)])
	   (cond ((occur n# (cadddr dec-node)) dec-node)
		 (t (setq sub-tree (cadr (member dec-node tree :test 'equal)))
		    (cond ((some #'(lambda (u) 
                                     (setq dec-node* (assoc-t n# u)))
				 sub-tree)
			   dec-node*)
			  (t nil)))))
	  (t (assoc-t n# (cdr tree))) )))

(defun best-branch (new-limb)  ;2feb95  called by hl-tree  3feb95 not used now
  ;;choose the branch, selecting the limb with the lowest rating at each 
  ;; decision node.
  (let (step subtree k0 u0 new-limb*)
    (cond ((null new-limb) nil)
	  ((atom (setq step (car new-limb))) 
	   (cons step (best-branch (cdr new-limb))))
	  ((eq-car step 'dec)                 ;a decision step
	   (setq subtree (cdr step))
	   (setq k0 999)
	   (mapc #'(lambda (u) (cond ((< (cadr u) k0) (setq k0 (cadr u))
				                      (setq u0 (car  u)))))
		 subtree)
	   (setq new-limb* (assoc u0 subtree))
	   (best-branch new-limb*))
	  (t (cons step (best-branch (cdr new-limb)))) )))

(defun best-option (rank-list)   ;18feb95   called by hl
  ;;rank-list= [(n#1 rank1) ... (n#k rankk)]
  (let (r0 n#i valuesi)
;;  (setq rank-list (mapcan #'(lambda (u)     ;11Mar95  For a trial only on PR8
;;         (cond ((equal 25/93 (cadr u)) nil) (t (list u))))
;;			    rank-list))
    (setq r0 (apply 'max (mapcar #'cadr rank-list)))
    (some #'(lambda (u) (and (equal r0 (cadr u))
			     (setq n#i (car u))
			     (setq valuesi (eval* n#i)) 	 
			     ;;valuesi= (n#i thetai Ranki Resultsi argsi)
			     (eq 'not-done (cadddr valuesi)) ))
	  rank-list)
    n#i))

(defun best-limb (l)  ;3feb95  called by hl
  ;;l= [(n#1 ranking1 result1) ... (n#k rankingk resultk)]
  ;;return the member of l with the highest ranking   4feb95  highest
  (let ((ranking 0) triple)
    (mapc #'(lambda (u) (cond ((< ranking (cadr u))
			       (setq ranking (cadr u)) (setq triple u))))
	  l)
    triple))

(defun combine-ranks (rank1 rank2)  ;1feb95  called by lemmas and bch-ors
  ;;0<= rank1 <=10, rank2=0 or rank2=1.  0<= ans <=10. the bigger the better.
  ;;rank1 is from prove-by-member,  rank2 is from fcn-repeats
  ;;eg, (combine-ranks 3 1) = 0, (combine-ranks 7 1) = 4.
  (cond ((equal rank2 0) rank1)
	((< rank1 3) 0) 
	(t (- rank1 3))))

(defun consn (n a l)  ; 28jan95 called by hl 
  ;;cons a onto the nth member of l
  ;;eg, (consn 3 'x '(a b (c d) e)) = (a b (x c d) e)
  (subst (cons a (nth (1- n) l)) (nth (1- n) l) l :test 'equal))

(defun constant-terms (A V &optional par)  ;13Apr95
  ;;V is the set of instantiatable variables
  (let (L)
    (setq L (crunch (c-terms-in A par)))
    (cond (par L)
	  (t (set-difference (sort L 'c-sort-fcn) V)))))

(defun c-terms-in (A &optional par)        ;13Apr95  Called by CONSTANT-TERMS
  (let (P)
    (cond ((atom A) (list A))
	  ((member (setq P (car A)) '(some all))
	   (c-terms-in (caddr A) par))
	  ((member P '(-> & or not))
	   (mapcan #'(lambda (u) (c-terms-in u par)) (cdr A)))
	  (par (cdr A))
	  (t (mapcan #'cti (cdr A))) )))

(defun cti (A)                ;13Apr95  Called by C-TERMS-IN
  ;;A is a term
  (let ()
    (cond ((atom A) (list A))
	  (t (cons (car A) (mapcan #'cti (cdr A)))) )))

(defun c-sort-fcn (x y) 
  (cond ((numberp x)
	 (cond ((numberp y) (<= x y)) (t t)))
	((numberp y) nil)
	(t (<= (length (explode x)) (length (explode y)))) ))

(defun crunch-options (L*)  ;22Mar95  Called by OPTIONS
  ;;L* is from OPTIONS, and has the form,
  ;;L*= ([(theta CS ...) Rank] ... [(theta CS ...) Rank])
  ;;Remove these with the same theta and CS's.
  (let (Option1 theta1 P1 u* L2)
    (cond ((null L*) nil)
	  ((null (cdr L*)) L*)
	  ((and (setq Option1 (car L*)) (setq theta1 (caar Option1)) 
		(setq P1 (cadar Option1))
		nil))  
	  ((some #'(lambda (u) (and (equal theta1 (caar u))
				    (equal P1 (cadar u)) (setq u* u)))
		 (cdr L*))
	   (setq L2 (remove u* L* :test 'equal))
	   (crunch-options L2))
	  (t (cons Option1 (crunch-options (cdr L*)))) )))

(defun equivalent (h c vc)  ;21feb95
  ;;this converts this triple into an equivalent form,
  ;;  [&e (h1 c1 vc1) ... (hk ck vck)]
  ;;eg, (equivalent (p a) (-> (q a) (some x (& (p x) (q x)))) nil)
  ;; = (&e ((& (p a) (q a)) (p x) (x)) ((& (p a) (q a)) (q x) (x)))
  (let (h* c* hcvs hcvs*)
    (cond ((atom c)   (list h c vc))
	  ((atomic c) (list h c vc))
	  ((eq-car c '->)
	   (setq h* (and-on h (cadr c))) 
	   (equivalent h* (caddr c) vc))
	  ((eq-car c 'some)
	   (equivalent h (caddr c) (cons (cadr c) vc)))
	  ((eq-car c 'all)
	   (setq xs (make-skolem-expresn (setq x (cadr c)) vc)) ;(xs ...)
	   (setq c* (subst xs x (caddr c) :test 'equal))
	   (equivalent h c* vc))
	  ((eq-car c 'or)  (later))
	  ((eq-car c 'not) (later)) 
	  ((eq-car c '&)  ;c= (& c1 (-> h2 (& c21 c22)) c3)
	   (setq hcvs (mapcar #'(lambda (ci) (equivalent h ci vc))
			      (cdr c)))
	   ;;hcvs= [(h c1 vc) (&e ((& h h2) c21 vc) ((& h h2) c22 vc))
           ;;       (h c3 vc)]
	    (setq hcvs* (cons '&e (e&dify hcvs))))
	   ;;hcvs*= [&e (h c1 vc) ((& h h2) c21 vc) ((& h h2) c22 vc)
	   ;;           (h c3 vc)]
	     )))

(defun equal** (A B V V*)      ;13 Oct 94  Called by MEMBER*2
  ;;Same as EQUAL except that SOME and ALL are forced to have common variables.
  ;;Also, (equal** A B V V*) if A=B or if A or B is a member of V.
  ;;Also, if A is a member of V* the the substition, (A . B) is returned
  ;;eg, if A e V and A ~e V*, return t,  if A e V and A e V* return (A . B)
  ;;it, if V* is nil, ACT LIKE THEY ARE EQUAL when they unify
  ;;      Similarly for B.
  (let ((theta t) sigma)
    (cond ((equal A B) t)
	  ((and (member A V) (not (occur A B)) (equal-types A B))
	   (setq *theta* (cons (cons A B) *theta*))             ;7Nov94
	   (cond ((member A V*) (list (cons A B))) (t t)))
	  ((and (member B V) (not (occur B A)) (equal-types A B))
	   (setq *theta* (cons (cons B A) *theta*))             ;7Nov94
	   (cond ((member B V*) (list (cons B A))) (t t)))
	  ((atom A) nil)
	  ((atom B) nil)
	  ((not (eq (car A) (car B))) nil)
	  ((member (car A) '(SOME ALL))
	   (equal** (caddr A) (subst (cadr A) (cadr B) (caddr B))))
	  ((every #'(lambda (x y) (and (setq sigma (equal** x y V V*))
				       (setq theta (compose theta sigma))))
		  (cdr A) (cdr B))
	   theta)
	  (t nil) )))

(defun e&dify (l)  ;21feb95  called by equivalent  see example above.
  ;;each member of l is either (h c vc) or (&e (h c v) ... (h c vc))
  (let () 
    (cond ((null l) nil)
	  ((eq-car (car l) '&e)
	   (append (cdar l) (e&dify (cdr l))))
	  (t (cons (car l) (e&dify (cdr l)))) )))

(defun eval* (n#) (cadr (assoc n# *storage*)))            

(defun evalr (a)  ;7Mar95  a is an atom lemma name
  (cadr (assoc a *lemma-list*)))

(defun first-n (n L)  ;14Mar95  The first n members of L
  (cond ((zerop n) nil)
	((null L) nil)
	(t (cons (car L) (first-n (1- n) (cdr L))))))

(defun first-n= (n L)  ;14Mar95  
  ;;Like first-n, except that it includes all with the same
  ;; value (cadr of the unit) as the nth one, unless value= 0
  ;;eg, (first-n= 3 '((a 5) (b 4) (c 2) (d 2) (e 2) (f 2)))
  ;;                 ((a 5) (b 4) (c 2) (d 2) (e 2))
  (cond ((zerop n) nil)
	((null L) nil)
	((equal 0 (cadar L)) (first-n= n (cdr L)))
	((equal 1 n)
	 (cond ((equal (cadar L) (cadadr L))
		(cons (car L) (first-n= 1 (cdr L))))
	       (t (list (car L)))))
	(t (cons (car L) (first-n= (1- n) (cdr L)))) ))

(defun graft (new-limb)   ;17feb95  called by hl
  ;;graft the new-limb= (n# ...) to *tree* at the node n#
  (let (limb tre)
    (cond ((setq limb (limb-at (car new-limb)))
	   (setq tre (subst new-limb limb *tree* :test 'equal))
	   (setq *tree* tre))
	  (t (format t "~%problem in graft~%") (break)) )))

(defun g () 
 (setq *decision-step-names* '(p10 p11)) 
 (graft
 '((dec (p12 200) (p13 205)) p11 130 p10 p19 root)
 '(root 122 p1 p2 (dec (p3 112)
		       (p4 115 p5 p6 (& (p7 128) (p8 131)) p9 (dec (p9 143)
								    (p10 149)))))))

(defun ground (a)  ;20feb95
  (not (intersection (free-variables-in a) *v*)))


(setq new-limb '(root 122 p1 p2 (dec (p3 112)
		       (p4 115 p5 p6 (& (p7 128) (p8 131)) p9 (dec (p9 143)
								   (p10 149))))))

(defun head-limb-of (n &optional (tree *tree*) limb*)  ;8Mar95   
  ;;Called by RERANK-TREE
  ;;The smallest limb of *tree* which contains n in a DEC node
  ;;eg, *tree*= (root n0 (dec n1 2 [(n2 .6) (n3 .4)])
  ;;               ((n2 n4 (dec n5 2 [(n6 0) (n7 .3)])) (n3)))
  ;;(head-limb-of 'n6) = (n2 n4 (dec n5 2 [(n6 0) (n7 .3)]))
  (let (sub-tree limb)
    (cond ((atom tree) nil)
	  ((not (occur n (cdr tree))) limb*)    ;wwb deal with limb*
	  ((some #'(lambda (u) 
                     (and (eq-car u 'dec)
			  (setq sub-tree (cadr (member u tree :test 'equal)))
			  (some #'(lambda (v) (setq limb (head-limb-of n v)))
				sub-tree)))
		 tree)
	   limb)
	  (t tree))))

(defun insertn (l n a)  ;17feb95  insert a in position n of l
 ;;e.g., (insertn '(a b c) 2 'x) = (a x b c)
 (cond ((equal n 1) (cons a l))
       ((or (null l) (zerop n)) (format t "~%a prob in insertn~%") (break))
       (t (cons (car l) (insertn (cdr l) (1- n) a))) ))

(defun insert2 (l i j a b)   ;17feb95    i<=j
  ;;e.g., (insert2 '(a b c d e f) 3 5 'x 'y) = (a b x c d y e f)
  ;;insert a and b in positions i and j of list l
  (let (l*)
    (setq l* (insertn l j b))
    (insertn l* i a)))

(defun insert-after (n# a)    ;17feb95  called by replace-resultsi
  ;;e.g., (setq *tree* '(root n1 (dec etc) ((n2 a b c) (n3 d e f))))
  ;;after (insert-after 'n3 nil) 
  ;;      *tree*      = (root n1 (dec etc) ((n2 a b c) (n3 nil d e f)))
  (let (limb limb*)
    (setq limb (limb-at n# *tree*))
    (setq limb* (insertn limb 2 a))
    (setq *tree* (subst limb* limb *tree* :test 'equal))))

(defun lemma-prime (lem)       ;13Apr95
  ;;This converts the lemma, LEM, into an unsound one, which
  ;; involves only it "strange" predicates.  
  ;;To be used in testing the potential of subgoals.
  (let (P lem2 lem3)
    (cond ((atom lem) lem)
	  ((member (setq P (car lem)) '(some all))
	   (setq Lem3 (lemma-prime (caddr lem)))
	   (cond ((occur (cadr lem) lem3)
		  (list (car lem) (cadr lem) lem3))
		 (t lem3)))
	   ((eq '-> P) (list '-> (lemma-prime (cadr lem))
			         (lemma-prime (caddr lem))))
	   ((and (eq 'not P) 
		 (not (member (caadr lem) '(some all & or -> not))))
	    lem)
	   ((eq 'not P) (list 'not (lemma-prime (cadr lem))))
	   ((member P '(& or))
	    (setq lem2 (mapcan #'(lambda (u) 
                   (cond ((setq u* (lemma-prime u)) (list u*))))
			       (cdr lem)))
	    (cond ((eq '&  P) (andify lem2))
		  ((eq 'or P) (orify  lem2))))

;;NOTE: We need to change the function CHANGE-NESS, to break    13Apr95
;;      the predicates into about three categories, instead of length

	   ((< 8 (strange-ness P)) lem)   ;and change this
	   (t nil) )))


(defun length-of (u)  ;2feb95  called by print-tree
  ;;eg, (length-of '(& (p7 128) (p8 131))) = 22
  (let (m)
    (cond ((null u) 0)
	  ((numberp u) (number-of-digits u))
	  ((atom u) (length (explode u)))
	  (t (setq m (1+ (length u)))
	     (mapc #'(lambda (x) (setq m (+ m (length-of x)))) u)
	     m))))

(defun length-L (L)      ;12Apr95 like length, curved down. 3/5 power
  (let ((ln (length L)))
    (cond ((equal 1 ln) 1)
	  ((equal 2 ln) 15/10)
	  ((equal 3 ln) 19/10)
	  ((equal 4 ln) 23/10)
	  ((equal 5 ln) 26/10)
	  ((equal 6 ln) 29/10)
	  ((equal 7 ln) 32/10)
	  ((equal 8 ln) 34/10)
	  (t            37/10) )))

(defun limb-after (n# &optional (new-limb *tree*))  ;17feb95  called by hl
  ;;the limb of *tree* that starts after n#
  ;;e.g.,   (setq new-limb '(root n1 (dec etc) ((n2 a b c) (n3 d e f))))
  ;;        (limb-after 'n3 new-limb) = (d e f)
  (cdr (limb-at n# new-limb)))

(defun limb-at (n# &optional (new-limb *tree*))     ;17feb95  called by limb-after
  (let (step sub-tree new-limbi)                    ;   and insert-after and graft
    (cond ((null new-limb) nil)
	  ((eq-car new-limb n#) new-limb)
	  ((eq-car (setq step (car new-limb)) 'dec)            ;a decision step
	   ;;step= ('dec n#* k [(n#1 rank1)...(n#k rankk)])
	   (setq sub-tree (cadr new-limb))
	   ;;sub-tree= ((n#1 ...) ... (n#k ...))
	   (cond ((some #'(lambda (u) (setq new-limbi (limb-at n# u)))
			sub-tree)
		  new-limbi)
		 (t nil)))
	  (t (limb-at n# (cdr new-limb))) )))

(defun make-skolem-expresn (x V)  ;3Apr95
  (cons (new-symbol (maknam  (list x 's))) V))

(defun member*2 (x L &optional (V *V*) (V* *V*) (path nil) (nrj t))  
  ;;20 Oct 94   Called by MTXG2
  ;;If x is a member** of L, with value theta, then return theta,path.
  (let (theta py txy)
      (cond ((some #'(lambda (y) 
             (and (setq theta (equal** x y V V*))
		  (setq py (cons (list y theta) path))
		  (setq txy (list theta x y))            ;30Mar95
		  (cond ((member py *reject* :test 'equal)
			 (and nrj (format t "Reject-in-member*2~%~s~%~%" py))
			 nil)
			(t (setq *thetasxy* (cons txy *thetasxy*)) t))));1Apr95
		   L)
	   (setq *reject* (cons py *reject*))  ;5Jan95 

	   (list theta py))
	  (t nil))))

(defun memberS*2 (Ci L V V* path)    ;12Jan95  Called by MEMBER&
  ;;The result is all thetas from all W's from member*2, for this Ci.
  (let (W theta path*)
    (cond ((setq W (member*2 Ci L V V* path nil))
	   (setq theta (car W)) (setq path* (cadr W))
	   (setq *reject* (cons path* *reject*))
	   (cons theta (memberS*2 Ci L V V* path)))
	  (t nil))))

(defun n-name ()                                 ;14feb95
  (maknam (list 'n (setq *nn* (1+ *nn*)))))

(defun number-of-digits (x)  ;2feb95  called by print-it
  (cond ((< x 10) 1) ((< x 100) 2) ((< x 1000) 3) ((< x 10000) 4)))

(defun occur (a b)   ;does x occur in A?   28Mar95
    (cond ((equal a b) t)
          ((atom b) nil)
	  ((and (atom (car b)) (atom (cdr b)))
	   (or (eq a (car b)) (eq a (cdr b))))
          (t (some #'(lambda (x) (occur a x)) b))))

(defun prefer-mem-bch-lem (L)  ;20Mar95  Called by OPTIONS
  ;;L*= ([($1 P1 Cs1 name1 H*1) rank1]  ... [($k Pk Csk namek H*k) rankk])
  ;;put them in the order with mamers in the order: LEM BCH LM
  (let (L1 L2 L3)
    (setq L1 (mapcan #'(lambda (u) (cond ((eq 'LEM (cadr u)) (list u)))) L))
    (setq L2 (mapcan #'(lambda (u) (cond ((eq 'BCH (cadr u)) (list u)))) L))
    (setq L3 (mapcan #'(lambda (u) 
                 (cond ((not (member (cadr u) '(MEM BCH))) (list u)))) L))
    (append L1 L2 L3) ))

(defun print-ns (L)  ;3Mar95
  (let (n# asso)
    (cond ((null L) nil)
	  ((eq 'root (setq n# (car L))) (print-ns (cdr L)))
	  ((null n#) (print-ns (cdr L)))
	  (t (setq asso (assoc n# *storage*))
	     (format t "~%~s= ~s~%" (car asso) (cadr asso))
	     (print-ns (cdr L))) )))

(defun print-it (x)  ;2feb95  called by print-tree
  (let (n)
    (cond ((integerp x) (format t "~s" x)
	   (setq n (- 4 (number-of-digits x))) (prn n))
	  ((atom x) (format t "~s" x)
	   (setq n (- 4 (length (explode x)))) (prn n))
	  ((eq-car x '&) (format t "~s" x) (prn 1))
	  (t (format t "~%problem in print-it~%") (break)) )))

(defun prn (n)  ;2feb95  print n spaces, with no return
  (cond ((< n 1) nil)
	(t (format t " ") (prn (1- n)))))

(defun prntq (A) (let (A=) (prnt A) (setq A= (eval A)) (prnt A=) (prnt A)))

(defun rank-thetas (L)       ;30Mar95 Called by OPTIONS
  ;;L= ([($1 P1 Cs1 name1 H*1) rank1]  ... [($k Pk Csk namek H*k) rankk])
  (let (txy txyi rki L*)
    (setq txy (setq *thetasxy* (crunch *thetasxy*)))
    (setq L* (mapcar #'(lambda (u)  ;u= [($i Pi Csi namei H*i) ranik]
                (setq txyi (assoc (caar u) txy :test 'equal)) ;txyi= ($i x y)
		(setq rki (rank-xy (cadr txyi) (caddr txyi)))
		(list (car u) (* rki (cadr u))))
		     L))
    L*))

(defun rank-xy (x y)         ;30Mar95 Called by RANK-THETAS
  ;;eg, (rank-xy '(E (T32S (L23S S) (C22S S)) C25)
  ;;             '(E (T32S (L23S S) (C22S S)) C11)) = 11
  ;;    (rank-xy '(E C25 S) '(E C11 S))             =  5

  (let (rk lu lv uv vu uv+ st)
    (cond ((not (eq (car x) (car y))) (format t "~%Prob in rank-xy~%") 
	                              (break)))
    (setq rk 0)

    (setq rk (+ rk (/ (+ (strange-ness (car x)) (strange-ness (car y))) 
		      (* 2 (+ (length x) (length y))))))

    (mapc #'(lambda (u v) 
;;(prnt u v rk) (break)
         (or (and (setq lu (length* u)) (setq lv (length* v)) (equal lu lv)
		  (setq rk (+ rk lu))
		  (or (and (listp u) (listp v) (equal (car u) (car v))
			   (setq rk (+ rk lu))
			   (equal u v) (setq rk (+ rk lu)))
	              (and (eq u v) (setq rk (+ rk 3)))
		      (and (or (not (member u *V*)) (not (member v *V*)))
			   (setq rk (+ rk 1)))))
	     (and (setq uv (/ lu lv)) (setq vu (/ lv lu)) (setq uv+ (+ lu lv))
		  (or (and (> uv .7) (< uv 1.4) (setq rk (+ rk (/ uv+ 4))))
		      (and (> vu .7) (< vu 1.4) (setq rk (+ rk (/ uv+ 4))))
		      (and (< lu lv) (setq rk (+ rk (/ lu 2))))
		      (and (< lv lu) (setq rk (+ rk (/ lv 2)))) ))))
(cdr x) (cdr y))
    rk))

(defun length* (L) (cond ((atom L) 1) (t (length L))))

(defun remove2 (l i j)  ;18feb95  remove the ith and jth members of l. i<j
  ;;eg, (remove2 '(a b c d e f g) 2 4) = (a c e f g)
  (let (l*)
    (setq l* (remove (nth (1- j) l ) l  :test 'equal))
    (setq l* (remove (nth (1- i) l*) l* :test 'equal)) ))

(defun replacen (n a l) ; 28jan95 called by hl 
  ;;replace the nth member of l by a
  ;;eg, (replacen 3 'x '(a b c d e)) = '(a b x d e)
  (subst a (nth (1- n) l) l :test 'equal))
                                       ;(n#i thetai ranki resultsi argsi)

(defun replace-resultsi (sigma n#i step valuesi) ;17feb95  called by hl
  ;;replace resulti by sigma in *tree* and *storage*
  ;;valuesi= (n#i thetai Ranki Resultsi argsi)
  (let (pair pari* valuesi*)
    (cond ((null sigma) (setq pair (assoc n#i (fourth step)))   ;(n#i ranki)
	   (setq pair* (list n#i 0))
	   (setq *tree* (subst pair* pair *tree* :test 'equal))
	   (setq valuesi* (replacen 3  0  valuesi)))
	  (t (setq valuesi* valuesi)))
    (setq valuesi* (replacen 4 sigma valuesi*))  
    (setq *storage* (subst valuesi* valuesi *storage* :test 'equal))
    (insert-after n#i sigma)
    ;;eg, *tree*= (root n1 (dec etc) ((n#i nil a b c) (n#j d e f)))
    ;;                                      ^
    ))

(defun rerank-tree (n#i)   ;8Mar95  Called by HL
  ;;Lessen the ranking of any decition node that has a nil result after it
  ;;eg, *tree*= (root n0 (dec n1 2 [(n2 .6) (n3 .4)])
  ;;               ((n2 n4 (dec n5 2 [(n6 0) (n7 .3)])) (n3)))
  ;;                                      ^
  ;;Then, (rerank-tree n6) would change *tree* to something like,
  ;;eg, *tree*= (root n0 (dec n1 2 [(n2 .3) (n3 .4)])
  ;;                                     ^
  ;;               ((n2 n4 (dec n5 2 [(n6 0) (n7 .3)])) (n3)))
  ;;Note: The n2 node has a 0 ranking after it, so reduce its .6 to .3
  (let (n# dec-node rank-list pair k rank rank* pair*)
    (setq limb (head-limb-of n#i))   ;limb= (n2 n4 (dec n5 2 [(n6 0) (n7 .3)]))
    (setq n# (car limb))                     ;n#= n2           ^
    (cond ((eq 'root n#) (return-from rerank-tree nil)))
    (setq dec-node (assoc-t n#))    ;dec-node= (dec n1 2 [(n2 .6) (n3 .4))
    (setq rank-list (cadddr dec-node))       ;rank-list= [(n2 .6) (n3 .4)
    (setq pair (assoc n# rank-list))  ;pair= (n2 .6)
    (setq k (length rank-list))              ;k= 2
    (setq rank (cadr pair))                  ;rank=  .6
    (cond ((zerop k) (prnt 'k=0) (break)))
    (setq rank* (cond ((eq k 1) (/ rank 2))  ;rank*= .3
		      ((eq k 2) (/ rank 2))
		      ((eq k 3) (/ rank 2))
		      (t (* (/ (- k 2) k) rank))))
    (setq pair* (list n# rank*))            ;pair*= (n2 .3)
    (setq *tree* (subst pair* pair *tree* :test 'equal))
    (rerank-tree n#)))             

#|(setq *tree*       '(root n0 (dec n1 2 ((n2 6/10) (n3 2/5)))
                            ((n2 n4 (dec n5 2 ((n6 0) (n7 3/10)))) (n3))))
  (rerank-tree 'n6) = (ROOT N0 (DEC N1 2 ((N6 3/10) (N3 2/5)))
                            ((N2 N4 (DEC N5 2 ((N6 0) (N7 3/10)))) (N3)))
|#

(defun rest-from (node l)    ;1feb95   called by graft
  (cond ((eq node (car l)) l)
	(t (rest-from node (cdr l)))))

(defun re-rank (new-limb) new-limb)   ;17feb95   fix this soon

(defun revamp-rankings (L)   ;26jan95  called by member&
  ;;L is a set of members Li of the form,
  ;;Li= (theta Lc n1 n2 n3), where theta is a substitution, Lc is
  ;;    a list of formulas, and n1,n2,n3 are integers.  
  ;;or Li might have the form (theta Lc n1 n2) or (theta Lc n1)
  ;;we will convert the n1,n2,n3 into one x, for each Li, 0<=x<=1.
  (let (L1 L2 L3 L* L** g g* g** g2 g3 x)
    ;;eg, L= [(t C1 27 1 9) (t C2 27 1 0)]
    ;;((T (E (L23S S) C11) 8 1 0) (T (E (L24S S) C11) 8 1 0))
    (setq L1 (mapcan #'(lambda (u) (cond ((fifth u) (list u)))) L)) ;L1=L
    (setq L* (set-difference l L1))                             ;L*= nil
    (setq L2 (mapcan #'(lambda (u) (cond ((fourth u) (list u)))) L*)) ;L2=nil
    (setq L** (set-difference L* L2))                           ;L**= nil
    (setq L3 (mapcan #'(lambda (u) (cond ((third u) (list u)))) L**)) ;L3=nil
    (setq x (fourth (car L1)))                              ;x= 1
    (setq g (mapcar #'fifth L1))                            ;g= (9 0)
    (setq g* (rev x g))                                     ;g*= (4/3 2/3)
    (setq x (third (car L2)))                               ;x= nil
    (setq g2 (mapcar #'fourth L2))                          ;g2= nil       
    (setq g (append g* g2))                                 ;g=  (4/3 2/3) 
    (setq g* (rev x g))
    (setq g3 (mapcar #'third L3))
    (setq g** (append g* g3))
    (setq tg 0) (mapc #'(lambda (x) (setq tg (+ tg x))) g**)
    (setq g** (cond ((zerop tg) g**)
		    (t (mapcar #'(lambda (x) (/ x tg)) g**))))
    
    (setq L* (mapcar #'(lambda (u i) (list (car u) (cadr u) i))
		     l g**))
    L*))

#|
(setq l '((t c 1 2 3) (t c 1 2 4) (t c 1 2 5) (t c 1 3) (t c 1 5) 
	  (t c 2) (t c 3)))
(revamp-rankings l) = ((t c 223/2352) (t c 2/21) (t c 75/784) (t c 17/168) 
                       (t c 19/168)   (t c 1/5)  (t c 3/10))
(setq l '((t c 3 4 5) (t c 3 4 4) (t c 3 4 3) (t c 3 3) (t c 3 2) 
	  (t c 2) (t c 1)))
(revamp-rankings l) = ((t c 895/5304) (t c 275/1632) (t c 35/208) (t c 45/272)
		       (t c 265/1632) (t c 1/9)      (t c 1/18))
|#

(defun rev (x g)   ;26jan95   called by revamp-rankings
  ;;eg, (rev 2 '(3 4 5)) =  (27/14 2 29/14)
  ;;    (rev 2 '(5 4 3)) =  (29/14 2 27/14)
  (let (m tg g*)
    (cond ((null x) (return-from rev g)))
    (setq m (* x (length g)))
    (setq tg 0) (mapc #'(lambda (i) (setq tg (+ tg i))) g)
    (cond ((equal tg 0) (setq tg 1)))                       ;28Mar95
    (setq g* (mapcar #'(lambda (i) (* (+ x (/ i tg)) (/ m (+ m 1))))
		     g))
    g*))

(defun sko-part (A par &optional V)     ;3Apr95   Called by APP-SUBQ
  ;;eg, (sko-part '(ALL x (some y (P x y))) t) = (ALL x (P x (ys x)))
  (let (x xs A*)
    (cond ((atom A) A)
	  ((and (not (occur 'all A)) (not (occur 'some A))) A)
	  ((or (and (not par) (eq-car A 'all)) (and par (eq-car A 'some)))
	   (setq x (cadr A))
	   (list (car A) x (sko-part (caddr A) par (cons x V))))
	  ((or (and (not par) (eq-car A 'some)) (and par (eq-car A 'all)))
	   (setq x (cadr A))
	   (setq xs (cons (new-symbol (maknam (list x 's))) V))
	   (setq A* (subst xs x (caddr A)))
	   (sko-part A* par V))
	  ((member (car A) '(& or))
	   (cons (car A) (mapcar #'(lambda (u) (sko-part u par V)) (cdr A))))
	  ((eq-car A '->)
	   (list (car A) (sko-part (cadr  A) (not par) V)
		         (sko-part (caddr A)    par    V)))
	  ((eq-car A 'not) (sko-part (cadr A) (not par) V))
	  (t A))))

(defun sort-preds-fcns-consts (L1 L2) ;4feb95  called by whos-first
  (let (L* L** LL1 LL1c LL2 LL2* LL2** LL2*** LL2h LL2h* LL3 LL4 LL4* LL4h 
	   LL4h* LL5 LL6 LL6* LL2d LL3u LL4d LL5u LL6hL pc k0) 
    (setq LL1 (mapcar #'(lambda (c)   
               (setq pc (predicate-choose c L2)) (list c (length pc)))
		     L1))
    (setq LL1c (copy-tree LL1))
    (setq LL2 (sort LL1c '(Lambda (x y) (> (cadr x) (cadr y)))))
    (setq k0 (cadar LL2))   ;highest
    (cond ((zerop k0) (setq LL2 (mapcan #'(lambda (u) (list (car u) 1)) LL2))))
    (setq LL2h (mapcan #'(Lambda (u) (cond ((equal k0 (cadr u)) (list  u))))
		      LL2))
    (setq LL2*  (mapcar #'car LL2))
    (setq LL2h* (mapcar #'car LL2h))

    (cond ((equal 1 (length LL2h*)) (setq L* LL2))     ;4feb95

	  (t (setq LL2** (set-difference LL2* LL2h*))
	     (setq LL2d  (set-difference LL2 LL2h))
	     (setq LL3 (mapcar #'(lambda (c) 
               (setq pc (func-const-choose c L2)) (list c (length pc)))
			      LL2h*))
	     (setq LL3u (mapcar #'(lambda (u v) (append u (list (cadr v))))
				LL2h LL3))
	     (setq LL4 (sort LL3u '(lambda (x y) (> (caddr x) (caddr y)))))
	     (setq k0 (caddar LL4))   ;highest
	     (cond ((zerop k0)
		    (setq LL4 (mapcar #'(lambda (u) (list (car u) 1)) LL4))))
	     (setq LL4h (mapcan #'(lambda (u) 
				  (cond ((equal k0 (caddr u)) (list u))))
				LL4))
	     (setq LL4*  (mapcar #'car LL4))
	     (setq LL4h* (mapcar #'car LL4h))
	     (cond ((equal 1 (length LL4h*)) (setq l* (append LL4 LL2d)))

		   (t (setq LL2*** (set-difference LL4* LL4h*))
		      (setq LL4d (set-difference LL4 LL4h))
		      (setq LL5 (mapcar #'(lambda (u) (list u (size u)))
					LL4h*))
		      (setq LL5u (mapcar #'(lambda (u v) 
                                                (append u (list (cadr v))))
					 LL4h LL5))
		      (setq LL6 (sort LL5u
				  '(lambda (x y) (<= (cadddr x) (cadddr y)))))
		      (setq k0 (cadddr (car (last LL6))))
		      (setq LL6hl (mapcar #'(lambda (u) 
                                     (replacen 4 (- k0 (cadddr u)) u))
					  LL6))
		      (setq LL6* (mapcar #'car LL6))     ;not used
		      (setq l* (append LL6hl LL4d LL2d)) ))))
    ;;L*= ([c1 n1 n2 n3] [c2 n1 n2 n3] ...)  or only 1 or 2 n's
    (cond ((not (cddar L*)) (car L*))
	  (t (setq L** (mapcar #'(lambda (u) (cons t u)) L*))
	     ;;L**= ([t c1 n1 n2 n3] [t c2 n1 n2 n3] ...) 
	     (setq L** (revamp-rankings L**))
	     (cdar L**)) )))

(defun strange (A) (member A *strange-list*))         ;1Apr95

(defun strange-ness (A) (length (strange A)))         ;10Apr 95


(defun store (l &optional step-name values)            ;14feb95  called by hl
  (cond (step-name t)
	(t (setq *sn* (1+ *nn*))                        ;step number
	   (setq step-name (maknam (list 'n *nn*)))))   ;step name
  (cond (values (setq *values* (cons (list step-name l) *values*)))
	(t (setq *storage* (cons (list step-name l) *storage*)))) )

(defun total-ranks=1 (L)   ;30Mar95  Called by Options
  ;;L*= ([($1 P1 Cs1 name1 H*1) rank1]  ... [($k Pk Csk namek H*k) rankk])
  ;;Make the sum of the ranks = 1
  (let (tot L*)
    (cond ((null L) (return-from total-ranks=1 nil)))
    (setq tot 0)
    (mapc #'(lambda (u) (setq tot (+ tot (cadr u)))) L)
    (cond ((equal tot 0) (return from total-ranks=1 nil)))
    (setq L* (mapcar #'(lambda (u) (replacen 2 (/ (cadr u) tot) u)) L)) ))

(defun un-andify (L) (cond ((eq-car L '&) (cdr L)) (t (list L))))

(defun whos-first (LC L2 v path) ;19dec94 4feb95  called by hl 
  ;;8feb95 this is exactly the high-low.lisp version
  ;;LC is (cdr c) from hl
  (let (w LC* LCs LL LLk LLk0 Lij ci* path* theta k0 LCpc)
    (format t "~%Whos-First")
    (cond ((setq LC* (mapcan #'(lambda (ci) (setq *reject* nil)
                (cond ((member*2 ci L2 v v (cons 'who path)) (list ci))))
			     LC))
	   (setq LL (mapcar #'(lambda (ci) (setq *reject* nil)
                        (setq w (member*2 ci L2 v v (cons 'who2 path)))
			(setq theta (car w))
			(setq Lij (mapcan #'(lambda (cj) 
		           (cond ((member (apply-sub theta cj) L2 :test 'equal)
				  (list cj))))
					  LC*))
		(list ci Lij))
			    LC*))
	   (setq LLk (mapcar #'(lambda (u) (length (cadr u)))
			     LL))
	   (setq k0 (maxx LLk))             ;the largest of member of LLk
	   (setq LLk0 (mapcan #'(lambda (u)
                       (cond ((equal k0 (length (cadr u))) (list (car u)))))
			      LL))
	   (cond ((some #'(lambda (ci) 
		            (and (setq path* (cons (name ci) path)) 
				 (setq ci* ci)
				 (not (member path* *reject* :test 'equal))))
			LLk0)
		  (list ci* path*))
		 (t nil)))
	  ((setq LCpc (sort-preds-fcns-consts LC L2))
	   (cond ((some #'(lambda (ci) 
			      (and (setq path* (cons (name ci) path)) 
				   (setq ci* ci)
				   (not (member path* *reject* :test 'equal))))
			LCpc)
		  (list ci* path*))
		 (t nil)))
	  ((setq LCs (sort-strange LC))
	   (cond ((some #'(lambda (ci) 
		             (and (setq path* (cons (name ci) path)) 
				  (setq ci* ci)
				  (not (member path* *reject* :test 'equal))))
			LCs)
		  (list Ci* path*))
		 (t nil)))
	  (t nil) )))

;;---------------------------------------------------------------------------
;;--------------- This is the RANK Section -- with its functions ------------
;;---------------------------------------------------------------------------

(defun rank (Lr h-list H1* H2* H1 H2 C VC path image)         ;6Feb95
  ;;h-list is a heuristic-name list. rank-hs means ranking heuristics  
  ;;Lr= ([O1 r1] [O2 r2] ... [On rn]), Oi's are options, ri's are ranks
  (let (LL L* Lir Li*)
    (cond ((null h-list) (return-from rank Lr)))
    (setq LL (rank-partition Lr))
    (setq L* (mapcan #'(lambda (Li)
	 (cond ((equal 1 (length Li)) Li)
	       ((not (setq Lir (rank-hs  Li (car h-list) H1* H2* H1 
					 H2 C VC path image))) Li)
	       (t 
		(setq Li* (rank Lir (cdr h-list)H1* H2* H1 H2 C VC path image))
		  (sort Li* '(lambda (x y) (< (cadr y) (cadr x)))))))
		     LL))
    ;;L*= ([(...) r1] [(...) r2] ...[(...) rk]), with 0<=ri<=1.
    L*))

(defun rank-hs (L hu H1* H2* H1 H2 C VC path image)   ;6Feb95  Called by RANK
  ;;Choose the heuristic with name hu. Then to get and rank an L call hu.
  ;;The result is L*= ([(...) #1] [(...) #2] ...[(...) #k]), with 0<=#i<=1.
  (let (L* Lr r (V *V*))
    (setq r (cond ((null (cdr L)) 1) ((cadar L)) (t (/ 1 10))))
    (cond ((eq hu   'number-Cs-with-same$)         ;member& uses the first 3
	   (setq L* (number-Cs-with-same$ H1* C path V)))
	  ((eq hu   'number-C$s-proved-new@)
	   (setq L* (number-C$s-proved-new@ L H1* V)))   
	  ((eq hu   'size-theta)
	   (setq L* (size-theta L)))
	  ((eq hu   'match-image)
	   (setq L* (match-images image *lemmas)))   ;Not used (yet)
	  ((eq hu   'BCH-$P)
	   (setq L* (BCH-$P H2* C image path VC)))
	  ((eq hu   'BCH-lem-$P)
	   (setq L* (BCH-lem-$P C image path VC)))  
	  ((eq hu   'fcn-Repeats-BC)
	   (setq L* (fcn-Repeats-BC L C)))    
	  ((eq hu   'prove-Ps-by-member)
	   (setq L* (prove-Ps-by-member L H1 H2)))   
	  ((eq hu   'atom-$s-member)                 ;not used
	   (setq L* (atom-$s-member C H1&2 path)))
	  )
    ;;L*=([(...) #1] ... [(...) #k])
    (setq Lr (mapcar #'(lambda (u) (list (car u) (* r (cadr u))))
		     L*))
    Lr))

(defun rank-partition (Lr &optional (r (cadar Lr)) Li)  ;6Feb95  Called by RANK
  ;;Partition Lr into subsets with equal ranks.
  ;;eg, (rank-partition '((a .9) (b .9) (c .8) (d .7) (e .7) (f .7)))
  ;;       =             ([(a .9) (b .9)] [(c .8)] [(d .7) (e .7) (f .7)])
  (let ()
    (cond ((null Lr) (list (reverse Li)))
	  ((equal (cadar Lr) r)
	   (rank-partition (cdr Lr) r (cons (car Lr) Li)))
	  (t (cons (reverse Li) (rank-partition Lr))) )))

(defun number-Cs-with-same$ (H1* C path V)  ;7Feb95  Called by RANK-HS
  ;;$ is an abbreviation for theta                 
  ;;C has the form (& C1 ... Cn)
  ;;This counts the number of these Ci's that are proved by Member
  (let (LC c-ths c-ths* thetas thetas* L0 L1 L2 L3 cs len rank)
    (setq LC (cdr C))
    (cond ((not (setq c-ths (crunch (mapcan #'(lambda (Ci) 
                             (setq *reject** *reject*)
			     (setq *reject* nil)
			     (setq thetas (crunch (memberS*2 Ci H1* V V path)))
			     (setq *reject* *reject**)
			     (cond (thetas 
				    (list (list Ci thetas)))))
				  LC)))) ;c-ths= ([C1 ($1 $2)] [C2 ($3 $4)]...)
	   (return-from number-Cs-with-same$ nil)))
;;(prnt c-ths) (break)
    ;;c-ths= ([C1 ($1 $2)] [C2 ($3 $4)]...)
    (setq c-ths* (copy-tree c-ths))
    (setq thetas* (crunch (mapcan #'(lambda (u) (cadr u)) c-ths*)))
    (setq L0 (mapcar #'(lambda (th) 
			  (setq cs (mapcan #'(lambda (cth)
                              (cond ((member th (cadr cth) :test 'equal)
				     (list (car cth)))))
				   c-ths))
		  (list th cs))
			thetas*))
    ;;L0= ([$ Cs] [$ Cs] ... [$ Cs])    
    ;;Cs are the Ci's which were proved BY THAT SAME $ (theta)
    (setq L1 (mapcar #'(lambda (thc)
                   (list (car thc) (set-difference LC (cadr thc))))
			 L0))
    ;;L1= ([$ Cs] [$ Cs] ... [$ Cs])    
    ;;Cs are the Ci's which are to be proved
    (setq len (length LC))
    (setq L2 (crunch (mapcar #'(lambda (pr) 
	      (setq rank (cond (len (/ (- len (length (cadr pr))) len))
			       (t 1)))                ;7Apr95 (/ ... len)
	      (list pr rank))
			     L1)))
    ;;L2= ([($ Cs) #] [($ Cs) #] ... [($ Cs) #])
    (setq L3 (sort L2 '(lambda (x y) (< (cadr y) (cadr x))))) 
    (setq k0 (cond ((zerop (cadar L3)) .1) (t (cadar L3))))       ;The largest
    (setq L4 (mapcar #'(lambda (u) (list (car u) (/ (cadr u) k0))) L3))
    ;;L4= ([($ Cs) #] [($ Cs) #] ... [($ Cs) #])
    L4 ))

(defun number-C$s-proved-new@ (L H1* V) ;7Feb95             Called by RANK-HS
  ;;$ an @ are abbreviations for theta and sigma           Used by LEMMAS
  ;;L= ([($ Cs) #] [($ Cs) #] ... [($ Cs) #]) 
  ;; 0< # <=1,is the same in each pair ($ Cs)
  ;;The # is the number of the C$s proved by Member*2 with a new sigma.
  (let (k L2 L3 theta Cs n m mn bn)
    (setq k (cadar L))                       ;The ranking # of each
    (Setq L2 (mapcar #'(lambda (u)    ;u= [($ Cs) rank]
		    (setq theta (caar u)) (setq Cs (sublis theta (cadar u)))
		    (setq n 0) 
		    (setq m (length Cs))
		    (mapc #'(lambda (Ci) (cond ((member*2 Ci H1*)
						(setq n (1+ n)))))
			  Cs)
		    (setq mn (- m n))
		    (setq bn (cond ((equal 0 mn) 1) (t (* k (/ mn m)))))
		    (list (list theta Cs) bn))
		     L))
    (setq L3 (sort L2 '(lambda (x y) (< (cadr y) (cadr x)))))
    (cond ((zerop (cadar L3)) (setq L3 (mapcar #'(lambda (u) (list (car u) .1))
					       L3))))
    ;;L3= ([($ Cs) #] [($ Cs) #] ... [($ Cs) #]) 
    L3))

(defun size-theta (L)    ;7Feb95  Called by RANK-HS, used by LEMMAS
  ;;Called after L is obtained by NUMBER-Cs-WITH-SAME@, ATOMS-Ps-BY-MEMBER
  ;;L= ([($ ...) #] [($ ...) #] ... [($ ...) #])
  (let (k L2 L3 L4 theta sn sn* sn0)
    (setq k (cadar L))
    (setq L2 (mapcar #'(lambda (u)           ;Chs smallest theta
	                    (setq theta (car u))	            
			    (setq sn (size (andify (mapcar #'cdr theta))))
			    (list (car u) sn))
		     L))
    (setq sn0 0) (mapc #'(lambda (u) (setq sn0 (+ sn0 (cadr u))))
		       L2)                ;sn0= largest sn  4Feb95
    (setq L3 (mapcar #'(lambda (u) (setq sn (cadr u))
	                    (setq sn* (* k (/ sn sn0)))
			    (list (car u) sn*))
		     L2))
    (setq L4 (sort L3 '(lambda (x y) (< (cadr y) (cadr x)))))
    ;;L4= ([($ ...) #]   [($ ...) #]   ... [($ ...) #])
    ;;L4= ([($ P lem) #] [($ P lem) #] ... [($ P lem) #]) LEMMAS Case
    L4))

(defun size (a)       ;used in ANS, SIZE-THETA
  (cond ((atom a) 1)
	((atom (cdr a)) (+ 1 (size (car a)) (size (cdr a))))
        (t (+ (length a) (size (car a)) (size (cdr a))))))

(defun match-image (image lemmas) nil)     ;not defined or used yet

(defun BCH-$P (H2* C image path VC)    ;8Feb95  Called by RANK-HS
  ;;C= (& C1 C2 ... Cn)
  (let (L2 L3 L* Csi)
    (setq L3 (crunch (mapcan #'(lambda (Ci)
		      (setq *reject** *reject*)
		      (setq *reject* nil)         ;5Apr95 - atomics only
		      (setq L2 (cond ((atomic Ci) (BCHs H2* Ci image nil VC))))
		      (setq *reject* *reject**)
		      (setq Csi (remove Ci (cdr C) :test 'equal))
		      (setq L2 (mapcar #'(lambda (u)    ;u= [$ P H*]
                                   (insertn u 3 Csi))   ;   [$ P Csi H*]
				       L2)))
			     (cdr C))))
    ;;L3= ([$ P CSi H*] [$ P CSi H*] ... [$ P CSi H*])
    (setq L* (mapcar #'(lambda (u)                  
                (list (insertn u 4 'BCH) 1))   ;[($ P CSi 'BCH H*) 1]
		     L3))
    ;;L*= ([($ P Cs'BCH H*) 1] [($ P Cs 'BCH H*) 1] ... [($ P Cs 'BCH H*) 1])
    L*))

(defun BCH-lem-$p (C image path VC)  ;6Mar95 Called by RANK-HS
  (let (L2 L3 L4 L5 L* lem Csi v*)
;;(prnt 'bch-lem L* 'bch-lem 1) (break)
    (setq L4 (crunch (mapcan #'(lambda (lm) (setq lem (evalr lm))
			 (setq L3 (mapcan #'(lambda (Ci) 
			        (setq *reject** *reject*)
				(setq *reject* nil)
				(setq L2 (BCHs lem Ci image nil VC))
				(setq *reject* *reject**)
				(setq Csi (remove Ci (cdr C) :test 'equal))
				(setq L2 (mapcar #'(lambda (u) ;u= [$ P H*]
                                   (insertn u 3 Csi))          ;   [$ P Csi H*]
						 L2)))
					  (cdr C)))
			 (setq L3 (crunch L3))
			 ;;L3= ([$ P Cs H*]  ... [$ P Cs H*]) 
			 (cond (L3 (list (list lm L3)))))
			     *lemmas**)))

    ;;L4= ([lm ([$ P Cs H*] ...[$ P Cs H*])] ...
    ;;     [lm ([$ P Cs H*] ...[$ P Cs H*])])
    (setq L* (mapcan #'(lambda (pr)           ;pr= [lm ([$ P Cs H*] ...[...])]
		  (setq lm (car pr))
		  (setq L5 (mapcar #'(lambda (v)             ;v= [$ P Cs H*]
			(setq v* (insertn v 4 lm))        ;v*=[$ P Cs lm H*]
			(list v* 1))
				   (cadr pr)))
		  ;;L5= ([($ P Cs lm H*) 1] ... [($ P Cs lm H*) 1])
		  L5)
		     L4))
    ;;L*= ([($ P CS lm H*) 1] ... [($ P Cs lm H*) 1])
;;(prnt 'bch-lem L* 'bch-lem 2) (break)
    L*))

(defun BCHs (H2* C image path VC)    ;8Feb95 Called by BCH-$P
  (let (L path* W)
    (setq L (cond ((setq W (BCH H2* C image path VC))   ;W=(theta P path H*)
		   (cons (list (car W) (cadr W) (cadddr W)) ;(theta P H*)
			 (BCHs H2* C image path* VC)))
		  (t nil)))
    ;;L= ([theta P H*] ... [theta P H*])
    L))

(defun bch (H C image path VC)  ;3Nov94   Called by HL. 
  ;;We have both bch and bch*, only for tracing.     
;;  (format t "~%BCH~%")
  (bch* H C image path VC))

(defun bch* (H C image path VC &optional VH P H*)  ;2Nov94 Called by BCH
  ;;Note that IMAGE is NOT used by BCH*  (maybe later)
  (let (path-u path-h& path-all path-some theta P* H** h# W 
	       xs x (V (union-w VC VH)) nhct tCH)
    (cond ((and (setq theta (unify-v H C V))
		(setq tch (list theta C H))            ;1Apr95
		(setq P* (apply-subs-q theta P t))
		(setq nhct (list (name H) (name C) (name P*) theta))
		(setq path-u (cons nhct path))
		(cond ((member path-u *reject* :test 'equal)
;;		       (format t "~%Reject-in-bch~%~s~%" path-u) 
		       nil) 
		      (t t))) ;1Apr95
	   (setq *reject* (cons path-u *reject*))
	   (setq H** (apply-subs-q theta H* nil))
;;(prnt 'bch* tch 'bch*) (break)
	   (setq *thetasxy* (cons tch *thetasxy*))
	   (list theta P* path-u H**))         ;($ P path H*)

	  ((atom H) nil)

	  ((and (eq-car H '&)
		(setq path-h& (cons 'h& path))
		(cond ((member path-h& *reject* :test 'equal)
		       (format t "~%Rejected from BCH*&~%")
		       (return-from bch* nil))
		      (t t)))
	   (cond ((some #'(lambda (Hi) 
                           (and (subset (predicate-symbols C) 
					(predicate-symbols Hi))
				(setq W (bch* Hi C image 
					     path VC VH P H))))
			(cdr H))               
		  W)
		 (t (setq *reject* (cons path-h& *reject*)) nil)))

	  ((eq-car H '->)                 ;6Jan95  trying today only. see next
	    (bch* (caddr H) C image  path VC VH 
		     (and-on (cadr H) P) H*))
#|
	  ((eq-car H '->) 
	   (or (bch* (caddr H) C image  path VC VH 
		     (and-on (cadr H) P) H*)
	       (bch* (not-fcnf (cadr H)) C image path VC VH 
		     (and-on (not-fcnf (caddr H)) P) H*)))
|#
	  ((eq-car H 'or) 
	   (or (bch* (cadr H) C image path VC VH
		     (and-on (not-fcnf (rest-&or H)) P) H*)
	       (bch* (rest-&or H) C image path VC VH
		     (and-on (not-fcnf (cadr H)) P) H*)))

	  ((eq-car H 'all)
	   (bch* (caddr H) C image path VC (cons (cadr H) VH) P H*))

	  ((eq-car H 'some)
	   (setq xs (make-skolem-expresn (setq x (cadr H)) VH))   ;(xs ...)
	   (setq H** (subst xs x (caddr H) :test 'equal))
	   (bch* H** C image path VC VH P H*))

	  ((eq-car H 'not) nil)                            ;later

	  (t nil) )))

(defun fcn-repeats-BC (L C)          ;8Feb95  Called by RANK-HS
  ;;L*= ([($ P Cs 'BCH H*) 1] [($ P Cs 'BCH H*) 1] ... [($ P Cs 'BCH H*) 1])
  (let (P u1 rpts L2 u* L*)
    (setq L2 (mapcar #'(lambda (u) (setq u1 (car u))
                                   (setq P (cadr u1))
			           (setq rpts (fcn-repeats C P))
				   (list u rpts))
		     L))
    (cond ((every #'(lambda (u) (zerop (cadr u))) L2) (setq L* L))
	  (t (setq L* (mapcar #'(lambda (u) ;u=([($ P Cs 'BCH H*) 1] rpts)
                   (cond ((zerop (setq rpts (cadr u))) (car u))
			 (t (setq u* (car u))   ;u*= [($ P Cs 'BCH H*) 1]
			    (list (car u*) (/ (cadr u*) (* 2 rpts))))))
			      L2))))
    ;;L*= ([($ P Cs 'BCH H*) #] [($ P Cs 'BCH H*) #] ... [($ P Cs 'BCH H*) #])
    L*))

(defun fcn-repeats (C P)            ;1Feb95  Called by BCH-ors and LEMMAS
  ;;eg (fcn-repeats '(foo (goo x (fnc y z)))  '(foo (goo x (fnc (fnc u v) z))))
  ;;   = 1, if no repeats, else  = 0
  ;;We probably need to enlarge this to 1, 1/2, 0 (and change COMBINE-RANKS)
  (cond ((setq fsp (function-symbols P))
	 (cond ((setq fsrp (fcn-rps fsp P))
		(setq fsc (function-symbols C))
		(cond ((set-intersection fsc fsrp) 1)
		      (t 0)))
	       (t 0)))
	(t 0)))

(defun fcn-rps (fs P)               ;1Feb95  Called by FCN-REPEATS
  (mapcan #'(lambda (f) (cond ((fcn-rp f P) (list f)))) fs))

(defun fcn-rp (f P)                 ;1Feb95  Called by FCN-RPT
  (cond ((eq-car P f) (cond ((occur f (cdr P)) t) (t nil)))
	((atom P) nil)
	((not (atom (car P))) (format t "~%Prob in fcn-rp~%") (break))
	((some #'(lambda (u) (fcn-rp f u)) (cdr P)) t)
	(t nil)))

(defun prove-Ps-by-member (L H1 H2)   ;4Apr95  Called by RANK-HS
  ;;L*= ([($ P Cs 'BCH H*) #] [($ P Cs 'BCH H*) #] ... [($ P Cs 'BCH H*) #])
  ;;In either case, add H* to H1 and H2  
  ;;Note that P will HAVE to be proved; if it H* is the FC of P against an H
  (let (P L2 L* rank0 H* H12 LH1* LH2* H1* H2* Cs L*u)
    (setq L2 (mapcan #'(lambda (u) 
                     (setq u1 (car u))  ;u1= [($ P Cs 'BCH H*) #]
		     (setq P (cadr u1))   
		     (setq H* (fifth u1))
		     (setq H12 (atomics-pair H*))      ;22Mar95
		     (setq H1* (and-on (car H12)  H1))
		     (setq H2* (and-on (cadr H12) H2))
		     (cond ((eq t P)
			    (setq *H** (cons H* *H**))
			    (setq Cs (caddr u1))
			    (setq L*u (member& H1* (andify Csi) nil *V*))
			    ;;L*u= ([($ t Cs 'mem nil) #]...
                            ;;                          [($ t Cs 'mem nil) #])
			    (setq L*u (subst 'BCH 'MEM L*u))
			    ;;L*u= ([($ t Cs 'BCH nil) #]...
			    ;;                          [($ t Cs 'BCH nil) #])
			    L*u)

			   (t (andify (predicate-choose P H1*))
                                                                      ;5Apr95
			      (setq H2* (andify (predicate-choose P H2*))) 
			      (setq *reject** *reject*)
			      (setq *reject* nil)
			      (setq rank (prove-by-member P H1* H2*))
			      ;;The number of Pi's proved with same $
			      (setq *reject* *reject**)
			      (list (list u1 (* (cadr u) rank))))))
		     L))
    ;;L2= ([($ P Cs 'BCH H*) #] ... [($ P Cs 'BCH H*) #])
    (cond ((every #'(lambda (u) (zerop (cadr u))) L2)
	   (setq rank0 (/ 1 (length L2)))
	   (setq L* (mapcar #'(lambda (u) (list (car u) rank0)) L2))
	   (return-from prove-Ps-by-member L*)))

    (setq rank0 0) (mapc #'(lambda (u) (setq rank0 (max rank0 (cadr u)))) L2)
    (setq L* (cond ((equal rank0 0) L2)
		   (t (mapcar #'(lambda (u) (list (car u) (/ (cadr u) rank0)))
			      L2))))
    ;;L*= ([($ P Cs 'BCH H*) #] ... [($ P Cs 'BCH H*) #])
;;(prnt 'prove- L* 'prove-) (break)
    L*))

(defun prove-by-member (P H1 H2)   ;10Nov94   Called by lemmas
  ;;9Mar95  Count the number m of members of (cdrr P) which are proved by
  ;;        member*2 using H1, with NON-CONFLICTING thetas (ie, the same $)
  (let (LP n m W theta LP* LP** k)
    (setq LP (cdrr P))                 ;eg, P=(& a b c), LP=(a b c)
    (setq n (length LP))
    (cond ((or (eq t H1) (null H1)) (return-from prove-by-member 0))
	  ((equal 1 n) 
	   (return-from prove-by-member (cond ((member*2 P H1 *V* *V* nil) 1)
					      (t 0)))))         ;7Apr95 1
    (setq m 0)
    (mapc #'(lambda (u) 
	      (cond ((setq W (member*2 u H1 *V* *V* nil))
		     (setq theta (car W)) 
		     (setq LP* (remove u LP :test 'equal))
		     (setq LP* (apply-sub theta LP*))
		     (setq H1* (apply-sub theta H1))        
		     (cond ((null 
			     (setq LP** (set-difference LP* H1* :test 'equal)))
          	    (return-from prove-by-member 1))) ;all proved   7Apr95 1
		     (setq k (- n (length LP**)))
		     (setq m (max m k)))))
	  LP)                                        ;7Apr95  (/ m n)
    (/ m n)))                                       

(defun atom-$s-member (C H1&H2 path)   ;8Fet95  Called by RANK-HS  NOT USED
  (let (thetas L*)
    (setq *reject** *reject*)
    (setq thetas (crunch (memberS*2 C H1&2 V V path)))
    (setq *reject* *reject**)
    (cond ((not thetas) nil)
	  (t (setq L* (mapcar #'(lambda (th) (list (list th) 1)) thetas))))
    ;;L*= ([($) 1] [($) 1] ... [($) 1])
    L*))

;;--------------------- Some Results --------------------------------

;; prex4  1.8 Seconds  10Mar95
;; prex5  2.4   "         "

;; After partially working to better the RANKINGS and break the ties 
;; Pr8-0  51 Sec       5Apr95   One retrace on *tree*;; Pr8   
;; Pr82  206  "        6  "


