
;;                       high-low2-tree.lisp                  21Jan95

;;$$;; This is a very preliminary version of high-low-tree.  14Feb95
;; Details, many not needed.  See high-low-tree.lisp for the real version.

;; See the end of this file for the RESULTS of this prover.   21Jan95
#|
 This is new version of the prover in high-low.lisp.  
 Many (most) of the concepts found there are used here.
 See that file and files high-low6.lisp, 5, etc for excplanations.
 See DOCUMENDATION below for a brief explanation of how this version
 uses a proof-tree, with values at its nodes and branches, to 
 determine how to proceed with the proof.

Loading:  

(load "imply.lisp")(ls)(lu)(lp)(le)                               ;(lplns)
(lres)(lpi)(lpci)(lop)(lsg)(lpbr)(lppc)(lpc)(lpbe)(lpLe)
;(load "print-float.lsp")
(lf)(lfo)(lgr)(lm2)(lehl)(lp)(leq)(lhl2)(lhlt)

|#
(defun lhlt () (load "high-low-tree.lisp"))
(defvar *FOL-version* t)
(defvar *strange-list* 
 '(nu clause-L clause clauses-L clauses exp << <<= < <= e))   
                                    ;This list needs to be lengthened  26Dec94

(setq   *repeats-limit* 40)
(setq *gv* *grind*-version*)
(defvar *types* nil)
(defvar *lemmas* nil)
(defvar *lemmas-names* nil)
(defvar *save-lemmas* nil)
(defvar *lemmas-used* nil)
(defvar *reject*  nil)
(defvar *reject** nil)
(defvar *n* 20)
(defvar *lemn* 0)                                   ;20Jan95
(defvar *nn* 0)                                     ;23Jan95 node number
(defvar *nodes* nil)
(defvar *sn* 0)                                     ;23Jan95 step number
(defvar *steps* nil)
(defvar *storage* nil)
(defvar *tree* nil)


(defun prove-HL (Thm &optional H Lemmas copies Lm) ;Main Call  2Sept94
  (let (Thm* thm** thm*** H* W lemmas* number-of-lemmas pv nl W k Hi= Hi> 
	     H1 H2 H12)
    (setq *reject* nil)
    (setq *save-lemmas* nil)
    (setq *lemmas-used* nil)
    (setq %theorem-variables% nil)
    (setq *n* 20)
    (setq *lemn* 0)
    (setq *repeats* 0)
    (setq *MINIMAL-IMAGE-MATCH* 1)
    (cond ((eq t Lemmas) (setq Lemmas nil)))   ;4 Oct 94
    (setq thm* (imp-on H thm))
    (cond ((and lemmas (eq-car lemmas 'exs-from-to)) 
	   (setq lemmas (exs-from-to (cadr lemmas) (caddr lemmas)
				     (cadddr lemmas) (fifth lemmas)))))
    (and copies (setq lemmas (union-n lemmas copies)))
    (and lm (setq lemmas (append (remove lm lemmas :test 'equal) (list lm))))
    (setq number-of-lemmas (length lemmas)) (prnt number-of-lemmas)
    (setq lemmas* (mapcar #'(lambda (u) (cond ((atom u) (eval u)) (t u)))
			  lemmas))
    (setq lemmas* (mapcar #'replace-multiple-quantifiers lemmas*))

    (setq thm** (imp-on (andify lemmas*) thm*))
    (setq thm** (sublis '((< . <<) (<= . <<=)) thm**))
;;    (setq thm** (reducef (unique-ize-quan-vars thm**)))   ;8 Oct 94
    (setq thm** (unique-ize-quan-vars thm**))               ;8 Oct 94
    (setq *V* (unifiable-variables Thm**))
    (setq pv (predicate-symbols thm**))    ;15Sept94
    (setq *types* (types Thm**))                            ;7Nov94
    (prnt *types*)
    (setq pv (set-difference pv *predicate-list*))
    (setq *predicate-list* (append pv *predicate-list*))
    (cond (lemmas (setq thm* (caddr thm**))
		  (setq *lemmas* (un-andify (cadr thm**))))
	  (t (setq thm* thm**) (setq *lemmas* nil)))
    (cond ((eq-car Thm* '->) 
	   (setq H* (cadr Thm*)) (setq Thm* (caddr Thm*))))
    (cond ((eq-car Thm* '->) 
	   (setq H* (and-on (cadr Thm*) H*)) (setq Thm* (caddr Thm*))))
    (setq H* (forward-chain-on H*))                        ;8 Oct 94
    (setq *lemmas* (subst '<< '< (subst '<<= '<= *lemmas*)))
    (cond (*FOL-version* (setq *matrix-version* t)))
    (cond (*grind*-version* (setq *grind-version* t)))
    (cond (*matrix-version* (setq *grind*-version* t)
			    (setq *grind-version* t)))

    ;;%%%%%%%%%%%%% Here we use only the FOL-version %%%%%%%%%%%%%%
    (cond (*FOL-version* 
	   (setq *lemmas* (mapcar #'(lambda (u) (list u (image u))) 
				    *lemmas*))
	   (setq H12 (atomics-pair H*))
	   (setq H1 (car H12)) (setq H2 (cadr H12))
	   (cond ((null (setq W (HL-tree H1 H2 thm* 'first))) nil)
		 (t '[]))))))

(defun HL-tree (H1 H2 C &optional flag)  ;2Feb95  Called by PROVE-HL	
  (let (path0 L ans)
    (setq path0 (list 'root 1))
    (cond ((eq flag 'first) (setq *tree* path0)))
    (setq L (list H1 H2 C path0 *tree* nil flag))
    (cond ((eq 'back (setq ans (HLL L))) (HL-tree H1 H2 C))
	  (t ans)) ))

(defun HLL (L)    ;23Jan95 9Feb95  Called by, and calls, HL
  (apply 'HL L))

;;HL HL HL HL HL HL HL HL HL HL HL HL HL HL HL HL HL HL HL HL HL HL HL HL 

(defun HL (H1 H2 C path tree VC &optional flag)    ;26Jan95
  ;;tree is guiding the proof.
  ;;HL now return only THETA (or nil or 'back)
  (let ((args0 (list H1 H2 C path tree VC)) step) $ 
(cond ((eq C t) (return-from HL t)))

(cond 
  (tree                                         ;HL is now following the tree
   (cond ((numberp (setq step (car tree)))
	  (setq path* (cons step path)) 
	  (HL H1 H2 C path* (cdr tree) VC flag))

 	 ((atom step) (setq n# step)                        ;REGULAR step
	  (setq L (cadr (assoc n# *storage*))) (HHL L))

	 ((eq-car step 'dec) (setq n# (cadr step))          ;DECISION step
	  ;;step= (n# args 'decision k [(n#1 Ranking1 Result1) ...   $$$ 
          ;;                            (n#k Rankingk Resultk)])
	  (setq limbi (best-limbi (fifth step)))            ;highest ranking
	  (setq n#i (car limbi)) 
	  (setq triple (cadr (assoc n#i *storage*)))
	  (setq thetai (cadr triple))             ;triple= (n#i thetai argsi)
	  ;;thetai is that substitution used originally to select that option.
	  (setq argsi (caddr triple))             ;argsi= (H1 H2 C nil nil VC)
	  (setq L (replacen 4 path (replacen 5 limbi argsi)))
                                                   ;L = (H1 H2 C path limbi VC)
	  (setq theta (HHL L))
          (cond ((eq 'back theta) (return-from HL 'back))
		((null theta) 
		 (replace-resultsi nil n# n#i) (return-from HL nil))
		(t (setq sigma (compose theta thetai))
		   (replace-resulti sigma n# n#i) 
                                          ;replace resulti by sigma in *tree*
		   (return-from HL sigma)))) 

	 ((eq-car step '&)    		;& step  step= ('& n#1 $$$
	  (setq n# (cadr step))
	  (setq 5-tuple (cadr (assoc n# *storage*))) 
          ;;5-tuple= (n# args '& m [(n#1 args1 Results1) (n#2 args2 Results2)])
	  (setq pair (fifth 5-tuple))
	  (cond ((eq 'not-tried (caddr (car pair)))
		 (setq triple (car pair)) (setq n 1)
		 (setq args1 (cadr triple))
		 ;;Replace something in args1?
		 (setq theta1 (HHL args1))
		 (cond ((eq 'back theta1) (return-from HL 'back))
		       ((null theta1) $$$


		((t (setq triple (cadr pair)) (setq n 2))))

$$$   5PM 8Feb95  I seem to be here.

 (setq n# (car step)) (setq args (cadr step))
           (setq args (cadr (assoc args *storage*)))
	   ;;args= (H1* H2* C* path* tree* VC*)
	   (setq H1* (car args)) (setq H2* (cadr args)) (setq C* (caddr args))
	   (setq path* (cadddr agrs)) (setq tree (fifth args))
	   (setq VC* (sixth args))
           (setq more (caddr step))   ;more= 'decision or '&
           (or (and (eq more 'decision) (setq k (cadddr step)) ;not needed here
		                        (setq nRRs (fifth step)))
	       (and (eq more '&)        (setq m (cadddr step)) ;not needed here
		                        (setq naRs (fifth step)))))


(and tree (setq step (car tree)) (setq n# (car step)) (setq args (cadr step))
           (setq args (cadr (assoc args *storage*)))
	   ;;args= (H1* H2* C* path* tree* VC*)
	   (setq H1* (car args)) (setq H2* (cadr args)) (setq C* (caddr args))
	   (setq path* (cadddr agrs)) (setq tree (fifth args))
	   (setq VC* (sixth args))
           (setq more (caddr step))   ;more= 'decision or '&
           (or (and (eq more 'decision) (setq k (cadddr step)) ;not needed here
		                        (setq nRRs (fifth step)))
	       (and (eq more '&)        (setq m (cadddr step)) ;not needed here
		                        (setq naRs (fifth step)))))

(cond ((and tree (not more))                ;an ordinary step  Case B 1
       (return-from HL (HL H1* H2* C* path* tree* VC*)))

      ((and tree nRRs)      ;the tree, DECISION case          Case B 2
       (setq next-step (cadr tree))
       (setq n#i (car next-step)) (setq thetai (cadr next-step))
       (setq argsi (caddr next-step))
       (setq sigma (HHL argsi))
       (cond ((eq 'back sigma) (return-from HL 'back)))
       (setq TH (compost thetai sigma))
       (setq nRR (assoc n#i nRRs))                ;nRR= (n#i Rankingi Resulti)
       (setq nRR* (subst TH (caddr nRR) nRR))     ;nRR*=(n#i Rankingi theta)
       (setq *tree (subst nRR* nRR *tree* :test 'equal))
                             ;put (compose thetai sigma) for Resultsi in *tree*
       (return-from HL TH))  ;and retune that composure for HL

      ((and tree naRs)        ;the tree, & case                 Case B 3
       (setq naR1 (car naRs))                      ;naR1= (n#1 args1 Result1)
       (setq naR2 (cdar naRs))                     ;naR2= (n#2 args2 Result2)
       (setq n#1 (car naR1)) (setq n#2 (car naR2)) 
       (setq next-step (cadr tree))
       (setq n#i (car next-step)) (setq argsi (cadr next-step))
       (setq argsi (subst (cons n#i (cdddr argsi)) (caddr argsi) agrsi
			                         :test 'equal))
       (setq theta (HHL argsi))
       (cond ((null theta) (return-from HL nil))
	     ((eq 'back theta) (return-from HL 'back)))
       (cond ((equal n#i n#1)                          ;i=1
	      (setq H1** (apply-substitution-q theta H1*))
	      (setq H2** (apply-substitution-q theta H2*))
	      (setq C**  (apply-substitution-q theta C*))
	      (setq path** (cons naR2 path*))
	      (setq theta2 (HL H1** H2** C** path** nil VC*))
	      (cond ((null theta2 (return-from HL nil)))
		    ((eq 'back theta2) (return-from HL 'back))
		    (t (setq theta (compose theta theta2))
		       (return-from HL theta)))))
	     ((equal n#i n#2)                          ;i=2
	      (setq theta1 (caddr naR1))
	      (setq theta (compose theta1 theta))
	      (return-from HL theta))
	     (t (format t :"%A problem in HL tree naRS~%") (break))))
      (tree (format t :"%A problem in HL tree all~%") (break)))


;;Now tree= NIL	
(cond 
  ((eq-car C '->)
   (setq H12 (atomics-pair (cadr C)))
   (or (setq HC1 (and-on (car H12)  H1)) t)
   (or (setq HC2 (and-on (cadr H12) H2)) t)
   (setq path-> (cons '-> path))
   (setq L (list HC1 HC2 (caddr C) path-> nil VC))
   (store L)        ;STORE represents L as a symbol, and stores that in *storage*
   (HLL L))         ;HHL calls HL with arguments listed in L

  ((eq-car C 'or)
   (setq H12 (atomics-pair (not-fcnf (cadr C))))
   (setq H21 (atomics-pair (not-fcnf (rest-&or C))))
   (or (and (setq L (list (and-on (car H21) H1) (and-on (cadr H21) H2)
			  (cadr C) (cons 'or1 path) (cdr tree) VC))
	    (store L) (HLL L))
       (and (setq L (list (and-on (car H12) H1) (and-on (cadr H12) H2) 
			  (rest-&or C) (cons 'or2 path) (cdr tree) VC))
	    (store L) (HLL L))))

  ((eq-car C 'not) nil)		;later

  ((eq-car C 'some)
   (setq path-s (cons 'some path))
   (setq L (list  H1 H2 (caddr C) path-s (cdr tree) (cons (cadr C) VC)))
   (store L) (HLL L))

  ((eq-car C 'all)
   (setq xs (make-skolem-expresn (setq x (cadr C)) VC)) ;(xs ...)
   (setq C* (subst xs x (caddr C) :test 'equal))
   (setq path-all (cons 'all path))
   (setq L (list H1 H2 C* path-all (cdr tree) VC))
   (store L) (HLL L))

  (cond ((member H2 *lemmas-names*)              ;this is impossible
	 (format t "~%LEMMA-NAME= ~s~%" H2) 
	 (setq H2 nil))
	((some #'(lambda (hi) (and (setq hi* hi) (member hi *lemmas-names*)))
	       H2)
	 (format t "~%LEMMA-NAME= ~s~%" hi*) 
	 (setq H2 (remove hi* H2))))

  ((and (setq LH1* (predicate-choose C H1)) ;name things
	(setq LH2* (predicate-choose C H2)) 
	(setq H1* (cond (LH1* (andify LH1*))))
	(setq H2* (cond (LH2* (andify LH2*))))
	(setq LH** (append LH1* LH2*)) nil))
    
  ((member C LH**) (prnt 'C-in-H) t)                     ;t only, 27Jan95
  ((and (eq-car C '&) 
	(null (setq CL* (set-difference (cdr C) LH** :test 'equal))))
   (format t "~%All Ci's in H~%~%") t)
  ((and (eq-car C '&) (not (equal CL* (cdr C))))
   (setq Cs-in-H (set-difference (cdr C) CL* :test 'equal))
   (prnt Cs-in-H) (format t "~%") (setq C* (andify CL*))
   (setq L (list  H1 H2 C* (cons 'Css path) tree VC))
   (store L) (HLL L))
  ((and (eq-car C '&)
	(not (equal C (setq C* (andify (crunch (cdr C)))))))
   (prnt '&crunch)          
   (setq L (list H1 H2 C* (cons 'crn path) tree VC))
   (store L) (HLL L))

;;------------------ Now try MEMBER*2--------------- (not (eq 'rj flag)) ??  
((and (atomic C)    
	(setq L* (member-ts C LH** *V* *V* path)))
    ;;L*= [(theta ranking) ... (theta ranking)]
   (cond ((equal 1 (setq k (length L*))) (return-from HL (caadr L*))))
   ;;From here, this is somewhat like members& 
   (setq n# (maknam (list 'n (setq *nn* (1+ *nn*)))))    ;decision step name
   (setq *decision-step-names* (cons n# *decision-step-names*))
   (setq tup2 (mapcar #'(lambda (u) 
                   (setq n#i (maknm (list 'n (setq *nn* (1+ *nn*)))))
		   (list n#i (cadr u) 'not-done))
		      L*))
   (setq 5-tuple (list n# args0 'decision k tup2))        ;The 5-tuple
   (store 5-tuple n#)                                     ;add it to *storage*
   (setq sub-tree (list 's ub-tree (mapcar #'(lambda (u v)
                             (setq thetai (car u)) (setq n#i (car v))
                             (setq Ci t)
			     (setq H1** (apply-subs-q thetai H1*))
			     (setq H2** (apply-subs-q thetai H2*))
			     (setq pathi (cons n#i path))
			     (setq argsi (list H1** H2** Ci pathi nil VC))
			     (list n#i argsi))
					  L* tup2)))
   (setq n#st (maknam (list 'n (setq *nn* (1+ *nn*)))))    
   (store sub-tree n#st)
   (setq branch (reverse (append '(n#st n#) path)))
   (graft branch)   ;to *tree*
   (return-from HL 'back))

  ((and nil (or (eq flag 'first)	;nil now, handle this later
		(and (not (eq flag 'rj)) (ground-v C *V*)))
	(setq ans (time (otter-prove C   
		     :inference-rules '(binary_res)
		     :time 10 :factor t :base-axioms (and-on H1 H2))))
	(eq-car ans t))			;Proved by otter
   (setq path-ot (cons 'otter path))
   (list t path-ot))

  ((atom C) nil)

;;-------------------- Now try MEMBER&, tree is nil.  Case A 1
((and (eq-car C '&)	
	(some #'atomic (cdr C))		;17Jan95
	(setq path-member& (cons 'member& path))
	(setq L* (member& LH1* C path-member& *V*)))   ;Brings back L*
   ;;L*= [(theta (C1 ... Cn) ranking) ... (theta (C1 ... Cn) ranking)]
   (cond ((equal 1 (setq k (length L*))) (return-from HL (caadr L*))))
   (setq n# (maknam (list 'n (setq *nn* (1+ *nn*)))))    ;decision step name
   (setq *decision-step-names* (cons n# *decision-step-names*))
   (setq tup2 (mapcar #'(lambda (u) 
                   (setq n#i (maknm (list 'n (setq *nn* (1+ *nn*)))))
		   (list n#i (caddr u) 'not-done))
		      L*))
   (setq 5-tuple (list n# args0 'decision k tup2))          ;The 5-tuple
   (store 5-tuple n#)
   (setq sub-tree (list 'sub-tree (mapcar #'(lambda (u v)
                             (setq thetai (car u)) (setq n#i (car v))
                             (setq Ci (apply-subs-q thetai (andify (cadr u))))
			     (setq H1** (apply-subs-q thetai H1*))
			     (setq H2** (apply-subs-q thetai H2*))
			     (setq pathi (cons n#i path))
			     (setq argsi (list H1** H2** Ci pathi nil VC))
			     (list n#i thetai argsi))
					  L* tup2)))
   (setq n#st (maknam (list 'n (setq *nn* (1+ *nn*)))))  
   (store sub-tree n#st)
   (setq branch (reverse (append '(n#st n#) path)))
   (graft branch)   ;to *tree*
   (return-from HL 'back))

  ;;------------------- Now try WHOS-FIRST   Case A 3 -------------
  ((eq-car C '&)       
   (setq n#  (maknam (list 'n (setq *nn* (1+ *nn*)))))    ;step name   
   (setq n#1 (maknam (list 'n (setq *nn* (1+ *nn*)))))    ;C1 step name   
   (setq n#2 (maknam (list 'n (setq *nn* (1+ *nn*)))))    ;C* step name   
   (setq m (length (cdr C)))

   (cond ((null (setq W (whos-first (cdr C) LH** *V* path)))
	  (format t "~%Problem with whos-first~%") (break)))

   (setq C1 (car W))        
   (cond ((equal C (andify (cons C1 (remove C1 (cdr C) :test 'equal)))) nil)
	 (t (format t "~%Moved to front of C~%~s~%~%" C1) (setq C C*)))
   (setq C* (andify (remove C1 (cdr C) :test 'equal)))
   
   (setq args1 (list H1 H2 C1 path nil VC))
   (setq args2 (list H1 H2 C* path nil VC))   

   (setq tup2 (list (list n#1 args1 'not-tried) (list n#2 args2 'not-tried)))
   (setq 5-tuple (list n# args0 '& m tup2))     
   (store 5-tuple n#)  
   (setq path* (cons n# path))

   (setq p1 (cons n#1 path*)) (setq p2 (cons n#2 path*))  
   (setq args1* (consn 4 n#1 args1))     ;cons n#1 to 4th argument of args1
   (setq args2* (consn 4 n#2 args2))     ;cons n#2 to 4th argument of args2

   (cond ((setq theta1 (HLL args1*))
	  (setq tup2* (list (list n#1 args1 theta1) 
			    (list n#2 args2 'not-tried)))
	  (setq 5-tuple (subst tup2* tup 5-tuple :test 'equal))
	  (setq path* (subst tup2* tup path* :test 'equal))
	  (setq C** (apply-subs-q theta1 (caddr args2*)))
	  (setq args2* (subst C** (caddr args2*) args2* :test 'equal))
	  (cond ((setq theta2 (HHL arge2*)) 
		 (cond ((eq 'back theta2) (return-from HL 'back))
		       (t (compose theta1 theta2))))
		(t nil)))
	 (t nil)))

  ((and (not (eq-car C '&))	  ;Now try BCH-ors, tree is nil.  Case A 1
	(setq path-BCH-ors (cons 'BCH-ors path))
	(progn (setq image (image C)) t)
	(setq L* (BCH-ors H1 H2 C image path-BCH-ors VC)))
   ;;L*= [(theta (C1 ... Cn) ranking) ... (theta (C1 ... Cn) ranking)]
   ;;Some Ci's can be P's,  but all are evaluated (with value, ranking)
   ;;From here, this is essentially the same as members& 
   (cond ((equal 1 (setq k (length L*))) (return-from HL (caadr L*))))
   (setq n# (maknam (list 'n (setq *nn* (1+ *nn*)))))    ;step name
   (setq *decision-step-names* (cons n# *decision-step-names*))
   (setq tup2 (mapcar #'(lambda (u) 
                   (setq n#i (maknm (list 'n (setq *nn* (1+ *nn*)))))
		   (list n#i (caddr u) 'not-done))
		      L*))
   (setq 5-tuple (list n# args0 'decision k tup2))          ;The 5-tuple
   (store 5-tuple n#)
   (setq sub-tree (list 'sub-tree (mapcar #'(lambda (u v)
                             (setq thetai (car u)) (setq n#i (car v))
                             (setq Ci (apply-subs-q thetai (andify (cadr u))))
                             (setq H1** (apply-subs-q thetai H1*))
			     (setq H2** (apply-subs-q thetai H2*))
			     (setq pathi (cons n#i path))
			     (setq argsi (list H1** H2** Ci pathi nil VC))
			     (list n#i thetai argsi))
					  L* tup2)))

   (setq n#st (maknam (list 'n (setq *nn* (1+ *nn*)))))    ;step name
   (store sub-tree n#st)
   (setq branch (reverse (append '(n#st n#) path)))
   (graft branch)   ;to *tree*
   (return-from HL 'back))
      
  ((and *lemmas*	       ;Now try LEMMAS    tree is nil.  Case A 1
   ;;We might should use the *used-lemmas* procedure.  (See high-low.lisp)
	(progn (setq image (image C)) t)
	(setq path-lemmas (cons 'lemmas path))
	(setq L* (lemmas H1 H2 C image path-lemmas VC)))
   ;;L*= [(lemma-name1 theta1 P1 rank1)...(lemma-namek thetak Pk rankk),
   ;;lemma-namei is an atom, naming the lemma
   ;;The Pi's are from BCH
   ;;From here, this is essentially the same as members&, but different
   (cond ((equal 1 (setq k (length L*))) (return-from HL (caadr L*))))
   (setq n# (maknam (list 'n (setq *nn* (1+ *nn*)))))    ;step name
   (setq *decision-step-names* (cons n# *decision-step-names*))
   (setq tup2 (mapcar #'(lambda (u) 
                   (setq n#i (maknm (list 'n (setq *nn* (1+ *nn*)))))
		   (list n#i (caddr u) 'not-done))
		      L*))
   (setq 5-tuple (list n# args0 'decision k tup2))          ;The 5-tuple
   (store 5-tuple n#)
   (setq sub-tree (list 'sub-tree (mapcar #'(lambda (u v)  
                                             u= (lem-namei thetai  Pi ranki)
			     (setq lem-namei (car u))
                             (setq thetai (cadr u)) (setq n#i (car v))
                             (setq Pi (apply-subs-q thetai (andify (caddr u))))
			     (setq pathi (cons n#i path))
			     (setq H2** (cons lem-namei 
					      (cons (eval lem-namei) H2)))
			     (setq H1** (apply-subs-q thetai H1*))
			     (setq H2** (apply-subs-q thetai H2**))
			     (setq argsi (list H1** H2** Pi pathi nil VC))
			     (list n#i thetai argsi))
					  L* tup2)))
   (setq n#st (maknam (list 'n (setq *nn* (1+ *nn*)))))   
   (names sub-tree n#st)
   (setq branch (reverse (append '(n#st n#) path)))
   (graft branch)   ;to *tree*
   (return-from HL 'back))

  ((and (eq 'first flag) 
	(setq ans (time (otter-prove C
				     :inference-rules '(binary_res)
				     :time 1000 :factor t 
				     :base-axioms (and-on H1 H2))))
	(eq-car ans t)) t) ) ))

;;%$%  See the next one
(defun member& (H1 C path V)  ;12Jan95  Called by HL
  (let (LC thetas thetas* c-ths c-ths* L0 L1 L2 L3 L4 L5 L6 L7 L8 L9 L10 L*
	   path* thc* theta n k m mn bn sn sn0 sn* cs)
      (format t "~%Member&~%")
    (setq LC (cdr C))
    (cond ((not (setq c-ths (crunch (mapcan #'(lambda (Ci) 
                             (setq *reject** *reject*)
			     (setq thetas (crunch (memberS*2 Ci H1 V V path)))
			     (setq *reject* *reject**)
			     (cond (thetas 
				    (list (list Ci thetas)))))
				  LC)))) ;c-ths= ([C1 ($1 $2)] [C2 ($3 $4)]...)
	   (return-from member& nil)))
    (setq c-ths* (copy-tree c-ths))
    (setq thetas* (crunch (mapcan #'(lambda (u) (cadr u)) c-ths*)))
    (setq L0 (mapcar #'(lambda (th) 
			  (setq cs (mapcan #'(lambda (cth)
                              (cond ((member th (cadr cth) :test 'equal)
				     (list (car cth)))))
				   c-ths))
		  (list th cs))
			thetas*))
    (setq L1 (mapcar #'(lambda (thc)
                   (list (car thc) (set-difference LC (cadr thc))))
			 L0))
    (setq L2 (mapcar #'(lambda (pr) (list (car pr) (cadr pr) 
			    (- (length LC) (length (cadr pr))))) ;4Feb95
			 L1))
    (setq L3 (sort L2 '(lambda (x y) (< (caddr y) (caddr x)))))  ;> 4Feb95
    ;;----------------------------- emd of first step
    (setq k (caddar L3))                     ;The largest ranking
    (setq L4 (mapcan #'(lambda (u) (cond ((equal k (caddr u)) (list u))))
			 L3))                ;Those with the largest, k
    (cond ((cdr L4)                          ;There is more than 1 k
	   (Setq L5 (mapcar #'(lambda (u)    ;Choose the most in H1
		    (setq theta (car u)) (setq Cs (sublis theta (cadr u)))
		    (setq n 0) (setq m (length Cs))
		    (mapc #'(lambda (Ci) (cond ((member*2 Ci H1 V V nil nil)
						(setq n (1+ n)))))
			  Cs)
		    (setq mn (- m n))
		    (setq bn (cond ((equal 0 mn) 10) (t (* 10 (/ n m))))) ;4Feb
		    (list theta Cs k bn))
			    L4))
			  
	   (setq L6 (sort L5 '(lambda (x y) (< (cadddr y) (cadddr x))))) ;>4Feb
           ;;------------------------------- end of second step
	   (setq k2 (cadddr (car L6)))
	   (setq L7 (mapcan #'(lambda (u) (cond ((equal k2 (cadddr u)) 
						 (list u))))
			    L6))
	   (cond ((cdr L7)
		  (setq L8 (mapcar #'(lambda (u)    ;Chs smallest theta
			    (setq sn (size (andify (mapcar #'cdr (car u)))))
			    (append u (list sn)))
				       L7))
		  (setq sn0 0)(mapc #'(lambda (u) (setq sn0 (+ sn0 (fifth u))))
				    L8)                ;sn0= largest sn  4Feb95
		  (setq L8 (mapcar #'(lambda (u)       ;4Feb95
				           (setq sn (fifth u))
					   (setq sn* (- 10 (* 10 (/ sn sn0))))
					   (subst sn* sn u :test 'equal))
				   L8))
				     
		  (setq L9 (sort L8 '(lambda (x y) 
					(< (fifth y) (fifth x)))))

		  (setq L10 (append L9
				(set-difference L6 L7 :test 'equal)))
		  (setq L* (append L10
				(set-difference L3 L4 :test 'equal))))
		 (t (setq L* (append L6 
				(set-difference L3 L4 :test 'equal))))))
	  (t (setq L* L3)))
    (prnt L*) ; (break)

    (setq L* (revamp-rankings L*))
    L*))

(defun member& (H1 C path V)  ;12Jan95  Called by HL
  (let (h-list L*)
    (setq h-list '(number-Cs-with-same$ number-C$s-proved-new@ size-theta))
    ;;             Lr            H2  H1&2  VC       image
    (setq L* (rank nil h-list H1 nil nil C nil path nil))
    ;;L*= ([($ Cs) #] [($ Cs) #] ... [($ Cs) #]) ))

;;%$% See the next
(defun lemmas (H1 H2 C image path VC &optional VH P H*) 
  ;;11Nov94 Called by HL.  
  ;;Not called if *lemmas* is nil (or if a test run is ??)
  (let (images lemmas* lemmas-depth W WW PP Lemmas** rank1 rank2 rank pr Cp
	        path* lem theta sigma P tot) 
      (format t "~%Lemmas~%")
    (setq lemmas-depth (mapcan #'(lambda (x) (cond ((eq x 'lemmas) (list x))))
			path))
    (cond ((< 5 (length lemmas-depth)) 
	   (prnt lemmas-depth) (format t "~%") (return-from lemmas nil)))
    (cond ((setq pr (assoc (setq Cp (list C path)) *save-lemmas* :test 'equal))
	   (setq lemmas** (cadr pr)))
	  (t (setq images (mapcar #'(lambda (lm) 
                   (list (car lm) (match-images image (cadr lm))))
				  *lemmas*))
	     (setq images (mapcan #'(lambda (lm)   ;prune the poor ones
                    (cond ((< *minimal-image-match* (cadr lm)) (list lm))))
				  images))
	     (setq lemmas* (sort images #'(lambda (x y)(< (cadr y) (cadr x)))))
	     (setq lemmas* (reverse (mapcar #'car lemmas*)))
	     ;;Here we essentially ignore the ranking caused by the IMAGing
	     ;;--------------------------------------------
	     (setq WW (mapcan #'(lambda (lm)
                      (setq path* (list 'Lm (setq *lemn* (1+ *lemn*))))
		      (progn (setq *reject** *reject*)
			     (setq W (bch lm C image path* VC)) ;20Jan95
			     (setq *reject* *reject**) t) ;W= (theta P ...)
		      (cond (W (list (list lm (car W) (cadr W))))))
			      lemmas*))
             ;;---------------------- end of lemmas1 6Feb95
	     (setq PP (mapcar #'(lambda (u) ;u= (lem theta P)
				(setq lem (car u))
				(setq lemma-name (name lem))
				(setq theta (cadr u)) (setq P (caddr u))
                                (setq rank1 (prove-by-member P H1 H2))
				(setq rank2 (fcn-repeats C P))
				(setq rank  (combine-ranks rank1 rank2))
				(list lemma-name theta P rank))
			      WW))  
	     ;;PP= [(lem-name1 theta1 P1 rank1)...(lem-namek thetak Pk rankk)]

	     (setq lemmas** (sort PP #'(lambda (x y) (< (cadddr x) 
							(cadddr y)))))
	     (setq lemmas** (reverse lemmas**))  ;largest Ranking first
	     (setq tot 0) (mapc #'(lambda (u) (setq tot (+ tot (cadddr u)))) 
				lemmas**)
	     (setq L* (mapcar #'(lambda (u) 
		  (list (car u) (/ (cadddr u) tot)))    ;4Feb95  largest
			      lemmas**))                       
	     ;;L*= [(lem1 theta1 P1 rank1)...(lemk thetak Pk rankk),
             ;; 0<=ranki<=1, (sum ranki)= 1.
             (prnt L*); (break)
	     L*))))

(defun lemmas (H1 H2 C image path VC &optional VH P H*) 
  ;;8Feb95 Called by HL.  
  ;;Not called if *lemmas* is nil (or if a test run is ??)
  (let (h-list L* H1&2)
    (setq h-list '(BCH-lem-$P fcn-Repeats-BC Prove-Ps-by-member)) ;match-images
    (setq H1&2 (append H1 H2))                                    ;   later??
    ;;             Lr   
    (setq L* (rank nil h-list H1 H2 H1&2 C Vc path image))
    ;;L*= ([($ P lem) #] [($ P lem) #] ... [($ P lem) #]) ))

;;$%$ See the next
(defun BCH-ors (H2 C image path VC)     ;30Jan95  Called by HL
  (let (WW L2 L3 L4 tot L* theta P rank1 rank2 rank)
    (setq *reject** *reject*)
    (setq WW (BCHs H2 C image path VC))
    (setq *reject* *reject**)
    ;;---------------------------------- end of 
    (cond (WW (setq L2 (mapcar #'(lambda (u) ;u= (theta P)
				(setq theta (cadr u)) (setq P (caddr u))
                                (setq rank1 (prove-by-member P H1 H2))
				(setq rank2 (fcn-repeats C P))
				(setq rank  (combine-ranks rank1 rank2))
				(list theta P rank))
			      WW))
	      
	      (setq L3 (sort L2 #'(lambda (x y) (< (caddr x) (caddr y)))))
	      (setq L4 (reverse L3))
	      (setq tot 0) (mapc #'(lambda (u) (setq tot (+ tot (caddr u)))) 
				 L4)
	      (setq L* (mapcar #'(lambda (u) 
				   (list (car u) (/ (caddr u) tot))) ;4Feb95
			       L4))                       
	      ;;L*= [(theta1 P1 rank1)...(thetak Pk rankk),
	      ;; 0<=ranki<=1, (sum ranki)= 1.
	      (prnt L*); (break)
	      L*)
	  (t nil) )))

(defun BCH-ors (H1 H2 C image path VC)     ;30Jan95  Called by HL
  (let (h-list L*)
    (setq h-list '(BCH-$P fcn-Repeats-member Prove-Ps-by-member))
    ;;             Lr               H1&2
    (setq L* (rank nil h-list H1 H2 nil C VC path image))
    ;;L*= ([($ P) #] [($ P) #] ... [($ P) #]) ))



;;$%$%  See the next one
(defun member-ts (C H1&2 V V path)            ;30Jan95 Called by HL
  (let (thetas thetas* L8 L9 tot L* sn)
    (format t "~%Member-ts~%")
    (setq *reject** *reject*)
    (setq thetas (crunch (memberS*2 C H1&2 V V path)))
    (setq *reject* *reject**)
    (cond ((not thetas) (return-from member-ts nil)))
    (setq thetas* (copy-tree thetas))
    (setq L8 (mapcar #'(lambda (u)    ;Choose smallest theta
		    (setq sn (size (andify (mapcar #'cdr u))))
		    (list u sn))
		     thetas*))
    (setq L9 (sort L8 '(lambda (x y) (< (second y) (second x))))) ;4Feb95 large
    (setq tot 0) (mapc #'(lambda (u) (setq tot (+ tot (cadr u)))) L9)
    (setq L* (mapcar #'(lambda (u) (list (car u) (/ (cadr u) tot))) L9))
    (prnt L*) ; (break)
    L*))

(defun member-ts (C H1&2 V V path)            ;8Feb95 Called by HL
  (let (h-list L*)
    (setq h-list '(atom$s-member size-theta))
     ;;            Lr         H1  H2         VC       image
    (setq L* (rank nil h-list nil nil H1&2 C nil path nil)) 
     ;;L*= ([$ #] [$ #] ... [$ #]) ))

#| DOCUMENTATION   Also, see the file HIGH-LOW-TREE-PROCEDURE

 The fundamental difference between this version and the high-low.lisp version,
 is the use of OVER-ALL guidance.
 That over-all guidance is helped by the use of a PROOF-TREE, *tree* --
 a global variable. As the proof proceeds and proof-tree is being built, 
 there are many  DECISION-NODES, where more than one path can be taken
 as the proof proceeds.  These decision-nodes are where a substitution
 theta is chosen, but other thetas might have been chosen.  Or a lemma
 is selected, and another lemma might have been (and even with lemmas
 selection, they too use a substitution theta, obtained by back-chaining
 the goal C against that lemma).
 These theta-decisions occur when an &-goal is somehow being handled, and are
 carried out by the functions MEMBER-TS, MEMBER&, BCH-ors and LEMMAS.  

 The key idea is this: it keep an overall picture of the proof-tree,
 as it proceeds to be built, with many decidion-nodes.

 The over-all prover, HL-tree, directs the main function, HL, in the 
 proof.  HL-tree commands HL to proceed with the present tree until
 it reaches the end (a leaf node).  At each decision node in the tree
 it selects the branch, from that node, with the smallest RANKING.
 Once the end is reached, HL proceeds with the proof via it regular 
 rules, and continues building the proof-tree. Once HL builds a NEW
 decision-node and its new branches, it computes (heuristically) 
 a ranking for each of the new branches, and uses these new values
 to re-compute the ranking of ALL decision-nodes in the tree.  And
 at that time returns to HL-tree, which directs HL to start from the
 beginning again, follow the existing tree and again build the tree
 until it reaches a new decision node.  

 We also employ &-STEPs (&-nodes) which represent more than one
 sub-goal to be proved, C1 ... Cn.  These Ci's are ORDERED using
 heuristics.  If one of these Ci's fails to be proved, the whold &-step 
 fails (of course) and nil is passed back.
 But as some of them ARE PROVED, the theta proving them is stored
 along with them -- to be used in the proof of the remaining Ci's AND 
 to help the overall evaluation of the RANKINGS of the decision- steps.  

 We use atoms to represent larger formulas in the process to make it
 easier for the human user to see how the proof is proceeding.  E.g.,
 each step (node) in the proof-tree, *tree*, is represented by an atom n#.
 n# is just the name of the node.  When n# is "evaluated" its value
 will show the arguments for HL to be used at that node, and also
 show information used at decision-nodes and at &-nodes, where more
 than one goal has to be proved.  The use of these atoms, n#, make
 it much easier for the human user to see the whole tree, and how it
 is proceeding.  How does it "evaluate" an atom such as n#?  It
 does so by ASSOCing n# against the global variable, *storage*, where
 the pair (n# its-value-formula) is stored.  
 Similarly, other large arguments, such as H1, H2, and C, are also
 represnted by atoms, H1-#, H2-#, C#, and also stored in glbal
 variables.  

 HL always passed back either nil -- if it fails, theta -- if it succeeds,
 and 'back -- if it has just completed a new decision-step and is going
 back to the function HL-step from whence it will restart the whole proof
 again (with a new proof-tree -- with new rankings).

|#

(defun eval* (n#) (cadr (assoc n# *storage*)))            ;6Feb95





(defun add-limb (limb tree)     ;24Jan95
 ;;eg, (setq tree '(root ((n1 (n11 n12 n13)) (n2 (n21 n22)))))
 ;;    (setq limb '(n12 (n121 n122)))
 ;;    (add-limb limb tree) = 
 ;;        (root ((n1 (n11 (n12 (n121 n122)) n13)) (n2 (n21 n22))))
  (let (node1 options tre*)
    (cond ((null tree) nil)
	  ((atom tree) (cond ((eq tree (car limb)) limb) (t tree)))
	  (t (list (car tree) (mapcar #'(lambda (tre) (add-limb limb tre))
				      (cadr tree)))))))

(defun apply-substitution-q (theta H*)  ;26Dec94  Called by HL
  ;;Some members of H* might have a quantifier
  ;;eg, (apply-substitution-q '((x . a) (y . b)) '(& (P x) (all y (Q y))))
  ;;            =                                 (& (P a) (Q b))
  (cond ((atom H*) (app-subq theta H*))
	((atom (car H*)) (app-subq theta H*))
	(t (mapcar #'(lambda (u) (app-subq theta u)) H*))))

(defun apply-subs-q (theta H*)  ;28Jan95  Just for a shorter name
      (apply-substitution-q theta H*))

(defun best-branch (tree)  ;2Feb95  Called by HL-TREE  3Feb95 Not used now
  ;;Choose the branch, selecting the limb with the lowest rating at each 
  ;; Decision node.
  (let (step subtree k0 u0 tree*)
    (cond ((null tree) nil)
	  ((atom (setq step (car tree))) 
	   (cons step (best-branch (cdr tree))))
	  ((eq-car step 'dec)                 ;a decision step
	   (setq subtree (cdr step))
	   (setq k0 999)
	   (mapc #'(lambda (u) (cond ((< (cadr u) k0) (setq k0 (cadr u))
				                      (setq u0 (car  u)))))
		 subtree)
	   (setq tree* (assoc u0 subtree))
	   (best-branch tree*))
	  (t (cons step (best-branch (cdr tree)))) )))

(defun best-limb (L)  ;3Feb95  Called by HL
  ;;L= [(n#1 Ranking1 Result1) ... (n#k Rankingk Resultk)]
  ;;Return the member of L with the highest ranking   4Feb95  highest
  (let ((ranking 0) triple)
    (mapc #'(lambda (u) (cond ((< ranking (cadr u))
			       (setq ranking (cadr u)) (setq triple u))))
	  L)
    triple))

(defun combine-ranks (rank1 rank2)  ;1Feb95  Called by Lemmas and BCH-ors
  ;;0<= rank1 <=10, rank2=0 or rank2=1.  0<= ans <=10. The bigger the better.
  ;;rank1 is from prove-by-member,  rank2 is from fcn-repeats
  ;;eg, (combine-ranks 3 1) = 0, (combine-ranks 7 1) = 4.
  (cond ((equal rank2 0) rank1)
	((< rank1 3) 0) 
	(t (- rank1 3))))

(defun consn (n A L)  ; 28Jan95 Called by HL 
  ;;cons A onto the nth member of L
  ;;eg, (consn 3 'x '(a b (c d) e)) = (a b (x c d) e)
  (subst (cons A (nth (1- n) L)) (nth (1- n) L) L :test 'equal))

(defun graft (branch tree)    ;1Feb95  Called by HL
  ;;branch= (n#n ... n#j ... n#i ... 'root) where n#j and n#i are
  ;;names of decision steps, the first two decision steps in branch.
  ;;We reverse the first portion, getting branch*= (n#i ... n#j ... n#n)
  ;;And place branch* into the tree at the node, n#i.
  (let (n#i branch* flag1 flag2)
    (mapc #'(lambda (nd) 
              (cond ((not flag2) 
		     (setq branch* (cons nd branch*))
		     (cond ((member nd *decision-step-names*)
			    (cond ((not flag1) (setq flag1 t))
				  (t           (setq flag2 t))))))))
	  branch)
    (graft2 branch* tree) ))

(defun graft2 (branch tree &optional (n (car branch))) ;1Feg95  Called by GRAFT
  (let (node tree2)
    (cond ((null tree) nil)
	  ((atom tree) (format t "~%A Problem in Graft2~%") (break))
	  ((eq n (setq node (car tree))) branch)
	  ((atom node)      (cons node (graft2 branch (cdr tree) n)))
	  ((numberp node)   (cons node (graft2 branch (cdr tree) n)))
	  ((eq-car node '&) 
	   (cons node (graft2 branch (cdr tree) n)))
	  ((eq-car node 'dec) 
	   (setq tree2 (cdr node))
	   (list (cons 'dec (mapcar #'(lambda (u) (graft2 branch u n)) 
				    (cdr node))))) )))
(defun g () 
 (setq *decision-step-names* '(p10 p11)) 
 (graft
 '((dec (p12 200) (p13 205)) p11 130 p10 p19 root)
 '(root 122 p1 p2 (dec (p3 112)
		       (p4 115 p5 p6 (& (p7 128) (p8 131)) p9 (dec (p9 143)
								    (p10 149)))))))
(setq tree '(root 122 p1 p2 (dec (p3 112)
		       (p4 115 p5 p6 (& (p7 128) (p8 131)) p9 (dec (p9 143)
								    (p10 149))))))

(defun length-of (u)  ;2Feb95  Called by PRINT-TREE
  ;;eg, (length-of '(& (p7 128) (p8 131))) = 22
  (let (m)
    (cond ((null u) 0)
	  ((numberp u) (number-of-digits u))
	  ((atom u) (length (explode u)))
	  (t (setq m (1+ (length u)))
	     (mapc #'(lambda (x) (setq m (+ m (length-of x)))) u)
	     m))))

(defun number-of-digits (x)  ;2Feb95  Called by PRINT-IT
  (cond ((< x 10) 1) ((< x 100) 2) ((< x 1000) 3) ((< x 10000) 4)))

(defun print-tree (tree &optional decf (n 0) (flag t))  ;2Feb95  
  (let (tree* k subtree)
    (cond ((eq-car tree 'root) 
	   (setq tree* (cons 'Rt (cdr tree)))
	   (return-from print-tree (print-tree tree* decf))))
    (cond (flag (format t "~%") (prn n)))
    (cond ((null tree) (return-from print-tree nil)))
    (setq tree* tree) (setq k n)
    (mapc #'(lambda (u) ;(prnt u) (break)
                        (cond ((eq-car u 'dec)
			       (setq subtree (cdr u))
			       (print-it 'dec) 
			       (print-tree (car subtree) decf 0 nil)
			       (setq k (+ k (cond (decf 5) (t 4))))
			       (format t "~%")
			       (mapcar #'(lambda (v) (print-tree v decf k))
				       (cdr subtree))
			       (format t "~%")
			       (return-from print-tree nil))
			      ((and decf (numberp u))
			       (print-it u) (setq k (+ k 1 (length-of u))))
			      ((and decf (atom u)
				    (numberp (cadr (member u tree))))
			       (print-it u) (setq k (+ k 1 (length-of u))))
			      ((and (eq decf '&) (eq-car u '&))
			       (print-it u) (setq k (+ k 1 (length-of u))))
			      ((and decf (eq-car u '&))
			       (format t "&") (setq k (1+ k)))
			      (decf    ;The case only print the decisions nodes
			       (format t ".") (setq k (1+ k)))
			      ((atom u) (print-it u) (setq k (+ k 4)))
			      (t (print-it u)
				 (setq k (+ k 1 (length-of u))))))
	  tree) ))

(defun print-it (x)  ;2Feb95  Called by PRINT-TREE
  (let (n)
    (cond ((integerp x) (format t "~s" x)
	   (setq n (- 4 (number-of-digits x))) (prn n))
	  ((atom x) (format t "~s" x)
	   (setq n (- 4 (length (explode x)))) (prn n))
	  ((eq-car x '&) (format t "~s" x) (prn 1))
	  (t (format t "~%Problem in Print-It~%") (break)) )))

(defun prn (n)  ;2Feb95  Print n spaces, with no return
  (cond ((< n 1) nil)
	(t (format t " ") (prn (1- n)))))



	   

(defun replacen (n A L) ; 28Jan95 Called by HL 
  ;;replace the nth member of L by A
  ;;eg, (replacen 3 'x '(a b c d e)) = '(a b x d e)
  (subst A (nth (1- n) L) L :test 'equal))

(defun replace-resulti (sigma n# n#i) ;3Feb95  Called by HL
  ;;replace resulti by sigma in *tree*
  (let (t-tuple t-tuple* 5th 5th* nRR nRR*)
    (setq 5-tuple (cadr (assoc n# *storage*)))
    (setq 5th (fifth 5-tuple))            
    (setq nRR (assoc n#i 5th))        ;nRR= (n#i thetai resulti)
    (setq nRR* (replacen 3 sigma nRR))
    (setq 5th* (subst nRR* nRR 5th :test 'equal))
    (setq 5-tuple* (subst 5th* 5th 5-tuple :test 'equal))
    (setq *tree* (subst 5-tuple* 5-tuple *tree* :test 'equal))))

(defun rest-from (node L)    ;1Feb95   Called by GRAFT
  (cond ((eq node (car L)) L)
	(t (rest-from node (cdr L)))))

(defun revamp-rankings (L)   ;26Jan95  Called by MEMBER&
  ;;L is a set of members Li of the form,
  ;;Li= (theta LC n1 n2 n3), where theta is a substitution, LC is
  ;;    a list of formulas, and n1,n2,n3 are integers.  
  ;;Or Li might have the form (theta LC n1 n2) or (theta LC n1)
  ;;We will convert the n1,n2,n3 into one x, for each Li, 0<=x<=1.
  (let (L1 L2 L3 L* L** G G* G** G2 G3 x)
    (setq L1 (mapcan #'(lambda (u) (cond ((fifth u) (list u)))) L))
    (setq L* (set-difference L L1))
    (setq L2 (mapcan #'(lambda (u) (cond ((fourth u) (list u)))) L*))
    (setq L** (set-difference L* L2))
    (setq L3 (mapcan #'(lambda (u) (cond ((third u) (list u)))) L**))
    
    (setq x (fourth (car L1)))                 ;the largest 4Feb95
    (setq G (mapcar #'fifth L1))
    (setq G* (rev x G))
    (setq x (third (car L2)))
    (setq G2 (mapcar #'fourth L2))
    (setq G (append G* G2))
    (setq G* (rev x G))
    (setq G3 (mapcar #'third L3))
    (setq G** (append G* G3))
    (setq TG 0) (mapc #'(lambda (x) (setq TG (+ TG x))) G**)
    (setq G** (mapcar #'(lambda (x) (/ x TG)) G**))
    
    (setq L* (mapcar #'(lambda (u i) (list (car u) (cadr u) i))
		     L G**))
    L*))

#|
(setq L '((t C 1 2 3) (t C 1 2 4) (t C 1 2 5) (t C 1 3) (t C 1 5) 
	  (t C 2) (t C 3)))
(revamp-rankings L) = ((T C 223/2352) (T C 2/21) (T C 75/784) (T C 17/168) 
                       (T C 19/168)   (T C 1/5)  (T C 3/10))
(setq L '((t C 3 4 5) (t C 3 4 4) (t C 3 4 3) (t C 3 3) (t C 3 2) 
	  (t C 2) (t C 1)))
(revamp-rankings L) = ((T C 895/5304) (T C 275/1632) (T C 35/208) (T C 45/272)
		       (T C 265/1632) (T C 1/9)      (T C 1/18))
|#

(defun rev (x G)   ;26Jan95   Called by REVAMP-RANKINGS
  ;;eg, (rev 2 '(3 4 5)) =  (27/14 2 29/14)
  ;;    (rev 2 '(5 4 3)) =  (29/14 2 27/14)
  (let (m tG G*)
    (setq m (* x (length G)))
    (setq TG 0) (mapc #'(lambda (i) (setq TG (+ TG i))) G)
    (setq G* (mapcar #'(lambda (i) (* (+ x (/ i TG)) (/ m (+ m 1))))
		     G))
    G*))

(defun sort-preds-fcns-consts (L1 L2) ;4Feb95  Called by WHOS-FIRST
  (let (L* L** LL1 LL2 LL2* LL2** LL2*** LL2h LL2h* LL3 LL4 LL4* LL4h LL4h* 
	    LL5 LL6 LL6* LL2d LL3u LL4d LL5u LL6hl pc k0) 
    (setq LL1 (mapcar #'(lambda (C)   
               (setq pc (predicate-choose C L2)) (list C (length pc)))
		     L1))
    (setq LL2 (sort LL1 '(lambda (x y) (> (cadr x) (cadr y)))))
    (setq k0 (cadar LL2))   ;highest
    (setq LL2h (mapcan #'(lambda (u) (cond ((equal k0 (cadr u)) (list  u))))
		      LL2))
    (setq LL2*  (mapcar #'car LL2))
    (setq LL2h* (mapcar #'car LL2h))
    (cond ((equal 1 (length LL2h*)) (setq L* LL2))     ;4Feb95

	  (t (setq LL2** (set-difference LL2* LL2h*))
	     (setq LL2d  (set-difference LL2 LL2h))
	     (setq LL3 (mapcar #'(lambda (C) 
               (setq pc (func-const-choose C L2)) (list C (length pc)))
			      LL2h*))
	     (setq LL3u (mapcar #'(lambda (u v) (append u (cadr v))) 
				LL2h LL3))
	     (setq LL4 (sort LL3u '(lambda (x y) (> (caddr x) (caddr y)))))
	     (setq k0 (caddar LL4))   ;highest
	     (setq LL4h (mapcan #'(lambda (u) 
				  (cond ((equal k0 (caddr u)) (list u))))
				LL4))
	     (setq LL4*  (mapcar #'car LL4))
	     (setq LL4h* (mapcar #'car LL4h))
	     (cond ((equal 1 (length LL4h*)) (setq L* (append LL4 LL2d)))

		   (t (setq LL2*** (set-difference LL4* LL4h*))
		      (setq LL4d (set-difference LL4 LL4h))
		      (setq LL5 (mapcar #'(lambda (u) (list u (size u)))
					LL4h*))
		      (setq LL5u (mapcar #'(lambda (u v) (append u (cadr v)))
					 LL4h LL5))
		      (setq LL6 (sort LL5u
				  '(lambda (x y) (<= (cadddr x) (cadddr y)))))
		      (setq k0 (cadddr (car (last LL6))))
		      (setq LL6hl (mapcar #'(lambda (u) 
                                     (replacen 4 (- k0 (cadddr u)) u))
					  LL6))
		      (setq LL6* (mapcar #'car LL6))     ;not used
		      (setq L* (append LL6hl LL4d LL2d)) ))))
    (setq L** (revamp-rankings L*)) ))

(defun store (L &optional step-name)                    ;23Jan95  Called by HL
  (cond (step-name t)
	(t (setq *sn* (1+ *nn*))                        ;step number
	   (setq step-name (maknam (list 'n *nn*)))))   ;step name
  (setq *storage* (cons (list step-name L) *storage*)))

(defun whos-first (LC L2 V path) ;19Dec94 4Feb95  Called by HL 
  ;;8Feb95 This is exactly the high-low.lisp version
  ;;LC is (cdr C) from HL
  (let (W LC* LCs LL LLk LLk0 Lij Ci* path* theta k0 LCpc)
    (cond ((setq LC* (mapcan #'(lambda (Ci) 
                (cond ((member*2 Ci L2 V V (cons 'who path)) (list Ci))))
			     LC))
	   (setq LL (mapcar #'(lambda (Ci) 
                        (setq W (member*2 Ci L2 V V (cons 'who2 path)))
			(setq theta (car W))
			(setq Lij (mapcan #'(lambda (Cj) 
		           (cond ((member (apply-sub theta Cj) L2 :test 'equal)
				  (list Cj))))
					  LC*))
		(list Ci Lij))
			    LC*))
	   (setq LLk (mapcar #'(lambda (u) (length (cadr u)))
			     LL))
	   (setq k0 (maxx LLk))             ;The largest of member of LLk
	   (setq LLk0 (mapcan #'(lambda (u)
                       (cond ((equal k0 (length (cadr u))) (list (car u)))))
			      LL))
	   (cond ((some #'(lambda (Ci) 
		            (and (setq path* (cons (name Ci) path)) 
				 (setq Ci* Ci)
				 (not (member path* *reject* :test 'equal))))
			LLk0)
		  (list Ci* path*))
		 (t nil)))
	  ((setq LCpc (sort-preds-fcns-consts LC L2))
	   (cond ((some #'(lambda (Ci) 
			      (and (setq path* (cons (name Ci) path)) 
				   (setq Ci* Ci)
				   (not (member path* *reject* :test 'equal))))
			LCpc)
		  (list Ci* path*))
		 (t nil)))
	  ((setq LCs (sort-strange LC))
	   (cond ((some #'(lambda (Ci) 
		             (and (setq path* (cons (name Ci) path)) 
				  (setq Ci* Ci)
				  (not (member path* *reject* :test 'equal))))
			LCs)
		  (list Ci* path*))
		 (t nil)))
	  (t nil) )))

;;---------------------------------------------------------------------------
;;--------------- This is the RANK Section -- with its functions ------------
;;---------------------------------------------------------------------------

(defun rank (Lr h-list H1 H2 H1&2 C VC path image)         ;6Feb95
  ;;h-list is a heuristic-name list. rank-hs means ranking heuristics  
  ;;Lr= [(O1 r1) (O2 r2)...(On rn)], Oi's are options, ri's are ranks
  ;;The result is L*= ([(...) r1] [(...) r2] ...[(...) rk]), with 0<=ri<=1.
  (let (LL L* Lir Li*)
    (cond ((null h-list) (return-from rank Lr)))
    (setq LL (rank-partition Lr))
    (setq L* (mapcan #'(lambda (Li)
	 (cond ((equal 1 (length Li)) Li)
	       (t (setq Lir (rank-hs  Li (car h-list) H1 H2 H1&2 C VC path 
                                                                      image))
		  (setq Li* (rank Lir (cdr h-list) H1 H2 H1&2 C VC path image))
		  (sort Li* '(lambda (x y) (< (cadr y) (cadr x)))))))
		     LL))
    L*))

(defun rank-partition (Lr &optional (r (cadar Lr)) Li)  ;6Feb95  Called by RANK
  ;;eg, (rank-partition '((a .9) (b .9) (c .8) (d .7) (e .7) (f .7)))
  ;;       =             ([(a .9) (b .9)] [(c .8)] [(d .7) (e .7) (f .7)])
  (let ()
    (cond ((null Lr) (list (reverse Li)))
	  ((equal (cadar Lr) r)
	   (rank-partition (cdr Lr) r (cons (car Lr) Li)))
	  (t (cons (reverse Li) (rank-partition Lr))) )))

(defun rank-hs (L hi H1 H2 H1&2 C VC path image)   ;6Feb95  Called by RANK
  ;;Choose the heuristic with name hi. Then to get and rank an L call hi.
  ;;The result is L*= ([(...) #1] [(...) #2] ...[(...) #k]), with 0<=#i<=1.
  (let (L* Lr r)
    (setq r (cond ((cadar L)) (t .1)))
    (cond ((eq hi   'number-Cs-with-same$)         ;member& uses the first 3
	   (setq L* (number-Cs-with-same$ H1 C path V)))
	  ((eq hi   'number-C$s-proved-new@)
	   (setq L* (number-C$s-proved-new@ L H1 C path V)))
	  ((eq hi   'size-theta)
	   (setq L* (size-theta L)))
	  ((eq hi   'match-image)
	   (setq L* (match-image image *lemmas)))   ;Not used (yet)
	  ((eq hi   'BCH-lem-$P)
	   (setq L* (BCH-lem-$P C image path VC)))
	  ((eq hi   'BCH-$P)
	   (setq L* (BCH-$P H2 C image path VC)))
	  ((eq hi   'fcn-Repeats-BC)
	   (setq L* (fcn-Repeats-BC L)))
	  ((eq hi   'prove-Ps-by-member)
	   (setq L* (prove-Ps-by-member L H1 H2)))
	  ((eq hi   'atom-$s-member)
	   (setq L* (atom-$s-member C H1&2 path))))
    
    (setq Lr (mapcar #'(lambda (u) (list (car u) (* r (cadr u))))
		     L*))
    Lr))


(defun number-Cs-with-same$ (H1 C path V)  ;7Feb95  Called by RANK-HS
  ;;$ is an abbreviation for theta
  (let (LC c-ths c-ths* thetas thetas* L0 L1 L2 L3 cs)
    (setq LC (cdr C))
    (cond ((not (setq c-ths (crunch (mapcan #'(lambda (Ci) 
                             (setq *reject** *reject*)
			     (setq thetas (crunch (memberS*2 Ci H1 V V path)))
			     (setq *reject* *reject**)
			     (cond (thetas 
				    (list (list Ci thetas)))))
				  LC)))) ;c-ths= ([C1 ($1 $2)] [C2 ($3 $4)]...)
	   (return-from number-Cs-with-same$ nil)))
    (setq c-ths* (copy-tree c-ths))
    (setq thetas* (crunch (mapcan #'(lambda (u) (cadr u)) c-ths*)))
    (setq L0 (mapcar #'(lambda (th) 
			  (setq cs (mapcan #'(lambda (cth)
                              (cond ((member th (cadr cth) :test 'equal)
				     (list (car cth)))))
				   c-ths))
		  (list th cs))
			thetas*))
    ;;L0= ([$ Cs] [$ Cs] ... [$ Cs])    ;Cs are the Ci's which were proved
    (setq L1 (mapcar #'(lambda (thc)
                   (list (car thc) (set-difference LC (cadr thc))))
			 L0))
    ;;L0= ([$ Cs] [$ Cs] ... [$ Cs])    ;Cs are the Ci's which are to be proved
    (setq L2 (mapcar #'(lambda (pr) 
              (list pr (- (length LC) (length (cadr pr)))))
		     L1))
     ;;L3= ([($ Cs) #] [($ Cs) #] ... [($ Cs) #])
    (setq L3 (sort L2 '(lambda (x y) (< (cadr y) (cadr x))))) 
    (setq k0 (cond ((zerp (cadar L3) .1) (t (cadar L3)))))       ;The largest
    (setq L4 (mapcar #'(lambda (u) (list (car u) (/ (cadr u) k0))) L3)) ))

(defun number-C$s-proved-new@ (L H1 V) ;7Feb95
  ;;$ an @ are abbreviations for theta and sigma
  ;;L= ([($ Cs) #] [($ Cs) #] ... [($ Cs) #]) 
  ;; 0< # <=1,is the same in each pair ($ Cs)
  ;;The # is the number of the C$s proved by Member*2 with a new sigma.
  (let (k L2 L3 theta Cs n m mn bn)
    (setq k (cadar L))                       ;The ranking # of each
    (Setq L2 (mapcar #'(lambda (u)    ;Choose the C$is in H1
		    (setq theta (car u)) (setq Cs (sublis theta (cadr u)))
		    (setq n 0) 
		    (setq m (length Cs))
		    (mapc #'(lambda (Ci) (cond ((member*2 Ci H1 V V nil nil)
						(setq n (1+ n)))))
			  Cs)
		    (setq mn (- m n))
		    (setq bn (cond ((equal 0 mn) 1) (t (* k (/ mn m)))))
		    (list (list theta Cs) bn))
		     L4))
    (setq L3 (sort L2 '(lambda (x y) (< (cadr y) (cadr x)))))
    (cond ((zerop (cadar L3)) (setq L3 (mapcar #'(lambda (u) (list (car u) .1))
					       L3))))
    L3))

(defun size-theta (L)    ;7Feb95          Called by RANK-HS
  ;;Called after L is obtained by NUMBER-Cs-WITH-SAME@, ATOMS-Ps-BY-MEMBER
  ;;L= ([($ ...) #] [($ ...) #] ... [($ ...) #])
  (let (k L2 L3 L4 theta sn sn* sn0)
    (setq k (cadar L))
    (setq L2 (mapcar #'(lambda (u)           ;Chs smallest theta
	                    (setq theta (car u))	            
			    (setq sn (size (andify (mapcar #'cdr theta))))
			    (list (car u) sn))
		     L))
    (setq sn0 0) (mapc #'(lambda (u) (setq sn0 (+ sn0 (cadr u))))
		       L2)                ;sn0= largest sn  4Feb95
    (setq L3 (mapcar #'(lambda (u) (setq sn (cadr u))
	                    (setq sn* (* k (/ sn sn0)))
			    (list (car u) sn*))
		     L2))
    (setq L4 (sort L3 '(lambda (x y) (< (cadr y) (cadr x))))) ))

(defun match-image (image lemmas) nil)     ;not defined or used yet

(defun BCH-lem-$P (C image path VC)  ;8Feb95 Called by RANK-HS
  (let (L* W W*)
    (setq L* (mapcan #'(lambda (lem) 
                          (cond ((setq W (BCH lem C image path VC))
				 (setq W* (list (car W) (cadr W) lem))
				 (list (list W 1))))) 
	    *lemmas*))
    ;;L*= ([($ P lem) 1] ... [($ P lem) 1])
    L*))

(defun BCH-$P (H2 C image path VC)    ;8Feb95  Called by RAND-HS
  (let (L2 L*)
    (setq *reject** *reject*)
    (setq L2 (BCHs H2 C image path VC))
    (setq *reject* *reject**)
    (setq L* (mapcar #'(lambda (u) (list (car u) (cadr u) 1)) L2))
    ;;L*= ([$ P 1] [$ P 1] ... [$ P 1])
    L*))

(defun BCHs (H2 C image path VC)    ;8Feb95 Called by BCH-#P
  (let (path* W)
    (setq path* (cons 'BCHs path))
    (cond ((setq W (BCH H2 C image path* VC))   ;W=(theta P ...)
	   (cons (list (car W) (cadr W)) (BCHs H2 C image path* VC)))
	  (t nil))))

(defun fcn-repeats-BC (L C)          ;8Feb95  Called by RANK-HS
  ;;L= ([($ P lem -maybe) #] ... [($ P lem) #])
  (let (P u1 P rank)
    (setq L* (mapcar #'(lambda (u) (setq u1 (car u))
                                   (setq P (cadr u1))
			           (setq rank (fcn-repeats C P))
				   (list u1 rank))
		     L))))

(defun fcn-repeats (C P)            ;1Feb95  Called by BCH-ors and LEMMAS
  ;;eg (fcn-repeats '(foo (goo x (fnc y z)))  '(foo (goo x (fnc (fnc u v) z))))
  ;;   = 1, if no repeats, else  = 0
  ;;We probably need to enlarge this to 1, 1/2, 0 (and change COMBINE-RANKS)
  (cond ((setq fsp (function-symbols P))
	 (cond ((setq fsrp (fcn-rps fsp P))
		(setq fsc (function-symbols C))
		(cond ((set-intersection fsc fsrp) 1)
		      (t 0)))
	       (t 0)))
	(t 0)))

(defun fcn-rps (fs P)               ;1Feb95  Called by FCN-REPEATS
  (mapcan #'(lambda (f) (cond ((fcn-rp f P) (list f)))) fs))

(defun fcn-rp (f P)                 ;1Feb95  Called by FCN-RPT
  (cond ((eq-car P f) (cond ((occur f (cdr P)) t) (t nil)))
	((atom P) nil)
	((not (atom (car P))) (format t "~%Prob in fcn-rp~%") (break))
	((some #'(lambda (u) (fcn-rp f u)) (cdr P)) t)
	(t nil)))

(defun prove-Ps-by-member (L H1 H2)   ;8Feb95  Called by RANK-HS
  ;;L= ([($ P lem -maybe) #] ... [($ P lem) #])
  (let (P L2 L* rank0)
    (setq L2 (mapcar #'(lambda (u) (setq u1 (car u))
			           (setq P (cadr u1))
				   (setq rank (prove-by-member P H1 H2))
				   (list u1 rank))
		     L))
    (setq rank0 0) (mapc #'(lambda (u) (setq rank0 (max rank0 (cadr u)))) L2)
    (setq L* (cond ((equal rank0 0) L2)
		   (t (mapcar #'(lambda (u) (list (car u) (/ (cadr u) rank0)))
			      L2))))
    ;;L2= ([($ P lem -maybe) #] ... [($ P lem) #])
    L*))

(defun prove-by-member (P H1 H2)   ;10Nov94   Called by lemmas
  (let (LP n m W theta LP* LP** k)
    (setq LP (cdrr P))                 ;eg, P=(& a b c), LP=(a b c)
    (setq n (length LP))
    (cond ((equal 1 n) 
	   (return-from prove-by-member 
			(cond ((member*2 P H1 *V* *V* nil) 100) (t 0)))))
    (setq m 0)
    (mapc #'(lambda (u) 
	      (cond ((setq W (member*2 u H1 *V* *V* nil))
		     (setq theta (car W)) 
		     (setq LP* (remove u LP :test 'equal))
		     (setq LP* (apply-sub theta LP*))
		     (setq H1* (apply-sub theta H1))
		     (cond ((null 
			     (setq LP** (set-difference LP* H1* :test 'equal)))
			    (return-from prove-by-member 100)))
		     (setq k (- n (length LP**)))
		     (setq m (max m k)))))
	  LP)
    m))

(defun atoms-$s-member (C H1&H2 path)   ;8Fet95  Called by RANK-HS
  (let (thetas L*)
    (setq *reject** *reject*)
    (setq thetas (crunch (memberS*2 C H1&2 V V path)))
    (setq *reject* *reject**)
    (cond ((not thetas) nil)
	  (t (setq L* (mapcar #'(lambda (th) (list (list th) 1)) thetas))))
    ;;L*= ([($) 1] [($) 1] ... [($) 1])
    L*))
