
;          high-low.lisp    31 Oct 94  3Nov94  11Nov94 18Dec94 2Jan95

;; Se the end of this file for the RESULTS of this prover.   21Jan95
;;
;; This is a revised version of high-low6.lisp, The changes are 
;;  mainly in HL, where we redefine the path/reject decisions.  2Jan95
;;  and the use of *reject*  3Jan95
;; This is a revised version of high-low5.lisp, but it needs none
;;  of the functions defined there.  
;; This version is also designed to handle ONLY FOL theorems (not sub=)
;;19Dec94:  The major change here from high-low5 is that we are simplifying
;; the path and reject concepts, in that we ONLY change the path when
;; a decision is made.  
;;Also we are here handling the Lemmas a little differently.  First
;; we will keep them in their "name" form, until that lemma is used
;; any way.  Also, when we select a lemma lm  -- in lemmas -- to be used to
;; help prove a goal G, that lemmas is not only put into H for future
;; goals, but the path-reject concept is used there too, so that if
;; the proof of G fails, then lm is not selected next for the same goal G.

;; See high-low and high-low2 for the BASIC IDEA, etc.

#|
Loading:  

(load "imply.lisp")(ls)(lu)(lp)(le)                               ;(lplns)
(lres)(lpi)(lpci)(lop)(lsg)(lpbr)(lppc)(lpc)(lpbe)(lpLe)

(lf)(lfo)(lgr)(lm2)(lehl)(lp)(leq)(lhl2)(lhl)

|#
(defun lhl () (load "high-low.lisp"))
(defun lhl2 () (load "high-low2.lisp"))
(defun lhl3 () (load "high-low3.lisp"))
(defvar *FOL-version* t)
(defvar *strange-list* 
 '(nu clause-L clause clauses-L clauses exp << <<= < <= e))   
                                    ;This list needs to be lengthened  26Dec94
(setq   *repeats-limit* 40)
(setq *gv* *grind*-version*)
(defvar *types* nil)
(defvar *lemmas* nil)
(defvar *lemmas-names* nil)
(defvar *save-lemmas* nil)
(defvar *lemmas-used* nil)
(defvar *reject*  nil)
(defvar *reject** nil)
(defvar *n* 20)
(defvar *lemn* 0)                                   ;20Jan95

(defun prove-HL (Thm &optional H Lemmas copies Lm) ;Main Call  2Sept94
  (let (Thm* thm** thm*** H* W lemmas* number-of-lemmas pv nl W k Hi= Hi> 
	     H1 H2 H12)
    (setq *reject* nil)
    (setq *save-lemmas* nil)
    (setq *lemmas-used* nil)
    (setq %theorem-variables% nil)
    (setq *n* 20)
    (setq *lemn* 0)
    (setq *repeats* 0)
    (setq *MINIMAL-IMAGE-MATCH* 1)
    (cond ((eq t Lemmas) (setq Lemmas nil)))   ;4 Oct 94
    (setq thm* (imp-on H thm))
    (cond ((and lemmas (eq-car lemmas 'exs-from-to)) 
	   (setq lemmas (exs-from-to (cadr lemmas) (caddr lemmas)
				     (cadddr lemmas) (fifth lemmas)))))
    (and copies (setq lemmas (union-n lemmas copies)))
    (and lm (setq lemmas (append (remove lm lemmas :test 'equal) (list lm))))
    (setq number-of-lemmas (length lemmas)) (prnt number-of-lemmas)
    (setq lemmas* (mapcar #'(lambda (u) (cond ((atom u) (eval u)) (t u)))
			  lemmas))
    (setq lemmas* (mapcar #'replace-multiple-quantifiers lemmas*))

    (setq thm** (imp-on (andify lemmas*) thm*))
    (setq thm** (sublis '((< . <<) (<= . <<=)) thm**))
;;    (setq thm** (reducef (unique-ize-quan-vars thm**)))   ;8 Oct 94
    (setq thm** (unique-ize-quan-vars thm**))               ;8 Oct 94
    (setq *V* (unifiable-variables Thm**))
    (setq pv (predicate-symbols thm**))    ;15Sept94
    (setq *types* (types Thm**))                            ;7Nov94
    (prnt *types*)
    (setq pv (set-difference pv *predicate-list*))
    (setq *predicate-list* (append pv *predicate-list*))
    (cond (lemmas (setq thm* (caddr thm**))
		  (setq *lemmas* (un-andify (cadr thm**))))
	  (t (setq thm* thm**) (setq *lemmas* nil)))
    (cond ((eq-car Thm* '->) 
	   (setq H* (cadr Thm*)) (setq Thm* (caddr Thm*))))
    (cond ((eq-car Thm* '->) 
	   (setq H* (and-on (cadr Thm*) H*)) (setq Thm* (caddr Thm*))))
    (setq H* (forward-chain-on H*))                        ;8 Oct 94
    (setq *lemmas* (subst '<< '< (subst '<<= '<= *lemmas*)))
    (cond (*FOL-version* (setq *matrix-version* t)))
    (cond (*grind*-version* (setq *grind-version* t)))
    (cond (*matrix-version* (setq *grind*-version* t)
			    (setq *grind-version* t)))

    ;;%%%%%%%%%%%%% Here we use only the FOL-version %%%%%%%%%%%%%%
    (cond (*FOL-version* 
	   (setq *lemmas* (mapcar #'(lambda (u) (list u (image u))) 
				    *lemmas*))
	   (setq H12 (atomics-pair H*))
	   (setq H1 (car H12)) (setq H2 (cadr H12))
	   (cond ((null (setq W (HL H1 H2 thm* nil 0 nil 'first))) nil)
		 (t '[]))))))

(defun HL (H1 H2 C &optional path (n 0) VC (flag t))  ;3Nov94
  ;;H1 is the Atomic type members of H, H2 the others
  (format t "~%HL~%")
(prnt path)
  (let (ans W W2 W3 theta theta* theta2 P P1 P2 path* path** path2 reject* 
	    image H* H** H1* H2* H1% H2% H12 H21 HC1 HC2 L#  C1 C* CL CL* 
            Cs-in-H xs x path-mem path-ot path-h path-c1 path-&1 
            path-bch path-lemmas path-HL path-Lh path-Cs path-&Cr path-rj
	    length-H1 length-H2 lemma lemma* lemmas* H*2 H*3 path-length 
	    LH1* Lh2* Cis)

    (cond ((< 100 (setq n (1+ n))) (format t "~%Too Deep in HL~%") 
                       	         (return-from HL nil)))
;;  (setq path-length (length path)) (prnt path-length)
;;  (cond ((< 20 path-length) (format t "~%Path longer than 20~%")
;;	   (return-from HL nil)))
    (setq LH1* (predicate-choose C H1)) ; (setq Length-H1 (length LH1*))
    (setq LH2* (predicate-choose C H2)) ; (setq Length-H2 (length LH2*))
;;  (prnt Length-H1 Length-H2)
    (setq H1* (cond (LH1* (andify LH1*))))
    (setq H2* (cond (LH2* (andify LH2*))))
    (setq H** (append LH1* LH2*))
    (cond ((member C H**) (prnt 'C-in-H) (return-from HL (list t path)))
	  ((not (eq-car C '&)) nil) 
	  ((null (setq CL* (set-difference (cdr C) H** :test 'equal)))
           (format t "~%All Ci's in H~%~%") (return-from HL (list t path)))
	  ((not (equal CL* (cdr C)))
	   (setq Cs-in-H (set-difference (cdr C) CL* :test 'equal))
	   (prnt Cs-in-H) (format t "~%") (setq C* (andify CL*))
	   (return-from HL (HL H1 H2 C* (cons 'Css path) n VC flag)))
	  ((and (eq-car C '&)
		(not (equal C (setq C* (andify (crunch (cdr C)))))))
	   (prnt '&crunch)          
	   (return-from HL (HL H1 H2 C* (cons 'crn path) n VC flag))))
    (cond ((and (atomic C) (not (eq 'rj flag))
		(setq path-mem (cons 'mem path))
		(not (member path-mem *reject* :test 'equal)))
           (format t "~%member*2~%")
	   (cond ((setq W (member*2 C H** *V* *V* path)) (return-from HL W))
		 (t (setq *reject* (cons path-mem *reject*)) nil))))
    (cond ((and nil (or (eq flag 'first) ;nil 3Jan95 2PM
			(and (not (eq flag 'rj)) (ground-v C *V*)))
		(setq ans (time (otter-prove C   
			     :inference-rules '(binary_res)
			     :time 10 :factor t :base-axioms (and-on H1 H2))))
		(eq-car ans t))		;Proved by otter
	   (setq path-ot (cons 'otter path))
	   (return-from HL (list t path-ot))))

    (cond ((atom C) nil)
	  ((and (eq-car C '&)              ;12Jan95 Now try MEMBER&
		(some #'atomic (cdr C))    ;17Jan95
		(setq path-member& (cons 'member& path))
		(not (member path-member& *reject* :test 'equal))
		(cond ((setq W (member& LH1* C path-member& *V*))
		       (setq theta (car W)) (setq Cis (cadr W)) 
		       (setq path* (caddr W)) 
		       (setq C* (sublis theta (andify Cis)))
		       (cond ((null Cis)
			      (format t "~%Proved by member&~%") 
			      (list theta path*))
			     ((and (not (equal Cis (cdr C)))
				   (format t "~%Part Proved by member&~%")nil))
			     ((setq W (HL H1 H2 C*            ;W=(theta path*)
					  (cons 'member& path*) n VC nil)) W)
			     (t (setq *reject* (cons path* *reject*))
				(HL H1 H2 C path n VC 'rj))))
		      (t (setq *reject* (cons path-member& *reject*)) 
			 (HL H1 H2 C path n VC flag)))))

	  ((eq-car C '&)
	   (cond ((null (setq W (whos-first (cdr C) H** *V* path)))
		  (format t "~%Problem with whos-first~%") (break)))
	   (setq C1 (car W)) (setq path* (cadr W))
	   (setq C* (andify (cons C1 (remove C1 (cdr C) :test 'equal))))
	   (cond ((equal C* C) nil) 
		 (t (format t "~%Moved to front of C~%~s~%~%" C1) (setq C C*)))
	   (setq *repeats* 0)
	   (setq p1 (cons 'C1 path)) (setq p2 (cons 'C2 path))
	   (cond ((setq W (HL H1 H2 (cadr C) p1 n VC 'rj))          ;C1
		   ;;16Jan95  RJ because it has just failed MEMBER&
		  (setq theta (car W)) 
		  (setq path-&1 (cadr W)) (setq H* (caddr W))
		  (setq H* (apply-substitution-q theta H*))    ;26Dec94
		  (setq CL (mapcar #'(lambda (u) 
					(apply-substitution theta u))
				   (cddr C)))
		  (cond ((eq-car CL '&)
			 (setq CL (mapcan #'(lambda (u) u) (cdr CL)))
			 (setq CL (crunch CL))))
		  (setq CL* (set-difference CL (cdrr H*) :test 'equal))
		  (cond ((null CL*) W)
			((progn (setq H12 (atomics-pair H*))
				(setq H1% (and-on (car  H12) H1))
				(setq H2% (and-on (cadr H12) H2)) nil))
			((setq W2 (HL H1% H2% (andify CL*) p2 n VC nil))
			 (setq theta2 (compose (car W2) theta)) ;rest of C
			 (cons theta2 (cdr W2)))
			(t (setq *reject* (cons path *reject*))   
			   (HL H1 H2 C path n VC 'rj))))
		 (t nil)))

	  ((and (eq-car C '->) 
		(setq H12 (atomics-pair (cadr C)))
		(or (setq HC1 (and-on (car H12)  H1)) t)
		(or (setq HC2 (and-on (cadr H12) H2)) t)
		(setq W (HL HC1 HC2 (caddr C) (cons '-> path) n VC nil))))
			
	  ((eq-car C 'or) 
	   (setq H12 (atomics-pair (not-fcnf (cadr C))))
	   (setq H21 (atomics-pair (not-fcnf (rest-&or C))))
	   (or (HL (and-on (car H21) H1) (and-on (cadr H21) H2) (cadr C)
		   path n VC nil) 
	       (HL (and-on (car H12) H1) (and-on (cadr H12) H2) 
			(rest-&or C) path n VC nil)))

	  ((eq-car C 'not) nil)                           ;later

 	  ((eq-car C 'some)
	   (HL H1 H2 (caddr C) (cons 'some path) n (cons (cadr C) VC) nil))

	  ((eq-car C 'all)
	   (setq xs (make-skolem-expresn (setq x (cadr C)) VC))   ;(xs ...)
	   (setq C* (subst xs x (caddr C) :test 'equal))
	   (HL H1 H2 C* (cons 'all path) n VC nil)) 

	  ((and (not (equal ans :FALSE))   ;Now try BCH
		(progn (setq image (image C)) t)
		(setq path-bch (cons 'bch path))
		(not (member path-bch *reject* :test 'equal))
		(cond ((setq W (bch H2 C image path VC))
		       (setq P (cadr W)) ;14Nov94  ;W=(theta P path H*)
		       (setq theta (car W)) (setq path* (caddr W))
		       (setq H* (cadddr W))
		       (cond ((eq t P) W)          ;HL returns (theta path H*)
			     ((not (setq W2 (HL H1 H2 P (cons 'P path*)
						n VC nil)))
			      (setq *reject* (cons path* *reject*))
			      (cond ((setq W3 (HL H1 H2 C path n VC 'rj)) W3)
				    (t nil)))
			     (t (setq theta* (compose (car W2) theta)) 
				(setq H*2 (and-on (caddr W2) H*))
				(list theta* (cadr W2) H*2))))
		      (t (setq *reject* (cons path-bch *reject*)) nil))))

	  ((and *lemmas*                  ;Now try LEMMAS
		(progn (setq image (image C)) t)
		(setq path-lemmas (cons 'lemmas path))
		(not (member path-lemmas *reject* :test 'equal))
		(cond ((setq W (lemmas H1 H2 C image path-lemmas VC))
		       (setq lemma (car W)) (setq path* (cadr W))
		       (setq lemma-name (cadr (assocq lemma *lemmas-names*)))
		       (prnt lemma-name)
		       (setq H2* (and-on lemma H2))
		       (cond ((setq W (HL H1 H2* C 
					  (cons 'lemmas path*) n VC 'rj))
			      (setq theta (car W)) (setq H* (caddr W))
			      (setq lemma* (apply-substitution-q theta lemma))
			      (list theta (cadr W) (and-on H* lemma*)))
			     (t (setq *reject* (cons path* *reject*))
				(HL H1 H2 C path n VC 'rj))))
		      (t (setq *reject* (cons path-lemmas *reject*)) 
			 (HL H1 H2 C path n VC 'rj)))))

	   ((and (eq 'first flag) (not (equal ans :FALSE))
		 (setq ans (time (otter-prove C
                         :inference-rules '(binary_res)
			 :time 1000 :factor t 
			 :base-axioms (and-on H1 H2))))
		 (eq-car ans t)) (list t t))
	  (t nil) )))

(defun bch (H C image path VC)  ;3Nov94   Called by HL. 
  ;;We have both bch and bch*, only for tracing.     
    (format t "~%BCH~%")
  (bch* H C image path VC))

(defun bch* (H C image path VC &optional VH P H*)  ;2Nov94 Called by BCH
  (let (path-u path-h& path-all path-some theta P* H** h# W 
	       xs x (V (union-w VC VH)) nhct)
    (setq theta (unify-v H C V)) 
    (setq nhct (list H (name C) theta))
    (setq path-u (cons nhct path))
    (cond ((member path-u *reject* :test 'equal)
	   (format t "~%Reject-in-bch~%~s~%" path-u) nil) 
	  ((and theta (some #'(lambda (u) 
                         (and (not (atom u)) (member H u :test 'equal))) path))
	   (format t "~%Same Hi used twice in sequence.") (prnt H) nil) ;Jan95
          (theta (setq *reject* (cons path-u *reject*))
		 (setq P*  (apply-sub-hb theta P))
		 (setq H** (apply-sub-hb theta H*))
		 (list theta P* path-u H**))

	  ((atom H) nil)

	  ((and (eq-car H '&)
		(setq path-h& (cons 'h& path))
		(cond ((member path-h& *reject* :test 'equal)
		       (format t "~%Rejected form BCH*&~%")
		       (return-from bch* nil))
		      (t t)))
	   (cond ((some #'(lambda (Hi) 
                           (and (subset (predicate-symbols C) 
					(predicate-symbols Hi))
				(setq W (bch* Hi C image 
					     path VC VH P H))))
			(cdr H))               
		  W)
		 (t (setq *reject* (cons path-h& *reject*)) nil)))

	  ((eq-car H '->)                 ;6Jan95  trying today only. see next
	    (bch* (caddr H) C image  path VC VH 
		     (and-on (cadr H) P) H*))
#|
	  ((eq-car H '->) 
	   (or (bch* (caddr H) C image  path VC VH 
		     (and-on (cadr H) P) H*)
	       (bch* (not-fcnf (cadr H)) C image path VC VH 
		     (and-on (not-fcnf (caddr H)) P) H*)))
|#
	  ((eq-car H 'or) 
	   (or (bch* (cadr H) C image path VC VH
		     (and-on (not-fcnf (rest-&or H)) P) H*)
	       (bch* (rest-&or H) C image path VC VH
		     (and-on (not-fcnf (cadr H)) P) H*)))

	  ((eq-car H 'all)
	   (bch* (caddr H) C image path VC (cons (cadr H) VH) P H*))

	  ((eq-car H 'some)
	   (setq xs (make-skolem-expresn (setq x (cadr H)) VH))   ;(xs ...)
	   (setq H** (subst xs x (caddr H) :test 'equal))
	   (bch* H** C image path VC VH P H*))

	  ((eq-car H 'not) nil)                            ;later

	  (t nil) )))

(defun lemmas (H1 H2 C image path VC &optional VH P H*) 
  ;;11Nov94 Called by HL.  
  ;;Not called if *lemmas* is nil (or if a test run is ??)
  (let (images lemmas* lemmas-depth W WW PP Lemmas** pb lm* namel pr Cp
	       lemmas-left path*)
      (format t "~%Lemmas~%")
    (setq lemmas-depth (mapcan #'(lambda (x) (cond ((eq x 'lemmas) (list x))))
			path))
    (cond ((< 5 (length lemmas-depth)) 
	   (prnt lemmas-depth) (format t "~%") (return-from lemmas nil)))
    (cond ((setq pr (assoc (setq Cp (list C path)) *save-lemmas* :test 'equal))
	   (setq lemmas** (cadr pr)))              
	  (t (setq images (mapcar #'(lambda (lm) 
                   (list (car lm) (match-images image (cadr lm))))
				  *lemmas*))
	     (setq images (mapcan #'(lambda (lm)   ;prune the poor ones
                    (cond ((< *minimal-image-match* (cadr lm)) (list lm))))
				  images))
	     (setq lemmas* (sort images #'(lambda (x y)(< (cadr x) (cadr y)))))
	     (setq lemmas* (reverse (mapcar #'car lemmas*)))
	     ;;Here we essentially ignore the ranking caused by the IMAGing
	     ;;And use instead only those that back-chain on C, and prefer
             ;; those that allow more back-chain goals to be proved by member*2
             ;;Perhaps we should use both IMAG and BCH
	     (setq n 0)
	     (setq WW (mapcan #'(lambda (lm)
                      (setq path* (list 'Lm (setq *lemn* (1+ *lemn*))))
                      (cond ((setq W (bch lm C image path* VC)) ;20Jan95
			     (list (list lm W)))))                
			      lemmas*))
	     (setq PP (mapcar #'(lambda (LW) 
                                (setq pb (prove-by-member (cadadr LW) H1 H2))
				(list (car LW) pb))
			      WW))
	     (setq lemmas** (sort PP #'(lambda (x y) (< (cadr x) (cadr y)))))
	     (setq lemmas** (reverse lemmas**))
(prnt lemmas**); (break)
	     (setq lemmas** (mapcar #'car lemmas**))
	     (cond ((not lemmas**) (return-from lemmas nil)))))
    (setq lemmas-left lemmas**)
    (cond ((some #'(lambda (Lm) 
		     (and (or (setq lemmas-left (cdr lemmas-left)) t)
			  (setq namel (name Lm))
			  (not (member namel *lemmas-used*))    
                                              ;use lemmas only once 17Jan95
			  (setq path* (cons namel path)) 
			  (setq Lm* Lm)
			  (cond ((member path* *reject* :test 'equal)
		                 (format t "~%Reject Lemma ~s~%" namel) nil)
				(t t))))
		 lemmas**)
	   (setq *save-lemmas* (cons (list Cp lemmas-left) *save-lemmas*))
	   (setq *lemmas-used* (cons namel *lemmas-used*))     ;18Jan95
	   (list Lm* path*))
	  (t nil)) ))

(defun andify (L &optional flag)                               ;widely used
  (let (L*)
    (cond ((null L) t)
	  ((atom L) L)
	  ((and flag (setq L (remove nil L)) nil))             ;3Dec94
	  ((eq-car (setq L (crunch L)) '&)
	   (cond ((cddr L) L) 
		 ((cdr L) (cadr L))
		 (t t)))
	  ((cdr L)
	   (cond ((equal L (setq L* (remove t L))) (cons '& L))
		 (t (andify L* flag))))
	  (t (car L)) )))

(defun and-on (A B)    ;widely used                   6Aug92
  ;; e g, (and-on (& c d) (& e f))  =  (& c d e f)
  (cond ((eq t A) B)
	((eq t B) A)
	((null A) B)
	((null B) A)
	((equal A B) A)
	(t (andify (crunch (append (cdrr A) (cdrr B))))) ))  ;9Nov94

(DEFUN APPLY-substitution (THETA D)   ;3Dec94
  (let (D*)
  (cond ((equal D (setq D* (apply-substitution2 theta D))) 
	 (cond ((atom D) D) (t (crunch D))))
	(t (apply-substitution theta D*)))))

(DEFUN APPLY-substitution2 (THETA D)	;14 Oct 94
       ;; the substitution2 THETA is applied to the form D
       (COND ((EQ T THETA) D)
	     ((TWO-XS THETA NIL)
	      (PROG (X2)
		    (SETQ X2 (TWO-XS THETA)) ;we removed the reduc 14 Oct 94
		    (RETURN (AND-ON (APPLY-SUBSTITUTION2 (CAR X2) D)
				    (APPLY-SUBSTITUTION2 (CADR X2) D)))))
	     (T (SUBLIS= THETA D))))

(defun apply-substitution-q (theta H*)  ;26Dec94  Called by HL
  ;;Some members of H* might have a quantifier
  ;;eg, (apply-substitution-q '((x . a) (y . b)) '(& (P x) (all y (Q y))))
  ;;            =                                 (& (P a) (Q b))
  (cond ((atom H*) (app-subq theta H*))
	((atom (car H*)) (app-subq theta H*))
	(t (mapcar #'(lambda (u) (app-subq theta u)) H*))))

(defun app-subq (theta A)     ;26Dec94 Called by APPLY-SUBSTITUTION-Q 
  (let () 
    (cond ((atom A) (apply-substitution theta A))
	  ((member (car A) '(all some))
	   (cond ((equal (cadr A) (apply-substitution theta (cadr A)))
		  (list (car A) (cadr A) (app-subq theta (caddr A))))
		 (t (app-subq theta (caddr A)))))
	  ((and (not (occur 'all A)) (not (occur 'some A)))
	   (apply-substitution theta A))
	  ((member (car A) '(-> & or not))
	   (cons (car A) (mapcar #'(lambda (u) (app-subq theta u))
				 (cdr A))))
	  (t (apply-substitution theta A)))))

(defun assocq (x LL)  ;31Dec94  Called by HL
  (let ()
    (cond ((null LL) nil)
	  ((equalq x (caar LL)) (car LL))
	  (t (assocq x (cdr LL))))))

(defun atomic (A)  ;1Nov94 
  (cond ((atom A) t)
	((member (car A) '(some all -> & or)) nil)
	((eq-car A 'not) (cond ((occurs '(some all -> & or not) (cdr A)) nil)
			       (t t)))
	(t t)))

(defun atomics (L) ;1Nov94
  (cond ((null L) nil)
	(t (mapcan #'(lambda (x) (cond ((atomic x) (list x)))) L))))

(defun atomics-pair (A) 
  (let (A1 A2)
    (cond ((null A) (return-from atomics-pair (list nil nil))))
    (setq A1 (atomics (cdrr A)))
    (setq A2 (set-difference (cdrr A) A1))
    (setq A1 (cond (A1 (andify A1))))
    (setq A2 (cond (A2 (andify A2))))
    (list A1 A2)))

(defun constant-symbols (A V)  ; 4Jan95 
  ;;V is the set of instantiatable variables
  (set-difference (variables-in A) V))

(defun cdrr (L)  ;3Nov94
  (cond ((null L) nil) ((eq-car L '&) (cdr L)) (t (list L))))  

(defun const-syms-pos (A)
  ;;eg
  (let (pA cA ans)
    (setq pA (crunch (pos A)))
    (setq cA (crunch (constant-symbols A *V*)))
    (setq ans (mapcan #'(lambda (x) 
                  (cond ((some #'(lambda (u) (occur x u)) pA) (list x))))
		      cA))
    ans))

(defun contridiction (L)   ;31 Oct 94  Does L have negative members
  (cont ((null (cdr L)) nil)
	((member* (car L) (cdr L) *V* *v*) t)
	(t (contridiction (cdr L))) ))

(defun equal** (A B V V*)      ;13 Oct 94  Called by MEMBER*
  ;;Same as EQUAL except that SOME and ALL are forced to have common variables.
  ;;Also, (equal** A B V V*) if A=B or if A or B is a member of V.
  ;;Also, if A is a member of V* the the substition, (A . B) is returned
  ;;      Similarly for B.
  (let ((theta t) sigma)
    (cond ((equal A B) t)
	  ((and (member A V) (not (occur A B)) (equal-types A B))
	   (setq *theta* (cons (cons A B) *theta*))             ;7Nov94
	   (cond ((member A V*) (list (cons A B))) (t t)))
	  ((and (member B V) (not (occur B A)) (equal-types A B))
	   (setq *theta* (cons (cons B A) *theta*))             ;7Nov94
	   (cond ((member B V*) (list (cons B A))) (t t)))
	  ((atom A) nil)
	  ((atom B) nil)
	  ((not (eq (car A) (car B))) nil)
	  ((member (car A) '(SOME ALL))
	   (equal** (caddr A) (subst (cadr A) (cadr B) (caddr B))))
	  ((every #'(lambda (x y) (and (setq sigma (equal** x y V V*))
				       (setq theta (compose theta sigma))))
		  (cdr A) (cdr B))
	   theta)
	  (t nil) )))

(defun equalq (x y) ;31Dec94  Called by ASSOCQ
  ;;Equal except for bound variables
  ;;eg, (equalq '(all x (P x)) '(all y (P y))) = t
  (cond ((equal x y) t)
	((not (equal (car x) (car y))) nil)
	((member (car x) '(some all))
	 (equalq (caddr x) (subst (cadr x) (cadr y) (caddr y))))
	((member (car x) '(-> & or not))
	 (every #'(lambda (u v) (equalq u v)) (cdr x) (cdr y)))
	(t nil)))

(defun equal-types (A B) 
  (let (tA tB)
    (setq tA (typee A)) (setq tB (typee B)) 
    (or (not tA) (not tB) (equal tA tB))))

(defun func-const-choose (C H)  ;4Jan95  Called by SORT-PREDS-FCNS-CONSTS
  (let (pc phh H*)
    (setq pc (union-w (fcn-syms-pos C) (const-syms-pos C)))
    (setq phh (mapcar #'(lambda (u) 
                (union-w (fcn-syms-pos u) (const-syms-pos u)))
		      (cdrr H)))
    (setq H* (mapcan #'(lambda (hi ph)  
               (cond ((set-intersection pc ph) (list hi))))
		     (cdrr H) phh)) 
    (crunch H*)))

(defun fcn-syms-pos (A)
#| ;eg (fcn-syms-pos '(SOME C22 (SOME L23 (SOME L24
         (& (E C22 S21) (CLAUSE-L C22) (NU C22) (E L23 C22)
            (LITERAL-L L23) (E L24 C22) (LITERAL-L L24) (NOT (== L23 L24))
            (ALL C25 (ALL L26 (-> (& (E C25 S21) (NU C25) (E L26 C25))
                                  (<<= (I L26) (I L23))))))))))
    = (I)
|#
  (let (pA fA ans)
    (setq pA (crunch (pos A)))
    (setq fA (crunch (function-symbols A)))
    (setq ans (mapcan #'(lambda (x) 
                  (cond ((some #'(lambda (u) (occur x u)) pA) (list x))))
		      fA))
    ans))

(defun ground-v (C V) ;12Nov94 Called by HL
  (null (set-intersection V (free-variables-in C))))

(defun image (A)   ;12 Oct 94  Called by prove-HL, etc  
  ;;We use the non-logical predicates, the functions, etc.
  (let ()                         ;2Nov94
    (list (predicate-symbols A) (pred-syms-pos A) (function-symbols  A)) ))

(defun match-images (Imc ImL)  ;2Nov94  Called by lemmas
  ;;Imc and ImL are images of two formulas.  This compares them.
  ;;Imi= (pred-syms pred-syms-pos function-syms)
  ;;Imc is the image of a goal, C. ImL is the image of a "lemma".
  ;;0 means nothing in common.  The better the match the higher the output.
  ;;This has been redefined for the FOL-version.  2Nov94
  ;;20Sept94  If the triples are equal, then 10.
  ;;2 Nov 94  If the last doubles are equal then 9.
  ;;Else, the fraction of pres and fcn syms in C (times 10)
  (let (pc ppc fc pL ppL fL pfc pfL pfc* pfc**)
    (setq pc (car imc)) (setq ppc (cadr imc)) (setq fc (caddr imc))
    (setq pL (car imL)) (setq ppL (cadr imL)) (setq fL (caddr imL))
    (setq pfc (append ppc fc)) (setq pfL (append ppL fL)) 
    (cond ((not (intersection ppc ppL)) 0)
	  ((equal Imc ImL) 10) 
	  ((equal (cdr Imc) (cdr ImL)) 9)
	  ((equal 0 (length pfc)) 2)             ;change this?
	  (t (setq pfc*  (length (intersection pfc pfL)))
	     (setq pfc** (length (union-w pfc pfL)))
	     (* 10 (/ pfc* pfc**))) )))

(defun maxx (L)  ;19Dec94  The largest member of L
  ;;eg, (maxx '(3 2 1 5 4 2)) = 5
  (cond ((null L) (format t "~%Problem in Maxx~%") (break))
	((null (cdr L)) (car L))
	(t (max (car L) (maxx (cdr L)))) ))

(defun member*2 (x L V V* path &optional (nrj t))  ;20 Oct 94   Called by MTXG2
  ;;If x is a member** of L, with value theta, then return theta,path.
  (let (theta py)
      (cond ((some #'(lambda (y) 
             (and (setq theta (equal** x y V V*))
		  (setq py (cons (list y theta) path))
		  (cond ((member py *reject* :test 'equal)
			 (and nrj (format t "Reject-in-member*2~%~s~%~%" py))
			 nil)
			(t t))))
		 L)
	   (setq *reject* (cons py *reject*))  ;5Jan95 
	   (list theta py))
	  (t nil))))

(defun memberS*2 (Ci L V V* path)    ;12Jan95  Called by MEMBER&
  ;;The result is all thetas from all W's from member*2, for this Ci.
  (let (W theta path*)
    (cond ((setq W (member*2 Ci L V V* path nil))
	   (setq theta (car W)) (setq path* (cadr W))
	   (setq *reject* (cons path* *reject*))
	   (cons theta (memberS*2 Ci L V V* path)))
	  (t nil))))

(defun member& (LH C path V)  ;12Jan95  Called by HL
  (let (LC thetas thetas* c-ths c-ths* L0 L1 L2 L3 L4 L5 L6 L7 L8 L9 L10 L*
	   path* thc* theta n k m mn bn sn cs)
      (format t "~%Member&~%")
    (setq LC (cdr C))
    (cond ((not (setq c-ths (crunch (mapcan #'(lambda (Ci) 
                             (setq *reject** *reject*)
			     (setq thetas (crunch (memberS*2 Ci LH V V path)))
			     (setq *reject* *reject**)
			     (cond (thetas 
				    (list (list Ci thetas)))))
				  LC)))) ;c-ths= ([C1 ($1 $2)] [C2 ($3 $4)]...)
	   (return-from member& nil)))
    (setq c-ths* (copy-tree c-ths))
    (setq thetas* (crunch (mapcan #'(lambda (u) (cadr u)) c-ths*)))
    (setq L0 (mapcar #'(lambda (th) 
			  (setq cs (mapcan #'(lambda (cth)
                              (cond ((member th (cadr cth) :test 'equal)
				     (list (car cth)))))
				   c-ths))
		  (list th cs))
			thetas*))
    (setq L1 (mapcar #'(lambda (thc)
                   (list (car thc) (set-difference LC (cadr thc))))
			 L0))
    (setq L2 (mapcar #'(lambda (pr) (list (car pr) (cadr pr) 
					      (length (cadr pr))))
			 L1))
    (setq L3 (sort L2 '(lambda (x y) (< (caddr x) (caddr y)))))

    (setq k (caddar L3))                     ;The minimal value
    (setq L4 (mapcan #'(lambda (u) (cond ((equal k (caddr u)) (list u))))
			 L3))                ;Those with the minimal, k
    (cond ((cdr L4)                          ;There is more than 1 k
	   (Setq L5 (mapcar #'(lambda (u)    ;Choose the most in LH
		    (setq theta (car u)) (setq Cs (sublis theta (cadr u)))
		    (setq n 0) (setq m (length Cs))
		    (mapc #'(lambda (Ci) (cond ((member*2 Ci LH V V nil nil)
						(setq n (1+ n)))))
			  Cs)
		    (setq mn (- m n))
		    (setq bn (cond ((equal 0 mn) 0) (t (* 10 (/ mn m)))))
		    (list theta Cs k bn))
				L4))
			  
	   (setq L6 (sort L5 '(lambda (x y) (< (cadddr x) (cadddr y)))))
	   (setq k2 (cadddr (car L6)))
	   (setq L7 (mapcan #'(lambda (u) (cond ((equal k2 (cadddr u)) 
						 (list u))))
			    L6))
	   (cond ((cdr L7)
		  (setq L8 (mapcar #'(lambda (u)    ;Chs smallest theta
			    (setq sn (size (andify (mapcar #'cdr (car u)))))
			    (append u (list sn)))
				       L7))
		  (setq L9 (sort L8 '(lambda (x y) 
					(< (fifth x) (fifth y)))))

		  (setq L10 (append L9
				(set-difference L6 L7 :test 'equal)))
		  (setq L* (append L10
				(set-difference L3 L4 :test 'equal))))
		 (t (setq L* (append L6 
				(set-difference L3 L4 :test 'equal))))))
	  (t (setq L* L3)))
(prnt L*) ; (break)
    (setq n 0)
    (cond ((some #'(lambda (thc) 
		     (and (setq path* (cons (setq n (1+ n)) path))   
			  (setq thc* (first-n 2 thc))
			  (cond ((member path* *reject* :test 'equal)
		                 (format t "~%Reject member&  ~s~%" thc) nil)
				(t t))))
		 L*)
	   (append thc* (list path*)))
	  (t nil)) ))

(defun name (A) 
  (let (Lp Lf L lem)
    (cond ((setq lem (assocq A *lemmas-names*)) (cadr lem))
	  (t (setq Lp (crunch (predicate-symbols A))) 
	     (setq Lf (crunch (function-symbols A)))
	     (setq L (append (first-n 3 Lp) (first-n 3 Lf)))))))

(defun order (L1 L2 V path)  ;18Dec94  Not Used as of 19Dec94
  (let (L1* L1** path*)
    (setq L1* (sort-strange L1))
    (setq path* (cons (name L1*) path))
    (setq L1** (cons nil L1*))
    (cond ((some #'(lambda (A) 
		     (and (setq path* (cons (name A) path)) 
			  (setq L1** (cdr L1**))
			  (not (member path* :test 'equal))))
		 L1*)
	   (list L1** path*)))))    

(defun order-number (L1 L2 theta)
  (let (L1* L2* L3)
    (setq L1* (apply-sub theta L1))
    (setq L2* (apply-sub theta L2))
    (setq L3  (mapcan #'(lambda (x) (cond ((member x L2* :test 'equal)
					   (list x))))
		      L1*))
    (length L3)))


(defun pos (A &optional (par t))   ;5Jan95
  ;;The conclusion parts of A
  ;;Eg, (pos '(& (P x) (-> B (& (Q x) (R x))) (-> (not (S x)) C)))
  ;;  =  ((P x) (Q x) (R x) (S x) C)
  (cond ((atom A) (cond (par (list A)) (t nil)))
	((member (car A) '(some all)) (pos (caddr A) par))
	((eq-car A '->) (append (pos (cadr  A) (not par))
				(pos (caddr A) par)))
	((eq-car A 'not) (pos (cadr A) (not par)))
	((member (car A) '(& or)) 
	 (mapcan #'(lambda (x) (pos x par)) (cdr A)))
	(par (list A))
	(t nil)))

(defun predicate-symbols (A)  ;15Sept94 Called by PROVE-HL
  (crunch-hl (psy A)))

(defun psy (A)   ;15Sept94  Called by PREDICATE-SYMBOLS
  (cond ((atom A) (list A))
	((member (car A) '(some all)) (psy (caddr A)))
	((member (car A) '(-> & or not)) (mapcan #'psy (cdr A)))
	(t (list (car A))) ))

(defun pred-syms-pos (A)  ;1Nov94 Called by PROVE-HLf
  ;;The predicate symbols in the "conclusion" part of A.
  ;;Eg, (pred-syms-pos '(-> (& (P a) (Q b)) (& (R c) (u d)))) = (R u)
  (crunch-hl (psp A t)))

(defun psp (A &optional par)   ;1Nov94  Called by PRED-SYMS-POS
  (cond ((atom A) (cond (par (list A)) (t nil)))
	((member (car A) '(some all)) (psp (caddr A) par))
	((eq-car A '->) (append (psp (cadr  A) (not par))
				(psp (caddr A) par)))
	((eq-car A 'not) 
         (cond ((occurs '(some all -> & or not) (cadr A))
		(psp (cadr A) (not par)))
	       (t (list (maknam (list 'not (cond ((atom (cadr A)) A) 
					   (t (caadr A)))))))))
	((member (car A) '(& or)) 
	 (mapcan #'(lambda (x) (psp x par)) (cdr A)))
	(par (list (car A)))
	(t nil)))

(defun predicate-choose (C H)  ;1Nov94  
  (let (pc phh H*)
    (setq pc (pred-syms-pos C)) 
    (setq phh (mapcar #'pred-syms-pos (cdrr H)))
    (setq H* (mapcan #'(lambda (hi ph)  
               (cond ((set-intersection pc ph) (list hi))))
		     (cdrr H) phh)) 
    (crunch H*)))

(defun prove-by-member (P H1 H2)   ;10Nov94   Called by lemmas
  (let (H** LP n m W theta LP* LP** k)
;;  (setq H** (append (cdrr H1) (cdrr H2)))
    (setq LP (cdrr P))                 ;eg, P=(& a b c), LP=(a b c)
    (setq n (length LP))
    (cond ((equal 1 n) 
	   (return-from prove-by-member 
			(cond ((member*2 P H1 *V* *V* nil) 100) (t 0)))))
    (setq m 0)
    (mapc #'(lambda (u) 
	      (cond ((setq W (member*2 u H1 *V* *V* nil))
		     (setq theta (car W)) 
		     (setq LP* (remove u LP :test 'equal))
		     (setq LP* (apply-sub theta LP*))
		     (setq H1* (apply-sub theta H1))
		     (cond ((null 
			     (setq LP** (set-difference LP* H1* :test 'equal)))
			    (return-from prove-by-member 100)))
		     (setq k (- n (length LP**)))
;;		     (setq k (* 10 (/ k n)))        ;;removed 10Nov94 6PM
		     (setq m (max m k)))))
	  LP)
    m))

(defun sort-preds-fcns-consts (L1 L2) ;30Dec94  Called by WHOS-FIRST
  (let (LL1 LL2 LL2* LL2** LL2*** LL2h LL2h* LL3 LL4 LL4* LL4h LL4h* 
	    LL5 LL6 LL6* pc k0)
    (setq LL1 (mapcar #'(lambda (C)   ;(prnt C) (break)
               (setq pc (predicate-choose C L2)) (list C (length pc)))
		     L1))
    (setq LL2 (sort LL1 '(lambda (x y) (> (cadr x) (cadr y)))))
    (setq k0 (cadar LL2))   ;highest
    (setq LL2h (mapcan #'(lambda (u) (cond ((equal k0 (cadr u)) (list  u))))
		      LL2))
    (setq LL2*  (mapcar #'car LL2))
    (setq LL2h* (mapcar #'car LL2h))
    (cond ((equal 1 (length LL2h*)) LL2*)
	  (t (setq LL2** (set-difference LL2* LL2h*))
	     (setq LL3 (mapcar #'(lambda (C) 
               (setq pc (func-const-choose C L2)) (list C (length pc)))
			      LL2h*))
	     (setq LL4 (sort LL3 '(lambda (x y) (> (cadr x) (cadr y)))))
	     (setq k0 (cadar LL4))   ;highest
	     (setq LL4h (mapcan #'(lambda (u) 
				  (cond ((equal k0 (cadr u)) (list u))))
				LL4))
	     (setq LL4*  (mapcar #'car LL4))
	     (setq LL4h* (mapcar #'car LL4h))
	     (cond ((equal 1 (length LL4h*)) (append LL4* LL2**))
		   (t (setq LL2*** (set-difference LL4* LL4h*))
		      (setq LL5 (mapcar #'(lambda (u) (list u (size u)))
					LL4h*))
		      (setq LL6 (sort LL5
                                    '(lambda (x y) (<= (cadr x) (cadr y)))))
		      (setq LL6* (mapcar #'car LL6))
		      (append LL6* LL2*** LL2**) ))))))

(defun sort-strange (L &optional (SL *strange-list*))  ;26Dec94 Called by ORDER
  ;;This function needs to be strengthened
  ;;eg, (sort-strange '((E (C22S S) S) (CLAUSE-L (C22S S)) (NU (C22S S))))
  ;;            =      ((NU (C22S S)) (CLAUSE-L (C22S S)) (E (C22S S) S))
  (let (L1 L2)         
    (cond ((null SL) L)
	  (t (setq L1 (mapcan #'(lambda (u) 
                                   (cond ((occur (car SL) u) (list u))))
			      L))
	     (setq L2 (set-difference L L1))
	     (append L1 (sort-strange L2 (cdr SL))) ))))


(defun types (A &optional (A* A))   ;7Nov94  Called by Prove-HL.
  (let (SS CC LL ii WW) 
    (setq SS (crunch (types-S A)))
    (setq CC (crunch (types-C A SS)))
    (setq LL (crunch (types-L A SS CC)))
    (setq WW (list 'w))
    (setq ii (crunch (types-i A WW)))
    (List (list 'Clause-sets SS)
	  (list 'Clauses     CC)
          (list 'Literals    LL)
	  (list 'omega WW)
	  (list 'integers ii)) ))

(defun typee (x)               ;7Nov94 Called by Equal**
 (let (tp)
  (cond ((some #'(lambda (u) (and (member x (cadr u)) (setq tp (car u))))
	       *types*)
	 tp)
	(t nil))))

(defun types-S (A)            ;7Nov94 Called by TYPES
  (let (P)
    (cond ((atom A) nil)
	  ((member (setq P (car A))
		   '(clauses-L clauses res res-L resolvents resolvents-L )) 
	   (list (cadr A)))
	  ((member P '(some all)) (types-S (caddr A)))
	  ((member P '(-> & or not)) (mapcan #'types-S (cdr A))) )))

(defun types-C (A &optional SS)            ;7Nov94 Called by TYPES
  (let (P)
    (cond ((atom A) nil)
	  ((member (setq P (car A)) '(clause-L clause)) (list (cadr A)))
	  ((and (eq 'e P) (member (caddr A) SS))   ;eg, (e C25 S21)
	   (list (cadr A)))
	  ((eq 'nu P) (list (cadr A)))   ;eg, (nu C27)
	  ((member p '(resolvent resolvent-L)) 
	   (list (cadr A) (caddr A) (sixth A)))
	  ((member P '(some all)) (types-C (caddr A) SS))
	  ((member P '(-> & or not)) 
	   (mapcan #'(lambda (u) (types-C u SS)) (cdr A))) )))

(defun types-L (A &optional SS CC)            ;7Nov94 Called by TYPES
  (let (P)
    (cond ((atom A) nil)
	  ((member (setq P (car A)) '(literal-L literal)) (list (cadr A)))
	  ((and (eq 'e P) (member (caddr A) CC))   ;eg, (e L31 C30)
	   (list (cadr A)))
	  ((member p '(resolvent resolvent-L)) 
	   (list (fourth A) (fifth A)))
	  ((member P '(some all)) (types-L (caddr A) SS CC))
	  ((member P '(-> & or not))
	   (mapcan #'(lambda (u) (types-L u SS CC)) (cdr A))) )))


(defun types-i (A &optional WW)            ;10Nov94 Called by TYPES
  (let (P)
    (cond ((atom A) nil)
	  ((and (eq-car A 'e) (member (caddr A) WW))   ;eg, (e n w)
	   (list (cadr A)))
	  ((member (setq P (car A)) '(some all)) (types-i (caddr A) WW))
	  ((member P '(-> & or not))
	   (mapcan #'(lambda (u) (types-i u WW)) (cdr A))) )))

(defun un-andify (L) (cond ((eq-car L '&) (cdr L)) (t (list L))))

(defun whos-first (L1 L2 V path) ;19Dec94 4Feb95  Called by HL 
  ;;L1 is (cdr C) from HL
  (let (W L1* L1s LL LLk LLk0 Lij Ci* path* theta k0 L1pc)
    (cond ((setq L1* (mapcan #'(lambda (Ci) 
                (cond ((member*2 Ci L2 V V (cons 'who path)) (list Ci))))
			     L1))
	   (setq LL (mapcar #'(lambda (Ci) 
                        (setq W (member*2 Ci L2 V V (cons 'who2 path)))
			(setq theta (car W))
			(setq Lij (mapcan #'(lambda (Cj) 
		           (cond ((member (apply-sub theta Cj) L2 :test 'equal)
				  (list Cj))))
					  L1*))
		(list Ci Lij))
			    L1*))
	   (setq LLk (mapcar #'(lambda (u) (length (cadr u)))
			     LL))
	   (setq k0 (maxx LLk))             ;The largest of member of LLk
	   (setq LLk0 (mapcan #'(lambda (u)
                       (cond ((equal k0 (length (cadr u))) (list (car u)))))
			      LL))
	   (cond ((some #'(lambda (Ci) 
		            (and (setq path* (cons (name Ci) path)) 
				 (setq Ci* Ci)
				 (not (member path* *reject* :test 'equal))))
			LLk0)
		  (list Ci* path*))
		 (t nil)))
	  ((setq L1pc (sort-preds-fcns-consts L1 L2))
	   (cond ((some #'(lambda (Ci) 
			      (and (setq path* (cons (name Ci) path)) 
				   (setq Ci* Ci)
				   (not (member path* *reject* :test 'equal))))
			L1pc)
		  (list Ci* path*))
		 (t nil)))
	  ((setq L1s (sort-strange L1))
	   (cond ((some #'(lambda (Ci) 
		             (and (setq path* (cons (name Ci) path)) 
				  (setq Ci* Ci)
				  (not (member path* *reject* :test 'equal))))
			L1s)
		  (list Ci* path*))
		 (t nil)))
	  (t nil) )))

;;----------------------------------------------------------------------
#| 21Jan 95   Some Results using this prover, in high-low.lisp.
   Reference file experiments-Q.lisp for the names of pr8, pr52, etc.

   QQ is the generated-pc-to be proved theorem from the analogy proof of 
   Completeness of Lock Resoltuion, using the proof of the Completeness
   of Resolution as a guide.  QQ2, QQ8, QQ52, etc, are rekduced versions of QQ.

   Q8  Is a k=0 version, with about 50 hypothises, most not needed, 
       and the 2 needed lemmas.
   Q82 Is a k=0 version, with about 50 hypothises, most not needed,
       and with about 50 lemmas, most not needed.

   Q5-0  Is a k>0 version, with only the needed hypotheses 
         and the 2 needed lemmas.
   Q8  Is a k>0 version, with about 50 hypothises, most not needed, 
       and the 2 needed lemmas.
   Q52  Is a k>0 version, with about 50 hypothises, most not needed,
        and with about 50 lemmas, most not needed.

   prx  is the proof of x.

   See files pr8, pr5, etc., for the proofs.

                       RESULTS

           Time to prove
           -------------

  pr8-0

  pr8       21 Seconds

  pr82      30   "

  pr5-0     21   "

  pr5       54   "

  pr52      ??


|#


(defun whos-first (L1 L2 V path) ;19Dec94 4Feb95  Called by HL 
  ;;L1 is (cdr C) from HL
  (let (W L1* L1s LL LLk LLk0 Lij Ci* path* theta k0 L1pc)
    (cond ((setq L1* (mapcan #'(lambda (Ci) 
                (cond ((member*2 Ci L2 V V (cons 'who path)) (list Ci))))
			     L1))
	   (setq LL (mapcar #'(lambda (Ci) 
                        (setq W (member*2 Ci L2 V V (cons 'who2 path)))
			(setq theta (car W))
			(setq Lij (mapcan #'(lambda (Cj) 
		           (cond ((member (apply-sub theta Cj) L2 :test 'equal)
				  (list Cj))))
					  L1*))
		(list Ci Lij))
			    L1*))
	   (setq LLk (mapcar #'(lambda (u) (length (cadr u)))
			     LL))
	   (setq k0 (maxx LLk))             ;The largest of member of LLk
	   (setq LLk0 (mapcan #'(lambda (u)
                       (cond ((equal k0 (length (cadr u))) (list (car u)))))
			      LL))
	   (cond ((some #'(lambda (Ci) 
		            (and (setq path* (cons (name Ci) path)) 
				 (setq Ci* Ci)
				 (not (member path* *reject* :test 'equal))))
			LLk0)
		  (list Ci* path*))
		 (t nil)))
	  ((setq L1pc (sort-preds-fcns-consts L1 L2))
	   (cond ((some #'(lambda (Ci) 
			      (and (setq path* (cons (name Ci) path)) 
				   (setq Ci* Ci)
				   (not (member path* *reject* :test 'equal))))
			L1pc)
		  (list Ci* path*))
		 (t nil)))
	  ((setq L1s (sort-strange L1))
	   (cond ((some #'(lambda (Ci) 
		             (and (setq path* (cons (name Ci) path)) 
				  (setq Ci* Ci)
				  (not (member path* *reject* :test 'equal))))
			L1s)
		  (list Ci* path*))
		 (t nil)))
	  (t nil) )))
