;;;*********************************************************************
;;;
;;;            IMPLY.lisp  An Interactive Natural Deduction Theorem
;;;                         Prover In KCL
;;;                                 
;;;               W. W. Bledsoe        21 Jan 1988   24 June 1988
;;;      This is a Kyoto Common Lisp version of an earlier version
;;;             which was called IMPLYi.LISP.  With YET and VE
;;;             and other features added (Aug 87)
;;;             
;;;             (Changed from IMPLYi-c.LISP, 7 Jan 88)
;;;
;;;********************************************************************
;;;      This requires the files:   
;;; 
;;;          PROVE.LISP  (now PROVE1.LISP and PROVE2.LISP)
;;;          OPTIONS.LISP
;;;          EXAMPLE-theorems.lisp    (Example theorems)
;;;          UNIFY.LISP
;;;          REDUCE.LISP
;;;          SKOLEM.LISP
;;;          VE.LISP
;;;          SYM.LISP
;;;          REPLACE.LISP
;;;          PLANS.LISP
;;;           etc
;;;     Load, then call (PROVE theorem), where theorem is being proved
;;;       e.g., try (PROVE ex1), or (PROVE ex2), etc.
;;;*******************************************************************

;; The following functions are for ease in loading and editing

(defun load-lisp-all ()			;load lisp source files
;;2Jan90 Version
  (lp)(lo)(lu)(ls)(lr)(lrep) (lle) (ld) (lj) (lg) (load-sb-o-all)
  (le)(lv)(lin)(lpl)(lan))         ;this line added for 2Jan90 version
(defun load-str+ve-all () (lrv) (lu) (ls) (lres) (ld)(le)(lv)(lrst)(lhst)(lst))

(defun load-set-var-all () (lrv) (lu) (ls) (ld)(le)(lv)(lrst)(lhst)(lres)(lh)
(lhs)(lsvo)(lsvo2)(lsv)(lsvr)(lsv3))
(defun load-set-var-all () (lrv) (lu) (ls) (ld)(le)(lv)(lrst)(lhst)(lres)(lh)
(lhs)(lsv)(lr)(lo) (lpbr)(lop)(lp)(lhp) (lsv))  ;2Feb93

(defun aug89 () (load-lisp-all)(load "grd-sb.lisp") (load-sb-o-all)(lcu)(lcs))

(defun compile-all ()
  (cp)(co)(cu)(cs)(cr)(crep)(cle)(cd)(cj)(cg) (compile-sb-all)
  (cv)(cin)(cpl)(can))

(defun load-all ()                      ;load compiled files
  (lcp)(lco)(lcu)(lcs)(lcr)(lcrep)(lcle)(lcd)(lcj)(lcg)(load-sb-o-all)(le)(lcv)
  (lcin)(lcpl)(lcan))

(defun l ()(load "imply.lisp"))
(defun lp1 () (load "prove1.lisp"))
(defun lp2 () (load "prove2.lisp"))
(defun lp3 () (load "prove3.lisp"))
(defun lp4 () (load "prove4.lisp"))
;(defun lp () (lp1) (lp2) (lp3)(lp4))  ;old
(defun lp  () (load "prove.lisp"))     ;9Jan92
(defun lo1 () (load "options1.lisp"))
(defun lo2 () (load "options2.lisp"))
(defun lo3 () (load "options3.lisp"))
(defun lo4 () (load "options4.lisp"))
;(defun lo () (lo1)(lo2)(lo3)(lo4))    ;old
(defun lo () (load "options.lisp"))    ;9Jan92
(defun lop () (load "otter-pvr13.lsp"))
(defun lov () (load "prover/overall-prover.lisp"))
(defun le () (load "example-theorems.lisp"))
(defun lu () (load "unify.lisp"))
(defun ls () (load "skolem.lisp"))
(defun lsi () (load "simpler.lisp"))
(defun lr () (load "reduce.lisp"))
(defun lrv () (load "reduce-ve.lisp"))
(defun lrsv () (load "reduce-sv.lisp"))
(defun lv () (load "ve.lisp"))
(defun lsym () (load "sym.lisp"))
(defun lrep () (load "replace.lisp"))
(defun lehbn1 () (load "examples-hb-nit1.lisp"))
(defun lehbn2 () (load "examples-hb-nit2.lisp"))
(defun lh2hbn1 () (load "examples2-hb-nit1.lisp"))
(defun lex  () (load "ex.lsp"))
(defun lin  () (load "infix.lisp"))
(defun lpl  () (load "plans.lisp"))
(defun largs ()(load "arguments.lisp"))
(defun lan  () (load "analogy.lisp"))
(defun lpr  () (load "proofs.lisp"))
(defun lle  () (load "lemmas.lisp"))
(defun ld   () (load "dons-ground-prover.lisp"))
(defun lj   () (load "journal-ready.lisp"))
(defun lg   () (load "grd-sb.lisp"))   ;Larry's Subset prover
(defun lb   () (load "bert.script"))
(defun lst  () (load "str+ve.lisp"))
(defun lres () (load "resolution.lisp"))
(defun lrs  () (load "res.lisp"))
(defun lst  () (load "str+ve.lisp"))
(defun lrst () (load "rstr+ve.lisp"))
(defun lhst () (load "hstr+ve.lisp"))
(defun lh   () (load "hand.resolution"))
(defun lhp  () (load "hyper-res.lisp"))
(defun lhs  () (load "hand.set-var"))              ;old
(defun lhs  () (load "hand-set-var.lisp"))         ;new
(defun lhs2 () (load "hand-set-var2.lisp"))
(defun lsv  () (load "set-var.lisp"))
(defun lsm  () (load "sv-marty.lisp"))
(defun lax  () (load "sv-aux.lisp"))  
(defun lsvo () (load "set-var-old.lisp"))
(defun lsvo2 () (load "set-var-old2.lisp"))
(defun lsvel () (load "set-var-element-version.lisp"))
(defun lsvr () (load "set-var-r.lisp"))
(defun lsvr () (load "set-var-r.lisp"))
(defun lsv3 () (load "set-var3.lisp"))
(defun lsv4 () (load "set-var4.lisp"))
(defun lsv5 () (load "set-var5.lisp"))
(defun lsv6 () (load "set-var6.lisp"))
(defun lsv7 () (load "set-var7.lisp"))
(defun lsc  () (load "script-prover.lisp"))
(defun lpc  () (load "pc.lisp"))
(defun lpcp () (load "pc.plans-lemmas"))
(defun l*t  () (load "theorems*.lisp"))
(defun lppc () (load "pcp.lisp"))
(defun lppp () (load "pcp.plans-lemmas"))
(defun lotL () (load "otter-pvr7.lsp"))
(defun lot () (load "otter-pvr9.o"))
(defun lpi () (load "prove-i.lisp"))
(defun lpi () (load "p-imply.lisp"))
(defun lpio () (load "prove-i.o"))
(defun lm () (load "me-pc.lisp"))
(defun lpbr () (load "pbr.lisp"))
(defun lt0 () (load "bt.i0"))
(defun lru () (load "runner.lisp"))
(defun lf  () (load "facial.lisp"))
(defun los () (load "otter-struve.experiments"))
(defun luo () (load "uses-only.lisp"))
(defun lsg () (load "struve-guide.lisp"))
(defun lpci () (load "pci.lisp"))
(defun lpbe () (load "examples-pbr.lisp"))
(defun lpLe () (load "examples-pbrL.lisp"))
(defun lplns () (load "pc-plans.lisp"))

(defun ci () (compile-file "imply.lisp"))
(defun cp1 () (compile-file "prove1.lisp"))
(defun cp2 () (compile-file "prove2.lisp"))
(defun cp3 () (compile-file "prove3.lisp"))
(defun cp4 () (compile-file "prove4.lisp"))
(defun cp () (cp1)(cp2)(cp3)(cp4))
(defun co1() (compile-file "options1.lisp"))
(defun co2() (compile-file "options2.lisp"))
(defun co3() (compile-file "options3.lisp"))
(defun co4() (compile-file "options4.lisp"))
(defun co() (co1)(co2)(co3)(co4))
(defun ce () (compile-file "example-theorems.lisp"))
(defun cu () (compile-file "unify.lisp"))
(defun cs () (compile-file "skolem.lisp"))
(defun cr () (compile-file "reduce.lisp"))
(defun cv () (compile-file "ve.lisp"))
(defun csym () (compile-file "sym.lisp"))
(defun crep () (compile-file "replace.lisp"))
(defun cin  () (compile-file "infix.lisp")))
(defun cpl  () (compile-file "plans.lisp")))
(defun cpr  () (compile-file "proofs.lisp"))
(defun can  () (compile-file "analogy.lisp"))
(defun cle  () (compile-file "lemmas.lisp"))
(defun cd   () (compile-file "dons-ground-prover.lisp"))
(defun cj   () (compile-file "journal-ready.lisp"))
(defun cg   () (compile-file "grd-sb.lisp"))   ;Larry's Subset prover

(defun lci () (load "imply.o"))
(defun lcp1 () (load "prove1.o"))
(defun lcp2 () (load "prove2.o"))
(defun lcp3 () (load "prove3.o"))
(defun lcp4 () (load "prove4.o"))
(defun lcp () (lcp1)(lcp2)(lcp3)(lcp4))
(defun lco1 () (load "options1.o"))
(defun lco2 () (load "options2.o"))
(defun lco3 () (load "options3.o"))
(defun lco4 () (load "options4.o"))
(defun lco () (lco1)(lco2)(lco3)(lco4))
(defun lce () (load "example-theorems.o"))
(defun lcu () (load "unify.o"))
(defun lcs () (load "skolem.o"))
(defun lcr () (load "reduce.o"))
(defun lcv () (load "ve.o"))
(defun lcsym () (load "sym.o"))
(defun lcrep () (load "replace.o"))
(defun lcin  () (load "infix.o"))
(defun lcpl  () (load "plans.o"))
(defun lcpr  () (load "proofs.o"))
(defun lcan  () (load "analogy.o"))
(defun lcle  () (load "lemmas.o"))
(defun lcd   () (load "dons-ground-prover.o"))    
;(defun lcd   () (load "ineq-prover.o"))         ;26 May 89
(defun lcj   () (load "journal-ready.o"))

(defun compile-sb-all () 
  (compile-file "cnf.lisp")
  (compile-file "sb1.lisp")
  (compile-file "sb2.lisp")
  (compile-file "grd-sb.lisp") )

(defun load-sb-o-all () 
  (load "cnf.o")
  (load "sb1.o")
  (load "sb2.o")
  (load "grd-sb.o") )

;;*******************************************************************
;;
;;             INITIALIZATION
;;
;;    Global Variables are (usually) given names of the form *global*
;;    Variables Scoped within  PROVE  are written  %scoped%
;;       "        "      "     IMPLY   "    "      @scoped@
;;       "        "      "  AND-C & OR-H "  "      &scoped&  (Old)
;;
;;********************************************************************

       ;The % %  indicates: 
       ;used within scope of PROVE-EXECUTOR
(defvar *-* nil)
(defvar *-c* nil)                       ;for suppressing printing "claim etc"
(defvar *after-Label* nil)
(defvar %al% nil)                       ;Analogy Light
(defvar *ancestry-light* t)           ;ancestry light
(defvar *A-options-stop-light* nil)
(DEFVAR *BC-DEPTH-LIGHT* T)            ;USED-IN (IMPLY-RULES)
(DEFVAR *BC-DEPTH-LIMIT* 50.0)          ;USED-IN (IMPLY-RULES)
(defvar *back-<chain-light* t)
(DEFVAR *CATCH-ATOM* NIL)            ;used by IMPLY OPTIONS BACKUP
(DEFVAR *CATCH-LIGHTS* '(B CATCH 1 2 PROVE proceed))
  ;used by IMPLY
(DEFVAR *CE-THEOREMS* NIL)
(defvar *claim-number* nil)
(defvar *CLL* nil)
(DEFVAR *CNT* 0)
(DEFVAR *CONSTANT-LIST*      ;USED-IN (ALL-VARS-IN INSTANCE-ELLIPSES)
 '(FALSE OMEGA TRUE UNIVERSE --- === %%% /// Completeness-of-Ground-Resolution    LOCK-Completeness-of-Ground-Resolution NIL []))
(DEFVAR *DEFINITION-TABLE* NIL)    ;see options
(defvar *detail-printing-light* nil)
(DEFVAR &EXCLUDE& NIL)      ;used by UNIFY, reset by AND-C,OR-H  (OLD)
(DEFVAR *EXPL* NIL) 
(defvar *flip* nil)        ;Flip light
(defvar *fsv* nil)
(defvar *function-type-list* '(f g h))
(defvar *function-depth-lt* nil)
(DEFVAR %GOAL-MESSAGE% NIL)
(DEFVAR %GLOBALERROR% 0)
(defvar *global-no-reduce-light* nil)
(defvar *global-QED-light* nil)
(defvar %ground-units% nil)
(defvar *ground-prover-file* nil)
(defvar *ground-prover-light* nil)
(defvar *hoalimit* 12)
(defvar *Hn* nil)
(defvar *imply-break-light* nil)
(defvar *imply-trace-light* nil)
(defvar *imply&prover-arguments* nil)
(defvar *in* 0)            ;For limiting the depth of recalling IMPLY-RULES
(defvar *in-lt* nil)       ;  "
(defvar *in-Limit** 50)    ;  "
(defvar *in-Limit* *in-Limit**)   ;  "
(defvar *indent* 0)                   ;Indent parameter for Jour Ready Proofs
(defvar *iprn* nil)
(defvar *jr-light* nil)               ;Indicates working on Jour Ready Proofs
(DEFVAR *LEMMA-LIST* NIL)
;;; don't seem to need it (defvar *lu-list* nil)
(defvar *nh* 1)
(defvar *ns* 0)
(defvar *no-interrupt* nil)
(DEFVAR %NON-STOP-LIGHT% NIL)          ;Used in OPTIONS
(defvar %object-list% nil)
(DEFVAR *OMIT-NIL-PROOF-LIGHT* NIL)
(defvar *order-c* t)
(defvar *or-out-light* nil)
(defvar *pbr-flag* nil)
(defvar %pairs-light% t)
(defvar *pairs-structure* 
    '( (element ( ((subset A B) (element x B) (element x A))
		  ((=      A B) (element x B) (element x A))
		  ((=      A B) (element x A) (element x B)) ))
       (subset  ( ((=      A B) (subset A B) (TRUE))
                  ((=      A B) (subset B A) (TRUE)) )) 
       (<=      ( ((<      A B) (<=     A B) (TRUE)) )) ))

(defvar *pairs-structure* 
    '( (element ( ((subset A88 B99) (element x77 B99) (element x77 A88))
		  ((=      A88 B99) (element x77 B99) (element x77 A88))
		  ((=      A88 B99) (element x77 A88) (element x77 B99)) ))
       (subset  ( ((=      A88 B99) (subset A88 B99) (TRUE))
                  ((=      A88 B99) (subset B99 A88) (TRUE)) )) 
       (<=      ( ((<      A88 B99) (<=     A88 B99) (TRUE)) )) ))

(defvar *period* '\.)
(defvar %plan% nil)
(defvar *%plan% nil)
(defvar %plan%% nil)
(defvar *pl* nil)
(defvar %plan-list% nil)
(defvar *pnames* nil)
(defvar *print-pretty* T)
(defvar *print-light* t)
(DEFVAR *PRINT-PROOF-LIGHT* nil)  ;USED-IN (PROVE)
(DEFVAR %PROOF% nil)
(DEFVAR %PROOF-LIST% NIL)   
(DEFVAR *PROOF-SAVE-LIGHT* NIL)   ;was USED-IN (PROVE)
(defvar *putlist* nil)
(DEFVAR %REDUCE-LIGHT% nil)
(DEFVAR *REDUCE-LIGHT* T)
(DEFVAR *REDUCE-TABLE* NIL)   ;USED-IN (ADD-REDUCE REDUCE)
(DEFVAR *reduce-table-ellipses* NIL)   ;USED-IN (ADD-REDUCE REDUCE)
(defvar *reject* nil)     ;Used in (back-chain) to reject certain bad subgoals
(DEFVAR *REPORT-LIGHTS*         ;USED-IN (IMPLY OPTIONS)
  '(QED-1 DETAIL-1 DETAIL-3 1 2 PROCEED PROVE))
(defvar *short-print-light* nil)
(defvar *shorten-c-light* nil)                      ;17July92  OPTIONS
(defvar *skolem-function-list* nil)
(DEFVAR *STOP-LIGHTS* '(1 2 PROVE proceed))       ;USED-IN (IMPLY OPTIONS)
(defvar *suppress-printing-c* nil)
(DEFVAR *SYMBOL-LIST*	;was USED-IN (ALL-VARS-IN INSTANCE-ELLIPSES) 
    '(EMPTY-SET & * + - --- -> = === < <= > >= || ABS ALL CHOICE
      CLOSURE CLOSURE-F 		 ELEMENT FALSE INTERSECTION
      INTERSECTION-OF-SETS LIMIT LIM MEMBER NOT OMEGA OR RANGE REFINEMENT
      REPEAT SCSR SET-OF SET-= SINGLETON 		 SOME SUBSET SUBSETS
      SUM TRUE UNION UNION-OF UNION-OF-SETS 		 UNIVERSE %%%
      continuous continuous-de continuous-n cont cont-de cont-n
      differentiable differentiable-de differentiable-L differentiable*
      diff diff-de diff-L []
      lambda))



(DEFVAR *TEMP* NIL)
(defvar *theorem-name* 'theorem)
(defvar %theorem-variables% '(%x%))
(DEFVAR %TIME% 0)
(defvar *unit-subsumption* nil)
(defvar *v* nil)  ;verbose for extra printing
(DEFVAR *VARIABLE-SUPPLY*                ;USED-IN (NEW-VARIABLES)
  '(X Y Z V W X1 Y1 Z1 U1 V1 W1 X2 Y2 Z2 U2 V2 W2 X3 Y3 Z3 U3 V3 W3
    X4 Y4 Z4 U4 V4 W4 X5 Y5 Z5 U5 V5 W5 X6 Y6 Z6 U6 V6 W6 X7 Y7 Z7 U7 V7 W7))
(defvar *var-sup-flag* nil)
(defvar *vc* nil)
(DEFVAR *VE-LIGHT* NIL)

;(lp1)(lp2)(lo)(le)(lu)(ls)(lr)(lv) (lsym) (lrep)     ;load lisp files

;;These are for testing Pairs-back-chaining
(setq eu '(-> (subset A B) (element x B)))
(setq em '(-> (& (element x A) (subset A B)) (element x B)))
(setq e1 '(-> (-> true (subset A B)) (element x B)))
(setq e2 '(-> (-> true (& (element x A) (subset A B))) (element x B))) 
(setq e3 '(-> (-> true (or P            (subset A B))) (element x B)))
(setq e4 '(-> (& P (-> true (subset A B)) (element x A)) (element x B))) 
(setq e5 '(-> (& P (-> true (& (element x A) (subset A B)))) (element x B))) 
(setq e6 '(-> (& P (-> true (or R            (subset A B)))) (element x B)))
(setq e7 '(-> (& P (-> true (& (element x A) (-> P (subset A B)))))
              (element x B)))

