;;;24July93  This is an earlier version of pc.lisp. Used by it.
;;;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;;;
;;;                       pbr.lisp                          20 Dec 1991
;;;                                                         15 Jan 1992
;;;                                                         23 Jan 1992
;;;                                                         28 Jan 1992
;;; (load "imply.lisp")(lres)(lrs)(lop) (load-lisp-all)(lpbr)(lpbe)(lpLe)
;;;
;;;    The   MULTI-LEVEL    WFF  Fi Fi2    Version    using OTTER (and not RES)
;;; This version uses WFF as members of the PLN (instead of clauses)
;;;
;;; See DOCUMENTATION below for a description.
;;;
;;;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

(defun lrs  () (load "res.lisp"))
(defun lpbr () (load "pbr.lisp"))
(defun lpbe () (load "examples-pbr.lisp"))
(defun lpLe () (load "examples-pbrL.lisp"))
(defun lpbro () (load "pbr.o"))
(defun lop () (load "otter-pvr13.lsp"))
(defun to () (trace otter-prove))

(defvar *print-light* t)
(defvar *rounds-limit* 4)
(defvar *theta* nil)
(setq %theorem-variables% nil)
(defvar *n* 30)
(defvar *tt* nil)

(defun pbr (H theorem Plan &optional Pln theta un-L flag)            ;top call
  ;;PBR attemps to prove the theorem THEOREM using the plan PLAN. 
  ;;This is done in two stages: PRE-PROCESS and REASON.  
  ;;H is a WFF, the general hypothesis for the theorem, and Plan has the form,
  ;;  (u1 u2 u3 ... un)
  ;; where each of the units ui has the form [Fi flagi plani lemmasi],
  ;; where Fi is a WFF and FLAGi is nil or tt (tt if Fi is to be assumed 
  ;;  without proof). Or ttt, a convenience in checking out a plan. 
  ;; PLANi and LEMMASi are usually nil, when not-nil they are
  ;;  used to help prove Fi (See documentation for PRE-PROCESS, REASON, etc).
  ;;THETA lets use abbreviations for certair formulas.
  ;;un-L is used in for naming the plan units. FLAG is like FLAGi, for THEOREM.
  (let (V terms lms)
    (setq *theta* (fuze-nums-to-vars theta))  ;fuzes n's to bound vars of THETA
    (cond (H (setq lms (list H))))
    (cond (pln) (t (setq pln (pre-process theorem plan lms un-L flag))))
    (setq %theorem-vairables% (append (variables-in pln) '(%X%))) ;initialize  
    (setq *n* 30)
    (reason pln)))

(defun reason (pln)     ;called by PBR           18Feb92
  ;;PLN has the form   (u1  u2  u3  ... un ) =

  ;;  (... [Fi Fi2 Vi flagi plani lemmasi] ...)

  ;; Fi and Fi2 are WFFs.
  ;;These Fi's are the same as those in PBR except that here any leading
  ;; existential quantifier has been removed and its variable placed in Vi.
  ;; (see pre-process documentation). Vi = NIL or a set of variables.
  ;; Fi2 starts the same as Fi but changes when backtracking is used.
  ;; flagi is t or nil -- depending on whether Fi has been proved,
  ;;  or tt if Fi is to be assumed without proof.
  ;; plani, if not nil, is a sub-plan for proving Fi, 
  ;; lemmasi is a list of lemmas to help with the proof of Fi.

  ;;REASON attemps to prove the Fi's one at a time, calling on the
  ;; proving function, PR (which uses OTTER).
  ;;If it fails on a particular Fi, it calls BACK-TRACK which attemps
  ;; to repair some earlier unit uj in the plan PLN, so that Fi can be proved.

  (let (ui ui* namei Fi Fi2 Vi flagi plni lemmasi lemmai Fpi Hi Fiq 
	   Fi* u* pln*)
    (cond ((setq ui* (find-ui pln))     ;Finds the first non-proved unit of PLN
	   (setq ui (cdr ui*)) (setq namei (car ui*))
	   (setq Fi (car ui)) (setq Fi2 (cadr ui)) (setq Vi (caddr ui))

	   (setq flagi (cadddr ui)) (setq plni (fifth ui)) 
	   (setq lemmasi (sixth ui))
	   (setq lemmai (cond (lemmasi (andify (mapcar #'evalx lemmasi)))))
	   (setq Fpi (and-on1 pln ui*))               ;conjoin previous Fj's
(prnt namei Fi) (prnt Vi);; (prnt Fpi)
	   (setq Hi (and-on lemmai Fpi))
	   (setq Fiq (re-quantify Fi2 Vi))

	   (cond ((eq '[] (setq Fi* (pr Hi Fiq)))
		  ;;try to prove Hi->Fi
		  ;;if proved, put plni=T and proceed
		  (setq u* (copy-tree ui))
		  (setf (fourth u*) t)
		  (setq pln* (subst u* ui pln :test 'equal))
		  (reason pln*))
		 ((setq pln* (back-track pln Fi* ui*))    ;note ui* here 7Mar92
		  ;;if not proved, back-track
		  (reason pln*))
		 (t nil) )) 
	  (t '[])   ;all plan-units handled,
	  )))


(defun pr (H F)                          ;called by REASON 18Feb92
  ;;Tries to prove the supposed theorem  H->F.
  ;;If it succeeds, it returns [].  Else it returns F*, which is such
  ;; that (& F* -> F).  Ie, F* is a pre-condition for F.
  ;; 28Jan92: It used the OTTER prover of McCune.
  (let (RR F* H* theta theta* W)
    (setq H (replace-multiple-quantifiers H))
    (setq F (replace-multiple-quantifiers F))
    (setq F* (unique-ize-quan-vars F))(setq H* (unique-ize-quan-vars H))
    (cond ((eq-car (setq RR (otter-prove F*
			 :inference-rules '(binary_res para_into para_from)
;;			 :return-reduced-formula t
			 :time 3
			 :base-axioms H*))
		   t)                ;if OTTER proves it, return []
	   (return-from pr '[])))

    (setq F (beta-reduce (subliss *theta* F)))
    (setq F (remove-univ-qs F))
#|                                             ;removed 12Mar92
    (setq F (reduce-p F))                      ;apply definitions, etc.
    (setq F (remove-univ-qs F))
;;  (setq F (apply= F))                        ;Removed 6Feb92
    (setq F (reduce-p F))                  
|#
    (setq H (beta-reduce (sublis *theta* H)))
    (setq W (unique-ize-quan-vars F t))
    (setq theta (cadr W)) (setq F* (car W))
    (setq theta* (mapcar #'(lambda (u) (cons (cdr u) (car u))) theta))
    (setq H* (unique-ize-quan-vars H))
    (cond ((eq-car (setq RR (otter-prove F*
			 :inference-rules '(binary_res para_into para_from)
;;			 :return-reduced-formula t
			 :time 30
			 :base-axioms H*))
		   t)                ;if OTTER proves it, return []
	   '[])
	  ((member RR '(:timed-out :unknown :false)) nil)
	  (t (sublis theta* (cadddr RR) :test 'equal))
           ;;else, return the pre-condition
	  )))

(defun back-track (pln Fi* ui* &optional ujs)              ;called by REASON
  ;;When REASON fails to prove a unit ui in PLN it calls BACK-TRACK
  ;;which finds the last proved unit uj of PLN before ui which is not in UJS
  ;; and for which some member of Vj occurs in Fi*.  It then conjoins
  ;; the Fi* from unit ui with the Fj2 of unit uj and tries to prove the
  ;; combined goals (if that fails it back-track further etc.)
  (let (ui uj* uj namej Fj Fj2 Fi Fji Fji2 Vj Vi Vji uji* pln* ui2 plnj 
	   lemmasj lemmaj Fpi Hji Fjiq Vj* theta)
    (setq ui (cdr ui*))      ;ui =  (      Fi Fi Vi flagi plni lemmasi) 7Mar92
                             ;ui* = (namei Fi Fi Vi flagi plni lemmasi)
    (setq uj* (find-uj pln Fi* ui* nil ujs))    ;see above
    (cond ((not uj*) (return-from back-track nil)))
    (setq uj (cdr uj*)) (setq namej (cdr uj*))
    (setq Fj (car uj)) (setq Fj2 (cadr uj)) (setq Fi (car ui))
    (setq Fji  (and-on Fj  Fi))      ;conjoin the two subgoals
    (setq Fji2 (and-on Fj2 Fi*))     ;conjoin the two subgoals
    (setq Vj (caddr uj)) (setq Vi (caddr ui)) (setq Vji (union-w Vj Vi))
    (setq uji* (list namej Fji Fji2 Vji t (fith uj)(sixth uj))) 
                                    ;new (combined) unit (with namej)
    (setq pln* (subst uji* uj* pln :test 'equal))  ;new pln
    (setq ui2 (copy-tree ui*)) (setf (fourth ui2 t))
    (setq pln* (subst ui2 ui* pln* :test 'equal))

    (setq plnj (firth uj)) (setq lemmasj (sixth uj)) ;plnj should be nil here
    (setq lemmaj (cond (lemmasj (mapcar #'evalx lemmasj))))
    (setq Fpi (and-on1 pln* ui))          ;all proved units up to ui
    (setq Hji (and-on lemmaj Fpi))
    (setq Fjiq (re-quantify Fji2 Vji))
    (setq Vj* (mapcar #'new-symbol Vj))
    (setq theta (ampcar #'(lambda (x y) (cons x y)) Vj Vj*))
    (setq Fjiq (sublis theta Fjiq))
    (cond ((eq '[] (pr Hji Fjiq)) pln*) ;if succeed then continue from ui
	  ;;if fail, then back-track further with Fji2
	  (t (back-track pln* Fji2 ui* (cons uji* ujs))) )))

(defun and-on1 (pln u)        ;called by REASON  27Feb92 for multi-level plans
  ;;Conjoin the "previous" Fi's before u in PLN. 
  ;;PLN is the whole multi-level plan.  
  ;; U is a unit of PLN or of a lower level plan.
  ;;7Mar92 U has the form (name F F2 V flag plan lemmas)
  (let (ui plni flagi Hi)
    (cond ((null pln) t)                         ;cannot happen?
	  ((equal u (setq ui (car pln))) t)      ;stop at the plan-unit u
	  ((setq flagi (fifth ui))              ;ui is marked as proved 
	   (and-on (cadr ui) (and-on1 (cdr pln) u)))  ;so add Fi
	  ((setq plni (sixth ui))                ;ui has a pln, plni
	   (cond ((all-proved-below plni)        ;All proved below so
		  (and-on (cadr ui) (and-on1 (cdr pln) u))) ;add Fi
		 (t (setq Hi (H-part (cadr ui)))  ;Not all proved below
		    (and-on Hi (and-on1 plni u)))))  ;so explore plni
	  (t (and-on1 (cdr pln) u)                   ;cannot happen
	     ) )))

(defun all-proved-below (pln)                ;7Mar92 Called by AND-ON1
  (let (ui plni flagi)
    (cond ((null pln) t)
	  ((setq flagi (fifth (setq ui (car pln)))) ;ui is marked proved
	   (all-proved-below (cdr pln)))
	  ((setq plni (sixth (car pln))) ;ui not marked proved, but has a plni
	   (cond ((all-proved-below plni) (all-proved-below (cdr pln)))
		 (t nil)))
	  (t nil) )))
	     
(defun apply= (A &optional (p t))     ;5Jan92 called by PR.  p is parity
  ;;If (= x y) appears in the hypothesis of A then replace y by x in A
  ;;Similarly for a subpart of A.  Dont need p.
  (let (H C E NE H* C* x y A2 A2*)
    (cond ((and (eq-car A 'ALL) (setq x (cadr A))
		(eq-car (setq A2 (caddr A)) '->) 
		(setq H (cadr A2)) (eq-car H '&) 
		(some #'(lambda (u) (and (eq-car u '=) (setq E u)
			   (or (and (eq x (cadr E)) (setq y (caddr E)))
			       (and (eq x (caddr E)) (setq y (cadr E))))
			   (not (occur x (setq y (caddr E)))))) (cdr H)))
	    ;;eg (apply= '(all x (-> (& (p x) (= x y)) (Q x))))
	    ;; = (-> (p y) (q y))     
	   (setq H* (remove E H :test 'equal))
	   (setq H* (subst y x H* :test 'equal))
	   (setq H* (apply= H* (not p)))
	   (setq C* (subst y x (caddr A2) :test 'equal))
	   (setq C* (apply= C* p))
	   (setq A2* (imp-on H* C*))
	   A2*)
	  ((and (eq-car A 'ALL) (setq x (cadr A))
		(eq-car (setq A2 (caddr A)) '->) 
		(setq E (cadr A2)) (eq '= (car E))
		(or (and (eq x (cadr E)) (setq y (caddr E)))
		    (and (eq x (caddr E)) (setq y (cadr E))))
		(not (occur x (setq y (caddr E)))))
	    ;;eg (apply= '(all x (-> (= x y) (Q x)))) = (Q y)
	   (setq C* (subst y x (caddr A2) :test 'equal))
	   (setq C* (apply= C* p))
	   C*)
	  ((and (eq-car A 'ALL) (setq x (cadr A))
		(eq-car (setq A2 (caddr A)) '&)
		(some #'(lambda (u) (and (eq-car u 'not) 
					 (eq-car (setq E (cadr u)) '=)
			   (or (and (eq x (cadr E)) (setq y (caddr E)))
			       (and (eq x (caddr E)) (setq y (cadr E))))
			   (not (occur x (setq y (caddr E)))))) (cdr A2)))
	    ;;eg (apply= '(all x (& (p x) (not (= x y)) (Q x))))
	    ;; = (& (p y) (q y))
	   (setq A2* (remove (list 'not E) A2 :test 'equal))
	   (setq A2* (subst y x A2* :test 'equal))
	   (setq A2* (apply= A2* (not p)))
	   A2*)
	  ((and (eq-car A 'SOME) (setq x (cadr A))
		(eq-car (setq A2 (caddr A)) '&)
		(some #'(lambda (u) (and (eq-car (setq E u) '=)
			   (or (and (eq x (cadr E)) (setq y (caddr E)))
			       (and (eq x (caddr E)) (setq y (cadr E))))
			   (not (occur x (setq y (caddr E)))))) (cdr H)))
	    ;;eg (apply= '(some x (& (p x) (= x y) (Q x))))
	    ;; = (& (p y) (q y))
	   (setq A2* (remove E A2 :test 'equal))
	   (setq A2* (subst y x A2* :test 'equal))
	   (setq A2* (apply= A2* (not p)))
	   A2*)
	  ((member (car A) '(& or)) 
	   (cons (car A) (mapcar #'(lambda (u) (apply= u p)) (cdr A))))
	  ((eq-car A 'not) (list 'not (apply= (cadr A) (not p))))
	  ((eq-car A '->)  (list '->  (apply= (cadr A) (not p))
				      (apply= (caddr A) p)))
	  ((member (car A) '(all some)) 
	   (list (car A) (cadr A) (apply= (caddr A) p)))

	  (t A) )))

(defun assoc3 (pln)    ;called by REASON               16Jan92
  ;;return the first unit of pln whose third element is NIL
    (let (u)
      (cond ((null pln) nil)
	    ((not (third (setq u (car pln)))) u)
	    (t (assoc3 (cdr pln))))))
(defun assoc4 (pln)    ;called by REASON               16Jan92
  ;;return the first unit of pln whose fourth element is NIL
    (let (u)
      (cond ((null pln) nil)
	    ((not (fourth (setq u (car pln)))) u)
	    (t (assoc4 (cdr pln))))))

(DEFUN BC (H C &optional C*)
 (LET (THETA LAMBDA B* H** Hn* C**)
  (COND ((equal H C) C*)
	((setq theta (unify H C)) (apply-sub theta C*))
	((atom H nil))

        ((eq '-> (car H))
         (setq C** (and-on (cadr H) C*))
         (bc (caddr H) C C**))

        ((eq '& (car H))
         (cond ((some #'(lambda (H*) (setq C2 (bc H* C C*))) (cdr H))
		(and-on C* C2))
	       (t C*))) )))
(defun back-chain (H C) 
  (let (W)
    (cond ((setq W (bc H C)) 
	   (remove-excess-quantifiers (car W))))))

(defun bc (H C &optional V (H2 t))
  ;;This returns W = (H* theta).  See examples just below.
  (let (theta H* C* W)
    (cond ((setq theta (unify-q H C V)) (list H2 theta))
	  ((and (eq-car C 'or) 
		(setq W (bc H (cadr C) V H2)))
	   (setq C* (car W)) (setq theta (cadr W))
	   (list (list 'or C* (caddr C)) theta))

	  ((and (eq-car C 'or) 
		(setq W (bc H (rest-of C) V H2)))
	   (setq C* (car W)) (setq theta (cadr W))
	   (list (list 'or (cadr C) C*) theta))

	  ((and (eq-car H '->) 
		(setq W (bc (caddr H) C V (and-on H2 (cadr H)))))
	   W)
	  ((and (eq-car H '->) 
		(setq W (bc (not-fcn (cadr H)) C V 
			    (and-on H2 (not-fcn (caddr H))))))
	   W)
	  ((and (eq-car H '&) 
		(some #'(lambda (H3) (setq W (bc H3 C V H2))) (cdr H))) 
	   W)
	  ((and (eq-car H 'all) 
		(setq W (bc (caddr H) C (cons (cadr H) V) H2)))
	   W)
	  ((and (eq-car C 'some) 
		(setq W (bc H (caddr C) (cons (cadr C) V) H2)))
	   (setq C* (subst (car W) (caddr C) C :test 'equal))
	   (list C* (cadr W)))
	  ((and (eq-car C '->) (setq W (bc H (caddr C) V H2)))
                                                           ;C= (-> (P x) (C x))
	   (setq C* (car W)) (setq theta (cadr W))         ;W= (B a/x)
	   (setq H* (apply-sub theta (cadr C)))
	   (list (list '-> H* C*) theta))                  ;((-> (P a) B) a/x)

	  ((and (eq-car C '&) 
		(some #'(lambda (A) (and (setq W (bc H A V H2)) (setq A* A))) 
		      (cdr C)))
	   (setq H* (car W)) (setq theta (cadr W))
	   (setq C* (subst H* A* C :test 'equal))
	   (list C* theta)) 

	  ((and (eq-car C 'all) (setq W (bc H (caddr C) V H2)))
	   (setq C* (car W)) (setq theta (cadr W))
	   (setq C* (list (car C) (cadr C) C*))
	   (list C* theta))

	  ((and (or (eq-car H 'all) (eq-car H 'some)) (eq (car H) (car C))
		(setq x (cadr H)) (setq y (cadr C))
		(setq H* (subst y x (caddr H)))
		(setq W (bc H* (caddr C) V H2)) )
	   (setq C* (car W)) (setq theta (cadr W))
	   (list (list (car C) y C*) theta))
	  (t nil) )))
  ;;(bc '(P x) '(p (a))) = (t (x a))
  ;;(bc '(-> (P x) (C x)) '(C (a))) = ((P (a)) ((x a)))
  ;;(bc '(all x (-> (P x) (C x))) '(C (a))) = ((P (a)) ((x a)))
  ;;(bc '(-> (P (a)) (C (a))) '(C x)) = ((P (a)) ((x a)))
  ;;(bc '(-> (P (a)) (C (a))) '(some x (C x))) = ((P (a)) ((x a)))
  ;;(bc '(-> Q (-> (P (a)) (C (a)))) '(some x (C x))) = ((P (a)) ((x a)))
  ;;(bc '(-> P Q) '(ALL x (-> R Q))) = (all x (-> R P))    ;theta ommitted
  ;;(bc '(-> P Q) '(-> R Q)) = (-> R P)
  ;;(bc '(-> P Q) 'Q) = P

(defun beta-reduce (A)                    ;called by REASON
  ;;(beta-reduce '((lambda x (Q x)) t)) = (Q t)
  ;;(beta-reduce '((lambda (x y) (Q x y)) r s)) = (Q r s)
  ;;We use beta-reduce2 only for convenience in tracing.
  (beta-reduce2 A))

(defun beta-reduce2 (A)      ;called by beta-REDUCE      24Feb92
 (let (B L Q)
  (cond ((atom A) A)
	((and (eq-car (car A) 'lambda) (atom (cadar A)))
	  ;;A has form ((lambda x (Q x)) t)
	 (subst (cadr A) (cadar A) (caddar A)))
	((eq-car (car A) 'lambda)  
          ;;A has form ((lambda (x1 x2 ...) (Q x1 x2 ...)) (t1 t2 ...))
	 (setq B (car A))                 ;(lambda (x1 x2  ...) (Q x1 x2  ...))
	 (setq L (cadr B))                ;(x1 x2  ...)
	 (setq Q (caddr B))               ;(Q x1 x2 ...)
	 (mapc #'(lambda (x y)
            (setq Q (beta-reduce2 (list (list 'lambda x Q) y))) ) L (cdr A))
	 Q)
	(t (cons (beta-reduce2 (car A)) (beta-reduce2 (cdr A)))) )))

(defun divide-pln (L u &optional fst)        ;called by BACK-TRACK2  15Jan92
  ;;ie, divide the list L=(a b c u d e f) into W=((a b c) (d e f))
  (cond ((null L) nil)
	((equal (car L) u) (list (reverse fst) (cdr L)))
	(t (divide-pln (cdr L) u (cons (car L) fst))) ))

(defun equl (x y)                            ;29Jan92 called by GROUND-IMPLY
  ;;Like EQUAL except that quantified variables can be different
  (cond ((equal x y) t)
	((atom x) nil) ((atom y) nil)
	((not (eq (car x) (car y))) nil)
	((member (car x) '(ALL SOME))
	 (equl (caddr x) (subst (cadr x) (cadr y) (caddr y))))
	((member (car x) '(& or -> not))
	 (every #'(lambda (u v) (equl u v)) (cdr x) (cdr y)))))

(defun evalx (x)               ;20Feb92 28Feb92
  ;;If x is an atom and (explode x) is the list (a n), then replace each
  ;; quantified symbol y in (eval x) by (fuze (y n)) and return the result.
  ;;(setq r5 '(all S (some C (P S C))))
  ;;(evalx 'r5) = (all S5 (some C5 (P S5 C5)))
  (let (L A V (Ln '(|0| |1| |2| |3| |4| |5| |6| |7| |8| |9|)))
    (cond ((not (atom x)) (return-from evalx x)))
    (setq L (explode x))
    (cond ((and (cdr L) (member (cadr L) Ln))
	   (setq L (cdr L))
	   (setq A (eval x))
	   (setq V (quantified-variables-in A))
	   (mapc #'(lambda (z) 
;;                   (setq A (subst (fuze (cons z L)) z A :test 'equal))
		     (setq A (subst (maknam (list z *n*)) z A :test 'equal))
		     (setq *n* (1+ *n*))             ;changed 28Feb92
		     )
		 V)
            A)
	  (t (eval x)) )))

(defun find-ui (pln)                         ;18Feb92 called by REASON
  ;;For MULTI-LEVEL Plans. Find the first unit ui of pln
  ;; for which flagi is nil and ui has no plan, or flagi is nil and
  ;; its plan plni has an unproved unit. 
  ;;We add the function FIND-Ui* only for tracing purposes
  (find-ui* pln) )

(defun find-ui* (pln)                         ;12Mar92 called by FIND-Ui
  (let (ui* ui flagi plni ui2)
    (cond ((null pln) nil)
	  ((and (setq ui* (car pln)) (setq ui (cdr ui*))
		(or (setq flagi (cadddr ui)) t)
		(setq plni (fifth ui)) nil)) ;name things

	  ((eq 't  flagi) (find-ui* (cdr pln)))            ;already proved
	  ((eq 'tt flagi) (find-ui* (cdr pln)))            ;never to be proved
	  (plni                       ;ui is not proved but has a plan, plni
	   (cond ((setq ui2 (find-ui* plni))            ;plni has an unproved 
		  ui2)                                 ;unit, so return it
		 (t (find-ui* (cdr pln))) ))
	  (t ui*)            ;ui* is not proved and has no plan, so return ui*.
	  )))

(defun find-uj (pln Fi* ui* &optional ujj ujs)   ;7Mar92 called by BACK-TRACK
  ;;For MULTI-LEVEL Plans. Find the last proved member uj* of pln before ui* 
  ;; which is not in ujs and for which some member of Vj occurs in Fi*
  ;;Note: uj* has the form (namej Fj Fj2 Vj flagj plnj lemmasj)
  ;;Note that uj* is (cons name uj), ie., uj with "a name" as its first member.
  (let (uj* uj2 V flagj plnj)
    (cond ((null pln) ujj)                  ;return the last uj* that was found
	  ((and (setq uj* (car pln)) (setq V (cadddr uj*))
		(setq flagj (fifth uj*)) nil))                    ;name things
	  ((eq t flagj)   (find-uj (cdr pln) Fi* ui* uj* ujs))    ;found one
	  ((eq 'tt flagj) (find-uj (cdr pln) Fi* ui* ujj ujs))    ;keep looking
	  ((setq plnj (sixth uj*))     ;uj* is not proved but has a plan, planj
	   (cond ((setq uj2 (find-uj plnj Fi* ui* nil ujs))    ;found one below
		  uj2)                                            ;so return it
		 (t (find-uj (cdr pln) Fi* ui* ujj ujs))          ;keep looking
		 )) )))

(defun first-n (L n)    ;the first n members of L       16Jan92
  (cond ((null L) (list 'L-empty))
	((< n 1) nil)
	(t (cons (car L) (first-n (cdr L) (1- n))))))

(defun fuze-nums-to-vars (theta)          ;20Feb92  Called by PBR
  ;;THETA has the form ((name1 . fmla1) n1 (name2 . fmla2) n2 ...)
  ;;This fuzes the integer ni to the bound vars in fmlai, for each i.
  ;;Eg, (fuze-nums-to-vars '((A . P) 5 (B . (all x (Q x))) 4))
  ;;                    = ((A . P) (B . (all x4 (Q x4))))
  (let (n P V)
     (cond ((null theta) nil)
	   ((numberp (car theta)) (fuze-nums-to-vars (cdr theta)));cant happen?
	   ((numberp (setq n (cadr theta)))       ;theta = ((A . P) 5 ...)
	    (setq P (cdar theta))
	    (setq V (quantified-variables-in P))
	    (mapc #'(lambda (z) 
               (setq P (subst (maknam (list z n)) z P :test 'equal)))
		  V)
	    (cons (cons (caar theta) P)
		  (fuze-nums-to-vars (cddr theta))))
	   (t (cons (car theta) (fuze-nums-to-vars (cdr theta)))) )))

(defun ground-imply (H C)                       ;29Jan92 called by PR
  ;;Very much like IMPLY except that no unification is done.
  ;;eg, (ground-imply '(& a b c d) '(& c b d)) = t
  (cond ((equal H C) t)
	((and (eq-car H '&) 
	      (or (member-equl C (cdr H))
		  (some #'(lambda (h1) (and (eq-car h1 '->) ;back-chain
					    (equl C (caddr h1))
					    (ground-imply H (cadr h1))))
			(cdr H))))   t)
	((eq-car C '->) (ground-imply (and-on (cadr C) H) (caddr C)))
	((eq-car C '&) (and  (ground-imply H (cadr C)) 
			     (ground-imply H (rest-of C))))
	((eq-car C 'or) (some #'(lambda (u) (ground-imply H u))) (cdr C))

	(t nil) ))

(defun H-part (Fi)                      ;27Feb92  Called by AND-ON1
  ;;(H-part '(-> H C)) = H
  ;;(H-part '(ALL x (ALL y (-> (H x y) (C x y))))) = (H x y)
  ;;(H-part '(ALL x (ALL y (-> (H x y) (-> (H1 x y) (C x y)))))) 
  ;;  = (& (H x y) (H1 x y))
  ;;Eventually we may need to use parity, and a more complicated procedure.
  (let (Fi*) 
    (cond ((atom Fi) nil)		;see below
	  ((eq-car Fi '->) (and-on (cadr Fi) (H-part (caddr Fi))))
	  ((eq-car Fi 'ALL) (H-part (caddr Fi)))
	  ((equal Fi (setq Fi* (beta-reduce (subliss *theta* Fi)))) nil)
	  (t (H-part Fi*)) )))

#|(defun H-part (Fi &optional (p t)) ;not used yet. 25Feb92  Called by AND-ON1
  ;;(H-part '(-> H C)) = H
  ;;(H-part '(ALL x (ALL y (-> (H x y) (C x y))))) = (H x y)
  ;;(H-part '(ALL x (ALL y (-> (H x y) (-> (H1 x y) (C x y))))))
  ;;  = (& (H x y) (H1 x y))
  ;;(H-part '(ALL x (ALL y (-> (H x y) (-> (all z (H1 x y z)) (C x y))))))
  ;;  = (& (H x y) (all z (H1 x y z)))
  ;;p means parity
  (cond ((atom Fi) nil)
	((eq-car Fi '->) (and-on (cadr Fi) (H-part (caddr Fi) p)))
	((eq-car Fi 'ALL) (H-part (caddr Fi) p))
	(t nil) ))
|#
(defun member-equl (x L)                      ;29Jan92 called by GROUND-IMPLY 
  ;;Like member except that EQUL is used instead of EQUAL
  (cond ((atom L) nil)
	((member x L :test 'equal) t)
	((some #'(lambda (u) (equl u x)) L) t)))

(defun multiple-setq (L)              ;18Feb92  
  ;;L is a set of pairs (x y).  This sets x to y for each such entry of L.
  ;;E.g., (multiple-setq '((x 'x) (y (list x 'y)) (z (list x y (list 'z)))))
  ;;results in x, y, and z having the values  x (x y) (x y (z))
  (cond ((null L) nil)    ;not finished
	))

(defun not-fcn (A)                     ;called by BC   29Feb92
  (cond ((eq-car A 'not) (cadr A)) (t (list 'not A))))

(defun occur-below (pln u)  ;30Jan92  Called by AND-ON1  3Mar92 not used now
 ;;Does u occur as a first member in the (multi-level) plan PLN?
  (let (uj plnj)
    (cond ((null pln) nil)
	  ((equal u (setq uj (car pln))) t)
	  ((member (setq plnj (fourth uj)) '(nil t tt ttt))
	   (occur-below (cdr pln) u))
	  ((eq-car plnj 'lemma)     ;plnj has the form ('lemma lemma t-or-nil)
	   (occur-below (cdr pln) u))
	  ((occur-below plnj u) t)
	  (t (occur-below (cdr pln) u)) )))

(defun pr-D (F L H &optional L*)        ;28Feb92 Called by PR
  ;;Directed Prover.  F and H are WFF's.
  ;;L is a list of lemmas that should be used in order before H is used.
  ;;Each entry in L is used at most once (so put some in more than once)
  ;;E.g., (pr-D 'C '((-> P C) (-> Q P)) 'Q)
  (let (F* A* L* H*)
    (cond ((and L* (some #'(lambda (A) (and (setq F* (back-chain A F))
					    (setq A* A)))
			 L*))        ;try to use the "delayed" Hyp's
	   (setq L* (remove A* L* :test 'equal))
	   (pr-D (list 'or F* F) L H L*))
	  ((null L) 
	   (setq H* (and-on H (andify L*)))
	   (otter-prove F
			:inference-rules '(binary_res para_into para_from)
;;			:return-reduced-formula t
			:time 30
			:base-axioms H*))
	  ((setq F* (back-chain (car L) F))     ;bc means "back-chain"    (2)
	   (pr-D (list 'or F* F) (cdr L) H))
	  (t (setq L* (crunch (append L* (list (car L)))))    ;delay its use
	     (pr-D F (cdr L) H L*)) )))
;;REMARK: PR-D is for use when the theorem is too difficult for OTTER.
;;Then we provide it with a List L of some of the Hypotheses in H which
;; are to be used in order, before the rest of H is used.  Human gives L.
;;Or we could use a heuristic to produce L from the goal F.  Then when
;; (2) above succeeds we might want to (heuristically) reorder (cdr L).
#|Example (for the regular version):
  (setq F '(all k (all S (-> (& (e k w) (all S* (gc S* k))) (gc S (+ k 1))))))
  (setq H '(& (-> (e n w) (not (e [] (res S n)))) ;6
	      (& (e 0 w) (e 1 w))))	;s13
  (setq L '( (-> (& (< 0 (exl S)) (not (e [] S))) (gc S (+ k 1))) ;22.4
	     (-> (e n w) (not (e [] S))) ;21
	     (-> (not (< 0 (exl S))) (& (e ns w) (e [] (res S ns)))) ;24
	     ))
  (defun pd () (pr-d F L H))
  |#
         
			     

(defun pre-process (theorem plan lms un-L flag)            ;called by PBR  
  ;;18Feb92 26Feb92
  ;;This converts a PLAN of the form    (u1' u2' u3' ... un') =

  ;;  (... [Fi' flagi plani lemmasi] ...)

  ;;to a PLN of the form                (u1  u2  u3  ... un ) =

  ;;  (... [Fi Fi2 Vi flagi plani lemmasi] ...)

  ;; where Fi is a WFF and FLAGi is nil or tt (tt if Fi is to be assumed 
  ;;  without proof). PLANi and LEMMASi are usually nil, when not-nil they are
  ;;  used to help prove Fi (See documentation for PRE-PROCESS, REASON, etc).
  ;; Fi and Fi2 are the same, but Fi2 is changed as the proof proceeds.
  ;; Vi = NIL and Fi = Fi2 = Fi' unless Fi' has the form 
  
  ;;    (SOME x (SOME y ... (P x y ...)))
  
  ;; in which case  Fi=Fi2= (P x y ...), and Vi = (x y ...).
  ;; (Actually, Fi and Vi are defined more generally, see UN-EX-QUAN.)

  ;;For example, if THEOREM is '(some x (R x)), and PLAN is
  ;; '((P nil nil nil) ((some y (Q y)) nil nil nil) (AB nil nil nil))
  ;;then (pre-process theorem plan) 
  ;; = ([P P nil nil nil nil]  [(Q y) (Q y) (y) nil nil nil]  
  ;;    [AB AB nil nil nil nil] [(some x (R x))(some x (R x)) nil nil nil nil])

  ;;Also if PLANi is non-nil then it is pre-processed and inserted in its
  ;; proper place in the resulting PLN.  Thus PLAN represents a multi-level
  ;; plan, a plan using sub-plans.
  ;;For Example, if the above example plan is changed to
  ;; '((P tt nil nil) ((some y (Q y)) nil nil nil) (AB nil plan2 (L1 L2)))
  ;; where, Plan2 = '((S tt nil nil) (R nil nil nil)), the we get
  ;;   ([P P nil tt nil nil]  [(Q y) (Q y) (y) nil nil nil]  
  ;;    [AB AB nil nil ([S S nil tt nil nil nil] [R R nil nil nil nil]
  ;;                                             [AB AB nil nil (L1 L2)])]
  ;;    [(some x (R x))(some x (R x)) nil nil nil nil])

    (cond ((eq 'ttt flag) (setq flag (cond (*tt* 'tt) (t nil)))))
    (pre-pro theorem plan lms flag un-L) )

(defun pre-pro (theorem plan Lmas &optional t4 un-L)
  ;;called by pre-process 18Feb92
  ;;Lmas, if not nil, is list of lemmas to be used only in the proof of 
  ;; theorem itself.
  ;;un-L is the unit-name-list, from which the unit name u-name is built
  (let (ui* ui W Fi Fi* Vi flagi plani lemmasi lm* plni flagi2 flagi3 
	    u-name un-L*)
;;(break)
    (setq un-L (reverse un-L)) 
    (setq un-L (reverse (cons (1+ (car un-L)) (cdr un-L))))
    (setq u-name (maknam un-L))

    (cond ((null plan) 
	   (setq ui* (list u-name theorem theorem nil t4 nil lmas))
	   (return-from pre-pro (list ui*))))
    (setq ui (car plan))
(prnt ui) (break)
    (setq Fi (car ui)) (setq Fi (cond ((atom Fi) (evalx Fi)) (t Fi)))
    (setq W (un-ex-quan Fi)) (setq Fi* (car W)) (setq Vi (cadr W))
    (setq Flagi (cadr ui)) (setq plani (caddr ui)) (setq lemmasi (cadddr ui))

    ;;We next take out the ttt's and replace them properly.
    ;;ttt is like tt if *tt* is on, else like nil
    (cond (plani (cond (*tt* (cond ((eq 'ttt flagi) 
				    (setq flagi2 nil) (setq flagi3 'tt))
				   ((eq 'tt flagi)
				    (setq flagi2 'tt) (setq flagi3 'na))
				   (t (setq flagi2 nil) (setq flagi3 nil))))
		       ((eq 'ttt flagi) (setq flagi2 nil) (setq flagi3 nil))
		       ((eq 'tt  flagi) (setq flagi2 'tt)  (setq flagi3 'na))
		       (t (setq flagi2 nil)  (setq flagi3 nil)) ))
	  (*tt* (cond ((eq 'ttt flagi) (setq flagi2 'tt)  (setq flagi3 'na))
		      ((eq 'tt  flagi) (setq flagi2 'tt)  (setq flagi3 'na))
		      (t (setq flagi2 nil)  (setq flagi3 'na)) ))
	  ((eq 'ttt flagi) (setq flagi2 nil)  (setq flagi3 'na))
	  ((eq 'tt  flagi) (setq flagi2 'tt)  (setq flagi3 'na))
	  (t (setq flagi2 nil)  (setq flagi3 'na)) )

    (cond ((and plani (not (eq 'na flagi3)))   ;na means "not applicable"
	   (setq un-L* (cond ((atom plani) (list plani '- 0))
			      (t '(planx - 0))))
	   (setq plani (cond ((atom plani) (evalx plani)) (t plani)))
	   (setq plni (pre-pro Fi plani lemmasi flagi3 un-L*))
	   (setq ui* (list u-name Fi* Fi* Vi flagi2 plni nil))
	   (cons ui* (pre-pro theorem (cdr plan) lmas t4 un-L)))
	  (t (setq ui* (list u-name Fi* Fi* Vi flagi2 nil lemmasi))
	     (cons ui* (pre-pro theorem (cdr plan) lmas t4 un-L))) )))

(defvar *x* nil)(defvar *y* nil)(defvar *z* nil)(defvar *u* nil)
(defvar *v* nil)
(defmacro prnt (x &optional y z u v)
  `(let ((*x* ', x)(*y* ', y)(*z* ', z)(*u* ', u)(*v* ', v))
     (and *print-light* ,x (or (format t "~%~s~s ~s~%" *x* '= ,x) t)
	                ,y (or (format t "~%~s~s ~s~%" *y* '= ,y) t)
                        ,z (or (format t "~%~s~s ~s~%" *z* '= ,z) t)
                        ,u (or (format t "~%~s~s ~s~%" *u* '= ,u) t)
                        ,v (or (format t "~%~s~s ~s~%" *v* '= ,v) t)
			)))
(defun quantified-variables-in (A)              ;20Feb92 called by EVALX
  (cond ((atom A) nil)
	((member (car A) '(all some))
	 (cond ((atom (cadr A)) 
		(cons (cadr A) (quantified-variables-in (caddr A))))
	       (t (append (cadr A) (quantified-variables-in (caddr A))))))
	((member (car A) '(& or -> not))
	 (crunch (mapcan #'quantified-variables-in (cdr A))))
	(t (union-w (quantified-variables-in (car A))
		    (quantified-variables-in (cdr A)))) ))

(defun reduce-p (A)                             ;called by PR
  (let (x B P nn S n A1 A2 A3 A4 A5 A6 B1 SS A-form SS% x% theta D1 D2 
	  C1 C2 L1 L2 R)
    (cond ((atom A) A)
	  ((eq 'e (car A))
	   (setq x (cadr A)) (setq B (caddr A))             ;A= (e x B)
	   (cond ((or (atom B) (numberp B)) A)
		 ((and (eq 'res (setq P (car B)))           ;B= (res S nn)
		       (eq-car (setq nn (caddr B)) '+)
		       (equal 1 (caddr nn)))                ;B= (res S (+ n 1))
		  (setq S (cadr B)) (setq n (cadr nn))
		  (setq B1 (list 'res S n))
		  (setq A1 (reduce-p (list 'e x B1)))
		  (setq A2 (reduce-p (list 'e x (list 'resolvents B1))))
		  (or-on A1 A2))
		 ((and (eq 'res-L (setq P (car B)))           ;B= (res-L S nn)
		       (eq-car (setq nn (caddr B)) '+)        ;22Jan92
		       (equal 1 (caddr nn)))             ;B= (res-L S (+ n 1))
		  (setq S (cadr B)) (setq n (cadr nn))
		  (setq B1 (list 'res-L S n))
		  (setq A1 (reduce-p (list 'e x B1)))
		  (setq A2 (reduce-p (list 'e x (list 'resolvents-L B1))))
		  (or-on A1 A2))
		 ((and (eq 'res (setq P (car B)))           ;B= (res S 0)
		       (equal 0 (caddr B)))
		  (list 'e x (cadr B)))
		 ((and (eq 'res-L (setq P (car B)))           ;B= (res-L S 0)
		       (equal 0 (caddr B)))
		  (list 'e x (cadr B)))
		 ((eq 'resolvents P)                      ;B= (resolvents SS)
		  (setq SS (cadr B))
		  (setq A-form '(some C1 (some C2 (some L1 (some L2
                     (& (e C1 SS%) (e C2 SS%) (resolvent C1 C2 L1 L2 x%)))))))
		  (setq theta (list (cons 'SS% SS) (cons 'x% x)))
		  (reduce-p (sublis theta A-form :test 'equal)))
		 ((eq 'resolvents-L P)                   ;B= (resolvents-LS S)
		  (setq SS (cadr B))
		  (setq A-form '(some C1 (some C2 (some L1 (some L2
                    (& (e C1 SS%) (e C2 SS%) (resolvent-L C1 C2 L1 L2 x%)))))))
		  (setq theta (list (cons 'SS% SS) (cons 'x% x)))
		  (reduce-p (sublis theta A-form :test 'equal)))
		 ((eq 'merge-low P)
		  (setq A1 (reduce-p (list 'e x (cadr B))))
		  (setq A-form '(all lml (-> (& (e lml D%) 
						(= (lit lml) (lit x%)))
					     (<= (i x%) (i lml)))))
		  (setq theta (list (cons 'D% (cadr B)) (cons 'x% x)))
		  (setq A2 (reduce-p (sublis theta A-form :test 'equal)))
		  (and-on A1 A2))
		 (t A) ))
	  ((eq 'resolvent (car A))	;A= (resolvent C1 C2 L1 L2 R)
	   (setq C1 (cadr A)) (setq C2 (caddr A)) 
	   (setq L1 (fourth A)) (setq L2 (fifth A)) (setq R (sixth A))
	   (setq A1 (reduce-p (list 'e L1 C1)))
	   (setq A2 (reduce-p (list 'e L2 C2)))
	   (setq A3 (list 'negatives L1 L2))
	   (setq A4 (list 'U (list '~ C1 (list 'sng L1))
			  (list '~ C2 (list 'sng L2))))
	   (setq A4 (list '= R A4))
	   (list '& A1 A2 A3 A4))
	  ((eq 'resolvent-L (car A))	;A= (resolvent-L C1 C2 L1 L2 R)
	   (setq C1 (cadr A)) (setq C2 (caddr A)) 
	   (setq L1 (fourth A)) (setq L2 (fifth A)) (setq R (sixth A))
	   (setq A1 (reduce-p (list 'e L1 C1)))
	   (setq A2 (reduce-p (list 'e L2 C2)))
	   (setq A3 (list 'negatives-L L1 L2))
	   (setq A4 (list 'merge-low
			  (list 'U (list '~ C1 (list 'sng L1))
				(list '~ C2 (list 'sng L2)))))
	   (setq A4 (list '= R A4))
	   (setq A5 '(ALL L5 (-> (e L5 C1) (<= (i L1) (i L5)))))
	   (setq A6 '(ALL L6 (-> (e L6 C2) (<= (i L2) (i L6)))))
	   (list '& A1 A2 A3 A4))
	  ((eq 'negatives (car A))	;A= (negatives L1 L2)
	   (list '= (cadr A) (not-on (caddr A))))
	  ((eq 'negatives-L (car A))	;A= (negatives-L L1 L2)
	   (list '= (list 'lit (cadr A))(list 'lit (not-on (caddr A)))))
	  ((member (car A) '(& or -> not)) ;A= (& ...) etc
	   (cons (car A) (mapcar #'reduce-p (cdr A))))
	  ((eq 'U P)                                 ;A= (e x (U D1 D2))
	   (setq B (caddr A))(setq D1 (cadr B)) (setq D2 (caddr B))
	   (setq A1 (reduce-p (list 'e x D1)))
	   (setq A2 (reduce-p (list 'e x D2)))
	   (or-on A1 A2))
	  ((eq '~ P)                                 ;A= (e x (~ D))
	   (reduce-p (and-on (list 'e x (cadr B))
			     (list 'not (list 'e x (caddr B))))))
	  ((eq 'sng P) (list '= x (cadr B)))         ;A= (e x {y})
	  ((member (car A) '(all some))
	   (List (car A) (cadr A) (reduce-p (caddr A))))

	  (t A) )))

(defun remove-excess-quantifiers (A)                 ;called by BACK-CHAIN
  (rem-exq A))

(defun rem-exq (A)                ;29Feb92 Called by REMOVE-EXCESS-QUANTIFIERS
  (let (A*)
    (cond ((atom A) A)
	  ((member (car A) '(all some))
	   (cond ((occur (cadr A) (caddr A))
		  (setq A* (rem-exq (caddr A)))
		  (subst A* (caddr A) A :test 'equal))
		 (t (rem-exq (caddr A)))))
	  ((member (car A) '(& or -> not))
	   (cons (car A) (mapcar #'rem-exq (cdr A))))
	  (t A))))

(defun remove-univ-qs (A &optional (p t))  ;21Jan92 called by PR. p is parity
  ;;Remove the universal quantifiers for pos parity (exs for neg parity)
  (cond ((atom A) A)
	((or (and (eq-car A 'ALL) p) (and (eq-car A 'some) (not p)))
	 (remove-univ-qs (caddr A) p))
	((member (car A) '(& or)) 
	 (cons (car A) (mapcar #'(lambda (u) (remove-univ-qs u p)) (cdr A))))
	((eq-car A '->) (list '-> (remove-univ-qs (cadr A) (not p))
			          (remove-univ-qs (caddr A) p)))
	((eq-car A 'not) (list 'not (remove-univ-qs (cadr A) (not p))))
	((member (car A) '(ALL SOME))
	 (list (car A) (cadr A) (remove-univ-qs (caddr A) p)))
	(t A)))

(defun replace-multiple-quantifiers (A)           ;called by PR
  ;;E.g., (ALL (x y z) (P x y z)) goes to (ALL x (ALL y (ALL z (P x y z))))
  (repl-mul-quans A))

(defun repl-mul-quans (A)                         ;called by PR
  (let (A*)
    (cond ((atom A) A)
	  ((member (car A) '(ALL SOME))
	   (cond ((null (cadr A)) (repl-mul-quans (caddr A)))
		 ((atom (cadr A))                      ;(ALL x P)
		  (setf (caddr A) (repl-mul-quans (caddr A))) A)
		 (t (setq A* (copy-tree A))            ;(ALL (x y z) P)
		    (setf (cadr A*) (cdr (cadr A*)))   ;(ALL (y z)   P)
		    (setq A* (repl-mul-quans A*))      ;(ALL y (ALL z P))
		    (list (car A) (caadr A) A*))))  ;(ALL x (ALL y (ALL z P)))
	  ((member (car A) '(& or not ->))
	   (cons (car A) (mapcar #'repl-mul-quans (cdr A))))
	  (t A) )))

(defun re-quantify (F V)   ;called by REASON, BACK-TRACK
  ;;existentially quantify F with the variables in V (if any)
  (cond ((null V) F)
	(t (list 'some (car V) (re-quantify F (cdr V))))))

(defun rest-of (A)                       ;called by GROUND-IMPLY
  (cond ((atom A) nil)
	((member (car A) '(& or))
	 (cond ((cdddr A) (cons (car A) (cddr A)))
	       (t (caddr A))))))

(defun set-difference-pc (L L2)       ;L ~ L2
  (cond ((null L) nil)
	((member (car L) L2 :test 'equal) (set-difference-pc (cdr L) L2))
	(t (cons (car L) (set-difference-pc (cdr L) L2))) ))

(defun setqq (x a) (setq x (copy-tree A)))

(defun some-occurs (V L)              ;called by BACK-TRACK2
  ;;does some member of V occur in L?
  (some #'(lambda (x) (occur x L)) V))

(defun subliss (theta A)               ;18Feb92 called by PR
  ;;needed because of iterated entries in theta
  (let (A*)
    (cond ((equal A (setq A* (sublis theta A :test 'equal))) A)
	  (t (subliss theta A*)))))

(defun subsume (C1 C2)                 ;called by BACK-TRACK

;;%%%%% $$$$$  8Jan92: This still has to be coded. 26Feb92  not used
  nil)

(defun subsume-replace (RR S)         ;called by PR
  ;;Replace any clause C* in S by a clause C of RR that subsumes it.
  (mapcar #'(lambda (C*) 
      (cond ((some #'(lambda (C) (and (subsume-c C C*) (setq C2 C))) RR) C2)
	    (t C*))) S))

(defun unclause (S)                     ;called by PR
  (list 'not (cons '& (mapcar #'(lambda (C) (orify C)) S))))

(defun un-ex-quan (F &optional (p t))             ;called by PRE-PROCESS
  ;;eg, (un-ex-quan '(Some x (some y (P x y)))) 
  ;;  = ( (P x y) (x y) )
  ;;and (-> ())
  (let (W W1 W2)
    (cond ((atom F) (list F nil))
	  ((and p (eq-car F 'SOME))
	   (setq W (un-ex-quan (caddr F) p))
	   (list (car W) (cons (cadr F) (cadr W))))
;;	  ((and (not p) (eq-car F 'ALL))                ;remove this for now
;;	   (setq W (un-ex-quan (caddr F) p))            ;3Mar92
;;	   (list (car W) (cons (cadr F) (cadr W))))
	  ((eq-car F '&)
	   (setq W1 (un-ex-quan (cadr F) p))
	   (setq W2 (un-ex-quan (rest-of F) p))
	   (list (and-on (car W1) (car W2)) 
		 (union-w (cadr W1) (cadr W2))))
	  ((eq-car F 'or)
	   (setq W1 (un-ex-quan (cadr F) p))
	   (setq W2 (un-ex-quan (rest-of F) p))
	   (list (or-on (car W1) (car W2)) 
		 (union-w (cadr W1) (cadr W2))))
	  ((eq-car F '->)
	   (setq W1 (un-ex-quan (cadr F) (not p)))
	   (setq W2 (un-ex-quan (caddr F) p))
	   (list (imp-on (car W1) (car W2)) 
		 (union-w (cadr W1) (cadr W2))))
	  ((eq-car F 'not)
	   (setq W1 (un-ex-quan (cadr F) (not p)))
	   (list (not-on (car W1)) (cadr W1)))
	  ((member (car F) '(all some))
	   (setq W1 (un-ex-quan (caddr F) p))
	   (list (list (car F) (cadr F) (car W1)) (cadr W1)))
	  (t (list F nil)) )))

(defun unify-q (A B &optional V)                    ;28Feb92 
  ;;like unify except that bound variables can be different
  (let (x y theta)
    (cond ((equl A B) t)
	  ((and (member A V) (not (occur A B)))
	   (list (cons A B)))
	  ((and (member B V) (not (occur B A)))
	   (list (cons B A)))
	  ((or (atom A) (atom B)) nil)
	  ((not (eq (car A) (car B))) nil)
	  ((member (car A) '(all some))
	   (setq x (cadr A)) (setq y (cadr B))
	   (setq theta (unify-q (subst x y (caddr A)) (caddr B) V))
	   (compose (list (cons x y)) theta))
	  (t (unify-q2 (cdr A) (cdr B) V)) )))

(defun unify-q2 (L1 L2 V)                 ;28Feb92 Called by UNIFY-Q
  (let (theta sigma)
    (cond ((null L1) (null L2))
	  ((null L2) nil)
	  ((setq theta (unify-q (car L1) (car L2) V))
	   (cond ((setq sigma (unify-q2 (apply-sub theta (cdr L1))
					(apply-sub theta (cdr L2)) V))
		  (compose theta sigma))
		 (t nil) ))
	  (t nil))))

(defun union-w (A B)			;a version of UNION
       (cond ((null B) A)
	     ((member (car B) A :test #'equal) (union-w A (cdr B)))
	     (t (union-w (append A (list (car B))) (cdr B)))))

(defun union2 (pln &optional u)   ;called by PBR, PR
  ;;returns the union of second members of units of pln, BEFORE the unit u.
  ;;eg, if pln= '((a (x1) t) (a (x2) t) (a (x3) nil))
  ;; then (union2 pln '(a (x2) t)) = (x2 x3). 
  (cond ((null pln) nil)
	((equal (car pln) u) nil)               ;quit when u is reached
	(t  (union-w (second (car pln)) (union2 (cdr pln) u))) ))
(defun union3 (pln &optional u)   ;called by PBR, PR
  ;;returns the union of third members of units of pln, BEFORE the unit u.
  ;;eg, if pln= '((a b (x1) t) (a b (x2) t) (a b (x3) nil))
  ;; then (union3 pln '(a b (x3) nil)) = (x1 x2)
  (cond ((null pln) nil)
	((equal (car pln) u) nil)               ;quit when u is reached
	(t  (union-w (third (car pln)) (union3 (cdr pln) u))) ))

(defun unique-ize-quan-vars (F &optional theta)          ;called by PR
  (let (W)
    (setq W (unique-iqv F))
    (cond (theta W) (t (car W)))))

(defun unique-iqv (F)          ;called by UNIQUE-IZE-QUAN-VARS
  ;;eg, (unique-iqv '(ALL x (& (P x) (some y (Q x y)))))
  (let (L x y F2 F* W theta L*)
    (cond ((atom F) (list F nil))
	  ((member (car F) '(all some)) 
	   (setq x (cadr F)) (setq L (explode x))
	   (setq y (maknam (list (car L) (setq *n* (1+ *n*)))))
	   (setq F2 (subst y x (caddr F) :test 'equal))
	   (setq W (unique-iqv F2))
	   (setq theta (cons (cons x y) (cadr W)))
	   (list (list (car F) y (car W)) theta))
	  ((member (car F) '(& or -> not))
	   (setq L (mapcar #'unique-iqv (cdr F)))
	   (setq L* (mapcar #'car L))
	   (setq theta (mapcan #'cadr L))
	   (list (cons (car F) L*) theta))
	  (t (list F nil)) )))

#|
                     Back-up Theorem                    13 Feb 92
                                                          SAVE

Theorem.  [H -> SOME x P(x)] & [H & SOME x P(x) -> SOME x (P(x)&Q(x))]
           ---> [H -> SOME x (P(x)&Q(x))].

This is a special case of the propositional theorem,
Theorem. [H -> A]  &  [H & A -> B] ---> [H -> B].

Application to the "Backing-up" strategy in our analogy prover:
 (See pbr.lisp)


                        PLAN
-----------------------------------------------------------------

 ...      Fj           .....               Fi   .....
     SOME x P(x)                          Q(x)

-----------------------------------------------------------------

If we prove goal Fj,

(1)               SOME x P(x),

at unit j, and fail to prove goal  Fi, namely Q(x),  at unit i 
and CAN prove  

(3)      H & Fj & Fj+1 ... Fi-1 -->  SOME x (P(x) & Q(x))

then (according to the back-up theorem) we COULD HAVE proved 

(2)      H -->  SOME x (P(x) & Q(x))

at unit j.  And, in this case, can change goal Fj to  SOME x (P(x)&Q(x))
instead of  SOME x P(x), and assume that Fi is true, and proceed
from unit i.  
|#



#|
%%%%%%%%%%%%%%%%%%   DOCUMENTATION  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
29Jan92: This needs to be re-edited.
18Feb92:       "                     See Documentation for the functions
                                 PBR, PRE-PROCESS, REASON, PR, BAKCTRACT

 See ATP 102 (A Precondition Prover for Analogy) for the general idea.

 Given a hypothesis H, a theorem and a plan for its proof, we attempt to 
 prove the  theorem with the help of the plan.
 A plan has the form

       (F1' F2' ... Fn') 

 The overall behavior of PBR is like a general form of Linear Resolution.
 There are two stages in the proof:
  the PREPROCESSING stage and the DEDUCTION stage.  
 During the preprocessing stage the theorem and plan are combined
  to build a proof-plan-center-clause, PLN.  Then during deduction stage the
  center-claused PLN is processed, changed, until it reaches [], in
  a manner like linear resolution.

 In general PLN has the form

   ( [F1 V1 flag1]  [F2 V2 flag2]  ... [Fk Vk flagk])

 where,for each i, the PLN unit  [Fi Vi flagi]  correspond to the plan 
 units Fi', where Fi is a WFF, Vi is a set of variables and flagi is
 T or nil, depending on whether the corresponding Fi has been proved.

 At the beginning, during the preprocessing stage, PLN is given the form

   ( [F1 V1 flag1]  [F2 V2 flag2]  ... [Fn+1 Vn+1 flagn+1])

 where, for i<n+1, 
 if Fi' has the form                (SOME x SOME y ... (P x y ...))
 then the corresponding  [Fi Vi nil] is  [(P x y ...) (x y ...) nil],
 otherwise,              [Fi Vi nil] is  [   Fi'         nil    nil.
 And  [Fn+1 Vn+1 nil]  =  [theorem nil nil].

 As the proof proceeds the flags as set to T as the corresponding 
 goal is proved.  

 In the Reasoning stage, the Fi are proved one at a time, using as 
 hypotheses, H and (F1 & F2 & ... Fi-1).  Actually, it usees the 
 prover PR to attempt the proof of

 (1)      H & (F1 & F2 & ... Fi-1) --> Fiq

 where, Fiq is the requantified form of Fi, 
 
         Fiq  =  (SOME x SOME y ... Fi),   for x,y,... in Vi.

 Once Fi is proved, flagi is set to T, and the next unit is tried, etc
 until all are proved and the  proof of THEOREM is finished.  

 If one of the subgoals (1) fails, then the plan is flawed, and the
 system attempts to repair that flaw, by Back-Tracking.  BACK-TRACK
 takes information from the failed unit and augments an earlier unit
 and tries to reprove that, etc.

 (more) 16Jan92
|#

;;--------------------------------------------------------------------
