
;;;                 pc-plans.lisp                             22 May 92


;; Example 1. F =  P -> ALL x (P & Q(x)), H = NIL, PLAN = NIL.
(setq H1 nil)
(setq F1 '(-> P (all x (& P (Q x)))))
(setq Plan-Ex1 nil) 
(defun p1 () (pc-start H1 F1 Plan-Ex1))

;; Example 2. H = P(a)& Q(a), F = SOME x (P(x)&Q(x)), PLAN = nil
(setq H2 '(& (P a) (Q a)))
(setq F2 '(some x (& (P x) (Q x))))
(setq Plan-Ex2 nil)
(defun p2 () (pc-start H2 F2 Plan-Ex2))

;; Example 2'.  (Same as Example 2, but with a plan)
(setq H2* '(& (P a) (Q a)))
(setq F2* '(some x (& (P x) (Q x))))
(setq Plan-Ex2* '( ((some x (P x)) nil) ((Q x) nil) ))
(defun p2* () (pc-start H2* F2* Plan-Ex2*))

;; Example 3.
;; This is essentially the crucial part of the proof of CGLR (which is
;;   derived from the proof plan for CGR).  See Section 4, of ATP 102.
(setq H3 '(& (e C1 S) (e C2 S) (e L1 C1) (nu C1) (P C1 L1)))
(setq F3 '(some C (some L (& (e C S) (nu C) (e L C) (P C L)))))
(setq Plan-Ex3 '( ((some C (& (e C S) (nu C))) nil)
	       ((some L (e L C)) nil)
	       ((P C L) nil) ))
(defun p3 () (pc-start H3 F3 Plan-Ex3))

;;-------------------------------------------------------------------------
;;Example 4 (Lemma 1)

;;PLAN1  = ([Lemma1* PLAN2] [Lemma1 nil])
(setq Plan-Ex4-1 '((lemma1* plan-ex4-2) (lemma1 nil)))

#| PLAN2 = 
 ([(C = C' U {L}) nil]
  [(R e Res(S',0) -> R e Res(S,0) v  RU{L} e Res(S,0)) PLAN22]
  [(kew & IH & R e Res(S',k+1) -> (R e Res(S,k+1) v RU{L} e Res(S,k+1)))
   PLAN23], where
       IH =  ALL R1 (R1 e Res(S',k) -> R1 e Res(S,k) v R1U{L} e Res(S,k))  
  [(induction-axiom --> ALL k ALL R (kew & R e Res(S',k) -> 
                               (R e Res(S,k) v RU{L} e Res(S,k)))) nil]
  [Lemma1* nil]) |#
(setq plan-ex4-2 '(
 ( (= C (U C1 (sng L))) nil)
 ( (-> (e R (res S1 0)) (or (e R (res S 0)) (e (U R (sng L)) S))) plan-ex4-22)
 ( (-> (& (e k w) (all R1 (e R1 (res S1 k)) (or (e R1             (res S k)) 
						(e (U R1 (sng L)) (res S k))))
	  (e R (res S1 (+ k 1))))
       (or (e R (res S (+ k 1))) (e (U R (sng L)) (res S (+ k 1))))) Plan-Ex4-23)
 ( (-> induction-axiom (all k (all R (& (e k w) (e R (res S1 k)))
          (or (e R (res S k)) (e (U R (sng L)) (res S k)))))) nil)))

#| PLAN22 =
  ([(ReS' ->  (R e S v RU{L} e S)) PLAN221
   [(R e Res(S',0) -> R e Res(S,0) v  RU{L} e Res(S,0)) nil]) |#
(setq plan-ex4-22 '(
 ( (-> (e R S1) (or (e R S) (e (U R (sng L)) S))) plan-ex4-221)
 ( (-> (e R (res S1 0)) (or (e R (res S 0)) (e (U R (sng L)) (res S 0)))) 
   nil)))

#| E
PLAN221 =
  ([(R = C' -> (R e S v RU{L} e S)) nil]
   [(R~= C' -> (R e S v RU{L} e S)) nil]) |#
(setq plan-ex4-221 '(
 ( (-> (= R C1)       (or (e R S) (e (U R (sng L)) S))) nil)
 ( (-> (not (= R C1)) (or (e R S) (e (U R (sng L)) S))) nil) ))

#| PLAN23 =
 ([(R e Res(S',k) v R e Resolvents(Res(S',k))) nil]
  [(R e Res(S',k) -> (R e Res(S,k+1) v RU{L} e Res(S,k+1))) PLAN232]
  [(R e Resolvents(Res(S',k)) ->  R     e Resolvents(Res(S,k)) v
                                  RU{L} e Resolvents(Res(S,k))) PLAN233]
  [(R e Resolvents(Res(S',k)) -> (R e Res(S,k+1) v RU{L} e Res(S,k+1))) nil]
  [(R e Res(S,k+1) v RU{L} e Res(S,k+1)) nil]) |#
(setq plan-ex4-23 '(
 ( (or (e R (res S1 k)) (e R (resolvents (res (S1 k))))) nil)
 ( (-> (e R (res S1 k))
       (or (e R (res S (+ k 1))) (e (U R (sng L)) (res S (+ k 1))))) plan-ex4-232)
 ( (-> (e R (Resolvents(Res S1 k)))
       (or (e R             (resolvents (res S k)))
	   (e (U R (sng L)) (resolvents (res S k))) )) plan-ex4-233)
 ( (-> (e R (Resolvents(Res S1 k)))
       (or (e R             (res S (+ k 1)))
	   (e (U R (sng L)) (res S (+ k 1))) )) nil)
 ( (or (e R             (res S (+ k 1)))
       (e (U R (sng L)) (res S (+ k 1))) ) nil) ))

#| PLAN232 = 
 ([(R e Res(S,k) v RU{L} e Res(S,k)) ((use IH))]
  [(R e Res(S,k+1) v RU{L} e Res(S,k+1)) nil]) |#
(setq plan232 '(
 ( (or (e R (res S k)) (e (U R (sng L)) (res S k))) ((use IH)) )
 ( (or (e R (res S (+ k 1))) (e (U R (sng L)) (res S (+ k 1)))) nil) ))

#| PLAN233 =
 ([SOME C1 SOME C2 SOME L1 SOME L2
       (C1 e Res(S',k) & C2 e Res(S',k) & RESOLVENT(C1 C2 L1 L2 R)) ((defn))]
  [(C1 e Res(S,k) v C1U{L} e Res(S,k)) ((use IH))]
  [(C2 e Res(S,k) v C2U{L} e Res(S,k)) ((use IH))]
      Let CCk = (R e Res(S,k+1) v RU{L} e Res(S,k+1))
  [(C1     e Res(S,k) & C2     e Res(S,k) ->  CCk) nil]
  [(C1     e Res(S,k) & C2U{L} e Res(S,k) ->  CCk) PLAN2335]
  [(C1U{L} e Res(S,k) & C2     e Res(S,k) ->  CCk) PLAN2336]
  [(C1U{L} e Res(S,k) & C2U{L} e Res(S,k) ->  CCk) PLAN2337]
  [CCk nil]) |#
(setq plan-ex4-233 '(
 ( (some C11 (some C21 (some L1 (some L2 
    (& (e C11 (res S1 k)) (e C21 (res S1 k)) (resolvent C11 C21 L1 L2 R))))))
   ((defn)) )
 ( (or (e C11 (res S k)) (e (U C11 (sng L)) (res S k))) ((use IH)))
 ( (or (e C21 (res S k)) (e (U C21 (sng L)) (res S k))) ((use IH)))
 ( (-> (& (e C11 (res S k)) (e C21 (res S k)))
       (or (e R (res S (+ k 1))) (e (U R (sng L)) (res S (+ k 1))))) nil)
 ( (-> (& (e C11 (res S k)) (e (U C21 (sng L)) (res S k)))
       (or (e R (res S (+ k 1))) (e (U R (sng L)) (res S (+ k 1))))) plan-ex4-2335)
 ( (-> (& (e (U C11 (sng L)) (res S k)) (e C21 (res S k)))
       (or (e R (res S (+ k 1))) (e (U R (sng L)) (res S (+ k 1))))) plan-ex4-2336)
 ( (-> (& (e (U C11 (sng L)) (res S k)) (e (U C21 (sng L)) (res S k)))
       (or (e R (res S (+ k 1))) (e (U R (sng L)) (res S (+ k 1))))) plan-ex4-2337)
 ( (or (e R (res S (+ k 1))) (e (U R (sng L)) (res S (+ k 1)))) nil) ))

#| PLAN2335 =  ([Lemma3 PLAN3] [CCk nil]) |#
(setq plan-ex4-2335 '((Lemma3 plan-ex4-3) (CCk nil) ))

#| PLAN3 =
 ([(L1 e C1 & L2 e C2 & negatives(L1,L2) & R = C1~{L1} U C2~{L2}) nil]
  [(R'= C1~{L1} U C2U{L}~{L2} -> R'= R v R'= RU{L}) PLAN32]
  [L2 e C2U{L} nil]
  [(RESOLVENT(C1 C2 L1 L2 R) v RESOLVENT(C1 C2 L1 L2 RU{L})) nil]) |#
(setq plan-ex4-3 '(
 ( (&  (e L1 C11) (e L2 C21) (negatives L1 L2) 
       (= R  (U (~ C1 (sng L1)) (~ C2 (sng L2))))) nil)
 ( (-> (= R* (U (~ C1 (sng L1)) (~ (U C2 (sng L)) (sng L2))))
       (or (= R* R) (= R* (U R (sng L))))) plan-ex4-32)
 ( (e L2 (U C2 (sng L))) nil)
 ( (or (resolvent C1 C2 L1 L2 R) (resolvent C1 C2 L1 L2 (U R (sng L)))) nil) ))

#| PLAN32 =
 ([ALL t (t e R -> t e R') nil] [R SUBSET R' nil]
  [ALL t (t e R'-> t e RU{L}) nil] [R' SUBSET RU{L} nil]
  [(R'= R v R'= RU{L}) nil]) |#
(setq plan-ex4-32 '(
 ( (all t (-> (e t R) (e t R*))) nil)
 ( (subset R R*) nil)
 ( (all t (-> (e t R*) (e t (U R* (sng L))))) nil)
 ( (subset R* (U R* (sng L))) nil)
 ( (or (= R* R) (= R* (U R (sng L)))) nil) ))

#| Lemma1 (Example 4).
    [clauses(S)  &  ground(S)  &  CeS  &  LeC  &  C' = C ~{L}  &
     S' = S ~{C} U {C'}  &  new  &  [] e Res(S',n) 
     --->  [] e Res(S,n) v {L} e Res(S,n)] |#
(setq lemma1 
 '(-> (& (clauses S) (ground S) (e C S) (e L C) (= C1 (~ C (sng L)))
	 (= S1 (U (~ S (sng C)) (sng C1))) (e n w) (e [] (res S1 n)))
      (or (e [] (res S n)) (e (sng L) (res S n)))))

#| Lemma1* (Example 4').
    [clauses(S)  &  ground(S)  &  CeS  &  LeC  &  C' = C ~{L}  &
     S' = S ~{C} U {C'}  &  iew  &  R e Res(S',i) 
     --->  R e Res(S,i) v RU{L} e Res(S,i)] |#
(setq lemma1*
 '(-> (& (clauses S) (ground S) (e C S) (e L C) (= C1 (~ C (sng L)))
	 (= S1 (U (~ S (sng C)) (sng C1))) (e n w) (e R (res S1 n)))
      (or (e R (res S n)) (e (U R (sng L)) (res S n)))))


(setq Hl1 nil)
(setq Fl1 lemma1)

(defun pl1 () (pc-start Hl1 Fl1 Plan-Ex4-1))

;;;-------------------------------------------------------------------------
;;;    &&&&&&&&&&&&&&&&&    GCR   &&&&&&&&&&&&&&&&&&&&&&

;;; See examples-pbr.lisp for definitions of H-GCR, THM-GCR, Plan-gcr gcr-theta

(defun pg () (pc-start h-gcr thm-gcr plan-gcr 'pbr-mode nil nil gcr-theta
		       '(plan-gcr - 0)))

(defun ppg () (lpc) (lpbe) (lplns) (untrace)
     (trace (pc :entry `(pc ,(cadr  si::arglist)))  ;prints only theorem
	    (pcn     :entry `(pcn ,(cadr si::arglist))) ;prints only F
	    (otter-prove  :entry `(otter-prove ,(car si::arglist)))
		)
     (time (pg)) )
(defun ta () (trace pc pcn otter-prove))
;;(setq *tt* t)     ;if we want ttt to be equated to t


;;;-------------------------------------------------------------------------
;;;    %%%%%%%%%%%%%%%%%%   GCLR   %%%%%%%%%%%%%%%%%%%%%%

;;; See examples-pbrL.lisp for definitions of H-GCLR, THM-GCLR, 
;;;   Plan-gclr gclr-theta

(defun pL () (pc-start h-gclr thm-gclr plan-gclr 'pbr-mode nil nil gclr-theta
		       '(plan-gclr - 0)))

(defun ppL () (lpc)  (lpLe) (lplns) (untrace)
     (trace (pc :entry `(pc ,(cadr  si::arglist)))  ;prints only theorem
;;	    (pcn     :entry `(pcn ,(cadr si::arglist))) ;prints only F
;;	    (otter-prove  :entry `(otter-prove ,(car si::arglist)))
		)
     (time (pL)) )

;;;  888888888888888888888  THEORY  88888888888888888888888888888888
(setq *gclr-theory* 
 '(r0 r1 r2 r3 r4 r5 r6 r7 r8 r9 r10 r11 
   d1 d2 d21 d3 d31 d4 d5 d6 d61
   s1 s2 s3 s4 s5 s6 s7 s8 s9 s10 s11 s13 s13 s14 s17    ;s12 s15 s16
   L= ))                            ;induction-axiom-gcL induction-axiom-lm1

(defun ta () (trace pc pcn otter-prove))
;;(setq *tt* t)     ;if we want ttt to be equated to t


(setq th (mapcar #'(lambda (u) (eval u)) *gclr-theory*))
(setq tha (andify th))

(setq *gclr-theory-H* (andify (mapcar #'eval *gclr-theory*)))
(setq *gclr-theory-HB* (beta-reduce (subliss *theta* *gclr-theory-h*)))

(setq trial-h
 '(& (E K* W) (CLAUSES-L S*) (GROUND S*)
                            (FINITE S*) (UNSAT-L S*) (<= (EXL S*) K*)
                            (ALL S0
                                 (ALL N0
                                      (-> (& (E N0 W) (E [] S0))
                                       (E [] (RES-L S0 N0)))))
                            (CLAUSES-L S) (GROUND S) (FINITE S)
                            (UNSAT-L S) (ALL X (<= X X))
                            (ALL S11
                                 (-> (& (CLAUSES-L S11) (FINITE S11))
                                     (E (EXL S11) W)))))
(setq trial-c
 '(-> (& (E 0 W) (CLAUSES-L S21) (GROUND S21)
                                   (FINITE S21) (UNSAT-L S21)
                                   (<= (EXL S21) 0))
                                (SOME N267
                                      (& (E N267 W)
                                         (E [] (RES-L S21 N267))))))

(defun trial (n) 
  (let (HT)
   (setq HT (beta-reduce 
	    (subliss *theta* (andify (mapcar #'eval 
					     (first-n n *gclr-theory*))))))
  (pcn (and-on HT trial-h) trial-c nil)))

(defun trial-r (n) 
  (let (HT)
   (setq HT (beta-reduce 
	    (subliss *theta* (andify (mapcar #'eval 
				     (first-n n (reverse *gclr-theory*)))))))
  (pcn (and-on HT trial-h) trial-c nil)))

      












