
;;;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;;;
;;;                         pc.lisp                         22 May 92
;;;
;;;          See earlier versions pcp.lisp and pbr.lisp
;;;          See papers, atp.102, atp.103
#|
 (load "imply.lisp")(lp)(lop)(lpbr)(lpc)(lres)(lpi)(lpci)  ;(load "pci.o")
        (lpbe)(lpLe)(ls)(lppc)(lpc)(lplns)(los)(luo)(lu)(lsg)
 
|#
;;;  This is a LISP program to carry out the pre-condition system.
;;;
;;;  The main function is pc:  Call (pc-start H C plan) 
;;;
;;;  This file uses the file pcp.lisp (load it first) 
;;;    and The OTTER Prover (of Bill McCune) in otter-pvr13.lisp.
;;;
;;;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;;;24July93  This again proved (ppg) (GCR with a plan)

(defun lpc  () (load "pc.lisp"))
(defun lplns () (load "pc-plans.lisp"))
(defun lop () (load "otter-pvr-1-0.o"))
;;(defun lop () (load "otter-pvr13.lisp"))
;;(defun lop () (load "otter-pvr13.o"))
(defun lpbr () (load "pbr.lisp"))
(defun lpbe () (load "examples-pbr.lisp"))
(defun lpLe () (load "examples-pbrL.lisp"))
(defun lppc () (load "pcp.lisp"))
(defun lpci () (load "pci.lisp"))
(defun lpi () (load "p-imply.lisp"))
(defun lso () (load "pcos.lisp"))

(defvar *tt* nil)
(defvar *set-theory-theorems* nil) 
(defvar *pbr-mode* nil)     
(defvar *theta* nil)     
(defvar *n* 30)
(defvar skip-it nil)
(setq skip-it nil)                ;11Aug93  NOTE  NOTE  NOTE  NOTE  NOTE  
(defun *gclr-theory* nil)
(defun *gclr-theory-H* nil)
(defvar *struve-FOL* nil)
(defvar *otter* nil)
(defvar *Lemmas* nil)    ;11Aug93


(defun pc-start (H C plan &optional pbr-mode flag lemmas theta un-L)
   ;;top level call.  Also called by PCN in pc.lisp. A CRUCIAL component.
  (setq *theta* (fuze-nums-to-vars theta))  ;fuzes n's to bound vars of THETA
  (setq *n* 30)
  (setq *set-theory-theorems* nil) 
  (setq *pbr-mode* pbr-mode)      ;this allows four arguments for plan entries
                                  ; u = (F flag plan lemmas) (from pbr.lisp)
  (cond ((not *pbr-mode*) 
	 (cond ((member plan '(tt)) (setq flag plan) (setq plan nil))
                                  ;convert to pbr.lisp plan-mode
	       ((not plan) nil)
	       (t (setq plan (convert-mode plan))))))
  (setq *lemmas* lemmas)          ;11Aug93   
    ;;NOTE: The global argument *Lemmas* is the set of lemmas used in all
    ;;      steps of the proofs, added to the hypotheses.
  (pc H C plan flag nil un-L))

(defun pc (H C plan flag prover-name un-L)        ;called by PC-START
  ;;prover-name, or pn, is given in each step of the proof, and indicates the 
  ;; name of the auxiliary prover (either OTTER or STRUVE), which is to be used
  ;; to complete that step.  st means struve, a number N means to run OTTER
  ;; for N seconds, and a pair (N1 N2) means run otter for N1 on its main goal
  ;; and for N2 seconds on its "reprove" goal.  
  (let (Step Plan* Plan1 C1 flag1 flag2 pn1 C* C** x xx P H1 H* 
	     Q Q1 Q2 Q3 Q2* Q2*1 Q2*2 W un-L* u-name Q1L Q2L syms pn1*
	     Hp Q* N1 N2 (pn prover-name))
     
    (cond ((eq-car plan 'HALT) (format t "~%Halted in PC~%") (break) 
	   (pc H C (cdr plan) flag pn un-L))
	  ((eq 'tt flag)               ;assume without proof
           (format t "~%tt: assume without proof~%") t)
	  ((and *tt* (eq 'ttt flag) (not plan))
           (format t "~%ttt: assume without proof~%") t)
	  ((eq 'Let plan) 
           (format t "~%Let: assume without proof~%") t)
	  ((eq 'fail flag)
           (format t "~%fail: User failed without trying to prove~%") 
	   (imp-on* H C))                                         ;11Aug93
	  ((eq 'STR+VE-subset plan) 
	   (format t "~%Need STR+VE-subset prover: assume without proof~%") 
	   (setq *Set-theory-theorems* 
		 (cons (imp-on* H C) *Set-theory-theorems*))
	   t)
	  ((eq-car plan 'ans)
	   (format t "~%User has given the answer~%")
	   (cadr plan))
	  ((member C Assumed-list :test 'equal)
	   (format t "~%Assume this is true without proof - in Assumed List~%")
	   t)
	  ((and (eq-car C '&) (not (null plan)))
	   (setq H* (and-on (cadr C) H)) (setq C* (rest-of C))
	   (and-on (pc H (cadr C) plan flag pn un-L) 
		   (pc H*   C*    plan flag pn un-L)))
	  ((and (eq-car H 'or) (not (null plan)))
	   (setq H* (rest-of H))
	   (and-on (pc (cadr H) C plan flag pn un-L) 
		   (pc    H*    C plan flag pn un-L)))
	  ((eq-car C '->)
	   (imp-on* (cadr C) 
		   (pc (and-on (cadr C) H) (caddr C) plan flag pn un-L)))
	  ((eq-car C 'ALL)
	   (setq Q (pc H (caddr C) plan flag pn un-L))
	   (cond ((eq t Q) t)
		 ((occur (cadr C) Q) (mini-scope (list 'ALL (cadr C) Q)))
		 (t Q)))
	  ((null plan) 			;Case when PLAN is null.
	   (pcn H C pn))

	  ((atom plan)                 ;(NOTE: PLAN is NOT nil from here on)
	   (setq un-L* (cond ((atom plan) (list plan '- 0)) (t '(planx - 0))))
	   (pc H C (convert-mode (eval plan)) flag pn un-L*))   ;25May92

	  ((progn (setq Step (car plan)) (setq C1 (car Step))
		  (cond ((atom C1) (setq C1 (eval C1))))
		  (setq flag1 (cadr step))
		  (cond ((eq-car flag1 'some-def) 
			 (setq flag2 t) (setq flag1 (cadr flag1))))
		  (setq plan1 (caddr Step)) 
                  (setq pn1 (cadddr step)) 

		  (cond ((numberp pn1) (setq N1 pn1)) ;pn1 is "prover-name" 
			((null pn1) (setq N1 30))    ; for the step
			((atom pn1) (setq N1 pn1))
			((and (listp pn1) (numberp (car pn1)))
			 (setq N1 (car pn1)) (setq N2 (cadr pn1)))
			(t (setq N1 pn1)))
		  (setq plan* (cdr plan))
		  (setq un-L (reverse un-L))                         ;25May92
		  (setq un-L (reverse (cons (1+ (car un-L)) (cdr un-L))))
		  (setq u-name (maknam un-L))
                  (format t "~%~s Step= ~s ~%" u-name step) 
		  (setq Hp (and-on (h-part C1) H))                   ;7Aug92
;;		  (cond ((setq H1 (h-part C1)) (setq Hp (and-on H1 H))))
		  nil))                   ;;name some things & do some things
                                          ;;Hp use introduced 6Aug92

          ;;%% The first statement in PLAN is an EXISTENTIAL CLAIM statement.

	  ((eq-car (setq C1 (some-out C1)) 'SOME)          ;C1 = SOME x P(x)
	   (setq W (matrix C1)) (setq xx (car W)) (setq P (cadr W))
	   (setq H* (and-on P H))                          ;H* = P(x) & H
	   (cond ((not (setq Q1 (pc Hp C1 plan1 flag1 N1 un-L))) nil)
                   ;;prove the first step, SOME x P(x)
		 ((not plan*) Q1)                        ;added 31July93
		 ((or (not plan*) (eq 'some-def plan))   ;10June93 some-def
                   ;;If plan* is nil or 'some-def, and the last
		  (cond ((equal C C1) Q1)    ; goal is C, then exit with Q1
			((setq Q2 (pc H* C nil flag pn un-L)) 
                          ;;else prove that C follows from earlier goals
			 (and-on Q1 Q2))))
		 ((not (setq Q2 (pc H* C plan* flag pn un-L))) nil)
                   ;;prove the remaining steps, returning Q2
		 ((eq t Q2) Q1)                      ;if Q2 is t, return Q1.
		 (flag2 (cond ((eq t Q1) (imp-on* P Q2)) (t and-on Q1 Q2)))
		  ;;If this an "existential definition" step, and Q1 is t,
                  ;;return P->Q2, else Q1&Q2.
		 ((not (occur-set xx Q2)) (and-on Q1 Q2))
		  ;;If Q2 contains no x in xx, return Q1&Q2
		  ;;Or (next) if Q2-steps contains no x in xx, return Q1&Q2
		 ((not (occur-set xx (remove-steps H Q2))) (and-on Q1 Q2))
		  ;;Next we prepare to and  prove the (some x [P(x)&Q(x)]) goal
		 (t (setq Q2* (mini-scope Q2))      ;push-in other quantifiers
                     ;;Separate out the part Q2*1 of Q2 that contains x from xx
                     ;; and try to prove (SOME xx P&Q2*1)
		    (cond ((not (eq-car Q2* '&)) 
			   (setq Q2*1 Q2*) (setq Q2*2 t))    
			  (t (setq Q2*1 t)(setq Q2*2 t)   ;set up for the mapc
			     (mapc #'(lambda (A) 
                                      (cond ((occur-set xx A) 
					     (setq Q2*1 (and-on Q2*1 A)))
					    (t (setq Q2*2 (and-on Q2*2 A)))))
				   (cdr Q2*))))
		    (setq C* (subst (and-on P Q2*1) P C1 :test 'equal))
                     ;;C* is the [P(x) & Q(x)] of (some x [P(x) & Q(x)])
		    (format t "~%Original-Step=  ~s ~% ~s ~%" u-name step)
		    (format t "~%Q2= ~s~%" Q2)
		    (format t "~%Augmented-Step=~%")
		    (format t "~%~s ~%" (list u-name C* plan1))
                     ;;Else prove SOME x (P(x) & Q2*1)
                    (progn (setq syms (lemma-symbols C*)) ;3Aug92
			   (setq C** (lemma-symbols-remove C*)) 
			    ;;Replace lemma-symbols in C* by the actual pn
			   (setq pn1* (union-w pn1 syms)) nil)
;;		    (format t "~%Type   (setq skip-it t) at the break?~%")
;;                  (break)            ;type (setq skip-it t) ?

		    (cond ((eq t skip-it)    ;remove this for normal use
                           ;;user sets skip-it to T or NIL at the break
			   ;; to allow it skip some proofs to speed the process
			   (setq skip-it nil)     
			   (prnt Hp C** pn1*)
			   (mini-scope-undo (and-on C** Q2*2)) ;11Aug93
			   )
                           ;;Here it tries to prove the (some x [P(x)&Q(x)])
                          ((eq t (setq Q3 (pcn Hp C** (list 'Q N2))))
			   Q2*2) ;11Aug93 Return the part of Q not containing x
			  (t (mini-scope-undo (and-on Q3 Q2*2))) )) ))
	  ;;%% The regular case (With a PLAN) 
	  ((not (setq Q1 (pc Hp C1 Plan1 flag1 N1 un-L))) nil)  
                                         ;prove the step
	  ((not plan*) Q1)      ;31July93  We exit anyway
	  ;;NOTE we ignore the next ((...)) entry
          ((not plan*)                   ;If C1 is the last goal of PLAN
	   (cond ((equal C1 C) Q1)       ;and C1 is C itself, then exit with Q1
                                 
		 ((setq Q2 (pc (and-on C1 H) C nil flag pn un-L))
                                 ;else prove that C follows from earlier goals
		  (and-on Q1 Q2))))         
                                                     ;(Q1&Q2)
	  ((not (setq Q2 (pc (and-on C1 H) C plan* flag pn un-L)))nil)
					                 ;Prove remaining steps
	  ((eq t Q1) (cond ((eq t Q2) t)
			   (t (imp-on* C1 Q2))))       ;note  22May92
	  (t (and-on Q1 Q2)) )))


(defun pcn (H C prover-name) ;called by PC 23May92. 12Aug93
  ;;See pbr.lisp for earlier version
  ;;Tries to prove the supposed theorem  H->C.
  ;;If it succeeds, it returns t.  Else the pre-condition.
  ;;12Aug93: It uses the OTTER prover of McCune and STRUVE of Hines.
  ;;prover-name may equal st, meaning we should use STRUVE, else use OTTER.
  (let (HL HL* HL** H* H** C* C** A Q (pn prover-name) N nst RR Ho)
    (setq N (cond ((numberp pn) pn) ((eq-car pn 'q) (cadr pn)) (t 30)))
    (setq HL  (andify *lemmas*))
    (setq HL* (pcn-process HL))  
    (setq H*  (pcn-process H))  
    (setq C*  (pcn-process C))  
    (setq HL** (apply-defns HL*))
    (setq H**  (apply-defns H*))
    (setq C**  (apply-defns C*))

    (cond ((and (or (eq 'st pn) *struve-FOL*) (not *otter*))   ;st means STRUVE
	   (cond (*struve-FOL* 
		  (setq nst 100))
		  ;;If *struve-FOL* is not nil, prove everything by STRUVE 
		 (t (setq nst 3000) ;else, if pn='st, 
		    ))
	   (cond ((eq t (struve-prove-start (and-on HL** H**) C** nst))
                   ;;14Sept93 Changed (and-on HL** H**) to H**
		  (format t "~%Proved by STRUVE~%") t)
		 ((and (and (numberp pn) (< pn 30)) 
		       (or (time (setq Q (pci-start HL* (imp-on H* C*)))) t) 
		       nil))
                                     ;Else try PCI. Abduction of (H->C) 
		 ((equal '(t t) Q) t)
		 ((eq-car Q nil) (imp-on* H C))     ;No change by PCI
		 (t (remove-lemmas *lemmas* (cadr Q)))))

	  (*otter* 
	   (setq Ho (and-on set-theory-lemmas (and-on HL** H**)))
	    ;;1Sep93 If *OTTER* is not nil, use OTTER on everything
	   (setq N (cond ((numberp pn) pn) (t 500)))
	   (setq RR (otter-prove-start C** Ho N))
	   (cond ((eq-car RR t) t) 
		 ((and (and (numberp pn) (< pn 30)) 
		       (or (time (setq Q (pci-start HL* (imp-on H* C*)))) t) 
		       nil))
          )))  t) 
		(or (setq C*  (beta-reduce (subliss *theta* C)))  t)
		(setq HL* (pcn-process HL*))  
		(setq H*  (pcn-process H*))  
		(setq C*  (pcn-process C*)) nil))
#|
	  ((eq-car (time (otter-prove C*      ;Try OTTER with longer time
   	            :inference-rules '(binary_res para_into para_from)
		    :time N
		    :base-axioms (and-on H* HL*))) t) t)
|#
	  ((eq-car (time (otter-prove-start C* (and-on H* HL*) N)) t) t)
                                             ;Try OTTER with longer time

	  ((and (eq-car pn 'q) (< N 30)) (imp-on* H C))

	  ((eq-car pn 'q)                       ;Called from Q-top in PC
	   (setq A (Larry-quantify (imp-on* (and-on HL* H*) C*))) ;13Aug93
	   (cond ((struve-prove A 100 100) (format t "~%Proved by STRUVE~%") t)
		 (t nil)))

	  ((and (or (setq HL* (c (let (theta) 
    (cond ((instance F H) t)
	  ((and (eq-car H '->) (setq theta (instance F (caddr H)))
		(pcn H (apply-sub theta (cadr H)) nil t)) t)
	  ((and (eq-car H '->) (eq-car (caddr H) '&)     ;H=(-> A (& B C ...))
		(some #'(lambda (Hi) (and (setq theta (instance F Hi))
					  (pcn H (apply-sub theta (cadr H))t)))
		      (cdr (caddr H)))) t)
	  ((and (eq-car H '&)                
		(some #'(lambda (u) (back-chain1 u F)) (cdr H))) t) 
	  ((eq-car H 'all) (back-chain1 (caddr H) F))
	  (t nil))))

(DEFUN COMPOSE (THETA SIGMA)  ;widely used  
  ;;5Aug93 This was in Resolution.lisp as compose-R
  ;; this returns the composition of the two substitutions THETA & SIGMA
    
  (COND ((or (null theta) (null sigma)) nil)
        ((EQ T THETA) SIGMA)
        ((EQ T SIGMA) THETA)
        (T (SETQ THETA (MAPCAR #'(lambda(U)
				   (CONS (CAR U) (SUBLIS= SIGMA (CDR U))))
			       THETA))
	   (SETQ THETA (UNION-W THETA SIGMA))
	   (cond ((MAPCAN #'(lambda(U)
		       (COND ((EQUAL (CAR U) (CDR U)) NIL) (T (LIST U))))
		   THETA))
		 (t t)))))

(defun convert-mode (plan)                  ;called by PC-START   23May92
  ;;This is only executed when *pbr-mode* is not nil.  Then the plan units
  ;; have the form u = (Fi plani), where plani might be tt.
  ;;We convert it into the form u = (Fi flagi plani lemmasi)
  (let (u plani)
    (cond (*pbr-mode* (return-from convert-mode plan))
	  ((null plan) nil)
	  ((member (setq plani (cadr (setq u (car plan)))) '(tt))
	   (setq u (append u (list nil nil)))
	   (cons u (convert-mode (cdr plan))))
	  (t (setq u (list (car u) nil plani nil))
	     (cons u (convert-mode (cdr plan)))))))

(defun first-n (n L)      ;the first n entries in L
  (cond ((< n 1) nil)
	((null L) nil)
	(t (cons (car L) (first-n (1- n) (cdr L))))))

(defun imp-on (P Q)      ;called by several functions
  (cond ((eq t Q) t) ((null P) Q) 
	((eq t P) Q)
	(t (list '-> P Q))))

(defun imp-on* (A B)    ;called by PC               27May92
  (cond ((eq-car B '->) (imp-on* (and-on A (cadr B)) (caddr B)))
	(t (imp-on A B))))

(defun larry-quantify (A &optional C**)   ;called by pcn  2Aug93
  ;;This will be used temporarily, while Larry changes slightly STRUVE 
  (let (V)

    (setq V (free-variables-in A))
    (setq A (universally-quantify A V))
    (cond ((and C** (L-occur 'some C**)) (list 'some 'larry A))
	  (t A))))

(defun L-occur (P A)  ;called by LARRY-QUANTIFY 2Aug93
  (cond ((eq-car A 'some) t)
	((atom A) nil)
	((eq-car A '->) (L-occur P (caddr A)))
	((member (car A) '(& or)) (some #'(lambda (u) (L-occur P u)) (cdr A)))
	((eq-car A 'all) (L-occur P (caddr A)))
	(t nil) ))

(defun lemma-symbols (A)  
  (cond ((atom A) (list A))
	((member (car A) '(& or -> not))
	 (mapcan #'lemma-symbols (cdr A)))
	((member (car A) '(all some))
	 (lemma-symbols (caddr A)))
	(t nil)))

(defun lemma-symbols-remove (A) (car (lem-symr A)))
(defun lem-symr (A)  
 (let (A*)
  (cond ((atom A) nil)
	((eq-car A '&)  (list (andify (mapcan #'lem-symr (cdr A)))))
	((eq-car A 'or) (list (orify  (mapcan #'lem-symr (cdr A)))))
	((eq-car A '->) (list (imp-on (car (lem-symr (cadr A)))
				      (car (lem-symr (caddr A))))))
	((eq-car A 'not)
	 (cond ((eq t (setq A* (lem-symr (cadr A))))
		(format t "~%ALARM t in lem-symr~%") nil)
	       ((eq nil (setq A* (lem-symr (cadr A))))
		(format t "~%ALARM nil in lem-symr~%") nil)
	       (t (list (list 'not (car A*))))))
	((member (car A) '(all some))
	 (list (list (car A) (cadr A) (car (lem-symr (caddr A))))))
	(t (list A)) )))

(defun lemma-symbols-replace (A) (lem-symrp A))      ;called by PC
(defun lem-symrp (A)  ;replace the lemma-symbols by their defns
 (let (A*)
  (cond ((atom A) (evalx A))         ;This is where the replacement is made
	((eq-car A '&)  (andify (mapcar #'lem-symrp (cdr A))))
	((eq-car A 'or) (orify  (mapcar #'lem-symrp (cdr A))))
	((eq-car A '->) (imp-on (lem-symrp (cadr A))
				(lem-symrp (caddr A))))
	((eq-car A 'not)
	 (list 'not (lem-symrp (cadr A))))
	((member (car A) '(all some))
	 (list (car A) (cadr A) (lem-symrp (caddr A))))
	(t A) )))

(defun otter-prove-start (C H N) ;21Aug93  Called by PCN
  ;;We now do some DEMODULATION before sending this to OTTER-PROVE
  (let (C* H*)
    (setq C* (Demodu H C))
    (setq H* (Demodu H H))
    (time (otter-prove (imp-on H* C*)                    ;2Sep93 imp-on
		       :inference-rules '(binary_res para_into para_from)
		       :time N    
		       :base-axioms nil))))

(defun demodu (H C) ;21Aug93  Called by OTTER- and STRUVE-PROVE-START
  ;;demodulate C by using the equality units in H and well as 
  ;; in the hypotheses of C. (21Aug93 changed my mind. Do ordinary Sub=)
  (let (E E* W C*)
    (cond ((and H (setq E (=s-in H H C)))
	   (setq E* (mapcan #'(lambda (u)
				(cond ((occur (cadr u) (caddr u)) nil)
				      (t (list u)))) E))
	   (setq W (sub== E* H (and-off C (andify E*))))
	   (setq C* (cadr W))
	   (demodu nil C*))
	  ((eq-car C '->) (imp-on (demodu (cadr C) (cadr C))
				  (demodu (cadr C) (caddr C))))
	  ((member (car C) '(all some))
	   (list (car C) (cadr C) (demodu nil (caddr C))))
	  ((eq-car C '&) 
	   (andify (mapcar #'(lambda (u) (demodu nil u)) (cdr C))))
	  (t C))))

(defun remove-lemmas (lemmas A)  ;11Aug93  Called by PC
  (let (lems H H2)
    (cond ((not (eq-car A '->))
	   (format t "~%Alarm in remove-lemmas~%") 
	     (prnt lemmas lems A H H2) (break))
	  (t (setq H (cadr A))
	     (setq lems (skolemize lemmas nil nil))
	     (setq H2 (and-off H lems))
	     (un-sko-for-pc (imp-on H2 (caddr A)))))))

(defun remove-steps (H A)  ;20Aug93  Called by PC
  ;;A has been returned as a pre-condition, and has the form H'->Q
  ;;This removes things in H and in *lemmas* from the H' part of A.
  ;;FOR NOW we will essentially just assume that H' consists of H and *lemmas*
  (let (HA (V (variables-in (and-on H (andify *lemmas*))))  ) 
    (cond ((not (eq-car A '->)) A)
	  ((set-intersection V (variables-in (cadr A))) 
	   (remove-steps H (caddr A)))
	  (t A))))

(defun remove-non-set-theory (A &optional flag)    ;Called by PCN  2Aug93
  (cond ((or (eq 'H flag) (eq 'HL flag))
	 (cond ((eq-car A '&) 
		(andify (mapcan #'(lambda (u) (cond ((set-theory u) (list u))))
				(cdr A))))
	       ((set-theory A) A)
	       (t nil)))
	(t  (rnst A))))

(defun rnst (A)  ;Called by REMOVE-NON-SET-THEORY  2Aug93
  (let (H C A* LA B)
    (cond ((atom A) A)
	  ((null (cdr A)) A)
	  ((eq-car A '->)
	   (cond ((setq H (rnst (cadr A)))
		  (cond ((setq C (rnst (caddr A))) (imp-on H C))
			(t nil)))
		 (t (rnst (caddr A)))))
	  ((eq-car A '&)
	   (cond ((setq LA (mapcan #'(lambda (u) 
                              (cond ((setq u* (rnst u)) (list u*))))
			   (cdr A)))
		  (andify LA)) (t nil)))
	  ((eq-car A 'or)
	   (orify (mapcan #'(lambda (u) (cond ((setq u* (rnst u)) (list u*))))
			  (cdr A))))
	  ((eq-car A 'not) (cond ((setq B (rnst (cadr A))) (list 'not B))))

	  ((member (car A) '(all some))
	   (cond ((setq B (rnst (caddr A))) (list (car A) (cadr A) B))))

	  ((member (car A) '(= e subset subset* ~ U intersection)) A)
	  (t nil))))

(defun replace-d (d A)                 ;called by APPLY-DEFNS  2Aug93
  (let (theta)
    (cond ((atom A) A)
	  ((member (car A) '(-> & or not all some))
	   (cons (car A) (mapcar #'(lambda (u) (replace-d d u)) (cdr A))))
	  ((setq theta (instance A (cadr d))) (apply-sub theta (caddr d)))
	  (t A))))

(defun set-theory (A)                  ;called by PCN  2Aug93
  (cond ((atom A) nil)
	((null (cdr A)) nil)
	((member (car A) '(all some)) (set-theory (caddr A)))
	((member (car A) '(-> & or not))
	 (every #'set-theory (cdr A)))
	((member (car A) '(= subset subset* e ~)) t)
	((member (car A) '(all some)) (set-theory (caddr A)))
	(t nil)))

(defun some-out (A)   ;called by PC. 
  ;;Bring SOME to the front of A.
  (let (A1 A2 A3 A*)
    (cond ((atom A) A)
	  ((eq-car A 'some) 
	   (subst (some-out (caddr A)) (caddr A) A :test 'equal))
	  ((eq-car A '->)
	   (setq A2 (some-out (caddr A)))
	   (cond ((eq-car A2 'some)	;(-> H (some x (P x)))
		  (setq A3 (some-out (imp-on (cadr A) (caddr A2)))) 
                                                       ;(-> H (P x))
		  (list 'some (cadr A2) A3)) ;goes to (some x (-> H (P x)))
		 (t A)))
	  ((eq-car A '&)		;(& B (-> H (some x (P x))) D)
	   (setq A* (cons '& (mapcar #'some-out (cdr A))))
					;(& B (some x (-> H (P x))) D)
	   (cond ((some #'(lambda (u) (and (eq-car u 'some) (setq A1 u)))
			(cdr A*))	;(some x (& B (-> H (P x)) D))
		  (setq A3 (subst (caddr A1) A1 A* :test 'equal))
		  (some-out (list 'some (cadr A1) A3)))
		 (t A)))
	  (t A) )))

(defun struve-prove-start (H C N) ;31Aug93  Called by PCN
  ;;We now do some DEMODULATION before sending this to STRUVE-PROVE
  (let (C* H*)
    (setq C* (Demodu H C))
    (setq H* (Demodu H H))
;;    (time (struve-prove (larry-quantify (imp-on* H* C*) C*) N N))
    (time (struve-prove (imp-on* H* C*) N N))
 ))

;;-----------------------------------------------------------------
	   
(defun eq-quan (A B)  ;like EQUAL except that it ignores bound variables 7Aug92
  ;;Eg, (eq-quan '(ALL x (some y (P x y))) '(ALL u (some v (P u v))))
  (cond ((equal A B) t)
	((atom A) nil)
	((atom B) nil)
	((not (eq (car A) (car B))) nil)
	((member (car A) '(all some))
	 (eq-quan (caddr A) (subst (cadr A) (cadr B) (caddr B))))
	(t (every #'(lambda (u v) (eq-quan u v)) (cdr A) (cdr B)))))

(defun mem-quan (x L) ;7Aug92
 ;; (mem-quan '(ALL x (some y (P x y))) 
 ;;           '((ALL u (some v (P u v))) xxx))
  (cond ((atom L) nil)
	(t (some #'(lambda (u) (eq-quan x u)) L))))

(defun pcn-process (A)  ;12Aug93  Called by PCN  
  (let (A*)
    (setq A* (replace-multiple-quantifiers A))
    (setq A* (unique-ize-quan-vars A*))
    (setq A* (sublis '((< . <<) (<= . <<=)) A*)) ))

(defun subset-quan (A B)  ;7Aug92
 ;;eg, (subset-quan  '((ALL x (some y (P x y))) (ALL u (some v (P u v))))
 ;;         '(xx yy zz (ALL r (some s (P r s))) (ALL w (some v (P w v)))))
  (cond ((null A) t)
	((atom B) nil)
	((atom A) nil)
	((mem-quan (car A) B) (subset-quan (cdr A) B))
	(t nil)))

(defun set-diff-quan (A B)  ;7aug92
 ;;Eg (set-diff-quan '(xx (ALL x (some y (P x y))) yy (ALL u (some v (P u v))))
 ;;                '(yy zz (ALL w (some v (P w v)))))
 (let (u*)
  (cond ((null A) nil)
	((null B) A)
	((atom A) A)               ;???
	((atom B) A)               ;???
	((some #'(lambda (u) (and (eq-quan-mu (car B) u) (setq u* u))) A)
	 (set-diff-quan (remove u* A :test 'equal) (cdr B)))
	(t (set-diff-quan A (cdr B))) )))

(defun st (&optional v) (setq *tt* v))

(or (find-package "PVR")
    (make-package "PVR" :use
		  '(SLOOP LISP user)))
(import '(user::sb-prove) "pvr")
(defun struve-prove (formula &optional (x 40) (y 40)) 
  (or (pvr::sb-prove (convert-for-struve formula) x y)
      (pvr::sb-prove (convert-for-struve `(some larry ,formula)) x y)))

(defun sp (A) (struve-prove A))

(defun universally-quantify (A L)
  (mapc #'(lambda (x) (setq A (list 'all x A))) L) A)

(defun un-sko-for-pc (A) ;11Aug93
  (cond ((atom A) A)
	((null (cdr A)) (car A))
	((not (atom (car A))) 
	 (format t "~%Alarm in un-sko-for-pc")
	 (prnt A) (break))
	(t (cons (car A) (mapcar #'un-sko-for-pc (cdr A))))))

(defun quanifiers-front (A) 
  (cond ((atom A) A)
	((member (car A) '(all some))
	 (list (car A) (cadr A) (quantifiers-front (caddr A)))) ))
	
(defun eq-quan-mu (A B) (eq-quan (mini-scope A) (mini-scope B)))  

(defun equiv (A B) (& (implies A B) (implies B A)))

(defun implies (A B) 
  (otter-prove B :inference-rules '(binary_res para_into para_from)
		 :time 30
		 :base-axioms A))
;;-----------------------------------------------------------------
;;See file USES-ONLY.LISP for the function USES-ONLY 
