;;;24July93  This is an earlier version of pc.lisp 
;;;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;;;
;;;                         pcp.lisp                       11 March 1991
;;;                                                         2 Aug   1991     
;;;                 See papers, atp.102, atp.103
;;;  This is a LISP program to carry out the pre-condition system.
;;;
;;;  The main function is pc:  Call (pc-start H C plan) or (pc H C plan).
;;;
;;;  This file uses The OTTER Prover of Bill McCune
;;;
;;;  27Mar91: To Load (load"imply.lisp") (lppp)(lppc)(lot)(lpi)
;;;            (put (lpio) for (lpi) if compiled)
;;; 
;;; Earlier we used the following, but THAT IS NOT NEEDED NOW
;;;  This uses the file pc.lisp and others.
;;(load"imply.lisp")(load-lisp-all)(lsc)(lpcp)(l*t)(lpc)(lppp)(lppc)(lot)(lpi)
;;;   with (lppc)(lot)(lpi) last.  ((lpio) for (lpi) if compiled)
;;;
;;;  11March91:  see file pc.lisp for another (earlier) version of the pc 
;;;   prover.  See pcp.plans-lemmas for more details.
;;;
;;; Script is a global varble for imitating the human entries.  
;;;  It lets the user advise the prover on how to prove a goal when there
;;;  is not a plan, a goal that PC is supposed to finish without help.
;;;  E.g.,  (script (d (res s 0)) oo) means "replace the term (res S 0) by 
;;;                                   its definition and then call OTTER".
;;;         (script (use 14) oo)  means use Lemma 14, and      "     ".
;;;         (script (bt 10) oo) means backchain on Lemma 10 and "    ".
;;;  This is for check-out purposes only; eventually PC is supposed to
;;;   handle without help all of the goals where PLAN is nil.
;;;
;;;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

(defun lppc () (load "pcp.lisp"))
(defun lppp () (load "pcp.plans-lemmas"))
(defun lpi () (load "prove-i.lisp"))
(defun clpc () (compile-file "pcp.lisp") (load "pcp.o"))

;(defvar script nil)      ;a global varble for imitating the human entries
(defvar assume-light nil)
(defvar otter-light nil)
(defvar assumed-list nil)

(defun pc-start (H C &optional plan)         ;top level call
  (setq assume-light nil)          ;global variable. If t, assume step is true
  (setq n 9)                       ;global counter for new variables
  (setq otter-light t)             ;global variable to use OTTER
                                   ; else assume the current goal is true
                                   ; (in human-input) until turned off
  (setq Set-theory-theorems nil)
  (pc H C plan))


(defun pc (H C &optional plan)        ;called by pc-start, or at the top level
  (let (Step Plan* Plan1 C1 C* x xx P H1 H* Q Q1 Q2 Q3 Q2* Q2*1 Q2*2)
    (cond ((and assume-light (or (null plan) (eq-car plan 'script)))
	   (format t "~%Assume-light is ON, so assume goal without proof~%")
	   t)
	  ((eq 'tt plan)               ;assume without proof
           (format t "~%tt: assume without proof~%") t)
	  ((eq 'STR+VE-subset plan) 
	   (format t "~%Need STR+VE-subset prover: assume without proof~%") 
	   (setq Set-theory-theorems (cons (imp-on H C) Set-theory-theorems))
	   t)

	  ((eq-car plan 'ans)
	   (format t "~%User has given the answer~%")
	   (cadr plan))

	  ((member C Assumed-list :test 'equal)
	   (format t "~%Assume this is true without proof - in Assumed List~%")
	   t)

	  ((and (eq-car C '&) (not (null plan)) (not (eq-car plan 'script)))
	   (setq H* (and-on (cadr C) H))
	   (setq C* (cond ((cdddr C) (cons '& (cddr C))) (t (caddr C))))
	   (and-on (pc H (cadr C) plan) (pc H* C* plan)))
	  ((and (eq-car H 'or) (not (null plan)) (not (eq-car plan 'script)))
	   (setq H* (cond ((cdddr H) (cons '& (cddr H))) (t (caddr H))))
	   (and-on (pc (cadr H) C plan) (pc H* C plan)))
	  ((eq-car C '->)
	   (imp-on (cadr C) (pc (and-on (cadr C) H) (caddr C) plan)))
	  ((eq-car C 'ALL)
	   (setq Q (pc H (caddr C) plan))
	   (cond ((occur (cadr C) Q) (list 'ALL (cadr C) Q)) (t Q)))

	  ((null plan) (pcn H C))        ;Case when PLAN is null.

	  ((and (not (atom plan)) (eq-car (car plan) 'use)) (pcn H C)) 
            ;;Later we might direct the prover via such a USE statement

	  ((and (atom plan) (setq plan (eval plan)) nil))

	  ((eq-car plan 'HALT) (format t "~%Halted in PC~%") (break) 
	   (pc H C (cdr plan)))

	  ((eq-car plan 'script) (pcn H C nil (cdr plan))) ;script= (cdr plan)

	  ((and (setq Step (car plan)) (setq C1 (car Step))
		(or (setq plan1 (cadr Step)) t) (or (setq plan* (cdr plan))t)
		(format t "~%Step= ~s ~%" step) nil))       ;name some things

	  ((eq-car step 'otter-light)               ;turn otter-light OFF or ON
	   (setq otter-light (cadr step))
	   (format t "~%Turn OTTER-LIGHT ~s ~%" 
		   (cond (otter-light 'ON)(t 'OFF)))
	   (pc H C plan*))

	  ((eq-car step 'assume-light)           ;turn assume-light OFF or ON
	   (setq assume-light (cadr step))
	   (format t "~%Turn ASSUME-LIGHT ~s ~%" 
		   (cond (assume-light 'ON)(t 'OFF)))
	   (pc H C plan*))

          ;;%% The first statement in PLAN is an EXISTENTIAL CLAIM statement.
	  ((eq 'SOME (car C1))                             ;C1 = SOME x P(x)
	   (setq W (matrix C1)) (setq xx (car W)) (setq P (cadr W))
	   (setq H* (and-on P H))                          ;H* = P(x) & H
	   (cond ((not (setq Q1 (pc H C1 plan1))) nil)
                   ;;prove the first step, SOME x P(x)

                   ;;Add this step 1Aug91, and try it.  Maybe remove it later
;;               ((not (eq t Q1)) Q1)

		 ((not plan*)                ;If plan* is nil, and the last
		  (cond ((equal C C1) Q1)    ; goal is C, then exit with Q1
			((setq Q2 (pc (and-on P H) C nil)) ;else prove that 
			 (and-on Q1 Q2))))   ;C follows from earlier goals
		 ((not (setq Q2 (pc H* C plan*))) nil)
                   ;;prove the remaining steps, returning Q2
		 ((eq t Q2) Q1)                      ;if Q2 is t, return Q1.
		 ((not (occur-set xx Q2)) (and-on Q1 Q2))
		  ;;if Q2 contains no x in xx, return Q1&Q2
		 (t (setq Q2* (mini-scope Q2))
                  ;;Separate out the part Q2*1 of Q2 that contains an x from xx
                  ;; and try to prove (SOME xx P&Q2*1)
		    (cond ((not (eq-car Q2* '&)) 
			   (setq Q2*1 Q2*) (setq Q2*2 t))
			  (t (setq Q2*1 t)(setq Q2*2 t)
			     (mapc #'(lambda (A) 
                                      (cond ((occur-set xx A) 
					     (setq Q2*1 (and-on Q2*1 A)))
					    (t (setq Q2*2 (and-on Q2*2 A)))))
				   (cdr Q2*))))
		    (setq C* (subst (and-on P Q2*1) P C1 :test 'equal))
		    (format t "~%Original-Step=  ~s ~%" step)
		    (format t "~%Q2= ~s~%" Q2)
		    (format t "~%Augmented-Step= ~s ~%" (list C* plan1))
                     ;;Else prove SOME x (P(x) & Q2*1)
		    (cond ((eq t (setq Q3 (pc H C* plan1))) Q2*2)
			  (t (mini-scope-undo (and-on Q3 Q2*2)))) )))

	  ;;%% The regular case
	  ((not (setq Q1 (pc H C1 Plan1))) nil)        ;prove the step
          ((not plan*)                   ;If plan* is nil, 
	   (cond ((equal C1 C) Q1)       ;and last goal is C, then exit with Q1
                                 ;else prove that C follows from earlier goals
		 ((setq Q2 (pc (and-on C1 H) C '(script oo)))
		  (and-on Q1 Q2))))                  
	  ((not (setq Q2 (pc (and-on C1 H) C plan*))) ;Prove remaining steps
	   nil)
	  (t (and-on Q1 Q2)) )))

(defun pcn (H C &optional V script)                     ;called by PC
  ;;computes the precondition Q, for the "theorem" (H&THEORY -> C), with no 
  ;; plan.  V is a set of existential variables from C.
  ;;Script is a global varble for imitating the human entries. 
  ;; See top of this file for explanation of script.
  ;;Example, which uses PCN-SOME1   and returns C.
  ;; H = (& (P a) (R a b))
  ;; C = (SOME x (SOME y (SOME z (& (P x) (Q y) (R x y) (A z) (B y z)))))
  ;;Example,  returns  (SOME y (SOME z (& (Q y) (A z) (B y z))))
  ;; H = (& (P a) (R a b))
  ;; C = (SOME x (SOME y (SOME z (& (P x) (Q y) (A z) (B y z)))))
  (let (Q Q* C* sigma L W theta xx xx2 xx3 Cm Lm Cm* L* L2 L2* L-master)

    (cond ((eq 't C) t)
	  ((and (not otter-light) script (member (car script) '(oo o))) t)
	   ;;If OTTER-LIGHT is off, then assume H->C without proof.
           ;;A check-out only feature.
	  
	  ((and script (not (member (car script) '(oo o)))
		(setq Q (human-input H C V script))) Q) 

	  ((and (setq C (mini-scope C))        ;push in quantifiers
		(cond ((eq-car C '&)      ;remove conjuncs of C which are in H
		       (setq L (set-difference-pc (cdr C) (listify H)))
		       (cond ((null L) (return-from pcn t))
			     (t (setq C (andify L)))))
		      ((member C H) (return-from pcn t)))
		nil))
	  
	 
	  ((and (setq C (mini-scope-undo C)) nil))   ;pull quans back to front

	  ((prove-o H C))               ;try to prove C (and return)

	  ((atom C) nil)

	  ((and (eq-car C '=) (atom (setq x (cadr C)))
		(member x V) (not (occur x (caddr C)))))     
           ;;In this case C is proved by: Let x = something.

	  ((and (eq-car C '&) (setq L (remove-proved H (cdr C)))
		(not (equal L (cdr C))))   ;if some conjuncts of C were proved
	   (cond ((null L) t)              ; try to prove the rest
		 (t (setq C* (andify L)) (pcn H C* V script))))

	  ((eq-car C '&)  (and-on (pcn H (cadr C) V script) 
				  (pcn H (rest-of C) V script)))
	  ((eq-car H 'or) (and-on (pcn (cadr H) C V script) 
				  (pcn (rest-of H) C V script)))
	  ((eq '-> (car C)) 
	   (imp-on (cadr C) (pcn (and-on (cadr C) H) (caddr C) V script)))

	  ((eq 'all (car C))
	   (setq Q (pcn H (caddr C) V script))
	   (cond ((eq 't Q) t) ((occur (setq x (cadr C)) Q) (list 'ALL x Q))
		 (t Q)))
	  ((eq 'or (car C))
	   (or-on (pcn H (cadr C) V script) (pcn H (caddr C) V script)))

	  ((and (eq-car C 'some) (setq W (matrix C)) 
		(setq xx (car W)) (setq Cm (cadr W)) 
		(setq Lm (cond ((eq-car Cm '&) (cdr Cm)) (t (list Cm))))
		(eq-car Cm '&))
	    ;;e.g., C = (SOME x (SOME y ... (& A1 A2 ...)))
	    ;;W = (xx Cm) = ((x y ...) (& A1 A2 ...))
	   (cond ((and (setq W (pcn-some1 H C V xx Cm))      ;W = (L* theta) 
		       (setq L* (car W)) (setq theta (cadr W))
                        ;;L* is the subset of (A1 A2 ...) not proved
		       (not (equal L* (cdr Cm)))) ;if nothing proved, return C

		  ;;Now, if THETA is T, return (for proof) the members of L*.
                  ;;Else, collect in L-MASTER, those members A(x) of Lm, for 
                  ;; which x is bound by theta, x occurs in A(x), and it is
                  ;; NOT the case that ALL members of Lm containing x were 
                  ;; proved.  And return to be proved, the members of 
                  ;;    (L*~ L-MASTER)THETA union L-MASTER.
                  ;; to be proved.
		  (cond ((eq t theta) 
			  (setq Cm* (andify (apply-sub theta L*))))

                         (t (setq xx2 (mapcar #'car theta))
			    (setq xx2 (mapcan #'(lambda (x) 
                                   (cond ((occur x L*) (list x))))
					      xx2))
                             ;;those x's bound by theta and occurring in L*
			    (setq xx3 (connect xx2 xx Lm))
			    (setq L-master (mapcan #'(lambda (A) 
                                    (cond ((occur-set xx3 A) (list A))))
						   Lm))
			    (setq L* (set-difference L* L-master))
			    (setq L* (apply-sub theta L*))
			    (setq Cm* (andify (union-w L* L-master)))))
		  (setq C* (subst Cm* Cm C :test 'equal))
		  (remove-excess-quantifiers C*))
		 (t C)))

	  ((eq-car C 'some)
	   (setq Q (pcn H (caddr C) (cons (setq x (cadr C)) V) script))
	   (cond ((eq 't Q) t) ((occur x Q) (list 'some x Q)) (t Q)))

	  ((and (eq-car H '&) 
		(some #'(lambda (H1) 
                    (and (eq-car H1 '->) (setq W (back-chain-pc C H1 V))
			 (setq C* (car W))
			 (setq H* (remove-pc H1 H))
			 (setq Q* (pcn H* C* V script))))
		      (cdr H)))
	   Q*)                  ;might want to return Q* v (pcn H* C V script) 
	  ((and (eq-car H '->) (setq sigma (unify-pc C (caddr H) V)))
	   (apply-sub sigma (cadr H)))
	  ((eq 'not (car C)) C)       ;might want to push not in
	  
	  (t C) )))

(defun pcn-some1 (H C V xx Cm)                           ;called by PCN
  ;;C has the form (SOME x (SOME y ... (& A1 A2 ...)))
  ;;  xx = (x y ...), Cm = (& A1 A2 ...)
  ;;This returns a pair (L* THETA) where L* is a subset of (A1 A2 ...),
  ;; which are not proved by prove-o.  The remaining members of Cm have been
  ;; proved with the substitution THETA.
  (let (W Lm theta sigma L2 A*)
    (setq Lm (cdr Cm))
    (setq theta t)
    (mapc #'(lambda (A) (cond ((and (setq A* (apply-sub theta A))
				    (setq A* (subst A* Cm C :test 'equal))
				    (setq A* (mini-scope A*))
				    (setq sigma (prove-o H A* xx))
;;				    (setq sigma (prove-i H A*))
				    )
			       (setq theta (compose theta sigma)))
			      (t (setq L2 (append L2 (list A))))))
	  Lm)
    (list L2 theta) ))


(defun human-input (H C V script)             ;called by PCN
  ;;The user has several options to prove the "theorem" (P->Q), or
  ;; to send back a precondition, Q.
  (let (input term exp ans H* thm C* W)

 ;;   (cond ((eq-car script 'oo)        ;repeated use of otter in HUMAN-INPUT
 ;;	   (return-from human-input (human-input H C V (cons 'o script)))))

    (cond ((and (not (atom script)) (member (car script) '(oo o)))
	   (return-from human-input (pcn H C V script))))
     ;;25Mar91: Dont call OTTER from Human-input, call it form PCN (except ot)
     ;; This can happen only from a call FROM Human-input

    (format t "~%              ***HUMAN INPUT REQUIRED***~%")
    (setq H* (remove-long-entries H 25))
;;    (format t "~%H= ~s ~%" H*)
    (format t "~%H= Look in Global variable HHH~%")
    (setq HHH H)
    (format t "~%C= ~s ~%" C)

    (cond (script (setq input (car script)) (setq script (cdr script))
		  (format t "~%Script input= ~s~%" input))
	  (t (format t "~%Please Respond:  ")
	     (setq input (read))))
    (cond ((eq nil input) nil)
	  ((eq 't input) t)
	  ((eq 't C    ) t)

	  ((member input '(o ot))         ;OTTER with only H or (H and THEORY)
            ;;25Mar91: This can now only be ot.  Fix this, if repeated ot.
	   (cond ((not otter-light) 
		  (format t "~%otter-light OFF, so assume the goal~%") 
		  (return-from human-input t)))
	    ;;if otter-light is OFF return true without proof
	   (setq H* (cond ((eq 'ot input) (and-on H theory)) (t H)))
	   (setq ans (prove-o H* C))
	   (cond (ans (format t "OTTER proved the goal~%") t)
		 (t (format t "OTTER FAILED to proved the goal~%") nil)))

	  ((eq 'r input) 
	   (setq ans (resolution-pc H C))
	   (format t "~%RESOLUTION returns ~s~%" ans) ans)
	  ((eq 'pt input)
	   (format t "~%THEORY-Lemmas= ~% ~s~%" theory)
	   (human-input H C V script))
	  ((eq 'HALT input) 
	   (format t "~%HALTED -- Push :r to continue~%") (break)
	   (human-input H C V script))

	  ((atom input) (format t "~%ALARM Human-input ATOM~%") nil)

	  ((eq 'd (car input)) (define-pc input H C V script))     ;DEFINITION

	  ((eq 'dd (car input))     ;find the next higher level term with it
	   (cond ((setq dt (next-higher-term (and-on C H) (cadr input)))
		  (setq C* (reduce-in dt C definition-table))
		  (setq h* (reduce-in dt H definition-table))
		  (human-input H* C* V script))
		 (t (human-input H C V script))))

	  ((eq 'r (car input)) (reduce-pc input H C V script))         ;REDUCE

	  ((and (eq 'h (car input)) (numbers (cdr input)))
	   (setq H (retain (cdr input) H))
	   (human-input H C V script))
	  ((and (eq 'b (car input)) (numberp (cadr input)))
	   (setq W (back-chain-pc C (retain (cdr input) H) V))
	   (setq C* (car W))
	   (human-input H C* V script))
	  ((and (eq 'bt (car input)) (numberp (cadr input)))
	   (setq W (back-chain-pc C (retain (cdr input) theory) V))
	   (setq C* (car W))
	   (cond ((member C* '(-> instance)) 
		  (setq C* C) (setq script (cons input script))))  ;repeat
	   (format t "~%C*= ~s~%" (cond ((equal C* C) 'no-change?) (t C*)))
	   (human-input H C* V script))
	  ((eq 'use (car input))
	   (setq H* (retain (cdr input) theory))
	   (format t "~%USE ~s~%" H*)
	   (pcn (and-on H* H) C V script))
	  (input)
	  (t nil) )))

(defun and-on (A B)    ;widely used   NOT USED  See Next one
  ;; e g, (and-on (& c d) (& e f))  =  (& c d e f)
  (cond ((eq t A) B)
	((eq t B) A)
	((null A) B)
	((null B) A)
	(t (cons '&
		 (union-w (cond ((and (not (atom a)) (eq '& (car a))) (cdr a))
			      (t (list a)))
			(cond ((and (not (atom b)) (eq '& (car b))) (cdr b))
			      (t (list b))))))))

(defun and-on (A B)    ;widely used                   6Aug92
  ;; e g, (and-on (& c d) (& e f))  =  (& c d e f)
  (cond ((eq t A) B)
	((eq t B) A)
	((null A) B)
	((null B) A)
	((equal A B) A)
	((eq-car A '&) 
	 (cond ((eq-car B '&)
		(cons '& (union-w (cdr A) (cdr B))))
	       (t (cons '& (union-w (cdr A) (list B))))))
	((eq-car B '&) (cons '& (union-w (list A) (cdr B))))
	(t (list '& A B)) ))

(defun and-front (C)                      ;called by MATRIX
  ;;ie, (& A (& B C) D) goes to  (& A B C D)
  (let (A* C*)
    (cond ((not (eq-car C '&)) C)
	  ((eq-car (cadr C) '&)           ;;eg, C= (& (& A B) C D)
	   (setq C* (cons '& (union-w (cdadr C) (cddr C))))
	   (and-front C*))
	  (t (setq C* (and-front (andify (cddr C))))  ;C= (& A (& B C) D)
                                                      ;C*=(& B C D)
	     (and-on (cadr C) C*)) )))

(defun andify (L)                               ;widely used
  (let (L*)
    (cond ((cdr L) (cond ((equal L (setq L* (remove t L))) (cons '& L))
			 (t (andify L*))))
	  (L (car L)) 
	  (t t))))

(DEFUN APPLY-sub (theta D)  
       ;; the substitution THETA is applied to the form D
       (COND ((or (EQ T THETA) (null theta)) D)
	     (T (SUBLIS THETA D))))

;;(defun back-chain-pc (C H* &optional V))   in file prove-i.lisp

;;(DEFUN COMPOSE (THETA SIGMA))   In file prove-i.lisp

(defun connect (xx xxx L)                   ;called by PCN
  ;;xxx is a set of variables and xx is a subset of xxx.
  ;;This returns the set xx2 of x's in xxx for which y is in xx and
  ;; x and y both occur in the same member of L.
  ;;E.g., (connect '(y z) '(x y z w) '((P x) (Q y) (R x y) (A z) (B y z)))
  ;;    = (x y z)

  (mapcan #'(lambda (x) (cond ((some #'(lambda (y) (some #'(lambda (A)
                               (and (occur x A) (occur y A))) 
							 L))
				     xx)
			       (list x))))
	  xxx))

(defun define-pc (input H C V script)             ;called by HUMAN-INPUT
  (let (term C* H* exp exp* )
    (setq term (cadr input))
    (cond ((null (cddr input))
	   (setq C* (reduce-in term C definition-table))
	   (setq h* (reduce-in term h definition-table)))
	  ((eq 'c (caddr input))
	   (setq C* (reduce-in term C definition-table))
	   (setq H* H))
	  ((eq 'h (caddr input))
	   (setq C* C)
	   (setq H* (reduce-in term H definition-table)))
	  ((setq exp (caddr input))
	   (setq exp* (reduce-in term exp definition-table))
	   (setq C* (subst exp* exp C :test 'equal))
	   (setq H* (subst exp* exp H :test 'equal))))
    (format t "~%C*= ~s~%" (cond ((equal C* C) 'no-change?) (t C*)))
    (human-input H* C* V script) ))

(setq definition-table '(
 ((res ?S 0) ?S)
 ((res ?S (+ ?n 1)) (U (res ?S ?n) (Resolvents (res ?S ?n))))
 ((ress ?S ?T 0) ?S)
 ((ress ?S ?T (+ ?n 1)) (U (ress ?S ?T ?n) 
			   (Ressolvents (ress ?S ?T ?n) (SOS ?S ?T ?n))))
 ((SOS ?S ?T 0) ?T)
 ((SOS ?S ?T (+ ?n 1))  (U (SOS ?S ?T ?n) 
          		   (Ressolvents (ress ?S ?T ?n) (SOS ?S ?T ?n))))

))

(defun eq-car (A B)   ;is A non-nil and (Car A) is B.
  (and (not (atom A)) (eq (car A) B)))

(DEFUN imp-ON (A B)    ;widely used    VE-the-variable  from PROVE.LISP
  (cond ((null A) B) ((eq t A) B) ((eq t B) t) ((equal '(empty) A) B) 
	((null B) (reduc (list 'not A))) 
        (t (list '-> A B))))

(defun imp-on (P Q)      ;called by several functions
  (cond ((eq t Q) t) ((null P) Q) 
	((eq t P) Q)
	(t (list '-> P Q))))

(defun increase-index (x m)     ;called by BACK-CHAIN-PC (see file csos.lisp)
  (let (L L2)
    (setq L (explode x))
    (setq L2 (list (car L) m))
    (maknam L2)))

(defun explode (A)  ;convert it to a list
  (map 'list #'(lambda (char) (intern (string char)))
       (symbol-name A)))

(defun instance-pc (A B &optional V)   ;Used in ASSOC-INSTANCE. 
 ;; 9/90 See reduce.lisp 
 ;;If A is an instance of B under substitution THETA then return THETA
 ;;This assumes A and B have no free vairalbes in common.
 ;; For the pc.lisp application, the variables of B have the form ?x.
 ;; 19Oct90 I have some concerns about this, exp regarding the ?x remark
 ;;20Mar91 Also used in REDUCE-IN.
  (let (THETA LAMBDA B*) 
    (cond ((atom B)
	   (cond ((eq B A) t)
		 ((numberp B) nil)
		 ((and V (not (member B) V)) nil)    ;4/91 version
 		 (t (list (cons B A))))) 	 

	  ((and (numberp A) (> A 0) (eq-car B '+) (atom (cadr B)) 
		(equal '1 (caddr B)))           ;(instance-pc    5   (+ n 1)) =
	   (instance-pc (list '+ (1- A) 1) B))  ;(instance-pc (+ 4 1)(+ n 1))

	  ((atom A) nil) 
	  ((not (eq (car B) (car A))) nil)
	  ((null (cdr B)) (cond ((null (cdr  A)) t)))
	  ((null (cdr A)) nil)
	  ((setq THETA (instance-pc (cadr A) (cadr B)))
	   (cond ((eq t theta) 
		  (instance-pc (cons (car A) (cddr A)) 
			       (cons (car B) (cddr B))))
		 (t (setq B* (apply-sub theta B))
		    (setq lambda (instance-pc A B*))
		    (compose theta lambda)))))))

(defun length-pc (L) (cond ((atom L) 1) (t (length L))))

(defun listify (H)   ;called by PCN
 ;; If H = (& A B) then (A B), else (list H)
 (cond ((eq-car H '&) (cdr H)) (t (list H))))

(DEFUN MAKNAM (L)                ;Fuzes the list L into an Atom
  (LET ((*PRINT-CASE* :UPCASE))
    (INTERN (WITH-OUTPUT-TO-STRING (V)
    	            (MAPC #'(LAMBDA (X) (PRIN1 X V))  L)
		        V))))

(defun matrix (C)                  ;called by PCN
  ;;C has the form (SOME x (SOME y ... (& A1 A2 ...)))
  ;; or the form  (SOME x (& ... (SOME y ... (& A1 A2 ...))))
  ;;(matrix C) returns W = (xx Cm) = ((x y ...) (& A1 A2 ...))
  (let (W A* C*)
    (cond ((eq-car C 'some) 
	   (setq W (matrix (caddr C)))
	   (list (cons (cadr C) (car W)) (cadr W)))
	  ((eq-car C '&) 
	   (cond ((some #'(lambda (A) (and (eq-car A 'some) (setq A* A)))
			(cdr C))
		   ;;(matrix '(& A (some x (some y (P x y))))) goes to 
		   ;; (matrix '(some x (some y (& A (P x y)))))
		  (setq W (matrix A*))                      ;W= ((x y) (P x y))
		  (setq C* (subst (cadr W) A* C :test 'equal));C*=(& A (P x y))
		  (mapc #'(lambda (x) (setq C* (list 'some x C*))) (car W))
		  (setq C* (and-front C*))
		  (matrix C*))
		 (t (list nil C))))
	  (t (list nil C)))))

(defun mini-scope (C)			;called by PCN 
  ;;eg, (some x (& A (P x) B (Q  x))) goes to (& A B (some x (& (P x) (Q x)))) 
  (let (C* C2 L1 L2 x C** sym)
    (cond ((atom C) C)
	  ((member (car C) '(some all))
	   (setq x (cadr C))
	   (setq C* (mini-scope (caddr C))) 	
	   (cond ((not (occur x C*)) C*)
		 ((atom C*) (format t "~%ALARM mini-scope~%") ;(some x x)
		  (list (car C) x C*)) 	
		 ((not (member (car C*) '(& or ->))) (list (car C) x C*))

		 ((eq-car C* '->)                  ;11Aug93
		  (cond ((not (occur x (cadr C*))) 
			 (setq C** (list (car C) x (caddr C*)))
			 (imp-on* (cadr C*) (mini-scope C**)))
			((not (occur x (caddr C*))) 
			 (setq sym (cond ((eq-car C 'all) 'some) (t 'all)))
			 (setq C** (list sym x (cadr C*)))
			 (imp-on* (mini-scope C**) (caddr C*)))
			(t (list (car C) x C*))))

		 (t (mapc #'(lambda (A)
                   	     (cond ((occur x A) (setq L2 (append L2 (list A))))
				   (t (setq L1 (append L1 (list A))))))
         			  ;;eg, L1= (A B), L2= ((P x) (Q x)) 
			  (cdr C*))
		    (setq C2 (list (car C) x (or-andify (car C*) L2))) 
		    (cond ((null L1) C2)
			  (t (setq L1 (append L1 (list C2)))
			     (or-andify (car C*) L1)) )) ))
	  ((member (car C) '(& or))
	   (or-andify (car C) (mapcar #'(lambda (A) (mini-scope A)) (cdr C))))
	  ((eq-car C '->) 
	   (imp-on* (mini-scope (cadr C)) (mini-scope (caddr C))))
	  ((eq-car C 'not) (list 'not (mini-scope (cadr C))))
	  (t C))))

(defun mini-scope-undo (C)			;called by PCN 
  ;;ie, C= (& D (some x (& (P x) (R x)) (some y (Q y))))  goes to
  ;;       (some x (some y (& D (P x) (R x) (Q y))))
  (let (A C* C** H*)
    (cond ((atom C) C)
	  ((member (car C) '(some all))
	   (setq C* (mini-scope-undo (caddr C)))
	   (subst C* (caddr C) C :test 'equal))
	  
	  ((eq-car C '->)                                   ;7Aug92
	   (setq H* (mini-scope-undo (cadr C)))
	   (setq C* (mini-scope-undo (caddr C)))
	   (bring-through-quans '-> H* C*))

          ((not (eq-car C '&)) C)
	  ((some #'(lambda (A*)     
                         ;ie, C= (& D (some x (& (P x) (R x)) (some y (Q y))))
              (and (not (atom A*)) (member (car A*) '(some all)) (setq A A*)))
		 (cdr C))
	   (setq C* (subst (caddr A) A C :test 'equal))
                                 ;eg, C*= (& D (& (P x) (R x)) (some y (Q y)))
	   (setq C* (and-front C*)) ; C*= (& D (P x) (R x) (some y (Q y)))
	   (setq C** (mini-scope-undo C*))  
                                    ;C**= (some y (& D (P x) (R x) (Q y)))
	   (list (car A) (cadr A) C**))
                                    ;(some x (some y (& D (P x) (R x) (Q y))))
	  (t C))))

(defun bring-through-quans (A B C) ;called by mini-scope-undo  7Aug92
  ;;Eg, (bring-through-quans '-> 'H '(some x (some y (P x y))))
  ;;     = (some x (some y (-> H (P x y))))
  (cond ((atom C) (list A B C))
	((member (car C) '(all some))
	 (list (car C) (cadr C) (bring-through-quans A B (caddr C))))
	(t (list A B C))))

(defun next-higher-term (A term)                ;called by HUMAN-INPUT
  ;;Eg, (next-higher-term (res (e [] (res S 0)))) returns (res S 0)
  (cond ((equal A term) A)
	((atom A) nil)
	((member term A :test 'equal) A)
	((next-higher-term (car A) term))
	((next-higher-term (cdr A) term))))

(defun numbers (L)
  (every #'numberp L))

(defun number-of-symbols (H)                    ;called by REMOVE-LONG-ENTRIES
  (cond ((null H) 0)
	((atom H) 1)
	(t (+ (number-of-symbols (car H))
	      (number-of-symbols (cdr H))))))
	 

(defun occur (a b)   ;does x occur in A?
    (cond ((equal a b) t)
          ((atom b) nil)
          (t (some #'(lambda (x) (occur a x)) b))))

(defun occur-set (xx A)    ;Called by PC. Does a member of xx occur in A?
  (some #'(lambda (x) (occur x A)) xx))
 
(defun or-on (A B)    ;widely used 
  ;; e g, (or-on (or c d) (or e d))  =  (or c d e)
  (cond ((eq t A) t)
	((eq t B) t)
	((null A) B)
	((null B) A)
	(t (cons 'or
		 (union-w (cond ((and (not (atom a)) (eq 'or (car a))) (cdr a))
			      (t (list a)))
			(cond ((and (not (atom b)) (eq 'or (car b))) (cdr b))
			      (t (list b))))))))

(defun orify (L)
  (cond ((cdr L) (cons 'or L))
	(L (car L))
	(t nil)))


(defun or-andify (sym L)                               ;called by mini-scope
  ;;eg, (& (a b c)) goes to (& a b c), (or (a)) goes to a, (& nil) goes to t
  (cond ((cdr L) (cons sym L)) (L (car L)) (t t)))

;;(defun prove-i (H C &optional V)  in file prove-i.lisp)
 
(defun prove-o (H C &optional xx (time 10))    ;called by PCN, REMOVE-PROVED
  ;;Attempt to prove the formula (H->C) using OTTER.  xx is a list
  ;; of variables, like (x y z).  If not nil, return their bindings.
  ;;We can easily add here the option of putting THEORY also into H
  ;; Or use some other prover than OTTER

  (let (W thm ans ans2 C* theta)
    (setq H (cond ((occur '= C) (and-on '(ALL x (= x x)) H)) (t H)))
    (setq thm (imp-on H C))
    
    (setq thm (sub=assignment thm))

    (setq xx (mapcan #'(lambda (x) (cond ((occur x thm) (list x)))) xx))
    (cond ((> (length-pc H) 20)
	   (setq time (max time (round (* (length-pc H) .5))))))
    (format t "~%TIME= ~s~%" time)
    (cond ((eq-car C '&)
	   (cond ((not (setq ans (prove-o H (cadr C) xx time))) nil)
		 ((not (setq ans2(prove-o H (andify (cddr C)) xx time))) nil)
		 (t (compose ans ans2))))
	  ((and (cond ((occur '= H)
		       (setq ans (otter-prove thm :time time :ans-vars xx
                    :inference-rules '(para_into para_from hyper_res))))
		      (t (setq ans (otter-prove thm :time time :ans-vars xx))))
		nil))
	  ((atom ans) (format t "NOT-Proved (by OTTER)~%") nil)
	  ((cdr ans) (format t "PROVED by OTTER - theta~%") (cadr ans))
	  (t (format t "PROVED by OTTER~%") t) )))

(defun remove-excess-quantifiers (C)         ;called by PCN
  ;;e.g., (all x (all y (all z (all w (P y w)))))  goes to
  ;;             (all y        (all w (P y x)))
  (cond ((atom C) C)
	((member (car C) '(all some))
	 (cond ((occur (cadr C) (caddr C))
		(list (car C) (cadr C) (remove-excess-quantifiers (caddr C))))
	       (t (remove-excess-quantifiers (caddr C))) ))
	(t (cons (remove-excess-quantifiers (car C))
		 (remove-excess-quantifiers (cdr C)))) ))
		


(defun remove-proved (H L)                   ;called by PCN
  ;;Remove those members of L which are proved by PROVE-O (usually OTTER)
  ;; using hypothesis H
  (mapcan #'(lambda (A) (cond ((prove-o H A) nil) (t (list A))))
	  L))

(defun remove-long-entries (H m)               ;called by HUMAN-INPUT
  ;;remove from H those entries of lenght greater than m
  (cond ((eq-car H '&)
	 (cons '& (mapcan #'(lambda (H1) (cond ((< (number-of-symbols H1) m)
						(list H1))))
			  (cdr H))))
	(t H)))


(defun reduce-in (term exp rt)               ;Called by HUMAN-INPUT
  ;;term is a term in the expression exp.  
  ;;Let (term1 term2) be an entry in the rt (REDUCE-TABLE), and suppose
  ;; that S is the mgu of term and term1, then this returns the
  ;; expression exp* gotten by replacing  term S  in  exp S  by  term2 S.
  (let (S term* term2 term2* term3 exp*)
    (cond ((some #'(lambda (pair) (and (setq S (instance-pc term (car pair)))
				       (setq term2 (cadr pair))))
		 rt)
	   (setq term*  (apply-sub S term))
	   (setq term2* (apply-sub S term2))
	   (setq exp*   (apply-sub S exp))
	   (subst term2* term* exp* :test 'equal) )
	  ((and NIL (eq-car term 'E) (setq term2 (caddr term))
		(eq-car term2 'U) (cdddr term2))
	   ;;eg, term = (E x (U A B C))                 ;term2  (U A B C)
	   (setq term3 (cons 'U (cddr term2)))          ;term3  (U B C)
	   (setq term2* (list 'U (cadr term2) term3))   ;term2* (U A (U B C))
	   (setq exp* (reduce-in term   finish this later??)))
	   
	  (t nil) )))

(defun reduce-pc (input H C V script)               ;called by HUMAN-INPUT
  (let (term C* H* exp exp* )
    (setq term (cadr input))
    (cond ((null (cddr input))
	   (setq C* (reduce-in term C reduce-table))
	   (setq h* (reduce-in term h reduce-table)))
	  ((eq 'c (caddr input))
	   (setq C* (reduce-in term C reduce-table))
	   (setq H* H))
	  ((eq 'h (caddr input))
	   (setq C* C)
	   (setq H* (reduce-in term H reduce-table)))
	  ((setq exp (caddr input))
	   (setq exp* (reduce-in term exp reduce-table))
	   (setq C* (subst exp* exp C :test 'equal))
	   (setq H* (subst exp* exp H :test 'equal))))
    (format t "~%C*= ~s~%" (cond ((equal C* C) 'no-change??) (t C*)))
    (human-input H* C* V script) ))

(setq reduce-table '(
 ((e ?t (intersection ?A ?B)) (& (e ?t ?A) (e ?t ?B)))
 ((e ?t (U ?A ?B)) (or (e ?t ?A) (e ?t ?B)))

))

(defun resolution-pc (H C)        ;called by PCN
  ;;Attemp to prove (H -> C) by resolution.
  (resolution (and-on H (list 'not C))))

(defun rest-of (C)     ;called by PCN
  ;;eg, (rest-of '(& A B C)) = (& B C), (rest-of '(& A B)) = B
  (cond ((atom C) (format t "~%ALARM C is Atom in REST-OF~%") nil)
	((null (cdr C)) (format t "~%ALARM C has no entry in REST-OF~%") nil)
	((null (cddr C))(format t "~%ALARM C has no more in REST-OF~%") nil)
	((null (cdddr C)) (caddr C))
	(t (cons (car C) (cddr C))))) 

(defun retain (L H)              ;called by HUMAN-INPUT
  ;;retain in H only the hypotheses with numbers in L
  ;;E.g., (retain '(2 4) '(& a b c d e)) = (& b d)
  (let (H*)
    (cond ((not (eq-car H '&)) (return-from retain H)))
    (setq H* (mapcar #'(lambda (n) (nth n H)) L))
    (cond ((cdr H*) (cons '& H*)) (t (car H*)))))

(defun set-difference-pc (L L2)       ;L ~ L2
  (cond ((null L) nil)
	((member (car L) L2 :test 'equal) (set-difference-pc (cdr L) L2))
	(t (cons (car L) (set-difference-pc (cdr L) L2))) ))

(defun set-intersection (L L2)        ;L intersection L2
  (cond ((null L) nil)
	((member (car L) L2 :test 'equal) 
	 (cons (car L) (set-intersection (cdr L) L2)))
	(t (set-intersection (cdr L) L2))))

(defun strip-leading-Ex-quans (C)   ;called by PC
  ;;remove any leading existential quantifiers from C and the variable
  ;;E.g., (SOME x (SOME y (P x y))) goes to (P x y)
  (cond ((eq-car C 'some) (strip-leading-Ex-quans (caddr C)))
	(t C)))

(defun sub=assignment (thm)         ;called by PROVE-O
  ;;If the left side of an implication in thm has an equality unit of the
  ;; form E= (= x term) where x is an atom, then delete H and replace x
  ;; by term in the right side.  
  ;;E.g., (-> (& A (= x (t1)) (= y (t2)) (P x y) B) (Q x y)) is replaced by
  ;;      (-> (& A (P (t1) (t2)) B) (Q (t1) (t2)))
  ;;Note: ALL x (x = t0 -> P(x))  <->  P(t0)
  (let (W H C thm*)
    (cond ((atom thm) thm)
	  ((eq-car thm '->) 
	   (setq H (sub=assignment (cadr thm)))
	   (setq C (sub=assignment (caddr thm)))
	   (setq W (sub=assign H C))
	   (imp-on (car W) (cadr W)))
	  ((member (car thm) '(& or))
	   (cons (car thm) (mapcar #'sub=assignment (cdr thm))))
	  ((member (car thm) '(all))
	   (setq thm* (sub=assignment (caddr thm)))
	   (cond ((occur (cadr thm) thm*) (list (car thm) (cadr thm) thm*))
		 (t thm*)))
	  ((member (car thm) '(some))
	   (list (car thm) (cadr thm) (sub=assignment (caddr thm))))
	  (t thm) )))

(defun sub=assign (H C)             ;called by PROVE-O
  ;;If H has assignment type equality units of the form (x term)
  ;; where x is an atom, the replace x by term in H and C.
  ;;ie, H= '(& A (= x (t1)) (= y (t2)) (P x y) B) C=(Q x y) goes to
  ;;    H= '(& A (P (t1) (t2)) B)  C=(Q (t1) (t2))
  (let (E x H* C*)
    (cond ((and (eq-car H '=) (atom (setq x (cadr H))))
	   (subst-Q (caddr H) x C))
	  ((not (eq-car H '&)) (list H C))
	  ((some #'(lambda (H1) (and (eq-car H1 '=) (atom (setq x (cadr H1)))
				     (setq E H1)))
		 (cdr H))
	   (setq H* (andify (remove E (cdr H) :test 'equal)))
	   (setq H* (subst-Q (caddr E) x H*))
	   (setq C* (subst-Q (caddr E) x C ))
	   (sub=assign H* C*))
	  (t (list H C)))))

(defun subst-Q (y x A)                      ;called by sub=assign
  ;;Like SUBST except that quantified variables are not replaced
  (cond ((equal x A) y)
	((atom A) A)
	((member (car A) '(all some))
	 (cond ((eq x (cadr A)) A)
	       (t (list (car A) (cadr A) (subst-Q y x (caddr A))))))
	((member (car A) '(& or -> not))
	 (cons (car A) 
	       (mapcar #'(lambda (B) (subst-Q y x B)) (cdr A))))
	(t (subst y x A :test 'equal)) ))

;;(defun subset (A B)  in file prove-i.lisp)
 
;;(DEFUN UNIFY-PC (A B &optional V)  in file prove-i.lisp)

;;(DEFUN unify-pc-sets (L L* V &optional THETA) in file prove-i.lisp)

;;(defun unify-subset (A B &optional V)    in file prove-i.lisp)
(DEFUN UNION-W (A B)    ;Woody's version of UNION
  (COND ((NULL B) A)
	((MEMBER (CAR B) A :test #'equal) (UNION-W A (CDR B)))
	(T (UNION-W (APPEND A (LIST (CAR B))) (CDR B)))))

(defun trace-without-H ()
  (trace (pc :entry `(pc , (cadr si::arglist) ., (cdddr si::arglist))))
  (trace (pcn :entry `(pcn , (cadr si::arglist) ., (cddddr si::arglist))))
  (trace (human-input :entry `(human-input , (cadr si::arglist) ., (cddddr si::arglist))))
  (trace (pcn-some1 :entry `(pcn-some1 ., (cdr si::arglist)))) 

;;  (trace (prove-o :entry `(prove-o , (cadr si::arglist) ., (cdddr si::arglist;;))))
;;  (trace (prove-i :entry `(prove-i , (cadr si::arglist) ., (cdddr si::arglist;;))))
  )

(defun tr () (trace-without-H))

(defun p () 
  (pcn '(& (P a) (R a b))
       '(SOME x (SOME y (SOME z (& (P x) (Q y) (A z) (B y z)))))))
