
;;*&% *&% *&% *&% *&% *&% *&% *&% *&% *&% *&% *&% *&% *&% *&% *&% *&% *&% 
;;
;; 18Nov92  We have temporarily changed the call 
;;
;;                  (prove theorem)
;; to
;;                  (imply-prove theorem)
;;
;; so that there will be no conflict with the use of STR+VE which also
;; uses the call (prove theorem)
;;
;;*&% *&% *&% *&% *&% *&% *&% *&% *&% *&% *&% *&% *&% *&% *&% *&% *&% *&% 


;;;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;;;
;;;                     prove.lisp                           15 Jan 1992
;;;
;;; (load "imply.lisp") (load-lisp-all)
;;;
;;; This the combined version of Prove1,Prove2,prove3,prove4.lisp
;;; See below.  Originally they were separated for compiling purposes,
;;;  but now recombined.
;;;
;;;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;;;*********************************************************************
;;;
;;;                     PROVE.LISP    In KCL
;;;                                 20 Aug 87,  30  Mar 87  
;;;               W. W. Bledsoe     30 January 1987  25 Feb 1989  2 Mar 90
;;;
;;;             This is the main routine of IMPLY.LISP
;;;                   Call  (PROVE Theorem)
;;;           to INTERACTIVELY prove the theorem Theorem
;;;   Now divided into four parts:  PROVE1,PROVE2,PROVE3.LISP,PROVE4.LISP
;;;          for ease of compiling  (This is PROVE1.LISP)       
;;;
;;;***********************************************************************

(defmacro imply-prove (TH &OPTIONAL plan non-stop-lt ap jr);18Nov92 imply-prove
  ;;This is the main routine
    ;;See PROVE-EXECUTOR for what it does
  (setq *jr-light* (cond (jr t) (t nil)))
  (setq %al% (cond (ap t) (t nil)))
  `(let ((*theorem-name* ', th))
                           (prove-executor ,th ,plan ,non-stop-lt)))

(defmacro pr    (TH &OPTIONAL plan non-stop-lt ap jr)   ;Same as PROVE
  (setq *jr-light* (cond (jr t) (t nil)))
  (setq %al% (cond (ap t) (t nil)))
  `(let ((*theorem-name* ', th))
                           (prove-executor ,th ,plan ,non-stop-lt)))

(defun PROVE-executor (THEOREM &OPTIONAL plan non-stop-lt)
  #| USED-IN (pr prove)
     This routine calls on IMPLY to prove the theorem (or non-theorem) THEOREM
      -- which may or may not be skolemized (but is not negated) -- it expects
     theorem to use n-ary ands and n-ary ors   |#

  (PROG	(H C THETA HEADING tl anc lt yet args *pl*)
        (cond ((eq 'restart theorem) ;Restarting from an IMPLY crash.
               (go below))) 
	(setq *in* 0) (setq *in-lt* nil)        
	(setq *function-depth-lt* t)
	;;For limiting the depth of recalling IMPLY-RULES
	(SETQ %PROOF-LIST% NIL)
        (setq %plan% plan)
	(setq *%plan% nil) ;for collecting plan from user inputs  28Apr92
        (setq %proof% (cond (%al% plan) (t nil)))
        ;;%al%, meaning "analogy-light", will be T if PROVE is  called by 
        ;; ANALOGY-PROVE (see file analogy.lisp).  
        (setq *pl* (cond (%plan% *detail-printing-light*) (t t)))
        (SETQ %REDUCE-LIGHT% (cond (*jr-light* nil) (t t)))
        (setq %non-stop-light% nil)
;;	(SETQ THEOREM (INFIX->PREFIX THEOREM))   ;skipped this 19June93
	(SETQ %GOAL-MESSAGE% 'ORIGINAL-GOAL)
        (and (not *jr-light*) (format t "~% Theorem Being Proved: ~%~a ~%"
                             *theorem-name*))
	(and *jr-light* (ind2)(--)) 
;;	(cond (*iprn* (print-infix theorem (+ *indent* 4))(-%))
;;	       (t (format t "~s~%" theorem)))   ;skipped this 19June93
	(SETQ %TIME% (get-internal-run-time))    ;Time-started
;;      (SETQ THEOREM (BINARY-TO-UNARY< THEOREM)) ;skipped this 19June93
        (setq %theorem-variables% (append 
              (set-difference-w (all-variables-in theorem)
				(bound-variables-in theorem)) '(%x%)))
	(SETQ THEOREM (SKOLEMIZE THEOREM))
;;	(SETQ THEOREM (NEW-VARIABLES THEOREM))     ;this takes too long
        (setq %object-list% nil)
        (setq H '(nil nil nil nil))
	(COND (*jr-light* (setq c theorem))
	      ((EQ '-> (CAR THEOREM))
               (setq H (and-on-h H (cadr theorem)))
	       (setq H (ground-units-forward-chain H))           ;29June92
;;             (and *or-out-light* (setq H (mapcar #'or-out H))) ;24Mar92 off
	       (SETQ C (AND-OUT (CADDR THEOREM))))
	      (T (SETQ C (OR-OUT THEOREM))))
        (cond (*jr-light* (ind2) (--) 
			  (format t "Skolemize (Remove Quantifiers)")
			  (-%)(ind2)(--)(sp 3)
			  (cond (*iprn* (print-infix theorem (+ *indent* 7)))
				(t (format t "~s" theorem)))
			  (setq *suppress-printing-c* t))
	      (t (format t "Theorem being proved -- Skolemized: ~% ~a 
		 ~% H:  " *theorem-name*)
		 (number&print-h H)
		 (format t "~%C:  ~s ~%~%" C)))
  
	(SETQ HEADING (LIST        ;2Aug89, I did not change this for jr proofs

                (list 'format 't "~% Theorem Being Proved: ~% H: ~% ~s
		      ~% ----> ~% C: ~4t ~s ~%" (list 'quote h) 
                                                (list 'quote c)) ))
BELOW   (cond ((eq 'restart theorem) ;Restarting from an error crash in IMPLY
               (setq args *imply&prover-arguments*)
               (setq H (car args)) (setq C (cadr args)) (setq TL (caddr args))
               (setq args (cdddr args)) (setq anc (car args))
               (setq LT (cond ((eq 'qed (cadr args)) 'P) (t (cadr args))))
	       (setq YET (caddr args)) 
               (setq %proof% (cadddr args)) (setq %al% (caddr (cddr args)))
               (setq args (cdddr (cddr args)))
               (setq %non-stop-light% (car args))
               (setq %proof-list% (cadr args))(setq %reduce-light%(caddr args))
               (setq args (cdddr args)) (setq non-stop-lt %non-stop-light%)
               (setq %goal-message% (cadr args)) (setq %time% (caddr args))
               (setq %theorem-variables% (cadddr args))
               (setq %object-list% (caddr (cddr args)))
               (cond (%al% (setq lt 'ao) (imply-break nil) (a-options-stop))) )
              (t (setq TL '(1)) (setq anc nil) 
                 (setq LT (cond (*global-QED-light* 'qed) 
                                (%al% 'ao) (T 'PROVE)))
                 (setq YET nil)
		 ))
(prnt H C TL anc LT) (break)

              (SETQ THETA (CATCH '*catch-atom* 
                                 (IMPLY H C TL anc LT yet %proof%)))
              ;;NOTE: regarding the above call to IMPLY.  If we are in the
              ;;  analogy mode, where the current call to PROVE comes from
              ;;  ANALOGY-PROVE (see file analogy.lisp), then %al% will be
              ;;  T and %proof% will contain the proof to be followed (auto-
              ;;  matically (in A-OPTIONS)).  In this case that proof, %proof%,
              ;;   will be transmitted as an argument of IMPLY.  
              ;;But, if we are in the PLAN mode, where the parameter PLAN,
              ;;  and therefore %plan%, are not nil, then the global variable
              ;;  %plan% contains the plan to be followed (automatically (in
              ;;  OPTIONS)). It is NOT transmitted as a argument of IMPLY -- in
              ;;  this case the argument %proof% of IMPLY remains nil.
              ;;Finally, in the ordinary case, where the user interacitvely
              ;;  supplies the commands to the prover (in OPTIONS),  the 
              ;;  argument %proof% of IMPLY also remains nil.

        (cond ((numberp theta) 
               (print 'RESTORED) 
               (setq %PROOF-LIST%     
                ;All of this %proof-list% stuff can be removed now(6/30/88).
                     (CONS (list 'format 't "RESTORED by backing up~%")
                            %PROOF-LIST%))
               (SETQ theta nil)))
	(COND ((and theta *-*) (-%)(-%)(format t "##~%~%~%"))
	      (THETA (format t "~%~%~% PROVED: ~s ~%" *theorem-name*)
                     (format t "~% With MGU THETA: ~s 
                        Returned for the Theorem~%" Theta))
              (T     (format t "~% NOT-PROVED: ~s ~%" *theorem-name*)))
	(SETQ %PROOF-LIST%
	      (CONS 
                 (list 'format 't 
                       "THETA= ~s ~33t IS RETURNED FOR THE THEOREM:  ~s
		       ~%" (list 'quote theta) (list 'quote *theorem-name*))
		    %PROOF-LIST%))
	(cond (*-* nil)
	      (t (pprint (list 'time-used 
			       (SETQ %TIME% (+ (get-internal-run-TIME) (- %time% )))
			       'msec))))
	(TERPRI)
	(SETQ %PROOF-LIST%
	      (CONS 
                    (list 'format 't "PROOF STEPS ~%")
		    (REVERSE (CONS 
                       (list 'format 't "TIME-USED ~11t ~s  msec ~%" 
                                        (list 'quote %time%))
				   %PROOF-LIST%))))

	(COND (*PRINT-PROOF-LIGHT*
	       (TERPRI)
               (cond ( %proof-list% (mapcar 'eval %proof-list%)) (t nil))))
	(and *%plan%                ;28Apr92  plan generated by user commands  
	     (setq *%plan% (mapcar #'(lambda (u) 
                (cond ((eq 'carriage-return u) 'cr) (t u))) *%plan%))
	     (prnt *%plan%))

	(COND (THETA (RETURN theta))) ))              ;(return theta) 6Jan93

(DEFUN IMPLY (H C TL ANC LT &OPTIONAL YET %proof%)    ;Called by PROVE-executor

  ;; THIS IS THE MAIN ROUTINE OF THIS FILE -- IT IS CALLED BY THE FUNCTION
  ;;  PROVE-executor AND TRIES TO RETURN A SUBSTITUTION THETA FOR WHICH 
  ;;  (APPLY-SUBSTITUTION THETA (H -> C)) IS A TAUTOLOGICAL THEOREM  
  ;;   
  ;; ALSO DURING THE PROOF PARTS OF THE PROOF ARE STORED IN THE LIST
  ;;    %proof-list% WHICH IS PRINTED OUT BY PROVE AT THE END (not after 6/88)
  ;;
  ;; 17.  DEC 1985.   WE ARE NOW AUGMENTING THIS FUNCTION AS PART OF
  ;;  implyi-c.lisp - AN INTERACTIVE PROVER LIKE wwb3.lisp 
  ;; ITS ACTS AS trap AND cntrl AND CALLS (imply-rules light) -- IT ISSUES
  ;;  catch CALLS (LIKE ERRSET) 
  ;; imply-rules IS CALLED ONLY once FOR EACH real CALL TO IMPLY 
  ;; YET has the form ( (THETA* H C TL ANC LT MSG) 
  ;;                    (THETA* H C TL ANC LT MSG) ...)  
  ;; H is made up to four parts:  USE h-gu H= and Hv, where
  ;;  USE is a Lemma that is to be used (if not NIL),
  ;;  h-gu is the conjunction of ground-units in the Hypothesis, 
  ;;  H= is the conjunction of ground equality units in the Hypothesis,
  ;;  and Hv is the rest.

  (declare  (special h c tl anc lt yet))
  (declare (special bigx reported))    
  (cond (*imply-break-light* (format t "~%IMPLY-break~%")(break)))       
   ;;Break IMPLY if *imply-break-light* light is T
  (and *v* (format t "~%C= ~s in Imply~%" c))    ;if "verbose" print c
  (cond ((and (null C) (equal h (list nil nil nil nil)))
	 (return-from imply nil)))

  (PROG (LT* use h-gu H= Hv)
    (setq use (car H)) (setq h-gu (cadr H)) (setq H= (caddr H)) 
                                            (setq Hv (cadddr H))
    (setq bigx (setq reported nil))
;;The following is for the Analogy-prover only. ao stands for A-options.
    (cond (%al% (return (cond ((eq lt 'ao) 
                               (A-options H C TL ANC LT YET %proof%))
			      (t (imply-rules 'prove))))))

;;The rest is for the regular Interactive Prover.
    (COND ((MEMBER LT '(QED DETAIL)) 
	   (RETURN (IMPLY-RULES LT)))
	  ((EQ 'QED-1 LT) 
	   (SETQ BIGX (IMPLY H C TL ANC 'QED YET)) )
	  ((MEMBER LT '(DETAIL-1 DETAIL-2 DETAIL-3))
	   (SETQ LT*
		 (COND ((EQ LT 'DETAIL-1) 'DETAIL-2)
		       ((EQ LT 'DETAIL-2) LT)
		       ((EQ LT 'DETAIL-3) 'DETAIL)))
	   (COND ((MEMBER LT '(DETAIL-1 DETAIL-3))
		  (SETQ BIGX (IMPLY H C TL ANC LT* YET)))
		 ((MEMBER LT '(DETAIL-2))
		  (RETURN (IMPLY-RULES LT*)))))

	  ((AND (MEMBER LT *catch-lights*) ;'(B catch 1 2 prove proceed)
		(NOT (EQUAL '(\.) (LAST TL))) 
		(SETQ TL (APPEND TL '(\.)))
		NIL))

	  ((AND (not %Non-stop-light%) 
		(MEMBER LT *stop-lights*) ;'(1 2 prove proceed)
                (cond ((eq 'failed-goal (setq bigx (options)))
		       (return-from imply nil))
                      (t bigx)))
 
	   (GO BELOW))
	  ((EQUAL '(\.) (LAST TL))
	   (SETQ BIGX (CATCH '*catch-atom* (IMPLY-RULES LT))))
	  ;;This the only way that BIGX can become a number
	  ;;by catching numbers thrown at various places in the pgm
	  (T  (SETQ BIGX  (IMPLY-RULES LT))) )
  
  BELOW 
(RETURN 

  (COND ((NUMBERP BIGX)
	 (COND ((EQUAL BIGX 1)
		(format t "RESTORED ~% ~a ~% ~s" tl c)
		(ans* '(RESTORED by backing up))                
		(OPTIONS))
	       (T (THROW '*catch-atom* (- BIGX 1)))))
 
	((MEMBer lt  '(QED DETAIL DETAIL-2)) ;seems impossible
	 BIGX)				;to get here
	 
	((MEMBER LT '(qed-1 detail-1 detail-3 1 2 proceed
			    prove))	;*REPORT-LIGHTS*
	 (REPORT C BIGX)
	 (SETQ REPORTED T)
	 (cond (%Non-stop-light% BIGX) 
	       (*jr-light* Bigx)
	       ((eq 'qed-1 lt) Bigx)
	       (T (OPTIONS))))
 
	(T BIGX)))))

 
(DEFUN IMPLY-RULES (LT)			;USED-IN (IMPLY)
   ;; This is called by IMPLY. 
   ;; H has four components, H = (use h-gu H= and Hv).  This calls
   ;; (IMPLY-RULES* H% h#), for H% equal to these components.
   ;; But if C is a ground unit, it first it tries to prove it by 
   ;;  the ground-unit-prover. 
   (declare  (special h c tl anc lt yet))  
   (let (use h-gu h-gu* H= Hv H=* hgs cs C* C2 N2)

       (and *v* (format t "~%C= ~s in Imply-Rules~%" c))  ;if "verbose" print c
;;       (format t "~%C= ~s in Imply-Rules~%" c)
;;       (format t "~%N2= ~s in Imply-Rules~%" N2)
       (cond ((eq t C) (return-from imply-rules (prove-yet t))))     ;4July92

     ;;%%% Test for too many recursive calls to IMPLY-Rules
       (cond ((and  *in-lt* (< *in-limit* (setq *in* (1+ *in*))))
	      (and (not *-*)(format t "~%Exceeded IMPLY-RULES Recall Limit~%"))
	      (return-from imply-rules nil))
	     ((not *in-lt*) (setq *in* 0)))

     ;;%%% Test for depth-of functions                             1Aug92
       (cond ((and *function-depth-lt* (function-depth C 2))
	      (format t "~%Exceeded FUNCTION-DEPTH Limit~%")
	      (return-from imply-rules nil)))
       
       (setq use (car H)) (setq h-gu (cadr H)) (setq H= (caddr H))
       (setq Hv (cadddr H))

     ;;%%% CONSEQUENCE.  See journal-ready.lisp for last-assummed-in
       (cond ((and (eq-car C '->)            ;Goal is P->C'
		   (setq C2 (car *Hn*))      ;Last entry in *Hn* 
                   (or (equal C2 (caddr C)) (equal (cadr C2) (caddr C)))
		    ;;Last entry proved was C?
		   (setq N2 (last-assummed-in *Hn*)) ;N2 was the last assummed
		   (equal (cadr N2) (cadr C)))
	      (setq H (purge H (cadr C2))) (setq *Hn* (remove C2 *Hn*))
	      (return-from imply-rules T)))

     ;;%%% Ground Unit -- member of H?
       (COND ((and (ground-unit C) 
		   (or (equal C h-gu) 
		       (and (eq-car h-gu '&) (member C h-gu :test 'equal) )
		       (equal C H=) 
		       (and (eq-car H= '&)   (member C H= :test 'equal)) ))
	      (cond ((and (not *jr-light*) *PL*)
		     (format t "~%C was found in the Hypothesis~%")))
	      (prove-yet t))
 
     ;;%%% Larry's SET PROVER
	     ((and (not use) (ground-unit C) (set-unit C)        ;8/16/89
		   (progn (setq h-gu* (copy-tree h-gu))
			  (setq hgs (cond ((eq-car h-gu* '&)
					   (cons '& (delete-if-not #'set-unit 
							       (cdr h-gu*))))
					  ((set-unit h-gu*) h-gu*)
					  (t nil)))
			  (setq hgs (and-on hgs H=))
			  (setq cs (cond (hgs (list '-> hgs C))
					 (t C))) t)
		   (eq 't (setq cs (LSP cs))))    ;call Larry's Set Prover.
	      (cond (*PL* (format t "~%Proved by Larry's Set Prover~%")))
	      (Prove-yet t))
#|  Remove Ground-unit-prover for now              25July92
     ;;%%% Try the GROUND-UNIT-PROVER
	     ((and (not use) (ground-unit C) 
		   (progn (setq H=* (remove& H=)) 
                          (setq H=* (mapcar #'cdr H=*)) t)
		   (ground-unit-prover C (and-on h-gu H=) H=* nil 1))
	      (cond (*PL* (format t "~%Proved by the GROUND-UNIT-PROVER~%")))
	      (Prove-yet t))
|#	     
      ;;%%% Remove GROUND CONJUNCTS of C that are in H
	     ((and (not use) (eq-car C '&)                        ;8/16/89


		   (eq-car h-gu '&)
		   (null (setq C* (set-difference C (cdr h-gu)))))
	      (cond (*PL* (format t "~%Conjuncts of C found in the Hyp~%")))
	      (Prove-yet t))

	     ((and (not use) (eq-car C '&) (eq-car h-gu '&)
                   (not (equal C* C))     ;8/16/89
		   (setq C (clear-& C*))            ;clear-& is in file ve.lisp
		   (format t "~%Some Conjuncts of C found in the Hypothesis~%")
		    nil))

      ;;%%% Multiple Back-chaining (See prove2.lisp)  (not enabled 27Feb90)
	     ((and nil (not use) (eq-car C '&) Hv                     ;8/16/89
		   (setq W (multiple-bc H C))
		   (cond ((equal '(true) (setq C (cadr W)))   ))))
	      
;;           ((or (prnt H C) (break) nil))
      ;;%%% Call IMPLY-RULES* for the four components of H
	     ((and use (imply-rules* lt use 1)))
	     ((and h-gu (imply-rules* lt h-gu 2)))
	     ((and Hv (imply-rules* lt Hv 3)))  ;re-reordered 3 and 4 11July92
             ((and H= (imply-rules* lt H= 4)))      ;reordered 3 and 4 26Mar92
             ((and (every #'null H) (imply-rules* lt Hv 3)))
	     )))

(defun imply-rules* (lt H% h#)  ;called by IMPLY-RULES
  ;;This is the main work-horse of IMPLY. It trys various rules to 
  ;; prove the goal C, or to process it so that other rules can prove it.
  (declare  (special h c tl anc lt yet))
  (declare  (special &exclude&))  
  (let (THETA SIGMA C* W B USE h-gu H= Hv H%% H2 H*1 H*2 H3 LP gu)

    (setq USE (car H)) (setq h-gu (cadr H)) (setq H= (caddr H))
                                             (setq Hv (cadddr H))
    (cond (*ancestry-light* (SETQ ANC (ADD-TO ANC C))))
           ;;anc is for ancestry. Used only when the ancestry-light is on.
    (WRITE-GOAL-MESSAGE)
;;(prnt h#)
    (COND ((AND 
	    (OR (EQUAL C '(TRUE))(equal c '(t))(eq c t)(EQUAL H% '(FALSE)) 
		(and (eq '& (car h%)) (MEMBER '(FALSE) H%)) (equal c '(<= 0)))
	    (ANS T) 
	    (report&options yet c t)
	    (SETQ SIGMA (PROVE-YET T)))
	   ;; rule 1 
	   SIGMA)
  
	  ((AND (SETQ THETA (UNIFY H% C)) (ANS THETA) 
		(or (and *pl* (format t "~% Match C and H with MGU: ~s ~%" theta))t)
                (report&options yet c theta)
		(SETQ SIGMA (PROVE-YET THETA)))
	   ;; match  
	   (COMPOSE THETA SIGMA))
 
	  ((AND 
	    (OR (EQUAL C '(TRUE))(equal c '(t))(eq c t)(EQUAL H% '(FALSE)) 
		(and (eq '& (car h%)) (MEMBER '(FALSE) H%)) (equal c '(<= 0)))
	    (ANS T) 
	    (report&options yet c t)
	    (SETQ SIGMA (PROVE-YET T)))
	   ;; rule 1 
	   SIGMA)
  
	  ((AND (ATOM C) C) (ANS NIL))
  
	  ((AND *ancestry-light* (SETQ THETA (ANCESTER C))
		(ANS THETA) 
		(ANS 'ANCESTRY '= '= '= 'BY)
		(SETQ SIGMA (PROVE-YET THETA)))
	   ;; rule 2: ancestry 
	   (COMPOSE THETA SIGMA))
 
	  ((and (equal h# 3) (HIGHER-GOAL-FAILURE C))
	   ;; rule 2: ancestry 
	   (ANS 'HGF '= '= '= 'BY)
	   (ANS NIL))
 
	  ((AND (equal h# 3) *BC-DEPTH-LIGHT*
		(< *BC-DEPTH-LIMIT* (LENGTH TL))
		(< *BC-DEPTH-LIMIT* (BACK-CHAIN-DEPTH TL)))
	   ;; IF THE NUMBER OF TIMES THE SAME HYPOTHESIS HAS BEEN USED
	   ;;  EXCEEDS THE BACK-CHAIN LIMIT THEN FAIL THE SUBGOAL 
	   (PRINT '(EXCEEDED BACK-CHAIN-LIMIT))
	   NIL)
  
	  ((AND (member h# '(2 3 4)) %REDUCE-LIGHT% 
		(OR (AND (NOT (EQUAL C (SETQ C (REDUC C 'T))))
			 (SETQ %GOAL-MESSAGE% 'REDUCE-C))
		    (AND (NOT (EQUAL H% (SETQ H%% (REDUC H% NIL))))
                         (setq H (subst H%% H% H :test 'equal))
			 (SETQ %GOAL-MESSAGE% 'REDUCE-H))
		    (SETQ %REDUCE-LIGHT% NIL)))
	   ;; rule 5: reduce 
	   (IMPLY H C (APPEND TL '(R)) ANC LT YET))

	  ((and *VE-light* (pure-inequality-goal C) 
		(setq B (inequality-prove h c tl anc lt yet)))
	   ;; If C is a all-inequality goal and *VE-light* is not nil 
	   ;;   then go Inequality-prover. Note also Rule 11 below; there only
           ;;   the goal C needs to be an inequality formula.
	   B)

	  ((EQ '-> (CAR C))
	   ;; rule 7: promote 

           (setq H (and-on-h H (cadr C)))
	   (and (setq gu (ground-units-g (cadr C)))
		(setq H (ground-units-forward-chain H gu)))        ;29June92
;;         (cond ((and (occur 'or (cadr C)) *or-out-light*)    ;removed 24Mar92
;;                (setq H (mapcar #'or-out H))
;;                (setq H (mapcar #'(lambda (H*) 
;;                       (cond ((occur 'or (cdr H*)) (reduc** H*)) (t H*)))
;;                                H))))
	   (SETQ %GOAL-MESSAGE% 'PROMOTE)
	   (IMPLY H (CADDR C) (APPEND TL '(P->)) ANC LT yet))

          
;;((break))
          ((and (not (atom H%)) (eq '& (car H%)) *or-out-light* 
                                                  ;H=(& A ... (or D E ...) ...)
(or (prnt H% C) t)  (or (break) t)
		(some #'(lambda (H*) (eq 'or (car (setq H2 H*)))) (cdr H%)))
                 ;; prepare for rule 4 (cases) next round, with or-out
                                                              ;H2= (or D E ...)
(prnt H% C) (break)
	   (setq H*1 (and-on (cadr H2) (remove H2 H% :test 'equal)))
                                          ;H*1=(& A ... D ...)
	   (setq LP  (last-part H2))      ;LP =(or E ...)
	   (cond ((eq-car LP '&) 
		  (setq LP (cons '& (mapcar #'(lambda (u) (list 'sub-here u))
					    (cdr LP)))))
		 (t (setq LP (list 'sub-here LP))))

	   (setq H*2 (and-on LP (remove H2 H% :test 'equal)))

           (setq H%% (or-on (and-on H*1 (remove H2 H% :test 'equal))
			    (and-on H*2 (remove H2 H% :test 'equal))))
                                                             ;changed 28Apr92
	   (setq H%% (reduc H%%))
	   (setq H (subst H%% H% H :test 'equal))
	   (imply H C TL ANC LT Yet)
	   )
          
          ((and (member h# '(2 3)) (EQ 'OR (CAR H%)) *or-out-light*)
	   ;; rule 4: cases    
           (cases Lt H% h#))

          ((and (not (atom H%)) (eq '& (car H%)) *or-out-light*    ;28Mar92
		(some #'(lambda (H*) 
                   (and (eq-car H* '->) (eq 'or (car (setq H2 (caddr H*))))
			(setq H3 H*)))
                               ;H3=H*= (-> H1 (or D E ...)) H2= (or D E ...)
		      (cdr H%)))
	   (setq H*1 (subst (cadr H2) H2 H3 :test 'equal))
	   (setq H*2 (list 'sub-here (subst (last-part H2) H2 H3 
		                               :test 'equal)))

           (setq H%% (or-on (subst H*1 H3 H% :test 'equal)     ;changed 21Apr92
			    (subst H*2 H3 H% :test 'equal)))

	   (setq H%% (reduc H%%))
	   (setq H (subst H%% H% H :test 'equal))
	   (imply H C TL ANC LT Yet)
	   )

	  ((EQ '& (CAR C))
	   ;; rule 3: and-split 
           (and-c lt))

	  ((and (EQ 'OR (CAR C)) (not (equal h# 1)))
	   ;; rule 6: or-fork   ;Dont do or-fork in USE Lemma case
	   (COND ((and (not (atom (cadr C))) 
		       (not (member (caadr c) '(< <=)))
		       (NOT (EQUAL C (SETQ C* (AND-OUT C)))))
		  (IMPLY H C* TL ANC LT yet))
		 ((SETQ THETA
			(IMPLY (AND-ON-h H (NOT-FORMULA (LAST-PART C)))
			       (CADR C) (APPEND TL '(OR1))
			       ANC LT yet))
		  (ANS THETA))
		 (T (IMPLY (AND-ON-h H (NOT-FORMULA (CADR C)))
			   (LAST-PART C) (APPEND TL '(OR2))
			   ANC LT yet))))

	  ((AND (ATOM H) H) (ANS NIL))

	  ((EQ '<-> (CAR C))
	   ;; RULE 8. 
	   (IMPLY H 
		  (AND-ON (LIST '-> (CADR C) (CADDR C))
			  (LIST '-> (CADDR C) (CADR C)))
		  TL ANC LT yet))

	  ((AND *VE-light* (member (car c) '(< <=) :test 'equal)
		(setq b (inequality-prove h c tl anc lt yet)))
	   ;; rule 11: inequality  -- This allows VE, etc
	   b)

	  ((SETQ B (MATCH H% h#)) 
	   ;; rule 12: match  
	   B)
	  ((SETQ B (BACK-CHAIN H% h#)) 
	   ;; rule13: back-chain  
	   B)
	  ((setq B (Pairs C H% h#)) B)	;Peek-pairs back-chaining

	  ((and *back-<chain-light*  (SETQ B (BACK-<CHAIN H% h#))) 
            ;;Ordinary back-chaining using  < and <= chaining.
           B)
;;((and (equal 3 H#) (or (format t "~%break at Sub=~%") t)(break)))  
	  ((SETQ B (SUB= H%)) 
	   ;; RULE 14: SUBSTITUTION OF EQUALS  
	   B)
;;$$
	  ((AND (eq h# 4) (EQ '= (CAR C)) 
                (SETQ THETA (UNIFY (CADR C) (CADDR C)))
		(ANS THETA) (SETQ SIGMA (PROVE-YET THETA)))
	   ;; rule 9 
	   (COMPOSE THETA SIGMA))
  
	  (NIL 
	   ;; rule 14H 
	   )

	  ((and *flip* (EQ 'NOT (CAR C)))
	   ;; RULE 10: FLIP-C 
	   (SETQ H (AND-ON-h H (CADR C)))
	   (SETQ C NIL)
	   (SETQ %GOAL-MESSAGE% 'FLIP-C)
	   (IMPLY H C TL ANC LT YET))
	  ((and *flip* (EQ 'NOT (CAR H%)))
	   ;; rule 15: flip-h 
	   (SETQ %GOAL-MESSAGE% 'FLIP-H)
	   (setq H (subst nil H% H :test 'equal))
	   (IMPLY H (OR-ON (CADR H%) C) TL ANC LT YET))
	  ((AND *flip* (EQ '& (CAR H%))
		(SETQ W
		      (SOME #'(lambda(H*) 
				(AND (EQ 'NOT (CAR H*)) H*))
			    (CDR H%))))
	   ;; rule 15: flip-h 
	   (SETQ H%% (DELETE-& W H%))
	   (SETQ C (OR-ON (CADR W) C))
	   (SETQ %GOAL-MESSAGE% 'FLIP-H)
	   (setq H (subst H%% H% H :test 'equal))
	   (IMPLY H C TL ANC LT YET))

	  ((AND (NOT (EQUAL C (SETQ C* (DEFINE C 'T)))) C*)
	   ;; rule 16: Define-C 
	   (SETQ %GOAL-MESSAGE% 'DEFINE-C)
	   (SETQ %REDUCE-LIGHT% T)
	   (IMPLY H C* (APPEND TL '(D)) ANC LT yet))
;;	  ((and (eq '= (car c))                  ;removed 26Mar92
;;		(or (and (not (atom (cadr  c))) (eq '+ (caadr  c)))
;;		    (and (not (atom (caddr c))) (eq '+ (caaddr c)))))
;;	   (prove= c))                  ;see reduce.lisp
	  (T (ANS NIL)))))

  
(DEFUN ADD1-TL (TL)  ;USED-IN and-split and cases (IMPLY-RULES)
  ;; This adds one to the last interger in the TL
       (SETQ TL (REVERSE TL))
  (COND ((NUMBERP (CAR TL)) (REVERSE (CONS (1+ (CAR TL)) (CDR TL))))
        (T (REVERSE TL))))

(DEFUN ADD-TO (L C)  ;USED-IN (IMPLY-RULES)
  (COND ((MEMBER C L :test #'equal) L) ((NOT C) L) 
                           (T (CONS C L))))

(DEFUN ADD1-MOD10 (N) ;USED-IN (REPLACE-VARIABLES)
                      ;  (Prove-the-premise,back-chain)
  (COND ((< N 10.) (1+ N)) (t (1+ (+ N -10.)))))

(DEFUN ALL-VARIABLES-IN (A)   ;used in NEW-BINDINGS, (DEFINE,REDUC)
  ;; THIS IS THE SET OF ALL VARIABLES - GROUND OR NOT - IN A 
  (CRUNCH (ALL-VARS-IN (COPY-TREE A))))

(DEFUN ALL-VARS-IN (A)    ;used in ALL-VARIABLES-IN
  (cond ((atom a) 
         (cond ((numberp a) nil)
	       ((member a *constant-list*) nil) 
	       (t (list a))))
        ((atom (car a))
         (cond ((null (cdr a)) 
                (cond ((member (car a) *constant-list*) nil) (t a)))
	       (t (mapcan #'all-vars-in (cdr a)))))
        (t (append (all-vars-in (car A)) (all-vars-in (cdr A))))))

(defun and-c (lt)   ;Called by IMPLY-RULES*
  (declare  (special h c tl anc lt yet))
  (declare  (special &exclude&))  
  (let (c* c1 c2 Lt* YET-UNIT)
       (cond (*order-c* (setq c* (cons '& (And-C-Reorder-c (cdr c)))))
	     (t (setq *order-c* nil) (setq c* c)))        ;26Mar92
       (setq c1 (cadr c*))
       (setq c2 (last-part c*))
       (and *pl* (not *jr-light*)(format t "~% SPLIT-C: NEW-C:   ~S ~%" c1))
       (setq Lt* (COND ((EQ 'DETAIL-2 LT) 'DETAIL-3)
		       ((MEMBER LT '(QED DETAIL)) LT)
		       (T lt)))
       (SETQ YET-UNIT 
	     (LIST T H (LIST 'SUB-HERE c2)
		   (APPEND TL (LIST 2)) ANC LT* 'C*))
       (IMPLY H c1 (APPEND TL (LIST 1)) ANC LT*
		  (CONS YET-UNIT YET)) ))

(defun And-C-Reorder-c (L)		;called by and-c. 
  ;;Reorder the list L so that fewer free variables and more skolem 
  ;; objects are preferred
  (let (L2)
    (cond ((eq-car L '&) (return-from and-c-reorder-c 
                              (cons '& (and-c-reorder-c (cdr L))))))
    (setq L2 (copy-tree L))
    (setq L2 (mapcar #'(lambda (x) (list x (length (free-variables-in x))
         				   (length (no-cdrs x)))) L2))
    (setq L2 (sort L2 #'and-C-R-predicate))
    (setq L2 (mapcar #'car L2))))

(defun and-C-R-predicate (x y)   ;called by And-C-reorder-c
  (let (v1 v2 L= o1 o2)
    (cond ((and (eq-car (car x) '=) (>= (caddr x) (caddr y))) t)
	  ((and (eq-car (car y) '=) (>= (caddr y) (caddr x))) nil)

	  ((zerop (setq v1 (cadr x))) t) ;prefer ground
	  ((zerop (setq v2 (cadr y))) nil)
	  ((and (eq-car (car x) '=)(eq-car (car y) '=))
	   (setq L= (list (cdr x) (cdr y)))
	   (equal L= (and-c-reorder-c L=)) )
	  ((eq-car (car x) '=) t)	;prefer the = predicate
	  ((eq-car (car y) '=) nil)
	  ((> (setq o1 (caddr x)) (setq o2 (caddr y)))t)
	  ((< o1 o2) nil)		;prefer more objects
	  ((< v1 v2) t)
	  ((< v2 v1) nil)		;prefer fewer free vars
	  (t t))))
 

;;;*********************************************************************
;;;
;;;                     PROVE.LISP    In KCL
;;;                                 20 Aug 87,  30  Mar 87  
;;;               W. W. Bledsoe     30 January 1987  25 Feb 1989  2 Mar 90
;;;
;;;             This is the main routine of IMPLY.LISP
;;;                   Call  (PROVE Theorem)
;;;           to INTERACTIVELY prove the theorem Theorem
;;;     Now divided into four parts:  PROVE1,PROVE2,PROVE3.LISP,PROVE4.LISP
;;;          for ease of compiling  (This is PROVE2.LISP)       
;;;
;;;***********************************************************************

(DEFUN ANCESTER (C)	  ;used by IMPLY-RULES
  ;;Rule 2, ANCESTRY   If C is the negation to a higher goal, return T
  ;;or a MGU
  (declare  (special h c tl anc lt yet))
  (SOME #'(LAMBDA (Q) (COND ((EQ (QUOTE NOT) (CAR C)) (EQUAL (CADR C) Q))
                             (T (EQUAL C (LIST (QUOTE NOT) Q)))))
        ANC) )

(defun and-off (A B)  ;used by PROVE-THE-PREMISE
;; e g, (and-off (& a b c d) (& b e d f))  =  (& a c)
 (let (D)
  (COND ((null A) nil)
	((null B) A)
        ((equal A B) nil)
        ((and (not (atom A)) (eq '& (car A)))
         (cond ((and (not (atom B)) (eq '& (car B)))
                (cond ((null (setq D (set-difference (cdr A) 
                                              (cdr B) :test 'equal))) nil)
                      ((null (cdr D)) (car D)) (t (cons '& D)) ))
               ((member B (cdr A) :test 'equal)
                (setq D (remove B A :test 'equal))
                (cond ((null (cdr D)) nil) 
                       ((null (cddr D)) (cadr D))
                       (t D)))
                (t A)))
        ((and (not (atom B)) (eq '& (car B)))
         (cond ((member A (cdr B) :test 'equal) nil) (t A)))
        ((equal A B) nil)
        (t A) )))

(DEFUN AND-ON (A B)    ;widely used  ;USED-IN  (AND-ON-LIST APPLY 
                      ;BACK-CHAIN-> BACK-CHAIN-O COUNTEREXAMPLE IMPLY-RULES
		      ;INDUCTION OPTIONS PPP PROVE-THE-PREMISE* USE)
  ;; e g, (and-on (& c d) (& e f))  =  (& c d e f)
  (COND ((EQ T A) B)
	((EQ T B) A)
	((NULL A) B)
	((NULL B) A)
        ((equal B '(empty)) A)
	(T (CONS '&
		 (UNION-W (COND ((AND (NOT (ATOM A)) (EQ '& (CAR A))) (CDR A))
			      (T (LIST A)))
			(COND ((AND (NOT (ATOM B)) (EQ '& (CAR B))) (CDR B))
			      (T (LIST B))))))))

(defun and-on-h (H* A &optional H% U)
  ;;this adds the appropriate parts of A to the components of H* ~ H%
  ;; H* has the form: (USE h-gu H= Hv),
  ;; where USE the current hypothesis designated by the USE command,
  ;;       h-gu is the conjunction of non-equality ground units of H,
  ;;       H=   "   "     "        "      equality   "      '   '  ",
  ;;             or units of the form (= (x) tt) where (x) is ground 26Mar92
  ;;       Hv   is the remainder of H. (v stands for "variable").
  ;;Remove members of H% from components of H, if any.
  ;;If U is non-NIL then place non-ground part of A in USE
  (let (gu USE* h-gu* H=* Hv* A*)
       (setq A (and-on-h-reduce A))
       (cond (H% (setq H* (mapcar #'(lambda (u) (and-off u H%)) H*))))
       (setq gu (ground-units A '=))
       (setq H=* (and-on gu (caddr H*)))
       (setq A* (and-off A gu))
       (setq gu (ground-units A* nil t))
       (setq h-gu* (and-on gu (cadr H*)))
       (setq A* (and-off A* gu))
       (cond (U (setq USE* (and-on A* (car H*))) (setq Hv* (cadddr H*)))
             (t (setq Hv* (and-on A* (cadddr H*)))(setq USE* (car H*))))
       (list USE* h-gu* H=* Hv*) ))

(defun and-on-h-reduce (A)    ;called by and-on-h     29June92
  ;;just reduce double &'s
  (let (u)
    (cond ((atom A) A)
	  ((eq-car A '&) 
	   (cond ((null (cdr A)) t)
		 ((null (cddr A)) (and-on-h-reduce (cadr A)))
		 (t (and-on (and-on-h-reduce (cadr A))
			    (and-on-h-reduce (cons '& (cddr A)))))))
	   (t A))))

(DEFUN AND-OR-ON (SYM A B)   ;used by NEW-VARS
  ;; eg,  (AND-OR-ON  & (& c d) (& e f))  =  (& c d e f)
  (COND ((EQ '-> SYM) (LIST SYM A B))
	(T (SETQ A
		 (COND ((OR (ATOM A) (NOT (EQ SYM (CAR A)))) (LIST A))
		       (T (CDR A))))
	   (SETQ B
		 (COND ((OR (ATOM B) (NOT (EQ SYM (CAR B)))) (LIST B))
 		       (T (CDR B))))
	   (CONS SYM (UNION-W A B)))))

(DEFUN AND-OR-OUT (L)     ;used by AND-OUT
  (let (W)
       (COND ((EQUAL L (SETQ L (MAPCAN #'(LAMBDA (A)
	        (COND ((SETQ W (SOME #'(LAMBDA (Q) (AND (EQ '& (CAR Q)) Q))
				     (CDR A)))
		       (MAPCAR #'(LAMBDA (R) (SUBST= R W A)) (CDR W)))
		      (T (LIST A))))
				       L)))
	      (AND-ON-LIST L))
	     (T (AND-OR-OUT L)))))

(DEFUN AND-OUT (A)    ;used in PROVE & IMPLY-RULES
  (COND ((ATOM A) A) ((EQ 'OR (CAR A)) (AND-OR-OUT (LIST A))) (T A)))

(defun and&or-out (A &optional (P t))
  (cond ((atom A) A)
        ((eq '-> (car A))
         (setq A (list '-> (and&or-out (cadr A) (not P))
                   (and&or-out (caddr A) P)))
         (cond ((and (not P) (not (atom (caddr A))) (eq 'or (caaddr A)))
                (or-on (imp-on (cadr A) (cadr (caddr A)))
                       (imp-on (cadr A) (caddr (caddr A)))))
               (t A)))
        ((eq 'not (car A)) (list 'not (and&or-out (cadr A) (not P))))
        ((and (member (car A) '(& or))
         (setq A (cons (car A) (mapcar #'(lambda (u) 
                                   (and&or-out u P)) (cdr A))))  nil))
        ((and (eq '& (car A)) (not P)) (or-out A))
        ((and (eq 'or (car A)) P) (and-out A))
        ((member (car A) '(some all))
         (list (car A) (cadr A) (and&or-out (caddr A) P)))
        (t A)))

(defun and-remove (H)  ;29June92
  (cond ((null H) nil) ((eq-car H '&) (cdr H)) (t (list H))))

(DEFUN ANS (THETA &optional H2 C2 TL2 RET)
       ;;USED-IN (AND-C BACK-CHAIN BACK-CHAIN* BACK-CHAIN-O IMPLY-RULES MATCH 
       ;;OPTIONS OR-H SUB= WRITE-GOAL-MESSAGE)
       ;;  After 6/88 %proof-list% not used.
       (declare  (special h c tl anc lt yet))
       (setq H2 (list H2 C2 TL2 REt))   ;1Mar90 Only to avoid compiling remarks
       (COND ((AND (NULL THETA) *OMIT-NIL-PROOF-LIGHT*) nil)
	     (T                                       
#|	      (SETQ %PROOF-LIST%                        ;From here 
		    (CONS 
		     (list 'format 't "~A ~15t ~s ----> 
                                ~21t ~s ~44t ~s ~53t ~a	~2%"
			   (list 'quote (cond (tl2 tl2) (t tl)))
			   (cond (h2 (list 'quote h2)) 
				 (t  (list 'quote 'H)))
			   (list 'quote (cond (c2 c2) (t c)))
			   (list 'quote (cond (ret ret) (t 'returns)))
			   (list 'quote theta))
		     %PROOF-LIST%))         |#            ;to here
              theta))) 

(DEFUN APPLY-substitution (THETA D)	;widely used
       ;; the substitution THETA is applied to the form D
       (COND ((EQ T THETA) D)
	     ((TWO-XS THETA NIL)
	      (PROG (X2)
		    (SETQ X2 (TWO-XS THETA))
		    (RETURN (reduc (AND-ON (APPLY-SUBSTITUTION (CAR X2) D)
					    (APPLY-SUBSTITUTION (CADR X2) D))))))
	     (T (SUBLIS= THETA D))))

(DEFUN APPLY-SUBSTITUTION-RESTRICTED (THETA YET-UNIT) ;USED BY PROVE-YET
  ;; The members of YET-UNIT are left unchanged, except for those of the
  ;; form  (SUB-HERE u), which are changed by applying the substitution
  ;; THETA to u.   For example, 
  ;;   (APPLY-SUBSTITUTION-RESTRICTED ((X B)) ( (A) (SUB-HERE (P x)) C D))
  ;; returns  ( (A) (P (B)) C D)
  (apply-sub-r theta yet-unit) )

(DEFUN APPLY-SUB-R (THETA A)    ;called by APPLY-SUBSTITUTION-RESTRICTED
  (cond ((atom A) A)
	((eq-car A 'sub-here) (apply-substitution theta (cadr A)))
	(t (cons (apply-sub-r theta (car A))
		 (apply-sub-r theta (cdr A))))))
 
(DEFUN ASSOC* (SYM A P)   ;used by INFIX->PREFIX (only)
  ;; THIS ACCEPTS A LIST A = (A1 - - AK SYM AK+1 - - AN) AND RETURNS ((A1 - -
  ;;  AK) (AK+1 - - AN)) 
  (COND ((NULL A) NIL)
        ((EQUAL SYM (CAR A)) (LIST P (CDR A)))
	(T (ASSOC* SYM (CDR A) (CONS (CAR A) P)))))

(DEFUN ATOMS-IN (A)      ;used by NEW-VARIABLES
  ;;Same as Variables-in, except that here we allow the functions symbols too
  ;; ie, (atoms-in (f (g x) y)) = (f g x y), (Variables-in (f (g x) y))=(x y)
  (CRUNCH (ATOMS-I A)))

(DEFUN ATOMS-I (A)     ;used by ATOMS-IN (only)
  (COND ((numberp A) nil)
	((null A) nil)
	((ATOM A) (LIST A))
	(T (UNION-W (ATOMS-IN (CAR A)) (ATOMS-IN (CDR A))))))

(DEFUN BACK-CHAIN (H% h# &optional tp use-bc C* (HH H%) Hn also)
  ;; USED-IN (IMPLY-RULES), tp = triplet                  also 4July92
  ;; RULE 13. 
  ;; Eg, if   H% = (&  (-> h1 c1)  (-> h2 c2)  (-> h3 c3) )
  ;;     and  C = c,   and (mgu c c1) is THETA
  ;;     then the next subgoal to prove is H% --> h1 THETA, etc.

 (declare  (special h c tl anc lt yet))

 (setq Hn (cond (Hn Hn) ((atom H%) nil) ((eq '& (car H%)) nil) (t H%))) 

 (LET (THETA LAMBDA B* H** Hn* C** also*)
(prnt h# H% C)
  (COND ((ATOM H%) nil)
        ((AND (SETQ THETA (UNIFY-tp H% C tp))
              (cond (tp (setq C** (and-on (cadr theta) C*))
                        (setq theta (car theta))
                        (or (and *pl* (not *jr-light*) 
				 (format t "~%Peek-Pairs")) t))
                    (t (setq C** C*)))
              (setq Lambda (cond ((and %al% use-bc) (list C* theta))
                                 (t (prove-the-premise Hn HH theta C** h# also)))))
         Lambda)

        ((eq '-> (car H%))
         (setq C** (and-on (cadr H%) C*))
         (back-chain (caddr H%) h# tp use-bc C** HH Hn))

        ((eq '& (car H%))
         (setq HH (cond (HH HH) (t H%)))
         (or (some #'(lambda (H*) (setq Hn* (cond (Hn Hn) (t H*)))
		                  (setq also* (and-off H% H*))   ;4July92 also
		       (setq theta 
			     (back-chain H* h# tp use-bc C* HH Hn* also*)))
		   (cdr H%))
             (and (assoc-r '= H%)    ;see replace.lisp for assoc-r defn
                  (setq H** (bc-apply= H%))
                  (not (equal H** H%))
                  (some #'(lambda (H*) (setq Hn* (cond (Hn Hn) (t H*)))
		       (setq theta 
			     (back-chain H* h# tp use-bc C* HH Hn*)))
		   (cdr H**))))
         theta)
      
        ((EQ 'OR (CAR H%))    
         (SOME #'(LAMBDA (H*) (SETQ B* (DELETE-ONE H* H%))
	                      (SETQ C** (AND-ON (NOT-ON B*) C*))
                              (setq theta 
                                    (back-chain H* h# tp use-bc C** HH Hn)))
               (cdr H%))
         theta)


        ((and (eq '-> (car H%)) (EQ '-> (CAADDR H%)))
          ;;eg, H% = (-> H1 (-> H2 C1))
	 (SETQ H** (LIST '-> (AND-ON (CADR H%) (CADR (CADDR H%)))
		             (CADDR (CADDR H%))))
         (BACK-CHAIN H** h# tp use-bc C* HH Hn)) )))

(defun bc-apply= (L)      ;Called by Back-chain
  ;;L has the form (& u u u (= a b) u u).
  ;;The result is gotten by substituting a for b or b or a in the rest of L.
  (let (U L* pr)
       (cond ((setq U (assoc-r '= L))
              (setq pr (bc-order (cadr u) (caddr u) L))
              (setq L* (delete u (copy-tree L) :test 'equal))
              (setq L* (subst= (car pr) (cadr pr) L*))
              (bc-apply= L*))
             (t L))))

(defun bc-order (a b L)            ;Called by bc-apply (back-chain)
  (cond ((numberp a) (list a b))
        ((numberp b) (list b a))
        ((occur a b) (list a b))
        ((occur b a) (list b a))
        ((occur a L) (list b a))
        ((occur b L) (list a b))
        (t           (list a b))))

(DEFUN BACK-<CHAIN (H% h# &optional tp use-bc C* (HH H%) Hn) 
  ;; Called by IMPLY-RULES*
  ;; RULE 11.  Essentially the same as BACK-CHAIN, except <CHAIN is used
  ;;  instead of UNIFY.  Ie, it does inequality chaining instead of unifying.
  ;; Eg, if   H% = (&  (-> h1 (< b c1))  (-> h2 c2)  (-> h3 c3) )
  ;;     and  C = (< c d),   and (mgu c c1) is THETA
  ;;     then the next subgoal to prove is H% --> (& (< b d) h1) THETA

 (declare  (special h c tl anc lt yet))

  (COND ((OR (ATOM H%) (ATOM C) (NOT (MEMBER (CAR C) '(< <=))))
         (RETURN-FROM BACK-<CHAIN NIL)))

 (setq Hn (cond (Hn Hn) ((atom H%) nil) ((eq '& (car H%)) nil) (t  H%)))

 (LET (L THETA LAMBDA B* H** Hn*)
  (COND ((AND (SETQ L (<chain H% C))            ;eg, H% = (< b c)
	      (setq Lambda (prove-the-premise-S Hn HH L C* h#)))
	 Lambda)

	((eq '-> (car H%))
	 (setq C* (and-on (cadr H%) C*))
	 (back-<chain (caddr H%) h# tp use-bc C* HH Hn))

	((eq '& (car H%))
	 (setq HH (cond (HH HH) (t H%)))
	 (some #'(lambda (H*) (setq Hn* (cond (Hn Hn) (t H*)))
		   (setq theta 
			 (back-<chain H* h# tp use-bc C* HH Hn*)))
	       (cdr H%))
	 
	 theta)
      
	((EQ 'OR (CAR H%))    
	 (SOME #'(LAMBDA (H*) (SETQ B* (DELETE-ONE H* H%))
			 (SETQ C* (AND-ON (NOT-ON B*) C*))
			 (setq theta 
			       (back-<chain H* h# tp use-bc C* HH Hn)))
	       (cdr H%))
	 theta)


	((and (eq '-> (car H%)) (EQ '-> (CAADDR H%)))
	 ;;eg, H% = (-> H1 (-> H2 C1))
	 (SETQ H** (LIST '-> (AND-ON (CADR H%) (CADR (CADDR H%)))
			 (CADDR (CADDR H%))))
	 (BACK-<CHAIN H** h# tp use-bc C* HH Hn)) )))


(DEFUN BACK-CHAIN-DEPTH (TL)		;USED-IN (IMPLY-RULES)
       ;; This calculates the maximum number of times that the same symbol
       ;; occurs in the theorem-label TL

       (CAR 
	 (SORT 
	  (MAPCAR #'(LAMBDA (X) 
	    (LENGTH (mapcan #'(LAMBDA (Y) (if (EQUAL X Y) (list x) nil) )
					    TL)))
		  TL) '>)))

(defun binary-to-unary< (TH)   ;called by PROVE-EXECUTOR
  ;; It converts all inequality atoms of the form (< a b) to (< (+ a (-b)))
 (let (L)
  (cond ((atom TH) TH)
       ((member (car TH) '(< <=)) 
	(cond ((null (cddr TH)) TH) 
	      (t (setq TH (list (car TH) 
                                 (list '+ (cadr TH) (list '- (caddr TH)))))
                 (setq TH (reduce-algebraically TH))
                 (setq L (sort (cadr TH) 'negs-last))
                 (list (car TH) L)) ))
       (t (cons (binary-to-unary< (car TH)) (binary-to-unary< (cdr TH)))) )))
 
(defun bound-variables-in (A)     ;Called by PROVE-executor
  (cond ((atom A) nil)
        ((member (car A) '(all some set-of union-of-sets intersection-of-sets))
         (cons (cadr A) (bound-variables-in (caddr A))))
        (t (union-w (bound-variables-in (car A)) 
		    (bound-variables-in (cdr A))))))

(DEFUN BRACKETS (N)        ;USED-IN (BACK-CHAIN-O PROVE-THE-PREMISE)
    (values (read-from-string (format nil "\\\[~a\\\]" n))))
 
(defun cases (Lt H% h#)   ;Called by IMPLY-RULES*
  ;;H% NOW has the form (OR ....)   27July92
  ;;eg, H% = (& (OR (A Z) (B Z)) (P X)) is first converted to
  ;;         (OR (& (A Z) (P X)) (& (SUB-HERE (B Z)) (P X)))  in H and then
  ;; or-split. Then using the hyp (& (A Z) (P X)) first to get a theta, and
  ;; on the second goal, theta is applied ONLY to (B Z) and not to (P X).
  (declare  (special h c tl anc lt yet))
  (declare  (special &exclude&))  
  (let (Lt* YET-UNIT FPH LPH LP)
    (and *pl* (not *jr-light*)(format t "~% SPLIT-H:NEW-H: ~%~s~%" (cadr h%))) 
    ;;update the ground-units, h-g
    (setq FPH (and-on-h H (cadr H%) H%))
    (setq LP (last-part H%))
    (cond ((occur 'sub-here LP) nil)   ;sub-here already put in in IMPLY-RULES*
	  (t (setq LP (list 'sub-here LP))))  

;;    (setq LPH (subst LP H% H :test 'equal))             ;changed 24Mar92
;;(print 'cases) (break)                  ;(format t "~% ~s~%" (short-sko LP))
    (setq LPH (and-on-h H LP H%))                       ;changed 17July92
;;(break)                                 ;(format t "~% ~s~%" (short-sko LPH))
                                                                    
    (setq Lt* (COND ((EQ 'DETAIL-2 LT) 'DETAIL-3)
		    ((MEMBER LT '(QED DETAIL)) LT)
		    (T lt)))
    (SETQ YET-UNIT 
	  (LIST T LPH C 
		(APPEND TL (LIST 'H2)) ANC LT*
		(cond ((equal h# 2) 'h-gu*) (t 'H*))))
    (IMPLY FPH C (APPEND TL (LIST 'H1)) ANC LT*
	   (CONS YET-UNIT YET))))

(DEFUN CDRS (SIG) ;USED-IN (PROVE-THE-PREMISE)
  (COND ((ATOM SIG) NIL) (T (MAPCAR 'CDR SIG))))

(DEFUN CHOOSE (A B)   ;used by SUB=
  (declare  (special h c tl anc lt yet))
  (COND ((NUMBERP A) A)
	((NUMBERP B) B)
	((OCCUR B A) B)
	((OCCUR A B) A)
	((OCCUR A C) B)
	((OCCUR B C) A)
	((OCCUR A H) B)
	((OCCUR B H) A)
 	(T A)))

(DEFUN <CHAIN (B C) ;called by INEQUALITY-CHAIN
  #| This accepts the two literals B = (< t1 t2)  and  C = (< t3 t4)
     and tries to chain them in various ways, returning the list L
     of pairs (THETA C2) for each subgoal C2 obtained by such
     chaining.  (Similarly for <=)
     For example, if B = (< (f x) 5)  and  C = (< (f (a)) (c))
     then this would return the list ( (THETA C2) ) where 
     THETA IS ((x a)) and C2 is (<= 5 (c))  
  |#
  (cond ((or (atom b) (atom c) 
             (not (member (car b) '(< <=))) (not (member (car b) '(< <=))))
         (return-from <chain nil)))

  (LET (SIGN BL CL BL* CL* BL2 CL2 L THETA C2 C3)

       (SETQ SIGN (COND ((EQ (CAR B) (CAR C)) '<=) 
                        ((EQ '< (CAR C)) '<)  (T '<=)))

       (SETQ BL (cond ((cddr b) 
                       (MINUS-ON-REDUCE (CADR B) (CADDR B)))(t (cadr b))))
       (setq BL (cond ((atom BL) (list '+ BL)) ((eq '+ (car BL)) BL)
                      (t (list '+ BL))))

       (SETQ CL (cond ((cddr c) 
		       (MINUS-ON-REDUCE (CADR C) (CADDR C)))(t (cadr c))))
               ;(< a b) goes to (+ a (- b))
       (setq CL (cond ((atom CL) (list '+ CL)) ((eq '+ (car CL)) CL)
                      (t (list '+ CL))))

       (SETQ BL* (cdr BL))       ;(+ a (- b)) goes to (a (- b))
       (SETQ CL* (cdr CL))       ;(+ a (- b)) goes to (a (- b))

       (SETQ L (MAPCAN #'(LAMBDA (X) 
                   (MAPCAN #'(LAMBDA (Y)
 	            (COND ((or (atom x) (atom y)) nil) ;Dont chain on variable
			  ((or (and (eq '- (car x)) (atom (cadr x)))
			       (and (eq '- (car y)) (atom (cadr y)))) nil)
			  ((SETQ THETA (UNIFY X Y))
			   (SETQ BL2 (apply-substitution theta (REMOVE1 X BL)))
			   (SETQ CL2 (apply-substitution theta (REMOVE1 Y CL)))
			   (setq c2 (MINUS-ON-REDUCE CL2 BL2))
			   (cond ((and (not (atom C2)) (eq '+ (car c2)))
				  (setq c3 (reduce-alg (cdr c2)))
				  (setq c2 (reduc* (cons '+ c3))))
				 (t t))
			   (SETQ C2 (LIST SIGN C2))
			   (LIST (LIST THETA C2)) ) ))
                           CL*))
                       BL*))
        (cond (L (and *pl* (format t "~%Inequality-chaining succeeded with ~s pairs ~%"
                    (length L)))))
        L

        ) )



(DEFUN <CHAIN-ON (B C E) ;called by REPLAC --  Like <CHAIN    6/89
  #| This accepts the two literals B = (< t1 t2)  and  C = (< t3 t4),
     and a term E, and tries to chain B against C upon E, returning the first
     pairs (THETA C2) obtained by such chaining.  (Similarly for <=)
     For example, if B = (< (f x) 5),  C = (< (f (a)) (c)), and E = (f (a)),
     then this would return the pair (THETA C2), where THETA IS ((x a)) 
     and C2 is (<= 5 (c))  
  |#
  (cond ((or (atom b) (atom c) 
             (not (member (car b) '(< <=))) (not (member (car b) '(< <=))))
         (return-from <chain-on nil)))
  (cond ((or (atom E) (and (eq '- (car E)) (atom (cadr E))))
         (print '(Dont chain on Variables)) (return-from <chain-on nil)))

  (LET (SIGN BL CL BL* BL2 CL2 W THETA C2 C3 e*)

       (SETQ CL (cond ((cddr c) 
		       (MINUS-ON-REDUCE (CADR C) (CADDR C)))(t (cadr c))))
               ;(< a b) goes to (+ a (- b))
       (setq CL (cond ((atom CL) (list '+ CL))
                      ((eq '+ (car CL)) CL)
                      (t (list '+ CL))))

       (cond ((member e CL :test 'equal) (setq e* e)) 
             ((member (setq e* (reduc* (list '- e))) CL :test 'equal) )
             (t (return-from <chain-on nil)))
       (setq CL2 (remove1 e* CL))

       (SETQ BL (cond ((cddr b) 
		       (MINUS-ON-REDUCE (CADR B) (CADDR B)))
		      (t (cadr b))))
       (setq BL (cond ((atom BL) (list '+ BL))
                      ((eq '+ (car BL)) BL)
                      (t (list '+ BL))))

       (SETQ SIGN (COND ((EQ (CAR B) (CAR C)) '<=) 
                        ((EQ '< (CAR C)) '<)  (T '<=)))

       (SETQ BL* (CDR BL))      ;(+ a (- b)) goes to (a (- b))

       (SETQ W (some #'(LAMBDA (X) 
		     (COND ((or (atom x) (and (eq '- (car x)) (atom (cadr x))))
                            nil)           ;Dont chain on variables.
			   ((SETQ THETA (UNIFY e* X))
			   (SETQ BL2 (apply-substitution theta (REMOVE1 X BL)))
			   (SETQ CL2 (apply-substitution theta CL2))
                            (setq c2 (MINUS-ON-REDUCE CL2 BL2))
                            (cond ((and (not (atom C2)) (eq '+ (car c2)))
                                   (cond ((set-equal (cdr c2)
					     (setq c3 (reduce-alg (cdr c2))))
					  (setq c3 (cdr c2))))
                                   (setq c2 (reduc (cons '+ c3))))
                                  (t t))
                            (SETQ C2 (LIST SIGN C2))
                            (LIST THETA C2))))
                       BL*))
        (cond (W (and *pl* (format t "~%Inequality-chaining succeeded with 
 ~s against ~% ~s upon ~%       ~s ~% getting ~%~% ~s ~%~%" B C E W)))) W))
  

(DEFUN COMPOSE (THETA SIGMA)  ;widely used  
  ;; this returns the composition of the two substitutions THETA & SIGMA
  (COND ((or (null theta) (null sigma)) nil)
        ((EQ T THETA) SIGMA)
        ((EQ T SIGMA) THETA)
        (T (SETQ THETA
                 (COND ((TWO-XS SIGMA NIL)
                        (PROG (X2)
                              (SETQ X2 (TWO-XS SIGMA))
                              (RETURN (UNION-W (COMPOSE THETA (CAR X2))
                                             (COMPOSE THETA (CADR X2))))))
                       (T (MAPCAR #'(lambda(U)
  				    (CONS (CAR U) (SUBLIS= SIGMA (CDR U))))
				  THETA))))
	   (SETQ THETA (UNION-W THETA SIGMA))
	   (MAPCAN #'(lambda(U)
		     (COND ((EQUAL (CAR U) (CDR U)) NIL) (T (LIST U))))
		   THETA))))
    
(DEFUN CRUNCH (L)   ;widely used  
  ;; USED-IN  (ALL-VARIABLES-IN AND-C ATOMS-IN CALLED-IN CRUNCH 
  ;; FREE-VARIABLES-IN VARIABLES-IN)
  ;;removes duplication from a list
  (COND ((NULL L) L)
	((MEMBER (CAR L) (CDR L) :test #'equal) (CRUNCH (CDR L)))
	(T (CONS (CAR L) (CRUNCH (CDR L))))))
    
(DEFUN DELETE-& (W H)    ;USED-IN (IMPLY-RULES SUB=)
 (COND ((EQUAL W H) NIL) 
       ((NULL (CDR (SETQ H (REMOVE W H)))) NIL)
       ((NULL (CDDR H)) (CADR H))
       (T H)))
    
(DEFUN DELETE-ONE (A L)    ;used by BACK-CHAIN-O & PROVE-THE-PREMISE*
  (SETQ L (REMOVE1 A L))
  (COND ((MEMBER (CAR L) '(& OR)) (COND ((NULL (CDDR L)) (CADR L)) (T L)))))

(defun delete-from (P L)   ;29June92  Called by GUFC
  (cond ((member P L :test 'equal) nil)
	((eq-car P '&) 
	 (andify (set-difference-w (cdr P) L)))
	(t P) ))  

(defun format-s (c &optional (sym-n 3) (n 0))   ;Called by options, etc
  ;;Instead of printing a formula c with all of its detail, the printing
  ;; is shortened by replacing long arguments (with more than sym-n symbols)
  ;; of each skolem function by a single variable and then showing the value 
  ;; of that variable.
  (let (theta theta2 (L (crunch (sko-args c)))
                    (LS (crunch (sko-expressions C))))
    (cond ((not *short-print-light*) (format t "~% ~s ~%" c))
	  ((setq L (delete-if-not #'(lambda (x) 
                (< sym-n (number-of-symbols-in x)))  L))
           (setq theta (mapcar #'(lambda (x) 
                (cons x (new-symbol (maknam (list '$ (setq n (1+ n))))))) L))
           (setq theta2 (mapcar #'(lambda (x) 
                (cons x (sublis theta x :test 'equal))) LS))
           (setq c (sublis theta2 c :test 'equal))
           (format t "~% ~s ~%" c)
           (format t "~%   WHERE~%")
           (mapc #'(lambda (u) (format t "~%     ~s = ~s~%" (cdr u) (car u))) 
		 theta))
          (t (format t "~% ~s ~%" c)))))

(defun number-of-symbols-in (x)   ;called by format-s
  (cond ((null x) 0)
        ((atom x) 1)
        (t (+ (number-of-symbols-in (car x)) (number-of-symbols-in (cdr x))))))

(setq *alphabet* '(a b c d e f g h i j k l m n o p q r s t u v w x y z)) ;7/92

(defun shorten ()   ;called by OPTIONS   6July92
 ;;This replaces, in H C and YET, ground terms of the form (xns ...) by (xns),
 ;; where n is not a member of alphabet.
  (declare  (special h c tl anc lt yet))
  (let (LH LC LY L theta)
    (setq LH (crunch (sko-ground-terms H)))
    (setq LC (crunch (sko-ground-terms C)))
    (setq LY (crunch (sko-ground-terms YET)))
    (setq L (crunch (union-w LH (union-w LC LY))))
    (setq theta (mapcar #'(lambda (u) (cons u (list (car u)))) L))
    (setq H (apply-substitution theta H))
    (setq C (apply-substitution theta C))
    (setq YET (apply-substitution theta YET))
    ))

(defun sko-ground-terms (A &optional not-ground)  ;called by SHORTEN  6July92
  (let (E)
    (cond ((atom A) nil)
	  ((numberp A) nil)
	  ((null (cdr A)) nil)
	  ((member (car A) '(& or -> not all some < <= << <<= + - *)) 
	   (mapcan #'(lambda (u) (sko-ground-terms u not-ground)) (cdr A)))
	  ((and (atom (car A)) (not (numberp (car A))) 
		(or not-ground (ground A))
                  ;;A must be ground if not-ground is nil
		(setq E (reverse (explode (car A))))
		(eq-car E 'S) (not (member (cadr E) *alphabet*)))
	   (list A))
	  (t (crunch (mapcan #'(lambda (u) (sko-ground-terms u not-ground)) 
			     A))) )))

(defun sko-args (c) ;called by format-s
  ;;This lists the arguments of any skolem expressions in c
  (cond ((atom c) nil)
        ((member (car c) *skolem-function-list*)
         (append (cdr c) (mapcan #'(lambda (x) (sko-args x)) (cdr c))))
        (t (append (sko-args (car c)) (sko-args (cdr c))))))

(defun sko-expressions (c)  ;called by format-s
  ;;This lists the skolem expressions in c
  (cond ((atom c) nil)
        ((member (car c) *skolem-function-list*) (list c))
        (t (append (sko-expressions (car c)) (sko-expressions (cdr c))))))

(defun function-depth (A n &optional sym m)  ;1Aug92 
  ;;If the length of a (tier) consecutive string of symbols exceeds n 
  ;;   then return T.
  ;;Eg, (function-depth 
  ;;     '(E (W) (U (U (U (RES-L (S124S (+ (K) 1) C112) (K129S (+ (K) 1) C112))
  ;;           (SNG L196)) (SNG L196)) (SNG L196))) 2) = T
  (let ()
    (cond ((atom A) nil)
	  ((member (car A) '(& or -> not))
	   (some #'(lambda (u) (function-depth u n)) (cdr A)))
	  ((not (atom (car A))) (format t "~%Function-depth Alarm~%") nil)
	  ((null (cdr A)) nil)
	  ((and sym (eq sym (car A)))
	   (cond ((< n (setq m (1+ m))) T)    ;success
		 (t (some #'(lambda (u) (function-depth u n sym m)) (cdr A)))))
	  ((and sym (not (eq sym (car A)))) nil) ;sym string ends
	  ((some #'(lambda (u) (function-depth u n (car A) 1)) (cdr A)) T)
	  ((some #'(lambda (u) (function-depth u n))           (cdr A)) T)
	  (t nil))))
    
(defun function&predicate-symbols-of (A) (crunch (f&p-syms A)))

(defun f&p-syms (A)   ;called by function&predicate-symbols-of 
  (cond ((atom A) nil)
        (t (cons (car A) (mapcan #'f&p-syms (cdr A))))))

(defun ground (A) (and (not (occur 'all A))(not (occur 'some A))
		       (null (free-variables-in A))))

(defun ground-unit (C)  ;called by IMPLY-RULES*, Is C a Ground Unit?
  (cond ((atom C) nil)
        ((member (car C) '(& or -> not)) nil)
        (t (ground C))))

(defun ground-units (A &optional sym unit)  
  ;;Called by PROPOSITIONALLY-FORWARD-CHAIN, AND-ON-H
  ;;This gives a formula (usually a conjunction) which is the conjunction of 
  ;; the ground units of A (if sym is nil), else the ground units of A whose
  ;; CAR is sym (eg, '=).
  ;;Note that these "units" may not be true atomic formulas unless unit is T.
  (let (L Lu)                 
    (cond ((atom A) nil)         ;(& (A) (OR (NOT (A)) (B)))
	  ((eq '& (car A))
	   (setq L (crunch (mapcan #'(lambda (u) 
               (cond ((and (ground u) (or (not sym) (eq (car u) sym))
                           (or (not unit) (ground-unit u)))
                      (list u))
		     ((and (eq-car u 'not) (ground u)                ;29June92
			   (or (not sym) (eq-car (cadr u) sym)) ;(not (ground))
                           (or (not unit) (ground-unit (cadr u))))
                      (list u))
		     ((and (ground u) (eq '= sym) (eq-car u '=)      ;29June92
			   (not (atom (cadr u))) (null (cdadr u))  ;??
			   )   ;29June92
                                                      ;u has form (= (x) tt)
		      (list u))

		     ((and (ground u) (eq-car u 'sub-here) (eq '= sym) 
			   (eq-car (cadr u) '=) (not (atom (cadr (cadr u))))
			   ;;			   (null (cdadr (cadr u)))  ;??
			   )   ;29July92
                                              ;u has form (sub-here (= (x) tt))
		      (list u))
		     ((and (eq-car u '&) (setq Lu (ground-units u sym unit)))
		      (and-remove Lu))
		     ))
				   (cdr A))))
           (cond ((null L) nil)
                 ((null (cdr L)) (car L))
                 (t (cons '& L))) )

	  ((and (ground A) (or (not sym) (eq (car A) sym))
                (or (not unit) (ground-unit A))) A)
	  ((and (eq '= sym) (eq-car A '=)                ;(null (cdadr A))
		)      		                         ;A has form (= (x) tt)
		      A)
;;((and (print 'ground-units) nil)) ((and (break) nil))
	  ((and (eq-car A 'sub-here) (eq '= sym) (eq-car (cadr A) '=)
		                                  ;(null (cdadr (cadr A)))  ??
		)                          ;A has form (sub-here (= (x) tt))
		      A)                      ;29July92
	  (t nil))))

(defun ground-units-g (A)
  (let (L)
    (cond ((setq L (units A)) 
	   (mapcan #'(lambda (u) (cond ((ground u) (list u)))) L)))))

(defun ground-units-forward-chain (H &optional hg)   ; 29June92  called by 
  ;;forward chain the ground units of h-gu into all of H returning the
  ;; altered H*
  (let (h-gu h-gu* hv hv* H*)
    (setq h-gu (cadr H)) (setq hv (cadddr H))
    (cond ((not (setq hg (cond (hg hg) (t (units h-gu)))))
	   (return-from ground-units-forward-chain H)))
    (setq h-gu* (and-remove h-gu))
    (setq h-gu* (andify (crunch (mapcar #'(lambda (u) (gufc hg u)) h-gu*))))
    (setq hv*   (and-remove hv))
    (setq hv*   (andify (crunch (mapcar #'(lambda (u) (gufc hg u)) hv*))))

    (setq h-gu* (and-on h-gu* h-gu))
    (setq H* (list (car H) h-gu* (caddr H) nil))
    (setq H* (and-on-h H* hv*)) ))


(defun gufc (L H)                 ;called by GROUND-UNIT-FORWARD-CHAIN
  (cond ((eq-car H '->)
	 (imp-on (delete-from (cadr H) L)
		 (gufc L (caddr H))))
	((atom H) H)
	((member (car H) '(& or not))
	 (cons (car H) (mapcar #'(lambda (u) (gufc L u)) (cdr H))))
	(t H) 
	))

;;;*********************************************************************
;;;
;;;                     PROVE.LISP    In KCL
;;;                                 20 Aug 87,  30  Mar 87  
;;;               W. W. Bledsoe     30 January 1987  25 Feb 1989  2 Mar 90
;;;
;;;             This is the main routine of IMPLY.LISP
;;;                   Call  (PROVE Theorem)
;;;           to INTERACTIVELY prove the theorem Theorem
;;;     Now divided into four parts:  PROVE1,PROVE2,PROVE3.LISP,PROVE4.LISP
;;;          for ease of compiling  (This is PROVE3.LISP)       
;;;
;;;***********************************************************************

(defun ground-unit-prover (C HG H= &optional Used-units n)
  ;;Prove the ground unit C, using the set HG of ground units, and 
  ;; the set H= of ground equality units (without the = sign, just pairs)
  (let (C*)
    (cond ((> (setq n (1+ n)) 6) nil)     ;Stop infinite loop
          ((and (eq-car HG '&) (member C HG :test 'equal)) t) ;Match in HG
	  ((Ground-pairs C HG H= Used-units n) t) 	      ;Ground-Pairs
	  ((some #'(lambda (u)		               ;Equality Substitution
               (and (not (member u Used-units :test 'equal))
		    (not (equal C (setq C* (subst (cadr u) (car u) C 
						  :test 'equal))))
		    (ground-unit-prover C* HG H= (cons u Used-units) n)))
		 H=) t)
	  ((some #'(lambda (u)		             ;Equality Substitution
		(and (setq u (reverse u))
                     (not (member u Used-units :test 'equal))
		     (not (equal C (setq C* (subst (cadr u) (car u) C 
						   :test 'equal))))
		     (ground-unit-prover C* HG H= (cons u Used-units) n)))
		 H=) t)
	  (t nil))))

(defun ground-pairs (C HG H= Used-units n)   ;Called by Ground-unit-prover
  ;;Like PAIRS except that C and HG are ground (no variables)
  (let (tp tp2 theta H*)
    (cond ((atom C) nil)
          ((not (setq tp (assoc (car C) *pairs-structure*))) nil)
          ((not (setq tp2 (mapcan #'(lambda (u)
		   (cond ((setq theta (instance C (cadr u)))
			  (list (list (apply-substitution theta (car u))
				      (apply-substitution theta (caddr u)))))))
				  (cadr tp)))) nil)          
          ((some #'(lambda (hyp) (some #'(lambda (tpp)
               (and (setq theta (instance  hyp (car tpp)))
		    (setq H* (apply-substitution theta (cadr tpp)))
		    (ground-unit-prover H* HG H= Used-units n)))  tp2))  HG)
           (and *pl* (format t "~%Proved by Ground-Pairs%"))
           t))))
    
(defun ground-part (A)                  ;called by PROVE-THE-PREMISE 4July92
  (cond ((ground A) A)
	((eq-car A '&) 
	 (andify (mapcan #'(lambda (u) (cond ((ground u) (list u)))) (cdr A))))
	(t nil)))

(DEFUN HIGHER-GOAL-FAILURE (C) C nil)   ;USED-IN (IMPLY-RULES)

(DEFUN imp-ON (A B)    ;widely used    VE-the-variable
  (cond ((null A) B) ((eq t A) B) ((eq t B) t) ((equal '(empty) A) B) 
	((null B) (reduc (list 'not A))) 
        (t (list '-> A B))))

(defun imply-break (&optional (v t))
  (setq *imply-break-light* v))

(defun ind () (sp *indent*) t)
(defun ind2 () (sp (+ *indent* 2)) t)
    
(DEFUN INEQUALITY-CHAIN ()                     ;USED-IN (IMPLY-RULES)
 (declare  (special h c tl anc lt yet))
 (let (use h-gu H= Hv)
      (setq use (car H)) (setq h-gu (cadr H)) (setq H= (caddr H))
                                              (setq Hv (cadddr H))
      (or (and use (inequality-chain2 use C))
	  (and h-gu (inequality-chain2 h-gu C))
	  (inequality-chain2 Hv C)) ))


(DEFUN INEQUALITY-CHAIN2 (H% C)                 ;Called by Inequality-Chain
 (LET (L H** LAMBDA)
  (COND 
   ((OR 
     (AND (SETQ L (<CHAIN H% C))		;H% = (< b C2)
	  (or (SETQ H** NIL) t)
	  (SETQ LAMBDA (PROVE-THE-PREMISE-S NIL NIL L H**)) )

     (AND (EQ '-> (CAR H%))		;H% = (-> H2 C2)
	  (OR
	   (AND (SETQ L (<CHAIN (CADDR H%) C)) ;H% = (-> H2 (< b C2))
		(SETQ H** (CADR H%))
		(SETQ LAMBDA (PROVE-THE-PREMISE-S NIL NIL L H**)) )

	   (AND (EQ '& (CAADDR H%))	;H% = (-> H2 (& B B ...))
		(SOME #'(LAMBDA (B)
				(AND 
				 (SETQ L (<CHAIN B C)) ;B = (< b C2)
				 (SETQ H** (CADR H%))
				 (SETQ LAMBDA 
				       (PROVE-THE-PREMISE-S NIL NIL L H**))))
		      (CDADDR H%)))

	   (AND (EQ 'OR (CAADDR H%))	;H% = (-> H2 (OR B B ...))
		(SOME #'(LAMBDA (B)
				(AND 
				 (SETQ L (<CHAIN B C)) ;B = (< b C2)
				 (or (SETQ H** (REMOVE B (CDADDR H%)))t)
				 (SETQ H** (COND ((CDDR H**) H**) 
						 (T (CADR H**))))
				 (SETQ H** (NOT-ON H**))
				 (SETQ LAMBDA 
				       (PROVE-THE-PREMISE-S NIL NIL L H**))))
		      (CDADDR H%)))))

     (AND (EQ '& (CAR H%))		;H% = (& H* H* ...)
	  (SOME #'(LAMBDA (H*) 
           (OR
	    (AND (SETQ L (<CHAIN H* C))	;H* = (< b C2)
		 (or (SETQ H** NIL) t)
		 (SETQ LAMBDA (PROVE-THE-PREMISE-S H* (CDR H%) L H**)) )  

	    (AND (EQ '-> (CAR H*))	;H* = (-> h2 (< b C2))
		 (OR
		  (AND (SETQ L (<CHAIN (CADDR H*) C)) ;H* = (< b C2)
		       (SETQ H** (CADR H*))
		       (SETQ LAMBDA (PROVE-THE-PREMISE-S H* (CDR H%) L H**)))  

		  (AND (EQ '& (CAADDR H*)) ;H* = (-> h2 (& B B ...))
		       (SOME #'(LAMBDA (B)
                         (AND 
			  (SETQ L (<CHAIN B C))	;B = (-> b C2)
			  (SETQ H** (CADR H*))
  			  (SETQ LAMBDA 
				(PROVE-THE-PREMISE-S H* (CDR H%) L H**))))
		         (CDADDR H*)))  

		  (AND (EQ 'OR (CAADDR H*))  ;H* = (-> H2 (OR B B ...))
		       (SOME #'(LAMBDA (B)
			  (AND 
			   (SETQ L (<CHAIN B C)) ;B = (< b C2)
			   (or (SETQ H** (REMOVE B (CDADDR H*))) t)
			   (SETQ H** (COND ((CDDR H**) H**) 
					   (T (CADR H**))))
			   (SETQ H** (NOT-ON H**))
			   (SETQ LAMBDA 
				 (PROVE-THE-PREMISE-S H* (CDR H%) L H**)
				 )))  
			  (CDADDR H*))) 
                  )) ))
		(CDR H%) )) )

    (AND *PL* (FORMAT T "~% < CHAINING ~%"))
    (ANS* '(< CHAINING))
    LAMBDA )) ))
    
(DEFUN INFIX->PREFIX (A)   ;USED-IN  PROVE
  ;; THIS ACCEPTS A FORMULA A IN infix FORM AND REWRITES IT IN prefix FORM 
  (PROG (W)
	(RETURN (COND ((ATOM A) A)
		      ((MEMBER (CAR A) '(-> & OR)) A)
		      ((MEMBER (CAR A) '(ALL SOME))
		       (LIST (CAR A) (CADR A) (INFIX->PREFIX (CADDR A))))
		      ((EQ 'NOT (CAR A)) (LIST 'NOT (INFIX->PREFIX (CADR A))))
		      ((SETQ W (ASSOC* '-> A NIL))
		       ;; A = (P -> Q) 
		       (LIST '->
			     (INFIX->PREFIX (CAR W))
			     (INFIX->PREFIX (CADR W))))
		      ((MEMBER (CADR A) '(& OR))
		       ;; A = (C & D & E) ETC 
		       (CONS (CADR A)
			     (MAPCAR 'INFIX->PREFIX
				     (CONS (CAR A) (REMOVE (CADR A) (CDDR A)))))
		       )
		      (T A)))))

(DEFUN LAST-PART (L)   ;USED-IN (IMPLY-RULES)
  ;; L IS OF THE FORM (& A B C ECT) OR (OR A B C ECT) -- 
  ;; (LAST-PARTL) RETURNS (& B C ECT) AND (OR B C ECT) RESPECTIVELY 
  (COND ((atom L) (print 'Alarm) L)     ;Cannot happen
        ((member (car L) '(& or))
         (cond ((cdddr L) (cons (car L) (cddr L)))
               ((cddr L) (caddr L))
               (t t)))
        (t (print 'Alarm) L) ))     ;Cannot happen
      
(DEFUN MAKNAM (L)                ;Fuzes the list L into an Atom
  ;;eg, (maknam '(a b 35)) = ab35
  (LET ((*PRINT-CASE* :UPCASE))
    (INTERN (WITH-OUTPUT-TO-STRING (V)
    	            (MAPC #'(LAMBDA (X) (PRIN1 X V))  L)
		        V))))
    
(defun match-1 (H% h# &optional tp)   ;used-in pairs
  ;; RULE 12: MATCH -  Does C match H%, Peek-pairs-case
 (declare  (special bigx reported))
 (declare  (special h c tl anc lt yet))
 (LET (THETA SIGMA C*)
  (COND 
   ((AND (SETQ THETA (UNIFY-tp H% C tp))
	 (cond (tp (setq C* (cadr theta))
		   (setq theta (car theta))
		   (and *pl* (not *jr-light*) (format t "~%Peek-Pairs"))
		   (setq sigma 
			 (prove-the-premise H% (list H%) theta C* h#)))
	       (t  (and *pl* (not *jr-light*)
			(format t "~% Match the Hyp ~s with MGU: ~s ~%" 
				     (cond ((equal h# 1) 'USE) 
					   ((equal h# 2) 'H-ground-units) 
                                           ((equal h# 4) 'H=)
					   (t 'Hv)) theta))
		   (report&options yet c theta) (ANS THETA)
		   (cond ((SETQ SIGMA (PROVE-YET THETA))
			  (setq sigma (compose theta sigma)))))))
    (ans sigma)))))

(DEFUN MATCH (H% h# &optional tp)   ;USED-IN (IMPLY-RULES)
  ;; RULE 12: MATCH -  Does C match some hypothesis of H% (or use Peek-pairs)
 (declare  (special bigx reported))
 (declare  (special h c tl anc lt yet))
 (LET (THETA SIGMA N C*)
  (COND 
   ((AND (EQ '& (CAR H%))
	 (SOME #'(lambda(H*) 
	   (AND (SETQ THETA (UNIFY-tp H* C tp))
		(cond (tp (setq C* (cadr theta)) 
			  (setq theta (car theta))
			  (and *pl* (not *jr-light*)(format t "~%Peek-Pairs"))
			  (setq sigma 
				(prove-the-premise H* (cdr H%) theta C* h#)))
		      (t (SETQ N (POSITION-IN H* (cdr H%) 1))
			 (and *pl* (not *jr-light*)
			      (format t "~% Back-Chain on Hyp: ~s of ~s with MGU: ~s ~%" 
					   n (cond ((equal h# 1) 'USE) 
						   ((equal h# 2) 'H-ground-units) 
                                                   ((equal h# 4) 'H=)
						   (t 'Hv)) theta))
			 (report&options yet c theta) (ANS THETA)
			 (SETQ SIGMA (PROVE-YET THETA))
			 (setq sigma (compose theta sigma))))))
	       (CDR H%)))
 
    (ans sigma)))))


(DEFUN MINUS-ON (A B) 
  (cond ((or (null b) (equal 0 b)) 
         (cond ((or (null a) (equal 0 a)) 0) (t a)))
        ((or (null a) (equal 0 a)) (reduc (list '- b)))
	(t (REDUC (LIST '+ A (LIST '- B))))))
    
(DEFUN MINUS-ON-REDUCE (a b) 
  ;;Same as Minus-on except that it always calls reduce2, no matter
  ;; what the value of *reduce-light*
  (cond ((or (null b) (equal 0 b)) 
         (cond ((or (null a) (equal 0 a)) 0) (t a)))
        ((or (null a) (equal 0 a)) (reduc* (list '- b)))
        ((and (setq a (LIST '+ a (LIST '- b)))
              (equal a (setq a (reduc* a)))) a)
        ((equal a (setq a (reduc* a))) a)
        (t (reduc* a)) ))

(defun multiple-bc (H C)   ;called by imply-rules (See USE)
  (let (theta Lemma* gu use h-gu H= Hv c* c**)
    (setq Hv (cadddr H))
    (cond ((not (some #'(lambda (u) (setq theta (find-theta u))(setq Lemma* u))
		(cdr Hv)))
	   (return-from multiple-bc nil)))

    (setq Lemma* (apply-substitution theta Lemma*))
;;%% Propositionally FC into the lemma, and store the results in h-gu, Hv,etc,
;;    and return to OPTIONS.

    (and (not (eq t theta)) 
	 (setq h-gu (and-on (cadr H) (caddr H))) ;(h-gu U H=)
	 (setq GU (cond ((atom h-gu) nil)
			((eq '& (car h-gu)) (cdr h-gu))
			(t (list h-gu))))
	 (setq Lemma* (propositionally-forward-chain GU Lemma*)))
    (setq H (and-on-h H lemma* nil 'USE))
    (setq USE (car H)) (setq h-gu (cadr H)) (setq H= (caddr H))
                                            (setq Hv (cadddr H))
    (cond ((setq GU (ground-units Lemma*))
	   (format t "~%The following units have been added to H:~%")      
	   (number&print GU)
	   (format t "~% (As a result of Forward-Chaining on the USE Lemma)~%")

           (format t "~%The Hypotheses now contain:~%")
	   (number&print-list USE h-gu H= Hv)
           (cond ((null (setq c* (and-off c h-gu))) (setq c '(true)) 
                  (format t "~%C is a subset of h-gu~%"))
                 ((null (setq c** (and-off c* Hv))) (setq c '(true))
                  (format t "~%C is a subset of ~s~%" 
                          (cond ((equal c* c) 'Hv) (t '(h-gu & Hv))) ))
                 ((equal c** c) nil)
                 ((equal c* c) (setq c c**) 
                  (format t "~% Part of C is a subset of Hv~%"))
                 ((equal c** c*) (setq c c**)
                  (format t "~% Part of C is a subset of h-gu~%"))
                 (t (format t "~% Part of C is a subset of (h-gu & Hv)~%"))))
    (t (format t "~%The USE Lemma has been put in the USE arg of IMPLY.~%")))
    (list H C)))

(defun multiple-bc (H C)   ;called by imply-rules (See USE)
  (let (theta Lemma* gu use h-gu H= Hv c* c**)
    (setq Hv (cadddr H))
    (cond ((not (some #'(lambda (u) (setq theta (find-theta u))(setq Lemma* u))
		(cdr Hv)))
	   (return-from multiple-bc nil)))

    (setq Lemma* (apply-substitution theta Lemma*))
;;%% Propositionally FC into the lemma, and store the results in h-gu, Hv,etc,
;;    and return to OPTIONS.

    (and (not (eq t theta)) 
	 (setq h-gu (and-on (cadr H) (caddr H))) ;(h-gu U H=)
	 (setq GU (cond ((atom h-gu) nil)
			((eq '& (car h-gu)) (cdr h-gu))
			(t (list h-gu))))
	 (setq Lemma* (propositionally-forward-chain GU Lemma*)))
    (setq H (and-on-h H lemma* nil 'USE))
    (setq USE (car H)) (setq h-gu (cadr H)) (setq H= (caddr H))
                                            (setq Hv (cadddr H))
    (cond ((setq GU (ground-units Lemma*))
	   (format t "~%The following units have been added to H:~%")      
	   (number&print GU)
	   (format t "~% (As a result of Forward-Chaining on the USE Lemma)~%")

           (format t "~%The Hypotheses now contain:~%")
	   (number&print-list USE h-gu H= Hv)
           (cond ((null (setq c* (and-off c h-gu))) (setq c '(true)) 
                  (format t "~%C is a subset of h-gu~%"))
                 ((null (setq c** (and-off c* Hv))) (setq c '(true))
                  (format t "~%C is a subset of ~s~%" 
                          (cond ((equal c* c) 'Hv) (t '(h-gu & Hv))) ))
                 ((equal c** c) nil)
                 ((equal c* c) (setq c c**) 
                  (format t "~% Part of C is a subset of Hv~%"))
                 ((equal c** c*) (setq c c**)
                  (format t "~% Part of C is a subset of h-gu~%"))
                 (t (format t "~% Part of C is a subset of (h-gu & Hv)~%"))))
    (t (format t "~%The USE Lemma has been put in the USE arg of IMPLY.~%")))
    (list H C)))
    
(DEFVAR N-ARY-FCN-LIST ;USED-IN (PREFIX->INFIX PREFIX-INFIX)
  '(LIKES KILLED-BY EATS))
    
(DEFVAR *NAME-NUMBER* 7)     ;USED-IN (REPLACE-VARIABLES)

(defun negs-last (x y)		;Used by binary-to-unary<, in SORT
  ;;Put negations before other entries
  (or (atom x)
      (not (eq '- (car x)))
      (and (not (atom y)) (eq '- (car y))) ) )

(defun new-symbol (x)  ;called by UNIQUE-BOUND-VARIABLES
  ;;replace x by a sym not occuring in %theorem-variables%
  (prog (n x*)
    (setq x* x) (setq n 1)
    TOP
    (cond ((member x* %theorem-variables%) ;we did have OCCUR instead of MEMBER
           (setq x* (maknam (list x n)))   ; here, but it is VERY slow.
           (setq n (1+ n))                
           (go TOP))
          (t (return x*)) )))

(DEFUN NEW-VARIABLES (A)   ;USED-IN (PROVE)
  (PROG (*var-sup* VE)
        (declare (special *var-sup*))        ;*var-sup* used in REPLACE-VS
	(SETQ VE (union-w (variables-IN A) *vc*))  ;6-30-89 this was ATOMS-IN
	(cond (*var-sup-flag* nil)
	      (t (SETQ *VAR-SUP* (SET-DIFFERENCE-W *VARIABLE-SUPPLY* VE))))
	(RETURN (NEW-VARS A NIL 'T))                 ;put this one back
      (RETURN (NEW-VARS A '(L) 'T))            ;24Mar92 Very,very temporary
	))
           
(DEFUN NEW-VARS (A OMIT PARITY)    ;USED-IN  NEW-VARIABLES
  (let (VC B)
    (COND ((ATOM A) A)
	  ((OR (AND PARITY (EQ 'OR (CAR A)))
	       (AND (NOT PARITY) (EQ '& (CAR A)))
	       (AND PARITY (EQ '-> (CAR A))))
	   (SETQ VC
		 (SET-INTERSECTION
		  (VARIABLES-IN (CADR A))
		  (VARIABLES-IN (CDDR A))))
	   (SETQ VC (SET-DIFFERENCE-W VC OMIT))
	   (SETQ B
		 (COND ((CDDDR A) (CONS (CAR A) (CDDR A)))
		       (T (CADDR A))))
	   (SETQ B (REPLACE-VS VC B))
	   (AND-OR-ON (CAR A)
		      (NEW-VARS (CADR A)
				OMIT 
				(COND ((EQ '-> (CAR A))
				       (NOT PARITY))
				      (T PARITY)))
		      (NEW-VARS B OMIT PARITY)))
	  ((OR (AND PARITY (EQ '& (CAR A)))
	       (AND (NOT PARITY) (EQ 'OR (CAR A)))
	       (AND (NOT PARITY) (EQ '-> (CAR A))))
	   (SETQ VC
		 (SET-INTERSECTION
		  (VARIABLES-IN (CADR A))
		  (VARIABLES-IN (CDDR A))))
	   (SETQ B
		 (COND ((CDDDR A) (CONS (CAR A) (CDDR A)))
		       (T (CADDR A))))
	   (AND-OR-ON (CAR A)
		      (NEW-VARS (CADR A)
				(UNION-W OMIT VC)
				(COND ((EQ '-> (CAR A))
				       (NOT PARITY))
				      (T PARITY)))
		      (NEW-VARS B (UNION-W OMIT VC) PARITY)))
	  ((EQ 'NOT (CAR A))
	   (LIST 'NOT (NEW-VARS (CADR A) OMIT (NOT PARITY))))
	  (T A))))

(defun new-objects (A A*) ;called by PROVE-executor
  ;;This returns the new objects of the theorem being proved
  ;; eg, the skolemized universally quantified variables
  (crunch (new-objs A A*)))

(defun new-objs (A A* &optional (P t) L) ;Called by NEW-OBJECTS
  (cond ((equal A A*) nil)
        ((atom A) (cond ((member A L) (list A*)) (t nil)))
        ((or (and P (eq 'all (car A)))
             (and (not P) (eq 'some (car A))))
         (new-objs (caddr A) A* P (cons (cadr A) L)))
        ((or (and  P (eq 'some (car A)))
             (and (not P) (eq 'all (car A))))
         (new-objs (caddr A) A* P L))
        ((eq (car A) (car A*))
         (mapcan #'(lambda (x y) (new-objs x y P L)) (cdr A) (cdr A*)))
        (t (format t "~%ALARM: Problem in New-objs, for 
    A: ~s ~%and B: ~s~%    P: ~s    L: ~s ~%" A A* P L))))

(defun no-cdrs (A) 
  ;;Returns the list of subexpressions of A of the form (atom).
  (cond ((atom A) nil)
        ((null (cdr A)) (cond ((atom (car A)) (list A))
                              (t (no-cdrs (car A)))))
        (t (mapcan #'no-cdrs (cdr A))) ))
     
(DEFUN NOT-FORMULA (A)   ;USED-IN (IMPLY-RULES)
  (COND ((OR (OCCUR 'NOT A) (OCCUR '-> A)) (REDUC (LIST 'NOT A)))
	(T NIL)))
    
(DEFUN NOT-ON (A)   ;USED-IN (BACK-CHAIN-O PROVE-THE-PREMISE* INEQUALITY-CHAIN)
  (COND ((eq t A) '(FALSE))
	((ATOM A) (LIST 'NOT A))
	((EQ 'NOT (CAR A)) (CADR A))
	((eq '-> (car A)) (and-on (cadr A) (not-on (caddr A))))
	(T (reduc (LIST 'NOT A)))))
    
(DEFVAR *OMIT-NIL-PROOF-LIGHT* NIL)   ;USED-IN (ANS)
    
(DEFUN OR-AND-OUT (L)   ;USED-IN  OR-OUT
  (PROG (W)
	(RETURN
	 (COND
	  ((EQUAL
	    L 
	    (SETQ L
	     (MAPCAN
	      #'(lambda(A)
 		(COND ((SETQ W
			     (SOME #'(lambda(Q) (AND (EQ 'OR (CAR Q)) Q))
				   (CDR A)))
		       (MAPCAR #'(lambda(R) (SUBST= R W A)) (CDR W)))
		      (T (LIST A))))
	      L)))
	   (OR-ON-LIST L))
	  (T (OR-AND-OUT L))))))

(defun or-off (A x)  ;22June93   
  (let (A*)
    (cond ((not (eq-car A 'or)) A)
	  ((not (member x A :test 'equal)) A)
	  ((and (setq A* (remove x A :test 'equal)) nil))  ;name things
	  ((not (cdr A*)) (prnt 'ALARM))                   ;A= (or x)
	  ((not (cddr A*)) (cadr A*))                      ;A= (or y x)
	  (t A*))))                                        ;A= (or y ... x ...)

(DEFUN OR-ON (A B)   ;USED-IN (IMPLY-RULES OR-ON-LIST)
  (COND ((NOT A) B)
	((NOT B) A)
	(T (CONS 'OR
		 (UNION-W (COND ((AND (NOT (ATOM A)) (EQ 'OR (CAR A))) (CDR A))
			      (T (LIST A)))
			(COND ((AND (NOT (ATOM B)) (EQ 'OR (CAR B))) (CDR B))
			      (T (LIST B))))))))
    
(DEFUN OR-ON-LIST (L)   ;USED-IN (OR-AND-OUT)
  (COND ((NULL L) NIL)
	((NULL (CDR L)) (CAR L))
	(T (OR-ON (CAR L) (OR-ON-LIST (CDR L))))))
    
(DEFUN OR-OUT (A &optional imp)   ;USED-IN (IMPLY-RULES PROVE)
  ;;Eg, (& a (or b c) d) is converted to  (or (& a b d) (& a c d))
  ;;and (& a (or b c) d (or e f) g) is converted to  
  ;;     (or (& a b d g) (& a c d g) (& a d e g) (& a d f g))
  ;;and (& (OR (& A B) C) D) goes to (OR (& A B D) (& C D))
  ;;and if imp is not nil, then (& A (-> B C) D) goes to 
  ;;    (OR-OUT (& A (or (not B) C) D)).

  (let (A-or L A*)
    (COND ((ATOM A) A) 
           ((EQ '& (CAR A))             ;see replace.lisp for assoc-r def
            (cond ((setq A-or (assoc-r 'or (cdr a)))   ;A-or = (or b c)
                   (setq L (mapcar #'(lambda (u) 
                                 (setq A* (or-out (subst-1 u A-or A)))
                                 (cond ((occur '& u) (setq A* (reduc** A*))))
                                 A*) (cdr A-or)))  ;L = ((& a b d) (& a c d))
                   (or-out (cons 'or L)))          ; (or (& a b d) (& a c d))
                  ((and imp (setq A-or (assoc-r '-> (cdr a))))
                   (setq A* (subst (list 'or (not-on (cadr A)) 
                                             (caddr A)) A-or A))
                   (or-out A*))
                  (t A)))

           ((EQ 'or (CAR A))     ;eg, A=(or a (or b c) d)
            (cond ((setq A-or (assoc-r 'or (cdr a)))   ;A-or = (or b c)
                   (setq A* (subst-elements (cdr A-or) A-or A))  ;(or a b c d)
                   (or-out A*))
                  (t A)))
           (t A) )))

(defun or-out-deep (A &optional (p t))   ;p is parity
  (let (A*)
    (cond ((atom A) (return-from or-out-deep A)))
    (cond (p (setq A (or-out A))))
    (setq A* (cond ((member (car A) '(& or))
		    (cons (car A) (mapcar #'(lambda(u) (or-out-deep u p))
					  (cdr A))))
		   ((eq-car A 'not) (list 'not (or-out-deep (not p))))
		   ((eq-car A '->) (list '-> (or-out-deep (cadr A) (not p))
					     (or-out-deep (caddr A) p)))
		   (t A)))
    (cond ((equal A* A) A)
	  (t (or-out-deep A* p)) )))

(defun or-out-and-on (gu hgu)  ;called by PROMOTE in IMPLY-RULES
  (cond ((atom gu) (and-on gu hgu))
        ((eq 'or (car gu))  ; (or a b) (& c d) goes to
                            ; (or (& a c d) (& b c d))
         (cons 'or (mapcar #'(lambda (u) (and-on u hgu)) (cdr gu))))
        ((occur 'or gu) (reduc** (or-out (and-on gu hgu))))
        (t (and-on gu hgu))))

(DEFUN OTHER (L A)  ;USED-IN (SUB=)
  (COND ((EQUAL A (CAR L)) (CADR L)) (T (CAR L))))
    
(defun pairs (C H% h#)  ;used by IMPLY-RULES
   (declare (special %pairs-light%))
   (let (tp tp2 theta)
     (cond ((not %pairs-light%) nil)
           ((atom C) nil)
           ((not (setq tp (assoc (car C) *pairs-structure*))) nil)
           ((not (setq tp2 (mapcan #'(lambda (u)
                   (cond ((setq theta (instance C (cadr u)))
                          (list (list (apply-substitution theta (car u))
                                      (apply-substitution theta (caddr u)))))))
                                   (cadr tp)))) nil)
;((and (format t "~%tp= ~s~%tp2= ~s~%" tp tp2) nil))
           ((some #'(lambda (tpp) (match-1 H% h# tpp)) tp2))
           ((some #'(lambda (tpp) (match   H% h# tpp)) tp2))
           ((some #'(lambda (tpp) (back-chain H% h# tpp)) tp2))
           (t nil) )))

(DEFUN POSITION-IN (X L &optional (K 1))  ;(k 1) 6Jan92
  ;USED-IN BACK-CHAIN-O PROVE-THE-PREMISE set-var files, etc.
  (COND ((NULL L) NIL)
	((equal x L) 1)
        ((eq '& (car L)) (position-in x (cdr L) K))
	((EQUAL X (CAR L)) K)
	(T (POSITION-IN X (CDR L) (1+ K)))))
    
(defvar *x* nil)(defvar *y* nil)(defvar *z* nil)(defvar *u* nil)
(defvar *v* nil)
(defmacro prnt (x &optional y z u v)
  `(let ((*x* ', x)(*y* ', y)(*z* ', z)(*u* ', u)(*v* ', v))
     (and *print-light* ,x (or (format t "~%~s~s ~s~%" *x* '= ,x) t)
	                ,y (or (format t "~%~s~s ~s~%" *y* '= ,y) t)
                        ,z (or (format t "~%~s~s ~s~%" *z* '= ,z) t)
                        ,u (or (format t "~%~s~s ~s~%" *u* '= ,u) t)
                        ,v (or (format t "~%~s~s ~s~%" *v* '= ,v) t)
			)))

(defun propositionally-forward-chain (L H1)   ;called by PROVE-THE-PREMISE
    (mapc #'(lambda (u) (setq H1 (subst= '(true) u H1))) L)
    (reduc** H1))

(DEFUN PROVE-N (TH-LIST &OPTIONAL (NON-STOP-LT NIL))   ;useful     
  (MAPCAR #'(lambda(W) (TERPRI) (TERPRI) (PRINT W) 
                       (PR (eval W) NON-STOP-LT)) TH-LIST))
     
(DEFUN PROVE-THE-PREMISE (H* HH THETA &OPTIONAL H** (h# 3) also) 
  ;; Used-in (BACK-CHAIN)                                  also 4July92
  ;; HH is the list of all hypotheses, H* is a member of HH.
  ;; HH and H* are only used here to determine (position-in H* HH) for tl.
  ;; H** THETA is being proved.  It is the premise of the hypothesis H*.
  ;;  (If H** is nil, we prove (cadr H*) instead)

  (declare  (special h c tl anc lt yet))
  (let (N tl* lambda H2 yett yet2 V use h-gu H= Hv hname tl-entry HH* n2 also*)
       (setq use (car H)) (setq h-gu (cadr H)) (setq H= (caddr H))
                                               (setq Hv (cadddr H))
       (setq yet2 yet)
       (setq V (VARIABLES-IN (and-on H** (cond ((equal h# 1) use) 
					       ((equal h# 3) Hv)))))

#|  We probably need this but in some different form
       (COND ((SETQ L (SET-INTERSECTION V (CDRS THETA)))
	      ;;If there is a variable conflict, replace them and redo IMPLY
	      (setq use2 (cond ((equal h# 1) 
				(replace-variables use L))(t use)))
	      (SETQ Hv2 (cond ((equal h# 3) (REPLACE-VARIABLES Hv L)) (t Hv)))
	      (cond ((and (equal Hv Hv2) (equal use use2)) t)
		    (t (setq H2 (list use2 h-gu H= Hv2))
                       (RETURN-FROM PROVE-THE-PREMISE 
				    (IMPLY H2 C TL ANC LT YET))))))
|#
       (SETQ N2 (COND (HH  (POSITION-IN H* HH  1)) (T 1)))   ;30Mar92
       (setq hname (cond ((Equal h# 1) 'USE) ((equal h# 2) 'h-gu) 
                   ((equal h# 4) 'H=)  (t 'Hv)))
       (setq tl-entry (BRACKETS (maknam (list N2 hname))))            ;24Mar92
       (SETQ TL* (APPEND TL (list tl-entry)))
       
       (and *pl* (not *jr-light*)
	    (format t "~% Back-Chain on Hyp: ~s of ~s with MGU: ~s ~%" 
		    n2 hname theta))                  ;use the N2 here 30Mar92

       (SETQ H** (COND (H** H**) (T (CADR H*)))) 
       (setq H** (APPLY-SUBSTITUTION THETA H**))
       (cond ((member H** *reject* :test 'equal)                     ;4July92 
	      (return-from prove-the-premise nil)))
       (setq %reduce-light% t)

       (cond ((and (setq yett (mapcar #'(lambda (u) 
                     (cons (compose (car u) theta) (cdr u))) yet2)) nil))
         	   ;;compose THETA with existing subs of YET
              ;;The use of ALSO 4July92 
             ((and (setq H2 (list nil h-gu H= Hv)) nil)) ;note that USE is nil.
	     ((or (not also) (member H** h-gu))
	      (cond ((SETQ LAMBDA (IMPLY H2 H** TL* ANC LT yett))
		     (compose theta lambda)))) ;regular case
	     ((SETQ LAMBDA (IMPLY H2 H** TL* ANC LT nil)) ;note that YET is nil
	      (setq also* (ground-part (apply-substitution theta also)))
	      (setq yett (mapcar #'(lambda (u) 
                     (cons (compose (car u) lambda)
			   (cons (and-on-h (cadr u) also*) (cddr u))))
				 yett))
	      (cond ((setq Lambda (IMPLY H2 t TL* ANC LT yett))
		     (compose theta lambda))))
	     (t nil)) ))

(DEFUN PROVE-THE-PREMISE-S (H* HH L H** &optional (h# 3))  
  ;;called by BACK-<CHAIN
  ;; PROVE-THE-PREMISE for SOME pair  (THETA C2) in the list L
  (LET (THETA LAMBDA)
   (SOME #'(LAMBDA (PAIR) 
                   (AND (SETQ THETA (CAR PAIR))
			(SETQ H** (AND-ON (CADR PAIR) H**))
			(SETQ LAMBDA (PROVE-THE-PREMISE H* HH THETA H** h#))))
         L) LAMBDA))
  

;;;*********************************************************************
;;;
;;;                     PROVE.LISP    In KCL
;;;                                 20 Aug 87,  30  Mar 87  
;;;               W. W. Bledsoe     30 January 1987  25 Feb 1989  2 Mar 90
;;;
;;;             This is the main routine of IMPLY.LISP
;;;                   Call  (PROVE Theorem)
;;;           to INTERACTIVELY prove the theorem Theorem
;;;     Now divided into four parts:  PROVE1,PROVE2,PROVE3.LISP,PROVE4.LISP
;;;          for ease of compiling  (This is PROVE4.LISP)       
;;;
;;;***********************************************************************
;;$$
(DEFUN PROVE-YET (THETA)    ; called by many functions 
  ;; This proves any remaining goals (in YET).
  ;; YET has the form ( (THETA* H C TL ANC LT h-gu MSG) 
  ;;                    (THETA* H C TL ANC LT h-gu MSG) ...)  
  ;; THETA* is the residual substitution which mush be applied to YET,usually T

 (declare (special h c tl anc lt yet))
 (let (yett u u* theta* h* c* tl* anc* lt* h-gu* msg lambda)

   (cond ((null yet) (return-from prove-yet t)))
   (setq yett 
     (cond ((eq t theta) yet)
	   (t (mapcar #'(lambda (u) (cons (compose (car u) theta) (cdr u)))
		      yet))))  ;compose THETA with existing subs of yet.
   (setq u (car yett))
   (setq theta* (car u))
   (setq u (apply-substitution-restricted theta* (cdr u)))

   (setq h* (first u)) (setq c* (second u)) (setq tl* (third u)) 
   (setq anc* (fourth u)) (setq lt* (fifth u)) 
   (setq u* (cdddr (cddr u)))
   (setq h-gu* (cadr h*))
   (cond ((cdr u*)
	  (setq msg (cadr u*))
	  (cond (*jr-light* nil) 
		((eq 'c* msg)
		 (and *pl* (format t "~%SPLIT-C: OTHER-C:  ~S~%" C*)))
                ((eq 'h* msg) 	
                 (and *pl* (format t "~%SPLIT-H: OTHER-H: ~%~S~%" H*)))
                ((eq 'h-gu* msg)
                 (and *pl* (format t "~%SPLIT-h-gu: OTHER-h-gu: ~%~S~%" h-gu*))

                  ))))
   (setq %reduce-light% (cond ((eq t theta*) nil) (t t)))
   (cond ((setq lambda (imply h* c* tl* anc* lt* (cdr yett)))
	  (compose theta* lambda))) ))

(defun pure-inequality-goal (C) ; Called by IMPLY-RULES
  ;;checks whether C has only  < or <=  predicates

 (cond ((atom C) t)
       ((null (cdr C)) t)
       ((member (car C) '(< <=)) t)
       ((member (car C) '(& or -> not))
        (every #'pure-inequality-goal (cdr c)))
       (t nil)))

(defun qed (&optional (tf t))
  (declare (special h c tl anc lt yet))
  (cond (tf (setq lt 'qed))       ;reset lt to QED
        (t  (setq lt 'proceed)))) ;reset lt to PROCEED

(defun reject (A)                 ;called by BACK-CHAIN    4July92
  (cond ((member A *reject* :test 'equal) t)     ;*reject* is a global variable
	((eq-car A '&) (some #'reject (cdr A)))
	(t nil)))

(DEFUN REMOVE1 (X L)  ;This removes the first occurance of x from L
       (COND ((NULL L) NIL) ((EQUAL X (CAR L)) (CDR L))
             (T (CONS (CAR L) (REMOVE1 X (CDR L))))))
 
  
(DEFUN REPLACE-VARIABLES (H* &OPTIONAL (L NIL))   ;USED-IN (PROVE-THE-PREMISE)
                                                  ;(back-chain)
  ;; THIS IS CALLED BY BACK-CHAIN -- IT REPALCES THE VARIABLES IN H* (FROM L
  ;; IF L IS NON-EMPTY) BY ADDING A DIGIT TO THEIR ENDS 
  
  (MAPC #'(lambda(X)
	    (SETQ H*
		  (SUBST= (MAKNAM (LIST X 
		       (SETQ *NAME-NUMBER* (ADD1-MOD10 *NAME-NUMBER*)) ))
			 X 
			 H*)))
   	(COND (L L) (T (VARIABLES-IN H*))))
	H*)

(DEFUN REPLACE-VS (VC A)      ;USED-IN (NEW-VARS)
(declare (special *var-sup*))     ;from NEW-VARIABLES
(MAPC #'(lambda(X)
          (cond ((member x *function-type-list*) nil)
                 ;;If function type, dont replace. (See Skolem.lisp)
                (t (SETQ A (SUBST= (CAR *VAR-SUP*) X A))
		   (SETQ *VAR-SUP* (CDR *VAR-SUP*)))))
	VC)
  A)

(DEFUN REPORT (C X)     ;USED-IN (IMPLY)
  (declare  (special h c tl anc lt yet))
  (and (not *jr-light*) (PRINc TL))
  (and (not *jr-light*) (PPRINT C))
  (COND (X
         (and (not *jr-light*) (PRINT 'PROVED-) (terpri)(terpri))
	 (COND ((EQ 'QED-1 LT) (and (not *jr-light*) (PRINT 'BY-QED) 
				    (ANS* '(PROVED USING QED)) (PRINT X)))
	       (T T)))
	(T 
         (PRINT 'FAILED-) (terpri)(terpri)
	 (COND ((EQ 'QED-1 LT) (PRINT 'USING-QED) (ANS* '(FAILED USING QED)))
	       (T T)))))
(defun report&options (yet c theta) 
  (declare  (special h c tl anc lt yet))
  (declare (special bigx reported))    
  (cond ((and yet (not (eq 'qed lt)))
	 (report c theta) (setq reported t) 
         (cond (%al% t)(t (options 'match)) ))
	(t t)))
 				    				    
(defun restart-prover ()    ;Called by the User
 ;;This is called after a error "crash" in imply, to resume the proof of the
 ;; current theorem, where the crash took place.  It is to follow a call to 
 ;; (SAVE-ARGUMENTS-OF-IMPLY&PROVE) (or (SAVE-ARGS)) which saves 
 ;; those arguments in the list *imply&Prove-arguments*.  When this is
 ;; employed, PROVE-EXECUTOR acts to use these old arguments.
 ;;Caution - the BACK-UP options will not work for previous back-up points.

;;(imply-break)
  (prove-executor 'restart))   

(defun rp (&optional args) (setq %plan% nil) 
   ;;(setq *global-no-reduce-light* t)
  (cond (args (setq *imply&prover-arguments* args)))     ;11July92
  (restart-prover))

(defun save-args () (save-arguments-of-imply&prove))

(defun save-arguments-of-imply&prove () ;Called by the user. 
  ;;See RESTART-PROVER.  This is called at the BREAK << level, when a
  ;; error takes place.  Then this is followed by a called to (RESTART-PROVER).

  (setq *imply&prover-arguments* 
        (list H C TL ANC LT YET %proof% %al% %NON-STOP-LIGHT% nil
              %REDUCE-LIGHT% 'NON-STOP-LIGHT %GOAL-MESSAGE% %TIME%
              %theorem-variables% %object-list%) ) t)

(DEFUN SET-DIFFERENCE-W (L L*)   ;Woody's version     6-30-89
                                  ;USED-IN (USED-INS NEW-VARIABLES NEW-VARS)
  (MAPCAN #'(lambda(X) (COND ((MEMBER X L* :test #'equal) NIL) 
                             (T (LIST X)))) L))

(DEFUN SET-INTERSECTION (L L*)   ;6-30-89
                                  ;USED-IN (NEW-VARS PROVE-THE-PREMISE UNIFY)
     (mapcan #'(lambda(X) (if (MEMBER X L* :test #'equal) (list x) nil)) L))
 
(DEFUN SET-SUBSET (A B)         ;USED-IN (OR-H)
   (COND ((EQ 'T A) NIL) 
         ((null a) t)
         ((member (car a) b :test #'equal) (set-subset (cdr a) b))
         (t nil) ))

(defun set-equal (A B) (and (set-subset A B) (set-subset B A)))

(defun set-unit (C)  ;called by IMPLY-RULES, Is C an atom from set theory?
  (cond ((atom C) nil)
        ((member (car C) '(subset proper-subset element = non-empty non-unit)))
	((eq 'not (car C)) (set-unit (cadr C)))))

(defun short ()       ;called by USER at *imply-stop*   11July92
  (let (L Hs Cs YETs)
    (setq L '((C186S (S))
	      (L114S (C186S) (C186S))
	      (C122S (L114s) (C186S))
	      (C123S (L114s) (C186S))
	      (L115S (C186S) (C186S))
	      (S124S (L114S) (C186S))
	      (S125S (L114S) (C186S))
	      (K129S (L114S) (C186S))
	      (R128S (L114S) (C186S))
	      (C133S (R128S) (RES-L (S124S) (K129S)) (L114S) (C186S))
	      (L136S (R128S) (RES-L (S124S) (K129S)) (L114S) (C186S))
	      (L135S (R128S) (RES-L (S124S) (K129S)) (L114S) (C186S))
	      (C134S (R128S) (RES-L (S124S) (K129S)) (L114S) (C186S))
	      (L144S (L136S (R128S) (RES-L (S124S) (K129S)) (L114S) (C186S))
		     (L135S (R128S) (RES-L (S124S) (K129S)) (L114S) (C186S))
		     (C134S (R128S) (RES-L (S124S) (K129S)) (L114S) (C186S))
		     (C133S) (L114S) (C186S))
              (L144S (L136S) (L135S) (C134S) (C133S) (L114S) (C186S))
	      ))
    (setq Hs H) (setq Cs C) (setq YETs YET)
    (mapc #'(lambda (u) (progn
       (setq Hs (subst (list (car u)) u Hs :test 'equal))
       (setq Cs (subst (list (car u)) u Cs :test 'equal))
       (setq YETs (subst (list (car u)) u YETs :test 'equal))) )
	  L)
    (setq H Hs) (setq C Cs) (setq YET YETs) 
    (length L) ))

(defun size (a)       ;used in ANS
  (cond ((atom a) 1)
        (t (+ (length a) (size (car a)) (size (cdr a))))))
 
(defun sp (n)   ;used in Journal Ready Proofs
  (cond ((not (numberp n)) nil)
	((< n 1) nil)
	((< n 3) (format t "  "))
	((< n 5) (format t "    "))
	((< n 7) (format t "      "))
	((< n 9) (format t "        "))
	((< n 11)(format t "          "))
	((< n 13)(format t "            "))
	((< n 15)(format t "              "))
	))

(defun split (A)    ;A is a theorem to be proved
  ;;The idea is to break A into two parts, A1 and A2 for which
  ;; A is equivalent to A1 & A2, so they can be proved separately.
  ;;E.g., (-> (& (H1) (or (H2) (H3))) C), (H2), (H3) have no vars in common
  ;; goes into    ( (-> (& (H1) (H2)) C) (-> (& (H1) (H3)) C) )
  ;;(-> H (& C D)) into ( (-> H C) (-> H D))  C,D no vars in common
  (let (W H A1 A2 C)
    (cond ((atom A) nil)
	  ((and (or (eq-car A '&) (eq-car (setq A (and-out A)) '&))
		(setq W (split2 (cdr A))))
	   (list (car W) (andify (cadr W))))
	  ((and (eq-car A '->)
		(setq H (cadr A))
		(or (eq-car H 'or) (eq-car (setq H (or-out H)) 'or))
		(setq W (split2 (cdr H))))
	   (setq A1 (list '-> (car W) (caddr A)))
	   (setq A2 (list '-> (orify (cadr W)) (caddr A)))
	   (list A1 A2))
	  ((and (eq-car A '->)
		(setq C (caddr A))
		(or (eq-car C '&) (eq-car (setq C (and-out C)) '&))
		(setq W (split2 (cdr C))))
	   (setq A1 (list '-> (cadr A) (car W)))
	   (setq A2 (list '-> (cadr A) (andify (cadr W))))
	   (list A1 A2))
	  )))

(defun split2 (L &optional (L* L))  ;called by SPLIT
  ;;eg, (split2 '((P x) (Q y) (R x))) = ( (Q y) ((P x) (R x)) )
  (let (A L2 V V2)
    (cond ((null L) nil)
	  ((and (setq A (car L)) (setq L2 (remove A L* :test 'equal))
		(null (set-intersection (free-variables-in A)
                                        (free-variables-in L2))))
	   (list A L2))
	  (t (split2 (cdr L) L*)) )))

(DEFUN subst-1 (x y L)  ;used by or-out. Replace the first x in L by y
  (cond ((null L) nil)
        ((equal y (car L)) (cons x (cdr L)))
        (t (cons (car L) (subst-1 x y (cdr L)))) ))

(defun subst-elements (L2 y L)  ;used by or-out.
  ;;This inserts the elements of L2 for y in L 
  ;;Eg, if L2=(b c), y=(or b c), and L=(or a (or b c) d), 
  ;; then the result is                (or a b c d)

  (cond ((null L) nil)
        ((equal (car L) y) (append L2 (cdr L)))
        (t (cons (car L) (subst-elements L2 y (cdr L))))
         ;;Ie,        (subst-elements L2 y (a y d)) goes to 
         ;;   (cons a (subst-elements L2 y (y d)))
          ))

(DEFUN SUB= (H%)               ;USED-IN (IMPLY-RULES)
  (declare  (special h c tl anc lt yet))
  (LET (E W P A B H* H** H3 C* THETA C&H P*)
;;(prnt c)                                                   ;$$
;;(break)                                                     
   (COND 

;;%% Set E W and P
     ((AND 
       (OR (AND (EQ '= (CAR H%))
		(SETQ E H%) (SETQ W H%) (not (setq P nil)))
	   (AND (EQ '-> (CAR H%))
		(EQ '= (CAADDR H%))
		(SETQ E (CADDR H%)) (SETQ W H%) (setq P (cadr H%)))
	   (AND (EQ '& (CAR H%))
		(SOME #'(lambda(H*) 
			  (AND (EQ '= (CAR H*)) 
			       (SETQ E H*) (SETQ W H*) (not (setq P nil))))
		      (CDR H%)))
	   (AND (EQ '& (CAR H%))
		(SOME #'(lambda(H*) 
			  (AND (EQ '-> (CAR H*))
			       (EQ '= (CAADDR H*))
			       (SETQ E (CADDR H*)) (SETQ W H*) 
			       (setq P (cadr H*))))
		      (CDR H%))))
            
;;%% Choose A and B and Replace B by A  in  H% and C.
       (SETQ A (CHOOSE (CADR E) (CADDR E)))
       (SETQ B (OTHER (LIST (CADR E) (CADDR E)) A))
       (progn (SETQ H* (DELETE-& W H%))
              (setq H3 (subst H* H% H :test 'equal))
	      (SETQ H** (SUBST= A B H3))
	      t)
       (SETQ C* (SUBST= A B C))
       (cond ((AND (EQUAL H** H3) (EQUAL C* C))
	      (cond ((and (eq-car C '=)
			  (eq-car (setq C* (minus-on (cadr C) (caddr C))) '+)
			  (setq E (minus-on (cadr E) (caddr E)))
			  (setq C* (sub=-+ E C*))   ;try the alg version on C
			  (setq C* (list '= C* 0))))
		    (t (and nil *pl* (format t "~% SUB= ~s for  ;25Mar92 nil
        ~s resulted in no change in H or C~%" A B)) 
		       nil)))
	     (t t))
       (setq c&h (cond ((equal H** H3) 'C) ((equal C* C) 'H)(t 'C&H)))
       (or (and *pl* (format t "~%SUB= - Replace  ~s  by  ~s  in  ~s~%" b a C&H)) t)
;;     (SETQ %GOAL-MESSAGE% 'SUB=)
       (SETQ %REDUCE-LIGHT% T)
       (setq H** (cond ((and (equal H** H3) (equal C* C)) H) (t H**))) ;26Mar92
       (or (setq P* (subst= A B P)) t)
       (SETQ THETA (IMPLY H** (and-on P* C*) (APPEND TL '(=)) ANC lt yet))
       (ANS THETA) )
           theta) )))

(DEFUN SUB=-+ (E C)  ;
  ;;If E and C and + formulas, the try to eliminate a strange term of
  ;; C by addition or subtraction of C and E.
  ;;eg, (SUB=-+ (+ a b c) (a b f)) goes to (+ f (- c))
  (let (E* par)
    (setq E* (strange-list (cdr E)))
    (cond ((some #'(lambda (u) 
              (setq par (cond ((member u C :test 'equal) '+)
			      ((eq '- (car u)) 
			       (cond ((member (cadr u) C :test 'equal) '-)))
			      ((member (list '- u) C :test 'equal) '-))))
		 E*)
	   (cond ((eq '+ par) (minus-on C E))
		 (t (plus-on C E)))))))

(defun strange-list (L)  ;called by SUB=-+
  (setq L (mapcan #'(lambda (u) (cond ((numberp u) nil) 
				      ((and (eq-car u '-) 
					    (numberp (cadr u))) nil)
				      (t (list u))))
		  L))
  (sort L 'stranger))

(defun stranger (A B) ;called by STRANGE-LIST
  (cond ((atom A) (cond ((atom B) t) (t nil)))
	((atom B) t)
	((eq-car A '-) (stranger (cadr A) B))
	((eq-car B '-) (stranger A (cadr B)))
	(t (>= (length A) (length B)))))



(DEFUN UNION-W (A B)    ;Woody's version of UNION
                        ;USED-IN (AND-ON AND-OR-ON ATOMS-I
			;BACK-CHAIN-DEPTH COMPOSE COUNTEREXAMPLE FC
          		;INITIALIZE NEW-VARS OR-ON REDUC UNIFY3 UNION)
  (COND ((NULL B) A)
	((MEMBER (CAR B) A :test #'equal) (UNION-W A (CDR B)))
	(T (UNION-W (APPEND A (LIST (CAR B))) (CDR B)))))

(defun unique-bound-variables (A)
  ;;called by SKOLEMIZE, DEFIN, DEFINEC
  ;;For each subformula Q of A of the form (ALL x P) or (SOME x P), replace x 
  ;; in Q by a variable not occuring in %theorem-variables% , or the rest of A.
  ;; And add to %theorem-variables% as appropriate.

  (let (x A* B B* W x*)
    (cond ((atom A) A)
	  ((member (car A)
		   '(all some set-of union-of-sets intersection-of-sets))
	   (setq x (cadr A)) (setq B (caddr A))
	   (setq B* (unique-bound-variables B))
	   (cond ((setq w (member x %theorem-variables%))
		  (cond ((and (equal B* B) (equal (cadr W) A)) A)
			(t (setq x* (new-symbol x))    ;in prove3.lisp
                           (setq B* (subst x* x B*))
			   (setq A* (list (car A) x* B*))
			   (setq %theorem-variables% 
				 (append (list x* A*) %theorem-variables%))
			   A*) ))
		 ((equal B* B)
		  (setq %theorem-variables% 
			(append (list x A) %theorem-variables%))
		  A)
		 (t (setq x* (new-symbol x))
                    (setq B* (subst x* x B*))
                    (setq A* (list (car A) x* B*))
		    (setq %theorem-variables% 
			  (append (list x* A*) %theorem-variables%))
		    A*)))

          (t (cons (unique-bound-variables (car A))
                   (unique-bound-variables (cdr A)))) )))

(defun unique-ize-variables-in (A) ;replaces all vars via GENSYM
  (mapc #'(lambda (x) (setq A (subst (gensym) x A)))
        (all-variables-in A))  A)

(defun units (H)                 ;called by GROUND-UNITS-FORWARD-CHAIN 29June92
  (cond ((atom H) nil)
	((eq-car H '&) (mapcan #'units (cdr H)))
	((member (car H) '(or ->)) nil)
	(t (list H)) ))

(defun u-thousand-ize (A) ;replace each var x by x1000
  (mapc #'(lambda (x) (setq A (subst (u-fuze (list x '1000)) x A)))
        (all-variables-in A))  A)

(defun u-fuze (L) (intern (apply #'concatenate 
			       (cons 'string (mapcar #'symbol-name L)))))

(setq *pairs-structure* (unique-ize-variables-in *pairs-structure*))

(DEFUN VARIABLES-IN (A)    ;USED-IN (COUNTEREXAMPLE GROUND NEW-VARS 
                           ;         PROVE-THE-PREMISE REPLACE-VARIABLES V)
  ;;The same as variables-in, except that there we omit quantified vars
  (CRUNCH (VARS-IN A)))

(DEFUN VARS-IN (A)         ;USED-IN (VARIABLES-IN)
  (COND ((NUMBERP A) NIL)
        ((NULL A) NIL)
        ((eq '[] A) nil)
	((ATOM A) (LIST A))
	((ATOM (CAR A))
	 (COND ((NULL (CDR A)) NIL) (T (MAPCAN 'VARS-IN (CDR A)))))
	(T (MAPCAN 'VARS-IN A))))

(DEFUN WRITE-GOAL-MESSAGE NIL              ;USED-IN (IMPLY-RULES)
  (declare  (special h c tl anc lt yet))
  (LET (TEMP)
       (SETQ TEMP %GOAL-MESSAGE%)
       (SETQ %GOAL-MESSAGE% NIL)
       (COND ((EQ 'ORIGINAL-GOAL TEMP) 
              (ANS 'GOAL H C TL 'ORIGINAL))
             ((member temp '(promote reduce-h sub= cases))
              (ANS '\: H C TL temp))
	     (TEMP (ANS '\: 'H C TL TEMP))
	     (T (ANS '\: 'H C TL 'SUBGOAL)))))

(DEFUN YESNO (R)            ;USED-IN  OK
   (COND ((MEMBER R '(Y YES OK)) T) (T NIL)))

(defvar th  '(-> (& (element x S) 
		  (all D (-> (P D) (subset D (B D))))
		  (P S))
	       (element x (B S))))

(defvar th* '(-> (& (ELEMENT x S)  
		  (all D (-> (CLAUSES D) (SUBSET D (RES D K))))
		  (clauses S))
	       (ELEMENT x (RES S NN))))

;;(trace (imply :entry `(imply ,(caddr  si::arglist)))
;;     (imply :entry `(imply ,(caddr si::arglist)))
;;       imply-rules
;;       (imply-rules* :entry `(imply-rules* ,(caddr si::arglist)))
;;       )
