
;;;*********************************************************************
;;;
;;;                     REDUCE-VE.LISP                 26 March 1990
;;;
;;;                     W. W. Bledsoe
;;;
;;;                 Called by  ve+str.lisp
;;;
;;;
;;;*********************************************************************
(defun lrve () (load "reduce-ve.lisp"))

(defun reduce-ve (A)  ;called by VE+STR, VE+STR2,...,5, VE-STR-CHAIN
  ;;For the sake of tracing, we have a separate call to reduce-ve
  ;;A is assummed to use UNARY < and <=

;  (format t " r")         ;print " r" each time reduce-ve is called
  (red A))

(defun red* (A)   ;keeps calling RED until A does not change
  (let (A2)
    (cond ((equal A (setq A2 (red A))) A)
	  (t (red* A2)))))

(defun red (A)            ;called by reduce-ve
; (format t ".")
 (let (theta A* B P C Thm)
   (cond
    ((null A) nil)			
    ((atom A) A)
    ((and (eq '= (car a)) 
	  (eval (list 'equal (list 'quote (cadr a))  ;(= A A)  ~>  true
		      (list 'quote (caddr a)))))
     '(true))

    ((and (null (cdr A)) (eq '+ (car A))) 0)     ;(+) goes to 0
    ((and (null (cdr A)) (eq '* (car A))) 1)     ;(*) goes to 1

    ((and (null (cddr A)) (member (car A) '(+ *))) (cadr A)) ; (+ a)  goes to a

    ((eq 'not (car A))               ;eg, A= (not (<= 1 2))
     (cond ((atom (cadr A)) A)
	   ((eq 'not (caadr A)) (cadadr A)) ; ~~A goes to A
           ((Eq '< (caadr a)) (red (list '<= (list '- (cadadr a)))))
           ((eq '<= (caadr a)) (red (list '< (list '- (cadadr a)))))
	   ((eq-car (cadr A) '&)        ;eg, (not (& A B)) goes to (or ~A ~B)
	    (red (cons 'or (mapcar #'(lambda (u) (red (list 'not u)))
				   (cdadr A)))))
	   (t (list 'not (red (cadr A))))))
 
   ((eq '- (car A))
     (cond ((numberp (cadr a)) (- (cadr a)))
	   ((atom (cadr A)) A)
	   ((eq '- (caadr A)) (cadadr A)) ;(- (- B)) goes to B
	   ((eq '+ (caadr a)) 
	    (red (cons '+ (mapcar #'neg-on (cdadr a))) ))
	    ;;(- (+ B C D)) goes to (+ (- B) (- C) (- D))
	   (t (list '- (red (cadr A) )))))

    ((and (eq '< (car A))  (numberp (cadr a)) (<  (cadr a) 0)) '(TRUE))
    ((and (eq '<= (car A)) (numberp (cadr a)) (<= (cadr a) 0)) '(TRUE))
    ((and (eq '< (car A))  (numberp (cadr a)) (<= 0 (cadr a))) '(FALSE))
    ((and (eq '<= (car A)) (numberp (cadr a)) (<  0 (cadr a))) '(FALSE))

    ((and (member (car A) '(+ * - = < <=))
	  (not (equal A (setq A* (cons (car A) 
	          (mapcar #'(lambda (x) (red x)) (cdr A)))))))
     (red A*))

    ((and (eq '+ (car A)) (eq-car (cadr A) '+))   ;(+ (+ ..) ..) ~> (+ ....)
      (red (cons '+ (append (cdadr A) (cddr A))) ))
     ((and (member (car A) '(+ * - /)) (every #'numberp (cdr a)))  (eval a))
     ((and (eq '+ (car A)) 
	   (not (equal (cdr a) (setq a* (reduce-alg-ve (cdr a))))))
      (cond ((null a*) 0)
	    ((numberp a*) a*)
	    (t (red (cons '+ a*) ))))

     ((and (eq '* (car A)) 
	   (not (equal (list A) (setq A* (reduce-alg-ve (list A))))))
      (cond ((null a*) 0)
	    ((numberp a*) a*)
	    (t (red (cons '+ a*) ))))
     ((member (car A) '(< <=)) 
      (cond ((equal A (list (car a) (red (cadr a) )))
	     (reduce-algebraically-ve A))
	    (t A)))
     ((and (eq-car A 'element) (eq-car (caddr A) 'set-of))
      ;;A= (element x (set-of z% (P z%))) ~-> (P x)
      (red (subst (cadr A) (cadr (caddr A)) (caddr (caddr A)))))
     ((and (eq-car A 'subset) (atom (cadr A))   
	   (eq-car (setq B (caddr A)) 'set-of))
      ;;A= (subset D (set-of z% (element z% E))) goes to (subset D E)
      (subst (red B) B A :test 'equal))
;;     ((and (eq-car A 'set-of) (eq-car (setq B (caddr A)) 'element))
;;       ;;A= (set-of z% (element z% E)) goes to E
;;      (caddr B))
     ((and (eq-car A 'element) (equal (caddr A) '(opens)))  ;17oct92
      ;;A= (element D (opens)) ~-> (open D)
      (list 'open (cadr A)))
     ((and (eq-car A 'not) (occurs 'subset (cadr A))
	   (equal '(true) (red* (cadr A))))
      nil)
     ((and (eq-car A 'not) (occur 'opens (cadr A)))         ;17oct92
      (list 'not (red (cadr A))))
     ((and (eq-car A 'subset)   ;(subset (set-of z% (P z%)) (set-of z% (Q z%)))
	   (eq-car (setq B (cadr  A)) 'set-of)              ;29oct92
	   (eq-car (setq C (caddr A)) 'set-of)
	   (eq (cadr B) (cadr C))
	   (setq thm (subst 'z 'z% (imp-on (caddr B) (caddr C))))
	   (eq-car (otter-prove Thm
			 :inference-rules '(binary_res para_into para_from)
			 :time 3
			 :base-axioms nil)
		   t))
      '(TRUE))
     ;;SET-OF Rules
     ((and (occur 'set-of A) (member (car A) '(& or -> not all some)))
      (cons (car A) (mapcar #'red (cdr A))))             ;24Nov92
;;   ((and (occur 'set-of A) (eq-car A 'not)) (list 'not (red (cadr A))))
     ((and (occur 'set-of A) (eq-car A 'subset))        ;(subset D (P set-of))
      (list 'all 'x (imp-on (red (list 'element 'x (cadr A)))
			    (red (list 'element 'x (caddr A))))))
     ((and (eq-car A 'element) (eq-car (setq B (caddr A)) 'set-of))
                                                ;(element x (set-of z% (P z%)))
      (red (subst (cadr A) (cadr B) (caddr B) :test 'equal)))     ;(P x)
     ((and (eq-car A 'element) (eq-car (setq B (caddr A)) 'union)
	   (occur 'set-of B))                 
      ;;(element x (union H)) goes to (some A (& (element A H) (element x A)))
      (list 'some 'A (and-on (red (list 'element 'A (cadr B)))
			          (list 'element (cadr A) 'A))))
     ((and (not (atom A)) (occur 'opens A))      ;(not (atom (car A))) 18Nov92
      (mapcar #'red A))

     (t A)
     )))

(defun ground-reduce (A R)
  ;;This Reduces the formula A by the Rules (pairs) in R
  (let (A*)
       (setq A* A) 
       (mapc #'(lambda (rl) (setq A* (subst (cadr rl) 
                                            (car rl) A* :test 'equal)))
             R)
       (cond ((equal A* A) A)
             (t (ground-reduce A* R)))))

 
(DEFUN NEG-ON (A) (REDUCE-VE (LIST '- A)))

(defun numbers-in (a) 
 (let (W)
  (cond ((null a) (list nil nil))
        ((atom a) (cond ((numberp a) (list (list a) nil))
                        (t (list nil (list a)))))
        ((atom (car a)) (cond ((numberp (car a))
                               (setq w (numbers-in (cdr a)))
                               (list (cons (car a) (car w)) (cadr w)))
                              )))))

(defun Numbers-negs-first (x y)		;Used by reduce-alg, in SORT
  ;;Put numbers (in order) first, then negations
  (cond ((numberp x) (cond ((numberp y) (<= x y)) (T T)))
        ((numberp y) nil)
        ((atom x) (cond ((atom y) T) ((eq '- (car y)) nil) (t t)))
        ((eq '- (car x)) 
	 (cond ((atom y) t) 
	       ((eq '- (car y)) (numbers-negs-first (cadr x) (cadr y)))
	       (t t)))
        ((atom y) t)
        ((eq '- (car y)) nil)
        ((eq '+ (car x)) t)
        ((eq '+ (car y)) nil)
        ((eq '* (car x)) t)
        ((eq '* (car y)) nil)
        (t t) ))

(defun occur (x y)   ;used-in (appl-e called-in choose not-formula  reduc)
  (cond ((equal y x))
	((atom y) nil)
	((occur x (car y)))
	((occur x (cdr y)))))

(defun reduce-algebraically-ve  (A)			;Called from options
  ;;This tries to reduce A (an inequality formuls) by a stronger 
  ;;set of reduction rules than are used in REDUC
  ;;eg, (< (+ (- (* (X1) (X1))) -1 (* (X1) (X1)))) is reduced to 
  ;;    (< -1)  (which means ( -1 < 0 ), which is true.)

  (let (A* A**)
    (cond ((atom A) A)
	  ((not (member (car a) '(< <=))) A)
          ((atom (cadr a)) A)
          ((not (eq '+ (car (setq A* (cadr A))))) A)

	  ((null (setq A** (reduce-alg-ve (cdr A*))))
;	   (format t "~% ~s  REDUCED ALGEBRAICALLY to ~s ~%" A* 0)
;	   (ans* (list A* 'Reduced-Algebraically-to 0))
	   (list (car A) 0))

          ((not (equal A** (cdr A*)))
           (setq A** (cond ((cdr A**) (cons '+ A**)) (T (car A**))))
;	   (format t "~% ~s  REDUCED ALGEBRAICALLY to ~% ~s ~%" A* A**)
;	   (ans* (list A* 'Reduced-Algebraically-to A**))
           (reduce-algebraically-ve (list (car A) A**)) )
	  (t A) )))

(defun reduce-alg-ve (L)    ; Called by RED
  ;; eg, L = ((* (N) (N)) (N) (* 2 (N)) 2 (- (* (N) (N))) 
  ;;          (- (N)) (- (N)) (- (N)) -1 -1)
  ;; L should be thought as the argument list of an + expression,
  ;;   eg, for (+ a b c),  L = (a b c)

;  (format t "+")  ;Print a + each time this is accessed

  (let (L* H A L**)

    (setq L* (sort (copy-tree L) 'Numbers-negs-first))  
    ;;Put numbers (in order) first, then negations
    ;; eg, L* = (-1 -1 2 (- (* (N) (N))) (- (N)) (- (N)) (- (N)) 
    ;;                   (* (N) (N)) (N) (* 2 (N)))

    (cond ((atom L*) L*)
          ((numberp (setq H (car L*)))
           (cond ((zerop H) (reduce-alg-ve (cdr L*))) ;remove 0's
                 ((null (cdr L*)) L*)
                 ((numberp (cadr L*))	;L* = (2 3 c ...)                 
                  (reduce-alg-ve (cons (+ H (cadr L*)) (cddr L*))))
                 (t (cons H (reduce-alg-ve (cdr L*))))))
          
          ((atom H) (cons H (reduce-alg-ve (cdr L*))))

          ((eq '- (car H))		;L* = ((- a) ....), H = (- a)
	   (cond ((numberp (cadr H))	;L* = ((- 3) ....), H = (- 3)
                  (reduce-alg-ve (cons (- (cadr H)) (cdr L*)))) ;to (-3 ...)
                 ((member (setq A (cadr H)) (cdr L*) :test 'equal) 
					;L* = ((- a) ... a ...)
		  (reduce-alg-ve (remove-one A (cdr L*))))
                 ((and (not (atom (cadr H))) (eq '+ (caadr H)))
                     ;;L* ((- (+ a b)) c d) goes to ((- a)(- b) c d)
                  (reduce-alg-ve (append (mapcar #'(lambda (x) (list '- x)) 
                                              (cdadr H))
                                      (cdr L*))))
		 (t (cons H (reduce-alg-ve (cdr L*)))) ))
	  ((eq '* (caar L*))		;L* = ((* a b ...) ...)
	   (setq A (sort (copy-tree (cdar L*)) 'Numbers-negs-first)) 
					;A = (a b ...)
	   (cond ((equal 0 (car A))	;L* = ((* 0 b ...) c ...), A=(0 c ...)
		  (reduce-alg-ve (cdr L*)))
		 ((member (car A) '(1 2 3 4 5 6) :test 'equal)
					;L* = ((* 2 b ...) ...)  A=(2 b ...)
		  (setq L** (multiply-out A))
		  ;;L** = ((* b ...)(* b ...) ...)
		  (reduce-alg-ve (append L** (cdr L*))))
                 ((and (not (atom (car a))) (eq '* (caar A)))
		  ;;A = ((* c d ...) e f ...)
                  (setq A (append (cdar A) (cdr A))) ; A = (c d ... e f ...)
		  (reduce-alg-ve (cons (cons '* A) (cdr L*))))
		 (t (cons (car L*) (reduce-alg-ve (cdr L*)))) ))
	  ((eq '+ (caar L*))		;L* = ((+ a b) c d), to (a b c d)
	   (reduce-alg-ve (append (cdar L*) (cdr L*))))
	  (t (cons (car L*) (reduce-alg-ve (cdr L*)))) )))
 
(defun multiply-out (A)  ;A has the form (2 b ...) or (3 b ...) etc
  ;;(2 b ...) goes to ((b ...) (b ...)) etc.
  (cond ((atom A) A)
        ((not (numberp (car A))) A)
        ((zerop (car A)) 0)            ;This should not happen
        ((equal 1 (car A)) (cond ((cddr A) (list (cons '* (cdr A))))
                                 ((cdr  A) (cdr A))  ;ie, (list (cadr A))
                                 (t A)))   ;This should not happen
        (t (cons (cond ((cddr a) (cons '* (cdr a)))
		       ((cdr  a) (cadr a))
		       (t a))		   ;This should not happen
                 (multiply-out (cons (1- (car a)) (cdr a))))) ))


(defun remove-one (x L)   ;remove the first x from L 
  (cond ((equal x L) nil)
        ((atom L) L)
        ((equal x (car L)) (cdr L))
        (t (cons (car L) (remove-one x (cdr L)))) ))

(defun binary->unary< (A)                 ;7sep92
  ;;eg, (binary->unary< '(<= 1 2)) = (<= -1)
  (cond ((atom A) A)
	((and (not (occur '< A)) (not (occur '<= A))) A)
	((and (member (car A) '(< <=)) (cddr A)) ;A= (< x y)
	 (list (car A) (minus-on (cadr A) (caddr A))))
	(t (cons (binary->unary< (car A)) (binary->unary< (cdr A))))))


;;****************************************************************************

(defvar thm '(= (+ (* (N) (N)) (N) (* 2 (N)) 2)
		(+ (* (N) (N)) (N) (N) (N) 1 1)))

(defvar thm* '(= (+ (* 3 (N)) 2) (+ (N) (N) (N) 1 1)))

(defvar am '((* (N) (N)) (N) (* 2 (N)) 2 (- (* (N) (N))) 
(- (N)) (- (N)) (- (N)) -1 -1))
