
;;                reformulate.lisp                        18Nov94

;; This program is to Implement the Reformulation Rule, ADD-ARGUMENT,
;; descriped by Erica Melis in her proposed paper, Section 4.1.
;;
;;The theorem, lemmas, proof, and KB are in the file, hb-data.lisp

(defun lrf () (load "reformulate.lisp"))
(defun lhd () (load "hb-data.lisp"))
(defun tr  () (trace add-arg aa aaa aa2 aa-quan aa-dup aa-dupp aa-dup3))
(defvar *xxn* 0)

(defun reformulate (th1 th2 lemmas plan)             ;not used
  (let () $

   ))

(defun add-arg (A S S3 S4)  ;18Nov94  19Dec94 (S4)
  ;;S is a list of pairs of atomic formulas, like ((nt x y) (rect x y r s))
  ;;A is a formula
  ;;Eg, (add-arg  '(length (nt a b)) '(((nt x y) (rect x y r s))))
  ;;    =  (length* (rect a b r* s*))
  (let (A* S* A5 A6n)
    (setq *xxn* 0)
    (setq S* (mapcan #'(lambda (pr) (cond ((atom (car pr)) nil)
					  (t (list pr)))) S))
	
    (cond ((some #'(lambda (pr) 
		  (not (member (/ (length (cdadr pr)) (length (cdar pr)))
			       '(1 2 3 4 5))))
		 S*)
	   (format t "~%A problem in add-arg ~%") (break)))
    (setq A* A)
    (mapc #'(lambda (pr) (setq A* (aa A* pr))) S*)
    (setq A5 A*)
    (mapc #'(lambda (pr3)        ;pr3= (((nt x y) (rect x y r s)) (lf rt))
               (setq n (/ (length (cdr (cadar  pr3))) 
			  (length (cdr (caar pr3)))))
	       (setq A5 (aa-dup3 A5 pr3 n))) 
	  S3)
;;(prnt A5) (break)
    (setq A6 A5)
    (mapc #'(lambda (pr)                  ;pr= (R R2)
               (setq A6 (aa-constants A6 (car pr) (cadr pr))))
	  S4)
    A6))

(defun aa (A pr)     ;18Nov94   Called by ADD-ARG 7Dec94
  (let (f1 f2 rest1 rest2 A2 A3 A4 k n)                   
    (setq f1 (caar pr)) (setq f2 (caadr pr))  
    (setq rest1 (cdar pr)) (setq rest2 (cdadr pr))
    (setq n (/ (length rest2) (length rest1)))
    (setq A2 (aaa A f1 f2 n))
    (setq k (length rest1))
    (setq A3 (cond ((< 1 k) (aa-quan A2 f2 k)) (t A2)))
    (setq A4 (aa-dup  A3 f2 k))
    A4
 ))

(defun aaa (A f1 f2 n)  ;18Nov94 Called by AA
  ;;Eg, (aaa '(g a b) 'g 'h 2)
  (aaa* A f1 f2 n))

(defun aaa* (A f1 f2 n)  ;17Dec94 Called by AAA (only for tracing)
  (let ()
    (cond ((eq-car A f1)
	   (aa2 f2 (cdr A) n))
	  ((atom A) A)
	  ((member (car A) '(some all -> & or not))
	   (cons (car A) (mapcar #'(lambda (u) (aaa* u f1 f2 n)) (cdr A))))
	  ((atom (car A))
	   (cons (car A) (mapcar #'(lambda (u) (aaa* u f1 f2 n)) (cdr A))))
	  (t (mapcar #'(lambda (u) (aaa* u f1 f2 n)) A)) )))

(defun aa2 (f2 L n &optional (L* L))     ;18Nov94   Called by AAA*
  ;;Eg, (aa2 'f '(x y z) 3) = (f x y z x* y* z* x** y** z**)
  (let (L2 L3 g g*)
    (cond ((<= (setq n (1- n)) 0) (cons f2 L))
	  (t (setq L2 (mapcar #'(lambda (x) 
		                   (cond ((atom x) (maknam (list x '*)))
					 ((atom (setq g (car x)))
					  (setq g* (maknam (list g '*)))
					  (cons g* (cdr x)))
					 (t (format t "~%Problem in AA2~%")))) 
			      L*))
	     (setq L3 (append L L2))
	     (aa2 f2 L3 n L2)))))

(defun aa-quan (A f2 k)  ;7Dec94  Called by AA
  ;;Add to A the needed additional quantifiers
  ;;Eg, (aa-quan '(some x (some y (g x y z w))) 'g 2)
  ;;   = (some x (some y (some z (some w (g x y z w)))))
  (aa-quan* A f2 k))

(defun aa-quan* (A f2 k)  ;17Dec94  Called by AAA (for tracing)
  (let (sym x A2 f2term xps A*)
    (cond ((atom A) A)
	  ((member (car A) '(some all))
	   (setq sym (car A)) (setq x (cadr A)) 
	   (setq A2 (aa-quan* (caddr A) f2 k))
	   (cond ((setq f2term (occur-term-with f2 A2 x))  ;f2term=(f2 ...)
		  (setq xps (xpairs (cdr f2term) x k))
		  (setq A* (add-quantifiers sym A2 xps))
		  (list sym x A*))
		 (t (list sym x A2))))
	  ((not (or (occur 'some A) (occur 'all A))) A)
	  ((member (car A) '(-> & or not))
	   (cons (car A) (mapcar #'(lambda (u) (aa-quan* u f2 k)) (cdr A))))
	  (t (mapcar #'(lambda (u) (aa-quan* u f2 k)) A)) )))

(defun aa-dup (A f2 k &optional (flag2 t) f2ts)  ;9Dec94  Called by AA
  ;;flag2=t means first entry.  
  ;;f2t means f2term. Eg, f2t=(f2 x y z w).
  ;;Eg, (aa-dup '(SOME u (SOME v (SOME r (SOME s
  ;;        (& (< u v) (subset (rect u v r s) B) (center z (rect u v r s)))))))
  ;;            'rect 2)
  ;; =   (SOME u (SOME v (SOME r (SOME s
  ;;(& (< u v) (< r s) (subset (rect u v r s) B) (center z (rect u v r s)))))))
  (let (sym A* x x* A2 A2*)
    (cond ((atom A) A)
	  ((numberp (setq sym (car A)))         
	   (list (car A) (cadr A) (aa-dup (caddr A) f2 k flag2 f2ts)
		 (cadddr A)))
	  ((not (atom sym))
	   (mapcar #'(lambda (u) (aa-dup u f2 k flag2 f2ts)) A))
	  (flag2 (cond ((occur f2 A) 
			(setq f2ts (fts f2 A))
			(aa-dup A f2 k nil f2ts)) 
		       (t A)))
	  ;;Below here, it is NOT the first entry (ie, flag2=nil)
          ;;Also, f2 HAS BEEN in A, but may not be in this subformula.
	  ((occur f2 A)                        ;ie, f2 is STILL in A
	   (cond ((numberp (setq sym (car A)))
		  (list (car A) (cadr A) (aa-dup (caddr A) f2 k nil f2ts)
			(cadddr A)))
		 ((not (atom sym))
		  (mapcar #'(lambda (u) (aa-dup u f2 k nil f2ts)) A))
		 ((member sym '(some all))		 
		  (setq x (cadr a)) 
		  (setq A2* (aa-dup (caddr A) f2 k nil f2ts))
		  (list sym x A2*))
		 ((member sym '(-> & or not))
		  (reduce&or (cons sym (mapcar #'(lambda (u) 
						   (aa-dup u f2 k nil f2ts))
				    (cdr A)))))
		 (t A)))
	  ((numberp (setq sym (car A)))         ;now, f2 is not in A 
	   (list (car A) (cadr A) (aa-dup (caddr A) f2 k nil f2ts)
		 (cadddr A)))
	  ((not (atom sym))
	   (mapcar #'(lambda (u) (aa-dup u f2 k nil f2ts)) A))
	  ((member sym '(some all))		 
	   (setq x (cadr a)) 
	   (setq A2* (aa-dup (caddr A) f2 k nil f2ts))
	   (list sym x A2*))
	  ((member sym '(-> & or not))
	   (cons sym (mapcar #'(lambda (u) (aa-dup u f2 k nil f2ts))
			     (cdr A))))
	  ((not (some #'(lambda (L) (some #'(lambda (x) 
                                               (and (occur x A) (setq L* L)))
					  L))
		      f2ts))
	   A)
	  (t (setq A* (aa-dupp A L* (first-n k L*) k))) )))

(defun aa-dupp (A L fk k)   ;9Dec94  Called by AA-DUP
  ;;Eg, (aa-dupp '(< u v) '(u v r s) '(u v) 2) = (& (< u v) (< r s))
  (let (nextk theta A* L*)
    (cond ((null L) nil)
	  (t (setq nextk (first-n k L))             ;nextk=(u v) or (r s)
	     (setq theta (mapcar #'(lambda (x y) (cons x y)) fk nextk))
	     (setq A* (sublis theta A))
	     (setq L* (all-but-first-n k L))
	     (and-on A* (aa-dupp A* L* fk k))) )))

(defun aa-dup3 (A pr3 n)   ;9Dec94   Called by ADD-ARG
  ;;Eg, (aa-dup3 '(<= (lf A) (rt A)) '(((nt x y) (rect x y r s)) (lf rt)) 2) 
  ;; =            (& (<= (lf A) (rt A)) (<= (lf* A) (rt* A)) )
  (let (ntpr lrpr lff rtf lrf lff* rtf* lrf* lrf** A* ntpr2 
	     lrf3 lrf4 lrf5 lrf6 cdr3 y)
    (setq ntpr (car pr3))           ;ntpr= ((nt x y) (rect x y r s))
    (setq lfpr (cadr pr3))          ;lfpr= (lf rt)
    (setq lff (car lfpr)) (setq rtf (cadr lfpr))
    (cond ((atom A) A)
	  ((numberp (car A))
	   (list (car A) (cadr A) (aa-dup3 (caddr A) pr3 n) (cadddr A)))
	  ((not (atom (car A)))
	   (mapcar #'(lambda (u) (aa-dup3 u pr3 n)) A))
	  ((member (car A) '(some all lambda))
	   (list (car A) (cadr A) (aa-dup3 (caddr A) pr3 n)))
	  ((member (car A) '(-> & or not))
	   (reduce&or (cons (car A) (mapcar #'(lambda (u) (aa-dup3 u pr3 n))
				 (cdr A)))))
	  ((and (or (occur lff A) (occur rtf A))    ;or 17Dec94
		(setq lrf (occur-term-in lff rtf A)))  ;lrf= (<= (lf A) (rt A))
                                           ;or lrf= (= (lf (rect x y x* y*)) x)
	   (cond ((and (setq ntpr2 (cadr ntpr))        ;ntpr2= (rect x y r s)
		       (setq lrf3 (occur-term (car ntpr2) lrf))
                                                       ;lrf3= (rect x y x* y*)
		       (setq lrf4 (subst 'xxaa-dup3 lrf3 lrf :test 'equal))
		       (some #'(lambda (x) (occur x lrf4)) (cdr lrf3)))
		  (setq lrf5 lrf4) (setq cdr3 (cdr lrf3))
		  (mapc #'(lambda (x) 
                     (cond ((setq y (npastx x n cdr3))
			    (setq lrf5 (subst y x lrf5 :test 'equal)))))
			cdr3)
		  (setq lrf6 (subst lrf3 'xxaa-dup3 lrf5)))
		 (t (setq lrf6 lrf)))
	   (setq lff* (maknam (list lff '*))) 
	   (setq rtf* (maknam (list rtf '*)))
	   (setq lrf* (subst rtf* rtf 
			     (subst lff* lff lrf6 :test 'equal) :test 'equal))
	   (setq lrf** (and-on lrf lrf*))
	   (cond ((and (eq '= (car lrf)) (eq '= (car lrf*))
		       (or (equal (cadr  lrf) (cadr  lrf*))
			   (equal (caddr lrf) (caddr lrf*))))
		  (setq A* A))
                  ;;17Dec94 NOTE This acts like n=2.  We can fix that (later)
		 (t (setq A* (subst lrf** lrf A)))))
	  (t A) )))

(defun aa-constants (A c1 c2 &optional reject)  ;17Dec94  Called by ADD-AGR
  ;;eg, (aa-constants L1 'R 'R2) = L1 
  ;;L1= (ALL X (-> (E X R) (= X (/ X (EXP 2 0)))))
  ;;eg, (aa-constants L9 'R 'R2) = L9   (Erica's version of L9)
  ;;eg, (aa-constants '(& (e u R) (center x (nt u v))) 'R 'R2) = same
  (let (tm xx ty tm* A*)
    (cond ((setq tm (occur-term-in c1 c1 A reject))     ;tm= (e x R)
	   (setq xx (remove c1 (variables-in tm)))      ;ty= (e x R)
	   (cond ((some #'(lambda (x) (setq ty (type-r x A tm)))
			xx)
		  (aa-constants A c1 c2 (cons tm reject)))
		 (t (setq tm* (subst c2 c1 tm :test 'equal))
		    (setq A* (subst tm* tm A))
		    (aa-constants A* c1 c2 (cons tm reject)))))
	  (t A))))

(defun type-r (x A tm)  ;17Dec94  Called by AA-CONSTANTS
  ;;(type-r 'x '(= X (/ X (EXP 2 0))) '(e x R)) = (e x R)
  (let (terms types theta ty)
    (setq terms (crunch (remove tm (terms-in A x) :test 'equal)))
                                          ;atomic terms of A with x in them
    (setq types (cadr (assoc 'types KB)))
    (cond ((some #'(lambda (u) (some #'(lambda (v)
                                 (and (setq theta (instance u (car v)))
				      (setq ty (apply-sub theta v))
				      (consistent tm ty)))
				     types))
		 terms)
	   ty) )))

#|
(defun aa-constants (A c1 c2 &optional reject)  ;17Dec94  Called by ADD-AGR?
  ;;eg, (aa-constants L1 'R 'R2) = L1 
  ;;L1= (ALL X (-> (E X R) (= X (/ X (EXP 2 0)))))
  ;;eg, (aa-constants L9 'R 'R2) = L9   (Erica's version of L9)
  ;;eg, (aa-constants '(& (e u R) (center x (nt u v)))) = same
  (let (tm xx ty tm* A*)$
    (cond ((setq tm (occur-term-in c1 c1 A reject))     ;tm= (e x R)
	   (setq xx (remove c1 (variables-in tm)))      ;ty= (e x R)
	   (cond ((some #'(lambda (x) (type-rr x A tm (list tm))) xx)
		  (aa-constants A c1 c2 (cons tm reject)))
		 (t (setq tm* (subst c2 c1 tm :test 'equal))
		    (setq A* (subst tm* tm A))
		    (aa-constants A* c1 c2 (cons tm reject)))))
	  (t A))))


(defun type-rr (x A tm &optional reject)  ;21Dec94 Called by AA-CONSTANTS
  ;;eg, (type-rr 'u  (& (e u R) (center x (nt u v)))) = t
  (let ()$
    (cond ((setq tm2 (occur-term-in x x A rejecct))  ;tm2= (nt u v)$$))))
|#

(defun all-but-first-n (n L)  ;9Dec94  Called by AA-DUPP
  ;;Eg, (all-but-first-n 3 '(a b c d e f g h)) = (d e f g h)
  (cond ((equal 0 n) L)
	(t (all-but-first-n (1- n) (cdr L)))))

(defun add-quantifiers (sym A V)  ;7Dec94  Called by AA-QUAN*
  ;;eg, (add-quantifiers 'some '(P x y) '(y z))
  ;;    =        (some y (some z (P x y)))
  (let (A*)
    (cond ((null V) A)
	  (t (setq A* (add-quantifiers sym A (cdr V)))
	     (list sym (car V) A*)))))


 (defun consistent (tm ty) ;17Dec94  Called by AA-CONSTANTS
  ;;eg, (consistent '(e x R)
  ;;                '((/ X (EXP 2 0)) ((E X R) (E (EXP 2 0) R)))) = t
  (let () 
     (member tm (cadr ty) :test 'equal)))

(defun find-sub-constants-in (pr f A &optional reject)   
  ;10Dec94  Called from hb-data.lisp
  ;;eg, (find-sub-constants-in '((nt x y) (rect x y r s)) 'nt 
  ;;            '(all D2  (-> (clsd-int D2)  (= D2 (nt (lf D2) (rt D2))))))
  ;; =                         (((nt x y) (rect x y r s)) (lf rt))
  (let (ft L)                  
    (cond ((setq ft (occur-term f A reject))  ;ft= (nt (lf D2) (rt D2))
	   (cond ((some #'(lambda (x) (atom x)) (cdr ft)) 
		  (find-sub-constants-in pr f A (cons ft reject)))
		 (t (setq L (mapcar 'car (cdr ft)))  ;L= (fl rt)
		    (list (list pr L)))))
	  (t nil) )))

(defun fts (f A &optional L reject)  ;22Dec94  Called by AA-DUP
  ;;eg, (fts 'rect '(SUBSET (RECT C D C* D*) (RECT U V U* V*)))
  ;;   =      ((C D C* D*) (U V U* V*))
  (let (ft L* reject*)
    (cond ((setq ft (occur-term f A reject))
	   (setq L* (crunch (append L (list (cdr ft)))))
	   (setq reject* (cons ft reject))
	   (fts f A L* reject*))
	  (t L))))

(defun npastx (x n L)  ;17Dec94 Called by aa-dup3 
  ;;select from L the element y, n posiitions past x, if x,y are in L.
  ;;eg, (npastx 'a 3 '(c a b c d e)) = d
  (let (y) 
    (cond ((null L) nil)
	  ((equal x (car L)) (car (all-but-first-n n L)))
	  (t (npastx x n (cdr L))))))

(defun occur (x A)  ;17Dec94 Often used
  (occur** x A))

(defun occur** (x A)  ;17Dec94 Called by OCCUR  (for Trace)
  (cond ((equal x A) t)
	((atom A) nil)
	((occur** x (car A)) t)
	((occur** x (cdr A)) t)
	(t nil)))

(defun occur-term (f A &optional reject)   ;7Dec94  Called by AA-QUAN*
  ;;Eg, (occur-term 'g '(some x (some y (g x y z w)))) = (g x y z w)
  (occur-term* f A reject))

(defun occur-term* (f A &optional reject)   ;17Dec94  Called by OCCUR-TERM
  (let (ft)
    (cond ((atom A) nil)
	  ((member A reject) nil)
	  ((not (occur f A)) nil)
	  ((member A reject :test 'equal) nil)  ;10Dec94 used by
	  ((eq-car A f) A)                      ;        FIND-SUB-CONSTANTS-IN
	  ((setq ft (occur-term* f (car A) reject)) ft)
	  ((setq ft (occur-term* f (cdr A) reject)) ft)
	  (t nil) )))

(defun occur-term-with (f A x &optional reject)  ;21Dec94 Called by AA-QUAN*
  (let (ft)
    (cond ((atom A) nil)
	  ((member A reject) nil)
	  ((not (occur f A)) nil)
	  ((member A reject :test 'equal) nil)  ;10Dec94 used by
	  ((and (eq-car A f) (occur x A)) A)         
	  ((setq ft (occur-term-with f (car A) x reject)) ft)
	  ((setq ft (occur-term-with f (cdr A) x reject)) ft)
	  (t nil) )))

(defun occur-term-in (f1 f2 A &optional reject)   ;7Dec94  Called by AA-QUAN* 
  ;;17Dec94 or for &
  ;;Eg, (occur-term-in 'lf 'rt '(some x (some y (& Q (<= (lf x) (rt x)) R))))
  ;; = (<= (lf x) (rt x))
  (let (term)
    (cond ((atom A) nil)
	  ((member A reject :test 'equal) nil)
	  ((not (or (occur f1 A) (occur f2 A))) nil)
	  ((member (car A) '(some all))(occur-term-in  f1 f2 (caddr A) reject))
	  ((member (car A) '(-> & or not))
	   (cond ((some #'(lambda (u) 
                                (setq term (occur-term-in f1 f2 u reject)))
			(cdr A))
		  term)
		 (t nil)))
	  ((or (occur f1 A) (occur f2 A)) A)
	  (t nil) )))

(defun reduce&or (A)  ;15Sept94   from High-low2.lisp 21Dec94
  (let (u2 A2)
    (cond ((atom A) A)
	  ((and (member (car A) '(& or))   ;(& a (& b c) d) ->> (& a b c d)
		(some #'(lambda (u) (and (eq-car u (car A)) (setq u2 u)))
		      (cdr A)))
	   (setq A2 (cons (car A) (mapcan #'(lambda (u) 
                            (cond ((equal u u2) (cdr u)) (t (list u))))
					  (cdr A))))
	   (reduce&or A2))
	  ((member (car A) '(-> & or not some all))
	   (cond ((equal A (setq A2 (cons (car A) 
					  (mapcar #'reduce&or (cdr A)))))
		  A)
		 (t (reduce&or A2))))
	  (t A))))

(defun terms-in (A x)  ;17Dec94 Called by TYPE.  Terms fo A with x in them.
  ;;eg, (terms-in '(= X (/ X (EXP 2 0))) 'x) 
  ;; =    ((= X (/ X (EXP 2 0))) (/ X (EXP 2 0)))
  (let () 
    (cond ((equal A x) nil)
	  ((atom A) nil)
	  ((not (occur x A)) nil)
	  ((member (car A) '(some all)) (terms-in (caddr A) x))
	  ((member (car A) '(-> & or not))
	   (mapcan #'(lambda (u) (terms-in u x)) (cdr A)))
	  ((not (atom (car A)))                ;This, then, is a plan
	   (terms-in (cadr A) x))
	  (t (cons A (mapcan #'(lambda (u) (terms-in u x)) (cdr A)))))))


    
(defun xpairs (L x k &optional (flag t) i)  ;7Dec94  Called by AA-QUAN*
  ;;(xpairs '(x y z w r s) 'y 2) = (w s)
  (let ()
    (cond ((null L) nil)
	  (flag (cond ((eq x (car L)) (xpairs (cdr L) x k nil k))
		      (t (xpairs (cdr L) x k flag i))))
	  ((equal i 1)
	   (cons (car L) (xpairs (cdr L) x k nil k)))
	  (t (xpairs (cdr L) x k nil (1- k))) )))
		       
