
;;;                  USES-ONLY.LISP                      13Sept93
;;;
;;;Used by PC.lisp, for discarding some of the lemmas and 
;;; hypotheses not needed in the proof by struve or otter.
;;;
;;;

(defun luo () (load "uses-only.lisp"))

;;;14Sept93  This file is far from complete or organized
;;;eg, see another version of USES-ONLY below
		
(defun uses-only (lemmas H C) ;13Sep93
  (let (W V Va Vf Lems Hs x Hs2 Lems2 Hs3 Lems3)
    (setq W (syms C)) 
    (setq Va (car W)) (setq Vf (cadr W)) (setq V (append Va Vf))
    
    (setq Lems (occur-s Lemmas Va Vf))
    (setq Hs   (occur-s H      Va Vf))
(prnt Hs Lems) (break)    
    (setq Hs2   (remove-=base Hs))
    (setq Lems2 (remove-=base Lems))
(prnt Hs2 Lems2) (break)    
    (cond ((null Vf) 
	   (setq Hs3 (mapcan #'(lambda (H) 
                                   (cond ((set-theory H) (list H))))
			     Hs2))
	   (setq Lems3 (mapcan #'(lambda (Lem) 
                                   (cond ((set-theory Lem) (list H))))
			     Lems2))
	   (list Hs3 Lems3))
	  (t (list Hs3 Lems3)) )))

(defun syms (A)   ;11Sept93
  ;;This returns the list (sya syf), where
  ;; sya is the set of free-variables in A,
  ;; and syf is the set of function symbols in A, non-logical, non-set-th.
  (let (sya syf)
    (setq sya (crunch (syms-a A)))
    (setq syf (syms-f A))
    (setq syf (set-difference (crunch syf) '(e subset sng U ~ intersection)))
    (list sya syf) ))

(defun syms-a (A &optional V)   ;11Sept93
  ;;eg, (syms-a '(-> (& (e C S) (subset C1 C))                    
  ;;		    (ALL C* (-> (E C* (U (~ S (sng C)) (sng C1))) 
  ;;			(SOME C** (& (E C** S) (SUBSET C* C**)))))))
  ;; = (C C1 S)
  (let ()
    (cond ((member A V) nil)
	  ((atom A) (list A))
	  ((not (atom (car A))) (format t "~%Alarm Syms-A~%") (break))
	  ((member (car A) '(all some)) 
	   (syms-a (caddr A) (cons (cadr A) V)))
	  (t (mapcan #'(lambda (u) (syms-a u V)) (cdr A))))))

(defun syms-f (A)   ;11Sept93
  (let ()
    (cond ((atom A) nil)
	  ((not (atom (car A))) (format t "~%Alarm Syms-F~%") (break))
	  ((member (car A) '(& or -> not sym))
	   (crunch (mapcan #'syms-f (cdr A))))
	  ((member (car A) '(e subset sng U ~ intersection))
	   (crunch (mapcan #'syms-f (cdr A))))
	  ((member (car A) '(all some)) 
	   (syms-f (caddr A)))
	  (t (crunch (cons (car A) (syms-f (cons 'sym (cdr A)))))) )))

(defun set-I (A B) (set-intersection A B))

(defun occur-s (L Va Vf)  ;13Sep93
  ;;Returns the members H of L for which a member x of Va is a free var in H
  ;; or for which a member                        f of Vf is a fcn symb in H
  (mapcan #'(lambda (H) (cond ((set-I (free-variables-in H) Va) (list H))
			      ((set-I (fcn-symbols-in    H) Va) (list H))))
	  L))

(defun fcn-symbols-in (A)
  ;;The non-logical, non-set-theory function symbols in A
  (let (f (NLS '(& or -> not e subset sng U intersection)))
    (cond ((atom A) nil)
	  ((null (cdr A)) nil)
	  ((not (atom (setq f (car A)))) (format t "~%Alarm fnc-symbols-in~%"))
	  ((member f NLS) (mapcan #'fcn-symbols-in (cdr A)))
	  ((member f '(all some)) (fcn-symbols-in (caddr A)))
	  (t nil))))


		
(defun remove-=base (L)  ;13Sep93 Called by USES-ONLY
  (let (=Base Hs2 Hs3)
    (setq =Base (mapcan #'(lambda (H)
                         (cond ((and (eq-car H '=) (atom (setq x (cadr H)))
				     (not (occur x (caddr H)))) (list H))))
			L))
    (setq Hs2 L)
    (mapc #'(lambda (H) (setq Hs3 (remove H Hs2 :test 'equal))
	                (cond ((not (occur (cadr H) Hs3)) 
			       (setq Hs2 Hs3))))
	  =Base)
    Hs2))

(defun sym-descendants (Va Vf L) ;13Sep93  Called by USES-ONLY
 (let (L2 WW Va2 Vf2)
    (setq L2 (occur-s L Va Vf))
    (setq WW (mapcar #'syms L2))
    (setq Va2 (mapcan #'car  WW))
    (setq Vf2 (mapcan #'cadr WW))
    (cond ((and (subset Va2 Va) (subset Vf2 Vf)) (list Va Vf))
	  (t (sym-descendants (union-w Va Va2) (union-w Vf Vf2)  L)))))

(defun subset (A B) (every #'(lambda (x) (member x B :test 'equal)) A))

(defun uses-only (L C)  ;13Dec93
  (let (W W2 Va Vf Va2 Vf2 L2 Gs LL L3)
    (setq W (syms C)) (setq Va (car W)) (setq Vf (cadr W))
    (setq W2 (sym-descendants Va Vf L)) 
    (setq Va2 (car W2)) (setq Vf2 (cadr W2))

    (setq L2 (occur-s L Va2 Vf2))
    (setq Gs (goals C))
(prnt L2 Gs) (break)
    (setq L3 (mapcan #'(lambda (G) (mapcan #'(lambda (H) 
                                      (goal-giver H (cadr G) (car G)))
					   L2))
		     Gs)) ))


(defun goals (C &optional (P t) V)  ;called by USES-ONLY
  (let (x G GG)
    (cond ((atom C) nil)
	  ((member (setq x (car C)) '(& or)) 
	   (mapcan #'(lambda (u) (goals u P V)) (cdr C)))
	  ((eq-car C '->) (goals (caddr C) P V))
           ;;Note: We may need to consider ~(cadr C)
	  ((eq-car C 'some) (goals (caddr C) P (cons (cadr C) V)))
	  ((eq-car C 'all)  (goals (caddr C) P V))
	  ((eq-car C 'not) (goals (cadr C) (not P) V))
	  (t (setq GG (mapcar #'(lambda (u) 
				   (cond ((member u V) 'x$) (t u)))
			      (cdr C)))
	     (setq G (cons (car C) GG))
	     (list (list P G))) )))

(defun goal-giver (H G P)  ;called by USES-ONLY
  ;;G has the form G=(G x1 ... xn) where the xi are either x$ or nil
  (let ()
    (cond ((atom H) nil)
	  ((and P (eq (car H) (car G)) (match-args (cdr H) (cdr G))) (list H))
	  ((member (car H) '(& or))
	   (mapcan #'(lambda (Hi) (goal-giver Hi G P)) (cdr H)))
	  ((eq-car H 'not) (goal-giver (cadr H) G (not P)))
	  ((eq-car H '->)  (goal-giver (caddr H) G P))
           ;;Note: We may need to consider ~(cadr H)
	  ((eq-car H 'some) 
	   (goal-giver (subst 'x% (cadr H) (caddr H)) G P))
	  ((eq-car H 'all) (goal-giver (caddr H) G P))
	  (t nil))))

(defun intersect-L (L)  ;called by USES-ONLY
  (let (L*)
    (cond ((null L) nil)
	  ((null (cdr L)) (car L))
	  ((setq L* (intersection (car L) (cadr L) :test 'equal))
	   (intersect-L (cons L* (cddr L))a))
	  (t nil))))

(defun match-args (HL GL)   ;called by GOAL-GIVER
  (cond ((equal HL GL) t)
	((or (null HL) (null GL)) nil)
	((equal (car HL) (car GL)) (match-args (cdr HL) (cdr GL)))
	((or (eq-car HL 'x%) (eq-car GL 'x$)) 
	 (match-args (cdr HL) (cdr GL)))))
